(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('jquery')) :
  typeof define === 'function' && define.amd ? define(['jquery'], factory) :
  (global.mobiscroll = factory(global.jQuery));
}(this, (function (jQuery) { 'use strict';

  jQuery = jQuery && jQuery.hasOwnProperty('default') ? jQuery['default'] : jQuery;

  var mobiscroll$2 = mobiscroll$2 || {};

  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };

  var extend = jQuery.extend;

  function init(that, options, args) {
      var ret = that;

      // Init
      if ((typeof options === 'undefined' ? 'undefined' : _typeof(options)) === 'object') {
          return that.each(function () {
              new mobiscroll$2.classes[options.component || 'Scroller'](this, options);
          });
      }

      // Method call
      if (typeof options === 'string') {
          that.each(function () {
              var r,
                  inst = mobiscroll$2.instances[this.id];

              if (inst && inst[options]) {
                  r = inst[options].apply(this, Array.prototype.slice.call(args, 1));
                  if (r !== undefined) {
                      ret = r;
                      return false;
                  }
              }
          });
      }

      return ret;
  }

  mobiscroll$2.presetShort = function (name, className, preset) {
      mobiscroll$2.components[name] = function (s) {
          return init(this, extend(s, {
              component: className,
              preset: preset === false ? undefined : name
          }), arguments);
      };
  };

  mobiscroll$2.$ = jQuery;

  //jQuery.mobiscroll = mobiscroll$2;
    jQuery.mobiscroll2 = mobiscroll$2;

    /*
  jQuery.fn.mobiscroll = function (method) {
      extend(this, mobiscroll$2.components);
      return init(this, method, arguments);
  };
    */
    jQuery.fn.mobiscroll2 = function (method) {
        extend(this, mobiscroll$2.components);
        return init(this, method, arguments);
    };

  var os;
  var vers;
  var majorVersion;
  var minorVersion;
  var version = [];
  var isBrowser = typeof window !== 'undefined';
  var userAgent = isBrowser ? navigator.userAgent : '';
  var device = userAgent.match(/Android|iPhone|iPad|iPod|Windows Phone|Windows|MSIE/i);
  var raf = isBrowser && window.requestAnimationFrame || function (func) {
      func();
  };
  var rafc = isBrowser && window.cancelAnimationFrame || function () {};

  if (/Android/i.test(device)) {
      os = 'android';
      vers = userAgent.match(/Android\s+([\d\.]+)/i);
      if (vers) {
          version = vers[0].replace('Android ', '').split('.');
      }
  } else if (/iPhone|iPad|iPod/i.test(device)) {
      os = 'ios';
      vers = userAgent.match(/OS\s+([\d\_]+)/i);
      if (vers) {
          version = vers[0].replace(/_/g, '.').replace('OS ', '').split('.');
      }
  } else if (/Windows Phone/i.test(device)) {
      os = 'wp';
  } else if (/Windows|MSIE/i.test(device)) {
      os = 'windows';
  }

  majorVersion = version[0];
  minorVersion = version[1];

  var tapped = 0;

  function preventClick() {
      // Prevent ghost click
      tapped++;
      setTimeout(function () {
          tapped--;
      }, 500);
  }

  function getCoord(e, c, page) {
      var ev = e.originalEvent || e,
          prop = (page ? 'page' : 'client') + c;

      // Multi touch support
      if (ev.targetTouches && ev.targetTouches[0]) {
          return ev.targetTouches[0][prop];
      }

      if (ev.changedTouches && ev.changedTouches[0]) {
          return ev.changedTouches[0][prop];
      }

      return e[prop];
  }

  function tap(that, el, handler, prevent, tolerance, time) {
      var startX,
          startY,
          target,
          moved,
          startTime,
          $ = mobiscroll$2.$,
          $elm = $(el);

      tolerance = tolerance || 9;

      function onStart(ev) {

          //console.log("onStart untar tap");

          if (!target) {
              // Can't always call preventDefault here, it kills page scroll
              if (prevent) {
                  ev.preventDefault();
              }
              target = this;
              startX = getCoord(ev, 'X');
              startY = getCoord(ev, 'Y');
              moved = false;
              startTime = new Date();
          }
      }

      function onMove(ev) {
          // If movement is more than 20px, don't fire the click event handler
          if (target && !moved && (Math.abs(getCoord(ev, 'X') - startX) > tolerance || Math.abs(getCoord(ev, 'Y') - startY) > tolerance)) {
              moved = true;
          }
      }

      function onEnd(ev) {
          if (target) {
              if (time && new Date() - startTime < 100 || !moved) {
                  ev.preventDefault();
                  handler.call(target, ev, that);
              }

              target = false;

              preventClick();
          }
      }

      function onCancel() {
          target = false;
      }

      if (that.settings.tap) {
          $elm.on('touchstart.mbsc', onStart).on('touchcancel.mbsc', onCancel).on('touchmove.mbsc', onMove).on('touchend.mbsc', onEnd);
      }

      $elm.on('click.mbsc', function (ev) {
          ev.preventDefault();
          // If handler was not called on touchend, call it on click;
          handler.call(this, ev, that);
      });
  }

  // Prevent standard behaviour on body click
  function bustClick(ev) {
      // Textarea needs the mousedown event
      if (tapped && !ev.tap && !(ev.target.nodeName == 'TEXTAREA' && ev.type == 'mousedown')) {
          ev.stopPropagation();
          ev.preventDefault();
          return false;
      }
  }

  if (isBrowser) {
      ['mouseover', 'mousedown', 'mouseup', 'click'].forEach(function (ev) {
          document.addEventListener(ev, bustClick, true);
      });

      if (os == 'android' && majorVersion < 5) {
          document.addEventListener('change', function (ev) {
              if (tapped && ev.target.type == 'checkbox' && !ev.target.mbscChange) {
                  ev.stopPropagation();
                  ev.preventDefault();
              }
              delete ev.target.mbscChange;
          }, true);
      }
  }

  /*!
   * Mobiscroll v3.2.3
   * http://mobiscroll.com
   *
   * Copyright 2010-2016, Acid Media
   * Licensed under the MIT license.
   *
   */

  function testProps(props) {
      var i;
      for (i in props) {
          if (mod[props[i]] !== undefined) {
              return true;
          }
      }
      return false;
  }

  function testPrefix() {
      var prefixes = ['Webkit', 'Moz', 'O', 'ms'],
          p;

      for (p in prefixes) {
          if (testProps([prefixes[p] + 'Transform'])) {
              return '-' + prefixes[p].toLowerCase() + '-';
          }
      }
      return '';
  }

  var animEnd;
  var mod;
  var ms;
  var pr;
  var prefix;
  var empty = function empty() {};
  var $ = mobiscroll$2.$;
  var id = +new Date();
  var instances = {};
  var extend$1 = $.extend;

  if (isBrowser) {
      mod = document.createElement('modernizr').style;
      prefix = testPrefix();
      pr = prefix.replace(/^\-/, '').replace(/\-$/, '').replace('moz', 'Moz');
      animEnd = mod.animation !== undefined ? 'animationend' : 'webkitAnimationEnd';
  }

  ms = extend$1(mobiscroll$2, {
      $: $,
      version: '3.2.3',
      util: {
          prefix: prefix,
          jsPrefix: pr,
          animEnd: animEnd,
          preventClick: preventClick,
          testTouch: function testTouch(e, elm) {
              if (e.type == 'touchstart') {
                  $(elm).attr('data-touch', '1');
              } else if ($(elm).attr('data-touch')) {
                  $(elm).removeAttr('data-touch');
                  return false;
              }
              return true;
          },
          objectToArray: function objectToArray(obj) {
              var arr = [],
                  i;

              for (i in obj) {
                  arr.push(obj[i]);
              }

              return arr;
          },
          arrayToObject: function arrayToObject(arr) {
              var obj = {},
                  i;

              if (arr) {
                  for (i = 0; i < arr.length; i++) {
                      obj[arr[i]] = arr[i];
                  }
              }

              return obj;
          },
          isNumeric: function isNumeric(a) {
              return a - parseFloat(a) >= 0;
          },
          isString: function isString(s) {
              return typeof s === 'string';
          },
          getCoord: getCoord,
          getPosition: function getPosition(t, vertical) {
              var style = getComputedStyle(t[0]),
                  matrix,
                  px;

              $.each(['t', 'webkitT', 'MozT', 'OT', 'msT'], function (i, v) {
                  if (style[v + 'ransform'] !== undefined) {
                      matrix = style[v + 'ransform'];
                      return false;
                  }
              });
              matrix = matrix.split(')')[0].split(', ');
              px = vertical ? matrix[13] || matrix[5] : matrix[12] || matrix[4];

              return px;
          },
          constrain: function constrain(val, min, max) {
              return Math.max(min, Math.min(val, max));
          },
          vibrate: function vibrate(time) {
              if ('vibrate' in navigator) {
                  navigator.vibrate(time || 50);
              }
          },
          throttle: function throttle(fn, threshhold) {
              var last, timer;

              threshhold = threshhold || 100;

              return function () {
                  var context = this,
                      now = +new Date(),
                      args = arguments;

                  if (last && now < last + threshhold) {
                      clearTimeout(timer);
                      timer = setTimeout(function () {
                          last = now;
                          fn.apply(context, args);
                      }, threshhold);
                  } else {
                      last = now;
                      fn.apply(context, args);
                  }
              };
          }
      },
      autoTheme: 'mobiscroll',
      presets: {
          scroller: {},
          numpad: {},
          listview: {},
          menustrip: {}
      },
      themes: {
          form: {},
          page: {},
          frame: {},
          scroller: {},
          listview: {},
          menustrip: {},
          progress: {}
      },
      platform: {
          name: os,
          majorVersion: majorVersion,
          minorVersion: minorVersion
      },
      i18n: {},
      instances: instances,
      classes: {},
      components: {},
      settings: {},
      setDefaults: function setDefaults(o) {
          extend$1(this.settings, o);
      },
      customTheme: function customTheme(name, baseTheme) {
          var i,
              themes = mobiscroll$2.themes,
              comps = ['frame', 'scroller', 'listview', 'menustrip', 'form', 'progress'];

          for (i = 0; i < comps.length; i++) {
              themes[comps[i]][name] = extend$1({}, themes[comps[i]][baseTheme], {
                  baseTheme: baseTheme
              });
          }
      }
  });

  ms.presetShort = ms.presetShort || function () {};

  ms.classes.Base = function (el, settings) {

      var lang,
          preset,
          s,
          theme,
          themeName,
          trigger,
          defaults$$1,
          that = this;

      that.settings = {};

      that._init = empty;

      that._destroy = empty;

      that._processSettings = empty;

      that.init = function (ss) {
          var key;

          // Reset settings object
          for (key in that.settings) {
              delete that.settings[key];
          }

          s = that.settings;

          // Update original user settings
          extend$1(settings, ss);

          // Load user defaults
          if (that._hasDef) {
              defaults$$1 = ms.settings;
          }

          // Create settings object
          extend$1(s, that._defaults, defaults$$1, settings);

          // Get theme defaults
          if (that._hasTheme) {

              themeName = s.theme;

              if (themeName == 'auto' || !themeName) {
                  themeName = ms.autoTheme;
              }

              if (themeName == 'default') {
                  themeName = 'mobiscroll';
              }

              settings.theme = themeName;

              theme = ms.themes[that._class] ? ms.themes[that._class][themeName] : {};
          }

          // Get language defaults
          if (that._hasLang) {
              lang = ms.i18n[s.lang];
          }

          if (that._hasTheme) {
              trigger('onThemeLoad', {
                  lang: lang,
                  settings: settings
              });
          }

          // Update settings object
          extend$1(s, theme, lang, defaults$$1, settings);

          that._processSettings();

          // Load preset settings
          if (that._hasPreset) {

              preset = ms.presets[that._class][s.preset];

              if (preset) {
                  preset = preset.call(el, that);
                  extend$1(s, preset, settings);
              }
          }

          that._init(ss);

          trigger('onInit');
      };

      that.destroy = function () {
          if (that) {
              that._destroy();
              trigger('onDestroy');

              // Delete scroller instance
              delete instances[el.id];

              that = null;
          }
      };

      /**
       * Attach tap event to the given element.
       */
      that.tap = function (el, handler, prevent, tolerance, time) {
          tap(that, el, handler, prevent, tolerance, time);
      };

      /**
       * Triggers an event
       */
      that.trigger = function (name, ev) {
          var ret,
              i,
              v,
              s = [defaults$$1, theme, preset, settings];

          for (i = 0; i < 4; i++) {
              v = s[i];
              if (v && v[name]) {
                  ret = v[name].call(el, ev || {}, that);
              }
          }

          return ret;
      };

      /**
       * Sets one ore more options.
       */
      that.option = function (opt, value) {
          var obj = {};
          if ((typeof opt === 'undefined' ? 'undefined' : _typeof(opt)) === 'object') {
              obj = opt;
          } else {
              obj[opt] = value;
          }
          that.init(obj);
      };

      /**
       * Returns the mobiscroll instance.
       */
      that.getInst = function () {
          return that;
      };

      settings = settings || {};
      trigger = that.trigger;

      function construct() {
          $(el).addClass('mbsc-comp');

          // Autogenerate id
          if (!el.id) {
              el.id = 'mobiscroll' + ++id;
          } else if (instances[el.id]) {
              instances[el.id].destroy();
          }

          // Save instance
          instances[el.id] = that;
          that.__ready = true;
      }

      if (!that.__ready) {
          construct();
      }
  };

  var classes$1 = mobiscroll$2.classes;
  var util = mobiscroll$2.util;
  var constrain = util.constrain;
  var pr$1 = util.jsPrefix;
  var pref = util.prefix;
  var getCoord$1 = util.getCoord;
  var getCurrentPosition = util.getPosition;
  var testTouch = util.testTouch;
  var isNumeric = util.isNumeric;
  var isString = util.isString;
  var isIOS = os == 'ios';

  var ScrollView = function ScrollView(el, settings, inherit) {
      var $btn,
          btnTimer,
          contSize,
          diffX,
          diffY,
          diff,
          dir,
          easing,
          elastic,
          endX,
          endY,
          eventObj,
          isBtn,
          lastX,
          maxScroll,
          maxSnapScroll,
          minScroll,
          move,
          moving,
          nativeScroll,
          rafID,

      //rafMoveID,
      rafRunning,
          scrolled,
          scrollDebounce,
          scrollTimer,
          snap,
          snapPoints,
          startPos,
          startTime,
          startX,
          startY,
          style,
          target,
          transTimer,
          threshold,
          trigger,
          vertical,
          that = this,
          currPos,
          currSnap = 0,
          currSnapDir = 1,
          s = settings,
          $elm = $(el);

      function onStart(ev) {

          //console.log("onStart unutar ScrollView");

          trigger('onStart', {
              domEvent: ev
          });

          // Better performance if there are tap events on document
          if (s.stopProp) {
              ev.stopPropagation();
          }

          if (s.prevDef || ev.type == 'mousedown') {
              // Prevent touch highlight and focus
              ev.preventDefault();
          }

          if (s.readonly || s.lock && moving) {
              return;
          }

          if (testTouch(ev, this) && !move) {

              if ($btn) {
                  $btn.removeClass('mbsc-btn-a');
              }

              // Highlight button
              isBtn = false;

              if (!moving) {
                  $btn = $(ev.target).closest('.mbsc-btn-e', this);

                  if ($btn.length && !$btn.hasClass('mbsc-btn-d')) {
                      isBtn = true;
                      btnTimer = setTimeout(function () {
                          $btn.addClass('mbsc-btn-a');
                      }, 100);
                  }
              }

              move = true;
              scrolled = false;
              nativeScroll = false;

              that.scrolled = moving;

              startX = getCoord$1(ev, 'X');
              startY = getCoord$1(ev, 'Y');
              endX = lastX = startX;
              diffX = 0;
              diffY = 0;
              diff = 0;

              startTime = new Date();

              startPos = +getCurrentPosition(target, vertical) || 0;

              // Stop scrolling animation, 1ms is needed for Android 4.0
              if (moving) {
                  scroll(startPos, isIOS ? 0 : 1);
              }

              if (ev.type === 'mousedown') {
                  $(document).on('mousemove', onMove).on('mouseup', onEnd);
              }
          }
      }

      function onMove(ev) {
          if (move) {
              if (s.stopProp) {

                  //console.log("stopProp");

                  ev.stopPropagation();
              }

              endX = getCoord$1(ev, 'X');
              endY = getCoord$1(ev, 'Y');
              diffX = endX - startX;
              diffY = endY - startY;
              diff = vertical ? diffY : diffX;

              if (isBtn && (Math.abs(diffY) > s.thresholdY || Math.abs(diffX) > s.thresholdX)) {
                  clearTimeout(btnTimer);
                  $btn.removeClass('mbsc-btn-a');
                  isBtn = false;
              }

              if (that.scrolled || !nativeScroll && Math.abs(diff) > threshold) {

                  if (!scrolled) {
                      trigger('onGestureStart', eventObj);
                  }

                  that.scrolled = scrolled = true;

                  if (!rafRunning) {
                      rafRunning = true;
                      rafID = raf(onMoving);
                  }
              }

              if (vertical || s.scrollLock) {
                  // Always prevent native scroll, if vertical
                  ev.preventDefault();
              } else {
                  if (that.scrolled) {
                      // Prevent native scroll
                      ev.preventDefault();
                      //console.log("that.scrolled");
                  } else if (Math.abs(diffY) > 7) {
                      nativeScroll = true;
                      that.scrolled = true;
                      $elm.trigger('touchend');
                      //console.log("(not that.scrolled yet & vertical mvmnt > 7");

                  }
              }
          }
      }

      function onMoving() {
          //var time = new Date();

          if (maxSnapScroll) {
              diff = constrain(diff, -snap * maxSnapScroll, snap * maxSnapScroll);
          }

          scroll(constrain(startPos + diff, minScroll - elastic, maxScroll + elastic));

          //if (s.momentum) {
          //    startTime = time;
          //    lastX = endX;
          //}

          rafRunning = false;
      }

      function onEnd(ev) {
          if (move) {
              var speed,
                  time = new Date() - startTime;

              // Better performance if there are tap events on document
              if (s.stopProp) {
                  ev.stopPropagation();
              }

              rafc(rafID);
              rafRunning = false;

              if (!nativeScroll && that.scrolled) {
                  // Calculate momentum distance
                  if (s.momentum && time < 300) {
                      speed = diff / time;
                      //speed = Math.abs(lastX - endX) / time;
                      diff = Math.max(Math.abs(diff), speed * speed / s.speedUnit) * (diff < 0 ? -1 : 1);
                  }

                  finalize(diff);
              }

              if (isBtn) {
                  clearTimeout(btnTimer);
                  $btn.addClass('mbsc-btn-a');
                  setTimeout(function () {
                      $btn.removeClass('mbsc-btn-a');
                  }, 100);

                  if (!nativeScroll && !that.scrolled) {

                      // Prevent phantom clicks
                      //if (ev.type === 'touchend') {
                      //    util.preventClick();
                      //}

                      //console.log("prije onBtnTap");
                      trigger('onBtnTap', {
                          target: $btn[0]
                      });

                      /*
                      trigger('onBtnTap', {
                          event: ev,
                          target: $btn[0]
                      });
                      */
                  }
              }

              // Detach document events
              if (ev.type == 'mouseup') {
                  $(document).off('mousemove', onMove).off('mouseup', onEnd);
              }

              move = false;
          }
      }

      function onScroll(ev) {
          ev = ev.originalEvent || ev;

          diff = vertical ? ev.deltaY || ev.wheelDelta || ev.detail : ev.deltaX;

          trigger('onStart', {
              domEvent: ev
          });

          if (s.stopProp) {
              ev.stopPropagation();
          }

          if (diff) {

              ev.preventDefault();

              //diff = diff < 0 ? 20 : -20;

              if (ev.deltaMode && ev.deltaMode == 1) {
                  diff *= 5;
              }

              diff = constrain(-diff, -20, 20);

              startPos = currPos;

              if (s.readonly || startPos + diff < minScroll || startPos + diff > maxScroll) {
                  return;
              }

              if (!scrolled) {
                  eventObj = {
                      posX: vertical ? 0 : currPos,
                      posY: vertical ? currPos : 0,
                      originX: vertical ? 0 : startPos,
                      originY: vertical ? startPos : 0,
                      direction: diff > 0 ? vertical ? 270 : 360 : vertical ? 90 : 180
                  };
                  trigger('onGestureStart', eventObj);
              }

              if (!rafRunning) {
                  rafRunning = true;
                  rafID = raf(onMoving);
              }

              scrolled = true;

              clearTimeout(scrollDebounce);
              scrollDebounce = setTimeout(function () {
                  rafc(rafID);
                  rafRunning = false;
                  scrolled = false;

                  finalize(diff);
              }, 200);
          }
      }

      function finalize(diff) {
          var i, time, newPos;

          // Limit scroll to snap size
          if (maxSnapScroll) {
              diff = constrain(diff, -snap * maxSnapScroll, snap * maxSnapScroll);
          }

          // Calculate snap and limit between min and max
          newPos = constrain(Math.round((startPos + diff) / snap) * snap, minScroll, maxScroll);
          currSnap = Math.round(newPos / snap);

          // Snap to nearest element
          if (snapPoints) {
              if (diff < 0) {
                  for (i = snapPoints.length - 1; i >= 0; i--) {
                      if (Math.abs(newPos) + contSize >= snapPoints[i].breakpoint) {
                          currSnap = i;
                          currSnapDir = 2;
                          newPos = snapPoints[i].snap2;
                          break;
                      }
                  }
              } else if (diff >= 0) {
                  for (i = 0; i < snapPoints.length; i++) {
                      if (Math.abs(newPos) <= snapPoints[i].breakpoint) {
                          currSnap = i;
                          currSnapDir = 1;
                          newPos = snapPoints[i].snap1;
                          break;
                      }
                  }
              }
              newPos = constrain(newPos, minScroll, maxScroll);
          }

          time = s.time || (currPos < minScroll || currPos > maxScroll ? 1000 : Math.max(1000, Math.abs(newPos - currPos) * s.timeUnit));

          eventObj.destinationX = vertical ? 0 : newPos;
          eventObj.destinationY = vertical ? newPos : 0;
          eventObj.duration = time;
          eventObj.transitionTiming = easing;

          trigger('onGestureEnd', eventObj);

          // Scroll to the calculated position
          scroll(newPos, time);
      }

      function scroll(pos, time, tap, callback) {
          var changed = pos != currPos,
              anim = time > 1,
              done = function done() {
              clearInterval(scrollTimer);
              clearTimeout(transTimer);
              //rafc(rafMoveID);

              moving = false;
              currPos = pos;
              eventObj.posX = vertical ? 0 : pos;
              eventObj.posY = vertical ? pos : 0;

              if (changed) {
                  trigger('onMove', eventObj);
              }

              if (anim) {
                  //that.scrolled = false;
                  trigger('onAnimationEnd', eventObj);
              }

              if (callback) {
                  callback();
              }
          };

          eventObj = {
              posX: vertical ? 0 : currPos,
              posY: vertical ? currPos : 0,
              originX: vertical ? 0 : startPos,
              originY: vertical ? startPos : 0,
              direction: pos - currPos > 0 ? vertical ? 270 : 360 : vertical ? 90 : 180
          };

          currPos = pos;

          if (anim) {
              eventObj.destinationX = vertical ? 0 : pos;
              eventObj.destinationY = vertical ? pos : 0;
              eventObj.duration = time;
              eventObj.transitionTiming = easing;

              trigger('onAnimationStart', eventObj);
          }

          style[pr$1 + 'Transition'] = time ? pref + 'transform ' + Math.round(time) + 'ms ' + easing : '';
          style[pr$1 + 'Transform'] = 'translate3d(' + (vertical ? '0,' + pos + 'px,' : pos + 'px,' + '0,') + '0)';

          if (!changed && !moving || !time || time <= 1) {
              done();
          } else if (time) {
              moving = !tap;

              clearInterval(scrollTimer);
              scrollTimer = setInterval(function () {
                  //rafMoveID = raf(function () {
                  var p = +getCurrentPosition(target, vertical) || 0;
                  eventObj.posX = vertical ? 0 : p;
                  eventObj.posY = vertical ? p : 0;
                  trigger('onMove', eventObj);
                  // Trigger done if close to the end
                  if (Math.abs(p - pos) < 2) {
                      done();
                  }
                  //});
              }, 100);

              clearTimeout(transTimer);
              transTimer = setTimeout(function () {
                  done();
                  //style[pr + 'Transition'] = '';
              }, time);

              // target.off(transEnd).on(transEnd, function (e) {
              //     if (e.target === target[0]) {
              //         target.off(transEnd);
              //         style[pr + 'Transition'] = '';
              //         done();
              //     }
              // });
          }

          if (s.sync) {
              s.sync(pos, time, easing);
          }
      }

      // Call the parent constructor
      classes$1.Base.call(this, el, settings, true);

      that.scrolled = false;

      /**
       * Scroll to the given position or element
       */
      that.scroll = function (pos, time, tap, callback) {
          // If position is not numeric, scroll to element
          if (!isNumeric(pos)) {
              pos = Math.ceil(($(pos, el).length ? Math.round(target.offset()[dir] - $(pos, el).offset()[dir]) : currPos) / snap) * snap;
          } else {
              pos = Math.round(pos / snap) * snap;
          }

          pos = constrain(pos, minScroll, maxScroll);

          currSnap = Math.round(pos / snap);

          startPos = currPos;

          scroll(pos, time, tap, callback);
      };

      that.refresh = function (noScroll) {
          var tempScroll;

          contSize = s.contSize === undefined ? vertical ? $elm.height() : $elm.width() : s.contSize;
          minScroll = s.minScroll === undefined ? Math.min(0, vertical ? contSize - target.height() : contSize - target.width()) : s.minScroll;
          maxScroll = s.maxScroll === undefined ? 0 : s.maxScroll;
          snapPoints = null;

          if (!vertical && s.rtl) {
              tempScroll = maxScroll;
              maxScroll = -minScroll;
              minScroll = -tempScroll;
          }

          if (isString(s.snap)) {
              snapPoints = [];
              target.find(s.snap).each(function () {
                  var offset = vertical ? this.offsetTop : this.offsetLeft,
                      size = vertical ? this.offsetHeight : this.offsetWidth;

                  snapPoints.push({
                      breakpoint: offset + size / 2,
                      snap1: -offset,
                      snap2: contSize - offset - size
                  });
              });
          }

          snap = isNumeric(s.snap) ? s.snap : 1;
          maxSnapScroll = s.snap ? s.maxSnapScroll : 0;
          easing = s.easing;
          elastic = s.elastic ? isNumeric(s.snap) ? snap : isNumeric(s.elastic) ? s.elastic : 0 : 0; // && s.snap ? snap : 0;

          if (currPos === undefined) {
              currPos = s.initialPos;
              currSnap = Math.round(currPos / snap);
          }

          if (!noScroll) {
              that.scroll(s.snap ? snapPoints ? snapPoints[currSnap]['snap' + currSnapDir] : currSnap * snap : currPos);
          }
      };

      that._processSettings = function () {
          vertical = s.axis == 'Y';
          dir = vertical ? 'top' : 'left';
          target = s.moveElement || $elm.children().eq(0);
          style = target[0].style;
          threshold = vertical ? s.thresholdY : s.thresholdX;
      };

      that._init = function () {
          that.refresh();

          $elm.on('touchstart mousedown', onStart).on('touchmove', onMove).on('touchend touchcancel', onEnd);

          if (s.mousewheel) {
              $elm.on('wheel mousewheel', onScroll);
          }

          if (el.addEventListener) {
              el.addEventListener('click', function (ev) {
                  if (that.scrolled) {
                      that.scrolled = false;
                      ev.stopPropagation();
                      ev.preventDefault();

                      //console.log("click while scrolling preventiran i ne propagira se");

                  }
              }, true);
          }

          //el.addEventListener('touchend', function (ev) {
          //    if (scrolled) {
          //        ev.stopPropagation();
          //    }
          //}, true);
      };

      /**
       * Destroy
       */
      that._destroy = function () {
          clearInterval(scrollTimer);

          $elm.off('touchstart mousedown', onStart).off('touchmove', onMove).off('touchend touchcancel', onEnd).off('wheel mousewheel', onScroll);
      };

      // Constructor

      s = that.settings;
      trigger = that.trigger;

      if (!inherit) {
          that.init(settings);
      }
  };

  ScrollView.prototype = {
      _class: 'scrollview',
      _defaults: {
          speedUnit: 0.0022,
          //timeUnit: 0.8,
          timeUnit: 3,
          initialPos: 0,
          axis: 'Y',
          thresholdX: 10,
          thresholdY: 5,
          //easing: 'ease-out',
          easing: 'cubic-bezier(0.190, 1.000, 0.220, 1.000)',
          stopProp: true,
          momentum: true,
          mousewheel: true,
          elastic: true
      }
  };

  classes$1.ScrollView = ScrollView;

  mobiscroll$2.presetShort('scrollview', 'ScrollView', false);

  var classes = mobiscroll$2.classes;
  var guid = 1;

  var MenuStrip = function MenuStrip(elm, settings) {
      var $activeItem,
          $cont,
          $ctx,
          $firstItem,
          $wnd,
          contClass,
          contWidth,
          display,
          itemWidth,
          multiple,
          oldWidth,
          posDebounce,
          rtl,
          select,
          selectedClass,
          scrollView,
          style,
          s,
          totalWidth,
          touched,
          trigger,
          cssClasses = {},
          animTime = 1000,
          that = this,
          $elm = $(elm);

      function onResize(ev) {
          clearTimeout(posDebounce);
          posDebounce = setTimeout(function () {
              size(ev.type !== 'load');
          }, 200);
      }

      function onItemTap($item, toggle) {

          //console.log("onItemTap u menustrip");
          if (!$item.length) {
              return;
          }

          var bl = $item.offset().left,
              bp = $item[0].offsetLeft,
              bw = $item[0].offsetWidth,
              cl = $cont.offset().left;

          $activeItem = $item;

          if (toggle === undefined) {
              toggle = !multiple;
          }

          if (select && toggle) {
              if (multiple) {
                  if ($item.attr('data-selected') == 'true') {
                      deselectItem($item);
                  } else {
                      selectItem($item);
                  }
              } else {
                  deselectItem($('.mbsc-ms-item-sel', $elm));
                  selectItem($item);
              }
          }

          if (rtl) {
              bp = totalWidth - bp - bw;
          }

          // Scroll item to view
          if (style == 'a') {
              if (bl < cl) {
                  scrollView.scroll(rtl ? bp + bw - contWidth : -bp, animTime, true);
              } else if (bl + bw > cl + contWidth) {
                  scrollView.scroll(rtl ? bp : contWidth - bp - bw, animTime, true);
              }
          } else {
              // Scroll item to center
              scrollView.scroll(contWidth / 2 - bp - bw / 2, animTime, true);
          }

          if (toggle) {
              // Trigger tap event
              trigger('onItemTap', {
                  target: $item[0]
              });
          }
      }

      function selectItem($item) {
          $item.addClass(selectedClass).attr('data-selected', 'true').attr('aria-selected', 'true');
      }

      function deselectItem($item) {
          $item.removeClass(selectedClass).removeAttr('data-selected').removeAttr('aria-selected');
      }

      function getItemByID(item) {
          if ((typeof item === 'undefined' ? 'undefined' : _typeof(item)) !== 'object') {
              item = $elm.children('[data-id="' + item + '"]');
          }
          return $(item);
      }

      function removePagePadding() {
          if (display && display != 'inline') {
              $ctx.find('.mbsc-page').css('padding-' + display, '');
          }
      }

      function initMarkup() {
          var hasIcons, hasText;

          $elm.find('.mbsc-ripple').remove();
          $elm.children().each(function (i) {
              var cssClass,
                  $item = $(this),
                  selected = select && $item.attr('data-selected') == 'true',
                  disabled = $item.attr('data-disabled') == 'true',
                  icon = $item.attr('data-icon'),
                  ref = $item.attr('data-ref');

              if (!ref) {
                  ref = guid++;
              }

              if (i === 0) {
                  $firstItem = $item;
              }

              if (select && !multiple && selected) {
                  $activeItem = $item;
              }

              if (icon) {
                  hasIcons = true;
              }

              if ($item.text()) {
                  hasText = true;
              }

              cssClass = 'mbsc-ms-item ' + (s.itemClass || '') + (s.tapHighlight ? ' mbsc-btn-e' : '') + (selected ? selectedClass : '') + (disabled ? ' mbsc-btn-d ' + (s.disabledClass || '') : '') + (icon ? ' mbsc-ms-ic mbsc-ic mbsc-ic-' + icon : '');

              $item.attr('data-ref', ref).attr('data-role', 'button').attr('aria-selected', selected ? 'true' : 'false').attr('aria-disabled', disabled ? 'true' : 'false').removeClass(cssClasses[ref]).addClass(cssClass);

              cssClasses[ref] = cssClass;

              /* TRIAL */
          });

          if (hasIcons) {
              $cont.addClass('mbsc-ms-icons');
          } else {
              $cont.removeClass('mbsc-ms-icons');
          }

          if (hasText) {
              $cont.addClass('mbsc-ms-txt');
          } else {
              $cont.removeClass('mbsc-ms-txt');
          }
      }

      function size(check, noScroll) {
          var w = s.itemWidth,
              layout = s.layout;

          that.contWidth = contWidth = $cont.width();

          if (check && oldWidth === contWidth || !contWidth) {
              // Don't do anything if container width has not changed
              return;
          }

          oldWidth = contWidth;

          if (mobiscroll$2.util.isNumeric(layout)) {
              itemWidth = contWidth ? contWidth / layout : w;
              if (itemWidth < w) {
                  layout = 'liquid';
              }
          }

          if (w) {
              if (layout == 'liquid') {
                  // The specified itemWidth will be handled as min width
                  itemWidth = contWidth ? contWidth / Math.min(Math.floor(contWidth / w), $elm.children().length) : w;
              } else if (layout == 'fixed') {
                  // Fixed width
                  itemWidth = w;
              }
          }

          if (itemWidth) {
              $elm.children().css('width', itemWidth + 'px');
          }

          // Add space to pages within context
          if (display != 'inline') {
              $ctx.find('.mbsc-page').css('padding-' + display, elm.offsetHeight + 'px');
          }

          that.totalWidth = totalWidth = elm.offsetWidth;

          extend$1(scrollView.settings, {
              contSize: contWidth,
              maxSnapScroll: s.paging ? 1 : false,
              maxScroll: 0,
              minScroll: totalWidth > contWidth ? contWidth - totalWidth : 0,
              snap: s.paging ? contWidth : s.snap ? itemWidth || '.mbsc-ms-item' : false,
              elastic: totalWidth > contWidth ? itemWidth || contWidth : false
          });

          // Pass new values to scrollview
          scrollView.refresh(noScroll);
      }

      // Call the parent constructor
      classes.Base.call(this, elm, settings, true);

      /* TRIALFUNC */

      that.navigate = function ($item, toggle) {
          onItemTap(getItemByID($item), toggle);
      };

      that.next = function (toggle) {
          var $next = $activeItem ? $activeItem.next() : $firstItem;
          if ($next.length) {
              $activeItem = $next;
              onItemTap($activeItem, toggle);
          }
      };

      that.prev = function (toggle) {
          var $prev = $activeItem ? $activeItem.prev() : $firstItem;
          if ($prev.length) {
              $activeItem = $prev;
              onItemTap($activeItem, toggle);
          }
      };

      that.select = function ($item) {
          if (!multiple) {
              deselectItem($('.mbsc-ms-item-sel', $elm));
          }
          selectItem(getItemByID($item));
      };

      that.deselect = function ($item) {
          deselectItem(getItemByID($item));
      };

      that.enable = function ($item) {
          getItemByID($item).removeClass('mbsc-btn-d').removeAttr('data-disabled').removeAttr('aria-disabled');
      };

      that.disable = function ($item) {
          getItemByID($item).addClass('mbsc-btn-d').attr('data-disabled', 'true').attr('aria-disabled', 'true');
      };

      /**
       * Recalculates sizes.
       */
      that.refresh = that.position = function (noScroll) {
          initMarkup();
          size(false, noScroll);
      };

      /**
       * Menustrip initialization.
       */
      that._init = function () {
          $ctx = $(s.context);
          $wnd = $(s.context == 'body' ? window : s.context);

          // --- TRIAL SERVER CODE START ---
          if (s.type == 'tabs') {
              s.select = s.select || 'single';
              s.variant = s.variant || 'b';
          } else if (s.type == 'options') {
              s.select = s.select || 'multiple';
              s.variant = s.variant || 'a';
          } else if (s.type == 'menu') {
              s.select = s.select || 'off';
              s.variant = s.variant || 'a';
          }

          if (s.itemWidth && s.snap === undefined) {
              s.snap = true;
          }

          // Remove old padding from mbsc-page
          // if display changed dynamically
          removePagePadding();

          display = s.display;
          rtl = s.rtl;
          style = s.variant;
          select = s.select != 'off';
          multiple = s.select == 'multiple';
          selectedClass = ' mbsc-ms-item-sel ' + (s.activeClass || '');
          contClass = 'mbsc-ms-c mbsc-no-touch mbsc-ms-' + style + ' mbsc-ms-' + display + ' mbsc-' + s.theme + ' ' + (s.baseTheme ? ' mbsc-' + s.baseTheme : '') + ' ' + (s.cssClass || '') + ' ' + (s.wrapperClass || '') + (rtl ? ' mbsc-ms-rtl' : ' mbsc-ms-ltr') + (s.itemWidth ? ' mbsc-ms-hasw' : '') + (s.context == 'body' ? '' : ' mbsc-ms-ctx') + (select ? '' : ' mbsc-ms-nosel');
          // --- TRIAL SERVER CODE END ---

          if (!$cont) {
              $cont = $('<div class="' + contClass + '"><div class="mbsc-ms-sc"></div></div>').insertAfter($elm);

              $cont.find('.mbsc-ms-sc').append($elm);

              scrollView = new ScrollView($cont[0], {
                  axis: 'X',
                  contSize: 0,
                  maxScroll: 0,
                  maxSnapScroll: 1,
                  minScroll: 0,
                  snap: 1,
                  elastic: 1,
                  rtl: rtl,

                  stopProp: false,  // drazen - da bi vertical scroll dosao do kenda

                  mousewheel: s.mousewheel,
                  thresholdX: s.threshold,
                  onStart: function onStart(ev) {

                      //console.log("onStart unutar scrollView instance menuStrip");

                      if (!touched && ev.domEvent.type == 'touchstart') {
                          touched = true;
                          $ctx.find('.mbsc-no-touch').removeClass('mbsc-no-touch');
                      }
                  },
                  onBtnTap: function onBtnTap(ev) {
                      onItemTap($(ev.target), true);
                  },

                  /*
                  onBtnTap: function onBtnTap(ev, obj) {

                      console.log("onBtnTap");
                      onItemTap($(obj.target), true);
                      //ev.event.stopPropagation(); // drazen - zaustavi tap
                      //ev.event.preventDefault();
                  },
                    */

                  onGestureStart: function onGestureStart(ev) {
                      trigger('onGestureStart', ev);
                  },
                  onGestureEnd: function onGestureEnd(ev) {
                      trigger('onGestureEnd', ev);
                  },
                  onMove: function onMove(ev) {
                      trigger('onMove', ev);
                  },
                  onAnimationStart: function onAnimationStart(ev) {
                      trigger('onAnimationStart', ev);
                  },
                  onAnimationEnd: function onAnimationEnd(ev) {
                      trigger('onAnimationEnd', ev);
                  }
              });
          } else {
              $cont.attr('class', contClass);
              // Remove ripple events (if theme changed)
              $elm.off('.mbsc-ripple');
          }

          // Prepare markup
          $elm.css('display', '').addClass('mbsc-ms ' + (s.groupClass || ''));

          initMarkup();

          trigger('onMarkupReady', {
              target: $cont[0]
          });

          // ---

          size();

          // Attach events
          // ---

          // When images are loaded, size migth change
          $cont.find('img').on('load', onResize);

          $wnd.on('orientationchange resize', onResize);

          // ---
      };

      /**
       * Menustrip destroy
       */
      that._destroy = function () {
          removePagePadding();

          $wnd.off('orientationchange resize', onResize);

          $elm.removeClass('mbsc-ms mbsc-ms-a mbsc-ms-b').insertAfter($cont).find('.mbsc-ms-item').each(function () {
              var $item = $(this);
              $item.width('').removeClass(cssClasses[$item.attr('data-ref')]);
          });

          $cont.remove();

          scrollView.destroy();
      };

      // ---

      // Constructor

      s = that.settings;
      trigger = that.trigger;

      that.init(settings);
  };

  // Defaults
  MenuStrip.prototype = {
      _class: 'menustrip',
      _hasDef: true,
      _hasTheme: true,
      _hasLang: true,
      _defaults: {
          context: 'body',
          type: 'options',
          display: 'inline',
          layout: 'liquid',
          tapHighlight: true
      }
  };

  classes.MenuStrip = MenuStrip;

  mobiscroll$2.presetShort('menustrip', 'MenuStrip');

  // English (UK)

  mobiscroll$2.i18n['en-GB'] = mobiscroll$2.i18n['en-UK'] = {
      dateFormat: 'dd/mm/yy',
      timeFormat: 'HH:ii'
  };

  mobiscroll$2.customTheme('mobiscroll-dark', 'mobiscroll');

  var themes = mobiscroll$2.themes;

  var theme = void 0;

  if (os == 'android') {
      theme = majorVersion >= 5 ? 'material' : 'android-holo';
  } else if (os == 'ios') {
      theme = 'ios';
  } else if (os == 'wp') {
      theme = 'wp';
  }

  mobiscroll$2.setAutoTheme = function () {
      $.each(themes.frame, function (key, settings) {
          // Stop at the first custom theme with the OS base theme
          if (theme && settings.baseTheme == theme && key != 'android-holo-light' && key != 'material-dark' && key != 'wp-light' && key != 'ios-dark') {
              mobiscroll$2.autoTheme = key;
              return false;
          } else if (key == theme) {
              mobiscroll$2.autoTheme = key;
          }
      });
  };

  mobiscroll$2.setAutoTheme();

  // Languages
  // import '../src/js/i18n/ar';
  // import '../src/js/i18n/bg';
  // import '../src/js/i18n/ca';
  // import '../src/js/i18n/cs';
  // import '../src/js/i18n/da';
  // import '../src/js/i18n/de';
  // import '../src/js/i18n/el';
  // import '../src/js/i18n/es';
  // import '../src/js/i18n/fa';
  // import '../src/js/i18n/fi';
  // import '../src/js/i18n/fr';
  // import '../src/js/i18n/he';
  // import '../src/js/i18n/hi';
  // import '../src/js/i18n/hr';
  // import '../src/js/i18n/hu';
  // import '../src/js/i18n/it';
  // import '../src/js/i18n/ja';
  // import '../src/js/i18n/ko';
  // import '../src/js/i18n/lt';
  // import '../src/js/i18n/nl';
  // import '../src/js/i18n/no';
  // import '../src/js/i18n/pl';
  // import '../src/js/i18n/pt-BR';
  // import '../src/js/i18n/pt-PT';
  // import '../src/js/i18n/ro';
  // import '../src/js/i18n/ru-UA';
  // import '../src/js/i18n/ru';
  // import '../src/js/i18n/sk';
  // import '../src/js/i18n/sr';
  // import '../src/js/i18n/sv';
  // import '../src/js/i18n/tr';
  // import '../src/js/i18n/vi';
  // import '../src/js/i18n/zh';

  // Themes

  // Custom themes
  // Auto Theme

  // Components
  // import '../src/js/forms.jquery';
  // import '../src/js/page.jquery';
  // import '../src/js/scroller.jquery';

  return mobiscroll$2;

})));

//# sourceMappingURL=mobiscroll.jquery.js.map