﻿var mad = mad || {};

mad.alerts = (function () {
    
    //The default options to use for Toastr
    var toastrDefaults = {
        "closeButton": false,
        "debug": false,
        "positionClass": "toast-bottom-full-width",
        "onclick": null,
        "newestOnTop": true,
        "showDuration": "222",
        "hideDuration": "222",
        "progressBar": false,
        "timeOut": "4444",
        "extendedTimeOut": "0",
        "showEasing": "swing",
        "hideEasing": "linear",
       // "showMethod": "fadeIn",
        //"hideMethod": "fadeOut"
        "showMethod": "slideDown",
        "hideMethod": "slideUp"
    };

    //Shows the loading panel on the screen
    var initLoading = function() {
        app.mobile.showLoading();
    };

    //Hides the loading panel from the screen
    var exitLoading = function() {
        app.mobile.hideLoading();
    };

    //Initializes Toastr with the default options
    var initToastr = function () {
        toastr.options = toastrDefaults;
    };

    //Displays a success message
    var success = function(message, title) {
        toastr.clear();
        toastr.options.positionClass = "toast-top-0";
        toastr.success(message, title);
    };
    var realTop0success = function(message) {
        toastr.clear();
        toastr.options.positionClass = "toast-real-top-0";
        toastr.options.progressBar = false;
        toastr.options.debug = false;
        toastr.success(message, '', toastr.options);
    };

    var success0 = function(message, title) {
        toastr.clear();
        toastr.options.positionClass = "toast-bottom-0-full-width";
        toastr.success(message, title, toastr.options);
    };


    //Displays an info message
    var info = function(message, title) {
        toastr.clear();
        toastr.info(message, title);
    };
    var info0 = function(message, title) {
        toastr.clear();
        toastr.options.positionClass = "toast-bottom-0-full-width";
        toastr.info(message, title, toastr.options);
    };


    //Displays a warning message
    var warning = function(message, title) {
        toastr.clear();
        toastr.warning(message, title);
    };
    var warning0 = function(message, title) {
        toastr.clear();
        toastr.options.positionClass = "toast-bottom-0-full-width";
        toastr.warning(message, title, toastr.options);
    };

    //Displays a top center warning message
    var topCenter = function(message, title) {
        toastr.options.positionClass = "toast-real-top-0";
        toastr.options.timeOut = "15000";
        toastr.options.progressBar = true;
        toastr.options.debug = false;
        toastr.warning(message, title, toastr.options);

        toastr.options = toastrDefaults;
        toastr.options.timeOut = "4444";
    };

    //Displays a top center warning message
    var topCenterE = function(message, title) {
        toastr.clear();
        toastr.options.positionClass = "toast-top-full-width";
        toastr.options.progressBar = false;
        toastr.options.debug = false;
        toastr.error(message, title, toastr.options);
    };

    var top0 = function(message) {
        toastr.clear();
        toastr.options.positionClass = "toast-top-0";
        toastr.options.progressBar = false;
        toastr.options.debug = false;
        toastr.error(message, '', toastr.options);
    };

    var realTop0 = function(message) {
        toastr.clear();
        toastr.options.positionClass = "toast-real-top-0";
        toastr.options.progressBar = false;
        toastr.options.debug = false;
        toastr.error(message, '', toastr.options);
    };

    var top = function(message) {
        toastr.clear();
        toastr.options.positionClass = "toast-top";
        toastr.options.progressBar = false;
        toastr.options.debug = false;
        //toastr.options.timeOut = "30000";
        toastr.error(message, '', toastr.options);
    };

    var topWarning = function(message) {
        toastr.clear();
        toastr.options.positionClass = "toast-top-0";
        toastr.options.progressBar = false;
        toastr.options.debug = false;
        toastr.warning(message, '', toastr.options);
    };

    var realTop0warning = function(message) {
        toastr.clear();
        toastr.options.positionClass = "toast-real-top-0";
        toastr.options.progressBar = false;
        toastr.options.debug = false;
        toastr.warning(message, '', toastr.options);
    };

    var top0test = function(message) {
        toastr.clear();
        toastr.options.positionClass = "toast-top-0";
        toastr.options.progressBar = false;
        toastr.options.debug = false;
        toastr.options.timeOut = 0;
        toastr.options.extendedTimeOut = 0;
        toastr.options.tapToDismiss = true;
        toastr.error(message, '', toastr.options);
    };

    //Displays an error message
    var error = function(message, title) {
       // toastr.clear();
        toastr.error(message, title);
    };
    var error0 = function(message, title) {
        toastr.clear();
        toastr.options.positionClass = "toast-bottom-0-full-width";
        toastr.error(message, title, toastr.options);
    };

    //Displays a clear message
    var clear = function() {
        toastr.clear();
    };

    return {
        initLoading: initLoading,
        exitLoading: exitLoading,
        initToastr: initToastr,
        success: success,
        success0: success0,
        realTop0success: realTop0success,
        info: info,
        info0: info0,
        warning: warning,
        warning0: warning0,
        topCenter: topCenter,
        topCenterE: topCenterE,
        top0: top0,
        realTop0: realTop0,
        top: top,
        topWarning: topWarning,
        realTop0warning: realTop0warning,
        top0test: top0test,
        error: error,
        error0: error0,
        clear: clear
    };

}());