/// <reference path="azureAppInsights.js" />
var mad = mad || {};

mad.app = (function (win) {
  "use strict";

  var onDeviceReady = function () {
    mad.common.disableLogging();

    console.log("onDeviceReady");

    mad.common.observables.set("externalLink", ""); //reset external link

    // use cordova info for simulator prop.
    window.navigator.simulator = device.isVirtual;
    console.log("--------------", "simulator", window.navigator.simulator);

    console.log("device model", device.model);

    mad.common.observables.bind("change", function (e) {
      console.log(
        ">> doslo je do promjene observable varijable u common",
        e.field
      );
      if (e.field == "lokiReady") {
        console.log("lokiReady je", mad.common.observables.get("lokiReady"));
        if (mad.common.observables.networkStatus == "online") {
          console.log("online smo");
          if (mad.loginToken !== "") {
            console.log("provjeri syncanje");
            doRebind();
            doSyncing();
          } else {
            console.log("al nema tokena pa ne radi nista u vezi sa syncanjem");
          }
        } else {
          console.log("al nismo on line - nema syncanja");
        }
      } else if (e.field == "networkStatus") {
        console.log(
          "networkStatus je",
          mad.common.observables.get("networkStatus")
        );
        if (mad.common.observables.lokiReady) {
          console.log("loki je ready");
          if (mad.loginToken !== "") {
            console.log("provjeri syncanje");
            doRebind();
            doSyncing();
          } else {
            console.log("al nema tokena pa ne radi nista u vezi sa syncanjem");
          }
        } else {
          console.log("al nije loki ready - nema syncanja");
        }
      }
    });

    //Attach to device put to background event
    document.addEventListener("pause", onPause, false);

    //Attach to device resume event
    document.addEventListener("resume", onResume, false);

    //Attach to device on Online event
    document.addEventListener("online", onOnline, false);

    //Attach to device on Offline event
    document.addEventListener("offline", onOffline, false);

    //Attach to device on Back Button event
    document.addEventListener("backbutton", onBackButton, false);

    //Attach to device on menu button event
    document.addEventListener("menubutton", onMenuButton, false);

    // listen for deep links
    /*
        universalLinks.subscribe('gotoFeed', gotoFeed);
        universalLinks.subscribe('gotoWorkoutsMenu', gotoWorkoutsMenu);
        */

    //Hide the native splash screen
    setTimeout(function () {
      navigator.splashscreen.hide();
    }, 1111);

    //hook for window.open
    window.open = cordova.InAppBrowser.open;

    handleKeyboard();

    mad.common.observables.set(
      "networkStatus",
      navigator.connection.type === Connection.NONE ? "offline" : "online"
    );

    mad.common.getVersion();

    initAnalyticsAndTelemetry();

    if (!device.isVirtual) {
      StatusBar.hide();
      initLocalStorageDB();
    } else {
      continueWithApp();
    }
  };

  function initLocalStorageDB() {
    console.log("initLocalStorageDB");

    var adapter = new LokiCordovaFSAdapter({ prefix: "loki" });

    /* delete database
         adapter.deleteDatabase('localJsonStorage', function(result) {
             console.log('databse deleted');
         });
         */

    localJsonDB = new loki("localJsonStorage", {
      autoload: true,
      verbose: true,
      autoloadCallback: localDatabaseLoaded,
      autosave: true,
      autosaveInterval: 10000,
      adapter: adapter
    });

    function localDatabaseLoaded() {
      console.log("this is autoloadCallback on new loki instance");

      // if collection did not exist it will be empty so I will intitialize here

      localUser = localJsonDB.getCollection("user");
      if (mad.common.isNullOrEmpty(localUser)) {
        console.log(
          "nema user kolekcije kreiraj je i dodaj objekte tj. bivse localStorage varijable"
        );

        localUser = localJsonDB.addCollection("user", { unique: ["name"] });
        localUser.insert({ name: "username", value: "" });
        localUser.insert({ name: "userId", value: "" });
        localUser.insert({ name: "token", value: "" });
        localUser.insert({ name: "userNoFollowing", value: "" });
        localUser.insert({ name: "FitnessLevel", value: "" });
        localUser.insert({ name: "Score", value: "" });
        localUser.insert({ name: "Goal", value: "" });
        localUser.insert({ name: "NumberOfFinishedWorkouts", value: "" });
        localUser.insert({ name: "HasUserNutrition", value: "" });
        localUser.insert({ name: "DateUserJoined", value: "" });
        localUser.insert({ name: "HasUserUSW", value: "" });
        localUser.insert({ name: "SubscriptionInfo", value: "" });
        localUser.insert({ name: "feedType", value: "" });

        localJsonDB.saveDatabase();
      }
      localUser.on("error", function (errDoc) {
        /*
                 može javiti npr.
                 Error: Duplicate key for property name: brisi
                 ako se dodaje name = brisi 2x
                 */
        console.log("greska na user kolekciji " + errDoc);
      });

      localApp = localJsonDB.getCollection("app");
      if (mad.common.isNullOrEmpty(localApp)) {
        localApp = localJsonDB.addCollection("app", { unique: ["name"] });
        localApp.insert({ name: "installationId", value: "" });
        localApp.insert({ name: "pnsHandle", value: "" });
        localApp.insert({ name: "subscribedNotificationTypes", value: "" });
        localApp.insert({ name: "pendingSync", value: "" });
        localApp.insert({ name: "pendingUpdates", value: "" });
        localApp.insert({ name: "pendingTrenings", value: "" });
        localApp.insert({ name: "pendingTreningsPlan", value: "" });
        localApp.insert({ name: "version", value: "0" });
        localApp.insert({ name: "sleep", value: "true" });
        localApp.insert({ name: "mute", value: "false" });
        localApp.insert({ name: "tts", value: "true" });
        localApp.insert({
          name: "lastQuote",
          value: JSON.stringify({ quoteDate: "", quoteIndex: 0 })
        });
        localApp.insert({ name: "ProfilePhoto", value: "" });
        localApp.insert({ name: "visitedFeed", value: "" });
        localApp.insert({ name: "visitedMadbarzRoutines", value: "" });
        localApp.insert({ name: "visitedWorkouts", value: "" });
        localApp.insert({ name: "visitedCreateWorkouts", value: "" });
        localApp.insert({ name: "visitedPlans", value: "" });
        localApp.insert({ name: "visitedWorkoutDetails", value: "" });
        localApp.insert({ name: "selectedLevel", value: "" });
        localApp.insert({ name: "subscriptionProductIds", value: "" });
        localApp.insert({ name: "WarmupReminder", value: "" });
        localApp.insert({ name: "tutorialCreateWorkout", value: "" });
        localApp.insert({ name: "fbUserId", value: "" });
        localApp.insert({ name: "facebookToken", value: "" });
        localApp.insert({ name: "token", value: "" });

        localJsonDB.saveDatabase();
      }
      localApp.on("error", function (errDoc) {
        console.log("greska na app kolekciji " + errDoc);
      });

      localSaved = localJsonDB.getCollection("savedWorkouts");
      if (mad.common.isNullOrEmpty(localSaved)) {
        localSaved = localJsonDB.addCollection("savedWorkouts", {
          unique: ["name"]
        });
        localSaved.insert({ name: "savedWorkouts", value: "[]" });
      }
      localSaved.on("error", function (errDoc) {
        console.log("greska na savedWorkouts kolekciji " + errDoc);
      });

      localRoutines = localJsonDB.getCollection("madbarzRoutines");
      if (mad.common.isNullOrEmpty(localRoutines)) {
        localRoutines = localJsonDB.addCollection("madbarzRoutines", {
          unique: ["name"]
        });
        localRoutines.insert({
          name: "routines",
          value: JSON.stringify([]),
          expires: 0
        });
      }
      localRoutines.on("error", function (errDoc) {
        console.log("greska na madbarzRoutines kolekciji " + errDoc);
      });

      localOther = localJsonDB.getCollection("other");
      if (mad.common.isNullOrEmpty(localOther)) {
        localOther = localJsonDB.addCollection("other", { unique: ["name"] });
        localOther.insert({ name: "tags", value: "" });
        localOther.insert({ name: "routines-filter", value: "[]" });
        localOther.insert({ name: "plans-filter", value: "[]" });
        localOther.insert({ name: "exercise-filter", value: "[]" });
      }
      localOther.on("error", function (errDoc) {
        console.log("greska na other kolekciji " + errDoc);
      });

      console.log("baza je", localJsonDB);

      mad.common.observables.set("lokiReady", true);

      continueWithApp();
    }
  }

  function continueWithApp() {
    mad.installation.checkIsUpgrade(); // It needs to be checked before the PushNotification plugin fire installation register method
    //this is for handling in-app purchases of subscriptions, we have to get ids of all subscription products
    var productCode = "madbarzpro";
    mad.subscriptionService.getSubscriptionProductIdsFromServer(productCode);
    initPlugins();
    startKendo();
    mad.common.events.bind(
      "notificationsSettings",
      mad.viewModels.settings.viewModel.notificationSettingsChange
    ); // bind custom events
  }

  function initAnalyticsAndTelemetry() {
    mad.appTelemetry.initAzureAppInsights();
    mad.googleAnalytics.initAnalytics();
    mad.appsFlyer.init();
    // mad.mixpanel.initMixpanel();
    //mad.mixpanel.registerSuperProperties();

    //version should be set before and is located in common
    // if (version) {
    //     //console.log("Version je: ", version);
    //     mad.appTelemetry.setAppVersionForAzureAppInsights(version);
    // }
  }

  // Init mobile plugins
  var initPlugins = function () {
    console.log("initPlugins");

    mad.alerts.initToastr(); // initialize javascript lib for alerts

    //mad.common.handleInsomnia();  // drazen - prebaceno na workout

    if (win.plugins) {
      // initialize CORDOVA plugins

      //   win.screen.lockOrientation('portrait-primary'); // not needed any more - done through x-code

      if (win.plugins.NativeAudio) {
        var audioFile = "sounds/10.wav";
        win.plugins.NativeAudio.preloadComplex(
          "ten",
          audioFile,
          1,
          1,
          0.05,
          mad.common.audioOnSuccess,
          mad.common.audioOnError
        );
        for (var i = 0; i < 6; i++) {
          audioFile = "sounds/num" + i + ".wav";
          win.plugins.NativeAudio.preloadComplex(
            "say" + i,
            audioFile,
            1,
            1,
            0.05,
            mad.common.audioOnSuccess,
            mad.common.audioOnError
          );
        }
        audioFile = "sounds/beep.wav";
        win.plugins.NativeAudio.preloadComplex(
          "beep2",
          audioFile,
          1,
          1,
          0.05,
          mad.common.audioOnSuccess,
          mad.common.audioOnError
        );
        win.plugins.NativeAudio.preloadComplex(
          "beep3",
          audioFile,
          1,
          1,
          0.05,
          mad.common.audioOnSuccess,
          mad.common.audioOnError
        );
        win.plugins.NativeAudio.preloadComplex(
          "beep4",
          audioFile,
          1,
          1,
          0.05,
          mad.common.audioOnSuccess,
          mad.common.audioOnError
        );
        audioFile = "sounds/beeeep.wav";
        win.plugins.NativeAudio.preloadComplex(
          "beep5",
          audioFile,
          1,
          1,
          0.05,
          mad.common.audioOnSuccess,
          mad.common.audioOnError
        );
      }

      if (win.plugins.pushNotification) {
        console.log("pushNotification plugin init");
        if (
          kendo.support.mobileOS.device == "android" || device.platform == "Android" || device.platform == "android" ||
          device.platform == "amazon-fireos"
        ) {
          win.plugins.pushNotification.register(
            mad.common.pushSuccessHandler,
            mad.common.pushErrorHandler,
            { senderID: GCM_SENDER_ID, ecb: "mad.common.onPushNotification" }
          );
        } else {
          win.plugins.pushNotification.register(
            mad.common.pushTokenHandler,
            mad.common.pushErrorHandler,
            {
              badge: "true",
              sound: "true",
              alert: "true",
              ecb: "mad.common.onPushNotificationApn"
            }
          );
        }
      }

      if (window.plugins.screensize) {
        window.plugins.screensize.get(function (screensize) {
          mad.common.variables.screenSize = screensize;
        }, function () {
        });
      }
    }
  };

  var startKendo = function () {
    console.log("starting kendo");

    var os = kendo.support.mobileOS,
      //statusBarStyle = os.ios && os.flatVersion >= 700 ? 'default' : 'blue';
      statusBarStyle = "hidden";

    //Set the options for the mobile app startup
    var options = {
      statusBarStyle: statusBarStyle,
      useNativeScrolling: false, // drazen - true je smoother ali content.height() ne racuna dobro i sl.
      updateDocumentTitle: false,
      transition: "none",
      skin: "flat",
      loading: false,
      init: function () {
        //mobile application is instantiated
        //fix mouse events in iOS don't do it for android, causes more issues than it fixes
        var defaultTreshold = 20;

        if (kendo.support.mobileOS.device == "android" || device.platform == "Android" || device.platform == "android") {
          defaultTreshold = 0;
        }
        kendo.UserEvents.defaultThreshold(defaultTreshold);
      }
    };

    // Initialize KendoUI mobile application
    mad.mobileApp = new kendo.mobile.Application(document.body, options);
    if (mad.mobileApp) {
      kendoStarted();
    } else {
      mad.alerts.error("Please try again.", "Madbarz");
    }
  };

  var kendoStarted = function () {
    console.log("kendoStarted");

    console.log("version", version);

    mad.common.checkVersion();
    mad.common.prepareCountries();
    mad.common.prepareStates();
    mad.models.quotes.read(); // podaci su u mad.models.quotes.data()

    mad.common.initRouter();

    // store data from cache to global vars
    mad.common.variables.username = mad.local.loadVariable("username"); // username

    console.log("root is", mad.common.variables.root);

    handleViewsVisibility();

    var getTokenFromStoragePromise = $.Deferred();

    function onGetTokenSuccess(token) {
      mad.loginToken = token;

      if (mad.loginToken !== "") {
        console.log("there is already user token");
        if (mad.common.observables.networkStatus == "online") {
          // and we are online
          console.log("and we are online");

          console.log(
            "app started, there is a token, we are online - call sync"
          );
          doSyncing(); // do syncing if necessary

          //get other user info
          var promise = $.Deferred();
          promise.then(
            function (success) {
              mad.common.loadUnreadNotif();
              mad.common.startCheckingNotif();

              // check if there is an external link
              var extLink = mad.common.observables.get("externalLink");
              if (extLink != "") {
                // & if there is
                console.log("there is external link to", extLink);
                mad.common.observables.set("externalLink", ""); // clear external link
                mad.mobileApp.navigate(extLink); // go there
                return; // & skip code below
              }

              if (mad.common.pushNotificationSemaphore.isPending()) {
                console.log(
                  "kendoStarted",
                  "Push notification is pending and it's about to navigate..."
                );
                mad.common.pushNotificationSemaphore.unlock();
              } else {
                mad.mobileApp.navigate("ui/workouts/menu.html?origin=start"); // show first view
              }
            },
            function (fail) {
              console.log("getUserInfo failed - idi na start");

              // probably expired token - clear loginToken & go to start
              //mad.local.removeVariable("loginToken");
              /*
                        mad.local.removeVariable("token");
                        mad.local.removeVariable("username");
                        */

              mad.alerts.error0("Couldn't get user info. Please login.");
              mad.mobileApp.navigate("ui/other/start.html"); // goto start page
            }
          );
          mad.common.getUserInfo(promise, false);
        } else {
          // in case we are offline
          // get last data from local storage (at least something)
          console.log("and we are offline");
          mad.common.variables.username = mad.local.loadVariable("username");
          mad.common.variables.userId = mad.local.loadVariable("userId");
          mad.common.variables.userNoFollowing = mad.local.loadVariable(
            "userNoFollowing"
          );

          mad.mobileApp.navigate(
            "ui/workouts/saved/madbarzSavedWorkoutsList.html?origin=start"
          ); // show saved workouts
        }
      } else {
        console.log("there is NO user token");
        if (mad.common.observables.networkStatus == "online") {
          // and we are online
          console.log("and we are online");
          mad.mobileApp.navigate("ui/other/start.html"); // goto start page
        } else {
          console.log("and we are offline");
          mad.alerts.topCenter(
            "You don't have Internet connection.<br><br><span class='red'>Please login at least once when you have Internet connection and you could work offline.</span><br>",
            ""
          );
          mad.mobileApp.navigate("ui/other/start.html"); // goto start page
        }
      }
    }

    function onGetTokenFail() {
      console.log("there is NO user token");
      if (mad.common.observables.networkStatus == "online") {
        // and we are online
        console.log("and we are online");
        mad.mobileApp.navigate("ui/other/start.html"); // goto start page
      } else {
        console.log("and we are offline");
        mad.alerts.topCenter(
          "You don't have Internet connection.<br><br><span class='red'>Please login at least once when you have Internet connection and you could work offline.</span><br>",
          ""
        );
        mad.mobileApp.navigate("ui/other/start.html"); // goto start page
      }
    }

    //get token !!!!
    getTokenFromStoragePromise.then(onGetTokenSuccess, onGetTokenFail);
    mad.local.loadToken(getTokenFromStoragePromise);
  };

  function handleKeyboard() {
    console.log("init handle keyboard");

    // fix keyboard overlaying the selected input on android / reg - page 5 & others
    window.addEventListener("native.keyboardshow", function (e) {
      mad.common.variables.keyboard.opened = true;
      mad.common.variables.keyboard.offset = e.keyboardHeight + getAndroidSoftButtonHeight();
      var offset = 0;

      if (kendo.support.mobileOS.device == "android" || device.platform == "Android" || device.platform == "android") {
        if (
          mad.common.actualViewID == "register" &&
          mad.viewModels.register.viewModel.get("currentPage") == 5
        ) {

          setTimeout(function () {
            $("#register [data-role='content']").animate(
              { marginTop: -(mad.common.variables.keyboard.offset - 15) },
              555
            );
          }, 22);
        } else if (
          mad.common.actualViewID == "madbarzWorkoutStat" ||
          mad.common.actualViewID == "planWorkoutStat"
        ) {
          $(".entryField-comment").animate(
            { bottom: mad.common.variables.keyboard.offset },
            555
          );
        } else if (mad.common.actualViewID == "workoutDetails") {
          $(".wd-entryField-comment").animate(
            { bottom: mad.common.variables.keyboard.offset },
            555
          );
        } else if (mad.common.actualViewID == "workoutDetailsComments") {
          $(".comm-entryField-comment").animate(
            { bottom: mad.common.variables.keyboard.offset },
            555
          );
        }
      }
    });

    window.addEventListener("native.keyboardhide", function (e) {
      mad.common.variables.keyboard.opened = false;
      mad.common.variables.keyboard.offset = 0;
      if (kendo.support.mobileOS.device == "android" || device.platform == "Android" || device.platform == "android") {
        if (
          mad.common.actualViewID == "register" &&
          mad.viewModels.register.viewModel.get("currentPage") == 5
        ) {
          setTimeout(function () {
            $("#register [data-role='content']").animate({ marginTop: 0 }, 222);
          }, 22);
        } else if (
          mad.common.actualViewID == "madbarzWorkoutStat" ||
          mad.common.actualViewID == "planWorkoutStat"
        ) {
          $(".comment-value").blur();
          $(".entryField-comment")
            .css("bottom", 0)
            .addClass("hidden");
          $("#workoutStatContainer .zamraci").removeClass("defocus");
          $("#planWorkoutStatContainer .zamraci").removeClass("defocus");
        } else if (mad.common.actualViewID == "workoutDetails") {
          $(".wd-entryField-comment")
            .css("bottom", 0)
            .addClass("hidden");
          $(".wd-comment-value").blur();
          $("#workoutDetailsContainer .zamraci").removeClass("defocus");
        } else if (mad.common.actualViewID == "workoutDetailsComments") {
          $(".comm-entryField-comment").css("bottom", 0);
          $(".comm-comment-value").blur();
        }
      }
    });
  }

  function getAndroidSoftButtonHeight() {
    if (mad.common.variables.screenSize && mad.common.variables.screenSize.softButtonsBarHeight && mad.common.variables.screenSize.densityValue) {
      return mad.common.variables.screenSize.softButtonsBarHeight / (mad.common.variables.screenSize.densityValue * mad.common.variables.screenSize.densityValue) + 15;
    }

    return 0;
  }



  function handleViewsVisibility() {
    // HACK !!!
    /* in case that app is first started offline (there is no token) we can't go further
         and there is no view to show, kendo will generate empty view with data-url = "/" which overlays
         our css on body tag (logo) so we added
         .km-view {
            visibility: hidden;
         }
         in style.css (which makes all views invisible !)

         here we add .km-view {visibility: visible;}
         in style tag at the end of head so views are visible from here on
         & hide unwanted view
         ---
         in other cases everything works as expected
         */
    $("head").append('<style type="text/css"></style>');
    var newStyleElement = $("head").children(":last");
    newStyleElement.html(".km-view {visibility: visible;}");
    $("[data-url='/']").css("display", "none");
  }

  var onPause = function () {
    console.log("pauza");

    var playingVideo = mad.viewModels.workoutVideo.viewModel.get(
      "playingVideo"
    );
    if (playingVideo) {
      return; // return and do nothing else
    }

    clearInterval(mad.common.variables.timers.notifications);

    if (mad.viewModels.madbarzWorkout.viewModel.get("pause") == "active") {
      mad.viewModels.madbarzWorkout.viewModel.set("pauseExit", new Date());
      mad.viewModels.madbarzWorkout.pauza.brojac.stop();
    }

    if (mad.viewModels.madbarzExercising.viewModel.get("workoutTimerActive")) {
      mad.viewModels.madbarzExercising.viewModel.set(
        "workoutStoppedAt",
        new Date()
      );
      mad.viewModels.madbarzExercising.vjezbanje.brojac.stop();
    }
  };

  var onResume = function () {
    /* povratak u app nakon privremenog izlaska iz app
            npr. sam je suspendiras da odes u neku drugu app ili
            npr. kad se ode playat video iz app
         */

    console.log("resume");

    var timeNow, passedTimeInSec;

    mad.common.variables.HasUserAccesToPro = -1;

    var playingVideo = mad.viewModels.workoutVideo.viewModel.get(
      "playingVideo"
    );
    if (playingVideo) {
      mad.viewModels.workoutVideo.viewModel.set("playingVideo", false);
      return; // return and do nothing else
    }

    if (mad.loginToken !== "") {
      console.log("mad.loginToken postoji");

      mad.common.loadUnreadNotif();
      mad.common.startCheckingNotif();

      //this is promise needed for calling get user info
      var getUSerInfoPromise = $.Deferred();

      getUSerInfoPromise
        .then(function (sucess) {
          //if there was some err
          if (!sucess) {
            //if there was some err delete data about subscription
            //this will force getting info about subscription from server
            mad.local.removeVariable("SubscriptionInfo");
          }
        })
        .fail(function () {
          //if there was some err delete data about subscription
          //this will force getting info about subscription from server
          mad.local.removeVariable("SubscriptionInfo");
        });

      mad.common.getUserInfo(getUSerInfoPromise, false);
    } else {
      console.log("mad.loginToken NE postoji");
      // check externalLink
      // check if there is an external link
      var extLink = mad.common.observables.get("externalLink");
      if (extLink != "") {
        // & if there is
        console.log("there is external link to", extLink, "but go to start");
        mad.mobileApp.navigate("ui/other/start.html"); // goto start page
        return; // exit resume
      }
    }

    if (mad.viewModels.madbarzWorkout.viewModel.get("pause") == "active") {
      mad.viewModels.madbarzWorkout.viewModel.set("pauseResume", new Date());
      passedTimeInSec = Math.round(
        (mad.viewModels.madbarzWorkout.viewModel.get("pauseResume") -
          mad.viewModels.madbarzWorkout.viewModel.get("pauseExit")) /
        1000
      );
      //console.log("proteklo je (sec)", passedTimeInSec);

      var restPauseTime =
        mad.viewModels.madbarzWorkout.pauza.brojac.value() - passedTimeInSec;
      //console.log("ostalo je jos (sec)", restPauseTime);
      if (restPauseTime <= 0) {
        //mad.alerts.info("pause expired ");
        mad.viewModels.madbarzExercising.viewModel.set(
          "pauseTxt",
          mad.glossary.ui.madbarzExercising.labels.resume[
          mad.common.observables.languageIndex()
          ]
        );
        mad.viewModels.madbarzWorkout.viewModel.set(
          "counters.pauseCountdown",
          0
        );
        //console.log("counters.pauseCountdown je na 0")
        mad.viewModels.madbarzWorkout.pauza.brojac.value(0);
        //console.log("pauza.brojac.value je na 0")
        mad.viewModels.madbarzWorkout.pauza.brojac.stop();
        //console.log("brojac je stopiran")
      } else {
        //console.log("pauza nastavlja na",restPauseTime)
        mad.viewModels.madbarzWorkout.pauza.brojac.resume(restPauseTime);
      }
    } else if (
      mad.viewModels.madbarzExercising.viewModel.get("workoutTimerActive")
    ) {
      timeNow = new Date();
      passedTimeInSec = Math.round(
        (timeNow -
          mad.viewModels.madbarzExercising.viewModel.get("workoutStoppedAt")) /
        1000
      );
      mad.viewModels.madbarzExercising.viewModel.set(
        "workoutStoppedAt",
        new Date()
      );
      mad.viewModels.madbarzExercising.vjezbanje.brojac.resume(
        mad.viewModels.madbarzExercising.vjezbanje.brojac.value() +
        passedTimeInSec
      );
    } else {
      // check externalLink
      // check if there is an external link
      var extLink = mad.common.observables.get("externalLink");
      if (extLink != "") {
        // & if there is
        console.log("there is external link to", extLink);
        mad.common.observables.set("externalLink", ""); // clear external link
        mad.mobileApp.navigate(extLink); // go there
      }
    }
  };

  var onOnline = function () {
    if (
      navigator.connection.type != Connection.UNKNOWN &&
      navigator.connection.type != Connection.NONE
    ) {
      console.log("online");
      mad.common.observables.set("networkStatus", "online");
      // mad.alerts.success("You are online now");

      if (firstTimeOnlineOffline) {
        //mad.alerts.success(mad.common.translate("words", "online"));
        // mad.alerts.success("You are online now");
      } else {
        firstTimeOnlineOffline = true;
      }

      /* drazen - prebaceno na lokiReady change event
        doRebind();
        doSyncing();
        */
    }
  };

  var doSyncing = function () {
    //console.log("doSyncing called ");
    if (mad.common.observables.get("syncingTrenings")) return; //exit if already syncing
    if (mad.common.observables.get("syncingUpdates")) return; //exit if already syncing

    var treningsToSync, updatesToSync, treningsToSyncPlan;

    //console.log(mad.local.loadVariable("pendingSync"));

    if (
      mad.local.loadVariable("pendingSync") == "true" ||
      mad.local.loadVariable("pendingSync") == true
    ) {
      // if there is something to sync

      if (
        navigator.connection.type != Connection.UNKNOWN &&
        navigator.connection.type != Connection.NONE
      ) {
        console.log("there is something to sync");
        mad.alerts.success("Syncing data ...");

        mad.common.observables.bind("checkSync", mad.common.checkSyncFinished); //attach handler to event once

        updatesToSync = mad.local.getPendingUpdates();
        if (!mad.common.isNullOrEmpty(updatesToSync)) {
          //console.log("there is update(s) to sync");
          mad.common.pendingUpdates = updatesToSync;
          mad.viewModels.madbarzWorkout.syncPendingUpdates();
        }

        treningsToSync = mad.local.getWorkout();
        if (!mad.common.isNullOrEmpty(treningsToSync)) {
          //console.log("there is workout(s) to sync");
          mad.common.pendingWorkouts = treningsToSync;
          mad.viewModels.madbarzWorkout.syncPendingWorkout();
        }

        treningsToSyncPlan = mad.local.getWorkoutPlan();
        if (!mad.common.isNullOrEmpty(treningsToSyncPlan)) {
          console.log("there is workout(s) from plans to sync");
          console.log("ali se ne handlayu za sada");
          /*
                   mad.common.pendingWorkoutsPlan = treningsToSyncPlan;        //pendingWorkoutsPlan nije deklariran
                   mad.viewModels.madbarzWorkout.syncPendingWorkoutPlan();
                   */
        }
      }
    } else {
      console.log("there is nothing to sync");
    }
  };

  var onOffline = function () {
    if (navigator.connection.type == Connection.NONE) {
      console.log("offline");
      mad.common.observables.set("networkStatus", "offline");

      if (firstTimeOnlineOffline) {
        mad.alerts.top0("You are currently offline");
      } else {
        firstTimeOnlineOffline = true;
      }

      doRebind();
    }
  };

  var doRebind = function () {
    //console.log("common", mad.common);

    var actualView = mad.common.actualView;

    if (!actualView) return;

    var actualViewModel = mad.common.actualView.model,
      actualViewObject = $(mad.common.$actualViewID);

    if (actualViewObject && actualViewModel) {
      console.log("rebinding view model because of network status changed");
      kendo.bind(actualViewObject, actualViewModel);
    } else {
      console.log(
        "rebinding, missing data: object,model",
        actualViewObject,
        actualViewModel
      );
    }
  };

  var onBackButton = function (e) {
    console.log("< - back button", mad.common.actualViewID);
    e.preventDefault();
    e.stopPropagation();

    var time = new Date().getTime();
    //console.log("vremena",time - lastBackTime, backButtonDelay);

    if (time - lastBackTime < backButtonDelay) {
      // ako nije proslo dovoljno vremena zanemari back
      //console.log("< < < < < < < < < zanemari back");
      return;
    }
    lastBackTime = time;

    // ako je kbd otvoren zatvori ga i nista vise
    if (mad.common.variables.keyboard.opened) {
      if (cordova.plugins && cordova.plugins.Keyboard) {
        console.log("kbd close");
        cordova.plugins.Keyboard.close();

        if (
          mad.common.actualViewID == "register" &&
          mad.viewModels.register.viewModel.get("currentPage") == 5
        ) {
          setTimeout(function () {
            $("#register [data-role='content']").animate({ marginTop: 0 }, 222);
          }, 22);
        } else if (mad.common.actualViewID == "workoutDetailsComments") {
          setTimeout(function () {
            $("#workoutDetailsComments-bottom").animate({ bottom: 0 }, 222);
          }, 22);
        }

        return;
      }
    }

    if (mad.common.actualViewID == "editReps") {
      mad.viewModels.editReps.viewModel.leftButtonAction();
    } else if (mad.common.actualViewID == "contactUs") {
      if (mad.viewModels.contact.viewModel.get("dropDownOpened")) {
        $("#contactUsDropDownList")
          .data("kendoDropDownList")
          .close();
      } else {
        mad.common.goBack();
      }
    } else if (
      mad.common.actualViewID == "madbarzWorkout" ||
      mad.common.actualViewID == "workoutDetailsComments" ||
      mad.common.actualViewID == "workoutDetails"
    ) {
      if (mad.viewModels.workoutVideo.viewModel.get("modalOpened")) {
        mad.viewModels.workoutVideo.viewModel.closeVideoModal();
      } else {
        if (
          mad.viewModels.popups.viewModel.get("opened") == "nextPartToList" ||
          mad.viewModels.popups.viewModel.get("opened") == "buySavedPRO"
        ) {
          mad.viewModels.popups.viewModel.closeModalWindow();
        } else {
          mad.common.goBack();
        }
      }
    } else if (mad.common.actualViewID == "createWorkoutMain") {
      if (mad.viewModels.workoutVideo.viewModel.get("modalOpened")) {
        mad.viewModels.workoutVideo.viewModel.closeVideoModal();
      } else {
        mad.common.goBack();
      }
    } else if (mad.common.actualViewID == "profileOtherUser") {
      if (mad.viewModels.profileOtherUser.viewModel.get("bigPhotoLoaded")) {
        mad.viewModels.profileOtherUser.viewModel.hideBigPhoto();
      } else {
        mad.common.goBack();
      }
    } else if (mad.common.actualViewID == "createWorkoutExercises") {
      if (mad.viewModels.workoutVideo.viewModel.get("modalOpened")) {
        mad.viewModels.workoutVideo.viewModel.closeVideoModal();
      } else {
        if (
          mad.viewModels.createWorkoutExercises.viewModel.get(
            "actionsheetOpened"
          )
        ) {
          $("#workoutsCreateAddExercisesTagFilterActionsheet")
            .data("kendoMobileActionSheet")
            .close();
          mad.viewModels.createWorkoutExercises.viewModel.set(
            "actionsheetOpened",
            false
          );
        } else {
          mad.mobileApp.navigate("ui/workouts/createWorkout/Main.html");
        }
      }
    } else if (mad.common.actualViewID == "workoutsCreateTips") {
      mad.mobileApp.navigate(
        "ui/workouts/createWorkout/Main.html",
        "slide:left reverse"
      );
    } else if (mad.common.actualViewID == "editRepsCreate") {
      mad.viewModels.createWorkoutMain.viewModel.set(
        "editWorkoutModel",
        mad.viewModels.editRepsCreate.viewModel.get("editWorkoutModel")
      );
      mad.viewModels.createWorkoutMain.viewModel.set(
        "editWorkoutModel.Reps",
        mad.viewModels.createWorkoutMain.viewModel.get(
          "editWorkoutModel.OldValue"
        )
      );
      mad.mobileApp.navigate(
        "ui/workouts/createWorkout/Main.html",
        "slide:left reverse"
      );
    } else if (mad.common.actualViewID == "userProgress") {
      mad.mobileApp.navigate("ui/profile/profile.html", "slide:right");
    } else if (mad.common.actualViewID == "madbarzExercising") {
      if (mad.viewModels.workoutVideo.viewModel.get("modalOpened")) {
        mad.viewModels.workoutVideo.viewModel.closeVideoModal();
      } else {
        return null;
      }
    } else if (
      mad.common.actualViewID == "madbarzWorkoutStat" ||
      mad.common.actualViewID == "workoutDetailsComments"
    ) {
      mad.viewModels.madbarzWorkoutComment.viewModel.rightButtonAction();
    } else if (mad.common.actualViewID == "planWorkoutStat") {
      if (mad.viewModels.planWorkoutStat.viewModel.get("modalOpened")) {
        mad.viewModels.planWorkoutStat.viewModel.closeModal();
      } else {
        if (mad.viewModels.madbarzWorkout.viewModel.get("showPopup")) {
          mad.viewModels.popups.viewModel.openModalWindow(
            "nextPart",
            "Well done!",
            "You can now move on to a new plan!",
            "See plans"
          );
        } else {
          mad.mobileApp.navigate(
            "ui/feed/feed.html?origin=workoutComment",
            "slide:right"
          );
        }
      }
    } else if (mad.common.actualViewID == "madbarzWorkoutDone") {
      if (
        mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz"
      ) {
        //mad.mobileApp.navigate("ui/workouts/madbarz/madbarzWorkoutsList.html", "slide:left reverse");
        mad.mobileApp.navigate(
          "ui/workouts/madbarz/madbarzRoutines.html",
          "slide:left reverse"
        );
      } else {
        mad.mobileApp.navigate(
          "ui/workouts/saved/madbarzSavedWorkoutsList.html",
          "slide:left reverse"
        );
      }
    } else if (mad.common.actualViewID == "editProfile") {
      var mobiscrollHiden = false;

      var visina = $("#userHeight").mobiscroll("getInst");
      var rodjenje = $("#bDay").mobiscroll("getInst");
      var country = $("#country").mobiscroll("getInst");
      var state = $("#state").mobiscroll("getInst");

      if (visina.isVisible()) {
        mobiscrollHiden = true;
        $("#userHeight").mobiscroll("hide");
      }
      if (rodjenje.isVisible()) {
        mobiscrollHiden = true;
        $("#bDay").mobiscroll("hide");
      }
      if (country.isVisible()) {
        mobiscrollHiden = true;
        $("#country").mobiscroll("hide");
      }
      if (state.isVisible()) {
        mobiscrollHiden = true;
        $("#state").mobiscroll("hide");
      }

      if (mobiscrollHiden == false) {
        mad.common.goBack();
      }
    } else if (mad.common.actualViewID == "register") {
      var mobiscrollHiden = false;

      var visina = $("#RuserHeight").mobiscroll("getInst");
      var tezina = $("#RuserWeight").mobiscroll("getInst");
      var rodjenje = $("#RbDay").mobiscroll("getInst");
      var country = $("#Rcountry").mobiscroll("getInst");
      var state = $("#Rstate").mobiscroll("getInst");

      if (visina.isVisible()) {
        mobiscrollHiden = true;
        $("#RuserHeight").mobiscroll("hide");
      }
      if (tezina.isVisible()) {
        mobiscrollHiden = true;
        $("#RuserWeight").mobiscroll("hide");
      }
      if (rodjenje.isVisible()) {
        mobiscrollHiden = true;
        $("#RbDay").mobiscroll("hide");
      }
      if (country.isVisible()) {
        mobiscrollHiden = true;
        $("#Rcountry").mobiscroll("hide");
      }
      if (state.isVisible()) {
        mobiscrollHiden = true;
        $("#Rstate").mobiscroll("hide");
      }

      if (mobiscrollHiden == false) {
        mad.viewModels.register.viewModel.prev();
      }

      /*
        }else if   (mad.common.actualViewID == "ToU" ||
                    mad.common.actualViewID == "PP"){

            if (mad.common.variables.navigationHistory[1].id == "ui/profile/settings.html" ||
                mad.common.variables.navigationHistory[0].id == "ui/PRO/explain.html"){      // if we came from settings or sales page
                mad.common.goBack();
            }else{                                                          // we are on registration
                mad.mobileApp.navigate("ui/other/register.html?origin=document", "overlay:up reverse");
            }
        */
    } else if (mad.common.actualViewID == "weight") {
      var inst = $("#WeightUserWeight").mobiscroll("getInst");

      if (mad.viewModels.weight.viewModel.get("isModalOpened")) {
        $("#weightBrisanje")
          .data("kendoMobileModalView")
          .close();
        mad.viewModels.weight.viewModel.set("isModalOpened", false);
      } else {
        if (inst.isVisible()) {
          inst.hide();
        } else {
          mad.common.goBack();
        }
      }
    } else if (mad.common.actualViewID == "nutritionRules") {
      if (mad.viewModels.nutritionRules.viewModel.get("harmonikaOtvorena")) {
        var otvoreni = $("#rulesData .harmonika.km-expanded");
        if (otvoreni.length) {
          otvoreni.data("kendoMobileCollapsible").collapse();
        }
      } else {
        mad.common.goBack();
      }
    } else if (mad.common.actualViewID == "plans") {
      if (mad.viewModels.plans.viewModel.get("isModalOpened")) {
        mad.viewModels.plans.viewModel.closeModal();
      } else {
        mad.common.goBack();
      }
    } else if (mad.common.actualViewID == "plansWork") {
      if (mad.viewModels.plansWork.viewModel.get("isModalOpened")) {
        mad.viewModels.plansWork.viewModel.closeModal();
      } else {
        if (mad.viewModels.popups.viewModel.get("opened") == "nextWeek") {
          return null;
        } else {
          if (mad.viewModels.plansWork.viewModel.get("origin") == "present") {
            mad.common.removeLastFromHistory();
          }
          mad.common.goBack();
        }
      }
    } else if (mad.common.actualViewID == "leaderboard") {
      var inst = $("#filterCountry").mobiscroll("getInst");
      var inst2 = $("#filterGender").mobiscroll("getInst");

      if (inst.isVisible()) {
        inst.hide();
      } else if (inst2.isVisible()) {
        inst2.hide();
      } else {
        mad.common.goBack();
      }
    } else if (mad.common.actualViewID == "profile") {
      var inst = $(".actionsheetphotosource").mobiscroll("getInst");
      var inst2 = $(".actionsheetphotoupload").mobiscroll("getInst");

      if (inst.isVisible()) {
        inst.hide();
      } else if (inst2.isVisible()) {
        inst2.hide();
      } else if (mad.viewModels.editPhoto.viewModel.get("editModalOpened")) {
        mad.viewModels.editPhoto.viewModel.closePhotoModal();
      } else {
        if (mad.common.variables.navigationHistory.length > 1) {
          mad.common.goBack();
        } else {
          askForExit();
        }
      }
    } else if (mad.common.actualViewID == "madbarzWorkoutComment") {
      if (mad.viewModels.popups.viewModel.get("opened") == "nextPart") {
        mad.viewModels.popups.viewModel.closeModalWindow();
      }
    } else if (mad.common.actualViewID == "madbarzSavedWorkoutsList") {
      if (mad.viewModels.popups.viewModel.get("opened") == "buySaved") {
        mad.viewModels.popups.viewModel.closeModalWindow();
      } else {
        mad.common.goBack();
      }
    } else if (mad.common.actualViewID == "otherUserHistory") {
      if (mad.viewModels.popups.viewModel.get("opened") == "PRO") {
        mad.viewModels.popups.viewModel.closeModalWindow();
      } else {
        mad.common.goBack();
      }
    } else if (mad.common.actualViewID == "PROexplain") {
      if (mad.viewModels.popups.viewModel.get("opened") == "buyProSuccess") {
        mad.viewModels.popups.viewModel.closeModalWindow();
      } else {
        mad.common.goBack();
      }
    } else if (mad.common.actualViewID == "feed") {
      var inst = $("#feedMenu").mobiscroll("getInst");

      if (mad.viewModels.popups.viewModel.get("opened") == "proRutine") {
        mad.viewModels.popups.viewModel.closeModalWindow();
      } else if (inst.isVisible()) {
        inst.hide();
      } else {
        askForExit();
      }
    } else if (mad.common.actualViewID == "madbarzWorkoutsList") {
      if (mad.viewModels.popups.viewModel.get("opened") == "proRutine") {
        mad.viewModels.popups.viewModel.closeModalWindow();
      } else {
        mad.common.goBack();
      }
    } else if (mad.common.actualViewID == "notifications") {
      if (mad.viewModels.popups.viewModel.get("opened") == "PRO") {
        mad.viewModels.popups.viewModel.closeModalWindow();
      } else {
        askForExit();
      }
    } else if (mad.common.actualViewID == "workoutsMenu") {
      var inst = $(".actionsheetphotosource").mobiscroll("getInst");
      var inst2 = $(".actionsheetphotoupload").mobiscroll("getInst");

      if (inst.isVisible()) {
        inst.hide();
      } else if (inst2.isVisible()) {
        inst2.hide();
      } else if (mad.viewModels.editPhoto.viewModel.get("editModalOpened")) {
        mad.viewModels.editPhoto.viewModel.closePhotoModal();
      } else {
        askForExit();
      }
    } else if (
      mad.common.actualViewID == "madbarzNutrition" ||
      mad.common.actualViewID == "start-view"
    ) {
      askForExit();
    } else {
      mad.common.goBack();
    }
  };

  function askForExit() {
    var msg = mad.glossary.messages.sure,
      language = mad.common.observables.languageIndex();
    navigator.notification.confirm(
      msg.message[language],
      function (button) {
        if (button == 1) {
          // if yes
          if (window.plugins && window.plugins.NativeAudio) {
            window.plugins.NativeAudio.unload(
              "countdown",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "ten",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "say0",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "say0",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "say1",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "say2",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "say3",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "say4",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "say5",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "beep2",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "beep3",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "beep4",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
            window.plugins.NativeAudio.unload(
              "beep5",
              mad.common.audioOnSuccess,
              mad.common.audioOnError
            );
          }
          navigator.app.exitApp();
        }
      },
      msg.title[language],
      [msg.button1[language], msg.button2[language]]
    );
  }

  var onMenuButton = function () {
    console.log("menu button");
  };

  var gotoFeed = function (e) {
    console.log("doso izvana pa hoce na feed");
    mad.common.observables.set(
      "externalLink",
      "ui/feed/feed.html?origin=external"
    );
  };

  var gotoWorkoutsMenu = function (event) {
    console.log("doso izvama - link je", event.path);
    mad.common.observables.set(
      "externalLink",
      "ui/workouts/menu.html?origin=external"
    );
  };

  // wait for device ready & start app / here everything starts
  document.addEventListener("deviceready", onDeviceReady, false);

  return {
    onOnline: onOnline,
    onBackButton: onBackButton,
    doSyncing: doSyncing
  };
})(window);
