var mad = mad || {};

mad.appsFlyer = (function () {
  var appIsRunningInSimulator = window.navigator.simulator === true;

  function initAppsFlyer() {
    if (appIsRunningInSimulator) {
      return;
    }

    if (window.plugins.appsFlyer) {
      var options = {
        devKey: "hyQN88E7aUPR5AqNN7GTXH" // your AppsFlyer devKey
      };

      var userAgent = window.navigator.userAgent.toLowerCase();

      if (/iphone|ipad|ipod/.test(userAgent)) {
        options.appId = "969057083"; // your ios app id in app store
      }

      window.plugins.appsFlyer.initSdk(
        options,
        function () {
          console.log("Apps flyer init success!");
          window.plugins.appsFlyer.setCurrencyCode("USD");
          window.plugins.appsFlyer.enableUninstallTracking(
            "AIzaSyCZ961gd--vMHunsGsa0IiTwaz2RcSSDKI"
          );
        },
        function (err) {
          console.log("Apps flyer init fail:", err);
        }
      );
    }
  }

  function trackEvent(name, data) {
    if (window.plugins.appsFlyer) {
      window.plugins.appsFlyer.trackEvent(name, data);
    }
  }

  function trackFreeTrialEnter(subscriptionId, revenue) {
    if (window.plugins.appsFlyer) {
      var eventName = "Entered free trial - " + subscriptionId;
      // var eventValues = {
      //   af_content_id: subscriptionId,
      //   af_currency: "USD",
      //   af_revenue: revenue
      // };
      window.plugins.appsFlyer.trackEvent(eventName);
      window.plugins.appsFlyer.trackEvent("Entered free trial - Overall");
    }
  }

  function trackPurchase(subscriptionId, revenue) {
    if (window.plugins.appsFlyer) {
      var eventName = "af_purchase";
      var eventValues = {
        "af_content_id": subscriptionId,
        "af_currency": "USD",
        "af_revenue": revenue.toString()
      };
      window.plugins.appsFlyer.trackEvent(eventName, eventValues);
    }
  }

  function setUserId(userId) {
    if (window.plugins.appsFlyer) {
      window.plugins.appsFlyer.setAppUserId(userId);
    }
  }

  function getAppsFlyerId(madbarzUserId, promise) {
    console.log("##### APS F 1");
    if (
      !!window.plugins.appsFlyer &&
      !!window.plugins.appsFlyer.getAppsFlyerUID
    ) {
      try {
        window.plugins.appsFlyer.getAppsFlyerUID(function (id) {
          console.log("############# APS 2");
          if (!!madbarzUserId && !!id) {
            console.log("###################Got data from Apps F");
            sendAppsFlyerDataToServer(id, madbarzUserId, promise);
          } else {
            promise.resolve(true);
          }
        });
      } finally {
        promise.resolve(true);
      }
    } else {
      promise.resolve(true);
    }
  }

  function sendAppsFlyerDataToServer(appsFlyerId, madbarzUserId, promise) {
    var link = mad.common.variables.serverUrl + "/api/User/SetAppsFlyerId";
    var url = { putanja: link, akcija: "POST" };
    var data = {
      UserId: madbarzUserId,
      AppsFlyerId: appsFlyerId
    };
    mad.data.load(url, data, false, true).then(
      function () {
        console.log("Appsf success");
        promise.resolve(true);
      },
      function (err) {
        console.log("Appsf error", err);
        promise.resolve(true);
      }
    );
  }

  return {
    init: initAppsFlyer,
    trackEvent: trackEvent,
    setUserId: setUserId,
    trackFreeTrialEnter: trackFreeTrialEnter,
    trackPurchase: trackPurchase,
    getAppsFlyerId: getAppsFlyerId
  };
})();

