/// <reference path="subscriptionService.js" />
/// <reference path="facebookAnalytics.js" />
/// <reference path="azureAppInsights.js" />
/// <reference path="googleAnalytics.js" />

/* drazen - koristi za trigeriranje eventa unutar nekog objekta
 var obj = new kendo.Observable();
 obj.bind("myevent", function(e) {
 console.log(e.sender === obj); // outputs "true"
 console.log(this === obj); // also outputs "true"
 });
 obj.trigger("myevent"); // causes the handler to be executed
 evente spremi u triggers: {} objekt

 ili 'one' umjesto 'bind'
 vidi: http://docs.telerik.com/kendo-ui/api/javascript/observable
 */

var mad = mad || {};

mad.loginToken = ""; // drazen - ovdje se inicijalizira

/* custom binders */

kendo.data.binders.buttonIs = kendo.data.Binder.extend({
  init: function (element, bindings, options) {
    //call the base constructor
    kendo.data.Binder.fn.init.call(this, element, bindings, options);
  },
  refresh: function () {
    var dodaj,
      value = this.bindings["buttonIs"].get();

    $(this.element).empty();
    if (value) {
      if (mad.common.isImage(value)) {
        dodaj = value;
      } else {
        if (value.substr(0, 5).toLowerCase() == "<span") {
          dodaj = value;
        } else {
          dodaj = "<span>" + value + "</span>";
        }
      }
      $(this.element).append(dodaj);
    }
  }
});

kendo.data.binders.showMore = kendo.data.Binder.extend({
  // primjer: data-bind="invisible: ifSavedWorkout, showMore: more/less"
  // more i less su rijeci koje se prevode
  // contejner mora bit fiksne visine
  init: function (element, bindings, options) {
    kendo.data.Binder.fn.init.call(this, element, bindings, options);
  },
  refresh: function () {
    // drazen ovo treba prebacit u fiju koja (slicna) ce se pozivati
    // najvjerojatnije onShow jer generiranje cesto ide kroz template
    // i element moze biti nevidljiv

    var rijeci,
      rijec = [],
      prevedenaRijec = [],
      slash;
    rijeci = this.bindings.showMore.path;
    slash = rijeci.indexOf("/");
    if (slash < 0) {
      rijec[0] = "more";
      rijec[1] = "less";
    } else {
      rijec = rijeci.split("/");
    }
    prevedenaRijec[0] = mad.common.translate("words", rijec[0]);
    prevedenaRijec[1] = mad.common.translate("words", rijec[1]);

    var content = $(this.element).context;
    var actualHeight = content.scrollHeight;
    var visibleHeight = content.clientHeight;

    var dodaj =
      '<div data-role="touch" data-bind="events: {tap: showMore}" class="show-more">' +
      '<span class="more">' +
      prevedenaRijec[0] +
      "</span>" +
      '<span class="less">' +
      prevedenaRijec[1] +
      "</span>" +
      "</div>";
    $(this.element).append(dodaj);
    $(this.element)
      .find(".show-more")
      .hide();
    /*
        console.log(actualHeight);
        console.log(visibleHeight);
         */

    /*
        if (actualHeight-2 > visibleHeight) {
            $(this.element).append(dodaj);
            $(this.element).toggleClass("place-for-show-more");
            $(this.element).find(".less").hide();
            //$(this.element).toggleClass("full-text");
        } else {
           // niš za sada
        }
        */
  }
});

kendo.data.binders.word = kendo.data.Binder.extend({
  //custom binder za prevođenje rijeci
  //primjena:        <span data-bind="word:dummy" data-value="close" class="closeTxt"></span>
  //napomena         iza word: mora nesto pisati a rijec za koju trazimo prijevod stavimo u data-value

  init: function (element, bindings, options) {
    //call the base constructor
    kendo.data.Binder.fn.init.call(this, element, bindings, options);
  },
  refresh: function () {
    var dodaj,
      value = $(this.element).data("value");

    $(this.element).empty();
    if (value) {
      dodaj = mad.common.translate("words", value);
      $(this.element).append(dodaj);
    }
  }
});

kendo.data.binders.translate = kendo.data.Binder.extend({
  //custom binder za prevođenje rijeci
  //primjena:        <span data-bind="translate:message" data-value="tut-feed-1""></span>
  //napomena         iza translate: moze biti words (u glossary trazi pod words), messages (pod messages) ili ui (trazi actualViewID u glossary), izraz za koji trazimo prijevod stavimo u data-value

  init: function (element, bindings, options) {
    //call the base constructor
    kendo.data.Binder.fn.init.call(this, element, bindings, options);
  },
  refresh: function () {
    var dodaj,
      sto = this.bindings.translate.path,
      value = $(this.element).data("value"),
      find;

    if (sto == "word") {
      find = "words";
    } else if (sto == "message") {
      find = "messages";
    } else if (sto == "ui") {
      find = "ui";
    } else {
      return;
    }

    $(this.element).empty();
    if (value) {
      dodaj = mad.common.translate(find, value);
      $(this.element).append(dodaj);
    }
  }
});

kendo.data.binders.isEnabled = kendo.data.Binder.extend({
  init: function (element, bindings, options) {
    //call the base constructor
    kendo.data.Binder.fn.init.call(this, element, bindings, options);
  },
  refresh: function () {
    var DISABLEDSTATE = "k-state-disabled",
      value = this.bindings["isEnabled"].get();

    $(this.element)
      .toggleClass(DISABLEDSTATE, !value)
      .prop("disabled", !value)
      .attr("aria-disabled", !value);
  }
});

/* widget binding !  for data-role="button" or similar */
kendo.data.binders.widget.isEnabled = kendo.data.Binder.extend({
  init: function (widget, bindings, options) {
    kendo.data.Binder.fn.init.call(this, widget.element[0], bindings, options);
  },
  refresh: function () {
    var DISABLEDSTATE = "k-state-disabled",
      value = this.bindings["isEnabled"].get();

    $(this.element)
      .toggleClass(DISABLEDSTATE, !value)
      .prop("disabled", !value)
      .attr("aria-disabled", !value);
  }
});

kendo.data.binders.formatedTime = kendo.data.Binder.extend({
  refresh: function () {
    var total = this.bindings["formatedTime"].get();
    if (total) {
      $(this.element).text(mad.common.formatedTime(total));
    } else {
      $(this.element).text("00:00");
    }
  }
});

/* global data */
var os = kendo.support.mobileOS,
  env = "PROD",
  version = "4.1.5", // postavlja se u app.js kendoStarted na version is builda
  PAGE_SIZE = os ? (os.tablet ? 128 : 64) : 192,
  OFF = 0,
  ON = 1,
  firstTimeOnlineOffline = false,
  NOstringify = false,
  ForceGet = true,
  imgExtensionRegex = /\.(png|jpg|gif|jpeg|svg)/i,
  classRegex = /class/i,
  maxLoaderTime = 20000,
  ajaxWaitTime = 0,
  maxWaitTime = 20000,
  maxRetryTime = 60000,
  notifInterval = 4000 * 60, // svakih 1 minutu
  lastBackTime = new Date().getTime(), // last time android back pressed
  backButtonDelay = 789,
  timeBetweenSyncsWorkout = 1000 * 60 * 1, // svaku minutu
  timeBetweenSyncsSaved = 1000 * 60 * 0.5, // svakih 1/2 minute
  bLazy, // for lazy loading
  router, // for navigation (back) & view overlap handling
  appInsights,
  audioStatus,
  tts,
  localJsonDB,
  localUser,
  localApp,
  localSaved,
  localRoutines,
  localOther,
  localUserVariables = [
    "username",
    "firstName",
    "lastName",
    "userId",
    "userNoFollowing",
    "noOfWorkoutsInFeed",
    "FitnessLevel",
    "Score",
    "Goal",
    "NumberOfFinishedWorkouts",
    "HasUserNutrition",
    "HasUserUSW",
    "SubscriptionInfo",
    "DateUserJoined",
    "feedType",
    "DisplayName"
  ],
  //ove se cuvaju od brisanja
  localAppVariables = [
    "installationId",
    "pnsHandle",
    "subscribedNotificationTypes",
    "pendingSync",
    "pendingUpdates",
    "pendingTrenings",
    "pendingTreningsPlan",
    "version",
    "sleep",
    "mute",
    "tts",
    "lastQuote",
    "ProfilePhoto",
    "visitedFeed",
    "visitedMadbarzRoutines",
    "visitedWorkouts",
    "visitedCreateWorkouts",
    "visitedPlans",
    "visitedWorkoutDetails",
    "selectedLevel",
    "subscriptionProductIds",
    "WarmupReminder",
    "tutorialCreateWorkout",
    "fbUserId",
    "facebookToken",
    "token"
  ], //ove se cuvaju od brisanja
  localOtherVariables = [
    "tags",
    "routines-filter",
    "plans-filter",
    "exercise-filter"
  ],
  // navedene varijable trebaju biti dodane i unutar kolekcija u initLocalStorageDB

  fitLevels = ["?", "Beginner", "Intermediate", "Advanced"],
  languages = {
    //index je broj jezika (od 0)
    name: ["English", "Hrvatski"],
    short: ["eng", "hrv"],
    prompt: ["I want to use English", "Želim koristiti Hrvatski"]
  },
  Hresolutions = [
    { name: "Wmin", maxResPx: 640 },
    { name: "Wnor", maxResPx: 855 },
    { name: "Whig", maxResPx: 9999 }
  ],
  Vresolutions = [
    { name: "Hmin", maxResPx: 960 },
    { name: "Hnor", maxResPx: 1440 },
    { name: "Hhig", maxResPx: 9999 }
  ],
  buttons = ["set"],
  metricHeight = [],
  metricWeight = [],
  imperialWeight = [],
  keysCM = [],
  valuesCM = [],
  keysKG = [],
  valuesKG = [],
  keysLB = [],
  valuesLB = [],
  GCM_SENDER_ID = "75402587729";

for (var i = 100; i < 251; i++) {
  keysCM.push(i);
  valuesCM.push(i.toString());
}
for (var i = 40; i < 251; i++) {
  keysKG.push(i);
  valuesKG.push(i.toString());
}
for (var i = 88; i < 551; i++) {
  keysLB.push(i);
  valuesLB.push(i.toString());
}

var wInches = [
  [
    {
      label: "Feet",
      keys: [1, 2, 3, 4, 5, 6, 7, 8, 9],
      values: ["1", "2", "3", "4", "5", "6", "7", "8", "9"]
    },
    {
      label: "Inches",
      keys: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11],
      values: ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11"]
    }
  ]
],
  wLbs = [
    [
      {
        label: "Pounds",
        keys: keysLB,
        values: valuesLB
      }
    ]
  ],
  wCentimeters = [
    [
      {
        label: "Centimeters",
        keys: keysCM,
        values: valuesCM
      }
    ]
  ],
  wKilograms = [
    [
      {
        label: "Kilograms",
        keys: keysKG,
        values: valuesKG
      }
    ]
  ];

console.log("--------------", os, "kendo", kendo.version);

mad.common = (function () {
  var observableVariablesAndFunctions = kendo.observable({
    networkStatus: "?",
    ifOnline: getNetworkStatus,
    ifOffline: ifOffline,
    statusColor: getStatusColor,
    // insomniaStatus: "off",
    orientation: "portrait",
    selectedLanguage: "eng",
    languageIndex: function () {
      return languages.short.indexOf(this.get("selectedLanguage"));
    },
    goTo: goTo,
    gender: 1, // 0=mail 1=femail
    defaultGender: 0,
    askAboutWaiting: true,
    showCyclesCounter: true,
    showExercisesCounter: true,
    swipeToDelete: false,
    showTotalTime: true,
    syncingTrenings: false,
    syncingUpdates: false,
    hide: hideLoader,
    leftButton: getLeftButton,
    leftButton2: getLeftButton2,
    rightButton: getRightButton,
    rightButton2: getRightButton2,
    getButtonTxt: getFooterBtnTxt,

    lokiReady: false,
    externalLink: "",

    totalItemsFromFollwoing: 0,
    totalItemsFromFeedAll: 0,
    totalItemsFeatured: 0
  });

  var commonEvents = new kendo.observable();

  /*
    var actualView;     // this mustn't be observable beacuse it already is

    var actualViewID, actualContainerID,
        $actualViewID, $actualContainerID,
        previousViewID = "";
    */

  // other important variables
  var serverUrl = "https://api.madbarz.com/", //"https://test-madbarz-api.azurewebsites.net/"
    //  var serverUrl = "http://madbarzinfrastructureapi20170328112412.azurewebsites.net/",
    serverOpis = "Produkcija", //"Test Notifications Build",
    stagingServerUrl = "http://f4070a810da24041995330ac1ccd92fe.cloudapp.net/",
    forAjax = { putanja: "/", akcija: "GET" },
    dataOptions = {},
    timers = {};

  var commonVariables = {
    serverUrl: serverUrl,
    serverOpis: serverOpis,
    stagingServerUrl: stagingServerUrl,
    forAjax: forAjax,
    dataOptions: dataOptions,
    root: getRoot(),
    todaysQuote: "",
    timers: timers,
    tts: false,
    countries: [],
    USAstates: [],
    username: "?",
    firstName: "",
    lastName: "",
    displayName: "",
    gender: "m", // current user gender
    showGender: "m", // gender to show - current / other (used for muscle presentation)
    userId: "-",
    userNoFollowing: 0,
    noOfWorkoutsInFeed: 0,
    userWorkouts: 0,
    totalNotifications: 0,
    unreadNotifications: 0,
    HasUserNutrition: false,
    HasUserAccesToPro: -1,
    DateUserJoined: "",

    checkIfUserHasNutrition: checkIfUserHasNutrition,
    HasUserUSW: false,

    loggedOut: false,

    onStartCameFrom: "nowhere",

    navigationHistory: [],
    maxNavigationItems: 6,

    getUserName: "",
    getUserId: "",
    keyboard: {
      opened: false,
      offset: 0
    },
    screenSize: {},
    subscriptionProductIds: {
      Apple: [],
      Google: [],
      Web: []
    }
  };

  var pendingWorkouts = [];
  var pendingUpdates = [];
  var pendingWorkoutsPlan = [];

  //common functions
  function setActualView() {
    var actualView = mad.mobileApp.view() || "";
    var viewId, containerId;
    if (actualView == "") {
      viewId = "";
      containerId = "";
    } else {
      viewId = actualView.wrapper.attr("id");
      containerId = viewId + "Container";
    }

    mad.common.actualViewID = viewId;
    mad.common.actualContainerID = containerId;

    mad.common.$actualViewID = "#" + viewId;
    mad.common.$actualContainerID = "#" + containerId;

    mad.common.actualView = actualView;

    console.log("");
    console.log("aktualni view je", mad.common.actualViewID);

    if (cordova.plugins && cordova.plugins.Keyboard) {
      if (
        mad.common.actualViewID == "search" ||
        mad.common.actualViewID == "workoutDetails"
      ) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true); // false to show again
      } else {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false); // false to show again
      }
    }
  }

  function setResolutionForView(w, h) {
    var rezH = _.find(Hresolutions, function (item) {
      return w <= item.maxResPx;
    });
    var rezV = _.find(Vresolutions, function (item) {
      return h <= item.maxResPx;
    });

    var selView = d3.select(mad.common.$actualViewID);
    selView.classed(rezH.name + " " + rezV.name, true);
  }

  function translate(type, element) {
    /* klasican bind view modela se desava cak i prije init faze
        tako da translate ne mozemo koristiti u tom slucaju.
        mozemo ga koristiti u show fazi npr. kod generiranja templatea */

    if (type != "ui" && type != "messages" && type != "words") return "";

    var result = "",
      trazi = type + ".";

    if (type == "messages" || type == "words") {
      trazi += element;
    } else {
      // ui
      trazi += mad.common.actualViewID + "." + element;
    }

    result = _.get(mad.glossary, trazi);

    if (isNullOrEmpty(result)) {
      return "???";
    } else {
      var sentence = result[mad.common.observables.languageIndex()];
      if ($.isArray(sentence)) {
        sentence = sentence[mad.common.observables.get("gender")];
      }

      return sentence;
    }
  }

  function scrollViewToTop() {
    // scroll whole view to top
    var viewScroller = mad.mobileApp.scroller();
    if (viewScroller) {
      if (Math.abs(viewScroller.scrollTop) != 0) {
        viewScroller.reset();
      }
    }
  }

  function getRoot() {
    var path = window.location.pathname;
    var rootPath = path.substring(0, path.lastIndexOf("/"));
    return rootPath;
  }

  function getVersion() {
    // console.log("dohvat verzije");
    // if (!window.navigator.simulator) {
    //     cordova.getAppVersion(function (value) {
    //         console.log("app ver.", value);
    //         version = value;
    //     });
    // }else{
    //     version = "0";
    //     console.log("this is simulator version which is always 0");
    // }
    version = "4.1.5";
    return version;
  }

  function checkVersion() {
    if (mad.local.getVersion() != version) {
      // if version has changed
      console.log(
        "version changed / local version",
        mad.local.getVersion(),
        "app build version",
        version
      );
      //   mad.local.removeVariable("token"); // this is for when we want to log out user!
      //delete routines because of different format
      mad.local.removeMadbarzRoutines();
      mad.local.removeVariable("tags");
      mad.local.removeVariable("savedWorkouts");
      mad.local.saveVersion(version);
    } else {
      console.log("same app version");
    }
  }

  function checkTutorial(tutorial) {
    if (mad.common.isNullOrEmpty(mad.local.loadVariable(tutorial))) {
      return true; // tutorial not shown at all
    } else {
      if (mad.local.usernameExistsIn(tutorial, mad.common.variables.username)) {
        return false; // tutorial shown to user
      } else {
        return true; // tutorial not shown to user
      }
    }
  }

  function startCheckingNotif() {
    clearInterval(mad.common.variables.timers.notifications);
    mad.common.variables.timers.notifications = setInterval(
      loadUnreadNotif,
      notifInterval
    ); //ako se ne sakrije rucno sakrij nakon x vremena
  }

  function loadUnreadNotif() {
    console.log("loadUnreadNotif - - - - -");

    if (ifOffline()) {
      console.log("skipped notification check because we are offline");
      return;
    }

    mad.app.doSyncing(); // periodically try to sync data if necessary

    if (mad.common.actualView) {
      if (
        mad.common.actualViewID == "madbarzWorkout" ||
        mad.common.actualViewID == "madbarzExercising"
      ) {
        console.log("skipped notification check because we are exercising");
        return;
      }
    }

    //console.log("checking notifications");
    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "/api/Notifications/GetNumberOfUnReadNotifications";
        mad.common.variables.forAjax.akcija = "GET";
        mad.common.variables.dataOptions = {};
        */
    var link = {
      putanja:
        mad.common.variables.serverUrl +
        "/api/Notifications/GetNumberOfUnReadNotifications",
      akcija: "GET"
    };
    var podaci = {};

    mad.data
      .load(link, podaci, false, true)
      .done(function (data) {
        //console.log("update badge on tab")
        // za test data += Math.floor(Math.random()*100+1);
        mad.common.variables.unreadNotifications = data;
        //console.log("No notifications", data);
        if (
          mad.common.actualView &&
          mad.common.actualViewID != "notifications"
        ) {
          updateNotificationBadge();
        } else {
          console.log("there is no actual view or view is notifications");
        }
        setBadge(mad.common.variables.unreadNotifications);
      })
      .fail(function (e) {
        console.log("greska kod dohvata notifikacije", e);
      });
  }

  function updateNotificationBadge() {
    //console.log("updating badge")
    var mainMenu = mad.common.actualView.footer
      .find(".km-tabstrip")
      .data("kendoMobileTabStrip");
    if (mainMenu) {
      if (mad.common.variables.unreadNotifications == 0) {
        mainMenu.badge(3, false);
      } else {
        mainMenu.badge(3, mad.common.variables.unreadNotifications);
      }
    } else {
      console.log("this view has no footer with tabstrip");
    }
  }

  function getUserInfo(promise, isCalledAfterRegistration) {
    console.log("getUserInfo");

    var loadedRoutines = mad.local.loadMadbarzRoutines(),
      routines = loadedRoutines.data,
      expired = loadedRoutines.expired;

    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/User/GetUserBasic";
        mad.common.variables.forAjax.akcija = "GET";
        mad.common.variables.dataOptions = {
            shouldIncludeFeaturedWithFollowing: false
        };
        */
    var link = {
      putanja: mad.common.variables.serverUrl + "api/User/GetUserBasic",
      akcija: "GET"
    };
    var podaci = {
      shouldIncludeFeaturedWithFollowing: false
    };

    mad.data
      .load(link, podaci, false, true)
      .done(function (data) {
        mad.common.hideLoader();

        if (data.IsBanned) {
          //clear cache
          mad.local.clear(); //  pendingSync, trenings, treningsPlan, updates, installationId, ProfilePhoto i pnsHandle su sacuvani (ili app kolekcija u lokiju)

          //do logout
          mad.viewModels.settings.doLogout();
        }

        console.log("user info data", data);
        // stavi sve ovo u user objekt u koji ces dodati i info kod dohvacanja profila
        mad.local.saveVariable("username", data.UserName);
        mad.local.saveVariable("firstName", data.FirstName);
        mad.local.saveVariable("lastName", data.LastName);
        mad.local.saveVariable("userId", data.Id);
        mad.local.saveVariable(
          "noOfWorkoutsInFeed",
          data.NumberOfFeedItemsInFeedFollowing
        );
        mad.local.saveVariable("userNoFollowing", data.NumberOfFollowing);
        mad.local.saveVariable("FitnessLevel", data.FitnessLevel);
        mad.local.saveVariable("Score", data.Score);
        mad.local.saveVariable("Goal", data.Goal);
        mad.local.saveVariable(
          "NumberOfFinishedWorkouts",
          data.NumberOfFinishedWorkouts
        );
        mad.local.saveVariable("HasUserNutrition", data.HasUserNutrition);
        mad.local.saveVariable("DateUserJoined", data.DateUserJoined);
        mad.local.saveVariable("HasUserUSW", data.HasUserUSW);
        mad.local.saveVariable("DisplayName", data.DisplayName);

        mad.local.saveVariableParse("ProfilePhoto", data.ProfilePhotoBase64);

        //info about users latest subscription
        mad.local.saveVariableParse("SubscriptionInfo", data.SubscriptionInfo);

        mad.common.variables.username = data.UserName;
        mad.common.variables.firstName = data.FirstName;
        mad.common.variables.lastName = data.LastName;
        mad.common.variables.displayName = data.DisplayName;

        mad.common.variables.gender = data.Gender == "Female" ? "f" : "m"; // drazen - not stored locally
        mad.common.variables.showGender = mad.common.variables.gender;
        mad.common.variables.userId = data.Id;
        mad.common.variables.userNoFollowing = data.NumberOfFollowing;
        mad.common.variables.noOfWorkoutsInFeed =
          data.NumberOfFeedItemsInFeedFollowing;
        mad.common.variables.HasUserNutrition = data.HasUserNutrition;
        mad.common.variables.HasUserUSW = data.HasUserUSW;
        mad.common.variables.DateUserJoined = data.DateUserJoined;

        // load new madbarz routines if necessary
        if (expired || routines.length == 0) {
          console.log("idem ucitat rutine sa servera jer ih nema lokalno");
          mad.local.removeMadbarzRoutines();
          mad.models.routines
            .read()
            .then(function () { })
            .fail(function () {
              console.log("GREŠKA, nisu loadana rutine");
            });
        }

        mad.models.exercisesDatasource.read(); // ucitaj exercises (spremaju se u createWorkoutExercises)

        console.log("going to preload nutrition rules from server");
        mad.viewModels.madbarzNutrition.viewModel.loadRules("fromServer");
        console.log("going to preload categories from server");
        mad.viewModels.madbarzNutrition.viewModel.loadCategories("fromServer");
        console.log("going to preload recipes from server");
        mad.viewModels.madbarzNutrition.viewModel.loadRecipes("fromServer");

        //mad.appTelemetry.setUserIdForAzureAppInsights(data.Id);

        //Mixpanel: if we want to have consistent  funnels before and after registration
        // we have connect Mixpanel user's id with our own
        if (isCalledAfterRegistration) {
          mad.mixpanel.connectMadbarzUserWithMixpanelAlias(data.Id);
        } else {
          //it is not registration; this user is already connected with mixpanel, we just
          //have to identify it, ie tell mixpanel who it is
          mad.analyticEvents.connectMadbarzUserIdWithAnalytics(data.Id);
        }

        mad.mixpanel.registerSuperProperties();
        mad.appsFlyer.setUserId(data.Id);
        mad.appsFlyer.getAppsFlyerId(data.Id, promise);
      })
      .fail(function (e) {
        mad.common.hideLoader();
        console.log("Error getUserInfo", e);
        promise.reject("error in getUserInfo");
      });
  }

  //this function determines wheter user has access to PRO or not
  function hasUserAccessToPro(deferred) {
    // drazen - todo / zakomentiraj
    //mad.common.variables.HasUserAccesToPro = 1;

    console.log("checking if user has access to PRO features");
    //firstly we check local var
    if (mad.common.variables.HasUserAccesToPro === 0) {
      // we are sure that user doesn't have access to pro; return false;
      deferred.resolve(false);
    } else if (mad.common.variables.HasUserAccesToPro === 1) {
      deferred.resolve(true);
    } else if (mad.common.variables.HasUserAccesToPro === -1) {
      // HasAccesToPro is not yet determined, call appropriate function calls depending on platform
      mad.subscriptionService.checkIfUserHasPro(deferred);
    } else {
      deferred.resolve(false);
    }
  }

  function checkIfUserHasNutrition(callback) {
    console.log("checkIfUserHasNutrition called");
    var link =
      mad.common.variables.serverUrl + "/api/Nutrition/CheckIfUserHasNutrition";
    var url = { putanja: link, akcija: "POST" };
    mad.data.load(url).then(callback.success, callback.error);
  }

  function cekajPromiseResolve(ms) {
    console.log("cekajPromiseResolve called");
    var d = $.Deferred();
    setTimeout(function () {
      console.log("cekajPromiseResolve resolved");
      d.resolve();
    }, ms);
    return d.promise();
  }

  function serverCheck(what, promise) {
    console.log("checking " + what);

    if (what != "Username" && what != "Email") {
      console.log("serverCheck - wrong parm");
      promise.reject("invalid first parm");
      return false;
    }

    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/Account/Check" + what;
        mad.common.variables.forAjax.akcija = "POST";
        if (what == "Username") {
            mad.common.variables.dataOptions = { Username: mad.viewModels.register.viewModel.data.get("firstname") + "." + mad.viewModels.register.viewModel.data.get("lastname") };
        } else {
            mad.common.variables.dataOptions = { Email: mad.viewModels.register.viewModel.data.get("email") };
        }
        */

    var link = {
      putanja: mad.common.variables.serverUrl + "api/Account/Check",
      akcija: "POST"
    };
    var podaci;
    if (what == "Username") {
      podaci = {
        Username:
          mad.viewModels.register.viewModel.data.get("firstname") +
          "." +
          mad.viewModels.register.viewModel.data.get("lastname")
      };
      link.putanja += "Username";
    } else {
      podaci = { Email: mad.viewModels.register.viewModel.data.get("email") };
      link.putanja += "Email";
    }

    mad.data
      .load(link, podaci, false, true)
      .done(function (data) {
        if (!data) {
          mad.alerts.top0("This " + what + " is already used!");
          if (mad.common.variables.keyboard.opened) {
            $("#toast-container").css(
              "top",
              mad.common.variables.keyboard.offset
            );
          } else {
            $("#toast-container").css("top", 0);
          }

          //enable reg button
          $("#DoRegistrationWithEmail").attr("disabled", false);
          mad.common.hideLoader();
        }
        promise.resolve(data);
      })
      .fail(function (e) {
        mad.alerts.top0(
          "Error checking " + what + ". Do you have Internet connection?"
        );
        if (mad.common.variables.keyboard.opened) {
          $("#toast-container").css(
            "top",
            mad.common.variables.keyboard.offset
          );
        } else {
          $("#toast-container").css("top", 0);
        }
        promise.reject(e);
      });
  }

  function userRegistration(isFacebookLogin, fbToken, fbUserId, photo) {
    mad.common.variables.onStartCameFrom = "registration";

    var link,
      podaci,
      password = " ";
    if (isFacebookLogin) {
      link = {
        putanja:
          mad.common.variables.serverUrl + "api/Account/FacebookRegister",
        akcija: "POST"
      };
    } else {
      link = {
        putanja: mad.common.variables.serverUrl + "api/Account/RegisterNew",
        akcija: "POST"
      };
    }
    if (!isFacebookLogin) {
      password = mad.viewModels.register.viewModel.data.get("password");
    }

    podaci = {
      UserName:
        mad.viewModels.register.viewModel.data.get("firstname") +
        "." +
        mad.viewModels.register.viewModel.data.get("lastname"),
      FirstName: mad.viewModels.register.viewModel.data.get("firstname"),
      LastName: mad.viewModels.register.viewModel.data.get("lastname"),
      Password: password,
      Email: mad.viewModels.register.viewModel.data.get("email"),
      Country: mad.viewModels.register.viewModel.data.get("country"),
      Gender: mad.viewModels.register.viewModel.data.get("gender"),
      State: mad.viewModels.register.viewModel.data.get("state"),
      Goal: mad.viewModels.register.viewModel.data.get("goalTxt"),
      Fat: parseInt(mad.viewModels.register.viewModel.data.get("fat")),
      CurrentLevel: mad.viewModels.register.viewModel.data.get("levelTxt"),
      DayBorn: 1,
      MonthBorn: parseInt(
        mad.viewModels.register.viewModel.data.get("monthNum")
      ),
      YearBorn: parseInt(
        mad.viewModels.register.viewModel.data.get("yearBorn")
      ),
      Unit: mad.viewModels.register.viewModel.data.get("isMetric")
        ? "Metric (cm / kg)"
        : "Imperial (foot / lbs)",
      Height: parseInt(
        mad.viewModels.register.viewModel.data.get("HeightInCm")
      ),
      Weight: parseInt(
        mad.viewModels.register.viewModel.data.get("WeightInKg")
      ),
      Photo: photo,
      FbToken: fbToken,
      FbUserId: fbUserId
    };

    mad.data
      .load(link, podaci, false, true)
      .done(function (data) {
        // isprazni cijeli localStorage, ali sačuvaj installationId
        var installationId = mad.local.loadVariable("installationId");
        var pnsHandle = mad.local.loadVariable("pnsHandle");
        localStorage.clear();
        mad.local.saveVariable("installationId", installationId);
        mad.local.saveVariable("pnsHandle", pnsHandle);
        mad.common.hideLoader();

        if (data.Success || data.success) {
          if (isFacebookLogin) {
            getFBToken(fbToken, fbUserId, true);

            var additionalInfo = { "Is Facebook": true };

            //analytics services where we send data, category of evenet (max is allways sent), event type (such as event, view, purchase), event name, any additional info, event categorz, event action
            mad.analyticEvents.track(
              [
                mad.analyticEvents.services.GA,
                mad.analyticEvents.services.MIXP,
                mad.analyticEvents.services.FB
              ],
              mad.analyticEvents.categories.MAX,
              mad.analyticEvents.types.EVENT,
              "Registration finished",
              additionalInfo,
              "Registration finished",
              "Facebook"
            );
            mad.appsFlyer.trackEvent("Registration finished", additionalInfo);
          } else {
            var username = mad.viewModels.register.viewModel.data.get("email");
            getToken(
              username,
              mad.viewModels.register.viewModel.data.get("password"),
              true
            );

            var mixpanelData = { "Is Facebook": false };

            mad.analyticEvents.track(
              [
                mad.analyticEvents.services.GA,
                mad.analyticEvents.services.MIXP,
                mad.analyticEvents.services.FB
              ],
              mad.analyticEvents.categories.MAX,
              mad.analyticEvents.types.EVENT,
              "Registration finished",
              mixpanelData,
              "Registration finished",
              "Email"
            );

            mad.appsFlyer.trackEvent("Registration finished", mixpanelData);
          }
        } else {
          if (data.hasOwnProperty("token")) {
            mad.local.saveToken(data.token);
            mad.local.saveVariable("username", data.username);
            mad.common.variables.username = data.username;
            mad.loginToken = data.token;

            // Associate registered user with the installation
            mad.installation.associateUser();

            //get other user info
            var promise = $.Deferred();
            promise.then(
              function (success) {
                // prvi put idi na workouts menu
                mad.mobileApp.navigate(
                  "ui/workouts/menu.html?origin=registration"
                ); // show first view
              },
              function (fail) {
                console.log("getUserInfo failed");
                // prvi put idi na workouts menu
                mad.mobileApp.navigate(
                  "ui/workouts/menu.html?origin=registration"
                ); // show first view
              }
            );
            mad.common.getUserInfo(promise, false);
          } else {
            mad.alerts.top0(
              "Error during registration process.<br>Please, try again.(1)"
            );
            //there was some err during reg, enable button
            $("#DoRegistrationWithEmail").attr("disabled", false);
          }
        }
      })
      .fail(function (e, r, t) {
        mad.common.hideLoader();
        mad.alerts.top0(
          "Error during registration process.<br>Please, try again. (2)"
        );
        //there was some err during reg, enable button
        $("#DoRegistrationWithEmail").attr("disabled", false);
      });
  }

  function getToken(username, password, isCalledAfterRegistration) {
    console.log("getToken");

    mad.common.showLoader();

    var cntx = arguments.callee.toString();
    mad.appTelemetry.logInfo(
      "Trying to login",
      getCurrentFunctionName(cntx),
      "",
      mad.appTelemetry.SEVERITY.Information,
      "",
      username
    );

    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "token";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = {
            grant_type: "password",
            username: username,
            password: password
        };
        */
    var link = {
      putanja: mad.common.variables.serverUrl + "token",
      akcija: "POST"
    };
    var podaci = {
      grant_type: "password",
      username: username,
      password: password
    };

    mad.data
      .load(link, podaci)
      .done(function (data) {
        mad.common.hideLoader();
        if (data.hasOwnProperty("access_token")) {
          console.log("get token has access_token", data.access_token);

          mad.local.saveToken(data.access_token);
          mad.local.saveVariable("username", username);
          //mad.local.saveVariable("password", password);
          mad.loginToken = data.access_token;
          mad.common.variables.username = username;

          // Associate registered user with the installation
          mad.installation.associateUser();

          //get other user info
          var promise = $.Deferred();
          promise.then(
            function (success) {
              mad.common.loadUnreadNotif();
              mad.common.startCheckingNotif();

              if (mad.common.variables.onStartCameFrom == "registration") {
                mad.mobileApp.navigate(
                  "ui/workouts/menu.html?origin=registration"
                ); // show first view
              } else {
                //mad.app.onOnline();                                                     // do syncing if necessary

                console.log("in getToken calling sync");
                mad.app.doSyncing(); // do syncing if necessary

                /*
                            if (mad.common.variables.userNoFollowing > 0) {
                                //console.log("idi na feed tab 0");
                                mad.mobileApp.navigate("ui/feed/feed.html?tab=0");            // show first view
                            } else {
                                //console.log("idi na feed tab 1");
                                mad.mobileApp.navigate("ui/feed/feed.html?tab=1");            // show first view
                            }
                            */

                mad.mobileApp.navigate("ui/workouts/menu.html?origin=start"); // show first view
              }
            },
            function (fail) {
              console.log("getUserInfo failed");

              if (mad.common.variables.onStartCameFrom == "registration") {
                mad.mobileApp.navigate(
                  "ui/workouts/menu.html?origin=registration"
                ); // show first view
              } else {
                mad.mobileApp.navigate("ui/workouts/menu.html?origin=start"); // show first view
              }
            }
          );
          mad.common.getUserInfo(promise, isCalledAfterRegistration);
        } else {
          mad.alerts.topCenterE("error - no access_token", "");
        }
      })
      .fail(function (e) {
        mad.common.hideLoader();
        var por = JSON.parse(e.responseText);
        console.log("Error getting token ", e);

        mad.appTelemetry.logInfo(
          "Login Failed",
          getCurrentFunctionName(cntx),
          por.error_description.toString(),
          mad.appTelemetry.SEVERITY.Error,
          "",
          username
        );

        mad.alerts.topCenterE(por.error_description, "");

        //mad.alerts.topCenterE("Error contacting server !!", "");
        //mad.alerts.topCenterE("Error, please check your username and password", "");
      });
  }

  function getFBToken(fbToken, fbUserId, isCalledAfterRegistration) {
    console.log("getFBToken");

    mad.common.showLoaderNoCancel();

    var cntx = arguments.callee.toString();

    mad.appTelemetry.logInfo(
      "Facebook login - token - trying to get",
      getCurrentFunctionName(cntx),
      "",
      mad.appTelemetry.SEVERITY.Information,
      "",
      ""
    );
    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/account/LoginWithFacebook";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = {
            Token: fbToken,
            UserId: fbUserId
        };
        */
    var link = {
      putanja: mad.common.variables.serverUrl + "api/account/LoginWithFacebook",
      akcija: "POST"
    };
    var podaci = {
      Token: fbToken,
      UserId: fbUserId
    };

    mad.data
      .load(link, podaci)
      .done(function (data) {
        if (data.hasUserExisted) {
          if (data.hasOwnProperty("token")) {
            mad.local.saveToken(data.token);
            mad.local.saveVariable("username", data.username);
            mad.common.variables.username = data.username;
            mad.local.saveVariable("fbUserId", data.facebookUserId);
            mad.local.saveVariable("facebookToken", data.facebookToken);
            mad.loginToken = data.token;

            // Associate registered user with the installation

            mad.installation.associateUser();

            mad.appTelemetry.logInfo(
              "Facebook login - token - success",
              getCurrentFunctionName(cntx),
              "",
              mad.appTelemetry.SEVERITY.Information,
              "",
              data.username
            );

            //get other user info
            var promise = $.Deferred();
            promise.then(
              function (success) {
                mad.common.loadUnreadNotif();
                mad.common.startCheckingNotif();

                var origin = isCalledAfterRegistration
                  ? "registration"
                  : "start";

                mad.mobileApp.navigate(
                  "ui/workouts/menu.html?origin=" + origin
                ); // show first view
              },
              function (fail) {
                console.log("getUserInfo failed");
                mad.mobileApp.navigate(
                  "ui/workouts/menu.html?origin=" + origin
                ); // show first view
              }
            );

            mad.common.getUserInfo(promise, isCalledAfterRegistration);
          } else {
            mad.appTelemetry.logInfo(
              "Facebook login - token - failed",
              getCurrentFunctionName(cntx),
              "No token",
              mad.appTelemetry.SEVERITY.Error,
              "",
              ""
            );
            mad.alerts.error0("error - no access_token");
          }
        } else {
          getFBInfo(fbToken, fbUserId);
        }
      })
      .fail(function (e) {
        var por = JSON.parse(e.responseText);
        console.log("Error getting token ", e);
        mad.alerts.error0(por.error_description);

        mad.appTelemetry.logInfo(
          "Facebook login - token - failed",
          getCurrentFunctionName(cntx),
          por.error_description,
          mad.appTelemetry.SEVERITY.Error,
          "",
          ""
        );
      })
      .always(function () {
        mad.common.hideLoaderNoCancel();
      });
  }

  // this is for fb login (not register)
  function getFBInfo(fbToken, fbUserId) {
    //console.log("getFBInfo");

    mad.common.showLoaderNoCancel();
    var link = {
      putanja: mad.common.variables.serverUrl + "api/account/GetFacebookInfo",
      akcija: "POST"
    };
    var podaci = {
      Token: fbToken,
      UserId: fbUserId
    };

    mad.data
      .load(link, podaci)
      .done(function (data) {
        if (data.hasOwnProperty("token")) {
          // facebook login is ok, set everything and go to feed !!!
          mad.local.saveToken(data.token);
          mad.local.saveVariable("username", data.username);
          mad.common.variables.username = data.username;
          mad.local.saveVariable("fbUserId", data.facebookUserId);
          mad.local.saveVariable("facebookToken", data.facebookToken);
          mad.loginToken = data.token;

          // Associate registered user with the installation
          mad.installation.associateUser();

          //get other user info
          var promise = $.Deferred();
          promise.then(
            function (success) {
              // check if there is an external link
              var extLink = mad.common.observables.get("externalLink");
              if (extLink != "") {
                // & if there is
                console.log("there is external link to", extLink);
                mad.common.observables.set("externalLink", ""); // clear external link
                mad.mobileApp.navigate(extLink); // go there
              } else {
                mad.mobileApp.navigate("ui/workouts/menu.html?origin=start"); // show first view
              }
            },
            function (fail) {
              console.log("getUserInfo failed");
              var extLink = mad.common.observables.get("externalLink");
              if (extLink != "") {
                // & if there is
                console.log("there is external link to", extLink);
                mad.common.observables.set("externalLink", ""); // clear external link
                mad.mobileApp.navigate(extLink); // go there
              } else {
                mad.mobileApp.navigate("ui/workouts/menu.html?origin=start"); // show first view
              }
            }
          );
          mad.common.getUserInfo(promise, false);
        } else {
          //fb login is not ok, we don't have user ! we have to go to registration!!!
          mad.viewModels.register.viewModel.resetRegisterData("#register");

          mad.viewModels.register.viewModel.data.set(
            "firstname",
            data.firstName
          );
          mad.viewModels.register.viewModel.data.set("lastname", data.lastName);
          mad.viewModels.register.viewModel.data.set("email", data.email);

          mad.viewModels.register.viewModel.set("fbInfo", data);
          mad.viewModels.register.viewModel.set("isRegisterWithFacebook", true);
          mad.viewModels.register.viewModel.set("isLoginWithFacebook", true);

          //console.log(data);
          mad.mobileApp.navigate("ui/other/register.html"); // show first view
        }
      })
      .fail(function (e) {
        var por = JSON.parse(e.responseText);
        console.log("Error getting ifo ", e);
        mad.alerts.error0(por.error_description);
      })
      .always(function () {
        mad.common.hideLoaderNoCancel();
      });
  }

  function stretchView() {
    var h = mad.common.actualView.content.height();
    var w = mad.common.actualView.content.width();
    $(mad.common.$actualViewID + " .mainContainer").css("height", h);
    $(mad.common.$actualViewID + " .mainContainer").css("width", w);
  }

  function stretchViewContentToBeElastic() {
    /* for view which usually has
         data-stretch="false"
         and kendo generated scroller
         this will stretch view's main container to be a little bigger and so elastic
         and return height of content area (w/o header & footer)
         */

    var winH = $(window).height();
    var winW = $(window).width();

    var head = $(mad.common.$actualViewID + " [data-role='header']");
    var foot = $(mad.common.$actualViewID + " [data-role='footer']");
    var headH = head.length ? head.height() : 0;
    var footH = foot.length ? foot.height() : 0;

    var h = winH - headH - footH + 3;
    //console.log("-/ actual view content height+3", h);

    $(mad.common.$actualContainerID).css({
      height: h,
      width: winW
    });

    return h;
  }

  function stretchViewContentToBeElasticWOhead() {
    /*
         this will stretch view's main container to be a little bigger and so elastic
         and return height of content area
         */

    var winH = $(window).height() + 3;
    var winW = $(window).width();

    $(mad.common.$actualContainerID).css({
      height: winH,
      width: winW
    });

    return winH;
  }

  function setViewBackground(color) {
    $(mad.common.$actualContainerID).css("background", color);
  }

  function setActualViewTitle() {
    mad.common.actualView.title =
      mad.glossary.ui[mad.common.actualViewID].header.title[
      mad.common.observables.languageIndex()
      ];
    mad.common.actualView.header
      .find(".km-navbar")
      .data("kendoMobileNavBar")
      .title(
        mad.glossary.ui[mad.common.actualViewID].header.title[
        mad.common.observables.languageIndex()
        ]
      );
  }

  function handleTabSwipe(e) {
    // dakle, sad svi koji koriste ovaj svipe moraju u view modelu imati isDragging i isOpened
    var actualViewModel = mad.common.actualView.model;

    // za swipe to delete i sl.
    if (actualViewModel.get("isDragging") && actualViewModel.get("isOpened")) {
      e.preventDefault();
      return;
    }
    var previousIndex = actualViewModel.get("selectedTab"),
      selectedIndex;

    var tabstrip = $(mad.common.$actualViewID + "-submenu").data(
      "kendoTabStrip"
    );

    if (e.direction == "left") {
      if (previousIndex < 2) {
        selectedIndex = previousIndex + 1;
        tabstrip.select(selectedIndex);
      }
    } else {
      if (previousIndex > 0) {
        selectedIndex = previousIndex - 1;
        tabstrip.select(selectedIndex);
      }
    }
  }

  function appendSlideLine() {
    // add menu slide line
    if ($(mad.common.$actualViewID + "-submenu li.slide-line").length) {
      console.log("****  vec postoji slide line u", mad.common.$actualViewID);
    } else {
      //$(mad.common.$actualViewID + "-submenu ul").append('<li class="slide-line"></li>');
      $(mad.common.$actualViewID + "-submenu ul.k-tabstrip-items").append(
        '<li class="slide-line"></li>'
      );
    }
  }

  function handleTabSliding(menuItem, promise) {
    var actualViewModel = mad.common.actualView.model;
    var selectedIndex = menuItem.index();
    var previousIndex = actualViewModel.get("selectedTab");
    var duration = actualViewModel.get("duration") || 444;

    //animate menu selection
    $(mad.common.$actualViewID + "-submenu .slide-line").animate(
      {
        width: menuItem.width(),
        left: menuItem.position().left
      },
      duration
    );

    //console.log("sel, previous", selectedIndex, previousIndex);

    if (selectedIndex > previousIndex) {
      slideLeft(previousIndex, selectedIndex, duration, promise);
    } else if (selectedIndex < previousIndex) {
      slideRight(previousIndex, selectedIndex, duration, promise);
    } else {
      promise.resolve(true); //back on same tab (no change)
    }
  }

  function slideLeft(tab, nextTab, duration, promise) {
    //console.log("sliding left")

    var firstTab = $(mad.common.$actualViewID + "-submenu-" + (tab + 1));
    var secondTab = $(mad.common.$actualViewID + "-submenu-" + (nextTab + 1));

    var actualTab = kendo.fx(firstTab);
    var tabToShow = kendo.fx(secondTab);

    var effectsOut = actualTab.slideIn("right");
    effectsOut
      .duration(duration)
      .stop()
      .reverse();

    var effectsIn = tabToShow.slideIn("left");
    effectsIn
      .duration(duration)
      .stop()
      .play()
      .then(function () {
        //console.log("slide finished");
        mad.common.actualView.model.set("selectedTab", nextTab);
        promise.resolve(true);
      });
  }

  function slideRight(tab, nextTab, duration, promise) {
    //console.log("sliding right")

    var firstTab = $(mad.common.$actualViewID + "-submenu-" + (tab + 1));
    var secondTab = $(mad.common.$actualViewID + "-submenu-" + (nextTab + 1));

    var actualTab = kendo.fx(firstTab);
    var tabToShow = kendo.fx(secondTab);

    var effectsOut = actualTab.slideIn("left");
    effectsOut
      .duration(duration)
      .stop()
      .reverse();

    var effectsIn = tabToShow.slideIn("right");
    effectsIn
      .duration(duration)
      .stop()
      .play()
      .then(function () {
        //console.log("slide finished");
        mad.common.actualView.model.set("selectedTab", nextTab);
        promise.resolve(true);
      });
  }

  function goTo(e) {
    /* on TAP event    //click event,
         koristi data-href za link
         za koji se podrazumjeva da je navedena putanja.
         primjer:
         data-href="ui/workouts/saved/madbarzSavedWorkoutsList.html"
         ako postoji view #madbarzSavedWorkoutsList ide na njega
         u protivnom ide na putanju
         [ovo rjesava problem u offline modu jer visestruki poziv preko href kreira vise view-ova
         */

    var target,
      ndx1,
      ndx2,
      ndx3,
      goWhereID,
      params = "";

    //target = e.touch.currentTarget,
    //target = e.touch.target.context;
    target = e.touch.target; // drazen - zbog nove verzije kenda

    (goWhere = $(target).attr("data-href")),
      (worksOffline = $(target).attr("data-worksoffline")); //vraca string true/false

    if (ifOffline() && worksOffline == "false") {
      mad.alerts.realTop0("You are currently offline");
      e.event.stopPropagation();
      return;
    }

    // izdvoji viewID i parametre
    ndx1 = goWhere.lastIndexOf("/") + 1;
    ndx2 = goWhere.indexOf(".");
    ndx3 = goWhere.indexOf("?");

    goWhereID = "#" + goWhere.substring(ndx1, ndx2);
    if (ndx3 > 0) {
      params = goWhere.substring(ndx3);
    }
    /*
        console.log("****** cijeli link / ", goWhere);
        console.log("****** ID viewa / ", goWhereID);
        console.log("****** parametri / ", params);
        */
    if ($(goWhereID).length) {
      console.log("idem lokalno na", goWhereID + params);
      mad.mobileApp.navigate(goWhereID + params, "slide");
    } else {
      console.log("idem remote na", goWhere);
      mad.mobileApp.navigate(goWhere, "slide");
    }
  }

  function addViewToHistory(what) {
    if (what == "reset") {
      commonVariables.navigationHistory = [];
    }
    var link = {};
    link.id = mad.common.actualView.id;
    link.viewId = mad.common.actualViewID;
    link.params = mad.common.actualView.params;
    // drazen - treba li tranzicija?

    if (commonVariables.navigationHistory.length > 0) {
      // ako ih ima
      if (commonVariables.navigationHistory[0].id != link.id) {
        // i nije isti kao zadnji dodan
        commonVariables.navigationHistory.unshift(link); // stavi na 1. mjesto
        /* izbacivanje prekobrojnog
                 if (commonVariables.navigationHistory.length > commonVariables.maxNavigationItems) {
                 commonVariables.navigationHistory.pop();
                 }
                */
      }
    } else {
      // nema nista u historiju
      commonVariables.navigationHistory.unshift(link); // stavi na 1. mjesto
    }
    //console.log("* * * history", commonVariables.navigationHistory);
  }

  function deleteHistory() {
    commonVariables.navigationHistory = [];
  }

  function removeLastFromHistory() {
    if (commonVariables.navigationHistory.length > 0) {
      //console.log("* * * history", commonVariables.navigationHistory);
      var removed = commonVariables.navigationHistory.shift(); // remove last added (from beginning)
      console.log("* * * history - removed", removed);
    }
  }

  function goBack() {
    if (commonVariables.navigationHistory.length > 0) {
      //console.log("* * * history back", commonVariables.navigationHistory);

      mad.common.previousViewID = "";

      var removed = commonVariables.navigationHistory.shift(); // remove last added (from beginning)
      if (commonVariables.navigationHistory.length > 0) {
        // if still something in history
        var actual = commonVariables.navigationHistory[0];
        actual.params.origin = removed.viewId; // set origin to ID of previous view

        // bloody exception (get tabs from previous view)
        if (actual.viewId == "following") {
          if (
            removed.viewId == "profile" ||
            removed.viewId == "profileOtherUser" ||
            removed.viewId == "search"
          ) {
            actual.params.tab = removed.params.tab;
          }
        } else if (actual.viewId == "workoutsMenu") {
          actual.params.modal = removed.params.modal; // show - prikazuje modal
        }

        var parametri = $.param(actual.params).replace(/\+/g, "%20");
        console.log("back to", actual.id + "?" + parametri);
        console.log("back from", removed.viewId, "to", actual.viewId);

        mad.common.previousViewID = removed.viewId;

        mad.mobileApp.navigate(
          actual.id + "?" + parametri,
          "slide:left reverse"
        );

        /*
                if (window.navigator.simulator === true){
                    mad.mobileApp.navigate(actual.id + '?' + parametri, "slide:left reverse");
                }else{
                    var options = {
                        "href"             : actual.id + "?" + parametri,
                        "direction"        : "right", // 'left|right|up|down', default 'left' (which is like 'next')
                        "duration"         :  500, // in milliseconds (ms), default 400
                        "slowdownfactor"   :    3, // overlap views (higher number is more) or no overlap (1). -1 doesn't slide at all. Default 4
                        "slidePixels"      :   20, // optional, works nice with slowdownfactor -1 to create a 'material design'-like effect. Default not set so it slides the entire page.
                        "iosdelay"         :  100, // ms to wait for the iOS webview to update before animation kicks in, default 60
                        "androiddelay"     :  150, // same as above but for Android, default 70
                        "winphonedelay"    :  250, // same as above but for Windows Phone, default 200,
                        "fixedPixelsTop"   :    0, // the number of pixels of your fixed header, default 0 (iOS and Android)
                        "fixedPixelsBottom":   60  // the number of pixels of your fixed footer (f.i. a tab bar), default 0 (iOS and Android)
                    };
                    window.plugins.nativepagetransitions.slide(
                        options,
                        function (msg) {console.log("navigate success: " + msg)}, // called when the animation has finished
                        function (msg) {console.log("navigate error:   " + msg)}  // called in case you pass in weird values
                    );
                }
                */
      } else {
        console.log("tapped back but there is nothing in history");
      }
    }
  }

  function titlePressed(e) {
    //mad.mobileApp.navigate("ui/other/settings.html");
  }

  function scaleMuscleMan(tabContainerH, tabContainerW) {
    var excludeFromCalc = 0;

    if (
      mad.common.actualViewID == "planWorkoutStat" ||
      mad.common.actualViewID == "planStat"
    ) {
      excludeFromCalc = 0;
    } else if (mad.common.actualViewID == "madbarzWorkoutStat") {
      excludeFromCalc = parseInt(
        $(mad.common.$actualViewID + " .text-block").outerHeight(true)
      );
    } else {
      excludeFromCalc =
        parseInt(
          $(mad.common.$actualViewID + " .card-musc-block").outerHeight(true)
        ) * 2; // cardio & muscles block height
    }

    // width & height of muscle man container
    var p = 0.15; //percentage 15%
    var w = tabContainerW - tabContainerW * p;
    var h = tabContainerH - excludeFromCalc - tabContainerH * p;

    // original image dims
    var originalWidth = 398;
    var originalHeight = 450;

    var scaleFactorWidth = w / originalWidth;
    var scaleFactorHeight = h / originalHeight;
    var scaleFactor =
      scaleFactorWidth < scaleFactorHeight
        ? scaleFactorWidth
        : scaleFactorHeight;

    w = parseInt(originalWidth * scaleFactor);
    h = parseInt(originalHeight * scaleFactor);

    //console.log("muscleMan", w, h);

    $(
      mad.common.$actualViewID +
      " " +
      mad.common.$actualViewID +
      "SingleMuscleMap"
    ).css("width", w);
    $(
      mad.common.$actualViewID +
      " " +
      mad.common.$actualViewID +
      "SingleMuscleMap"
    ).css("height", h);
  }

  function scaleMuscleMan2(tabContainerH, tabContainerW, reducePercent) {
    var w = tabContainerW - tabContainerW * (reducePercent / 100);
    var h = tabContainerH - tabContainerH * (reducePercent / 100);

    // original image dims
    var originalWidth = 398;
    var originalHeight = 450;

    var scaleFactorWidth = w / originalWidth;
    var scaleFactorHeight = h / originalHeight;
    var scaleFactor =
      scaleFactorWidth < scaleFactorHeight
        ? scaleFactorWidth
        : scaleFactorHeight;

    w = parseInt(originalWidth * scaleFactor);
    h = parseInt(originalHeight * scaleFactor);

    //console.log("muscleMan", w, h);

    $(
      mad.common.$actualViewID +
      " " +
      mad.common.$actualViewID +
      "SingleMuscleMap"
    ).css("width", w);
    $(
      mad.common.$actualViewID +
      " " +
      mad.common.$actualViewID +
      "SingleMuscleMap"
    ).css("height", h);
  }

  function showLoader(msg) {
    $(".loaderMessage").html(msg);
    $("#MadLoader").addClass("enabled");
    if (mad.common.observables.askAboutWaiting) {
      mad.common.variables.timers.showLoader = setTimeout(
        checkLoaderClosed,
        maxLoaderTime
      ); //ako se ne sakrije rucno sakrij nakon x vremena
    }
  }

  function showLoaderNoCancel(msg) {
    $(".loaderMessage").html(msg);
    $("#MadLoader").addClass("enabled");
  }

  function checkLoaderClosed() {
    if ($("#MadLoader").hasClass("enabled")) {
      // if loader is still running
      if (mad.common.observables.askAboutWaiting) {
        var msg = mad.glossary.messages.tooLong,
          language = mad.common.observables.languageIndex();
        navigator.notification.confirm(
          msg.message[language],
          function (button) {
            if (button == 2) {
              // and you want to cancel it
              hideLoader();
            } else {
              // you want to wait one cycle again
              clearTimeout(mad.common.variables.timers.showLoader);
              mad.common.variables.timers.showLoader = setTimeout(
                checkLoaderClosed,
                maxLoaderTime
              );
            }
          },
          msg.title[language],
          [msg.button1[language], msg.button2[language]]
        );
      } else {
        hideLoader();
      }
    }
  }

  function showBusyLoader(msg) {
    $(".loaderMessage").html(msg);
    $("#MadLoader").addClass("enabled");
  }

  function hideLoader() {
    //console.log("hide")
    $("#MadLoaderMessage").html("");
    $("#MadLoader").removeClass("enabled");
    if (mad.common.observables.askAboutWaiting) {
      clearTimeout(mad.common.variables.timers.showLoader);
    }
  }

  function hideLoaderNoCancel() {
    //console.log("hide")
    $("#MadLoaderMessage").html("");
    $("#MadLoader").removeClass("enabled");
  }

  function selectMenuTab(which) {
    // select appropriate tab
    var tabstrip = mad.mobileApp
      .view()
      .footer.find(".km-tabstrip")
      .data("kendoMobileTabStrip");
    if (which == "feed") {
      console.log(" > feed tab selected");
      tabstrip.switchByFullUrl("ui/feed/feed.html?origin=menu");
    } else if (which == "search") {
      console.log(" > search tab selected");
      tabstrip.switchTo("ui/search/search.html");
    } else if (which == "nutrition") {
      console.log(" > nutrition tab selected");
      tabstrip.switchByFullUrl("ui/nutrition/nutrition.html?origin=menu");
    } else if (which == "workouts") {
      console.log(" > workouts tab selected");
      tabstrip.switchByFullUrl("ui/workouts/menu.html?origin=menu");
    } else if (which == "notifications") {
      console.log(" > notifications tab selected");
      tabstrip.switchByFullUrl(
        "ui/notifications/notifications.html?origin=menu"
      );
    } else if (which == "profile") {
      console.log(" > profile tab selected");
      tabstrip.switchByFullUrl("ui/profile/profile.html?origin=menu"); //activate "profile/stats" tab
    } else {
      console.log(" > invalid tab name", which);
    }
  }

  function isImage(url) {
    var hasImgExtension = imgExtensionRegex.test(url);
    var hasHttp = url.toLowerCase().indexOf("http") == -1 ? false : true;
    var canBeImage = hasImgExtension || hasHttp;
    //console.log("image", url, "is", hasImgExtension, hasHttp, canBeImage );

    return canBeImage;
  }

  function hasClass(str) {
    return classRegex.test(str);
  }

  function preloadImage(src, callback) {
    var img = new Image();
    // bez dodatnih argumenata img.onload = callback;
    img.onload = function () {
      // s argumentima
      callback(src);
    };
    img.onerror = function () {
      callback(false); // return false on error
    };
    img.src = src;
  }

  function preloadImageWithPromise(src) {
    var deferred = $.Deferred();
    var img = new Image();
    img.onload = function () {
      deferred.resolve();
    };
    img.src = src;
    return deferred.promise();

    /* pozvala bi se npr. ovako za cekanje vise njih
         var loaders = [];
         loaders.push(preloadImageWithPromise('1.png'));
         loaders.push(preloadImageWithPromise('2.png'));
         loaders.push(preloadImageWithPromise('3.png'));
         $.when.apply(null, loaders).done(function() {
         // callback when everything was loaded
         });
         */
  }

  function showImage(url, type) {
    // this handler will search for prebundled images with the app, we bundle some images with the app so we don't have to pull them from the internet
    // (type === 'workout' || type === 'exercise')

    var imgFound = false;

    if (isNullOrEmpty(url)) {
      return "images/" + type + "/default.png";
    } else {
      var index = url.lastIndexOf("/");
      var imgName = url.substring(index + 1, url.length);

      if (imgName.indexOf("jpg") > 0) {
        if (imgName.indexOf(".jpg") < 0) {
          imgName += ".jpg";
        }
      } else if (imgName.indexOf("jpeg") > 0) {
        if (imgName.indexOf(".jpeg") < 0) {
          imgName += ".jpeg";
        }
      } else if (imgName.indexOf("png") > 0) {
        if (imgName.indexOf(".png") < 0) {
          imgName += ".png";
        }
      }

      var newPath = "images/" + type + "/" + imgName;

      //console.log("provjera slike", window.location.href.substring(0, window.location.href.indexOf("index.html")) + newPath);
      //console.log("root je", mad.common.variables.root);

      $.ajax({
        url:
          window.location.href.substring(
            0,
            window.location.href.indexOf("index.html")
          ) + newPath,
        async: false
      })
        .done(function () {
          imgFound = true;
        })
        .fail(function (e, e2) { });

      if (imgFound) {
        return newPath;
      } else {
        return url;
      }
    }
  }

  function getLocalImage(url, path) {
    if (isNullOrEmpty(url)) {
      return "images/" + path + "/default.png";
    } else {
      var index = url.lastIndexOf("/");
      var imgName = url.substring(index + 1, url.length);
      var newPath = "images/" + path + "/" + imgName;

      return newPath;
    }
  }

  function animate() {
    setTimeout(function () {
      var objekt = $(mad.common.$actualViewID + " .animiraj");
      objekt.addClass("animirano");
    }, 22);
  }

  function deAnimate() {
    setTimeout(function () {
      var objekt = $(mad.common.$actualViewID + " .animiraj");
      objekt.removeClass("animirano");
    }, 22);
  }

  function fadeIn() {
    var objekt = $(mad.common.$actualViewID + " .animiraj");
    if (objekt.length) {
      objekt.addClass("notransition");
      objekt.removeClass("animirano");
      objekt[0].offsetHeight; // Trigger a reflow, flushing the CSS changes

      setTimeout(function () {
        objekt.removeClass("notransition");
        objekt.addClass("animirano");
        objekt[0].offsetHeight; // Trigger a reflow, flushing the CSS changes
      }, 22);
    }
  }

  function fadeOut() {
    var elementi = d3.selectAll(mad.common.$actualViewID + " .animiraj");
    elementi
      .transition()
      //.duration(111)
      .style("opacity", "0");
  }

  function showUserImage(img) {
    if (ifOffline()) {
      return "images/icons/offline.svg";
    } else {
      return img != "/img/profile.jpg" &&
        img !=
        "https://madbarzpictures.blob.core.windows.net/madbarzpictures/profile-web-retina.jpg" &&
        img != "https://mdbrzallpics.azureedge.net/profile-web-retina.jpg"
        ? img
        : "images/profile-web-retina.jpg";
    }
  }

  function handleFeedTap(
    origin,
    listview,
    objekt,
    selectedItem,
    tab,
    scroller
  ) {
    //console.log("selected item nakon tap je", selectedItem);

    var userId =
      origin == "following" || origin == "search"
        ? selectedItem.Id
        : selectedItem.UserId;
    var originQS = "origin=" + origin;
    var usernameQS =
      "&UserName=" +
      (origin == "notifications"
        ? encodeURIComponent(selectedItem.Title)
        : encodeURIComponent(selectedItem.DisplayName));
    var userIdQS = "&UserId=" + userId;
    var workoutIdQS =
      "&WorkoutId=" +
      (origin == "notifications" ? selectedItem.Link : selectedItem.WorkoutId);
    var fromPlanQS = "&fromPlan=" + selectedItem.IsWorkoutFromPlan;
    var tabQS = "&tab=" + tab;
    var commonQS = originQS + tabQS + usernameQS + userIdQS;

    var link, sourceInfo, options, route, data;
    var followersBtn, followingBtn;

    function FEfollowingUpdate() {
      if (origin === "search") {
        listview.refresh();
      } else {
        if (selectedItem.IsCurrentUserAlreadyFollowing) {
          if (followersBtn) {
            followersBtn.removeClass("follow").addClass("following");
          }
          if (followingBtn) {
            followingBtn.removeClass("follow").addClass("following");
          }
        } else {
          if (followersBtn) {
            followersBtn.removeClass("following").addClass("follow");
          }
          if (followingBtn) {
            followingBtn.removeClass("following").addClass("follow");
          }
        }
      }
    }

    if (objekt.hasClass("gotoUser") && origin != "profileOtherUser") {
      if (userId != mad.common.variables.userId) {
        if (origin === "search") {
          sourceInfo = "People" + (tab === 0 ? " - Near you" : " -  Trending");
          data = {
            Source: sourceInfo
          };

          //analytics services where we send data, category of evenet (max is allways sent), event type (such as event, view, purchase), event name, any additional info, event categorz, event action
          mad.analyticEvents.track(
            [mad.analyticEvents.services.GA],
            mad.analyticEvents.categories.SOCIAL,
            mad.analyticEvents.types.EVENT,
            "Profile clicked",
            data,
            "Social",
            "Profile clicked",
            "From " + sourceInfo
          );
        }

        if (origin === "following") {
          if (tab === 0) {
            sourceInfo = "Followers list";
          } else {
            sourceInfo = "Following list";
          }
          data = {
            Source: sourceInfo
          };

          //analytics services where we send data, category of evenet (max is allways sent), event type (such as event, view, purchase), event name, any additional info, event categorz, event action
          mad.analyticEvents.track(
            [mad.analyticEvents.services.GA],
            mad.analyticEvents.categories.SOCIAL,
            mad.analyticEvents.types.EVENT,
            "Profile clicked",
            data,
            "Social",
            "Profile clicked",
            "From" + sourceInfo
          );
        }
        //link = encodeURIComponent("ui/profileOtherUser/profileOtherUser.html?" + commonQS);
        link = "ui/profileOtherUser/profileOtherUser.html?" + commonQS;
        console.log("link je", link);

        mad.mobileApp.navigate(link); // navigate to other user profile
      } else {
        //link = encodeURIComponent("ui/profile/profile.html?" + commonQS);
        //link = "ui/profile/profile.html?" + encodeURIComponent(commonQS);
        link = "ui/profile/profile.html?" + commonQS;
        mad.mobileApp.navigate(link); // navigate to yours user profile
      }
    } else if (objekt.hasClass("gotoWorkout")) {
      //za test
      //            selectedItem.IsProWorkout = false;

      //           mad.viewModels.popups.viewModel.openModal("PRO");

      if (origin == "otherUserHistory") {
        mad.analyticEvents.track(
          [mad.analyticEvents.services.GA],
          mad.analyticEvents.categories.PROFILEOTHER,
          mad.analyticEvents.types.EVENT,
          "Profile Other - Workouts - Single workout Click",
          null,
          "Profile Other",
          "SWorkouts",
          "Single workout click"
        );
      }

      if (!selectedItem.IsProWorkout) {
        mad.mobileApp.navigate(
          "ui/workoutDetails/workoutDetails.html?" +
          commonQS +
          workoutIdQS +
          fromPlanQS
        ); // navigate to workout
      } else {
        var checkIfUserHasAccesToProPromise = $.Deferred();

        checkIfUserHasAccesToProPromise
          .then(function (hasUserAccessToPRo) {
            if (hasUserAccessToPRo) {
              mad.mobileApp.navigate(
                "ui/workoutDetails/workoutDetails.html?" +
                commonQS +
                workoutIdQS +
                fromPlanQS
              ); // navigate to workout
            } else {
              //mad.viewModels.popups.viewModel.openModal("PRO");
              mad.viewModels.popups.viewModel.openModalWindow(
                "proRutine",
                "Premium workout",
                "Only premium members can see this workout. Premium members:",
                "Learn more"
              );
            }
          })
          .fail(function (err) {
            console.log(
              "There has been some errr determing if user is pro or not: ",
              err
            );
            //mad.viewModels.popups.viewModel.openModal("PRO");
            mad.viewModels.popups.viewModel.openModalWindow(
              "proRutine",
              "Premium workout",
              "Only premium members can see this workout. Premium members:",
              "Learn more"
            );
          });

        hasUserAccessToPro(checkIfUserHasAccesToProPromise);
      }
    } else if (objekt.hasClass("gotoComment")) {
      //za test
      // selectedItem.IsProWorkout = true;

      if (!selectedItem.IsProWorkout) {
        mad.mobileApp.navigate(
          "ui/workoutDetails/workoutDetailsComments.html?" +
          commonQS +
          workoutIdQS +
          fromPlanQS
        ); // navigate to workout comments
      } else {
        var checkIfUserHasAccesToProForCommentsPromise = $.Deferred();
        checkIfUserHasAccesToProForCommentsPromise
          .then(function (hasUserAccessToPRo) {
            if (hasUserAccessToPRo) {
              mad.mobileApp.navigate(
                "ui/workoutDetails/workoutDetailsComments.html?" +
                commonQS +
                workoutIdQS +
                fromPlanQS
              ); // navigate to workout comments
            } else {
              mad.viewModels.popups.viewModel.openModalWindow(
                "proRutine",
                "Premium workout",
                "Only premium members can see this workout. Premium members:",
                "Learn more"
              );
            }
          })
          .fail(function (err) {
            console.log(
              "There has been some errr determing if user is pro or not: ",
              err
            );
            //mad.viewModels.popups.viewModel.openModal("PRO");
            mad.viewModels.popups.viewModel.openModalWindow(
              "proRutine",
              "Premium workout",
              "Only premium members can see this workout. Premium members:",
              "Learn more"
            );
          });

        hasUserAccessToPro(checkIfUserHasAccesToProForCommentsPromise);
      }
    } else if (objekt.hasClass("presentPlan")) {
      var isPartFree = selectedItem.WorkoutPlanData.Groups.indexOf("Free") > -1;

      var additionalIfno = {
        "Part type": isPartFree ? "Free" : "Pro"
      };

      //analytics services where we send data, category of evenet (max is allways sent), event type (such as event, view, purchase), event name, any additional info, event categorz, event action
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA],
        mad.analyticEvents.categories.WORKOUTPLAN,
        mad.analyticEvents.types.EVENT,
        "Workout plan clicked",
        additionalIfno,
        "Workout plan",
        "Clicked",
        additionalIfno["Part type"]
      );

      if (selectedItem.WorkoutPlanData.Status == "active") {
        if (isPartFree || mad.viewModels.workoutsMenu.viewModel.get("IsPro")) {
          mad.mobileApp.navigate("ui/plans/work.html?" + originQS);
        } else {
          mad.mobileApp.navigate("ui/plans/present.html?" + originQS);
        }
      } else {
        mad.mobileApp.navigate("ui/plans/present.html?" + originQS);
      }
    } else if (objekt.hasClass("showPlan")) {
      mad.mobileApp.navigate("ui/plans/work.html?" + originQS + tabQS);
    } else if (objekt.hasClass("gotoCategory")) {
      mad.mobileApp.navigate(
        "ui/nutrition/categoryContent.html?" +
        originQS +
        "&title=" +
        selectedItem.Title +
        "&id=" +
        selectedItem.Id
      );
    } else if (objekt.hasClass("gotoRecipe")) {
      mad.mobileApp.navigate(
        "ui/nutrition/recipe.html?" +
        originQS +
        "&title=" +
        selectedItem.Title +
        "&id=" +
        selectedItem.Id
      );
    } else if (objekt.hasClass("respectClick")) {
      //handles if user respects / unrespects workout on feed

      var feedPrefix;
      if (mad.common.actualViewID == "feed") {
        feedPrefix = "-F-";
      } else if (mad.common.actualViewID == "userHistory") {
        feedPrefix = "-UH-";
      } else if (mad.common.actualViewID == "otherUserHistory") {
        feedPrefix = "-OUH-";
      } else {
        feedPrefix = "";
      }

      var respectIcon = $("#respectBtn" + feedPrefix + selectedItem.WorkoutId);

      // drazen rucno handlanje klasa jer listview.refresh() to ne radi dobro nakon druge strane
      if (respectIcon.hasClass("respect")) {
        respectIcon.removeClass("respect").addClass("respected");
      } else {
        respectIcon.removeClass("respected").addClass("respect");
      }

      var method = "";

      if (selectedItem.HasRespected) {
        selectedItem.HasRespected = false;
        selectedItem.NumberOfRespects--;
        method = "UnRespect";
      } else {
        selectedItem.HasRespected = true;
        selectedItem.NumberOfRespects++;
        if (selectedItem.NumberOfRespects <= 1) {
          selectedItem.IsFirstRespect = true; // ovdje se dodaje u dataSource i nigdje drugdje se ne vidi a koristi se u feed/hist templateu
        }
        method = "Respect";

        data = {
          "Where action occurred": "Feed Direct"
        };

        //analytics services where we send data, category of evenet (max is allways sent), event type (such as event, view, purchase), event name, any additional info, event categorz, event action
        mad.analyticEvents.track(
          [mad.analyticEvents.services.GA],
          mad.analyticEvents.categories.SOCIAL,
          mad.analyticEvents.types.EVENT,
          "Social - Respect",
          data,
          "Social",
          "Respect",
          "Feed Direct"
        );
      }

      updateRespectTxt(feedPrefix, selectedItem);

      route = {
        putanja: mad.common.variables.serverUrl + "api/FeedV3/Post" + method,
        akcija: "POST"
      };

      options = {
        workoutId: selectedItem.WorkoutId,
        IsWorkoutFromPlan: selectedItem.IsWorkoutFromPlan
      };

      mad.data
        .load(route, options, false, true)
        .done(function (data) {
          if (data.Result) {
            //console.log(method + " workout id:" + selectedItem.WorkoutId + "- from user: " + selectedItem.UserName);
          } else {
            console.log("respect error");
            //on frontend we automaticaly handle (un)respect, but if something fails on the server side we reverte changes
            selectedItem.HasRespected = !selectedItem.HasRespected;
            if (selectedItem.HasRespected) {
              selectedItem.NumberOfRespects++;
              respectIcon.removeClass("respect").addClass("respected");
            } else {
              selectedItem.NumberOfRespects--;
              respectIcon.removeClass("respected").addClass("respect");
            }
          }
        })
        .fail(function (data) {
          console.log("respect error - fail");
          //on frontend we automaticaly handle (un)respect, but if something fails on the server side we reverte changes
          selectedItem.HasRespected = !selectedItem.HasRespected;
          if (selectedItem.HasRespected) {
            selectedItem.NumberOfRespects++;
            respectIcon.removeClass("respect").addClass("respected");
          } else {
            selectedItem.NumberOfRespects--;
            respectIcon.removeClass("respected").addClass("respect");
          }
          console.log("un/respecting failed");
        });
    } else if (objekt.hasClass("onFollowClick")) {
      var setFollowingTo, isFollowing;
      //followers, klasa, followBtn

      /*
            if (selectedItem.IsCurrentUserFollowingThisOne === null || selectedItem.IsCurrentUserFollowingThisOne === undefined) {
                isFollowing = selectedItem.IsCurrentUserAlreadyFollowing;
            } else {
                isFollowing = selectedItem.IsCurrentUserFollowingThisOne;
            }
            */

      if (origin === "following") {
        isFollowing = selectedItem.IsCurrentUserAlreadyFollowing;
      } else {
        isFollowing = selectedItem.IsCurrentUserFollowingThisOne;
      }

      /*
            followers = !!objekt.hasClass("FS");
            // gornje zamjenjuje ovo -> followers = objekt.hasClass("FS") ? true : false;
            klasa = followers ? "FS" : "FG";
            followBtn = $("#followBtn" + selectedItem.Id + "." + klasa );
            */

      followersBtn = $("#followBtn" + selectedItem.Id + ".FS");
      followingBtn = $("#followBtn" + selectedItem.Id + ".FG");

      if (isFollowing) {
        route = {
          putanja: mad.common.variables.serverUrl + "api/follow/UnFollow",
          akcija: "POST"
        };
        setFollowingTo = false;
      } else {
        route = {
          putanja: mad.common.variables.serverUrl + "api/follow/Follow",
          akcija: "POST"
        };
        setFollowingTo = true;

        if (origin === "search") {
          sourceInfo = "People" + (tab === 0 ? " - Near you" : " -  Trending");
          data = {
            Source: sourceInfo
          };

          //analytics services where we send data, category of evenet (max is allways sent), event type (such as event, view, purchase), event name, any additional info, event categorz, event action
          mad.analyticEvents.track(
            [mad.analyticEvents.services.GA],
            mad.analyticEvents.categories.SOCIAL,
            mad.analyticEvents.types.EVENT,
            "Follow clicked",
            data,
            "Social",
            "Follow",
            "From " + sourceInfo
          );
        }

        if (origin === "following") {
          if (tab === 0) {
            sourceInfo = "Followers list";
          } else {
            sourceInfo = "Following list";
          }
          data = {
            Source: sourceInfo
          };

          //analytics services where we send data, category of evenet (max is allways sent), event type (such as event, view, purchase), event name, any additional info, event categorz, event action
          mad.analyticEvents.track(
            [mad.analyticEvents.services.GA],
            mad.analyticEvents.categories.SOCIAL,
            mad.analyticEvents.types.EVENT,
            "Follow clicked",
            data,
            "Social",
            "Follow",
            "From" + sourceInfo
          );
        }
      }

      options = {
        Id: userId
      };

      if (origin === "following") {
        selectedItem.IsCurrentUserAlreadyFollowing = setFollowingTo;
      } else {
        selectedItem.IsCurrentUserFollowingThisOne = setFollowingTo;
      }

      FEfollowingUpdate();

      mad.data.load(route, options, false, true).done(function (data) {
        if (data.Result) {
          // update mad.common.variables.userNoFollowing
          if (isFollowing) {
            if (
              mad.common.variables.userNoFollowing &&
              !isNaN(parseFloat(mad.common.variables.userNoFollowing)) &&
              isFinite(mad.common.variables.userNoFollowing) &&
              mad.common.variables.userNoFollowing > 0
            ) {
              mad.common.variables.userNoFollowing--;
            } else {
              mad.common.variables.userNoFollowing = 0;
            }
          } else {
            if (
              mad.common.variables.userNoFollowing &&
              !isNaN(parseFloat(mad.common.variables.userNoFollowing)) &&
              isFinite(mad.common.variables.userNoFollowing) &&
              mad.common.variables.userNoFollowing >= 0
            ) {
              mad.common.variables.userNoFollowing++;
            } else {
              mad.common.variables.userNoFollowing = 1;
            }
          }

          var promise = $.Deferred();
          mad.common.getUserInfo(promise, false); //to update global NumberOfFeedItemsInFeedFollowing
        } else {
          //on frontend we immediatelly updated (un)following, but if something fails on the server side we revert changes
          selectedItem.IsCurrentUserFollowingThisOne = !selectedItem.IsCurrentUserFollowingThisOne;
          FEfollowingUpdate();
          console.log("error update following", data);
        }
      });
    } else if (objekt.hasClass("goToBlog")) {
      window.open("https://madbarz.com/blog/" + selectedItem.Link, "_blank");
    } else if (objekt.hasClass("goToSale")) {
      window.open("https://madbarz.com/" + selectedItem.Link, "_blank");
    }
  }

  function updateRespectTxt(prefix, data) {
    var domElement = $("#respectTxt" + prefix + data.WorkoutId);

    // var mnozina = (data.NumberOfRespects != 1) ? "s" : "";
    //var izlazR = data.NumberOfRespects.toString() + " respect" + mnozina;
    var izlazR = data.NumberOfRespects.toString();

    //mnozina = (data.NumberOfComments != 1) ? "s" : "";
    // var izlazC = data.NumberOfComments.toString() + " comment" + mnozina;
    var izlazC = data.NumberOfComments.toString();

    domElement.find(".respect-txt").html(izlazR);
    domElement.find(".comments-wrapper").html(izlazC);
  }

  function getQueryVariable(qs, variable) {
    var vars = qs.split("&");
    var varsL = vars.length;
    for (var i = 0; i < varsL; i++) {
      var pair = vars[i].split("=");
      if (pair[0] == variable) {
        return pair[1];
      }
    }
  }

  function getXcharacters(baseWidth, numOfCharacters) {
    return Math.round(window.innerWidth * (numOfCharacters / baseWidth));
  }

  function isNullOrEmpty(value) {
    if (typeof value === "undefined" || value === null) {
      return true;
    }
    if (_.isArray(value) || _.isObject(value)) {
      return _.isEmpty(value);
    } else {
      if (value === "") {
        return true;
      } else {
        return false;
      }
    }
  }

  function hasOne(provjeri, pretrazi) {
    /**
     * @description determine if an array contains one or more items from another array.
     * @param {array} provjeri - the array to search.
     * @param {array} pretrazi - the array providing items to check for in the provjeri.
     * @return {boolean} true|false if provjeri contains at least one item from pretrazi.
     */
    return pretrazi.some(function (v) {
      return provjeri.indexOf(v) >= 0;
    });
  }

  var isFunction = function (fn) {
    return typeof fn === "function";
  };

  function formatedTime(time) {
    //time += (59 * 60 + 44);
    var hours = Math.floor(time / 60 / 60);
    var minutes = Math.floor(time / 60) % 60;
    var seconds = Math.round(((time / 60) % 1) * 60);

    hours = hours == 0 ? "" : hours + ":";
    minutes = minutes < 10 ? "0" + minutes + ":" : minutes + ":";
    seconds = seconds < 10 ? "0" + seconds : seconds;
    return hours + minutes + seconds;
  }

  function formatedDate(d) {
    // d is valid string date
    var datum = new Date(d);
    return (
      mad.glossary.other.months[mad.common.observables.languageIndex()][
      datum.getMonth()
      ] +
      " " +
      datum.getDate() +
      ", " +
      datum.getFullYear() +
      "."
    );
  }

  function formatTimeForDisplayingTimedExercises(time) {
    var hours = Math.floor(time / 60 / 60);
    var minutes = Math.floor(time / 60) % 60;
    var seconds = Math.round(((time / 60) % 1) * 60);
    seconds = seconds < 10 ? "0" + seconds : seconds;

    if (hours > 0) {
      minutes = minutes < 10 ? "0" + minutes : minutes;
      return hours + ":" + minutes + ":" + seconds + " h";
    }

    if (minutes > 0) {
      return minutes + ":" + seconds + " min";
    }

    return "0:" + seconds + " sec";
  }

  // ifOnline
  function getNetworkStatus() {
    //između ostalog poziva i ifOnline
    if (
      navigator.connection.type != Connection.UNKNOWN &&
      navigator.connection.type != Connection.NONE
    ) {
      //console.log("ifOnline", true);
      return true;
    } else {
      //console.log("ifOnline", false);
      return false;
    }
  }

  function ifOffline() {
    if (navigator.connection.type == Connection.NONE) {
      //console.log("ifOffline", true);
      return true;
    } else {
      //console.log("ifOffline", false);
      return false;
    }
  }

  function getStatusColor() {
    var online = "rgba(0,255,0, 0)",
      offline = "rgba(255,48,0,1)";

    var returnColor =
      mad.common.observables.get("networkStatus") == "online"
        ? online
        : offline;
    return returnColor;
  }

  function showSyncing() {
    var online = "#00ee00",
      offline = "rgb(79,79,79)";

    var returnColor =
      mad.common.observables.get("networkStatus") == "online" &&
        mad.common.observables.get("syncing")
        ? online
        : offline;
    return returnColor;
  }

  function getLeftButton() {
    /* koristi se za <span data-bind="buttonContent: common.leftButton">left</span>
        -- taj nacin moguc je jedino ako je definiran u layoutu
        jer se  mad.common.actualViewID (koji se koristi dalje u getButtonContent)
        postavlja kod show view, sto znaci da je tako definirano u normalnom HTMLu unutar view
        binding bi pucao jer se desava i prije inita
         */
    var button = "left";
    return getButtonContent(button, 1); // regular buttons
  }

  function getLeftButton2() {
    //        console.log("getLeftButton2");
    var button = "left";
    return getButtonContent(button, 2); // alternative buttons
  }

  function getRightButton() {
    var button = "right";
    return getButtonContent(button, 1); // regular buttons
  }

  function getRightButton2() {
    var button = "right";
    return getButtonContent(button, 2); // alternative buttons
  }

  function getButtonContent(button, regAlternative) {
    var komentari,
      komentariLoaded,
      tmpBrojKomentara = 0;
    var view = mad.common.actualViewID,
      actualViewModel = mad.common.actualView.model,
      languageNdx = mad.common.observables.languageIndex(),
      language = languages.short[languageNdx],
      appendToButton = regAlternative == 1 ? "" : "2",
      whichButtons = "buttons" + appendToButton,
      gumbi = mad.glossary.ui[view].header[whichButtons],
      gumb = "?",
      buttonIndex = "left" == button ? 0 : 1,
      expectedLength = buttonIndex + 1,
      leftRightVisible =
        "left" == button
          ? "isButtonVisibleL" + appendToButton
          : "isButtonVisibleR" + appendToButton,
      leftRightIs =
        "left" == button
          ? "leftButtonIs" + appendToButton
          : "rightButtonIs" + appendToButton;

    // if isButtonVisibleL/isButtonVisibleR is false or undefined - exit
    if (!_.get(actualViewModel, leftRightVisible)) return null;

    if (isNullOrEmpty(gumbi) || gumbi.length < expectedLength) {
      console.log("!!! nije definiran " + button + " gumb za view " + view);
      return null;
    } else {
      gumb = gumbi[buttonIndex][languageNdx];

      // drazen - ovo je tvik za workout details (desni gumb bez komentara)
      if (mad.common.actualViewID == "workoutDetails") {
        if (leftRightIs == "rightButtonIs") {
          komentari = actualViewModel.selectedWorkout.get("Comments");
          komentariLoaded = actualViewModel.selectedWorkout.get(
            "CommentsLoaded"
          );
          if (!komentariLoaded) {
            $(mad.common.$actualViewID + " .rButton")
              .addClass("loadingComments")
              .removeClass("hasComments")
              .removeClass("noComments");
          } else {
            if (komentari) {
              tmpBrojKomentara = komentari.length;
              if (tmpBrojKomentara == 0) {
                //gumb = "<img src='images/icons/Ncomment-unread.svg' />"
                $(mad.common.$actualViewID + " .rButton")
                  .addClass("noComments")
                  .removeClass("hasComments")
                  .removeClass("loadingComments");
              } else {
                $(mad.common.$actualViewID + " .rButton")
                  .addClass("hasComments")
                  .removeClass("noComments")
                  .removeClass("loadingComments");
              }
            }
          }
        }
      }

      if ($.isArray(gumb)) {
        //if we have array of buttons for some language we need to declare leftButtonIs/rightButtonIs
        if (isNullOrEmpty(_.get(actualViewModel, leftRightIs))) {
          console.log(
            "!!! nije definirana varijabla " +
            leftRightIs +
            " u view modelu za " +
            view
          );
          return null;
        } else {
          //console.log("kreiram on/off " + button.toUpperCase() + appendToButton + " gumb za " + view + " view, jezik je " + language + " a status gumba je " + actualViewModel.get(leftRightIs));
          gumb = gumb[actualViewModel.get(leftRightIs)];
        }
      } else {
        //console.log("kreiram obican " + button.toUpperCase() + appendToButton + " gumb za " + view + " view, jezik je " + language);
      }
    }
    return gumb;
  }

  function getFooterBtnTxt(v) {
    // v has to be number or nothing
    // call eg.
    // data-bind="buttonContent: common.getButtonTxt"
    // data-bind="buttonContent: common.getButtonTxt(2)"
    var btnNdx = 0;
    if (typeof v == "undefined" || !$.isNumeric(v)) {
      //console.log("footer parametar nije naveden ili nije ok broj, v parm je", v);
    } else {
      //console.log("button", v);
      btnNdx = v;
    }

    var view = mad.common.actualViewID;
    var language = mad.common.observables.languageIndex();
    var gumb = mad.glossary.ui[view].footer.button;
    if (gumb) {
      return gumb[btnNdx][language];
    }
  }

  function toggleButton(button) {
    var actualViewModel = mad.common.actualView.model,
      leftRightIs = "left" == button ? "leftButtonIs" : "rightButtonIs";

    if (!isNullOrEmpty(_.get(actualViewModel, leftRightIs))) {
      var oldVal = _.get(actualViewModel, leftRightIs),
        newVal = Math.abs(oldVal - 1);
      _.set(actualViewModel, leftRightIs, newVal);

      //getButtonContent(button);
      /* drazen - todo / sada refresh gumba radi tako da se rebinda cijeli view,
             rijesiti to tako da se refresha samo button
             */
      kendo.bind($(mad.common.$actualViewID), actualViewModel);
    }
  }

  function setLangObj() {
    var classedObj = {};
    var l = languages.name.length;
    for (var i = 0; i < l; i++) {
      _.set(
        classedObj,
        languages.short[i],
        languages.short[i] == mad.common.observables.get("selectedLanguage")
          ? true
          : false
      );
    }
    return classedObj;
  }

  function setLangForView() {
    var selView = d3.select(mad.common.$actualViewID);

    if (!selView.classed(mad.common.observables.get("selectedLanguage"))) {
      var languageClasses = setLangObj();
      selView.classed(languageClasses);
      /* set for all classes
            var allClasses = selView.selectAll("[class]");
            allClasses.classed(languageClasses);
            */
    }
  }

  function checkSyncFinished(e) {
    console.log("checking if all syncing finished");

    var pS = mad.local.loadVariable("pendingSync");
    var sT = mad.common.observables.get("syncingTrenings");
    var sU = mad.common.observables.get("syncingUpdates");
    if (pS && !sT && !sU) {
      //if pending syncing & nothing is syncing any more
      //console.log("checksync - everything is done");
      mad.local.saveVariable("pendingSync", false);
      mad.common.observables.unbind("checkSync", mad.common.checkSyncFinished);
      mad.alerts.success(mad.common.translate("messages", "syncingF"));
    } else {
      //console.log("checksync - workouts, updates", sT, sU);
    }
  }
  /*
      moze se koristiti mobileWidget.trigger("customEvent", { eventData:'ovo je trigerirani event!' }); i
    //read event specific data if it exists
       if(e.eventData !== undefined){
              output('customEvent fired with data: '
                + e.eventData);
        }
    */
  function countdownTimer(start, stop, tickCallback) {
    var timerID,
      value,
      running = false,
      kf = stop > start ? 1 : -1; // -1 for substracting

    // ako odbrojavanje pocinje nakon 1 sec (znaci nema tickCallback(value); prije setInterval)
    // var startValue = start - (1 * kf);      // increase/decrease start value for 1

    var startValue = start;

    this.start = function () {
      if (running) return;
      running = true;

      var that = this;

      value = startValue;

      that.parent().trigger("started"); //trigger event in caller

      tickCallback(value); // odbrojavanje pocinje odmah a ne nakon 1 sec.

      timerID = setInterval(function () {
        value = value + 1 * kf;
        tickCallback(value);
        if (value === stop) {
          clearInterval(timerID);
          running = false;
          that.parent().trigger("finished");
        }
      }, 1000);
    };

    this.stop = function () {
      clearInterval(timerID);
      running = false;
    };
    this.isRunning = function () {
      return running;
    };
    this.reset = function () {
      value = start;
    };
    this.value = function (v) {
      if (!arguments.length) return value;
      value = v;
      //console.log("pause counter value set to", v)
    };
    this.setStart = function (start) {
      startValue = start;
    };
    this.resume = function (resumeTime) {
      if (running) return;
      running = true;

      var that = this;

      value = resumeTime;

      //that.parent().trigger("resumed");   //trigger event in caller (drazen-pazi / pause i resume ne rade s resumed!

      if (value === stop) {
        clearInterval(timerID);
        running = false;
        that.parent().trigger("finished");
      } else {
        tickCallback(value); // odbrojavanje pocinje odmah a ne nakon 1 sec.

        timerID = setInterval(function () {
          value = value + 1 * kf;
          tickCallback(value);
          if (value === stop) {
            clearInterval(timerID);
            running = false;
            that.parent().trigger("finished");
          }
        }, 1000);
      }
    };
  }

  function simpleTimer(tickCallback) {
    var timerID,
      value,
      running = false;

    this.start = function () {
      if (running) return;
      running = true;

      value = 0;

      tickCallback(value); // odbrojavanje pocinje odmah a ne nakon 1 sec.

      timerID = setInterval(function () {
        value = value + 1;

        //                console.log("timer",timerID, value, tickCallback);

        tickCallback(value);
      }, 1000);
    };

    this.stop = function () {
      clearInterval(timerID);
      running = false;
    };
    this.isRunning = function () {
      return running;
    };
    this.reset = function () {
      value = 0;
      tickCallback(value);
    };
    this.value = function () {
      return value;
    };
    this.resume = function (resumeTime) {
      if (running) return;
      running = true;

      value = resumeTime;

      tickCallback(value); // odbrojavanje pocinje odmah a ne nakon 1 sec.

      timerID = setInterval(function () {
        value = value + 1;

        // console.log("ponovni timer",timerID, value, tickCallback);

        tickCallback(value);
      }, 1000);
    };
  }

  function audioOnSuccess(s) {
    //console.log("audio success:", s);
  }

  function audioOnError(s) {
    console.log("audio error: ", s);
  }

  function audioOnComplete(s) {
    //console.log('audio complete: ', s);
  }

  function handleInsomnia() {
    if (mad.viewModels.settings.getSleepStatus()) {
      turnInsomniaON();
    } else {
      turnInsomniaOFF();
    }
  }

  function turnInsomniaON() {
    console.log("insomniaON");
    if (canRunInsomnia()) {
      //win.plugins.insomnia.keepAwake(insomniaON());
      window.plugins.insomnia.keepAwake();
    }
  }

  function turnInsomniaOFF() {
    console.log("insomniaOFF");
    if (canRunInsomnia()) {
      //win.plugins.insomnia.allowSleepAgain(insomniaOFF());
      window.plugins.insomnia.allowSleepAgain();
    }
  }

  function canRunInsomnia() {
    if (window.navigator.simulator === true) {
      //mad.alerts.error("no Insomnia in the simulator","");
      return false;
    } else if (window.plugins.insomnia === undefined) {
      toastr.options.timeOut = 6666;
      toastr.warning(
        "Insomnia not found. Maybe you are running in AppBuilder</br>Companion app which currently does not support this plugin.",
        "",
        toastr.options
      );
      toastr.options.timeOut = 4444;
      return false;
    } else {
      return true;
    }
  }

  function prepareCountries() {
    var that = this;
    //prepare countries for mobiscroll
    var drzave = that.variables.countries;
    mad.models.Countries.read().then(function () {
      var ucitaniPodaci = mad.models.Countries.data();
      _.forEach(ucitaniPodaci, function (obj, n) {
        var tmpObj = {};
        tmpObj.letter = obj.Country.charAt(0);
        tmpObj.value = obj.Country;
        tmpObj.text =
          "<img src='../images/flags/" + obj.code + ".png' /> " + obj.Country;
        drzave.push(tmpObj);
      });
    });
  }

  function prepareStates() {
    var that = this;
    //prepare states for mobiscroll
    var states = that.variables.USAstates;
    mad.models.States.read().then(function () {
      var ucitaniPodaci = mad.models.States.data();
      _.forEach(ucitaniPodaci, function (obj, n) {
        var tmpObj = {};
        tmpObj.abbreviation = obj.abbreviation;
        tmpObj.letter = obj.name.charAt(0);
        tmpObj.value = obj.name;
        states.push(tmpObj);
      });
    });
  }

  /* helper za procesiranje templejta u glossariju
        koristi se kao parametar u JSON.stringify
        sadrzaj mora imati template=
    */

  function replacer(key, value) {
    if (typeof value === "string") {
      if (value.indexOf("template") == 0) {
        var parts = value.split("=");
        var tpl = parts[1]; //nema kontrola - pretpostavlja se da postoji (todo)
        var template = kendo.template($("#" + tpl).html());
        return template({});
      } else {
        return value;
      }
    } else {
      return value;
    }
  }

  // Global confirm dialog
  function showConfirm(message, title, callback) {
    navigator.notification.confirm(message, callback || function () { }, title, [
      "OK",
      "Cancel"
    ]);
  }

  function areYouSure(YEScallback) {
    var msg = mad.glossary.messages.sure,
      language = mad.common.observables.languageIndex();

    navigator.notification.confirm(
      msg.message[language],
      function (button) {
        if (button == 1) {
          // if yes execute callback function
          YEScallback();
        }
      },
      msg.title[language],
      [msg.button1[language], msg.button2[language]]
    );
  }

  // returns only object own properties
  function objectCopy(obj) {
    _.each(_.slice.call(arguments, 1), function (source) {
      for (var prop in source) {
        if (Object.prototype.hasOwnProperty.call(source, prop)) {
          obj[prop] = source[prop];
        }
      }
    });
    return obj;
  }

  function getCurrentFunctionName(func) {
    // Match:
    // - ^          the beginning of the string
    // - function   the word 'function'
    // - \s+        at least some white space
    // - ([\w\$]+)  capture one or more valid JavaScript identifier characters
    // - \s*        optionally followed by white space (in theory there won't be any here,
    //              so if performance is an issue this can be omitted[1]
    // - \(         followed by an opening brace
    //
    var result = /^function\s+([\w\$]+)\s*\(/.exec(func.toString());

    return result ? result[1] : ""; // for an anonymous function there won't be a match
  }
  // helper string that turns bytes to Base64 encoded strings, used for caching images
  function arrayBufferToBase64(buffer) {
    var binary = "";
    var bytes = new Uint8Array(buffer);
    var len = bytes.byteLength;
    for (var i = 0; i < len; i++) {
      binary += String.fromCharCode(bytes[i]);
    }
    return window.btoa(binary);
  }

  function cacheImage(id, url) {
    /*
         this method caches an image, we pull the image from the remote server
         and store it to the array as a base64 string under id
        */

    var xhr = new XMLHttpRequest();
    xhr.open("GET", url, true);
    xhr.responseType = "arraybuffer";

    xhr.onload = function (e) {
      console.log("loaded", this);

      if (this.status == 200) {
        var string_with_bas64_image = arrayBufferToBase64(this.response);
        mad.local.saveVariableParse(id, string_with_bas64_image);
      }
    };
    /*
        xhr.onreadystatechange = function () {
            console.log(xhr.readyState, xhr.status, xhr);
            console.log("headeri", xhr.getAllResponseHeaders());
        };
        */

    xhr.send(null);
  }

  function getCachedImage(id) {
    var image = mad.local.loadVariableParse(id);
    if (isNullOrEmpty(image)) {
      return "";
    } else {
      return "data:image/png;base64," + image;
    }
  }

  function saveBase64ImagePromise(promise, id, url) {
    /* this method caches an image, we pull the image from the remote server and store it to the array as a base64 string under id  */

    var xhr = new XMLHttpRequest();
    xhr.open("GET", url, true);
    xhr.responseType = "arraybuffer";

    xhr.onload = function (e) {
      if (this.status == 200) {
        var string_with_bas64_image = arrayBufferToBase64(this.response);
        mad.local.saveVariableParse(id, string_with_bas64_image);
        promise.resolve(true);
      } else {
        promise.resolve(false);
      }
    };

    xhr.onerror = function () {
      promise.resolve(false);
    };

    xhr.onabort = function () {
      promise.resolve(false);
    };

    xhr.ontimeout = function () {
      promise.resolve(false);
    };

    xhr.send(null);
  }

  function imageToBase64(promise, url) {
    /* we pull the image from the remote server and return it as a base64 string  */

    var string_with_bas64_image;

    var xhr = new XMLHttpRequest();
    xhr.open("GET", url, true);
    xhr.responseType = "arraybuffer";

    xhr.onload = function (e) {
      if (this.status == 200) {
        string_with_bas64_image =
          "data:image/jpeg;base64," + arrayBufferToBase64(this.response);
        promise.resolve(string_with_bas64_image);
      } else {
        promise.reject();
      }
    };

    xhr.onerror = function () {
      promise.reject();
    };

    xhr.onabort = function () {
      promise.reject();
    };

    xhr.ontimeout = function () {
      promise.reject();
    };

    xhr.send(null);
  }

  function onTap(e) {
    //console.log("tap", e.touch.target);
  }

  function removeTouchEventsFromList(lista, reset) {
    var scroller = lista._scrollerInstance;
    var touches = scroller.userEvents.touches;
    var dummyEvent = { event: { preventDefault: $.noop } };
    for (var i = 0; i < touches.length; i++) {
      console.log("touch event to clear", touches[i]);
      touches[i].end(dummyEvent);
    }
    if (reset) {
      scroller.reset();
    }
  }

  // --- notifikacije
  function PushNotificationSemaphore(initLock) {
    if (initLock) this.locked = true;
    else this.locked = false;
  }

  PushNotificationSemaphore.prototype.lock = function () {
    this.locked = true;
  };

  PushNotificationSemaphore.prototype.unlock = function () {
    this.locked = false;
    if (this.func) {
      var f = this.func;
      this.func = null;
      f();
    }
  };

  PushNotificationSemaphore.prototype.run = function (runFunc) {
    var self = this;
    self.func = runFunc;
    if (!self.locked) {
      var f = self.func;
      self.func = null;
      f();
    }
  };

  // todo: dodati clear metodu (mislav)

  PushNotificationSemaphore.prototype.isPending = function () {
    return this.locked && this.func;
  };

  var pushNotificationSemaphore = new PushNotificationSemaphore(true);

  function processPushNotification(notification, withNavigation) {
    var notificationId = notification.id;
    var notificationType = notification.type;
    var unreadNotificationsCount = notification.unreadCount;
    var workoutId = notification.link;
    var userId = notification.fromUserId;

    // Prepare for navigation
    var originQS = "origin=/ui/profile/notifications/notifications.html";
    var userIdQS = "&UserId=" + userId;
    var userNameQS = "&UserName=" + userId; // HACK: In order to the navigation to a profile work, there should be included the UserName query string which is not used in the profile view.
    var workoutIdQS = "&WorkoutId=" + workoutId;
    var tabQS = null;
    var commonQS = null;

    var markReadPromise = null;

    // If the navigation is requested and the user is logged in.
    // HACK: Here the check is made if any user is logged in, but should be logged in the user who received the notification!
    if (withNavigation && mad.loginToken !== "") {
      switch (notificationType) {
        case "TreningRespect":
          //console.log("onPushNotification", "Navigating to the workout (ID:" + workoutId + ") on TreningRespect");
          tabQS = "&tab=0";
          commonQS = originQS + tabQS + userIdQS;
          mad.mobileApp.navigate(
            "ui/workoutDetails/workoutDetails.html?" + commonQS + workoutIdQS
          );
          break;
        case "TreningComment":
          //console.log("onPushNotification", "Navigating to the workout (ID:" + workoutId + ") on TreningComment");
          tabQS = "&tab=1";
          commonQS = originQS + tabQS + userIdQS;
          mad.mobileApp.navigate(
            "ui/workoutDetails/workoutDetails.html?" + commonQS + workoutIdQS
          );
          break;
        case "TreningSave":
          //console.log("onPushNotification", "Navigating to the workout (ID:" + workoutId + ") on TreningSave");
          tabQS = "&tab=0";
          commonQS = originQS + tabQS + userIdQS;
          mad.mobileApp.navigate(
            "ui/workoutDetails/workoutDetails.html?" + commonQS + workoutIdQS
          );
          break;
        case "StatusComment":
        case "FeedStatusRespect":
        case "BattleCompare":
          break;
        case "Follows":
        case "NewFbFriend":
          //console.log("onPushNotification", "Navigating to the user profile (ID:" + userId + ") on Follows");
          tabQS = "&tab=0";
          commonQS = originQS + tabQS + userNameQS + userIdQS;
          mad.mobileApp.navigate(
            "ui/profileOtherUser/profileOtherUser.html?" + commonQS
          );
          break;
        case "Trending":
          mad.mobileApp.navigate("ui/search/search.html");
          break;
      }

      // Mark the notification as read!
      markReadPromise = mad.data.load(
        {
          putanja:
            mad.common.variables.serverUrl +
            "api/Notifications/MarkNotificationAsRead",
          akcija: "POST"
        },
        {
          id: notificationId
        },
        false,
        true
      );
    }

    // In all cases, update the number of unread notifications (badge and in-app indicator)
    $.when(markReadPromise).done(mad.common.loadUnreadNotif);
  }

  function pushTokenHandler(result) {
    //console.log("pushTokenHandler", JSON.stringify(result));
    // Your iOS push server needs to know the token before it can push to this device
    // here is where you might want to send it the token for later use.
    mad.installation.register(result);
  }

  function pushSuccessHandler(result) {
    //console.log("pushSuccessHandler", JSON.stringify(result));
    //updateLog("successHandler", result);
  }

  function pushErrorHandler(result) {
    console.log("pushErrorHandler", JSON.stringify(result));
  }

  function onPushNotification(e) {
    switch (e.event) {
      case "registered":
        if (e.regid.length > 0) {
          console.log(
            "onPushNotification",
            "Registered with the push notification service",
            JSON.stringify(e)
          );
          // Register the app installation with the back-end
          mad.installation.register(e.regid);
        }
        break;
      case "message":
        var notification = e.payload.notification;
        var markReadPromise = null;

        // If the app is launched from the background or is cold start and also the user didn't left the app in the middle of exercise, navigate the user.
        pushNotificationSemaphore.run(function () {
          processPushNotification(
            notification,
            !e.foreground && mad.common.actualViewId !== "madbarzExercising"
          );
        });

        // Log the event
        if (e.foreground) {
          console.log(
            "onPushNotification",
            "Message received while the app was in the foreground"
          );
          // Do something with the push notification received when the app is in the foreground.
        } else if (e.coldstart) {
          console.log(
            "onPushNotification",
            "Message received, the app coldstarted via the notification tray"
          );
          // Do something with the push notification received when the app was lounched and coldstarted through the notification tray
        } else {
          console.log(
            "onPushNotification",
            "Message received when the app was in the background, the app launched via the notification tray"
          );
          // Do something with the push notification received when the app was in the background and was launched througs the notification tray
        }
        break;
      case "error":
        console.log("onPushNotification", "Error", e.msg);
        break;
      default:
        console.log("onPushNotification", "Unknown event", JSON.stringify(e));
        break;
    }
  }

  function onPushNotificationApn(e) {
    // console.log("onPushNotificationApn", JSON.stringify(e));

    var notification = {
      id: e.id,
      type: e.type,
      unreadCount: e.badge,
      link: e.link,
      fromUserId: e.fromUserId
    };

    // If the app is launched from the background or is cold start and also the user didn't left the app in the middle of exercise, navigate the user.
    pushNotificationSemaphore.run(function () {
      processPushNotification(
        notification,
        e.foreground == 0 && mad.common.actualViewId !== "madbarzExercising"
      );
    });

    if (e.alert) {
      console.log("onPushNotificationApn", "alert");
      // Show alert notification
    }
    if (e.sound) {
      console.log("onPushNotificationApn", "sound");
      // Play a sound notification
    }
    if (e.badge) {
      console.log("onPushNotificationApn", "badge");
      // Change the badge icon on the push notification
    }
  }

  function setBadge(count) {
    if (
      !window.navigator.simulator &&
      window.plugins.pushNotification &&
      window.plugins.pushNotification.setApplicationIconBadgeNumber
    ) {
      window.plugins.pushNotification.setApplicationIconBadgeNumber(
        function () {
          //console.log("setApplicationIconBadgeNumber", "success");
        },
        function () {
          console.log("setApplicationIconBadgeNumber", "error");
        },
        count
      );
    }
  }

  function clearBadge() {
    setBadge(0);
  }

  function randomBetween(min, max) {
    return Math.floor(Math.random() * (max - min + 1) + min);
  }

  function getQuote() {
    var lastQuote = mad.local.loadVariableParse("lastQuote"),
      newQuote = {},
      numberOfQuotes = mad.models.quotes.data().length,
      quoteDate,
      quoteIndex,
      danas = new Date().toDateString();

    //console.log("citati u getQuote", mad.models.quotes.data().length);

    if (
      !mad.common.isNullOrEmpty(lastQuote) &&
      !mad.common.isNullOrEmpty(mad.common.variables.todaysQuote)
    ) {
      quoteDate = lastQuote.quoteDate;
      quoteIndex = lastQuote.quoteIndex;
      if (quoteDate == danas) {
        return mad.common.variables.todaysQuote;
      } else {
        return createQuote(); // new quote of the day
      }
    } else {
      return createQuote();
    }

    function createQuote() {
      quoteDate = danas;
      quoteIndex = randomBetween(0, numberOfQuotes - 1);
      newQuote.quoteDate = quoteDate;
      newQuote.quoteIndex = quoteIndex;
      mad.local.saveVariableParse("lastQuote", newQuote);
      mad.common.variables.todaysQuote = mad.models.quotes.data()[quoteIndex];
      return mad.common.variables.todaysQuote;
    }
  }
  function showMore(e) {
    //var currentEl = e.touch.currentTarget;
    var currentEl = e.touch.target; // drazen - zbog novog kenda
    var parentEl = $(currentEl).parent();
    $(parentEl).toggleClass("full-text");
    $(currentEl).toggleClass("show-more show-less");
    if ($(currentEl).hasClass("show-more")) {
      $(currentEl)
        .find(".more")
        .show();
      $(currentEl)
        .find(".less")
        .hide();
    } else {
      $(currentEl)
        .find(".less")
        .show();
      $(currentEl)
        .find(".more")
        .hide();
    }
  }

  function shortenDescription() {
    var desc, DOMelement, klasa, actualHeight, visibleHeight;
    desc = $(mad.common.$actualViewID).find(".shorten");

    if (desc.length > 0) {
      DOMelement = desc[0];
      klasa = desc.attr("data-class");
      desc.addClass(klasa);
      actualHeight = DOMelement.scrollHeight;
      visibleHeight = DOMelement.clientHeight;
      /*
             console.log(actualHeight);
             console.log(visibleHeight);
            */
      if (actualHeight - 2 > visibleHeight) {
        console.log("show --- show more");
        //desc.toggleClass("place-for-show-more");
        desc.addClass("place-for-show-more");
        desc.find(".show-more").show();
        desc.find(".less").hide();
        //desc.toggleClass("full-text");
      }
    }
  }

  function toTitleCase(str) {
    return str.replace(/\w\S*/g, function (txt) {
      return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
    });
  }

  function initRouter() {
    router = new kendo.Router();
    router.bind("change", function (e) {
      var link = e.url;
      console.log("****** router **  view changed to", link);

      var actualView = mad.mobileApp.view() || "";
      if (actualView != "") {
        $("#profile-user-img img").removeClass("biggerPhoto");
        $("#workoutsMenu .image").removeClass("biggerPhoto");

        actualView.one("transitionStart", function (e) {
          if (e.type !== "hide") {
            $(e.sender.element).removeClass("viewSkriven");
          }
        });
        actualView.one("hide", function (e) {
          $(e.sender.element).addClass("viewSkriven");
        });
        actualView.one("beforeShow", function (e) {
          $(e.sender.element).removeClass("viewSkriven");
        });
        /*
                actualView.one("transitionEnd", function (e) {
                    //console.log("** router ** transitionEnd", e.sender.id, "transition", e.sender.transition);
                });
                actualView.one("show", function (e) {
                    //console.log("** router ** show", e.sender.id, "transition", e.sender.transition);
                });
                actualView.one("afterShow", function (e) {
                    //console.log("** router ** afterShow", e.sender.id, "transition", e.sender.transition);
                });
                actualView.one("beforeHide", function (e) {
                    //console.log("** router ** beforeHide", e.sender.id, "transition", e.sender.transition);
                });
                */
      } else {
        //console.log("** router ** error: no view");
      }
    });

    router.bind("back", function (e) {
      console.log("****** router BACK **  from", e.url, "to", e.to);
      $("#profile-user-img img").removeClass("biggerPhoto");
      $("#workoutsMenu .image").removeClass("biggerPhoto");
    });

    router.start();
    console.log("router initialized");
  }

  function checkViews() {
    console.log(" -- checkViews ");

    var transitionOK = true;

    var prev$ = $("#" + mad.common.previousViewID);
    var actual$ = $("#" + mad.common.actualViewID);

    var actualView = mad.mobileApp.view() || "",
      viewId = "";
    if (actualView != "") {
      viewId = actualView.wrapper.attr("id");
    }
    if (mad.common.actualViewID != viewId) {
      console.log(
        "mad.common.actualViewID razlicit od stvarno trenutnog",
        viewId
      );
    }

    if (mad.common.previousViewID != "") {
      console.log(
        " -- checkViews from",
        mad.common.previousViewID,
        "to",
        mad.common.actualViewID
      );
      //console.log(" -- klase", prev$[0].classList);

      if (prev$.hasClass("k-fx-current")) {
        // ako tranzicija prethodnog viewa nije OK zavrsila imat ce k-fx-current

        transitionOK = false;

        console.log("");
        console.log("                 DOSLO JE DO PREKLAPANJA  !!!");
        console.log(" -- checkViews   prev ima k-fx-current");

        prev$.removeClass("k-fx-current");
        actual$.removeClass("k-fx-next");

        setTimeout(function () {
          prev$.css("display", "none");
        }, 222); // 200ms je transition time između viewova
      }

      if (prev$.hasClass("k-fx-next")) {
        transitionOK = false;
        console.log(" -- checkViews prev ima k-fx-next");
      }
      if (actual$.hasClass("k-fx-next")) {
        transitionOK = false;
        console.log(" -- checkViews actual ima k-fx-next");
      }
      if (actual$.hasClass("k-fx-current")) {
        transitionOK = false;
        console.log(" -- checkViews actual ima k-fx-current");
      }
    }

    return transitionOK;
  }

  function disableLogging() {
    //inspired by this SO post: https://stackoverflow.com/questions/13815640/a-proper-wrapper-for-console-log-with-correct-line-number
    if (env === "PROD") {
      console.log = function () { };
    }
  }

  return {
    observables: observableVariablesAndFunctions,
    variables: commonVariables,
    events: commonEvents,
    previousViewID: "",
    actualViewID: "",
    getVersion: getVersion,
    checkVersion: checkVersion,
    getUserInfo: getUserInfo,
    setActualView: setActualView,
    stretchView: stretchView,
    stretchViewContentToBeElastic: stretchViewContentToBeElastic,
    stretchViewContentToBeElasticWOhead: stretchViewContentToBeElasticWOhead,
    setViewBackground: setViewBackground,
    setActualViewTitle: setActualViewTitle,
    scrollViewToTop: scrollViewToTop,
    getRightButton: getRightButton,
    translate: translate,
    appendSlideLine: appendSlideLine,
    handleTabSwipe: handleTabSwipe,
    handleTabSliding: handleTabSliding,
    toggleButton: toggleButton,
    selectMenuTab: selectMenuTab,
    isImage: isImage,
    hasClass: hasClass,
    preloadImage: preloadImage,
    showImage: showImage,
    getLocalImage: getLocalImage,
    showUserImage: showUserImage,
    handleFeedTap: handleFeedTap,
    updateRespectTxt: updateRespectTxt,
    getXcharacters: getXcharacters,
    isNullOrEmpty: isNullOrEmpty,
    hasOne: hasOne,
    isFunction: isFunction,
    formatedTime: formatedTime,
    formatedDate: formatedDate,
    checkSyncFinished: checkSyncFinished,
    titlePressed: titlePressed,
    scaleMuscleMan: scaleMuscleMan,
    scaleMuscleMan2: scaleMuscleMan2,
    getToken: getToken,
    showLoader: showLoader,
    showLoaderNoCancel: showLoaderNoCancel,
    showBusyLoader: showBusyLoader,
    hideLoader: hideLoader,
    hideLoaderNoCancel: hideLoaderNoCancel,
    setLangForView: setLangForView,
    countdownTimer: countdownTimer,
    simpleTimer: simpleTimer,
    getQueryVariable: getQueryVariable,
    audioOnSuccess: audioOnSuccess,
    audioOnError: audioOnError,
    audioOnComplete: audioOnComplete,
    handleInsomnia: handleInsomnia,
    turnInsomniaON: turnInsomniaON,
    turnInsomniaOFF: turnInsomniaOFF,
    prepareCountries: prepareCountries,
    prepareStates: prepareStates,
    addViewToHistory: addViewToHistory,
    removeLastFromHistory: removeLastFromHistory,
    deleteHistory: deleteHistory,
    serverCheck: serverCheck,
    userRegistration: userRegistration,
    getFBToken: getFBToken,
    getFBInfo: getFBInfo,
    animate: animate,
    deAnimate: deAnimate,
    fadeIn: fadeIn,
    fadeOut: fadeOut,
    goBack: goBack,
    cacheImage: cacheImage,
    getCachedImage: getCachedImage,
    saveBase64ImagePromise: saveBase64ImagePromise,
    imageToBase64: imageToBase64,
    onTap: onTap,
    replacer: replacer,
    loadUnreadNotif: loadUnreadNotif,
    startCheckingNotif: startCheckingNotif,
    updateNotificationBadge: updateNotificationBadge,
    setResolutionForView: setResolutionForView,
    checkTutorial: checkTutorial,
    pushSuccessHandler: pushSuccessHandler,
    pushTokenHandler: pushTokenHandler,
    pushErrorHandler: pushErrorHandler,
    onPushNotification: onPushNotification,
    onPushNotificationApn: onPushNotificationApn,
    setBadge: setBadge,
    clearBadge: clearBadge,
    randomBetween: randomBetween,
    getQuote: getQuote,
    showMore: showMore,
    areYouSure: areYouSure,
    shortenDescription: shortenDescription,
    pushNotificationSemaphore: pushNotificationSemaphore,
    removeTouchEventsFromList: removeTouchEventsFromList,
    cekajPromiseResolve: cekajPromiseResolve,
    objectCopy: objectCopy,
    getCurrentFunctionName: getCurrentFunctionName,
    hasUserAccessToPro: hasUserAccessToPro,
    toTitleCase: toTitleCase,
    initRouter: initRouter,
    checkViews: checkViews,
    formatTimeForDisplayingTimedExercises: formatTimeForDisplayingTimedExercises,
    disableLogging: disableLogging
  };
})();
