var mad = mad || {};

mad.data = (function() {
  function ajaxRequest(route, options, stringify, force) {
    var path = route.putanja,
      verb = route.akcija,
      iOptS = options === undefined ? "" : "?" + $.param(options),
      uString = stringify === undefined ? false : stringify,
      forceGet = force === undefined ? false : force,
      urlS = path + iOptS,
      dfd = new $.Deferred();

    //perform async req.
    $.ajax({
      type: verb,
      url: path,
      data: uString ? JSON.stringify(options) : options,
      timeout: ajaxWaitTime,
      beforeSend: function(request) {
        request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
      },
      statusCode: {
        200: function(s) {
          //console.log("status 200", s)
        },
        400: function() {
          //alertify.error("bad request");
        },
        401: function() {
          // probably expired token

          setTimeout(function() {
            mad.alerts.error0("expired token (401) ");
          }, 3333);

          console.log("status code 401 - idi na start");
          mad.mobileApp.navigate("ui/other/start.html"); // goto start page
        }
      },
      dataType: "json"
    })
      .success(function(data, code, xhr) {
        dfd.resolve(data, code, xhr);
      })
      .error(function(qXHR, textStatus, errorThrown) {
        //Possible values for the second argument (besides null) are "timeout", "error", "abort", and "parsererror".
        if (qXHR.status == 200 && qXHR.statusText == "OK") {
          // drazen ovo je tu samo zato jer RegisterNew tako radi
          dfd.resolve("OK", 200);
        } else {
          //console.log("request ERROR", qXHR, textStatus, errorThrown);
          dfd.reject(qXHR, textStatus, errorThrown);
        }
      });

    return dfd.promise();
  }

  return {
    load: function(link, options, stringify, force) {
      return ajaxRequest(link, options, stringify, force);
    },
    post: function(link, options, stringify) {
      return ajaxRequest(link, options, stringify);
    },
    put: function(link, options, stringify) {
      return ajaxRequest({ putanja: link, akcija: "PUT" }, options, stringify);
    },
    delete: function(link, options, stringify) {
      return ajaxRequest(
        { putanja: link, akcija: "DELETE" },
        options,
        stringify
      );
    }
  };
})();
