var mad = mad || {};

mad.googleAnalytics = (function () {
    
    var isAppRunningInSimulator;

 
    function initAnalytics() {
        if (window.analytics && !isAppRunningInSimulator()) {
            window.analytics.startTrackerWithId('UA-61895500-2');
            enableOrDisableReportingOfUncaughtExceptions(true);
        }
    }

   
    function trackView(viewName) {
        if (window.analytics && !isAppRunningInSimulator()) {
            window.analytics.trackView(viewName);
        }
    }

    function trackEvent() {
        if (window.analytics && arguments.length >= 2 && !isAppRunningInSimulator()) {
            var category = arguments[0];
            var action = arguments[1];
            var label = arguments.length >= 3 ? arguments[2] : '';
            var value = arguments.length >= 4 ? (typeof(arguments[3]) === "number" ? arguments[3] : 0) : 0;
            
            window.analytics.trackEvent(category, action, label, value);
            console.log("GA - event",category, action, label, value);
        }
    }

    function trackPurchase(id, revenue, currencyCode) {
        if (window.analytics && arguments.length >= 2 && !isAppRunningInSimulator()) {

            var affiliation = device.platform === "Android" ? "Google Play Store" : "Apple App Store";
            window.analytics.addTransaction(id, affiliation, revenue, 0, 0, currencyCode);
        }

    }

    function registerUserIdWithAnalytics(userId) {
        if (window.analytics && !isAppRunningInSimulator()) {
            if (userId) {
                window.analytics.setUserId(userId);
            }
        }
    }

    function enableOrDisableReportingOfUncaughtExceptions(enable) {
        if (window.analytics && !isAppRunningInSimulator()) {
            window.analytics.enableUncaughtExceptionReporting(enable, function() {
                console.log("SUCCESS: GA " + (enable ? "enabled" : "disabled") + " reporting of uncaught exceptions");
            }, function() {
                console.log("FAILED: GA " + (enable ? "enabled" : "disabled") + " reporting of uncaught exceptions");

            });

        }
    }

    isAppRunningInSimulator = function () {
        return window.navigator.simulator === true;
    };

    return {
        initAnalytics: initAnalytics,
        trackView: trackView,
        trackEvent: trackEvent,
        registerUserIdWithAnalytics: registerUserIdWithAnalytics,
        enableOrDisableReportingOfUncaughtExceptions: enableOrDisableReportingOfUncaughtExceptions,
        trackPurchase: trackPurchase
    };

}());