var mad = mad || {};

mad.photos = (function() {

    var serverURI = "";
    
    function getPhoto(inputOptions, whichAPI){
        console.log("getPhoto");

        var defaultOptions = {
            quality: 50,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            mediaType: Camera.MediaType.PICTURE,
            destinationType: Camera.DestinationType.FILE_URI,
            encodingType: Camera.EncodingType.JPEG,
            correctOrientation: true,
            allowEdit: false,
            targetWidth: 600,
            targetHeight: 600
        };

        var options = _.extend(defaultOptions, inputOptions);

        serverURI = whichAPI;
        
        // take a picture or select file
        navigator.camera.getPicture(pictureTaken, getPictureFailed, options);

    }

    function pictureTaken(imageURI) {
        console.log("pictureTaken",imageURI);
        // getFileEntry
        window.resolveLocalFileSystemURL(imageURI, gotFileName, getFileEntryFailed);
    }
    
    function gotFileName(fileEntry) {
        //console.log("got file: " + fileEntry.fullPath, fileEntry.nativeURL);

        var d = new Date();
        var n = d.valueOf();        // num of milisecs since 1.1.1970

        var headers={'Authorization':"Bearer " + mad.loginToken};
        var options = new FileUploadOptions();

        options.headers = headers;
        options.fileKey = "file";
        options.fileName = mad.common.variables.username + n;
        options.mimeType = "image/jpg";
        options.chunkedMode = false;        // default = true
        
        //console.log("file",  options.fileName);

        var ft = new FileTransfer();
        
        ft.onprogress = function(progressEvent) {
            if (progressEvent.lengthComputable) {
                console.log("progress:", progressEvent.loaded / progressEvent.total);
            } else {
                console.log(".");
            }
        };
        
        ft.upload(fileEntry.nativeURL, serverURI, fileUploaded, uploadFailed, options);
    }

    function fileUploaded (r) {
        console.log("file uploaded");
        mad.alerts.success(mad.common.translate("messages", "uploaded"));
        /*
        console.log("Code = " + r.responseCode);
        console.log("Response = " + r.response);
        console.log("Sent = " + r.bytesSent);
        */
        doCleanup();
    }

    function doCleanup(){
        if (device.platform == "iOS" && viewModel.get("photoSource") == Camera.PictureSourceType.CAMERA){
            navigator.camera.cleanup(onSuccessCleanup, onFailCleanup);
        }
    }

    function onSuccessCleanup() {
        console.log("Camera cleanup successful.")
    }

    // fejlovi
    function getPictureFailed(message) {
        console.log("get picture fail", message);
    }

    function getFileEntryFailed() {
        // If don't get the FileEntry (which may happen when testing on some emulators)
        console.log("no file entry");
        doCleanup();
    }

    function uploadFailed(error) {
        mad.alerts.realTop0(mad.common.translate("messages", "notUploaded"))
        console.log("upload failed / error code = " + error.code);
        console.log("upload error source " + error.source);
        console.log("upload error target " + error.target);
        doCleanup();
    }

    function onFailCleanup(message) {
        console.log('Camera cleanup Failed because: ' + message);
    }
    
    return {
        get: getPhoto,
    };

}());