var mad = mad || {};
mad.local = (function () {

	function getVersion() {
		var doc,
			localVariable = "0";

		if (window.navigator.simulator) {
			localVariable = localStorage.getItem("version") || "0";
		}else{
			doc = localApp.findOne({'name': "version"});
			console.log("loadVariable", "version", doc);
			if (doc){
				localVariable = doc.value;
			}else{
				console.log("there is no version doc in app colection so it will be created here")
				localApp.insert({name:'version', value: "0"});
			}
		}
		return localVariable;
	}

	function saveVersion(value) {
		var doc;

		if (window.navigator.simulator) {
			localStorage.setItem("version", value);
		}else{
			doc = localApp.findOne({'name': "version"});
			if (doc){
				doc.value = value;
				localApp.update(doc);
			}else{
				console.log("there is no version doc in app colection so it will be created & set here")
				localApp.insert({name:'version', value: value});
			}
			localJsonDB.saveDatabase();
		}
	}

    /**
     * @summary Gets user's auth token 
     * @param {any} promise Promise to resolve 
     */
	function loadToken(promise) {
        var token = "";

		if (window.navigator.simulator) {

			//if in simulator just get token from local storage
            token = localStorage.getItem("token") || "";

		    promise.resolve(token);

		} else {

		 mad.nativeStorage.getItem("token",
				function(value) {
					console.log("token: retrieved from native storage");

                    //just safety check
				    if (value) {
				        token = value;
				    }

                    promise.resolve(token);
				},
				function(error) {
                    console.log("token: failed to retrieve from native storage --- error code : ", error.code);

                    var doc = localApp.findOne({ 'name': 'token' });
				    if (doc) {
				        token = doc.value;
                    }

				    promise.resolve(token);

				});			
		}

	}

	function saveToken(value) {

		if (window.navigator.simulator) {
			// if in simulator just save token to local storage
			localStorage.setItem("token", value);
		}else {
			mad.nativeStorage.setItem("token",
				value,
				function() {
					console.log("token: save to native storage success");
				},
				function(error) {
					console.log("token: save to native storage fail --- error code: ", error.code);

				});

			//also save in loki DB !!!

			// Find and update an existing document
			var doc = localApp.findOne({ 'name': 'token' });
			if (doc) {
				doc.value = value;
				localApp.update(doc);
			} else {
				console.log("there is no token in localUser colection so it will be created & set here");
				localApp.insert({ name: 'token', value: value });
			}
			localJsonDB.saveDatabase();
		}
	}

	function loadVariable(key) {
		var doc,
			localVariable = "";

		if (window.navigator.simulator) {
			localVariable = localStorage.getItem(key) || "";
		}else{

			if (localUserVariables.indexOf(key) > -1){
				doc = localUser.findOne({'name': key});
				if (doc) {
					localVariable = doc.value;
				}else{
					console.log("there is no " + key + " doc in user colection so it will be created here");
					localUser.insert({name: key, value: ""});
					localJsonDB.saveDatabase();
				}
			}else

			if (localAppVariables.indexOf(key) > -1){
				doc = localApp.findOne({'name': key});
				if (doc){
					localVariable = doc.value;
				}else{
					console.log("there is no " + key + " doc in app colection so it will be created here");
					localApp.insert({name: key, value: ""});
					localJsonDB.saveDatabase();
				}
			}else

			if (localOtherVariables.indexOf(key) > -1){
				doc = localOther.findOne({'name': key});
				if (doc){
					localVariable = doc.value;
				}else{
					console.log("there is no " + key + " doc in other colection so it will be created here");
					localOther.insert({name: key, value: ""});
					localJsonDB.saveDatabase();
				}

			}else{
				console.log("loadVariable - nemam spremljeno u niti jednoj kolekciji, kreiraj u other", key);
				localOther.insert({name: key, value: ""});
				localJsonDB.saveDatabase();
			}
		}
		return localVariable;
	}

	function saveVariable(key, value) {
		var doc;

		if (window.navigator.simulator) {
			localStorage.setItem(key, value);
		}else{

			if (localUserVariables.indexOf(key) > -1){
				// Find and update an existing document
				doc = localUser.findOne({'name': key});
				if (doc) {
					doc.value = value;
					localUser.update(doc);
				}else{
					console.log("there is no " + key + " doc in user colection so it will be created & set here")
					localUser.insert({name: key, value: JSON.stringify(value)});
				}
			}else

			if (localAppVariables.indexOf(key) > -1){
				doc = localApp.findOne({'name': key});
				if (doc) {
					doc.value = value;
					localApp.update(doc);
				}else{
					console.log("there is no " + key + " doc in app colection so it will be created & set here")
					localApp.insert({name: key, value: JSON.stringify(value)});
				}
			}else

			if (localOtherVariables.indexOf(key) > -1){
				doc = localOther.findOne({'name': key});
				if (doc) {
					doc.value = value;
					localOther.update(doc);
				}else{
					console.log("there is no " + key + " doc in other colection so it will be created & set here")
					localOther.insert({name: key, value: JSON.stringify(value)});
				}
			}else{
				console.log("saveVariable - nemam spremljeno u niti jednoj kolekciji, kreiraj u other", key);
				localOther.insert({name: key, value: JSON.stringify(value)});
			}

			localJsonDB.saveDatabase();
		}

	}

	function loadVariableParse(key) {
		var doc,
			tmpValue,
			localVariable = "[]";

		if (window.navigator.simulator) {
			localVariable = localStorage.getItem(key) || "[]";
		}else{

			if (localUserVariables.indexOf(key) > -1){
				doc = localUser.findOne({'name': key});
				if (doc) {
					if (mad.common.isNullOrEmpty(doc.value)){
						tmpValue = "[]";
					}else{
						tmpValue = doc.value;
					}
					localVariable = tmpValue;
				}else{
					console.log("there is no " + key + " doc in user colection so it will be created here");
					localUser.insert({name: key, value: "[]"});
					localJsonDB.saveDatabase();
				}
			}else

			if (localAppVariables.indexOf(key) > -1){
				doc = localApp.findOne({'name': key});
				if (doc){
					if (mad.common.isNullOrEmpty(doc.value)){
						tmpValue = "[]";
					}else{
						tmpValue = doc.value;
					}
					localVariable = tmpValue;
				}else{
					console.log("there is no " + key + " doc in app colection so it will be created here");
					localApp.insert({name: key, value: "[]"});
					localJsonDB.saveDatabase();
				}
			}else

			if (localOtherVariables.indexOf(key) > -1){
				doc = localOther.findOne({'name': key});
				if (doc){
					if (mad.common.isNullOrEmpty(doc.value)){
						tmpValue = "[]";
					}else{
						tmpValue = doc.value;
					}
					localVariable = tmpValue;
				}else{
					console.log("there is no " + key + " doc in other colection so it will be created here");
					localOther.insert({name: key, value: "[]"});
					localJsonDB.saveDatabase();
				}
			}else{
				console.log("loadVariableParse - nemam spremljeno u niti jednoj kolekciji stavi u other", key);
				localOther.insert({name: key, value: "[]"});
				localJsonDB.saveDatabase();
			}
		}
		return JSON.parse(localVariable);
	}

	function saveVariableParse(key, value) {
		var doc;

		if (window.navigator.simulator) {
			localStorage.setItem(key, JSON.stringify(value));
		}else{

			if (localUserVariables.indexOf(key) > -1){
				// Find and update an existing document
				doc = localUser.findOne({'name': key});
				if (doc) {
					doc.value = JSON.stringify(value);
					localUser.update(doc);
				}else{
					console.log("there is no " + key + " doc in user colection so it will be created & set here")
					localUser.insert({name: key, value: JSON.stringify(value)});
				}
			}else

			if (localAppVariables.indexOf(key) > -1){
				doc = localApp.findOne({'name': key});
				if (doc) {
					doc.value = JSON.stringify(value);
					localApp.update(doc);
				}else{
					console.log("there is no " + key + " doc in app colection so it will be created & set here")
					localApp.insert({name: key, value: JSON.stringify(value)});
				}
			}else

			if (localOtherVariables.indexOf(key) > -1){
				doc = localOther.findOne({'name': key});
				if (doc) {
					doc.value = JSON.stringify(value);
					localOther.update(doc);
				}else{
					console.log("there is no " + key + " doc in other colection so it will be created & set here")
					localOther.insert({name: key, value: JSON.stringify(value)});
				}
			}else{
				console.log("saveVariableParse - nemam spremljeno u niti jednoj kolekciji stavi u other", key);
				localOther.insert({name: key, value: JSON.stringify(value)});
			}

			localJsonDB.saveDatabase();
		}
	}

	function loadSaved() {
		var doc,
			localVariable = "[]";

		if (window.navigator.simulator) {
			localVariable = localStorage.getItem("savedWorkouts") || "[]";
		}else{
			doc = localSaved.findOne({'name': "savedWorkouts"});
			if (doc) {
				localVariable = doc.value;
			}else{
				console.log("there is no savedWorkouts doc in localSaved colection so it will be created here");
				localSaved.insert({name: "savedWorkouts", value: "[]"});
				localJsonDB.saveDatabase();
			}
		}
		return JSON.parse(localVariable);
	}

	function saveSaved(value) {
		var doc;

		if (window.navigator.simulator) {
			localStorage.setItem("savedWorkouts", JSON.stringify(value));
		}else{
			// Find and update an existing document
			doc = localSaved.findOne({'name': "savedWorkouts"});
			if (doc) {
				doc.value = JSON.stringify(value);
				localSaved.update(doc);
			}else{
				console.log("there is no savedWorkouts doc in savedWorkouts colection so it will be created & set here")
				localSaved.insert({name: "savedWorkouts", value: JSON.stringify(value)});
			}
			localJsonDB.saveDatabase();
		}
	}

	function loadMadbarzRoutines() {
		var doc,
			localVariable = "[]",
			rExp,
			expired = true;

		if (window.navigator.simulator) {
			localVariable = localStorage.getItem("routines") || "[]";
			rExp = localStorage.getItem("routines-expires");
			expired = (rExp === null || new Date(rExp).getTime() < new Date().getTime() || $.isEmptyObject(localVariable)) ? true : false;
		}else{
			doc = localRoutines.findOne({'name': "routines"});
			if (doc) {
				localVariable = doc.value;
				expired = (doc.expires == 0 || new Date(doc.expires).getTime() < new Date().getTime() || $.isEmptyObject(localVariable)) ? true : false;
			}else{
				console.log("there is no routines doc in madbarzRoutines colection so it will be created here");
				localRoutines.insert({name: "routines", value: JSON.stringify([]), "expires": 0});
				localJsonDB.saveDatabase(function(err) {
                    if (err) {
                        console.log("error saving routines to loki database: " + err);
                    }
                    else {
                        console.log("database saved.");
                    }
                });
			}
		}
		return {data: JSON.parse(localVariable), expired: expired};
	}

	function saveMadbarzRoutines(value) {
		var doc,
			expireValue;

		if (!mad.common.isNullOrEmpty(value)) {
			expireValue = new Date(new Date().getTime() + (86400000 * 5)); // 5 dana
		}else{
			expireValue = new Date(new Date().getTime() + (1000 * 10));
		}

		if (window.navigator.simulator) {
			localStorage.setItem("routines", JSON.stringify(value));
			if (!mad.common.isNullOrEmpty(value)) {
				localStorage.setItem("routines-expires", expireValue); // 5 dana
			}else{
				localStorage.setItem("routines-expires", expireValue);
			}
		}else{
			// Find and update an existing document
			doc = localRoutines.findOne({'name': "routines"});
			if (doc) {
				doc.value = JSON.stringify(value);
				doc.expires = expireValue;
				localRoutines.update(doc);
			}else{
				console.log("there is no routines doc in madbarzRoutines colection so it will be created & set here")
				localRoutines.insert({name: "routines", value: JSON.stringify(value), "expires": expireValue});
			}
			localJsonDB.saveDatabase();
		}
	}

	function removeMadbarzRoutines(){
		if (window.navigator.simulator) {
			localStorage.removeItem("routines");
			localStorage.removeItem("routines-expires");
		}else{
			doc = localRoutines.findOne({'name': "routines"});
			if (doc) {
				localRoutines.remove(doc);
			}
		}
	}

	function clear(){

		var pendingS, updatesToSync, treningsToSync, installationId, pnsHandle, fotka;

		if (window.navigator.simulator) {
			pendingS = loadVariable("pendingSync");
			updatesToSync = getPendingUpdates();
			treningsToSync = getWorkout();
			installationId = loadVariable("installationId");
			pnsHandle = loadVariable("pnsHandle");
			fotka = loadVariableParse("ProfilePhoto");

			localStorage.clear();

			saveVariableParse("ProfilePhoto", fotka);
			saveVariable("pnsHandle", pnsHandle);
			saveVariable("installationId", installationId);
			saveWorkout(treningsToSync);
			savePendingUpdates(updatesToSync);
			saveVariable("pendingSync", pendingS);
		}else{
			localJsonDB.removeCollection('user');
			localJsonDB.removeCollection('savedWorkouts');
			localJsonDB.removeCollection('madbarzRoutines');
			localJsonDB.removeCollection('other');
			localJsonDB.saveDatabase();
		}

		//reread madbarz routines
		mad.local.removeMadbarzRoutines();
		mad.models.routines.read();

	}

	function removeVariable(key) {
		var doc;

		if (window.navigator.simulator) {
			localStorage.removeItem(key);
		}else{

			if (localUserVariables.indexOf(key) > -1){
				doc = localUser.findOne({'name': key});
				if (doc) {
					localUser.remove(doc);
				}else{
					console.log("there is no " + key + " doc in user colection");
				}
			}else

			if (localAppVariables.indexOf(key) > -1){
				doc = localApp.findOne({'name': key});
				if (doc){
					localApp.remove(doc);
				}else{
					console.log("there is no " + key + " doc in app colection");
				}
			}else

			if (localOtherVariables.indexOf(key) > -1){
				doc = localOther.findOne({'name': key});
				if (doc){
					localOther.remove(doc);
				}else{
					console.log("there is no " + key + " doc in other colection");
				}
			}else

			if (key == "savedWorkouts"){
				doc = localSaved.findOne({'name': key});
				if (doc){
					localSaved.remove(doc);
				}else{
					console.log("there is no " + key + " doc in localSaved colection");
				}
			}else

			if (key == "routines"){
				doc = localRoutines.findOne({'name': key});
				if (doc){
					localRoutines.remove(doc);
				}else{
					console.log("there is no " + key + " doc in localRoutines colection");
				}
			}else{
				console.log("loadVariable - nemam spremljeno", key);
			}

			localJsonDB.saveDatabase();
		}
	}

	function getPendingUpdates() {
		return loadVariableParse("pendingUpdates");
	}
	function savePendingUpdates(value) {
		saveVariableParse("pendingUpdates", value);
	}
	function appendPendingUpdates(value) {
		// append to updates saved in cache
		var alreadySaved = loadVariableParse("pendingUpdates");
		alreadySaved.push(value);
		saveVariableParse("pendingUpdates", alreadySaved);

		saveVariable("pendingSync",true);
	}
	function clearPendingUpdates() {
		removeVariable("pendingUpdates");
	}



	function getWorkout() {
		return loadVariableParse("pendingTrenings");
	}

	function saveWorkout(value) {
		saveVariableParse("pendingTrenings", value);
	}

	function appendWorkout(value) {
		// append to workouts saved in cache
		var alreadySaved = loadVariableParse("pendingTrenings");
		alreadySaved.push(value);
		saveVariableParse("pendingTrenings", alreadySaved);

		saveVariable("pendingSync",true);
	}

	function clearWorkout() {
		removeVariable("pendingTrenings");
	}

	function getWorkoutPlan() {
		return loadVariableParse("pendingTreningsPlan");
	}

	function appendWorkoutPlan(value) {
		// append to workouts saved in cache
		var alreadySaved = loadVariableParse("pendingTreningsPlan");
		alreadySaved.push(value);
		saveVariableParse("pendingTreningsPlan", alreadySaved);

		saveVariable("pendingSync",true);
	}

	function usernameExistsIn(key, value) {
		var users = loadVariableParse(key);
		if (users.indexOf(value) != -1) {
			return true;     // username exists
		}else{
			return false
		}
	}

	function appendUsernameTo(key, value) {
		var users = loadVariableParse(key);

		// append only if username is not there
		if (users.indexOf(value) == -1) {       // username doesn't exists
			users.push(value);
			saveVariableParse(key, users);
		}
	}

	return {
		clear: clear,
		getVersion: getVersion,
		saveVersion: saveVersion,
		loadToken: loadToken,
		saveToken: saveToken,
		loadVariable: loadVariable,
		saveVariable: saveVariable,
		loadVariableParse: loadVariableParse,
		saveVariableParse: saveVariableParse,
		loadSaved: loadSaved,
		saveSaved: saveSaved,
		saveMadbarzRoutines: saveMadbarzRoutines,
		loadMadbarzRoutines: loadMadbarzRoutines,
		removeMadbarzRoutines: removeMadbarzRoutines,
		removeVariable: removeVariable,
		savePendingUpdates: savePendingUpdates,
		appendPendingUpdates: appendPendingUpdates,
		getPendingUpdates: getPendingUpdates,
		clearPendingUpdates: clearPendingUpdates,
		saveWorkout: saveWorkout,
		appendWorkout: appendWorkout,
		appendWorkoutPlan: appendWorkoutPlan,
		getWorkout: getWorkout,
		getWorkoutPlan: getWorkoutPlan,
		clearWorkout: clearWorkout,
		appendUsernameTo: appendUsernameTo,
		usernameExistsIn: usernameExistsIn
	};

}());