var mad = mad || {};

mad.mixpanel = (function () {

   

    var isAppRunningInSimulator;

    //these are properties of event which are always sent with the event
    function registerSuperProperties() {
       


        if (window.mixpanel) {

            if (window.mixpanel && !isAppRunningInSimulator()) {
            var value = mad.common.getVersion();
            
            window.mixpanel.register({
                "Platform": "Mobile",
                "Platform Type": window.device.platform,
                "Device Model": window.device.model,
                "Device Version": window.device.version,
                "App version": value,
                "Fitness Level": mad.local.loadVariable("FitnessLevel"),
                "Goal": mad.local.loadVariable("Goal"),
                "Score": mad.local.loadVariable("Score"),
                "Date User Joined": mad.local.loadVariable("DateUserJoined"),
                "Number Of Finished Workouts": mad.local.loadVariable("NumberOfFinishedWorkouts"),             
            });
            console.log("Mixpanel Registered Super Properties");
           }         
            
        }
    }

    function trackEvent(eventName) {
        if (window.mixpanel && !isAppRunningInSimulator()) {

            window.mixpanel.track(eventName);
            console.log("Mixpanel Track:", eventName);
        }

    }

    function trackEventWithAdditionalInfo(eventName, object) {
        if (window.mixpanel && !isAppRunningInSimulator()) {
            if (object) {
                window.mixpanel.track(eventName, object);
                console.log("Mixpanel Track:", eventName);
            }
        }
    }

    function connectMadbarzUserWithMixpanel(id) {
        if (window.mixpanel && !isAppRunningInSimulator()) {
            window.mixpanel.identify(id);
        }
    }

    function connectMadbarzUserWithMixpanelAlias(id) {
        if (window.mixpanel && !isAppRunningInSimulator()) {
            window.mixpanel.alias(id);
        }
    }

    function initMixapnel() {
        if (window.mixpanel && !isAppRunningInSimulator()) {
            mixpanel.init("3497866e5678a654af6e8b2d8aca5d54");

        }
    }

    function reset() {
        if (window.mixpanel && !isAppRunningInSimulator()) {
            window.mixpanel.reset();
        }
    }

    isAppRunningInSimulator = function () {
        return window.navigator.simulator === true;
    };
    return {
        initMixpanel: initMixapnel,
        registerSuperProperties : registerSuperProperties,
        trackEvent: trackEvent,
        trackEventWithAdditionalInfo: trackEventWithAdditionalInfo,
        connectMadbarzUserWithMixpanel: connectMadbarzUserWithMixpanel,
        connectMadbarzUserWithMixpanelAlias: connectMadbarzUserWithMixpanelAlias,
        reset: reset
    };

}());