// this is a custom kendo plugin created for the touch value picker
// it supprots kendo binidng and has kinetic scrolling


(function () {
    // shorten references to variables. this is better for uglification
    var kendo = window.kendo,
        ui = kendo.ui,
        Widget = ui.Widget,

        CHANGE = "change";

    function xpos(e) {
        // touch event
        if (e.originalEvent.targetTouches && (e.originalEvent.targetTouches.length >= 1)) {
            return e.originalEvent.targetTouches[0].clientX;

        } else if (e.originalEvent.touch) {
            return e.originalEvent.touch.clientX;
        }
        // mouse event
        return e.clientX;
    }

    var ValuePicker = Widget.extend({

        // variables
        _list: "",
        _tapped: false,
        _overlay: "",
        _value: 1,

        _tapWait: 101,
        _dragWait: 11,

        _listObject: {},
        _listNumbers: [],
        _listElements: 60,
        _listThreshold: 20,

        max: 0,
        min: 0,
        offset: 0,
        reference: 0,
        pressed: false,
        xform: "transform",
        velocity: 0,
        frame: 0,
        timestamp: 0,
        ticker: null,
        amplitude: 0,
        target: 0,
        timeConstant: 225,
        snap: 0,
        adding: false,
        working: false,

        init: function (element, options) {
            // base call to initialize widget
            var that = this;

            Widget.fn.init.call(that, element, options);

            that._list = $('<ul class="madbarz-value-picker-list"></ul>');
            that._overlay = $('<div class="madbarz-value-picker-overlay"></div>');

            that._listObject = $(element.id + " ul");

            /*
            for (var i = 0; i < 26; i++) {
                $(that._list).append($('<li>' + i + '</li>'));
            }
            that._doOnTap();    // u 1. verziji je bilo 100 sad se korisi _tapWait: 12 (mogla bi se prenijeti vrijednost kao parametar)
            */

            var container = $('<div class="madbarz-value-list-container"></div>');
            container.append(that._list);
            $(element).addClass('madbarz-value-picker');
            $(element).append(that._overlay);
            $(element).append(container);

            if (typeof window.ontouchstart !== 'undefined') {
                $(element).on('touchstart', that.tap);
                $(element).on('touchmove', function (e) {
                    var event = e;
                    setTimeout(function () {
                       that.drag(event);
                    }, that._dragWait);
                });
                //$(element).on('touchend touchleave touchcancel', that.release);

                //$(element).on('touchend touchleave touchcancel', function (e) {

                $(element).on('touchend', function (e) {
                    var event = e;
                    setTimeout(function () {
                        that.release(event);
                    }, 11);
                });
            }

            //that.initNumbers();   //ovo ne treba jer se izvodi prerano dok se jos inicijalizira widget

            ['webkit', 'Moz', 'O', 'ms'].every(function (prefix) {
                var e = prefix + 'Transform';
                if (typeof element.style[e] !== 'undefined') {
                    that.xform = e;
                    return false;
                }
                return true;
            });
        },

        initNumbers: function () {
            var that = this;

            $(that._list).empty();
            for (var i = 0; i < that._listElements; i++) {
                $(that._list).append($('<li>' + i + '</li>'));
            }
            that._doOnTap();    // u 1. verziji je bilo 100 sad se korisi _tapWait: 12 (mogla bi se prenijeti vrijednost kao parametar)

            var dr_svi = $(that._list).children();
            var dr_ukupno = $(dr_svi).length;
            var dr_prvi = $(that._list).children()[0];
            var dr_prvi_sirina, tmpSirina;
            var defaultW = mad.common.actualView.content.width() / 5;       //ako ne stigne izracunati uzmi default koji podrazumjeva da je raspoređeno 5 brojeva

            //that._listNumbers = dr_svi.map(function() { return $(this).text(); }).get();
            that._listNumbers = dr_svi.map(function() { return parseInt($(this).text()); }).get();

            //daj mu malo vremena
            setTimeout(function() {
                tmpSirina = dr_prvi.getBoundingClientRect().width;
                dr_prvi_sirina = tmpSirina == 0 ? defaultW : tmpSirina;

                that.max = dr_ukupno * dr_prvi_sirina;
                that.offset = 0;

                $(that._overlay).width(dr_prvi_sirina);
                $(that._overlay).css('left', (dr_prvi_sirina * 2) + "px");

                that.snap = dr_prvi_sirina;
                that.min = -(that.snap * 2);
                that.max = (dr_ukupno - 3) * that.snap;

                //that._moveValue();

                //za kvazi anim
                that._moveToValue(that._value - 10);
                that._animatedMoveValue();

            }, 222)

        },

        tap: function (e) {
            var that = $(this).data("kendoValuePicker");
            //console.log("tap", that);
            //console.log("tap, dragWait", that._dragWait);
            console.log("tap");

            that._tapped = true;
            that.working = true;
            that.pressed = true;
            that.reference = xpos(e);

            that.velocity = that.amplitude = 0;
            that.frame = that.offset;
            that.timestamp = Date.now();
            clearInterval(that.ticker);

            function track() {
                console.log("track");
                var now, elapsed, delta, v;
                now = Date.now();
                elapsed = now - that.timestamp;
                timestamp = now; //drazen (zasto nema that)
                //that.timestamp = now;

                delta = that.offset - that.frame;
                that.frame = that.offset;
                v = 1000 * delta / (1 + elapsed);
                that.velocity = 0.8 * v + 0.2 * that.velocity;

                console.log("tap",that.timestamp, that.frame, that.velocity);
            }
            that.ticker = setInterval(track, that._tapWait);

            e.preventDefault();
            e.stopPropagation();
            return false;
        },

        drag: function (e) {
            //console.log("drag - vraca undefined zakendoValuePicker ");

            var x, delta;
            // var that = $(this).data("kendoValuePicker"); //ni dobro

            console.log("drag", this);

            var that = this;
            that._tapped = false;
            if (that.pressed) {
                console.log("drag & pressed");

                x = xpos(e);
                delta = that.reference - x;
                if (delta > 2 || delta < -2) {
                    that.reference = x;
                    that.scroll(that.offset + delta);
                }
            }
            e.preventDefault();
            e.stopPropagation();
            return false;
        },

        release: function (e) {
            //var that = $(this).data("kendoValuePicker");
            var that = this;
            //console.log("release", that);

            that.pressed = false;

            function autoScroll() {
                var elapsed, delta;
                if (that.amplitude) {
                    elapsed = Date.now() - that.timestamp;
                    delta = -that.amplitude * Math.exp(-elapsed / that.timeConstant);
                    if (delta > 5 || delta < -5) {
                        console.log("release - prije scroll (delta > 5)",that.timestamp, that.frame, that.velocity);
                        that.scroll(that.target + delta);
                        requestAnimationFrame(autoScroll);
                    } else {

                        console.log("release - prije scroll",that.timestamp, that.frame, that.velocity);

                        that.scroll(that.target);
                        var vl = Math.floor(that.target / that.snap) + 2;
                        if (vl < 0)
                            vl = 0;
                        that._update(vl);
                    }
                    that.working = false;
                }
            }

            clearInterval(that.ticker);
            that.target = that.offset;
            if (that.velocity > 10 || that.velocity < -10) {
                that.amplitude = 0.8 * that.velocity;
                that.target = that.offset + that.amplitude;
            }
            that.target = Math.round(that.target / that.snap) * that.snap;
            that.amplitude = that.target - that.offset;
            that.timestamp = Date.now();

            var targetNum = Math.round(that.target / that.snap);
            console.log("target je", targetNum, e.type );
            console.log("release",that.timestamp, that.frame, that.velocity);

            requestAnimationFrame(autoScroll);
            e.preventDefault();
            e.stopPropagation();
            return false;
        },

        value: function (v) {
            var that = this;
            if (v === undefined) {
                //console.log("value undefined, vraca", that._value);
                return that._value;
            }else{
                //console.log("value ", v );
                that._update(v);
                that._moveValue();
            }
        },

        scroll: function (x) {

            // x = pozicija u px 'broj * sirina prvog broja u px

            var that = this;

            //console.log("prije, sad", that.offset, x);

            that.offset = (x < that.min) ? that.min : x;        // pozicija 1. vidljivog/lijevog  broja u px
            that._list.css('transform', 'translate3d(0,0,0) translateX(' + (-that.offset) + 'px)');

            var maxSteps = Math.round(that.max / that.snap);        // zadnji broj (broj elemenata liste)
            var currentStep = Math.round(that.offset / that.snap);
            //console.log("lijevi", currentStep, maxSteps);

            if (maxSteps - currentStep < that._listThreshold && that.adding === false) {

                /*
                that.adding = true;

                for (var i = maxSteps + 3; i < currentStep + 54; i++) {
                    $(that._list).append('<li>' + i + '</li>');
                }
                $($(that._list).children()).unbind("click");
                $($(that._list).children()).unbind("touchend");
                that._doOnTap();
                that.max = ($($(that._list).children()).length - 3) * that.snap;

                that.adding = false;
                */

                that.adding = true;
                console.log(currentStep);
                //console.log("brojceki", that._listNumbers);
                that._addToRight(currentStep);
                //console.log("brojceki", that._listNumbers);
                that._numbersToList();
                that.adding = false;

            }
        },

        _addToRight: function(currentStep){
            var that = this;

            var lastOne = parseInt(that._listNumbers[that._listElements-1]);
            var numFrom =  lastOne + 1;
            var numTo = numFrom + this._listThreshold;

            var leftPart = that._listNumbers.splice(0, that._listThreshold);
            var rightPart = [];

            for (var i = numFrom; i < numTo; i++){
                rightPart.push(i);
            }

            that._listNumbers = that._listNumbers.concat(rightPart);
        },

        _numbersToList: function(){
            var that = this;
            that._list.children().each(function(i,e){
                $(e).text(that._listNumbers[i]);
            });
        },

        animatedGoTo: function (v) {
            var that = this;

            that._update(v);
            that._animatedMoveValue();
        },

        _update: function (value) {
            var that = this;
            that._value = value;
            that.trigger(CHANGE);
        },

        _animatedMoveValue: function () {
            var that = this;
            $(that._list).css('transition', 'all linear 0.3s');
            setTimeout(function () {
                that.scroll((that.value() - 2) * that.snap);
            }, 50);
            setTimeout(function () {
                $(that._list).css('transition', '');
            }, 360);
        },

        _moveValue: function () {
            var that = this;
            that.scroll((that.value() - 2) * that.snap);
        },

        _moveToValue: function (v) {
            var that = this;
            if (v){
                that.scroll((v - 2) * that.snap);
            }else{
                that.scroll((that.value() - 2) * that.snap);
            }
        },

        _change: function (value) {
            var that = this;
            //Determine if the value is different than it was before
            if (that._old !== value) {
                //It is different, update the value
                that._update(value);
                //Capture the new value for future change detection
                that._old = value;
                // trigger the external change
                that.trigger(CHANGE);
            }
        },

        _doOnTap: function(){
            var that = this;
            $($(that._list).children()).on('click, touchend', function (e) {
                //console.log("_doOnTap");
                setTimeout(function () {
                    if (that._tapped) {
                        //console.log("_doOnTap-animiraj");
                        that.animatedGoTo(parseInt($(e.currentTarget).html()));
                    }
                }, that._tapWait);

            });
        },

        events: [
            CHANGE
        ],

        options: {
            // the name is what it will appear as off the kendo namespace(i.e. kendo.ui.MyWidget). 
            // The jQuery plugin would be jQuery.fn.kendoMyWidget.
            name: "ValuePicker"
            // other options go here

        }
    });

    ui.plugin(ValuePicker);

})();
