var mad = mad || {};

mad.models = mad.models || {};

(function(modelz){

    'use strict';

    // local variables
    
    modelz.commonVars = new kendo.observable({
        /*
        username: "test",
        userId: "0",
        */
        searchTerm: "mad",
        feedPage: 0,
        notificationsCurrentPage: 0,
        followingSkipped: 0,
        followers: 0,
        following: 0,
        banners: ["platinum", "nutrition"],
        lastBanner: ""
    });

    /* drazen - primjer extendanja datasourcea novom metodom
     kendo.data.DataSource.prototype.getFieldType = function(field) {
        return this.options.schema.model.fields[field].type;
     }
     i uporaba:
     var fieldType = dataSource.getFieldType("grad");
     */

    // feed model - - - - - - - - -
    modelz.feedAll = new kendo.data.DataSource({
        offlineStorage: "feedAll",
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/FeedV3/GetFeedAllUsersWithFeaturedWorkouts",
                cache: true,
                data: function () {
                    var totalItemsAll = mad.common.observables.get("totalItemsFromFeedAll");
                    var totalItemsFeatured = mad.common.observables.get("totalItemsFeatured");
                    return {
                        totalItemsAll: totalItemsAll,
                        totalItemsFeatured: totalItemsFeatured
                    }
                },
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                    //get requesting page no
                    var pages = this.url.split("?");
                    var page = mad.common.getQueryVariable(pages[1],"page");
                    modelz.commonVars.set("feedPage", page);
                    if (page == 1){
                        //console.log("page 1 - nema preloadera")
                    }else{
                        //console.log("page > 1 - show preloader", page)
                       // mad.common.showLoader(mad.common.translate("words", "loading"));
                    }
                }
            }
        },
        requestEnd: function (e) {
           // mad.common.hideLoader();
        },
        schema: {
            parse: function(data) {
                $.each(data, function (idx, elem) {
                    elem.Type = "FA";
                });

                var numberOfFeaturedItems = _.filter(data,
                    function (item) {
                        return item.IsFeaturedWorkout;
                    }).length;
                var numberOfAllItems = data.length - numberOfFeaturedItems;
                var totalAll = mad.common.observables.get("totalItemsFromFeedAll");
                var totalFeatured = mad.common.observables.get("totalItemsFeatured");
                mad.common.observables.set("totalItemsFromFeedAll", totalAll + numberOfAllItems);
                mad.common.observables.set("totalItemsFeatured", totalFeatured + numberOfFeaturedItems);

                return data;
            },
            total: function (data) {
                if (data.length == 0) {
                    return 0;           // drazen - za slucaj da nema podataka treba vratiti 0 inace puca template
                }else{
                    return 6400;        // max podataka za ucitati
                }
            }
        }, 

        serverPaging: true,
        pageSize: 48
    });
    modelz.feedAll.online(true);

    // feed model for following - - - - - - - - - 
    modelz.feedFollowing = new kendo.data.DataSource({
        offlineStorage: "feedFollowing",
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/FeedV3/GetFeedFollowingUsers",
                cache: true,

                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                    //get requesting page no
                    var pages = this.url.split("?");
                    var page = mad.common.getQueryVariable(pages[1],"page");
                    modelz.commonVars.set("feedPage", page);
                    if (page == 1){
                        //console.log("page 1 - nema preloadera")
                    }else{
                        //console.log("page > 1 - show preloader")
                        //mad.common.showLoader(mad.common.translate("words", "loading"));
                    }
                }
            }
        },

        schema: {
            parse: function(data) {

                $.each(data, function(idx, elem) {
                    elem.Type = "FF";
                });

                return data;
            },
            total: function (data) {

                if (data.length == 0) {
                    return 0;           // drazen - za slucaj da nema podataka treba vratiti 0 inace puca template
                }else{
                    return mad.common.variables.noOfWorkoutsInFeed;
                }
            }
        }, 
        serverPaging: true,
        pageSize: 48
    });
    modelz.feedFollowing.online(true);

    modelz.notifications = new kendo.data.DataSource({
        offlineStorage: "notifications",
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/Notifications/GetNotifications",
              //  url: "https://test-madbarz-api.azurewebsites.net/api/Notifications/GetNotifications",
                cache: true,
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                    //get requesting page no
                    var pages = this.url.split("?");
                    var page = mad.common.getQueryVariable(pages[1],"page");
                    modelz.commonVars.set("notificationsCurrentPage", page);
                    //console.log("page", page);
                    if (page == 1){
                        //console.log("page 1 - nema preloadera")
                    }else{
                        //console.log("page > 1 - show preloader")
                        mad.common.showLoader(mad.common.translate("words", "loading"));
                    }
                }
            }
        },
        requestStart: function (e) {
            //mad.common.showLoader(mad.common.translate("words", "loading"));
        },

        requestEnd: function (e) {
            //console.log("requestEnd notif",  e.response);
            mad.common.hideLoader();
        },

        change: function (e) {
            mad.common.hideLoader();
        },

        schema: {
            data: function (data) {
                return data;
            },
            total: function (data) {
                if (data.length === 0) {
                    //mad.viewModels.notif.viewModel.set("noNotifications", true);
                    return 0;           // drazen - za slucaj da nema podataka treba vratiti 0 inace puca template
                } else {
                    //mad.viewModels.notif.viewModel.set("noNotifications", false);
                    return mad.common.variables.totalNotifications;
                }


            }
        },
        serverPaging: true,
        pageSize: PAGE_SIZE
        //pageSize: 32                // 2  vidljiva x 4 x 2
    });
    modelz.notifications.online(true);

    // feed model for following - - - - - - - - -
    modelz.feedHistory = new kendo.data.DataSource({
        offlineStorage: "feedHistory",
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/FeedV3/GetFeedForCurrentUser",
                cache: true,
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                    //get requesting page no
                    var pages = this.url.split("?");
                    var page = mad.common.getQueryVariable(pages[1],"page");
                    modelz.commonVars.set("feedPage", page);
                    if (page > 1){
                        //mad.common.showLoader(mad.common.translate("words", "loading"));
                    }
                }
            }
        },
        schema: {
            data: function (data) {
                return data;
            },
            total: function (data) {
                var brojSlogova = data.length;
                if (brojSlogova == 0){
                    return 0;           // drazen - za slucaj da nema podataka treba vratiti 0 inace puca template
                }else{
                    var finishedWorkouts = parseInt(mad.local.loadVariable("NumberOfFinishedWorkouts"));
                    //console.log("total user workouts", finishedWorkouts);
                    return finishedWorkouts
                }
            }
        }, 
        serverPaging: true,
        pageSize: 48              // 3 vidljiva x 3 x 2 = 18
    });
    modelz.feedHistory.online(true);

    // model for leaderboard - - - - - - - - -
    modelz.leaderboard = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/leaderboard/GetLeaderBoardFiltered",
                cache: true,
                data: {
                    IsCurrentUser: function () {
                        return false;
                    },
                    Country: function () {
                        var country = mad.viewModels.leaderboard.viewModel.get("selectedCountry");
                        if (country === "World") {
                            country = "";
                        }
                        return country;
                    },
                    Gender: function () {
                        var gender = mad.viewModels.leaderboard.viewModel.get("selectedGender");
                        if (gender === "Top 10") {
                            gender = "";
                        } else

                        if (gender === "Top 10 Females") {
                            gender = "Female";
                        } else

                        if (gender === "Top 10 Males") {
                            gender = "Male";
                            /*
                        } else

                        if (gender === "Show me") {
                            gender = "Me";
                            */
                        }

                        return gender;
                    }
                },
                beforeSend: function (request) {
                       request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            }
        },
        requestStart: function (e) {
            //mad.common.showLoader(mad.common.translate("words", "loading"));
        },
        requestEnd: function (e) {
            //mad.common.hideLoader();
            if (e.response == undefined) {
                e.response = [];
            }
        },
        error: function (e) {
            //console.log("request error", e.errorThrown);
        },

        schema: {
            data: function (data) {
               
                console.log("data u datasourceu leaderboarda:", data);
                return data;
            },
            total: function (data) {
                var brojSlogova;
                if (data) {
                    brojSlogova = data.length;
                }else{
                    brojSlogova = 0;
                }
                /*
                if (brojSlogova == 0) {
                    mad.viewModels.leaderboard.viewModel.set("noFollowers", true);
                } else {
                    mad.viewModels.leaderboard.viewModel.set("noFollowers", false);
                }
                */

                return brojSlogova;
            }
        },
        serverPaging: false,
        serverSorting: false

    });
    modelz.leaderboard.online(true);


    modelz.leaderboardFollowing = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/leaderboard/GetLeaderBoardCurrentUserFollowing",
                cache: true,
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            }
        },
        requestStart: function (e) {
            //mad.common.showLoader(mad.common.translate("words", "loading"));
        },
        requestEnd: function (e) {
            //mad.common.hideLoader();
            if (e.response == undefined) {
                e.response = [];
            }
        },
        error: function (e) {
            //console.log("request error", e.errorThrown);
        },

        schema: {
            data: function (data) {
                var podaci = [];
                if (data) {
                    podaci = data
                    mad.viewModels.leaderboard.viewModel.set("position", podaci.CurrentUserPosition);
                    mad.viewModels.leaderboard.viewModel.set("total", podaci.Total);
                };
                //mad.viewModels.leaderboard.viewModel.set("selectedCountry", data[0].Country);
                console.log("data u datasourceu leaderboarda following:", podaci);
                return podaci.Data;
            },
            total: function (data) {
                var brojSlogova;
                if (data) {
                    brojSlogova = data.Data.length;
                }else{
                    brojSlogova = 0;
                }
                
                 if (brojSlogova < 2) {
                     mad.viewModels.leaderboard.viewModel.set("noLeaderBoardFollowing", true);
                 } else {
                     mad.viewModels.leaderboard.viewModel.set("noLeaderBoardFollowing", false);
                 }
                 
                return brojSlogova;
            }
        },
        serverPaging: false,
        serverSorting: false

    });
    modelz.leaderboardFollowing.online(true);

    // model for following - - - - - - - - -
    modelz.following = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/follow/GetAllUserWhichUserFollowsPaged",
                cache: true,
                data: {
                    id:  function() {
                        //console.log("user id za following je", mad.common.actualView.params.UserId);
                        return mad.common.actualView.params.UserId;
                    }
                },
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);

                    //get info from request
                    var qs = this.url.split("?");
                    var skip = parseInt(mad.common.getQueryVariable(qs[1],"skip"));
                    modelz.commonVars.set("followingSkipped", skip);

                    // following se mora poslati u opcijama querija
                    var following = mad.common.getQueryVariable(qs[1],"following")
                    // nece ga bit kad se requesta 2. (ili veci) page pa ce se koristiti prethodno postavljena vrijednost
                    if (!mad.common.isNullOrEmpty(following)){
                        modelz.commonVars.set("following", parseInt(following));
                    }
                }
            }
        },
        requestStart: function (e) {
            //mad.common.showLoader(mad.common.translate("words", "loading"));
        },
        requestEnd: function (e) {
            //console.log("following req end")
            //mad.common.hideLoader();
            if (e.response == undefined) {
                e.response = [];
            }
        },
        schema: {
            data: function (data) {
                var podaci = [];
                if (data){podaci = data};
                //console.log("following ds data", podaci);
                return podaci;
            },
            total: function (data) {
                var podatakaZaUcitati = 99, ucitano = 0, ukupnoUcitano = 0;

                if (data) {
                    ucitano = data.length;
                }

                podatakaZaUcitati = modelz.commonVars.get("following");
                ukupnoUcitano = modelz.commonVars.get("followingSkipped") + ucitano;

                if (ucitano < modelz.following.options.pageSize){
                    podatakaZaUcitati = ukupnoUcitano;
                }

                //console.log("following ds total - za ucitati, ucitano, ukupnoUcitano", podatakaZaUcitati, ucitano, ukupnoUcitano);
                return podatakaZaUcitati;
            }
        },
        serverPaging: true,
        pageSize: 64,
        serverSorting: false
    });
    modelz.following.online(true);

    // model for followers - - - - - - - - -
    modelz.followers = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/follow/GetFollowersForUserPaged",
                cache: true,
                data: {
                    id:  function() {
                        //console.log("user id za followers je", mad.common.actualView.params.UserId);
                        return mad.common.actualView.params.UserId;
                    }
                },
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);

                    //get info from request
                    var qs = this.url.split("?");
                    var skip = parseInt(mad.common.getQueryVariable(qs[1],"skip"));
                    modelz.commonVars.set("followingSkipped", skip);

                    // followers se mora poslati u opcijama querija
                    var followers = mad.common.getQueryVariable(qs[1],"followers")
                    // nece ga bit kad se requesta 2. (ili veci) page pa ce se koristiti prethodno postavljena vrijednost
                    if (!mad.common.isNullOrEmpty(followers)){
                        modelz.commonVars.set("followers", parseInt(followers));
                    }

                }
            }
        },
        requestStart: function (e) {
            //mad.common.showLoader(mad.common.translate("words", "loading"));
        },
        requestEnd: function (e) {
            //mad.common.hideLoader();
            if (e.response == undefined) {
                e.response = [];
            }
        },
        schema: {
            data: function (data) {
                var podaci = [];
                if (data){podaci = data};
                //console.log("followers data u datasourceu:", podaci);
                return podaci;
            },
            total: function (data) {
                var  podatakaZaUcitati = 99, ucitano = 0, ukupnoUcitano = 0;

                if (data) {
                    ucitano = data.length;
                }
                podatakaZaUcitati = modelz.commonVars.get("followers");
                ukupnoUcitano = modelz.commonVars.get("followingSkipped") + ucitano;

                if (ucitano < modelz.followers.options.pageSize){
                    podatakaZaUcitati = ukupnoUcitano;
                }

                //console.log("followers ds total - za ucitati, ucitano, ukupnoUcitano", podatakaZaUcitati, ucitano, ukupnoUcitano);
                return podatakaZaUcitati;
            }
        },
        serverPaging: true,
        pageSize: 64,
        serverSorting: false
    });
    modelz.followers.online(true);

    // other user feed model  - - - - - - - - -
    modelz.profileOtherUserFeed = new kendo.data.DataSource({
        offlineStorage: "profileOtherUserFeed",
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/Feed/GetFeedForUser",
                data:
                    {
                     id: function () {
                         return mad.viewModels.otherUserHistory.viewModel.get("UserId");
                    }
                },
                cache: true,
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            }
        },
        requestStart: function (e) {
        //    mad.common.showLoader("loading");
        },

        requestEnd: function (e) {
       //     mad.common.hideLoader();
        },

        change: function(e) {
            var data = this.data();
            //console.log("data on change (profileOtherUserFeed):", data);
            mad.common.hideLoader();
        },

        schema: {
            parse: function(data) {
                $.each(data, function(idx, elem) {
                       elem.Type = "OF";
                });
                return data;
            },

            data: function (data) {
                var podaci = [];
                if (data){podaci = data};
                return podaci;
            },
            total: function (data) {
                var uk = parseInt(mad.viewModels.profileOtherUser.viewModel.user.get("NumberOfFeedItems") );
                return uk;          // max podataka za ucitati
            }
        },
        serverPaging: true,
        //pageSize: PAGE_SIZE
        pageSize: 24
        //pageSize: 32                // 2  vidljiva x 4 x 2
    });
    modelz.profileOtherUserFeed.online(true);

    modelz.Countries = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.root + "/json/Countries.json",
                //url: mad.common.variables.root + "/json/CountriesAllReduced.json",
                dataType: "json"
            }
        },
        change: function(e) {
            var data = this.data();
        }
    });

    modelz.States = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.root + "/json/States.json",
                dataType: "json"
            }
        },
        change: function(e) {
            var data = this.data();
        }
    });

    modelz.tags = new kendo.data.DataSource({
        serverFiltering: false, // <-- Do filtering server-side
        serverPaging: false, // <-- Do paging server-side
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/Routine/Tags",

                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                },

                dataType: "json"
            }
        },
        requestEnd: function (e) {
            //console.log("requestEnd tags")
        },
        schema: {
            parse: function(data) {
                //console.log("parse tags")
                var muscles=["Abs", "Arms", "Back", "Chest", "Legs", "Shoulders"];

                 $.each(data, function(idx, elem) {

                     if (elem.Name == "Beginner friendly") {
                         elem.DisplayName = "Beginner";
                     }else if (elem.Name == "Indoor"){
                         elem.DisplayName = "At home";
                         elem.OrdinalNumber = 7.5;
                     }else{
                         elem.DisplayName = elem.Name;
                     }

                     if ($.inArray(elem.Name, muscles) > -1){
                         elem.type = "muscles"
                     }else{
                         elem.type = "type"
                     }
                 });
                 //console.log("data u datasourceu nakon parse:", data);
                 mad.viewModels.madbarzWorkoutS.viewModel.set("tags", data);
                 mad.local.saveVariableParse("tags",data);
                 return data;
            },
            data: function (data) {
                return data;
            },
            model: {
                id: "RoutineTagId",
                fields: {
                    RoutineTagId: {type: "number"},
                    Name: {type: "string"},
                    Description: {type: "string"},
                    ImageUrl: {type: "string"},
                }
            }
        }
    });

    modelz.routines = new kendo.data.DataSource({
        serverFiltering: false,
        serverPaging: false,
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/Routine/AllRoutinesIncludingProv2",
                beforeSend: function(request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                },
                dataType: "json"
            }
        },
        schema: {
            data: function(data) {
                var podaci = [];
                if (!mad.common.isNullOrEmpty(data)) podaci = data;

                console.log("  x x x - ucitane sve rutine", podaci);
                //mad.viewModels.madbarzWorkoutS.viewModel.set("routines", podaci);
                /*
                mad.viewModels.madbarzRoutines.viewModel.set("routines", podaci);
                mad.viewModels.madbarzRoutines.viewModel.routinesDataSource = kendo.data.DataSource.create({ data:  mad.viewModels.madbarzRoutines.viewModel.get("routines") });
                */
                mad.viewModels.madbarzRoutines.viewModel.routinesDataSource = kendo.data.DataSource.create({ data: podaci });
                mad.viewModels.madbarzRoutines.viewModel.routinesDataSource.group({field: "IsTop"});
                mad.local.saveMadbarzRoutines(podaci);
                console.log("routines saved locally & loaded to routinesDataSource in madbarzRoutines viewModel");
                return podaci;

            },
            total: function(data) {
                return data.length;
            }

        }
    });

    function roughSizeOfObject( object ) {
        var objectList = [];
        var recurse = function( value ) {
            var bytes = 0;

            if ( typeof value === 'boolean' ) {
                bytes = 4;
            } else if ( typeof value === 'string' ) {
                bytes = value.length * 2;
            } else if ( typeof value === 'number' ) {
                bytes = 8;
            } else if (typeof value === 'object'
                && objectList.indexOf( value ) === -1) {
                objectList[ objectList.length ] = value;
                for( i in value ) {
                    bytes+= 8; // assumed existence overhead
                    bytes+= recurse( value[i] )
                }
            }
            return bytes;
        }
        return recurse( object );
    }


    // routines for user progress
    modelz.userRoutines = new kendo.data.DataSource({
        serverPaging: false,
        serverSorting: false,

        transport: {
            read: {
                url:  mad.common.variables.serverUrl + "api/Statistics/GetAllRoutinesUserHasDone",
                beforeSend: function (req) {
                    req.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                },
                dataType: "json",
                //data to send - API requires this, page = 0 means get all data
                data: {
                    page: 0,
                    pageSize: 0,
                    skip: 0,
                    take: 0
                }
            }
        },

        requestStart: function(e) {
            //mad.common.showLoader(mad.common.translate("words", "loading"));
        },
        requestEnd: function (e) {
            //mad.common.hideLoader();
            if (e.response == undefined) {
                e.response = [];
            }
            //console.log("progress - user routines loaded", e.response);
        },
        error: function(e) {
            //console.log("request error", e.errorThrown);
        },
        schema: {
            parse: function(data) {
                $.each(data, function(idx, elem) {
                    elem.Group = "Workout Progress";
                });
                return data;
            },

            data: function (data) {
                return data;
            },
            total: function (data) {
                var brojSlogova = data.length; //console.log("brojSlogova", brojSlogova);

                mad.viewModels.userProgress.viewModel.set("workoutsCount", brojSlogova);

                /* izbaceno jer se kombinira s planovima
                if (brojSlogova == 0){
                    mad.viewModels.userProgress.viewModel.set("noUserProgress", true);
                }else{
                    mad.viewModels.userProgress.viewModel.set("noUserProgress", false);
                }
                */
                return data.length;
            }
        }
    });

    // saved workouts
    modelz.savedWorkouts = new kendo.data.DataSource({
        serverFiltering: false,
        serverPaging: false,
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/Saved/GetSavedWorkoutsAndExercisesBasedOnUsersAccessToPro",
                data: {
                    hasPro: function () {
                        return mad.viewModels.madbarzSavedWorkoutS.viewModel.get("hasPro");
                        
                    },
                },
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                },
                dataType: "json"
            }
        },

        schema: {
            parse: function(data) {
                //console.log("ucitani sejvani", data);
                // create & set createdBy
                $.each(data, function(idx, el) {
                    if (el.UserNameWhoCreatedTrening == mad.common.variables.username) {
                        el.createdBy = "Your Custom Workouts";
                    }else{
                        el.createdBy ="Other";
                    }
                });
                //console.log("ucitani sejvani nakon parse", data);
                return data;
            },
            data: function (data) {
                mad.local.saveSaved(data);
                return data;
            },
            model: {
                id: "RoutineId",
                fields: {
                    RoutineId: {type: "number"},
                    Name: {type: "string"},
                }
            },
            total: function (data) {
                return data.length;
            }
        }
    });

    // exercises for create exercise
    modelz.exercisesDatasource = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/CreateRoutine/GetAllExercisesTest",

                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            }
        },
        serverPaging: false,

        schema: {
            parse: function(data) {
                $.each(data, function(idx, elem) {
                    elem.selectedXtimes = 0;
                    elem.displayTimes = "";
                });
                return data;
            },

            data: function (data) {
                console.log("----------- loaded list of exercises", data);
                //console.log("----------- list of exercises loaded");
                // spremi podatke samo u createWorkoutExercises.viewModel
                mad.viewModels.createWorkoutExercises.viewModel.set("nonFilterData", data);
                mad.viewModels.createWorkoutExercises.viewModel.listOfExercises.data(data);
                mad.viewModels.createWorkoutExercises.viewModel.set("totalNumberOfExercises", data.length);

                //console.log("ucitani exercisei", data);
                return data;
            },
            total: function (data) {
                return data.length;
            }
        }
    });
    modelz.exercisesDatasource.online(true);

    modelz.searchResults = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/Search/SearchUser",
                data:
                    {
                        term: function () {
                            return modelz.commonVars.get("searchTerm");
                        }
                    },
                cache: false,
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            }
        },
        requestStart: function (e) {
            mad.common.showLoader(mad.common.translate("words", "loading"));
        },
        requestEnd: function (e) {
            mad.common.hideLoader();
            if (e.response == undefined) {
                e.response = [];
            }
            //console.log("search loaded", e.response);
        },
        error: function (e) {
            console.log("request error", e.errorThrown);
        },

        schema: {
            /* drazen - ovo je izbaceno jer ce mi nikola pripremiti taj podatak /
            ostavljeno je kao primjer manipulacije podataka nakon responsa
            parse: function(data) {
                // adding a new field IsCurrentUserFollowingThisOne to the received data
                $.each(data, function(idx, elem) {
                    elem.IsCurrentUserFollowingThisOne = mad.viewModels.search.checkFollowing(elem.UserName);
                });
                console.log("data u datasourceu nakon parse:", data);
                return data;
            },
             */

            data: function (data) {
                console.log("data u searchResults datasourceu:", data);
                return data;
            },
            total: function (data) {
                var brojSlogova = data.length; //console.log("brojSlogova", brojSlogova);

                mad.viewModels.search.viewModel.set("usersCount", brojSlogova);

                if (brojSlogova == 0) {
                    mad.viewModels.search.viewModel.set("noUsers", true);
                    mad.viewModels.search.viewModel.set("pillsVisible", true);
                    mad.alerts.info("No one found", "");
                } else {
                    mad.viewModels.search.viewModel.set("noUsers", false);
                    mad.viewModels.search.viewModel.set("pillsVisible", false);
                    //mad.alerts.info(brojSlogova + " found", "");
                }
                return data.length;
            }
        },
        serverPaging: false,
        serverSorting: false
    });
    modelz.searchResults.online(true);

    modelz.searchDiscover = new kendo.data.DataSource({
        offlineStorage: "discovered",
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/Search/SuggestUsersFromMadbarz",
                cache: true,
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            }
        },
        requestEnd: function (e) {
            if (e.response == undefined) {
                e.response = [];
            }
            //console.log("progress - user routines loaded", e.response);
        },

        schema: {
            data: function (data) {
                console.log("data u searchDiscover datasourceu:", data);
                return data;
            },
            total: function (data) {
                var brojSlogova = data.length; //console.log("brojSlogova", brojSlogova);

                mad.viewModels.search.viewModel.set("usersDiscoverCount", brojSlogova);

                if (brojSlogova == 0) {
                    mad.viewModels.search.viewModel.set("noUsersDiscover", true);
                } else {
                    mad.viewModels.search.viewModel.set("noUsersDiscover", false);
                }
                return data.length;
            }
        },
        serverPaging: false,
        serverSorting: false
    });
    modelz.searchDiscover.online(true);

    modelz.searchHot = new kendo.data.DataSource({
        offlineStorage: "hot",
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/Search/GetTrendingUsers",
                cache: true,
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            }
        },
        requestEnd: function (e) {
            if (e.response == undefined) {
                e.response = [];
            }
            console.log("hot loaded", e.response);
        },

        schema: {
            data: function (data) {
                console.log("data u searchHot datasourceu:", data);
                return data;
            },
            total: function (data) {
                var brojSlogova = data.length; //console.log("brojSlogova", brojSlogova);

                mad.viewModels.search.viewModel.set("usersHotCount", brojSlogova);

                if (brojSlogova == 0) {
                    mad.viewModels.search.viewModel.set("noUsersHot", true);
                } else {
                    mad.viewModels.search.viewModel.set("noUsersHot", false);
                }
                return data.length;
            }
        },
        serverPaging: false,
        serverSorting: false
    });
    modelz.searchHot.online(true);

    modelz.currentUser = new kendo.data.DataSource({
        offlineStorage: "currentUser",

        /*
         drazen - todo / ovo je samo podsjetnik da offlineStorage treba radit s lokijem

         offlineStorage: {
             getItem: function() {
                // primjer - use sessionStorage instead of localStorage
                return JSON.parse(sessionStorage.getItem("products-key"));
             },
             setItem: function(item) {
                sessionStorage.setItem("products-key", JSON.stringify(item));
             }
         },
         */

        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/user/GetCurrentUser",
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            }
        },
        requestEnd: function (e) {
            if (e.response == undefined) {
                e.response = [];
            }
            console.log("current user loaded (online)", modelz.currentUser.online(), e.response);
        },
        schema: {
            parse: function(data) {
                var rez=[];
                rez.push(data);
                mad.common.variables.userWorkouts = rez[0].NumberOfWorkouts;
                return rez;
            }
        }
    });
    modelz.currentUser.online(true);

    modelz.workoutsHome = new kendo.data.DataSource({
        offlineStorage: "workoutsHome",
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/WorkoutPlans/GetWorkoutsHome",
               // url: "https://test-madbarz-api.azurewebsites.net/api/WorkoutPlans/GetWorkoutsHome",
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            }
        },
        schema: {
            parse: function(data) {
                var rez=[];
                if (!mad.common.isNullOrEmpty(data)) {                              // ako neceg ima
                    rez.push(data);
                    //console.log("workoutsHome data:", rez);
                } else {                                                              // nije bilo nikakvih podataka - postavi na prazno
                    console.log("workoutsHome data empty");
                }
                return rez;

            }
        },
        serverPaging: false,
        serverSorting: false
    });
    modelz.workoutsHome.online(true);

    // info o svim planovima određene kategorije
    modelz.plansCategory = new kendo.data.DataSource({
        transport: {
            read: {
               url: mad.common.variables.serverUrl + "api/WorkoutPlans/GetAllPlans",
               beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                },
                data: {
                    //group: "pro%2Bsuggested"
                    group: function(){
                        if (window.navigator.simulator === true) {
                            return "pro%2Bsuggested"
                        }else{
                            return "pro+suggested"
                        }
                    }
                }
            },
            dataType: "json"
        },
        schema: {
            data: function (data) {
                var podaci = (!mad.common.isNullOrEmpty(data)) ? data : [];
                console.log("ucitani planovi", podaci);
                mad.viewModels.plans.viewModel.planoviDataSource = kendo.data.DataSource.create({ data:  podaci });
                return podaci;
            }
        },
        serverPaging: false,
        serverSorting: false

    });
    modelz.plansCategory.online(true);

    // info o jednom planu
    modelz.planData = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.serverUrl+ "api/WorkoutPlans/GetPlan",
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                },
                data:
                {
                    id: function () {return  mad.viewModels.plans.viewModel.get("selectedPlan.WorkoutPlanId")}
                }
            },
            dataType: "json"
        },
        schema: {
            data: function (data) {
                if (!mad.common.isNullOrEmpty(data)) {                              // ako neceg ima
                    var rez=[];
                    rez.push(data);
                    //console.log("ucitan aktivni plan u planData", rez);
                    return rez;
                } else {                                                              // nije bilo nikakvih podataka - postavi na prazno
                    return [];
                }
            }
        },
        serverPaging: false,
        serverSorting: false

    });
    modelz.planData.online(true);

    modelz.plansProgressList = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/WorkoutPlans/GetProgressList",
                //url: "https://test-madbarz-api.azurewebsites.net/api/WorkoutPlans/GetProgressList",
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            },
            dataType: "json"
        },
        schema: {
            parse: function(data) {

                console.log("iz plana", data);

                $.each(data, function(idx, elem) {
                    elem.RoutineCreator = "Plan";
                    elem.startedFormated = mad.common.formatedDate(elem.Progress.StartedOn);
                    if (elem.Progress.EndedOn){
                        elem.finishedFormated = mad.common.formatedDate(elem.Progress.EndedOn);
                    }
                    elem.Group = "Workout Plan Progress";

                    /* leveli su popravljeni u backendu al nek ostane za svaki slucaj */
                    if (elem.Level == "Medium"){
                        elem.Level = "Intermediate"
                    }else
                    if (elem.Level == "Hard"){
                        elem.Level = "Advanced"
                    }

                    if (elem.Status == "opened"){
                        elem.Status = "active"
                    }
                });
                return data;
            },

            data: function (data) {
                if (!mad.common.isNullOrEmpty(data)) {                              // ako neceg ima
                    return data;
                } else {                                                              // nije bilo nikakvih podataka - postavi na prazno
                    return [];
                }
            }
        },
        serverPaging: false,
        serverSorting: false

    });
    modelz.plansProgressList.online(true);

    modelz.plansProgress = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/WorkoutPlans/GetProgress",
                //url: "https://test-madbarz-api.azurewebsites.net/api/WorkoutPlans/GetProgress",
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                },
                data:
                {
                    id: function() { return mad.viewModels.userProgress.viewModel.get("selectedWorkoutPlanId")}
                }

            },
            dataType: "json"
        },
        change: function(){
            console.log("plan history loaded");
            mad.viewModels.planStat.viewModel.set("dataLoaded", true);
        },
        schema: {
            data: function (data) {
                if (!mad.common.isNullOrEmpty(data)) {                              // ako neceg ima
                    var rez=[];
                    rez.push(data);
                    return rez;
                } else {                                                              // nije bilo nikakvih podataka - postavi na prazno
                    return [];
                }
            }
        },
        serverPaging: false,
        serverSorting: false

    });
    modelz.plansProgress.online(true);

    modelz.nutritionCategories = new kendo.data.DataSource({
        offlineStorage: "nutritionCategories",

        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/Nutrition/GetCategories",
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            },
            dataType: "json"
        },
        change: function(e) {
            if (this.online()){
                console.log("nutritionCategories loaded from server", this.data());
            }else{
                console.log("nutritionCategories loaded from offlineStorage", this.data());
            }

        },
        schema: {
            data: function (data) {
                if (!mad.common.isNullOrEmpty(data)) {                              // ako neceg ima
                    if (typeof data === 'string') {
                        console.log("nutritionCategories je string");
                        return JSON.parse(data);
                    }else{
                        return data;
                    }
                } else {                                                              // nije bilo nikakvih podataka - postavi na prazno
                    return [];
                }
            }
        },
        serverPaging: false,
        serverSorting: false

    });
    modelz.nutritionCategories.online(true);

    modelz.recepies = new kendo.data.DataSource({
        offlineStorage: "nutritionRecepies",
        transport: {
            read: {
                url: mad.common.variables.serverUrl  + "api/Nutrition/GetRecepies",
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            },
            dataType: "json"
        },
        change: function(e) {
            if (this.online()){
                console.log("recipes loaded from server (change event)", this.data());
            }else{
                console.log("recipes loaded from offlineStorage (change event)", this.data());
            }
            var selected = this.view().length;
            console.log("number of selected", selected);
        },
        schema: {
            data: function (data) {
                if (!mad.common.isNullOrEmpty(data)) {                              // ako neceg ima
                    if (typeof data === 'string') {
                        return JSON.parse(data);
                    }else{
                        return data;
                    }
                } else {                                                              // nije bilo nikakvih podataka - postavi na prazno
                    return [];
                }
            }
        },
        serverPaging: false,
        serverSorting: false

    });
    modelz.recepies.online(true);

    modelz.rules = new kendo.data.DataSource({
        offlineStorage: "nutritionRules",
        transport: {
            read: {
                url: mad.common.variables.serverUrl + "api/Nutrition/GetRules",
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                }
            },
            dataType: "json"
        },
        change: function(e) {
            if (this.online()){
                console.log("rules loaded from server", this.data());
            }else{
                console.log("rules loaded from offlineStorage", this.data());
            }
        },
        schema: {
            data: function (data) {
                if (!mad.common.isNullOrEmpty(data)) {                              // ako neceg ima
                    return data;
                } else {                                                              // nije bilo nikakvih podataka - postavi na prazno
                    return [];
                }
            }
        },
        serverPaging: false,
        serverSorting: false

    });
    modelz.rules.online(true);

    modelz.quotes = new kendo.data.DataSource({
        transport: {
            read: {
                url: mad.common.variables.root + "/json/quotes.json",
            },
            dataType: "json"
        },
        requestEnd: function(e) {
            //console.log("*** quotes na requestEnd", e);
        },
        schema: {
            data: function (data) {
                var podaci = [];
                if (!mad.common.isNullOrEmpty(data)) {                              // ako neceg ima
                    podaci = data;
                    if (typeof podaci === 'string') {
                        podaci = JSON.parse(podaci.replace(/(\r\n|\n|\r)/gm,""));       // ili /\r?\n|\r/g
                    }
                }
                //console.log("*** quotes u schema", podaci);
                //return JSON.parse(podaci);
                return podaci;
            }
        },
        serverPaging: false,
        serverSorting: false

    });
    modelz.quotes.online(true);


})(mad.models); //pass in madbarz namespace