var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.PRO = (function() {
  "use strict";

  var viewModel = kendo.observable({
    common: mad.common.observables,

    init: initView,
    show: showView,
    afterShow: afterShow,
    closeTap: closeTap,
    isButtonEnabled: isButtonEnabled,
    buttonEnabled: true,

    button1Enabled: true,
    button2Enabled: true,
    button3Enabled: true,
    selectionIndex: 1,
    duration: ["1 month", "3 months", "12 months"],
    forPeriod: forPeriod,
    perWeek: perWeek,
    totalPrice: totalPrice,
    isFemale: false,
    isIntroCurrent: isIntroCurrent,
    isPlansCurrent: isPlansCurrent,
    isNutritionCurrent: isNutritionCurrent,
    isUnlimitedCurrent: isUnlimitedCurrent,
    isTransformationsCurrent: isTransformationsCurrent,
    isPaymentCurrent: isPaymentCurrent,

    currentSection: "intro",
    pricesAndroid: ["$9.99", "$24.99", "$59.99"],
    pricesAndroidWeekly: ["$2.29", "$1.91", "$1.15"],
    pricesiOs: ["$12.49", "$36.99", "$88.99"],
    pricesiOsWeekly: ["$2.87", "$2.83", "$1.71"],
    prices: ["$9.99", "$29.99", "$59.99"],
    pricesWeekly: ["$1.42", "$3.57", "$8.57"],
    pricesDecimal: ["7", "17.5", "42"],
    pricesProceedsAndroid: [6.3, 15.74, 37.79],
    pricesProceedsiOs: [8.24, 24.41, 58.73],
    storeType: "iTunes",
    subscriptionProducts: [],
    oneButtonTap: oneButtonTap,
    checkifOnline: checkifOnline,
    origin: "?",
    openToU: openToU,
    openPP: openPP,
    openBilling: openBilling,
    isPlatformAndroid: false
  });

  var scroller, paymentTop;

  function initView(e) {
    var viewID = "#PROexplain";

    paymentTop = $("#payment").offset().top;
    console.log("paymentTop", paymentTop);

    //scroller = e.view.scroller;

    scroller = $("#PROexplain .km-content");

    scroller.scroll(function(e) {
      //var top = parseInt(e.scrollTop);
      var top = scroller.scrollTop();
      //var top = $("#PROexplainContainer").offset().top; isto kao i ovo gore
      console.log("scroll", top);

      if (top > paymentTop - 20) {
        $("#PROexplain .forHide").addClass("hide");
      } else {
        $("#PROexplain .forHide").removeClass("hide");
      }
      updateKruzic(top);
    });
    /*
        scroller.bind("scroll", function(e) {
            var top = parseInt(e.scrollTop);
            //console.log("top", top);
            if (top>2990){
                $("#PROexplain .forHide").addClass("hide");
            }else {
                $("#PROexplain .forHide").removeClass("hide");
            }
            updateKruzic(top);
        });
        */

    $(viewID).kendoTouch({
      filter:
        ".proButtonTest, .payment-dropdown, .subscription-option, .payment-button, .mainContainer, .closeButton, .TOSlink, .PPlink",
      tap: function(e) {
        handleTap(e);
      }
    });
  }

  function updateKruzic(top) {
    var currentSection = "";
    var viewportTop = top;
    var viewportBottom = viewportTop + $(window).height();
    var divHeight = $(window).height();

    var mojKonstr = function(idSekcije) {
      this.top = $("#" + idSekcije).offset().top;
      this.height = $("#" + idSekcije).outerHeight();
      this.bottom = this.top + this.height;
    };

    var intro = new mojKonstr("sectionIntro");
    var plans = new mojKonstr("sectionPlans");
    var nutrition = new mojKonstr("sectionNutrition");
    var unlimited = new mojKonstr("sectionUnlimited");
    var transformations = new mojKonstr("sectionTransformations");
    var payment = new mojKonstr("payment");

    if (intro.top <= 0 && intro.top > -divHeight) {
      currentSection = "intro";
    } else if (plans.top <= 0 && plans.top > -divHeight) {
      currentSection = "plans";
    } else if (nutrition.top <= 0 && nutrition.top > -divHeight) {
      currentSection = "nutrition";
    } else if (unlimited.top <= 0 && unlimited.top > -divHeight) {
      currentSection = "unlimited";
    } else if (transformations.top <= 0 && transformations.top > -divHeight) {
      currentSection = "transformations";
    } else if (payment.top <= 0 && payment.top > -divHeight) {
      currentSection = "payment";
      appsFlyer.trackEvent("Premium sales page - scrolled to payment section");
    }
    viewModel.set("currentSection", currentSection);
  }

  function handleTap(e) {
    e.preventDefault(); // da ne probija

    var element = e.touch.target.context;

    if ($(element).hasClass("proButtonTest")) {
      //scroller.animatedScrollTo(0, -paymentTop); kendo scroll
      scroller.animate(
        {
          scrollTop: paymentTop
        },
        1234
      );
      mad.appsFlyer.trackEvent("Scroll to start now trial clicked");
      mad.facebookAnalytics.trackEvent("Scroll to start now clicked");
    } else if ($(element).hasClass("payment-dropdown")) {
      $("#PROexplain .payment-dropdown-options").addClass("show");
      $("#PROexplain .payment-dropdown-options").removeClass("dropdownHidden");
    } else if ($(element).hasClass("subscription-option")) {
      var ndx = parseInt($(element).attr("data-value"));
      console.log(ndx);
      viewModel.set("selectionIndex", ndx);
      $("#PROexplain .payment-dropdown-options").addClass("dropdownHidden");
      $("#PROexplain .payment-dropdown-options").removeClass("show");
    } else if ($(element).hasClass("mainContainer")) {
      $("#PROexplain .payment-dropdown-options").addClass("dropdownHidden");
      $("#PROexplain .payment-dropdown-options").removeClass("show");
    } else if ($(element).hasClass("payment-button")) {
      subscribe(e);
    } else if ($(element).hasClass("closeButton")) {
      closeTap(e);
    } else if ($(element).hasClass("TOSlink")) {
      openToU(e);
    } else if ($(element).hasClass("PPlink")) {
      openPP(e);
    }
  }

  function showView(e) {
    var origin = e.view.params.origin;
    viewModel.set("origin", origin);

    viewModel.set("isFemale", checkIsFemale());
    viewModel.set("isPlatformAndroid", device.platform == "Android");

    mad.common.setActualView();
    mad.common.addViewToHistory();
    setupView();

    if (
      origin != "document" &&
      origin != "BillingTerms" &&
      origin != "pro" &&
      origin != "ToU" &&
      origin != "PP"
    ) {
      //mad.common.scrollViewToTop();
      scroller.animate(
        {
          scrollTop: 0
        },
        234
      );
    }

    removeAllPreloaders();

    var products = [
      "com.madbarz.madbarzapp.premiumsubs",
      "com.madbarz.madbarzapp.premiumsubs.3m",
      "com.madbarz.madbarzapp.premiumsubs.12m"
    ];

    if (window.navigator.simulator !== true) {
      if (device.platform === "Android") {
        viewModel.set("storeType", "Google Play");
        viewModel.set("prices", viewModel.get("pricesAndroid"));
        viewModel.set("pricesWeekly", viewModel.get("pricesAndroidWeekly"));

        products = [
          "com.madbarz.madbarzapp.premiumsubs",
          "com.madbarz.madbarzapp.premiumsubs.3m",
          "com.madbarz.madbarzapp.premiumsubs.12m_android_higher_price"
        ];
      } else {
        viewModel.set("storeType", "iTunes");
        viewModel.set("prices", viewModel.get("pricesiOs"));
        viewModel.set("pricesWeekly", viewModel.get("pricesiOsWeekly"));
      }

      window.inAppPurchase
        .getProducts(products)
        .then(function(data) {
          var tmpArray = [];
          var tmpPrices = [];
          var tmpPricesWeekly = [];
          _.forEach(data, function(item) {
            tmpArray.push(item);
          });

          var sorted = _.sortBy(tmpArray, function(item) {
            var x = products.indexOf(item.productId);
            return x;
          });

          viewModel.set("subscriptionProducts", sorted);

          var it = 0;
          _.forEach(sorted, function(item) {
            tmpPrices.push(item.price);
            var numOfWeeks = 4.34524;

            if (it === 0) {
              numOfWeeks = 4.34524; // this is for 1 month subscription
            } else if (it === 1) {
              numOfWeeks = 13.0357; // this is for 3 month subs
            } else if (it === 2) {
              numOfWeeks = 52.1429; // this is for 1 year
            } else {
              numOfWeeks = 4.34524;
            }

            var weeklyPrice = convertToWeeklyPrice(item.price, numOfWeeks);
            if (weeklyPrice) {
              tmpPricesWeekly.push(weeklyPrice);
            }

            it++;
          });

          if (tmpPrices.length >= 3) {
            viewModel.set("prices", tmpPrices);
            console.log(tmpPrices);
          }

          if (tmpPricesWeekly.length >= 3) {
            viewModel.set("pricesWeekly", tmpPricesWeekly);
            console.log(tmpPrices);
          }
        })
        .catch(function(err) {
          console.log("Failed to get subscription products: ", err);
        });
    } else {
      viewModel.set("storeType", "SIMULATOR");
    }

    setAllButtonsAsEnabled();

    //mad.googleAnalytics.trackView("PROexplain");
    kendo.bind($(mad.common.$actualViewID), viewModel);
  }

  function afterShow() {
    var viewName = "Pro sales page loaded";
    mad.analyticEvents.track(
      [mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP],
      mad.analyticEvents.categories.MENUSCREEN,
      mad.analyticEvents.types.VIEW,
      viewName,
      null,
      viewName,
      "Screen loaded"
    );

    mad.appsFlyer.trackEvent("PRO sales page loaded");
    mad.facebookAnalytics.trackEvent("PRO sales page loaded");
  }

  function closeTap(e) {
    e.preventDefault(); // da ne probija
    mad.common.goBack();
  }

  function subscribe(e) {
    //var target = e.touch.currentTarget; // za tap
    var target = e.touch.target; // drazen - zbog nove verzije kenda

    var gumb = $(target).attr("data-value");

    //var isEnabled = isButtonEnabled(gumb);
    var isEnabled = isButtonEnabled();

    if (!isEnabled) {
      return;
    }
    removeAllPreloaders();
    setAllButtonsAsDisabled();
    //$("#subscribe" + gumb).addClass("preloader");
    $("#subscribe").addClass("preloader");

    if (window.navigator.simulator === true) {
      alert("ne radi u simulatoru");
      return;
    }

    sendAnalytics(gumb, "Buy subscription button clicked");

    var subscriptionProducts = viewModel.get("subscriptionProducts");

    //if (subscriptionProducts.length < gumb - 1) {
    if (subscriptionProducts.length < gumb) {
      var products = [
        "com.madbarz.madbarzapp.premiumsubs",
        "com.madbarz.madbarzapp.premiumsubs.3m",
        "com.madbarz.madbarzapp.premiumsubs.12m"
      ];

      if (device.platform === "Android") {
        products = [
          "com.madbarz.madbarzapp.premiumsubs",
          "com.madbarz.madbarzapp.premiumsubs.3m",
          "com.madbarz.madbarzapp.premiumsubs.12m_android_higher_price"
        ];
      }

      window.inAppPurchase
        .getProducts(products)
        .then(function(data) {
          if (data.length >= 3) {
            var sorted = _.sortBy(tmpArray, function(item) {
              var x = products.indexOf(item.productId);
              return x;
            });

            //var product = sorted[gumb - 1];
            var product = sorted[gumb];
            purchaseProduct(gumb, product);
          } else {
            setAllButtonsAsEnabled();
            //$("#subscribe" + gumb).removeClass("preloader");
            $("#subscribe").removeClass("preloader");

            mad.alerts.error("There was some error. Please try again");
            return;
          }
        })
        .catch(function(err) {
          setAllButtonsAsEnabled();
          //$("#subscribe" + gumb).removeClass("preloader");
          $("#subscribe").removeClass("preloader");

          console.log(err);
          mad.alerts.error(
            "Could not retrieve product from store, please contact support or try again"
          );

          //  mad.common.hideLoader();
        });
    } else {
      //var product = subscriptionProducts[gumb - 1];
      var product = subscriptionProducts[gumb];
      purchaseProduct(gumb, product);
    }
  }

  function purchaseProduct(gumb, product) {
    console.log("*** PRODUCT:", product);

    var purchaseSubscriptionDeferred = $.Deferred();

    purchaseSubscriptionDeferred
      .then(function(purchaseSuccessful) {
        setAllButtonsAsEnabled();
        //$("#subscribe" + gumb).removeClass("preloader");
        $("#subscribe").removeClass("preloader");

        if (purchaseSuccessful) {
          sendAnalytics(gumb, "Purchase Successful");

          mad.viewModels.popups.viewModel.openModalWindow(
            "buyProSuccess",
            "You are now premium!",
            "Stay sharp and focused!",
            "Nice!"
          );
        } else {
          mad.alerts.error("There was some error. Please try again");
        }
      })
      .fail(function(err) {
        setAllButtonsAsEnabled();
        //$("#subscribe" + gumb).removeClass("preloader");
        $("#subscribe").removeClass("preloader");

        console.log("Purchase could not be completed, reason: ", err);
        mad.alerts.error("There was some error. Please try again");
        return;
      });

    var productCode = "madbarzpro";
    mad.subscriptionService.purchaseSubscription(
      product.productId,
      productCode,
      purchaseSubscriptionDeferred
    );
  }

  /*
function isButtonEnabled(koji) {
    if (koji == 1) {
        return viewModel.get("button1Enabled");
    } else if (koji == 2) {
        return viewModel.get("button2Enabled");
    } else if (koji == 3) {
        return viewModel.get("button3Enabled");
    } else if (koji == 4) {
        return viewModel.get("button4Enabled");
    }
}
    */

  function isButtonEnabled() {
    return viewModel.get("buttonEnabled");
  }

  function setAllButtonsAsDisabled() {
    /*
        viewModel.set("button1Enabled", false);
        viewModel.set("button2Enabled", false);
        viewModel.set("button3Enabled", false);
        viewModel.set("button4Enabled", false);
        */
    viewModel.set("buttonEnabled", false);
  }

  function setAllButtonsAsEnabled() {
    /*
        viewModel.set("button1Enabled", true);
        viewModel.set("button2Enabled", true);
        viewModel.set("button3Enabled", true);
        viewModel.set("button4Enabled", true);
        */
    viewModel.set("buttonEnabled", true);
  }

  function removeAllPreloaders() {
    /*
        $("#subscribe1").removeClass("preloader");
        $("#subscribe2").removeClass("preloader");
        $("#subscribe3").removeClass("preloader");
        $("#subscribe4").removeClass("preloader");
        */
    $("#subscribe").removeClass("preloader");
  }

  function sendAnalytics(gumb, action) {
    var possibleSubscriptions = ["One Month", "Three Months", "Twelve Months"];

    var dataForAnalytics = {
      //"Type": possibleSubscriptions[gumb - 1]
      Type: possibleSubscriptions[gumb]
    };
    mad.analyticEvents.track(
      [
        mad.analyticEvents.services.GA,
        mad.analyticEvents.services.MIXP,
        mad.analyticEvents.services.FB
      ],
      mad.analyticEvents.categories.MAX,
      mad.analyticEvents.types.PURCHASE,
      "Pro sales page - " + action,
      dataForAnalytics,
      "Pro sales page",
      action
    );

    if (action === "Buy subscription button clicked") {
      mad.appsFlyer.trackEvent(
        "Enter free trial button clicked - " + dataForAnalytics.Type
      );
      mad.facebookAnalytics.trackEvent(
        "Enter free trial button clicked - " + dataForAnalytics.Type
      );
    }

    if (action === "Purchase Successful") {
      //mad.facebookAnalytics.trackPurchase(viewModel.get("pricesDecimal")[gumb - 1], "USD");

      var price = viewModel.get("pricesDecimal")[gumb];

      if (device.platform === "Android") {
        price = viewModel.get("pricesProceedsAndroid")[gumb];
      } else {
        price = viewModel.get("pricesProceedsiOs")[gumb];
      }

      try {
        mad.appsFlyer.trackFreeTrialEnter(dataForAnalytics.Type, price);
        mad.facebookAnalytics.trackEvent(
          "Free trial entered - " + dataForAnalytics.Type
        );
      } catch (err) {
        console.log("failed to send data: ", err);
      }
    }
  }

  function convertToWeeklyPrice(price, numOfWeeks) {
    price = price.trim();
    // this is regex matches only numbers, and ',' and '.'
    var regExpr = /[\d,.\s+]*[\d]+/g;
    var priceVaule = regExpr.exec(price)[0];
    var currency = price.replace(priceVaule, "").trim();
    var positionOfCurrencyBasedOnValue = "right"; // whether price was displayed as "HRK 10" - this is left or "10 HRK" - this is right;

    //price did not start with value ie currency is on the right
    if (price.indexOf(priceVaule) > 0) {
      positionOfCurrencyBasedOnValue = "left";
    }

    //we have to check if dot(.) was maybe used as thousand separator instead of comma(,)
    //so we will just replace all the dots with commas
    //(in code  below will fix comma being used as decimal separator)

    priceVaule = priceVaule.replace(".", ",");

    //we have to check if comma (,) is used as decimal separator (instead of dot (.))
    var lastIndexOfComma = priceVaule.lastIndexOf(",");
    // pricevalue.length - 1 - lastIndexOfComma should equal 2 because price always contains 2 decimal places
    if (
      lastIndexOfComma > -1 &&
      priceVaule.length - 1 - lastIndexOfComma === 2
    ) {
      //if this is the case, then ',' must be replaced with '.' as decimal separator
      priceVaule = replaceAt(priceVaule, lastIndexOfComma, ".");
    }

    var priceValueDecimal = window.accounting.unformat(priceVaule);
    var weeklyPriceAsDecimalValue = (priceValueDecimal / numOfWeeks).toFixed(2); // price of subscription per week

    if (positionOfCurrencyBasedOnValue === "left") {
      return accounting.formatMoney(weeklyPriceAsDecimalValue, {
        symbol: currency,
        format: "%s%v"
      });
    } else {
      return accounting.formatMoney(weeklyPriceAsDecimalValue, {
        symbol: currency,
        format: "%v%s"
      });
    }
  }
  function replaceAt(str, index, chr) {
    if (index > str.length - 1) return str;
    return str.substr(0, index) + chr + str.substr(index + 1);
  }

  function oneButtonTap() {
    mad.alerts.error("Buying PRO ..");
    mad.common.goBack();
  }

  function checkifOnline() {
    return this.common.ifOnline();
  }

  function setupView() {
    //mad.common.stretchView();
    mad.common.setResolutionForView(
      parseInt(mad.mobileApp.view().content.width()),
      parseInt(mad.mobileApp.view().content.height())
    );
    mad.common.setLangForView();
  }

  function openToU() {
    mad.mobileApp.navigate("ui/other/ToU.html?origin=pro", "overlay:up");
  }

  function openPP() {
    mad.mobileApp.navigate("ui/other/PP.html?origin=pro", "overlay:up");
  }

  function openBilling() {
    mad.mobileApp.navigate(
      "ui/other/billingTerms.html?origin=pro",
      "overlay:up"
    );
  }

  function forPeriod() {
    return viewModel.get("duration")[viewModel.get("selectionIndex")] + ":";
  }
  function perWeek() {
    return viewModel.get("pricesWeekly")[viewModel.get("selectionIndex")];
  }
  function totalPrice() {
    return viewModel.get("prices")[viewModel.get("selectionIndex")];
  }

  function checkIsFemale() {
    // console.log("comm vars", mad.common.variables);
    return mad.common.variables.gender == "f";
  }

  function isIntroCurrent() {
    return viewModel.get("currentSection") == "intro";
  }
  function isPlansCurrent() {
    return viewModel.get("currentSection") == "plans";
  }
  function isNutritionCurrent() {
    return viewModel.get("currentSection") == "nutrition";
  }
  function isUnlimitedCurrent() {
    return viewModel.get("currentSection") == "unlimited";
  }
  function isTransformationsCurrent() {
    return viewModel.get("currentSection") == "transformations";
  }
  function isPaymentCurrent() {
    return viewModel.get("currentSection") == "payment";
  }

  return {
    viewModel: viewModel
  };
})();
