var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.feed = (function() {
    "use strict";
    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        beforeShow: beforeShow,
        show: showView,
        afterShow: afterShow,
        showUserImage: showUserImage,

        uCanTouchThis: false,

        selectType: selectType,
        selectedType: "V",

        setRespectClass: setRespectClass,
        selectedItem: {},
        openPage: openPage,
        firstTimeHere: false,
        initialDelay: 2000,
        timeLastPull: 0,
        origin: "",
        loadingListData: true,
        noFeedItems: false,
        tooltip: "Find friends",

        removeSelectedItemFromDS: removeSelectedItemFromDS
    });

    var ds = new kendo.data.DataSource({});

    function initView(e) {
        //console.log("FEED init");

        initFeedList();

        var viewID = "#feed";

        viewModel.set("uCanTouchThis", false);

        var scrl = $("#feed-scroller");
        var scroller;

        if (scrl.length) {
            scroller = scrl.data("kendoMobileScroller");
        }else{
            console.log("neka greska s scrollerom - nema ga");
        }

        $(viewID).kendoTouch({
            filter: ".mButton, .selected, .rButton, .arrow_box, .gotoUser, .gotoWorkout, .respectClick, .reklama, .share",
            touchstart: function(e) {
                //console.log("touchstart");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    //console.log("touchstart but canceled")
                    if(scroller){
                        if (scroller.enabled){
                            scroller.disable();
                        }
                    }
                }else{
                    if(scroller){
                        if (!scroller.enabled) {
                            scroller.enable();
                        }
                    }
                }
            },
            tap: function(e) {
                //console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    //console.log("but canceled")
                }else{
                    handleTap(e);
                }
            }
        });

        //viewModel.set("initialDelay", 2345);
        viewModel.set("initialDelay", 333);

        var feedType = mad.local.loadVariable("feedType");

        var numFoll =  mad.local.loadVariable("userNoFollowing");
        var numWkts = mad.local.loadVariable("noOfWorkoutsInFeed");

        if (feedType == ""){
            if (numFoll > 0 && numWkts > 0) {
                ds = mad.models.feedFollowing;
                viewModel.set("selectedType", "Following");
            }else{
                ds = mad.models.feedAll;
                viewModel.set("selectedType", "Live");
            }
            mad.local.saveVariable("feedType", viewModel.get("selectedType"));
        }else{
            viewModel.set("selectedType", feedType);
            if (feedType == "Live") {
                ds = mad.models.feedAll;
            } else if (feedType == "You") {
                ds = mad.models.feedHistory;
            } else if (feedType == "Following") {
                ds = mad.models.feedFollowing;
            }
        }

        var lista = $("#feed-list").data("kendoMobileListView");
        lista.setDataSource(ds);

        prepareMobiscroll();
    }

    function initFeedList() {
        var osjetljivost = 20;
        var detektirajPullNa = 100;
        var lastTop = 0;
        var smjer = "?";

        $("#feed-scroller").kendoMobileScroller({
                pullToRefresh: true,
                pullOffset: detektirajPullNa,
                messages: {
                    pullTemplate: $("#refresh-template").html(),
                    releaseTemplate: $("#refresh-template").html(),
                    refreshTemplate: $("#refresh-template").html()
                },
                pull: function(e) {
                    var scroller = e.sender;
                    var listview = $("#feed-list").data("kendoMobileListView");
                    mad.common.observables.set("totalItemsFeatured", 0);
                    mad.common.observables.set("totalItemsFromFollwoing", 0);
                    mad.common.observables.set("totalItemsFromFeedAll", 0);

                    var atTheMoment = (new Date()).getTime();
                    console.log(atTheMoment - viewModel.timeLastPull);

                    if (atTheMoment - viewModel.timeLastPull > 12345){
                        viewModel.timeLastPull = atTheMoment;
                        listview.dataSource.read()
                            .then(function() {
                                setTimeout(function() {
                                        scroller.animatedScrollTo(0, 0);
                                        scroller.pullHandled();
                                    },
                                    1111);
                            })
                            .fail(function(e) {
                                scroller.animatedScrollTo(0, 0);
                                scroller.pullHandled();
                            });
                    }

                },
                scroll: function(e){
                    var top = parseInt(e.scrollTop);
                    if (top < 0) return;
                    if (Math.abs(top - lastTop) > osjetljivost){
                        if (top > lastTop){
                            smjer = "gore"
                            $(".feed-top").addClass("up");
                        }else{
                            smjer = "dolje"
                            $(".feed-top").removeClass("up");
                        }
                        lastTop = top;
                    }
                }
            }
        );

        $("#feed-list").kendoMobileListView({
            autoBind: false,
            endlessScroll: true,

            template: function(data) {
                var tpl = kendo.template($("#feed-workouts-template").text());
                return tpl(data);
            }
        });
    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var message,
            subject,
            file,
            url;

        var element = e.touch.target;

        if ($(element).hasClass("mButton") || $(element).hasClass("selected")) {
            selectType(e);
        }else if ($(element).hasClass("arrow_box")) {
            hideTooltip();
        }else if ($(element).hasClass("rButton")) {
            inviteUser();
        }else if ($(element).hasClass("reklama")) {
            openPage(e.touch.initialTouch.className);
        }else if ($(element).hasClass("gotoUser") ||
            $(element).hasClass("gotoWorkout") ||
            $(element).hasClass("respectClick")) {
            itemTapped(element);
        }
    }

    function selectType(e) {
        if (viewModel.common.ifOffline()) {
            mad.alerts.realTop0("You are currently offline");
            e.event.stopPropagation();
            return;
        }

        var inst = $("#feedMenu").mobiscroll("getInst");
        //with a little delay because it sometimes closes automatically
        setTimeout(function() {
            inst.show(false, false); // Call the show method with animate & focus
        }, 22);
    }

    function removeSelectedItemFromDS(){
        var listview = $("#feed-list").data("kendoMobileListView");
        var selectedItem = viewModel.get("selectedItem");
        var ds = listview.dataSource;
        ds.remove(selectedItem);
        listview.refresh();
    }

    function itemTapped(element) {

        var listview = $("#feed-list").data("kendoMobileListView");
        var li = element.closest("li");
        var selectedItemData = listview.dataSource.getByUid(li.attr("data-uid"));
        viewModel.set("selectedItem", selectedItemData);

        if (!mad.common.isNullOrEmpty(selectedItemData)) {
            mad.common.handleFeedTap("feed", listview, element, selectedItemData, 0); //parms:origin, listview, tappedElement, selectedItemData, tab
        }else{
            console.log("izgleda da je selected item obrisan u dataSourceu");
        }
    }

    function prepareMobiscroll() {
        var theme = $.mobiscroll.defaults.theme,
            mode = "static",
            display = "bottom",
            lang = "hr";

        var podaci = [// Wheel groups array
            [
                { // Wheel object
                    values: ["Live", "You", "Following"]
                }
            ]
        ];
        $("#feedMenu").mobiscroll({
            theme: theme,
            mode: mode,
            display: display,
            buttons: [],
            lang: lang,
            showLabel: false,
            showInput: false,
            wheels: podaci,
            height: 45,
            rows: 3,
            readonly: false,
            group: false,
            layout: "liquid",
            onShow: function (html, valueText, inst) {

                html.addClass("feedMenuOpened");

                var winH = $(window).height();
                var dialogEl = html.find("[role='dialog']");
                var dialogElHight = dialogEl.height();
                // korigiraj top poziciju
                dialogEl.css({"top": winH - dialogElHight});

            },
            onValueTap: function (item, inst) {
                ds.data([]);

                viewModel.set("selectedType", item.context.textContent);
                mad.local.saveVariable("feedType", item.context.textContent);

                // prepare & fetch data
                if (item.context.textContent == "Live") {
                    mad.common.observables.set("totalItemsFeatured", 0);
                    mad.common.observables.set("totalItemsFromFollwoing", 0);
                    mad.common.observables.set("totalItemsFromFeedAll", 0);
                    ds = mad.models.feedAll;

                } else if (item.context.textContent == "You") {
                    ds = mad.models.feedHistory;
                } else if (item.context.textContent == "Following") {
                    ds = mad.models.feedFollowing;
                }
                inst.hide(false, "set");

                var listview = $("#feed-list").data("kendoMobileListView");
                listview.setDataSource(ds);

                // remove loadMore items on feed
                $("#feed-list .km-load-more.km-scroller-refresh").remove();

                viewModel.set("loadingListData", true);
                ds.online(true);
                doQuery();

            }
        });

    }

    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e) {
        var w, contentHeight;

        var origin = e.view.params.origin;
        console.log("origin", origin);
        viewModel.set("origin", origin);


        if (!(origin == "workoutDetails" || origin == "profileOtherUser" || origin == "profile")) {
            mad.common.observables.set("totalItemsFeatured", 0);
            mad.common.observables.set("totalItemsFromFollwoing", 0);
            mad.common.observables.set("totalItemsFromFeedAll", 0);
        }

        viewModel.set("firstTimeHere", checkTutorial());


        mad.common.setActualView(); mad.common.addViewToHistory("reset");
        contentHeight = mad.common.stretchViewContentToBeElastic();

        // bind viewModel to view
        kendo.bind($(mad.common.$actualViewID), viewModel);

        $("#feed-scroller").css("height", contentHeight);

        w =  $(window).width();    // jquery width
        $("#noFeedItems").css({
            "height": contentHeight,
            "width": w
        });

        

        if (origin == "menu" || origin == "start" || origin == "workoutComment") {
            viewModel.set("loadingListData", true);
            loadFeed();
        }

        if (origin != "menu") {
            // rucno selektiranje taba ako se nije doslo s menija
            mad.common.selectMenuTab("feed");
        }

    }

    function afterShow(e) {
        viewModel.set("uCanTouchThis", true);

        var listview = $("#feed-list").data("kendoMobileListView");
        var page = mad.models.commonVars.get("feedPage");
        var origin = viewModel.get("origin");
        if (origin == "menu" || origin == "start" || origin == "workoutComment") {
            // u ovoj varijanti se vec sve loadalo i refreshalo
        }else{
            if (page == 1){
                listview.refresh();
            }
        }

        mad.appTelemetry.trackPageView("Feed");

        if (viewModel.get("firstTimeHere")) {
            mad.local.appendUsernameTo("visitedFeed", mad.common.variables.username);
        }

        // azuriranje u DOMu jer listview.refresh() to ne radi dobro nakon druge strane

        var selectedItem = mad.viewModels.feed.viewModel.get("selectedItem");

        if (mad.common.isNullOrEmpty(selectedItem.WorkoutId)){
            return  // no selectedItem - exit
        }

        // drazen - komentar / azurira se samo ako ga je bilo
        var commentTxt = $("#commentTxt" + selectedItem.WorkoutId);
        if (commentTxt.length) {
            commentTxt.html(selectedItem.WorkoutComment);
        }

        var respectIcon = $("#respectBtn-F-" + selectedItem.WorkoutId);
        if (selectedItem.HasRespected) {
            respectIcon.removeClass("respect").addClass("respected");
        } else {
            respectIcon.removeClass("respected").addClass("respect");
        }

        mad.common.updateRespectTxt("-F-", selectedItem);
    }

    function hideTooltip(){
        viewModel.set("firstTimeHere", false);
    }

    function checkTutorial() {
        return mad.common.checkTutorial("visitedFeed");
    }

    function inviteUser() {
        mad.mobileApp.navigate("ui/search/search.html?origin=feed");
    }

    function showUserImage(img) {
        return (img != "/img/profile.jpg" &&
                img != "https://madbarzpictures.blob.core.windows.net/madbarzpictures/profile-web-retina.jpg")
            ? img
            : "images/workout-icon.png";
    }

    function setRespectClass(hasResected) {
        if (hasResected) {
            return "respected";
        } else {
            return "respect";
        }
    }

    // -- not in viewModel Context  - - - - - - - - - - - - - - - -

    function loadFeed() {

        ds.online(true);  doQuery();

        //googleAnalytics
        var viewName = "Feed screen loaded";
        mad.googleAnalytics.trackView(viewName);
        mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.FB], mad.analyticEvents.categories.MENUSCREEN, mad.analyticEvents.types.VIEW,
            viewName,
            null,
            viewName,
            "Screen loaded");
    }

    function doQuery() {

        var scroller = $("#feed-scroller");
        var scrollerWidget;

        if (scroller.length) {
            scrollerWidget = scroller.data("kendoMobileScroller");
        }

        var listview = $("#feed-list").data("kendoMobileListView");

        var pSize = 48;
        var options = {
            pageSize: pSize,
            take: pSize,
            skip: 0,
            page: 1
        };

        ds.query(options)
            .then(function(e) {
                if (ds.online() && scroller.length) { // when data fetched when online hide preloader

                    if (ds.data().length == 0){
                        viewModel.set("noFeedItems", true);
                    }else{
                        viewModel.set("noFeedItems", false);
                    }

                    var delay = viewModel.get("initialDelay");
                    console.log("delay", delay);

                    setTimeout(function() {

                        viewModel.set("loadingListData", false);
                        // mora doc iza jer se tek tada vidi
                        // makni tranziciju i stavi opacity na 0
                        var objekt = $(mad.common.$actualViewID + " .animiraj");
                        if (objekt.length){
                            objekt.addClass("notransition");
                            objekt.removeClass("animirano");
                            objekt[0].offsetHeight;         // Trigger a reflow, flushing the CSS changes
                        }

                        setTimeout(function() {
                            listview.refresh();
                        }, 555);

                        viewModel.set("initialDelay", 333);
                        setTimeout(function() {
                            mad.common.fadeIn();
                            scrollerWidget.animatedScrollTo(0, 0);
                        }, 555);
                    }, delay);
                }
            })
            .fail(function(e) {
                console.log("error fetching " + feed, e.statusText);
                mad.alerts.error("Error fetching feed!", "");
            });
    }

    function openPage(what) {
        //var mobDevice = kendo.support.mobileOS.device || "nepoznat";
        var linkJe = "http://madbarz.com/" +
            what +
            "?utm_source=app_android&utm_medium=feed_banner&utm_content=" +
            what +
            "_ad&utm_campaign=" +
            what +
            "_app";
        console.log(linkJe);
        window.open(linkJe, "_system");
    }

    function checkifOnline() {
        return viewModel.common.ifOnline();
    }

    return {
        viewModel: viewModel
    };

}());