var mad = mad || {};

mad.viewModels = mad.viewModels || {};


mad.viewModels.following = (function () {

    "use strict";
    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,
        tabs: getTabs,
        showUserImage: showUserImage,
        selectedTab: -1,
        sameTabFromBeginning: false,
        duration: 222,

        leftButtonAction: leftButtonAction,
        rightButtonAction: gotoDiscover,

        UserName: "",
        UserId: "",

        selectedItem: {},
        selectedListview: {},

        followersCount: 0,
        noFollowers: false,
        noFollowings: false,
        followersDataLoaded: false,
        followingDataLoaded: false,

        NumberOfFollowers: 0,
        NumberOfFollowing: 0,

        origin: "",
        discover: gotoDiscover

    });

    function initView(e){
        console.log("init following -------------------");

        var taboviString = JSON.stringify(mad.glossary.ui.following.tabs[mad.common.observables.languageIndex()].dataSource, mad.common.replacer);
        var taboviJSON = JSON.parse(taboviString);

        // create submenu tabstrip
        var submenuElement = $("#following-submenu").kendoTabStrip({
            dataTextField: "Name",
            dataContentField: "Content",
            animation: false,
            select: function(e) {
                //console.log("select tab",$(e.item).index());
            },
            show: onTabShow,
            activate: onTabActivate
        }).data("kendoTabStrip").setDataSource(taboviJSON);

        initFollowers();
        initFollowing();

    }

    function showView(e){
        console.log("show following ----- -");

        viewModel.set("sameTabFromBeginning", false)
        // assume there is data for list (to have lists generated)
        mad.viewModels.following.viewModel.set("noFollowers", false);
        mad.viewModels.following.viewModel.set("noFollowings", false);
        // no data loaded in the beginning
        viewModel.set("followersDataLoaded", false);
        viewModel.set("followingDataLoaded", false);


        var inputParam = e.view.params.tab, inputParamInt;
        if(!mad.common.isNullOrEmpty(inputParam)){                                    // if there is tab parameter in qs
            inputParamInt = parseInt(inputParam);
            if (inputParamInt == viewModel.get("selectedTab")){
                viewModel.set("sameTabFromBeginning", true);
            }
            viewModel.set("selectedTab", inputParamInt);
        }else{
            console.log("**** missing tab param ***"); return;
        }

        inputParam = e.view.params.origin;
        if(!mad.common.isNullOrEmpty(inputParam)) {                                   // if there is origin parameter in qs
            viewModel.set("origin", inputParam);
        }else{
            console.log("**** missing origin ***"); return;
        }

        inputParam = e.view.params.UserName;
        if(!mad.common.isNullOrEmpty(inputParam)) {                                   // if there is UserName parameter in qs
            viewModel.set("UserName", inputParam);
        }else{
            console.log("**** missing UserName aka displayName ***"); return;
        }

        inputParam = e.view.params.UserId;
        if(!mad.common.isNullOrEmpty(inputParam)) {                                   // if there is UserId parameter in qs
            viewModel.set("UserId", inputParam);
        }else{
            console.log("**** missing UserId ***"); return;
        }

        inputParam = e.view.params.followers;
        if(!mad.common.isNullOrEmpty(inputParam)) {                                   // if there is followers parameter in qs
            viewModel.set("NumberOfFollowers", inputParam);
        }else{
            console.log("**** missing followers ***"); return;
        }

        inputParam = e.view.params.following;
        if(!mad.common.isNullOrEmpty(inputParam)) {                                   // if there is following parameter in qs
            viewModel.set("NumberOfFollowing", inputParam);
        }else{
            console.log("**** missing following ***"); return;
        }

        mad.common.setActualView(); mad.common.addViewToHistory();
        mad.common.stretchView();

        // bind viewModel to view
        kendo.bind($(mad.common.$actualViewID), viewModel);

        // add menu slide line
        mad.common.appendSlideLine();

        // setup submenu tabstrip
        var tabstrip = $(mad.common.$actualViewID + "-submenu").data("kendoTabStrip");
        var selectTab = viewModel.selectedTab == -1 ? 1 : viewModel.selectedTab;
        tabstrip.select(selectTab);     // this will also fetch data first time

        if (viewModel.get("sameTabFromBeginning")){
            console.log("manually handle active tab because it's same as before");
            handleActiveTab();
        }

        setViewTitle (viewModel.get("UserName"));

    }

    function afterShow(e) {
        console.log("after show following --");
        /*
        var selectedTab = viewModel.get("selectedTab");
        if (selectedTab == 0){            // followers tab
            $("#followers-list").data("kendoMobileListView").refresh();  // i refreshaj listu
        } else if (selectedTab == 1) {    // following tab
            $("#following-list").data("kendoMobileListView").refresh();  // i refreshaj listu
        }
        */
    }

    function onTabShow(e){
        console.log("show tab",$(e.item).index());
        //console.log("SHOW item, content", e.item, e.contentElement);

        var tabJe = $(e.item).index();

        var visinaTabova =  $("#following-submenu .k-tabstrip-items").outerHeight(true);
        var contentHeight = parseInt(mad.mobileApp.view().content.height() - visinaTabova );

        if (tabJe == 0) {
            $("#followers-scroller").css("height", contentHeight);
        } else if (tabJe == 1) {
            $("#following-scroller").css("height", contentHeight);
        }
        $(".noOne").css("height", contentHeight);
    }

    function onTabActivate(e){
        console.log("activate tab",$(e.item).index());

        var promise = $.Deferred();
        promise.then(function (success) {
            handleActiveTab();
        }, function (fail) {
            //slide failed
            console.log("slide failed");
        });

        mad.common.handleTabSliding($(e.item), promise);
    }


    function leftButtonAction(e) {
        e.preventDefault(); // da ne probija
        mad.common.goBack();
    }

    function gotoDiscover(e){
        e.preventDefault(); // da ne probija

        mad.mobileApp.navigate("ui/search/search.html?origin=following&tab=" + viewModel.get("selectedTab"));
    }

    function getTabs(){
       return mad.glossary.ui.following.tabs[mad.common.observables.languageIndex()];
    }

    function showUserImage(img) {
        return (img != "/img/profile.jpg" && img != "https://madbarzpictures.blob.core.windows.net/madbarzpictures/profile-web-retina.jpg") ? img : "";
    }

    // -- not in viewModel Context  - - - - - - - - - - - - - - - -
    function setViewTitle(naslov) {
        mad.common.actualView.title = naslov;
        setTimeout(function() {
            mad.common.actualView.header
                .find(".km-navbar")
                .data("kendoMobileNavBar").title(naslov);
        }, 22);
    }

    function handleActiveTab(){
        console.log("handleActiveTab");

        // drazen - ovo je fix / ucini scroller vidljivim jer se gubi ljevo/desno (tabovi)
        var scrollContainerFIX = ($("#followingContainer .k-content.k-state-active"))
        if (scrollContainerFIX){
            scrollContainerFIX.css("-webkit-transform", "translateX(0px)");
        }

        var options = {
            followers: viewModel.get("NumberOfFollowers"),
            following: viewModel.get("NumberOfFollowing"),
            pageSize: 64,
            take: 64,
            skip: 0,
            page: 1
        };

        var selectedTab = viewModel.get("selectedTab");
        var viewName = selectedTab === 0 ? "Followers List" : "Following List";

        if ( selectedTab == 0){            // followers tab
            if (!viewModel.get("followersDataLoaded")){
                mad.models.followers.data([]);  // isprazni datasource

                console.log("brisanje liste");
                $("#followers-list").data("kendoMobileListView").refresh();  // i refreshaj listu

                mad.models.followers.query(options)
                    .then(function(e) {
                        if (mad.models.followers.data().length == 0){
                            mad.viewModels.following.viewModel.set("noFollowers", true);
                        } else {
                            mad.viewModels.following.viewModel.set("noFollowers", false);
                        }
                        var scroller1 = $("#followers-scroller");
                        if (scroller1.length) {
                            console.log("resetiranje skrolera");
                            scroller1.data("kendoMobileScroller").reset();
                        }
                    })
                    .fail(function(e) {
                        console.log("error fetching followers", e.statusText);
                        mad.alerts.error("Error fetching followers!", "");
                    });
                viewModel.set("followersDataLoaded", true);
            }else{
                //$("#followers-list").data("kendoMobileListView").refresh();  // i refreshaj listu
            }

        } else if (selectedTab == 1) {    // following tab
            if (!viewModel.get("followingDataLoaded")) {
                mad.models.following.data([]);  // isprazni datasource
                $("#following-list").data("kendoMobileListView").refresh();  // i refreshaj listu

                mad.models.following.query(options)
                    .then(function (e) {
                        if (mad.models.following.data().length == 0){
                            mad.viewModels.following.viewModel.set("noFollowings", true);
                        } else {
                            mad.viewModels.following.viewModel.set("noFollowings", false);
                        }
                        var scroller1 = $("#following-scroller");
                        if (scroller1.length) {
                            scroller1.data("kendoMobileScroller").reset();
                        }
                    })
                    .fail(function (e) {
                        console.log("error fetching following", e.statusText);
                        mad.alerts.error("Error fetching following!", "");
                    });
                viewModel.set("followingDataLoaded", true);
            }else{
            }
        }
        mad.googleAnalytics.trackView(viewName);
    }

    function initFollowers(){
        $("#followers-scroller").kendoMobileScroller();

        $("#followers-list").kendoMobileListView({
            dataSource: mad.models.followers,
            autoBind: false,
            endlessScroll: true,
            pullToRefresh: false,
            loadMore: false,
            template: function(data) {
                data.type = "FS";
                var tpl = kendo.template($("#followers-list-template").text());
                //console.log("followers ListView - template - list item za", data.DisplayName);
                return tpl(data);
            }
        }).kendoTouch({
            filter: ".gotoUser, .onFollowClick",
            tap: somethingSelected
        });
    }

    function initFollowing() {
        $("#following-scroller").kendoMobileScroller();

        $("#following-list").kendoMobileListView({
            dataSource: mad.models.following,
            autoBind: false,
            endlessScroll: true,
            pullToRefresh: false,
            loadMore: false,
            template: function(data) {
                data.type = "FG";
                var tpl = kendo.template($("#followers-list-template").text());
                //console.log("following ListView - template - list item za", data.DisplayName);
                return tpl(data);
            }
        }).kendoTouch({
            filter: ".gotoUser, .onFollowClick",
            tap: somethingSelected
        });
    }

    function somethingSelected (e){
        e.preventDefault();     // da ne probija

        var listview, otherListview, found ;
        //var tappedElement = $(e.touch.currentTarget);
        var tappedElement = e.touch.target;  // drazen - zbog nove verzije kenda

        var tabJe = mad.viewModels.following.viewModel.get("selectedTab");
        if (tabJe == 0){
            listview = $("#followers-list").data("kendoMobileListView");
            otherListview = $("#following-list").data("kendoMobileListView");
        } else if (tabJe == 1) {
            listview = $("#following-list").data("kendoMobileListView");
            otherListview =$("#followers-list").data("kendoMobileListView");
        }
        var li = tappedElement.closest("li");
        var selectedItem = listview.dataSource.getByUid(li.attr("data-uid"));

        viewModel.set("selectedItem", selectedItem);    // for updating from other models
        viewModel.set("selectedListview", listview);

        if (tappedElement.hasClass("onFollowClick")) {
            found = check(selectedItem, otherListview.dataSource.data());
            if (tabJe == 0){
                /* ako usera od/folovamo na followers listi nece se maknut/dodat na following jer se ne ucitava ponovo */
                viewModel.set("followingDataLoaded", false);
            }
        }

        if (!mad.common.isNullOrEmpty(selectedItem)){
            mad.common.handleFeedTap("following", listview, tappedElement, selectedItem, tabJe);   //parms:origin, listview, tappedElement, selectedItem, tab
        }
    }

    function check(selectedItem, otherList){

        // find & update value in other listview data
        // returns found status

        var found = false;
        var id = selectedItem.Id;
        var value = selectedItem.IsCurrentUserAlreadyFollowing;

        var nadjeno = _.find(otherList, 'Id', id);

        //console.log("find", nadjeno);

        if (nadjeno){
            found = true;
            nadjeno.IsCurrentUserAlreadyFollowing = !value;
        }
        return found;
    }

    return {
        viewModel: viewModel
    };

}());

