var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.notif = (function () {


    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        beforeShow: beforeShow,
        show: showView,
        afterShow: afterShow,

        loadingData: true,

        timeLastPull: 0,
        noNotifications: false,
        uCanTouchThis: false

    });

    var scroller;

    function initView(e) {

        var viewID = "#notifications";
        viewModel.set("uCanTouchThis", false);
        scroller = e.view.scroller;

        $(viewID).kendoTouch({
            filter: ".gotoUser, .gotoWorkout, .gotoComment, .goToTrending, .goToBlog, .goToSale",

            touchstart: function(e) {
                console.log("touchstart");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    //console.log("touchstart but canceled")
                    if(scroller){
                        if (scroller.enabled){
                            scroller.disable();
                        }
                    }
                }else{
                    if(scroller){
                        if (!scroller.enabled) {
                            scroller.enable();
                        }
                    }
                }
            },
            tap: function(e) {
                console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    console.log("but canceled")
                }else{
                    somethingSelected(e);
                }
            }
        });

        scroller.setOptions({
                pullToRefresh: true,
                pullOffset: 100,
                messages: {
                    pullTemplate: $("#refresh-template").html(),
                    releaseTemplate: $("#refresh-template").html(),
                    refreshTemplate: $("#refresh-template").html()
                },
                pull: function(e){
                    var scroller = e.sender;
                    var listview = $("#notifications-list").data("kendoMobileListView");

                    var atTheMoment = (new Date()).getTime();
                    console.log(atTheMoment - viewModel.timeLastPull);

                    if (atTheMoment - viewModel.timeLastPull > 12345) {
                        viewModel.timeLastPull = atTheMoment;

                        listview.dataSource.read()
                            .then(function () {
                                setTimeout(function () {
                                    scroller.animatedScrollTo(0, 0);
                                    scroller.pullHandled();
                                }, 1111)
                            })
                            .fail(function (e) {
                                scroller.animatedScrollTo(0, 0);
                                scroller.pullHandled();
                            });
                    }
                }
            }
        );

        $("#notifications-list").kendoMobileListView({
            dataSource: mad.models.notifications,
            autoBind: false,
            endlessScroll: true,
            template: function (data) {
                var tpl = kendo.template($("#notifications-template").text());
                return tpl(data);
            }
        });
    }

    function somethingSelected(e) {

        e.preventDefault();     // da ne probija

        var listview = $("#notifications-list").data("kendoMobileListView");
        var tappedElement = $(e.touch.target);          //za klik je $(e.target)
        var tab = 0;
        var li = tappedElement.closest("li");
        var selectedItem = listview.dataSource.getByUid(li.attr("data-uid"));

        if (!mad.common.isNullOrEmpty(selectedItem)) {

            if (selectedItem.Type === "Follows" && tappedElement.hasClass("gotoWorkout")) {
                return;
            }
            if (selectedItem.HasBeenRead === false) {
                selectedItem.Status = "read";
                listview.refresh();
                markNotificationAsRead(selectedItem.Id);
            }
            if (selectedItem.Type == "Trending") {
                mad.mobileApp.navigate("ui/search/search.html");                                          // navigate to yours user profile
            } else {
                mad.common.handleFeedTap("notifications", listview, tappedElement, selectedItem, tab);   //parms:origin, listview, tappedElement, selectedItem, tab
            }
        }
    }

    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e) {
        mad.common.setActualView();
        mad.common.addViewToHistory("reset");

        var contentHeight = mad.common.stretchViewContentToBeElastic();
        $("#notificationsContainer .preloaderContainer").css("height", contentHeight);
        $("#notificationsContainer .noNotifications").css("height", contentHeight);

        kendo.bind($(mad.common.$actualViewID), viewModel);

        viewModel.set("loadingData", false);

        var origin = e.view.params.origin;
        console.log("origin", origin);

        if (origin == "menu"){
            viewModel.set("loadingData", true);

            var mainMenu =  mad.common.actualView.footer.find(".km-tabstrip").data("kendoMobileTabStrip");
            mainMenu.badge(3,false);
            loadNotifNum();
            mad.common.variables.unreadNotifications = 0;
            // Set the number of unread notifications on badge (on iOS)
            mad.common.setBadge(mad.common.variables.unreadNotifications);
            mad.models.notifications.online(false);
            doQuery("notifications", mad.models.notifications);
            mad.models.notifications.online(true);
            doQuery("notifications", mad.models.notifications);
        }

        if (origin != "menu") {
            // rucno selektiranje taba ako se nije doslo s menija
            mad.common.selectMenuTab("notifications");
        }
    }

    function afterShow() {
        viewModel.set("uCanTouchThis", true);

        var viewName = "Notification screen loaded";
        mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.FB], mad.analyticEvents.categories.MENUSCREEN, mad.analyticEvents.types.VIEW,
            viewName,
            null,
            viewName,
            "Screen loaded");
    }

    function loadNotifNum(){
        var route = {
            putanja: mad.common.variables.serverUrl + "api/Notifications/GetNumberOfNotifications",
            akcija: "GET"
        };

        mad.data.load(route, {}, false, true)
            .done(function (data) {
                mad.common.variables.totalNotifications =  data;
            })
            .fail(function (x) {
                console.log("fail to load notifications");
                mad.common.variables.totalNotifications = 0;
            });
    }

    function markNotificationAsRead(id) {
        var route = {
            putanja: mad.common.variables.serverUrl + 'api/Notifications/MarkNotificationAsRead',
            akcija: "POST"
        };

        var options = {
            id: id
        };

        mad.data.load(route, options, false, true).done(function (data) {
            if (data.Result) {
                //console.log("Notification read");
            }
        });
    }

    function doQuery(notif, ds) {
        if (!ds.online()){                      // if offline - move down to see preloader
            scroller.animatedScrollTo(0,100);
        }

        var options = {
            pageSize: PAGE_SIZE,
            take: PAGE_SIZE,
            skip: 0,
            page: 1
        };

        scroller.reset();       // go to top

        ds.query(options)
            .then(function (e) {
                if (ds.online()){               // when data fetched when online hide preloader

                    if (mad.models.notifications.data().length === 0) {
                        viewModel.set("noNotifications", true)
                    }else{
                        viewModel.set("noNotifications", false)
                    }
                    viewModel.set("loadingData", false);

                    var listview = $("#notifications-list").data("kendoMobileListView");

                    listview.refresh();
                    setTimeout(function() {
                        scroller.animatedScrollTo(0, 0);
                    }, 222);
                }
            })
            .fail(function (e) {
                console.log("error fetching " + feed, e.statusText);
                viewModel.set("noNotifications", true)
                viewModel.set("loadingData", false);
                mad.alerts.error("Error fetching notifications!", "");
            });
    }

    return {
        viewModel: viewModel
    };

}());