var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.nutritionCategories = (function () {

    "use strict";

    var viewModel = kendo.observable({
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,
        leftButtonAction: mad.common.goBack,

        selectedCategory: {},
        loadedFromServer:false,
        loadedFromMob: false,
        loadData: loadCategories,

        checkifOnline: checkifOnline

    });

    function initView(e) {
        var left = false;
        $("#nutritionCategoriesList").kendoMobileListView({
            dataSource: mad.models.nutritionCategories,
            autoBind: false,
            endlessScroll: false,
            dataBound: function(e) {
                var slicice = $("#nutritionCategoriesList .background");
                if (slicice.length > 0){
                    setTimeout(function () {
                        slicice.addClass("cover");
                    }, 0);
                }

            },
            template: function(data) {
                left = !left;
                data.side = left == true ? "left" : "right";
                var tpl = kendo.template($("#nutrition-categories-template").text());
                var generirano = tpl(data);
                return generirano;
            }
        }).kendoTouch({
            filter: ".gotoCategory",
            tap: somethingSelected
        });

        viewModel.set("loadedFromMob", false);
        viewModel.set("loadedFromServer", false);
    }

    function showView(e) {

        mad.common.setActualView(); mad.common.addViewToHistory();
        mad.common.stretchView();

        var origin = e.view.params.origin;
        console.log("origin",origin);

        if (origin == "nutrition") {
            if (viewModel.get("loadedFromMob") == false){
                // load local categories
                loadCategories("fromMob");
                // start loading recepies from server
                mad.viewModels.categoryContent.viewModel.loadData("fromServer");
            }
        }

        kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    function afterShow() {
        var contentHeight = Math.ceil(mad.mobileApp.view().content.height());

        var scroller1 = $("#nutritionCategoriesContainer .scrollContainer");
        if (scroller1.length) {
            scroller1.css("height", contentHeight);
            $("#nutritionCategoriesList").css("height", contentHeight + 3);
        }

        var viewName = "Nutrition - All recipe categories screen loaded";
        mad.analyticEvents.track([mad.analyticEvents.services.GA], mad.analyticEvents.categories.NUTRITION, mad.analyticEvents.types.VIEW,
            viewName,
            null,
            viewName,
            "Screen loaded");
    }

    function loadCategories(fromWhere){
        console.log("loading categories", fromWhere);

        if (fromWhere == "fromMob"){
            mad.models.nutritionCategories.transport.options.read.url = mad.common.variables.root + "/json/nutritionCategories.json";
        }else{
            mad.models.nutritionCategories.transport.options.read.url = mad.common.variables.serverUrl + "api/Nutrition/GetCategories";
        }
        //console.log("get url",  mad.models.nutritionCategories.transport.options.read.url);

        mad.models.nutritionCategories.read().then(
            function(){                         // read OK (promise finished)
                //mad.common.hideLoader();
                //console.log("nutritionCategories data", mad.models.nutritionCategories.data());
            },
            function(){                         // read failed
                //mad.common.hideLoader();
                console.log("kategorije nisu ucitane")
            }
        )

    }

    function somethingSelected (e){
        e.preventDefault();     // da ne probija

        var listview = $("#nutritionCategoriesList").data("kendoMobileListView");
        var tappedElement = $(e.touch.target);          //za klik je $(e.target)
        var li = tappedElement.closest("li");


        var x = li.attr("data-uid");

        var selectedItem = listview.dataSource.getByUid(x);
        //console.log("selektiran0", selectedItem);
        viewModel.set("selectedCategory", selectedItem);

        if (!mad.common.isNullOrEmpty(selectedItem)){
            mad.common.handleFeedTap("nutritionCategories", listview, tappedElement, selectedItem, 0);   //parms:origin, listview, tappedElement, selectedItem, tab
        }
    }



    function checkifOnline() {
        return this.common.ifOnline();
    }

    return {
        viewModel: viewModel
    };

}());

