var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.categoryContent = (function () {

    "use strict";

    var viewModel = kendo.observable({
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,

        initRecipe: initRecipe,
        showRecipe: showRecipe,
        afterShowRecipe: afterShowRecipe,

        leftButtonAction: mad.common.goBack,

        selectedCategory: {
            field: "CategoryId",
            operator: "eq",
            value: 0
        },
        categoryTitle: "",
        origin: "",
        selectedRecipe: {},
        backImg: "",
        checkifOnline: checkifOnline

    });

    /* for recipe category -  -  -  -  -  -  -  -  -  - */
    function initView(e) {
        $("#categoryContentList").kendoMobileListView({
            dataSource: mad.models.recepies,
            autoBind: false,
            endlessScroll: false,
            dataBound: function(e) {
                var slicice = $("#categoryContentList .image");
                if (slicice.length > 0){
                    setTimeout(function () {
                        slicice.addClass("cover");
                    }, 0);
                }
            },
            template: function(data) {
                var tpl = kendo.template($("#categoryContent-template").text());
                return tpl(data);
            }
        }).kendoTouch({
            filter: ".gotoRecipe",
            tap: somethingSelected
        });
    }

    function showView(e) {
        mad.common.setActualView(); mad.common.addViewToHistory();
        mad.common.stretchView();

        var origin = e.view.params.origin;
        viewModel.set("origin", origin);

        var title = e.view.params.title;
        var id = e.view.params.id;

        viewModel.set("selectedCategory.value", parseInt(id));
        viewModel.set("categoryTitle", title);
        setViewTitle(title);

        if (origin == "nutritionCategories") {
            loadRecepies("fromMob");
        }

        kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    function afterShow() {
        var contentHeight = Math.ceil(mad.mobileApp.view().content.height());

        var scroller1 = $("#categoryContentContainer .scrollContainer");
        if (scroller1.length) {
            scroller1.css("height", contentHeight);

            if (viewModel.get("origin") == "nutritionCategories") {
                scroller1.data("kendoMobileScroller").reset();
            }
        }

        var categoryName = viewModel.get("categoryTitle");
        var data = {
            "Category name": categoryName
        };

        mad.analyticEvents.track([mad.analyticEvents.services.GA], mad.analyticEvents.categories.NUTRITION, mad.analyticEvents.types.VIEW,
            "Nutrition - Recipe Category loaded",
            data,
            "Nutrition",
            "Recipe Category loaded", categoryName);
    }

    function loadRecepies(fromWhere){
        console.log("loading category content (Recepies)", fromWhere);

        if (fromWhere == "fromMob") {
            mad.models.recepies.online(false);
        } else {
            mad.models.recepies.online(true);
        }

        mad.models.recepies.read().then(
            function() { // read OK (promise finished)
                var listview = $("#categoryContentList").data("kendoMobileListView");
                if (!mad.common.isNullOrEmpty(listview)) {
                    console.log("filtriram podatke za listu");
                    listview.dataSource.filter(viewModel.get("selectedCategory"));
                }
            },
            function() { // read failed
                console.log("recepies nisu ucitani")
            }
        );
    }


    function somethingSelected (e){
        e.preventDefault();     // da ne probija

        var listview = $("#categoryContentList").data("kendoMobileListView");
        var tappedElement = $(e.touch.target);          //za klik je $(e.target)
        var li = tappedElement.closest("li");
        var selectedItem = listview.dataSource.getByUid(li.attr("data-uid"));
        if (!mad.common.isNullOrEmpty(selectedItem)){
            viewModel.set("selectedRecipe",selectedItem);
            mad.common.handleFeedTap("categoryContent", listview, tappedElement, selectedItem, 0);   //parms:origin, listview, tappedElement, selectedItem, tab
        }
    }

    /* for recipe -  -  -  -  -  -  -  -  -  - */
    function initRecipe(){
        $("#recipeList").kendoMobileListView();
    }

    function showRecipe(e) {
        mad.common.setActualView(); mad.common.addViewToHistory();
        mad.common.stretchView();

        var origin = e.view.params.origin;
        var title = e.view.params.title;
        var id = e.view.params.id;

        setViewTitle(viewModel.get("categoryTitle"));   // category name

        var url = viewModel.get("selectedRecipe.CoverImage");
        var index = url.lastIndexOf("/");
        var imgName = url.substring(index + 1, url.length);
        var localPath = "images/nutrition/categories/rec/" + imgName;
        viewModel.set("backImg", "url('" + localPath + "')");
    }

    function afterShowRecipe() {
        var contentHeight = Math.ceil(mad.mobileApp.view().content.height());

        var scroller1 = $("#recipeContainer .scrollContainer");
        if (scroller1.length) {
            scroller1.css("height", contentHeight);
            scroller1.data("kendoMobileScroller").reset();
        }

        var recipeName = viewModel.get("selectedRecipe.Title");
        //console.log("NUTRITION - recipe loaded", recipeName);

        var data = {
            "Recipe name": recipeName
        };

        mad.analyticEvents.track([mad.analyticEvents.services.GA], mad.analyticEvents.categories.NUTRITION, mad.analyticEvents.types.VIEW,
            "Nutrition - Recipe Loaded",
            data,
            "Nutrition",
            "Recipe Loaded", recipeName);
    }

    /* common -  -  -  -  -  -  -  -  -  - */
    function checkifOnline() {
        return this.common.ifOnline();
    }

    function setViewTitle(naslov){
        mad.common.actualView.title = naslov;
        setTimeout(function() {
            mad.common.actualView.header
                .find(".km-navbar")
                .data("kendoMobileNavBar").title(naslov);
        }, 22);
    }

    return {
        viewModel: viewModel
    };

}());

