var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.madbarzNutrition = (function() {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,

        online: checkifOnline,

        recipes: recipes,
        rules: rules,
        checkTapped: checkTapped,
        updateNutrition: updateNutrition,
        goPro: buyPRO,

        hasNutritionDetected: false,
        hasSelectedProgramDetected: false,
        hasNutrition: false,
        hasSelectedProgram: false,
        enableSelectProgramButton: false,

        harmonikaOtvorena: false,

        rulesNoData: true,
        loadRules: loadRules,
        loadCategories: loadCategories,
        loadRecipes: loadRecipes,

        origin: "?"
    });


    function loadRules(fromWhere){
        console.log("loading rules", fromWhere);

        if (fromWhere == "fromMob"){
            mad.models.rules.online(false);
        }else{
            mad.models.rules.online(true);
        }

        mad.models.rules.read().then(
            function() { // read OK (promise finished)
                // rules ucitani
                if (mad.common.actualViewID == "madbarzNutrition"){ // ako smo na nutritionu renderiraj
                    generateRules();
                }
            },
            function() { // read failed
                console.log("rules nisu ucitani");
            }
        );
    }

    function loadCategories(fromWhere){
        console.log("loading categories", fromWhere);
        /*
        if (fromWhere == "fromMob"){
            mad.models.nutritionCategories.transport.options.read.url = mad.common.variables.root + "/json/nutritionCategories.json";
        }else{
            mad.models.nutritionCategories.transport.options.read.url = mad.common.variables.serverUrl + "api/Nutrition/GetCategories";
        }
        */
        //console.log("get url",  mad.models.nutritionCategories.transport.options.read.url);

        if (fromWhere == "fromMob"){
            mad.models.nutritionCategories.online(false);
        }else{
            mad.models.nutritionCategories.online(true);
        }

        mad.models.nutritionCategories.read().then(
            function(){                         // read OK (promise finished)
                //console.log("kategorije ucitane")
            },
            function(){                         // read failed
                console.log("kategorije nisu ucitane")
            }
        )
    }

    function loadRecipes(fromWhere){
        console.log("loading Recepies", fromWhere);

        if (fromWhere == "fromMob") {
            mad.models.recepies.online(false);
        } else {
            mad.models.recepies.online(true);
        }

        mad.models.recepies.read().then(
            function() { // read OK (promise finished)
                //console.log("recepti ucitani")
            },
            function() { // read failed
                console.log("recepti nisu ucitani")
            }
        );
    }

    function generateRules(){
        var rulesContainer = $("#rulesData");
        if (mad.models.rules.data().length > 0 && rulesContainer.length > 0) {
            viewModel.set("rulesNoData", false);
            generateRulesContent();
        }else{
            viewModel.set("rulesNoData", true);
            generateRulesEmptyContent();
        }
    }

    function generateRulesContent(){
        var template = kendo.template($("#nutrition-rules-template").html(), { useWithBlock: false });
        var result = template(mad.models.rules.data());        //Pass the data to the compiled template
        $("#rulesData").html(result);
        $(".harmonika").kendoMobileCollapsible({
            inset: true,
            iconPosition: "top",
            collapseIcon: "arrow-up",
            expandIcon: "arrow-down",
            expand: function(e){
                console.log("ekspand",e);

                viewModel.set("harmonikaOtvorena", true);

                var that = this;
                var otvoreni = $("#rulesData .harmonika.km-expanded");
                if (otvoreni.length){
                    otvoreni.data("kendoMobileCollapsible").collapse();
                }
                console.log("of", that.content.context.offsetTop);
                var topH = $("#nutritionMenu .menuContainer").height();
                var of = that.content.context.offsetTop - topH;

                $("#nutritionRulesContainer .scrollContainer").data("kendoMobileScroller").animatedScrollTo(0, -of);
                setTimeout(function() {
                    that.content.css({
                        height: "auto"
                    });
                    console.log("st", that.content.position().top);
                },11);
            },
            collapse: function(){
                console.log("collapse");
                viewModel.set("harmonikaOtvorena", false);
            }

        });
    }

    function generateRulesEmptyContent(){
        $("#rulesData").html("Loading ...");
    }

    function checkifOnline() {
        return viewModel.common.ifOnline();
    }


    function initView(e) {

        $("#menuButtongroup").kendoMobileButtonGroup({
            select: function(e) {
                var odabran = e.index;
                console.log("odabran", odabran);
                menuOptionSelected(odabran)
            }
        });

        var left = false;
        $("#nutritionCategoriesList").kendoMobileListView({
            dataSource: mad.models.nutritionCategories,
            autoBind: false,
            endlessScroll: false,
            dataBound: function(e) {
                var slicice = $("#nutritionCategoriesList .background");
                if (slicice.length > 0){
                    setTimeout(function () {
                        slicice.addClass("cover");
                    }, 0);
                }

            },
            template: function(data) {
                left = !left;
                data.side = left == true ? "left" : "right";
                var tpl = kendo.template($("#nutrition-categories-template").text());
                var generirano = tpl(data);
                return generirano;
            }
        }).kendoTouch({
            filter: ".gotoCategory",
            tap: somethingSelected
        });
    }

    function menuOptionSelected(odabran){
        if (odabran == 0) {
            console.log("selektirana pravila");
            $("#nutritionRulesContainer").removeClass("hidden");
            $("#nutritionCategoriesContainer").addClass("hidden");
        }else if (odabran == 1){
            console.log("selektirani recepti");
            $("#nutritionCategoriesContainer").removeClass("hidden");
            $("#nutritionRulesContainer").addClass("hidden");
        }
    }

    function somethingSelected (e){
        e.preventDefault();     // da ne probija

        var listview = $("#nutritionCategoriesList").data("kendoMobileListView");
        var tappedElement = $(e.touch.target);          //za klik je $(e.target)
        var li = tappedElement.closest("li");
        var x = li.attr("data-uid");
        var selectedItem = listview.dataSource.getByUid(x);
        viewModel.set("selectedCategory", selectedItem);

        if (!mad.common.isNullOrEmpty(selectedItem)){
            mad.common.handleFeedTap("nutritionCategories", listview, tappedElement, selectedItem, 0);   //parms:origin, listview, tappedElement, selectedItem, tab
        }
    }

    function showView(e) {
        var origin = e.view.params.origin;
        viewModel.set("origin", origin);

        mad.common.setActualView();

        viewModel.set("hasNutritionDetected", false);
        viewModel.set("hasSelectedProgramDetected", false);

        mad.common.addViewToHistory("reset");

        mad.common.stretchView();

        kendo.bind($(mad.common.$actualViewID), viewModel);

        if (origin == "menu") {
            checkNutrition();
            loadRules("fromMob");
            loadCategories("fromMob");

            // odabir recepata - default
            var odaberi = 1;
            var buttongroup = $("#menuButtongroup").data("kendoMobileButtonGroup");
            buttongroup.select(odaberi);
            menuOptionSelected(odaberi);
        }else{
            viewModel.set("hasNutritionDetected", true);
            viewModel.set("hasSelectedProgramDetected", true);
        }

        if (origin != "menu") {
            // rucno selektiranje taba ako se nije doslo s menija
            mad.common.selectMenuTab("nutrition");
        }
    }

    function afterShow(e) {
        var visinaPilula = 0;
        var contentHeight = Math.ceil(mad.mobileApp.view().content.height() - visinaPilula);
        $(".scrollerElement").css("height", contentHeight);
        $(".scrollContainer").css("height", contentHeight);
        $("#nutritionMenu .section").css("height", contentHeight);
        $(".nutritionContent").css("height", contentHeight + 3);

        mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.FB], mad.analyticEvents.categories.NUTRITION, mad.analyticEvents.types.VIEW,
            "Nutrition screen loaded",
            null,
            "Nutrition screen loaded",
            "Screen loaded");
    }

    function buyPRO(e) {
        e.preventDefault();     // da ne probija

        mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP, mad.analyticEvents.services.FB], mad.analyticEvents.categories.NUTRITION, mad.analyticEvents.types.EVENT,
            "Nutrition - Learn more clicked",
            null,
            "Nutrition",
            "Learn more clicked");
        mad.appsFlyer.trackEvent("Nutrition - Learn more clicked");

        mad.mobileApp.navigate("ui/PRO/explain.html", "overlay:up");

    }

    function recipes() {
        mad.mobileApp.navigate("ui/nutrition/categories.html?origin=nutrition");
    }

    function rules() {
        mad.mobileApp.navigate("ui/nutrition/rules.html?origin=nutrition");
    }


    // here we check 2 things, firstly whether user  has access to nutrition
    // and if he has, has he selected which Nutrition guide to follow
    function checkNutrition() {
        console.log("checkin' nutrition");

        viewModel.set("hasNutrition", false);

        // init stuff
        viewModel.set("hasSelectedProgram", false);
        viewModel.set("enableSelectProgramButton", false);

        var cekajNutritionType = $.Deferred();

        //we have to check which nutrition type user has bought
        cekajNutritionType.then(
           function (nutritionType) {

               // test - nutritionType = 3;

               if (mad.common.isNullOrEmpty(nutritionType) || nutritionType === 3) {
                   console.log("no selected nutrition guide type");
                   viewModel.set("hasSelectedProgram", false);
                   viewModel.set("enableSelectProgramButton", true);
                   viewModel.set("hasSelectedProgramDetected", true);
               } else {
                   console.log("user has selected (0=fat, 1=muscle, 2=both)", nutritionType);
                   viewModel.set("hasSelectedProgram", true);
                   viewModel.set("enableSelectProgramButton", true);
                   viewModel.set("hasSelectedProgramDetected", true);
               }
           },
           function (fail) {
               console.log("checkNutritionType failed !!");
               viewModel.set("hasSelectedProgramDetected", false);

           });

        // firstly we check if user has access to nutrition 
        //because he could have bought it on the web

        if (mad.common.variables.HasUserNutrition === true) {
            //okay user has nutrition
            viewModel.set("hasNutrition", true);
            viewModel.set("hasNutritionDetected", true);

            //now we have to check if user has selected any nutirtion guide to follow
            checkNutritionType(cekajNutritionType);
        } else {
            // user didn't buy nutrition on the web so we need to check if he has subscription
            var hasUserAccessToNutirionPromise = $.Deferred();

            hasUserAccessToNutirionPromise.then(
                function(success) {
                    if (success) { // ako ima access to pro
                        console.log("user has access to pro");
                        viewModel.set("hasNutrition", true);
                        viewModel.set("hasNutritionDetected", true);
                        checkNutritionType(cekajNutritionType); // vidi ima li odabran koji program
                    } else {
                        console.log("user nema access to pro");
                        viewModel.set("hasNutritionDetected", true);
                        // prikazuje se link na nutrition sales page
                    }
                },
                function(fail) {
                    console.log("hasUserAccessToPro failed !!");
                    viewModel.set("hasNutritionDetected", true);
                });

            //check if user has access to pro or not
            mad.common.hasUserAccessToPro(hasUserAccessToNutirionPromise);
        }
    }

    function checkNutritionType(deferred) {
        console.log("checkin' nutrition type");

        var link = mad.common.variables.serverUrl + "api/Nutrition/CheckActiveNutritionType";
        mad.data.post({ putanja: link, akcija: "POST" })
            .done(function(data, textStatus, jqXHR) {
                //console.log("podaci za nutrition", data);
                deferred.resolve(data);
            })
            .fail(function(jqXHR, textStatus, errorThrown) {
                console.log("checkNutritionType", textStatus, errorThrown);
                deferred.resolve(null);
            });

    }

    function checkTapped(e) {
        console.log("touchstart");
        if (viewModel.get("enableSelectProgramButton") == false) {
            console.log("touchstart canceled");
            e.sender.cancel();
        }
    }

    function updateNutrition(e) {
        if (this.common.ifOffline()) {
            mad.alerts.realTop0(mad.common.translate("words", "offline"));
            return;
        }

        viewModel.set("enableSelectProgramButton", false);

        var target = e.touch.currentTarget; // za tap
        var type = parseInt($(target).attr("data-type"));

        var link   = {putanja : mad.common.variables.serverUrl + "api/nutrition/UpdateNutritionType", akcija : "POST"};
        var podaci = {
            Type: type
        };

        mad.data.post(link, podaci)
            .done(function(data) {
                viewModel.set("enableSelectProgramButton", true);
                console.log("UpdateUserNutrition successful", data);
                checkNutrition();
            })
            .fail(function(e, r, t) {
                viewModel.set("enableSelectProgramButton", true);
                console.log("UpdateUserNutrition UNsuccessful", e, r, t);
                mad.alerts.error("Error");
            });
    }

    return {
        viewModel: viewModel
    };
}());