var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.nutritionRules = (function () {

    "use strict";

    var viewModel = kendo.observable({
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,

        leftButtonAction: mad.common.goBack,

        harmonikaOtvorena: false,

        loadedFromServer:false,
        noData: true,
        loadData: loadRules

    });

    function initView(e) {
    }

    function showView(e) {
        console.log("show");
        mad.common.setActualView(); mad.common.addViewToHistory();
        mad.common.stretchView();

        var origin = e.view.params.origin;

        if (origin == "nutrition") {
            if (viewModel.get("loadedFromServer") == false){
                loadRules("fromMob");
            }else{
                generate();
            }
        }

        kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    function afterShow() {
        console.log("after show");
        var contentHeight = Math.ceil(mad.mobileApp.view().content.height());
        var scroller1 = $("#nutritionRulesContainer .scrollContainer");
        if (scroller1.length) {
            scroller1.css("height", contentHeight);
        }
    }

    function loadRules(fromWhere){
        console.log("loading rules", fromWhere);

        if (fromWhere == "fromMob"){
            mad.models.rules.online(false);
        }else{
            mad.models.rules.online(true);
        }

        mad.models.rules.read().then(
            function() { // read OK (promise finished)
                generate();
            },
            function() { // read failed
                console.log("rules nisu ucitani");
            }
        );
    }

    function generate(){
        var rulesContainer = $("#rulesData");
        if (mad.models.rules.data().length > 0 && rulesContainer.length > 0) {
            viewModel.set("noData", false);
            generateContent();
        }else{
            viewModel.set("noData", true);
            generateEmptyContent();
        }
    }

    function generateContent(){
        var template = kendo.template($("#nutrition-rules-template").html(), { useWithBlock: false });
        var result = template(mad.models.rules.data());        //Pass the data to the compiled template
        $("#rulesData").html(result);
        $(".harmonika").kendoMobileCollapsible({
            inset: true,
            iconPosition: "top",
            collapseIcon: "arrow-up",
            expandIcon: "arrow-down",
            expand: function(){
                console.log("ekspand");

                viewModel.set("harmonikaOtvorena", true);

                var that = this;
                var otvoreni = $("#rulesData .harmonika.km-expanded");
                if (otvoreni.length){
                    otvoreni.data("kendoMobileCollapsible").collapse();
                }
                console.log("of", that.content.context.offsetTop);
                $("#nutritionRulesContainer .scrollContainer").data("kendoMobileScroller").animatedScrollTo(0, -that.content.context.offsetTop);
                setTimeout(function() {
                    that.content.css({
                        height: "auto"
                    });
                    console.log("st", that.content.position().top);
                },11);
            },
            collapse: function(){
                console.log("collapse");
                viewModel.set("harmonikaOtvorena", false);
            }

        });
    }

    function generateEmptyContent(){
        $("#rulesData").html("Loading ...");
    }

    return {
        viewModel: viewModel
    };

}());

