var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.OTPactivation = (function () {

   "use strict";

   var viewModel = kendo.observable({ 
       // properties or functions we want to observe and expose to html
       common: mad.common.observables,

       init: initView,
       show: showView,
       afterShow: afterShow,

       titlePressed: mad.common.titlePressed,

       isButtonVisibleL: true,
       enableIfOfflineL: true,
       leftButtonAction: leftButtonAction,

       isButtonVisibleR: true,
       enableIfOfflineR: true,
       rightButtonAction: rightButtonAction,

       dropDownOpened: false,

   });

    function initView(e){
        console.log("contact init");
    }

    function showView(e){
        console.log("contact show");
        var that = this;                                // all methods & properties of viewModel
        mad.common.setActualView(); mad.common.addViewToHistory(); setupView();

        kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    function afterShow(e){
    }

    function leftButtonAction(e){
        e.preventDefault(); // da ne probija
        // automatically close the keyboard on iOS
        document.activeElement.blur();
        mad.common.goBack();
    }

    function rightButtonAction(e){
        // send
        e.preventDefault(); // da ne probija

        var messageValue = $('#OTPcode').val();
        if (messageValue == "") {
            mad.alerts.info("Please enter your activation code","");
            return null;
        }

        mad.common.showBusyLoader("Sending");

        var link   = {putanja : mad.common.variables.serverUrl + "api/payment/ActivateOtpDeal", akcija : "GET"};
        //var link   = {putanja : mad.common.serverUrl + "api/payment/ActivateOtpDeal", akcija : "GET"};

        var podaci = {
            code: messageValue
        };

        mad.data.post(link, podaci)
            .done(function (data) {
                mad.common.hideLoader();
                $('#OTPcode').val("");
                document.activeElement.blur();
                 
                mad.viewModels.popups.viewModel.openModalWindow("nextPart", "Congratulations!", "You have successfully unlocked workout program!", "Take me to my program");

                mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP, mad.analyticEvents.services.FB], mad.analyticEvents.categories.MAX, mad.analyticEvents.types.EVENT,
                    "OTP plan activated",
                    {},
                    "OTP plan activated",
                    "");
            })
            .fail(function (qXHR) {
                mad.common.hideLoader();
                $('#OTPcode').val("");
                // automatically close the keyboard on iOS
                document.activeElement.blur();

                console.log("Error sending OTP", qXHR);
                var odgovor = qXHR.responseText;
                var poruka = JSON.parse(odgovor);
                mad.alerts.error(poruka.Message);
            });
    }

    // -- not in viewModel Context  - - - - - - - - - - - - - - - -
    function setupView(){
        mad.common.stretchView();
        mad.common.setResolutionForView(parseInt(mad.mobileApp.view().content.width()), parseInt(mad.mobileApp.view().content.height()));
    }

    return {
        viewModel: viewModel
    };

}());

