var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.videoExerciseList = (function () {

    "use strict";

//    var ds;
    var data;

    var videos = new kendo.data.DataSource({
        data: []
    });

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,

        titlePressed: mad.common.titlePressed,

        isButtonVisibleL: true,
        enableIfOfflineL: true,
        leftButtonAction: leftButtonAction,

        isButtonVisibleR: false,
        enableIfOfflineR: false,
        rightButtonAction: null,

        noExerciseVideos: false,
        folderName: "mdbrzvideo" //,
        //data: []

    });

    function initView(e) {
        console.log("exercise video list init");
        initExerciseVideosList();
    }

    function showView(e) {
        console.log("exercise video list show");
        mad.common.setActualView(); mad.common.addViewToHistory(); setupView();

        // clear previous data (if any)
        var list =  $("#exerciseVideoList-list").data("kendoMobileListView");
        if (list) {
            list.dataSource.data([]);
        }

        getExericseVideos();
    }

    function afterShow(e) {
        //console.log("after show contact");
    }

    function leftButtonAction() {
        mad.common.goBack();
    }

    function initExerciseVideosList() {
        console.log("#idem inicjalzirati liset");
        $("#exerciseVideoList-scroller").kendoMobileScroller();

        var list =  $("#exerciseVideoList-list").kendoMobileListView({
            dataSource: mad.viewModels.videoExerciseList.videos,
            autoBind: true,
            template: function (data) {
                var tpl = kendo.template($("#exericseVideoList-list-template").text());
                return tpl(data);
            },
            endlessScroll: false,
            dataBound: postaviSirine,

        }).kendoTouch({
            filter: ".delete",
            tap: navigate,
            enableSwipe: false
        });
    }

    function postaviSirine(e){
        //console.log("data bounded",e);
        var contentWidth  = parseInt(mad.mobileApp.view().content.width());
        $("#exerciseVideoList-list .exercise-item").css("width", contentWidth);
    }

    function navigate(e) {
        var element = e.touch.target;
        var uidElement = element.closest("li");
        //var selectedItem = ds.getByUid(uidElement.attr("data-uid"));
        var selectedItem = mad.viewModels.videoExerciseList.videos.getByUid(uidElement.attr("data-uid"));

        //console.log(selectedItem);

        if ($(element).hasClass("delete")) {
            var msg = mad.glossary.messages.sure,
                language = mad.common.observables.languageIndex();
            navigator.notification.confirm(
                msg.message[language],
                function(button) {
                    if (button == 1) { // if yes
                        var file = data[selectedItem.id];
                        file.remove(function(parameters) {
                            mad.viewModels.videoExerciseList.videos.remove(selectedItem);
                            mad.alerts.success("Done");
                        }, function(err) {
                            mad.alerts.error0("Error deleting video. " + err.code);
                        });
                    }
                },
                msg.title[language], [msg.button1[language], msg.button2[language]]);

        }
    }

// -- not in viewModel Context  - - - - - - - - - - - - - - - -
    function setupView() {
        mad.common.stretchView();
        mad.common.setActualViewTitle();
        mad.common.setResolutionForView(parseInt(mad.mobileApp.view().content.width()), parseInt(mad.mobileApp.view().content.height()));
        mad.common.setLangForView();
    }

    function getExericseVideos() {
        getFilesystem(function (fileSystem) {
            console.log("gotFS");
            getFolder(fileSystem, viewModel.get("folderName"), function (folder) {
                console.log("got folded");
                var directoryReader = folder.createReader();
                console.log(directoryReader);

                directoryReader.readEntries(function (list) {
                    if (list.length <= 0) {
                        viewModel.set("noExerciseVideos", true);
                    } else {
                        viewModel.set("noExerciseVideos", false);

                    }


                    data = list;
                    console.log("data je", data);


                    for (var i = 0; i < list.length; i++) {
                        var obj = {
                            id: i,
                            name: list[i].name.substring(0, list[i].name.lastIndexOf('.')).replace(/-/g, ' '),
                            uri: list[i].fullPath
                        };
                        console.log(obj);
                        mad.viewModels.videoExerciseList.videos.add(obj);
                    }


                }, function (err) {
                    $("#videoExerciseListList").append('<li><span>' + err.code + '</span></li>');

                });

            }, function () {
                console.log("failed to get folder");
            });

            kendo.bind($(mad.common.$actualViewID), viewModel);


        },
         function () {
             console.log("failed to get filesystem");
         });
    }

    function getFilesystem(success, fail) {
        window.requestFileSystem = window.requestFileSystem || window.webkitRequestFileSystem;
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, success, fail);
    }

    function getFolder(fileSystem, folderName, success, fail) {
        fileSystem.root.getDirectory(folderName, { create: true, exclusive: false }, success, fail);
    }

    return {
        viewModel: viewModel,
        videos: videos
    };

}());

