var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.contact = (function () {

   "use strict";

   var viewModel = kendo.observable({ 
       // properties or functions we want to observe and expose to html
       common: mad.common.observables,

       init: initView,
       show: showView,
       afterShow: afterShow,

       titlePressed: mad.common.titlePressed,

       isButtonVisibleL: true,
       enableIfOfflineL: true,
       leftButtonAction: leftButtonAction,

       isButtonVisibleR: true,
       enableIfOfflineR: true,
       rightButtonAction: rightButtonAction,

       dropDownOpened: false,

   });

    function initView(e){
        console.log("contact init");
    }

    function showView(e){
        console.log("contact show");
        var that = this;                                // all methods & properties of viewModel
        mad.common.setActualView(); mad.common.addViewToHistory(); setupView();

        kendo.bind($(mad.common.$actualViewID), viewModel);

        $("#contactUsDropDownList").kendoDropDownList({
            open: function(e) {
                console.log("opened");
                viewModel.set("dropDownOpened", true);
            },
            close: function(e) {
                console.log("closed");
                viewModel.set("dropDownOpened", false);
            }
        });

    }

    function afterShow(e){
    }

    function leftButtonAction(e){
        e.preventDefault(); // da ne probija
        // automatically close the keyboard on iOS
        document.activeElement.blur();
        mad.common.goBack();
    }

    function rightButtonAction(e){
        // send
        e.preventDefault(); // da ne probija

        var messageValue = $('#contactUs #message').val();
        if (messageValue == "") {
            mad.alerts.info("Please enter message","");
            return null;
        }

        mad.common.showBusyLoader("Sending");

        var subject = $("#contactUsDropDownList").data("kendoDropDownList").value();
        var levelRange = ["?", "?", "Beginner", "Intermediate", "Advanced"];
        var userLevel = levelRange[mad.viewModels.settings.viewModel.get("user.FitnessLevel")];    //must be 2,3 or 4
        var ver = (version) ? version : "?";

        /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/user/PostFeedback";
        mad.common.variables.forAjax.akcija = "POST";
        var dataToSend = {
            Feedback: messageValue,
            Type: subject,
            Level: userLevel,
            Device_model: device.model,
            Device_platform: device.platform,
            Device_version: device.version,
            AppVersion: ver
        };
        mad.common.variables.dataOptions = dataToSend;
        */
        var link   = {putanja : mad.common.variables.serverUrl + "api/user/PostFeedback", akcija : "POST"};
        var podaci = {
            Feedback: messageValue,
            Type: subject,
            Level: userLevel,
            Device_model: device.model,
            Device_platform: device.platform,
            Device_version: device.version,
            AppVersion: ver
        };

        mad.data.post(link, podaci)
            .done(function (data) {
                mad.common.hideLoader();
                console.log('feedback sent', data);
                mad.alerts.success(mad.glossary.messages.thanksMessage[mad.common.observables.languageIndex()]);
            })
            .fail(function (qXHR, textStatus, errorThrown) {
                mad.common.hideLoader();
                console.log("Error sending feedback", textStatus, qXHR);
                mad.alerts.error(mad.glossary.messages.errorSendingFeedback[mad.common.observables.languageIndex()]);
            });

        $('#contactUs #message').val("");
        $("#contactUsDropDownList").data("kendoDropDownList").value("Other");
        // automatically close the keyboard on iOS
        document.activeElement.blur();

    }

    // -- not in viewModel Context  - - - - - - - - - - - - - - - -
    function setupView(){
        mad.common.stretchView();
        mad.common.setActualViewTitle();
        mad.common.setResolutionForView(parseInt(mad.mobileApp.view().content.width()), parseInt(mad.mobileApp.view().content.height()));
        mad.common.setLangForView();

    };

    return {
        viewModel: viewModel
    };

}());

