var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.editPhoto = (function() {

    "use strict";

    var viewModel = kendo.observable({
        common: mad.common.observables,
        rotateLeft: rotateLeft,
        rotateRight: rotateRight,
        resetCropper: resetCropper,
        closePhotoModal: closePhotoModal,
        savePicture: savePicture,
        originalPic: "",
        coords: null,
        editModalOpened: false,
        prepareMobiscroll: prepareMobiscroll
    });

    var cropperObj = {};
    var cropperObjOriginal = {};
    var dimensions = {};            // new image dimensions & ratio - considering device & original dimensions
    var imageCurrentHeight = 0;     // this will be height of cropped image
    var actions;

    function prepareMobiscroll() {
        var theme = $.mobiscroll.defaults.theme,
            mode = "static",
            display = "bottom",
            lang = "hr";

        var uploadInst;

        if (mad.common.actualViewID == "madbarzWorkoutStat" || mad.common.actualViewID == "planWorkoutStat"){
            actions = [[{values: ["Edit photo", "Upload new"]}]];
        }else{
            actions = [[{values: ["Edit photo", "Upload new", "View photo"]}]];
        }

        $(".actionsheetphotosource").mobiscroll({
            theme: theme,
            mode: mode,
            display: display,
            buttons: [],
            lang: lang,
            showLabel: false,
            showInput: false,
            wheels: actions,
            height: 45,
            //rows: 3,
            rows: actions[0][0].values.length,
            readonly: false,
            group: false,
            layout: "liquid",
            onShow: function(html, valueText, inst) {
                html.addClass("editPhoto");
                var winH = $(window).height();
                var dialogEl = html.find("[role='dialog']");
                var dialogElHight = dialogEl.height();
                dialogEl.css({"top": winH - dialogElHight});    // korigiraj top poziciju
            },
            onValueTap: function(item, inst) {
                if (item.context.textContent == "Edit photo") {
                    onEditPictureSelect();
                } else if (item.context.textContent == "Upload new") {
                    uploadInst = $(".actionsheetphotoupload").mobiscroll("getInst");
                    setTimeout(function() {uploadInst.show(false, false);}, 22);
                } else if (item.context.textContent == "View photo") {
                    $("#profile-user-img img").addClass("biggerPhoto");
                    $("#workoutsMenu .image").addClass("biggerPhoto");
                }
                inst.hide(false, "set");
            }
        });

        var podaci;
        if (mad.common.actualViewID == "workoutDetails"){
            podaci = [[{values: ["Camera", "Gallery", "Remove"]}]];
        }else{
            podaci = [[{values: ["Camera", "Gallery"]}]];
        }


        $(".actionsheetphotoupload").mobiscroll({
            theme: theme,
            mode: mode,
            display: display,
            buttons: [],
            lang: lang,
            showLabel: false,
            showInput: false,
            wheels: podaci,
            height: 45,
            //rows: 2,
            rows: podaci[0][0].values.length,
            readonly: false,
            group: false,
            layout: "liquid",
            onShow: function(html, valueText, inst) {
                html.addClass("editPhoto");
                var winH = $(window).height();
                var dialogEl = html.find("[role='dialog']");
                var dialogElHight = dialogEl.height();
                dialogEl.css({"top": winH - dialogElHight});    // korigiraj top poziciju
            },
            onValueTap: function(item, inst) {
                if (item.context.textContent == "Camera") {
                    getProfilePic(Camera.PictureSourceType.CAMERA);
                } else if (item.context.textContent == "Gallery") {
                    getProfilePic(Camera.PictureSourceType.PHOTOLIBRARY);
                } else if (item.context.textContent == "Remove") {
                    mad.viewModels.workoutDetails.viewModel.removeWorkoutDetailsPhoto();
                }
                inst.hide(false, "set");
            },
            onClose: function(valueText, botun, inst) {
                console.log("close s botunom", botun);
            }
        });
    }

    function getProfilePic(galType) {
        // dohvati fotku s kamere ili iz galerije
        navigator.camera.getPicture(pictureTakenOrSelected, onFail,
            {
                quality: 90,
                sourceType: galType,
                destinationType: Camera.DestinationType.FILE_URI,
                encodingType: Camera.EncodingType.JPEG,
                correctOrientation: true,
                allowEdit: false
            });

        function pictureTakenOrSelected(imageData) {
            pictureSelected(imageData);

            if (mad.common.actualViewID != "madbarzWorkoutStat" && mad.common.actualViewID != "planWorkoutStat"){
                // za editiranje na profilu i meniju
                doUpload(imageData);
            }
        }

        function doUpload(imageData){
            var options = new FileUploadOptions();
            options.fileKey = "file";
            options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
            options.headers = { "Authorization": "Bearer " + mad.loginToken };
            options.mimeType = "image/jpeg";
            options.params = {}; // if we need to send parameters to the server request
            var ft = new FileTransfer();

            mad.common.showBusyLoader("Uploading");

            ft.upload(imageData, encodeURI(mad.common.variables.serverUrl + "api/user/UploadImageV2"),
                function (data) {
                    //navigator.camera.cleanup();         //za fotke s kamere na iOSu
                    mad.common.hideLoader();
                },
                function(err) {
                    //navigator.camera.cleanup();         //za fotke s kamere na iOSu
                    mad.common.hideLoader();
                    console.log("Failed", err);
                    mad.alerts.error("Image not uploaded");
                }, options);
        }

        function onFail(message) {
            //navigator.camera.cleanup();         //za fotke s kamere na iOSu
            console.log("get picture fail");
            mad.common.hideLoader();
            $("#editPictureModal").kendoMobileModalView("close");
            $("#editPictureModal").addClass("hidden");
            viewModel.set("editModalOpened", false);
        }
    }

    function onEditPictureSelect(e) {

        var photoToEdit, loadedData;

        if (mad.common.actualViewID == "profile"){
            if (mad.viewModels.profile.viewModel.user.ProfilePhotoBig == null ||
                typeof mad.viewModels.profile.viewModel.user.ProfilePhotoBig == "undefined" ||
                mad.viewModels.profile.viewModel.user.ProfilePhotoBig == "/images/photo.png") {
                photoToEdit = "images/photo.png";
            } else {
                mad.common.showBusyLoader();
                photoToEdit = mad.viewModels.profile.viewModel.user.ProfilePhotoBig;
            }
            pictureSelected(photoToEdit);

        }else if (mad.common.actualViewID == "workoutsMenu"){
            // load again ProfilePhotoBig
            if (viewModel.common.ifOnline()) {
                mad.common.showBusyLoader();
                mad.models.currentUser.online(true);
                mad.models.currentUser.read()
                    .then(function() {
                        loadedData = mad.models.currentUser.data();
                        photoToEdit = loadedData[0].ProfilePhotoBig;
                        pictureSelected(photoToEdit);
                    })
                    .fail(function() {
                        mad.common.hideLoader();
                        console.log("user nije ucitan");
                        mad.alerts.realTop0("Error loading profile photo");
                    });
            } else {
                mad.alerts.realTop0("You are currently offline");
            }
        }else if (mad.common.actualViewID == "madbarzWorkoutStat" || mad.common.actualViewID == "planWorkoutStat"){
            // drazen - pocni od originalno spremljene slike
            photoToEdit = viewModel.get("originalPic");
            pictureSelected(photoToEdit);
        }
    }

    function pictureSelected(pic){

        // drazen - kad je slika odabrana spremi je kao original
        viewModel.set("originalPic", pic);

        $("#editPictureModal").data("kendoMobileModalView").open();

        var h =  $(window).height();
        var w =  $(window).width();

        $("#editPictureModal").css({"height": h, "width": w});
        $("#imgContainer").css({"height": h, "width": w});

        $("#editPictureModal").removeClass("hidden");

        viewModel.set("editModalOpened", true);

        $("#settingsImageTocrop").attr("src", pic);
        $("#settingsImageTocrop").one("load", function() {
            scaleImage();
        });
    }

    function scaleImage() {

        var orignalHeight = $("#settingsImageTocrop")[0].naturalHeight;
        var originalWidth = $("#settingsImageTocrop")[0].naturalWidth;

        dimensions = newImgDimensions(originalWidth, orignalHeight);

        $("#settingsImageTocrop")[0].height = dimensions.height;

        mad.common.hideLoader();

        setTimeout(function () {
            var objekt = $("#imgContainer.animiraj");
            objekt.addClass("animirano");
        }, 22);

        if ($.isFunction($("<canvas>")[0].getContext)){
            // ako je podrzan canvas
            if (mad.common.actualViewID == "madbarzWorkoutStat" || mad.common.actualViewID == "planWorkoutStat" || mad.common.actualViewID == "workoutDetails"){
                assignCropperToImg();
            }else{
                shrinkAndAssignCropper();  // pozovi stvarno smanjivanje slike
            }
        }else{
            assignCropperToImg();
        }
    }

    function shrinkAndAssignCropper(){
        // smanjivanje na max velicinu koliko stane na mob

        var canvas, ctx, dataURL;

        canvas = $("<canvas>")[0];
        canvas.width = dimensions.width;
        canvas.height = dimensions.height;
        ctx = canvas.getContext("2d");
        ctx.drawImage($("#settingsImageTocrop")[0], 0, 0, dimensions.width, dimensions.height);

        dataURL = canvas.toDataURL('image/jpeg', 0.5);

        $("#settingsImageTocrop").attr("src", dataURL);  // i vrati umjesto originalne kako bi cropper radio s manjom fotkom

        $("#settingsImageTocrop").one("load", function() {
            console.log("smaller img loaded");
            setTimeout(function () {
                assignCropperToImg();
            }, 22);
        });
    }

    function assignCropperToImg(){

        console.log("-cropper assigned");

        var image;
        var editPhoto = mad.viewModels.editPhoto;

        image = document.getElementById('settingsImageTocrop');

        editPhoto.cropperObj = new Cropper(image, {
            aspectRatio: 1,
            viewMode: 1,
            minCanvasWidth: 120,
            minCanvasHeight: 120,
            minCropBoxWidth: 80,
            minCropBoxHeight: 80,
            movable: false,
            scalable: false,
            rotatable: false,
            zoomable: false,
            modal: true,
            background: true,
            autoCrop: true,
            autoCropArea: 0.8,
            wheelZoomRatio: 0.1,
            zoomOnWheel: false,
            zoomOnTouch: true,
            ready: function () {
                this.cropper.reset();
                console.log("-cropper ready", this.cropper);
            },
            /*
            cropend: function (e){
                var data = e.detail;
                var maxHeight = this.cropper.getCanvasData().height;
                if(data.height < 256 && data.height < maxHeight){
                    var cropbox = this.cropper.getCropBoxData();
                    cropbox.width += 1;
                    cropbox.height += 1;
                    console.log("w/h manje od 256, cropbox w/h", cropbox.width );
                    this.cropper.setCropBoxData(cropbox);
                }

            },
            */
            cropend: function (e) {
                console.log("cropend", e);
                var maxHeight = this.cropper.getCanvasData().height;
                var cropbox = this.cropper.getCropBoxData();
                if(imageCurrentHeight < 256){
                    console.log("manje od 256");
                    var minCropboxH = 256 * dimensions.ratio;
                    console.log("minCropboxH, maxHeight", minCropboxH, maxHeight);

                    if (minCropboxH < maxHeight){
                        cropbox.width = minCropboxH;
                        cropbox.height = minCropboxH;
                        console.log("postavljen cropbox");
                    }else {
                        cropbox.width = maxHeight;
                        cropbox.height = maxHeight;
                        console.log("cropbox se ne moze vise povecati")
                    }
                    this.cropper.setCropBoxData(cropbox);
                }
                console.log("croppanje / imageCurrentHeight, cropbox.width, widthPrekoCropboxa", imageCurrentHeight, cropbox.width, cropbox.width / dimensions.ratio);

            },
            crop: function(e) {
                //console.log("crop", e);

                var data = e.detail;

                imageCurrentHeight = data.height;

                // use ratio used for resizing big image to reflect cropper position on small image
                data.x /= dimensions.ratio;
                data.y /= dimensions.ratio;
                data.width /= dimensions.ratio;
                data.height /= dimensions.ratio;
                viewModel.coords = data;

            }
        });
    }

    function newImgDimensions(imageWidth, imageHeight) {
        var footerHeight = 0;
        var avaliableHeight = window.innerHeight - footerHeight;
        var avaliableWidth = window.innerWidth;
        var scaleRatioHeight = avaliableHeight / imageHeight;
        var scaleRatioWidth = avaliableWidth / imageWidth;
        var scaleRatio = scaleRatioWidth < scaleRatioHeight ? scaleRatioWidth : scaleRatioHeight;
        var iWidth = parseInt(imageWidth * scaleRatio);
        var iHeight = parseInt(imageHeight * scaleRatio);
        return { width: iWidth, height: iHeight, ratio: scaleRatio, ratioW: scaleRatioWidth, ratioH: scaleRatioHeight};
    }

    function rotateLeft(e){
        e.preventDefault();
        mad.viewModels.editPhoto.cropperObj.rotate(-5);
    }

    function rotateRight(e){
        e.preventDefault();
        mad.viewModels.editPhoto.cropperObj.rotate(5);
    }

    function resetCropper(e){
        e.preventDefault();
        mad.viewModels.editPhoto.cropperObj.reset();
    }

    function closePhotoModal(e) {
        removeCropper();
        $("#editPictureModal").data("kendoMobileModalView").close();
        $("#editPictureModal").addClass("hidden");

        viewModel.set("editModalOpened",false);
    }

    function savePicture(e){
        var originalCropBoxData, cropana;

        if (mad.common.actualViewID == "madbarzWorkoutStat"|| mad.common.actualViewID == "planWorkoutStat") {
            console.log("spremanje fotke");

            originalCropBoxData = mad.viewModels.editPhoto.cropperObj.getCropBoxData();
            console.log("originalCropBoxData", originalCropBoxData, dimensions.ratio);

            // use ratio used for resizing big image to reflect cropper position on small image and use it back for original image size
            originalCropBoxData.left /= dimensions.ratio;
            originalCropBoxData.top /= dimensions.ratio;
            originalCropBoxData.width /= dimensions.ratio;
            originalCropBoxData.height /= dimensions.ratio;
            originalCropBoxData.width = parseInt(originalCropBoxData.width);
            originalCropBoxData.height = parseInt(originalCropBoxData.height);

            console.log("originalCropBoxData nakon", originalCropBoxData, dimensions.ratio);

            if (mad.common.actualViewID == "madbarzWorkoutStat") {
                mad.viewModels.workoutStat.viewModel.set("takenPhotoInfo", originalCropBoxData);
            }else{  // za planWorkoutStat
                mad.viewModels.planWorkoutStat.viewModel.set("takenPhotoInfo", originalCropBoxData);
            }

            // cropanje s umanjenom slikom ili originalon ako je result screen
            cropana = mad.viewModels.editPhoto.cropperObj.getCroppedCanvas({
                imageSmoothingEnabled: false,
                imageSmoothingQuality: 'high'
            }).toDataURL('image/jpeg');

            if (mad.common.actualViewID == "madbarzWorkoutStat") {
                mad.viewModels.workoutStat.viewModel.set("takenPhoto", cropana);
            }else{  // za planWorkoutStat
                mad.viewModels.planWorkoutStat.viewModel.set("takenPhoto", cropana);
            }

            removeCropper();

            $("#editPictureModal").kendoMobileModalView("close");
            $("#editPictureModal").addClass("hidden");
            viewModel.set("editModalOpened", false);

            if (mad.common.actualViewID == "madbarzWorkoutStat") {
                mad.viewModels.workoutStat.viewModel.set("photoNotTaken", false);
            }else{  // za planWorkoutStat
                mad.viewModels.planWorkoutStat.viewModel.set("photoNotTaken", false);
            }

            mad.common.animate();

        }else if (mad.common.actualViewID == "workoutDetails"){
            console.log("spremanje fotke");

            originalCropBoxData = mad.viewModels.editPhoto.cropperObj.getCropBoxData();
            console.log("originalCropBoxData", originalCropBoxData);

            // use ratio used for resizing big image to reflect cropper position on small image and use it back for original image size
            originalCropBoxData.left /= dimensions.ratio;
            originalCropBoxData.top /= dimensions.ratio;
            originalCropBoxData.width /= dimensions.ratio;
            originalCropBoxData.height /= dimensions.ratio;
            originalCropBoxData.width = parseInt(originalCropBoxData.width);
            originalCropBoxData.height = parseInt(originalCropBoxData.height);

            console.log("originalCropBoxData nakon", originalCropBoxData);
            mad.viewModels.workoutDetails.viewModel.set("takenPhotoInfo", originalCropBoxData);

            // cropanje s umanjenom slikom ili originalon ako je result screen
            cropana = mad.viewModels.editPhoto.cropperObj.getCroppedCanvas({
                imageSmoothingEnabled: false,
                imageSmoothingQuality: 'high'
            }).toDataURL('image/jpeg');

            mad.viewModels.workoutDetails.viewModel.set("takenPhoto", cropana);

            mad.viewModels.workoutDetails.viewModel.addWorkoutDetailsPhoto();

            removeCropper();

            $("#editPictureModal").kendoMobileModalView("close");
            $("#editPictureModal").addClass("hidden");
            viewModel.set("editModalOpened", false);

            //mad.viewModels.workoutStat.viewModel.set("photoNotTaken", false);
            mad.common.animate();


        }else{
            closeAndUpload();   // za profilnu i onu na meniju
        }
    }

    function closeAndUpload() {
        var k = viewModel.get("coords");

        var imageSaved = $.Deferred();

        mad.common.showBusyLoader("Sending");

        /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/user/UploadCroped";
        mad.common.variables.forAjax.akcija = "POST";
        var dataToSend = {
            H: k.height,
            W: k.width,
            X: k.x,
            X2: 0,
            Y: k.y,
            Y2: 0
        };
        mad.common.variables.dataOptions = dataToSend;
        */

        var link   = {putanja : mad.common.variables.serverUrl + "api/user/UploadCroped", akcija : "POST"};
        var podaci = {
            H: k.height,
            W: k.width,
            X: k.x,
            X2: 0,
            Y: k.y,
            Y2: 0
        };

        mad.data.post(link, podaci)
            .done(function (data) {
                mad.common.hideLoader();

                removeCropper();

                $("#editPictureModal").kendoMobileModalView("close");
                $("#editPictureModal").addClass("hidden");

                viewModel.set("editModalOpened",false);

                mad.common.saveBase64ImagePromise(imageSaved, "ProfilePhoto", data);

                imageSaved.then(function(){
                    if (mad.common.actualViewID == "profile"){
                        mad.viewModels.profile.viewModel.loadUser();
                    }else if (mad.common.actualViewID == "workoutsMenu"){
                        var fotka = $("#workoutsMenuContainer .imgContainer .image");
                        var kamera = $(".km-icon.km-camera");

                        var newImgLink = mad.common.getCachedImage("ProfilePhoto");

                        if (!mad.common.isNullOrEmpty(newImgLink)){
                            fotka.css('background-image', 'url("' + newImgLink + '")');
                            kamera.css('opacity', 0);
                        }else{
                            fotka.css('background-image', '');
                            kamera.css('opacity', 1);
                        }
                    }
                }).fail(function(){
                    mad.alerts.error("error saving image");
                });

            })
            .fail(function(qXHR, textStatus, errorThrown) {
                mad.common.hideLoader();

                removeCropper();

                $("#editPictureModal").kendoMobileModalView("close");
                $("#editPictureModal").addClass("hidden");

                viewModel.set("editModalOpened",false);

                console.log("Error uploading img", textStatus, qXHR);
                mad.alerts.error(mad.glossary.messages.notUploaded[mad.common.observables.languageIndex()]);
            });
    }

    function removeCropper(){
        var image = document.getElementById('settingsImageTocrop');
        image.cropper.destroy();
    }

    return {
        viewModel: viewModel,
        cropperObj: cropperObj  // drazen - ne treba exportat
    };

}());