var mad = mad || {};

mad.viewModels = mad.viewModels || {};


mad.viewModels.login = (function () {

   // "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,

        isButtonVisibleL: true,
        prev: back,

        checkEnter: checkEnter,
        passVisible: true,
        showHide: showHide,
        login: login,
        fbLogin: fbLogin,

        mode: "login",

        getUsernamePlaceholder: getUsernamePlaceholder,
        getPasswordPlaceholder: getPasswordPlaceholder,
        forgotTxt: forgotTxt,
        forgot: forgot,

        username: "",
        password: "",

        titlePressed: mad.common.titlePressed
    });

    function initView(e){
        console.log("init login -------------------");
        viewModel.set("passVisible", true);
    }

    function showView(e){
        console.log("show login ----- -");

        mad.common.setActualView(); mad.common.addViewToHistory(); setupView();

        viewModel.set("mode", "login");

        viewModel.set("username","");
        viewModel.set("password","");

        var template = kendo.template($("#login-template").html());
        var templateData = template(viewModel); //Execute the template
        $("#login-list").html(templateData);

        showHidePass();

        kendo.bind($(mad.common.$actualViewID), viewModel);

        // assign events for immediate input fields change
        /*
        $('#uName').on('input',function(e){
            viewModel.set('username',$(this).val())
        });

        $('#uPass').on('input',function(e){
            viewModel.set('password',$(this).val())
        });
        */
        // assign events for input fields change & when loses focus
        $('#uName').on('change',function(e){
            viewModel.set('username',$(this).val())
            console.log("name changed to", $(this).val());
        });

        $('#uPass').on('change',function(e){
            viewModel.set('password',$(this).val())
            console.log("pass changed to", $(this).val());
        });
    }

    function afterShow(e) {
        mad.googleAnalytics.trackView("Login");
        mad.appTelemetry.trackPageView("Login");
    }

    function checkEnter(e){

        var nam, pwd;

        //console.log("input changed", e);

        if (e.keyCode == 13) {

            $(e.target).blur();

            nam = viewModel.get("username");
            pwd = viewModel.get("password");

            console.log("name", nam);

            if (viewModel.get("mode") == "login") {
                if (nam.length == 0 || pwd.length == 0) {
                    mad.alerts.topCenterE("You must enter both fields!");
                }else{
                    login();
                }
            }else{
                if (nam.length == 0) {
                    mad.alerts.topCenterE("Please, enter your eMail !");
                }else{
                    forgotPass();
                }
            }
        }

    }

    function back() {
        mad.mobileApp.navigate("ui/other/start.html", "slide:right");
    }

    function fbLogin(){

        mad.common.showLoaderNoCancel();
        facebookConnectPlugin.login(
            ["email"],                      // array of permissions
            function(response) {
                mad.common.hideLoaderNoCancel();
                if (response.status === "connected") {      // success
                    deleteSubscriptionInfo();
                    // contains the 'status' - bool, 'authResponse' - object with 'session_key', 'accessToken', 'expiresIn', 'userID'
                    mad.common.getFBToken(response.authResponse.accessToken, response.authResponse.userID, false);
                }
            }, function (failedResponse) {
                mad.common.hideLoaderNoCancel();
                console.log(failedResponse);
                mad.alerts.error0("Please try again or login with email");
            });
    }

    function getUsernamePlaceholder(){
        if (mad.viewModels.login.viewModel.get("mode") == "login"){
            return "Email";
        }else{
            return "Email";
        }
    }

    function getPasswordPlaceholder(){
        //mad.glossary.ui.login.labels.message[common.languageIndex()]
        return "Password";
    }

    function showHide(e){
        console.log("showHide");
        if (viewModel.get("passVisible")){
            viewModel.set("passVisible", false);
        }else{
            viewModel.set("passVisible", true);
        }
        showHidePass();
    }

    function showHidePass(){
        console.log("showHidePass");
        if (viewModel.get("passVisible")){
            $(".eye").removeClass("invisible").addClass("visible");
            $( "#uPass" ).attr( "type", "password" );
        }else{
            $(".eye").addClass("invisible").removeClass("visible");
            $( "#uPass" ).attr( "type", "text" );
        }
    }

    function login(e){

        if (mad.viewModels.login.viewModel.get("mode") == "login"){
            doLogin();
        }else{
            forgotPass();
        }
    }

    function doLogin(){
        console.log("do login");

        if (cordova.plugins && cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.close();
        }

        // automatically close the keyboard on iOS
        document.activeElement.blur();

        var controlsOK = true;

        var nam = viewModel.get("username");
        var pwd = viewModel.get("password");

        if (nam.length == 0 || pwd.length == 0) {
            mad.alerts.topCenterE("You must enter both fields!");
            controlsOK = false;
        }else{
            if (nam.length>99){
                mad.alerts.topCenterE("Invalid username / email","");
                controlsOK = false;
            }else{
                if (pwd.length>99){
                    mad.alerts.topCenterE("Invalid password","");
                    controlsOK = false;
                }
            }
        }

        if (controlsOK){
            // automatically close the keyboard on iOS
            document.activeElement.blur();
            deleteSubscriptionInfo();
            mad.common.variables.onStartCameFrom = "login";
            mad.common.getToken(viewModel.get("username"), viewModel.get("password"), false);
        }
    }

    function forgotPass(){
        console.log("forgotPass")

        if (cordova.plugins && cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.close();
        }

        var controlsOK = true;

        var nam = viewModel.get("username");

        if (nam.length == 0) {
            mad.alerts.topCenterE("Please, enter your eMail !")
            controlsOK = false;
        }else{
            if (nam.length<6 || nam.length>99){
                mad.alerts.topCenterE("Invalid email","");
                //$("#uName").focus();
                controlsOK = false;
            }
        }

        if (controlsOK){
            // automatically close the keyboard on iOS
            document.activeElement.blur();

            sendEmailForPasswordReset();
        }
    }

    function forgotTxt(){
        return mad.glossary.ui.login.labels.forgot[mad.common.observables.languageIndex()]
    }

    function forgot(){
        console.log("forgot");
        mad.viewModels.login.viewModel.set("mode", "forgot");

        viewModel.set("username", "");
        viewModel.set("password", "");

        $("#uPassLabel").addClass("hideField");
        $(".fButton").addClass("hideField");

        $("#login-list .eye").addClass("hideField");

        $(".forgot").addClass("hideField");
        $("#loginBtn").html("Send me a password");

        $("#uName").attr("placeholder", "Email");
    }

    function sendEmailForPasswordReset() {

        mad.common.showLoader();

        /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/Account/SendPasswordTokenV2";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = {
            Email: mad.viewModels.login.viewModel.get("username")
        };
        */

        var link   = {putanja : mad.common.variables.serverUrl + "api/Account/SendPasswordTokenV2", akcija : "POST"};
        var podaci = {
            Email: mad.viewModels.login.viewModel.get("username")
        };

        var cntx = arguments.callee.toString();
        mad.appTelemetry.logInfo("Trying to reset password",
               mad.common.getCurrentFunctionName(cntx), "", mad.appTelemetry.SEVERITY.Information, "", podaci.Email);

        mad.data.post(link, podaci)
            .done(function (data) {
                if(data.Result === true){
                    mad.alerts.success0("Instructions on how to reset your password have been sent to your email. Please read and follow them.");
                    mad.mobileApp.navigate("ui/other/start.html", "slide:right");
                }else{
                    mad.alerts.topCenterE(data.Message);
                    mad.appTelemetry.logInfo("Password reset failed", mad.common.getCurrentFunctionName(cntx),data.Message, mad.appTelemetry.SEVERITY.Error, "", podaci.Email);
                }
            })
            .fail(function (e, r, t) {
                console.log("Error reseting your password.", e);
                mad.alerts.topCenterE("Error reseting your password.");
                mad.appTelemetry.logInfo("Password reset failed", mad.common.getCurrentFunctionName(cntx), "", mad.appTelemetry.SEVERITY.Error, "", podaci.Email);
            })
            .always(function(){
                mad.common.hideLoader();
            });
    }


    function deleteSubscriptionInfo() {
        mad.local.removeVariable("SubscriptionInfo");
        mad.common.variables.HasUserAccesToPro = -1;
    }

    // -- not in viewModel Context  - - - - - - - - - - - - - - - -
    function setupView(){
        mad.common.stretchView();
        mad.common.setResolutionForView(parseInt(mad.mobileApp.view().content.width()), parseInt(mad.mobileApp.view().content.height()));
        mad.common.setLangForView();
    }

    return {
        viewModel: viewModel
    };

}());

