var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.popups = (function() {

    "use strict";

    var viewModel = kendo.observable({
        common: mad.common.observables,
        modalID: "",
        openModalWindow: openModalWindow,
        closeModalWindow: closeModalWindow,
        opened: "",
        title: "",
        subtitle: "",
        button: "",
        buy: buy
    });

    function openModalWindow(which, title, subtitle, button) {
        var titleParm = title === undefined ? "" : title,
            subtitleParm = subtitle === undefined ? "" : subtitle,
            buttonParm = button === undefined ? "" : button;

        viewModel.set("opened", which);
        viewModel.set("title", titleParm);
        viewModel.set("subtitle", subtitleParm);
        viewModel.set("button", buttonParm);

        if (which == "PRO" || which=="buyPro") {
            viewModel.set("modalID", "#buyPRO");
            mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP], mad.analyticEvents.categories.SALES, mad.analyticEvents.types.EVENT,
                "Pro Converter - Feed Pro workout modal",
                null,
                "Pro Converter",
                "Feed Pro workout modal");
            mad.appsFlyer.trackEvent("Pro Converter - Feed Pro workout modal");
        } else if (which == "proRutine") {
            viewModel.set("modalID", "#proMadbarzRoutine");
            mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP], mad.analyticEvents.categories.SALES, mad.analyticEvents.types.EVENT,
                "Pro Converter - Feed Pro routine modal",
                null,
                "Pro Converter",
                "Feed Pro routine modal");
            mad.appsFlyer.trackEvent("Pro Converter - Feed Pro routine modal");

        }else if (which === "buySaved") {
            viewModel.set("modalID", "#buySaved");
            mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP], mad.analyticEvents.categories.SALES, mad.analyticEvents.types.EVENT,
                "Pro Converter - USW modal",
                null,
                "Pro Converter",
                "USW modal");
            mad.appsFlyer.trackEvent("Pro Converter - USW modal");

        }else if (which === "buyProSuccess") {
            viewModel.set("modalID", "#buyProSuccess");
        } else if (which === "buySavedPRO") {

            viewModel.set("modalID", "#buySaved");
            mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP], mad.analyticEvents.categories.SALES, mad.analyticEvents.types.EVENT,
                "Pro Converter - USW modal",
                null,
                "Pro Converter",
                "USW modal");
            
            mad.appsFlyer.trackEvent("Pro Converter - USW modal");


            viewModel.set("modalID", "#buySavedPRO");

        }else if (which === "nextPart") {
            viewModel.set("modalID", "#gotoPartII");
        }else if (which === "nextPartToList") {
            viewModel.set("modalID", "#gotoPartII");
        }else if (which === "nextWeek") {
            viewModel.set("modalID", "#nextWeek");
        }else{
            viewModel.set("modalID", "");
            console.log("** There is no " + which + " modal");
        }
        if (viewModel.get("modalID") != ""){
            goOpenModal();
        }
    }

    function goOpenModal(){
        var ID = viewModel.get("modalID"), modal$, modalContainer$, mv;

        modal$ = $(ID),
        modalContainer$ = $(ID + "Container"),
        mv = modal$.data("kendoMobileModalView");

        modal$.removeClass("hidden");
        mv.open();
        modalContainer$.css("height", modal$.parent().height());

        modal$.css("scale", 0.2);
        modal$.css("opacity", 0);

        modal$.velocity(
            {
                scale: 1,
                opacity: 1,
                translateY: ['0%', '-50%']
            }, {
                duration: 777,
                easing: "spring"
            });

    }

    function closeModalWindow(e){

        if (e){
            e.preventDefault(); // da ne probija
        }

        /* kod starog close smo imali
            // exit only
            if (e.touch.initialTouch.id == "buySavedContainer" ||
                e.touch.initialTouch.id == "buySavedPROContainer" ||
                e.touch.initialTouch.id == "buyButton" ||
                e.touch.initialTouch.className == "button-content") {
        */

        var ID = viewModel.get("modalID"),
        modal$ = $(ID),
        mv = modal$.data("kendoMobileModalView");

        modal$.velocity(
            {
                scale: 0.8,
                translateY: ['-100%', '0%']
            }
            , {
                easing: "easy",
                duration: 444,
                complete: function() {
                    mv.close();
                    modal$.addClass("hidden");
                    afterClose();
                }
            });
    }

    function afterClose(){
        var opened = viewModel.get("opened");

        if (opened === "nextPart") {
            mad.mobileApp.navigate("ui/plans/list.html?origin=settings", "fade");
        }else if (opened === "nextPartToList") {
            // update status in viewmodel for list
            mad.viewModels.plans.viewModel.updateStatus("finished");
            mad.common.removeLastFromHistory();
            mad.mobileApp.navigate("ui/plans/list.html?origin=workoutMenu", "fade");
        }else if (opened === "nextWeek") {
            mad.viewModels.plansWork.viewModel.finishWeek();
        }else if (opened === "buyProSuccess") {
            mad.mobileApp.navigate("ui/workouts/menu.html?origin=workoutMenu", "fade");
        }

        viewModel.set("opened", "");
    }

    function buy(e) {

        var tappedElement, val , desc1, desc2;

        e.preventDefault(); // da ne probija

        //tappedElement = $(e.touch.currentTarget);
        tappedElement = e.touch.target;  // drazen - zbog nove verzije kenda
        val = $(tappedElement).attr('data-value');

        if (val == "prekobrojni" || val == "savedPRO"){
            desc1 = "Pro Converter - USW modal - Button Clicked";
            desc2 = "USW modal";


            mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP], mad.analyticEvents.categories.SALES, mad.analyticEvents.types.EVENT,
                desc1,
                null,
                "Pro Converter",
                desc2);

        }else{
            desc1 = "Pro Converter - Feed Pro workout modal - Button clicked";
            desc2 = "Feed Pro workout modal";
        }

        if (mad.common.observables.ifOffline()) {
            mad.alerts.error(this.common.translate("messages", "offline"));
            return;
        }


        mad.mobileApp.navigate("ui/PRO/explain.html");
    }

    return {
        viewModel: viewModel
    };

}());