var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.register = (function() {
  "use strict";

  var viewModel = kendo.observable({
    // properties or functions we want to observe and expose to html
    common: mad.common.observables,

    init: initView,
    show: showView,
    afterShow: afterShow,

    testBack: testBack,

    prev: prev,
    next: next,
    currentPage: 0,
    lastPage: 0,

    title: getTitle,
    intro: getIntro,

    unitsChanged: unitsChanged,
    translateWord: getWord,
    translateWordForNextBtn: getWordForNextButton,
    getBorn: getBorn,

    openToU: openToU,
    openPP: openPP,

    isRegisterWithFacebook: false,
    isLoginWithFacebook: false,
    fbInfo: {},
    fbSignup: fbSignup,

    checkEnter: checkEnter,
    //acceptSuggestion: acceptSuggestion,
    ifNotUSA: ifNotUSA,
    isButtonVisibleL: isBackVisible, // mora se zvati isButtonVisibleL
    isRegisterEnabled: false,

    showHide: showHide,
    passVisible: true,

    //     isNextEnabled: false,
    doRegistration: doRegistration,
    resetRegisterData: resetRegData,

    countryBefore: "",

    data: {
      gender: "",
      level: 0,
      levelTxt: "",
      goal: 0,
      goalTxt: "",
      fat: 0,
      monthBorn: "June",
      monthNum: 6,
      yearBorn: 1991,
      isMetric: true,
      height: "177 cm",
      HeightInCm: "177",
      HeightImp: "5 ft 10 in",
      weight: "80 kg",
      WeightInKg: "80",
      WeightImp: "177 lbs",
      firstname: "",
      lastname: "",
      password: "",
      email: "",
      country: "",
      state: "",
      origin: ""
    },
    screensAlreadyTracked: {
      gender: false,
      level: false,
      goal: false,
      bodyDetails: false,
      signupMethod: false,
      emailChosen: false
    } // purpose of this helper object is to remove multiplication of analytics events during registration process, for example if users goes back and forth between some screens
  });

  function testBack(e) {
    mad.app.onBackButton(e);
  }

  function initView(e) {
    console.log("init reg");
    viewModel.set("passVisible", true);

    $("#regScrollview").kendoMobileScrollView({
      page: 0,
      duration: 1111,
      enablePager: false,
      contentHeight: "100%",
      changing: changingPage,
      change: changedPage
    });
    var questions = ["level", "gender", "goal", "fat"],
      template,
      data,
      result;

    questions.forEach(function(what) {
      template = kendo.template($("#reg-template").html(), {
        useWithBlock: true
      });
      data = mad.glossary.ui.register[what];
      result = template(data); //Pass the data to the compiled template
      $("#reg-" + what + "-list").html(result);
    });

    initMobiscrollFields();

    $("#Rmail").on("blur", function(event) {
      if (event.target.value.length > 0) {
        if (!isEmail(event.target.value)) {
          mad.alerts.top("invalid " + event.target.name);
          $("#Rmail").focus();
          handleTopOfToast();
        }
      }
    });

    $("#Rpass").on("blur", function(event) {
      if (event.target.value.length > 0) {
        if (!isValidPass(event.target.value)) {
          mad.alerts.top(event.target.name + " is too short");
          $("#Rpass").focus();
          handleTopOfToast();
        }
      }
    });

    $("#Rfirst").on("blur", function(event) {
      if (event.target.value.length > 0) {
        if (!isValidContent(event.target.value)) {
          mad.alerts.top(event.target.name + " contains invalid characters");
          $("#Rfirst").focus();
          handleTopOfToast();
        } else if (!isValidLength(event.target.value)) {
          mad.alerts.top(event.target.name + " is too long");
          $("#Rfirst").focus();
          handleTopOfToast();
        }
      }
    });
    $("#Rlast").on("blur", function(event) {
      if (event.target.value.length > 0) {
        if (!isValidContent(event.target.value)) {
          mad.alerts.top(event.target.name + " contains invalid characters");
          $("#Rlast").focus();
          handleTopOfToast();
        } else if (!isValidLength(event.target.value)) {
          mad.alerts.top(event.target.name + " is too long");
          $("#Rlast").focus();
          handleTopOfToast();
        }
      }
    });
  }

  function showView(e) {
    console.log("show reg");

    var origin = e.view.params.origin;
    viewModel.set("origin", origin);

    var scrollview = $("#regScrollview").data("kendoMobileScrollView");

    mad.common.setActualView();

    if (origin == "document" || origin == "ToU" || origin == "PP") {
      scrollview.scrollTo(4);
    } else {
      mad.common.addViewToHistory();

      var isFbLogin = viewModel.get("isLoginWithFacebook");
      if (!isFbLogin) {
        resetRegData($(mad.common.$actualViewID));
      } else {
        kendo.bind($(mad.common.$actualViewID), viewModel);
      }
      scrollview.scrollTo(0);

      // assign events for input fields change
      /*
            $('#Rmail').on('input',function(e){
                viewModel.data.set('email',$(this).val())
            });
            $('#Rpass').on('input',function(e){
                viewModel.data.set('password',$(this).val())
            });
            $('#Rfirst').on('input',function(e){
                viewModel.data.set('firstname',$(this).val())
            });
            $('#Rlast').on('input',function(e){
                viewModel.data.set('lastname',$(this).val())
            });
            */

      // assign events for input fields change & when loses focus
      $("#Rmail").on("change", function(e) {
        viewModel.data.set("email", $(this).val());
      });
      $("#Rpass").on("change", function(e) {
        viewModel.data.set("password", $(this).val());
      });
      $("#Rfirst").on("change", function(e) {
        viewModel.data.set("firstname", $(this).val());
      });
      $("#Rlast").on("change", function(e) {
        viewModel.data.set("lastname", $(this).val());
      });

      var initCountry = mad.viewModels.register.viewModel.data.get("country");

      console.log("- - - - country na pocetku je", initCountry);
      if (mad.common.isNullOrEmpty(initCountry)) {
        $("#Rcountry").mobiscroll("setVal", "Croatia");
        $("#Rcountry_dummy")[0].value = "Select your Country";
      } else {
        //console.log("dummy country", $('#Rcountry_dummy'));
        if ($("#Rcountry_dummy").lenght > 0) {
          //$('#Rcountry_dummy')[0].value = "";     //obrisi prethodni country u dummy input polju
          $("#Rcountry_dummy")[0].value = "Select your Country";
        }
      }
    }

    showHidePass();
  }

  function resetRegData(viewId) {
    mad.viewModels.register.viewModel.set("lastPage", 0);
    mad.viewModels.register.viewModel.set("isRegisterEnabled", false);
    //  mad.viewModels.register.viewModel.set("isNextEnabled", false);              // on page 5
    mad.viewModels.register.viewModel.set("isRegisterWithFacebook", false);
    mad.viewModels.register.viewModel.set("fbInfo", {});

    mad.viewModels.register.viewModel.data.set("gender", "");
    mad.viewModels.register.viewModel.data.set("level", 0);
    mad.viewModels.register.viewModel.data.set("goal", 0);
    mad.viewModels.register.viewModel.data.set("fat", 0);
    mad.viewModels.register.viewModel.data.set("monthBorn", "June");
    mad.viewModels.register.viewModel.data.set("yearBorn", 1991);
    mad.viewModels.register.viewModel.data.set("isMetric", true);
    mad.viewModels.register.viewModel.data.set("height", "177 cm");
    mad.viewModels.register.viewModel.data.set("HeightInCm", "177");
    mad.viewModels.register.viewModel.data.set("HeightImp", "5 ft 10 in");
    mad.viewModels.register.viewModel.data.set("weight", "80 kg");
    mad.viewModels.register.viewModel.data.set("WeightInKg", "80");
    mad.viewModels.register.viewModel.data.set("WeightImp", "177 lbs");
    mad.viewModels.register.viewModel.data.set("firstname", "");
    mad.viewModels.register.viewModel.data.set("lastname", "");
    mad.viewModels.register.viewModel.data.set("password", "");
    mad.viewModels.register.viewModel.data.set("email", "");
    mad.viewModels.register.viewModel.data.set("country", "");
    mad.viewModels.register.viewModel.data.set("state", "");

    kendo.bind(viewId, viewModel);
  }

  function afterShow(e) {
    console.log("after show reg");
    var contentHeight = parseInt(mad.mobileApp.view().content.height());
    $("#register .photo").css("height", contentHeight);

    mad.appTelemetry.trackPageView("Register");
  }

  function prev() {
    //console.log("prev");
    if (mad.viewModels.register.viewModel.get("currentPage") == 0) {
      mad.common.goBack();
    } else {
      var scrollview = $("#regScrollview").data("kendoMobileScrollView");
      scrollview.prev();
    }
  }

  function next(e) {
    //console.log("next");
    //console.log(e);

    var c = mad.viewModels.register.viewModel.get("currentPage");
    var l = mad.viewModels.register.viewModel.get("lastPage");
    var scrollview = $("#regScrollview").data("kendoMobileScrollView");

    //   var data = mad.viewModels.register.viewModel.get("data");
    var eventsAlreadyTracked = mad.viewModels.register.viewModel.get(
      "screensAlreadyTracked"
    );

    if ($("[name='level']:checked").length > 0 && !eventsAlreadyTracked.level) {
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA, mad.analyticEvents.MIXP],
        mad.analyticEvents.categories.REGISTRATION,
        mad.analyticEvents.types.EVENT,
        "Registration Process - Selected Level",
        null,
        "Registration Process",
        "Selected Level"
      );

      mad.viewModels.register.viewModel.screensAlreadyTracked.set(
        "level",
        true
      );
    }

    if (
      $("[name='gender']:checked").length > 0 &&
      !eventsAlreadyTracked.gender
    ) {
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA, mad.analyticEvents.MIXP],
        mad.analyticEvents.categories.REGISTRATION,
        mad.analyticEvents.types.EVENT,
        "Registration Process - Selected Gender",
        null,
        "Registration Process",
        "Selected Gender"
      );

      mad.viewModels.register.viewModel.screensAlreadyTracked.set(
        "gender",
        true
      );
    }

    if ($("[name='goal']:checked").length > 0 && !eventsAlreadyTracked.goal) {
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA, mad.analyticEvents.MIXP],
        mad.analyticEvents.categories.REGISTRATION,
        mad.analyticEvents.types.EVENT,
        "Registration Process - Selected Goal",
        null,
        "Registration Process",
        "Selected Goal"
      );

      mad.viewModels.register.viewModel.screensAlreadyTracked.set("goal", true);
    }

    //this is last next before choosing register with Email or FB screen

    /// Apple doesn't allow us ask for country
    var cntry = mad.viewModels.register.viewModel.data.get("country");
    if (
      !cntry &&
      e.currentTarget.id == "registerNext" &&
      device.platform === "Android"
    ) {
      mad.alerts.realTop0("Please select your country");
      return;
    }

    if (
      !eventsAlreadyTracked.bodyDetails &&
      e.currentTarget.id == "registerNext"
    ) {
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA, mad.analyticEvents.MIXP],
        mad.analyticEvents.categories.REGISTRATION,
        mad.analyticEvents.types.EVENT,
        "Registration Process - Filled body details",
        null,
        "Registration Process",
        "Filled body details"
      );

      mad.viewModels.register.viewModel.screensAlreadyTracked.set(
        "bodyDetails",
        true
      );
    }

    if (
      !eventsAlreadyTracked.emailChosen &&
      e.currentTarget.id == "registerWithEmail"
    ) {
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA],
        mad.analyticEvents.categories.REGISTRATION,
        mad.analyticEvents.types.EVENT,
        "Registration Process - Choose Sign Up method Email",
        null,
        "Registration Process",
        "Choose Sign Up method Email"
      );

      mad.viewModels.register.viewModel.screensAlreadyTracked.set(
        "emailChosen",
        true
      );
    }

    var isFbLogin = viewModel.get("isLoginWithFacebook");
    if (isFbLogin && e.currentTarget.id == "registerNext") {
      prepareData();
    } else {
      scrollview.next();
    }

    //scrollview.scrollTo(c+1, false);
  }

  function showHide(e) {
    console.log("showHide");
    if (viewModel.get("passVisible")) {
      viewModel.set("passVisible", false);
    } else {
      viewModel.set("passVisible", true);
    }
    showHidePass();
  }

  function showHidePass() {
    console.log("showHidePass");
    if (viewModel.get("passVisible")) {
      $(".eye")
        .removeClass("invisible")
        .addClass("visible");
      $("#Rpass").attr("type", "password");
    } else {
      $(".eye")
        .addClass("invisible")
        .removeClass("visible");
      $("#Rpass").attr("type", "text");
    }
  }

  function getTitle(p) {
    return mad.glossary.ui.register[p].title[
      mad.common.observables.languageIndex()
    ];
  }

  function getIntro(p) {
    return mad.glossary.ui.register[p].intro[
      mad.common.observables.languageIndex()
    ];
  }

  function changingPage(e) {
    // triggerira se samo na swipe
    console.log(
      "changing current, last page",
      mad.viewModels.register.viewModel.get("currentPage"),
      mad.viewModels.register.viewModel.get("lastPage")
    );
    var l = mad.viewModels.register.viewModel.get("lastPage");
    if (e.nextPage > l) {
      e.preventDefault(); //prevent scrolling
    }
  }

  function changedPage(e) {
    mad.viewModels.register.viewModel.set("currentPage", e.page);
    var l = mad.viewModels.register.viewModel.get("lastPage");

    if (e.page > l) {
      mad.viewModels.register.viewModel.set("lastPage", e.page);
    }

    //console.log("changed current, last page", mad.viewModels.register.viewModel.get("currentPage"), mad.viewModels.register.viewModel.get("lastPage"));
    var subPage = [
      "Registration - Fitness Level",
      "Registration - Gender",
      "Registration - Goal",
      "Registration - Body Details",
      "Registration  - SignUp",
      "Registration - Account Details"
    ];

    if (subPage[e] == "Registration - Fitness Level") {
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP],
        mad.analyticEvents.categories.REGISTRATION,
        mad.analyticEvents.types.VIEW,
        subPage[e.page],
        null,
        subPage[e.page],
        "Screen loaded"
      );
    } else {
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA, mad.analyticEvents.MIXP],
        mad.analyticEvents.categories.REGISTRATION,
        mad.analyticEvents.types.VIEW,
        subPage[e.page],
        null,
        subPage[e.page],
        "Screen loaded"
      );
    }

    if (e.page == 5) {
      $("#DoRegistrationWithEmail").attr("disabled", false);
    }

    if (e.page == 6) {
      // on a last page
      checkFields(); // check if all fields are populated
    }
  }

  function checkEnter(e) {
    //console.log("on input", e);

    if (checkFields()) {
      if (e.keyCode == 13) {
        doRegistration(e);
      }
    }
  }

  function checkFields() {
    var frst = mad.viewModels.register.viewModel.data.get("firstname");
    var last = mad.viewModels.register.viewModel.data.get("lastname");
    var pass = mad.viewModels.register.viewModel.data.get("password");
    var mail = mad.viewModels.register.viewModel.data.get("email");
    //  var cntr = mad.viewModels.register.viewModel.data.get("country"); // old code while countr was still on last screen

    var isFbLogin = viewModel.get("isRegisterWithFacebook");
    var filledAll = true;

    if (frst.length > 0) {
      $("#RfirstLabel").addClass("popunjeno");
    } else {
      $("#RfirstLabel").removeClass("popunjeno");
      filledAll = false;
    }

    if (last.length > 0) {
      $("#RlastLabel").addClass("popunjeno");
    } else {
      $("#RlastLabel").removeClass("popunjeno");
      filledAll = false;
    }

    if (pass.length > 0 || isFbLogin) {
      $("#RpassLabel").addClass("popunjeno");
    } else {
      $("#RpassLabel").removeClass("popunjeno");
      filledAll = false;
    }

    if (mail.length > 0) {
      $("#RmailLabel").addClass("popunjeno");
    } else {
      $("#RmailLabel").removeClass("popunjeno");
      filledAll = false;
    }

    //if (cntr.length === 0 && !isFbLogin) {
    //    filledAll = false;
    //}

    mad.viewModels.register.viewModel.set("isRegisterEnabled", filledAll);

    return filledAll;
  }

  function isBackVisible() {
    return true;
  }

  function doRegistration(e) {
    console.log("rigister clikced", e);
    if (e) {
      e.preventDefault();
    }

    if (clientControlsOK()) {
      if (mad.common.observables.networkStatus == "online") {
        // and we are online

        //we disable button so user cannot click on it multiple times
        $("#DoRegistrationWithEmail").attr("disabled", true);
        mad.common.showLoader();

        //checking if email exists
        var promise2 = $.Deferred();
        promise2.then(
          function(success) {
            if (success) {
              // name is OK

              // automatically close the keyboard on iOS
              document.activeElement.blur();

              // idi registriraj
              console.log(
                "podaci",
                mad.viewModels.register.viewModel.get("data")
              );
              mad.analyticEvents.track(
                [mad.analyticEvents.services.GA, mad.analyticEvents.MIXP],
                mad.analyticEvents.categories.REGISTRATION,
                mad.analyticEvents.types.EVENT,
                "Registration Process - Final Register Clicked",
                null,
                "Registration Process",
                "Final Register Clicked"
              );

              prepareData();
            }
          },
          function(fail) {
            console.log("bilo je doslo do greske u checkEmail");
            //there was some err remove diabled attr
            $("#DoRegistrationWithEmail").attr("disabled", false);
            mad.common.hideLoader();
          }
        );
        //mad.common.checkEmail(promise2);
        mad.common.serverCheck("Email", promise2);
      } else {
        // in case we are offline
        mad.alerts.top("You are not connected to the Internet.");
        //handleTopOfToast();
      }
    }
  }

  function prepareData() {
    var firstName = mad.viewModels.register.viewModel.data.get("firstname");
    mad.viewModels.register.viewModel.data.set("firstname", firstName.trim());

    var lastName = mad.viewModels.register.viewModel.data.get("lastname");
    mad.viewModels.register.viewModel.data.set("lastname", lastName.trim());

    var email = mad.viewModels.register.viewModel.data.get("email");
    mad.viewModels.register.viewModel.data.set("email", email.trim());

    var months = [
      "January",
      "February",
      "March",
      "April",
      "May",
      "June",
      "July",
      "August",
      "September",
      "October",
      "November",
      "December"
    ];
    var mnth =
      months.indexOf(mad.viewModels.register.viewModel.data.get("monthBorn")) +
      1;
    mad.viewModels.register.viewModel.data.set("monthNum", mnth);

    var levelRange = ["0", "1", "Beginner", "Intermediate", "Advanced"];
    mad.viewModels.register.viewModel.data.set(
      "levelTxt",
      levelRange[mad.viewModels.register.viewModel.data.get("level")]
    );

    var goalRange = ["0", "LooseWeight", "AthleteBody", "Jacked"];
    mad.viewModels.register.viewModel.data.set(
      "goalTxt",
      goalRange[mad.viewModels.register.viewModel.data.get("goal")]
    );

    console.log("podaci", mad.viewModels.register.viewModel.get("data"));
    var isLoginWithFb = mad.viewModels.register.viewModel.get(
      "isRegisterWithFacebook"
    );

    if (isLoginWithFb) {
      var fbInfo = mad.viewModels.register.viewModel.get("fbInfo");
      mad.common.userRegistration(
        true,
        fbInfo.fbToken,
        fbInfo.fbId,
        fbInfo.photo
      );
    } else {
      mad.common.userRegistration(false, "", "", "");
    }
  }

  function unitsChanged(e) {
    var heightTxt, weightTxt, valueText, feet, inches, cm, lbs, kg, units;

    units = e.target.id;

    //  var cntry = viewModel.data.get("country");

    //if (cntry.length > 0) {
    //    viewModel.set("isNextEnabled", true);              // on page 5

    //}

    /*
        heightTxt = getHeightSwitch();
        weightTxt = getWeightSwitch();
        */
    heightTxt = getHeightValue(units);
    weightTxt = getWeightValue(units);

    if (units == "Rmetric") {
      viewModel.data.set("isMetric", true);
      valueText = heightTxt;
      $("#RuserHeight").mobiscroll("option", "wheels", wCentimeters); //change wheels
      if (valueText) {
        valueText = valueText.toString().split(" ");
        feet = valueText[0];
        inches = valueText[2];
        cm = parseInt(feet * 30.48 + inches * 2.54);
      } else {
        cm = 177;
      }
      $("#RuserHeight").mobiscroll("setArrayVal", [cm], true, false); // change data
      valueText = weightTxt;
      $("#RuserWeight").mobiscroll("option", "wheels", wKilograms); //change wheels
      if (valueText) {
        valueText = valueText.toString().split(" ");
        kg = parseInt(valueText[0] * 0.45359237);
      } else {
        kg = 77;
      }
      $("#RuserWeight").mobiscroll("setArrayVal", [kg], true, false);
    } else {
      viewModel.data.set("isMetric", false);
      valueText = heightTxt;
      $("#RuserHeight").mobiscroll("option", "wheels", wInches);
      inches = (parseInt(valueText) * 0.393700787).toFixed(0);
      feet = Math.floor(inches / 12);
      inches %= 12;
      $("#RuserHeight").mobiscroll("setArrayVal", [feet, inches], true, false);
      valueText = weightTxt;
      $("#RuserWeight").mobiscroll("option", "wheels", wLbs);
      lbs = Math.ceil(parseInt(valueText) * 2.20462).toFixed(0);
      $("#RuserWeight").mobiscroll("setArrayVal", [lbs], true, false);
    }
  }

  function getHeightValue(units) {
    var retVal;

    if (units == "Rmetric") {
      retVal = viewModel.data.get("HeightImp");
    } else {
      retVal = Math.ceil(viewModel.data.get("HeightInCm")) + " cm";
    }
    console.log("getHeight", retVal);
    return retVal;
  }
  function getWeightValue(units) {
    var retVal;

    if (units == "Rmetric") {
      retVal = viewModel.data.get("WeightImp");
    } else {
      retVal = Math.ceil(viewModel.data.get("WeightInKg")) + " kg";
    }
    console.log("getWeight", retVal);
    return retVal;
  }

  function getWord(word) {
    return mad.common.translate("words", word);
  }

  function getWordForNextButton(word) {
    var isFbLogin = viewModel.get("isLoginWithFacebook");

    if (isFbLogin) {
      word = "register";
    }
    return mad.common.translate("words", word);
  }

  function countryChanged(e) {
    var selectedCountry = viewModel.data.get("country");

    if (
      selectedCountry != "USA" &&
      selectedCountry != "United States of America (the)"
    ) {
      viewModel.data.set("state", "");
    }
    console.log("izabrana zemlja je", selectedCountry);
  }

  function ifNotUSA() {
    return (
      viewModel.data.get("country") != "USA" &&
      viewModel.data.get("country") != "United States of America (the)"
    );
  }

  function getBorn() {
    return (
      viewModel.data.get("monthBorn") + " " + viewModel.data.get("yearBorn")
    );
  }

  function initMobiscrollFields() {
    var theme, mode, display, lang;

    (theme = $.mobiscroll.defaults.theme),
      (mode = "scroller"),
      (display = "bottom"),
      (lang = "hr");

    function getLenWheels() {
      if (
        viewModel.data.get("isMetric") == "true" ||
        viewModel.data.get("isMetric") == true
      ) {
        return wCentimeters;
      } else {
        return wInches;
      }
    }

    $("#RuserHeight").mobiscroll({
      theme: theme,
      mode: mode,
      display: display,
      buttons: buttons,
      lang: lang,
      showLabel: true,
      wheels: getLenWheels(),
      height: 40,
      maxWidth: 150,

      onClose: function(valueText, botun, inst) {
        var feet, inches, cm;

        if (botun == "set") {
          // postavljanje - metric
          valueText = valueText.toString().split(" ");
          if (
            viewModel.data.get("isMetric") == "true" ||
            viewModel.data.get("isMetric") == true
          ) {
            cm = parseInt(valueText[0]);
          } else {
            // konverzija u cm
            feet = valueText[0];
            inches = valueText[2];
            cm = parseInt(feet * 30.48 + inches * 2.54);
          }
          viewModel.data.set("HeightInCm", cm);

          // konverzija u imperial
          inches = (parseInt(cm) * 0.393700787).toFixed(0);
          feet = Math.floor(inches / 12);
          inches %= 12;
          viewModel.data.set("HeightImp", feet + " ft " + inches + " in");
          //console.log("height changed", cm, feet, inches);
        }
      },

      formatResult: function(data) {
        if (
          viewModel.data.get("isMetric") == "true" ||
          viewModel.data.get("isMetric") == true
        ) {
          //console.log("height before format METRIC", data);
          return data + " cm";
        } else {
          //console.log("height before format IMPERIAL", data);
          return data[0] + " ft " + data[1] + " in";
        }
      },

      parseValue: function(valueText) {
        //console.log("parseValue before format", valueText);
        if (
          viewModel.data.get("isMetric") == "true" ||
          viewModel.data.get("isMetric") == true
        ) {
          if (valueText) {
            valueText = valueText.toString().split(" ");
            return [valueText[0]];
          } else {
            return ["177"];
          }
        } else {
          if (valueText) {
            valueText = valueText.toString().split(" ");
            return [valueText[0], valueText[2]];
          } else {
            return ["5", "10"];
          }
        }
      }
    });

    function getWeightWheels() {
      if (
        viewModel.data.get("isMetric") == "true" ||
        viewModel.data.get("isMetric") == true
      ) {
        return wKilograms;
      } else {
        return wLbs;
      }
    }

    $("#RuserWeight").mobiscroll({
      theme: theme,
      mode: mode,
      display: display,
      buttons: buttons,
      lang: lang,
      showLabel: true,
      wheels: getWeightWheels(),
      height: 40,
      maxWidth: 150,

      onClose: function(valueText, botun, inst) {
        var kg, lbs;

        if (botun == "set") {
          // postavljanje - metric
          valueText = valueText.toString().split(" ");
          if (
            viewModel.data.get("isMetric") == "true" ||
            viewModel.data.get("isMetric") == true
          ) {
            kg = parseInt(valueText[0]);
          } else {
            kg = parseInt(valueText[0] * 0.45359237); // konverzija u kg
          }
          viewModel.data.set("WeightInKg", kg);

          // konverzija u imperial
          lbs = Math.ceil(kg * 2.20462).toFixed(0);
          viewModel.data.set("WeightImp", lbs);
          //console.log("weight changed", kg, lbs);
        }
      },

      formatResult: function(data) {
        //console.log("weight before format", data);
        if (
          viewModel.data.get("isMetric") == "true" ||
          viewModel.data.get("isMetric") == true
        ) {
          return data + " kg";
        } else {
          return data + " lbs";
        }
      },

      parseValue: function(valueText) {
        //console.log("parseValue before format", valueText);
        if (
          viewModel.data.get("isMetric") == "true" ||
          viewModel.data.get("isMetric") == true
        ) {
          if (valueText) {
            valueText = valueText.toString().split(" ");
            return [valueText[0]];
          } else {
            return ["77"];
          }
        } else {
          if (valueText) {
            valueText = valueText.toString().split(" ");
            return [valueText[0]];
          } else {
            return ["170"];
          }
        }
      }
    });

    $("#RbDay")
      .mobiscroll()
      .date({
        theme: theme, // Specify theme like: theme: 'ios' or omit setting to use default
        mode: mode, // Specify scroller mode like: mode: 'mixed' or omit setting to use default
        display: display, // Specify display mode like: display: 'inline' or omit setting to use default
        buttons: buttons,
        defaultValue: new Date(1995, 7, 1),
        lang: lang, // Specify language like: lang: 'pl' or omit setting to use default
        onClose: function(valueText, botun, inst) {
          if (botun == "set") {
            valueText = valueText.toString().split(" ");
            var mnth = valueText[0],
              year = valueText[1];
            viewModel.data.set("monthBorn", mnth);
            viewModel.data.set("yearBorn", year);

            console.log("bday promjena", mnth, year, botun);
          }
        }
      });

    $("#Rcountry")
      .mobiscroll()
      .select({
        theme: theme,
        mode: mode,
        display: display,
        buttons: [],
        lang: lang,
        showLabel: false,
        showInput: true,
        data: mad.common.variables.countries,
        dataText: "value",
        dataValue: "value",
        dataGroup: "letter",
        height: 40,
        rows: 9,
        readonly: false,
        group: false,
        layout: "liquid",
        onValueTap: function(item, inst) {
          var obj = $(item.context);
          if (!mad.common.isNullOrEmpty(obj)) {
            console.log("odabrano je", obj.textContent);
            viewModel.data.set("country", obj.textContent);
            countryChanged();
            //    checkFields();
            inst.hide(false, "set");
          }
        },
        onClose: function(valueText, botun, inst) {
          console.log("close s botunom", botun);
          if (botun == "cancel") {
            viewModel.data.set("country", viewModel.get("countryBefore"));
          }
        },
        onBeforeShow: function(inst) {
          viewModel.set("countryBefore", viewModel.data.get("country"));
        }
      });

    $("#Rstate")
      .mobiscroll()
      .select({
        theme: theme,
        mode: mode,
        display: display,
        buttons: [],
        lang: lang,
        showLabel: false,
        showInput: true,
        data: mad.common.variables.USAstates,
        dataText: "value",
        dataValue: "value",
        dataGroup: "letter",
        height: 40,
        rows: 9,
        readonly: false,
        group: false,
        layout: "liquid",
        onValueTap: function(item, inst) {
          var obj = $(item.context);
          if (!mad.common.isNullOrEmpty(obj)) {
            console.log("odabrano je", obj.textContent);
            viewModel.data.set("state", obj.textContent);
            inst.hide(false, "set");
          }
        },
        onClose: function(valueText, botun, inst) {
          console.log("close s botunom", botun);
          /*
                if (botun == 'cancel'){
                }
                */
        },
        onBeforeShow: function(inst) {
          //viewModel.set("stateBefore", viewModel.data.get("State"));
        }
      });
  }
  function fbSignup() {
    mad.common.showLoaderNoCancel();

    mad.analyticEvents.track(
      [mad.analyticEvents.services.GA, mad.analyticEvents.MIXP],
      mad.analyticEvents.categories.REGISTRATION,
      mad.analyticEvents.types.EVENT,
      "Registration Process - Choose Sign Up method Facebook",
      null,
      "Registration Process",
      "Choose Sign Up method Facebook"
    );

    facebookConnectPlugin.login(
      ["email"], // array of permissions
      function(response) {
        if (response.status === "connected") {
          // contains the 'status' - bool, 'authResponse' - object with 'session_key', 'accessToken', 'expiresIn', 'userID'
          getFBInfo(
            response.authResponse.accessToken,
            response.authResponse.userID
          );
        } else {
          mad.common.hideLoaderNoCancel();
          console.log("response nije bio connected");
        }
      },
      function(failedResponse) {
        mad.common.hideLoaderNoCancel();
        console.log(failedResponse);
        mad.alerts.error0("Please try again or login with email");
      }
    );
  }

  function openToU() {
    mad.mobileApp.navigate(
      "ui/other/ToU.html?origin=registration",
      "overlay:up"
    );
  }

  function openPP() {
    mad.mobileApp.navigate(
      "ui/other/PP.html?origin=registration",
      "overlay:up"
    );
  }

  function getFBInfo(fbToken, fbUserId) {
    console.log("getFBToken");

    mad.common.showLoaderNoCancel();

    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/account/GetFacebookInfo";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = {
            Token: fbToken,
            UserId: fbUserId
        };
        */
    var link = {
      putanja: mad.common.variables.serverUrl + "api/account/GetFacebookInfo",
      akcija: "POST"
    };
    var podaci = {
      Token: fbToken,
      UserId: fbUserId
    };

    mad.data
      .load(link, podaci)
      .done(function(data) {
        mad.common.hideLoaderNoCancel();

        if (data.hasOwnProperty("token")) {
          mad.local.saveToken(data.token);
          mad.loginToken = data.token;
          mad.local.saveVariable("username", data.username);
          mad.common.variables.username = data.username;
          mad.local.saveVariable("fbUserId", data.facebookUserId);
          mad.local.saveVariable("facebookToken", data.facebookToken);

          console.log("user has token", data);

          viewModel.data.set("firstname", data.firstName);
          viewModel.data.set("lastname", data.lastName);
          viewModel.data.set("email", data.email);

          //    get other user info
          var promise = $.Deferred();
          promise.then(
            function(success) {
              mad.common.hideLoaderNoCancel();
              mad.mobileApp.navigate("ui/workouts/menu.html?origin=start"); // show first view
            },
            function(fail) {
              mad.common.hideLoaderNoCancel();
              console.log("getUserInfo failed");
              mad.mobileApp.navigate("ui/workouts/menu.html?origin=start"); // show first view
            }
          );
          mad.common.getUserInfo(promise, false);
        } else {
          viewModel.data.set("firstname", data.firstName);
          viewModel.data.set("lastname", data.lastName);
          viewModel.data.set("email", data.email);
          viewModel.set("fbInfo", data);
          viewModel.set("isRegisterWithFacebook", true);
          prepareData();
        }
      })
      .fail(function(e) {
        mad.common.hideLoaderNoCancel();
        var por = JSON.parse(e.responseText);
        console.log("Error getting info ", e);
        mad.alerts.error0(por.error_description);
        next();
      });
  }

  function isValidContent(name) {
    name = name.trim();
    //var regex = /^[a-zA-Z0-9-_.]+$/;
    var regex = /^[a-zA-Z]+$/;
    return regex.test(name);
  }

  function isValidLength(name) {
    name = name.trim();
    var tempResult = true;

    if (name.length > 15) {
      tempResult = false;
    }
    return tempResult;
  }

  function isValidPass(pass) {
    if (viewModel.get("isRegisterWithFacebook")) {
      return true;
    }

    if (pass && pass.length >= 6) {
      return true;
    }

    return false;
  }

  function isEmail(email) {
    email = email.trim();
    if (email.length < 6) {
      return false;
    } else {
      return validateEmail(email);
    }
  }

  function validateEmail(email) {
    var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
  }

  function handleTopOfToast() {
    /*
        var topIs = 0;
        if (mad.common.variables.keyboard.opened) {
            //topIs = mad.common.variables.keyboard.offset + "px";
            topIs = getPageOffset().y + "px";
            console.log(topIs);
        }
        */
    setTimeout(function() {
      var topIs = getPageOffset().y - 50 + "px"; // -50 zbog css-a
      $("#toast-container").attr("style", "top:" + topIs + " !important");
    }, 111);
  }

  function getPageOffset() {
    var supportPageOffset = window.pageXOffset !== undefined;
    var isCSS1Compat = (document.compatMode || "") === "CSS1Compat";
    var x = supportPageOffset
      ? window.pageXOffset
      : isCSS1Compat
        ? document.documentElement.scrollLeft
        : document.body.scrollLeft;
    var y = supportPageOffset
      ? window.pageYOffset
      : isCSS1Compat
        ? document.documentElement.scrollTop
        : document.body.scrollTop;

    return {
      x: x,
      y: y
    };
  }

  function clientControlsOK() {
    if (!isEmail(mad.viewModels.register.viewModel.data.get("email"))) {
      mad.alerts.top("Empty or invalid email");
      $("#Rmail").focus();
      handleTopOfToast();
      return false;
    } else if (
      !isValidPass(mad.viewModels.register.viewModel.data.get("password"))
    ) {
      mad.alerts.top("Password is too short");
      $("#Rpass").focus();
      handleTopOfToast();
      return false;
    } else if (
      !isValidContent(mad.viewModels.register.viewModel.data.get("firstname"))
    ) {
      mad.alerts.top("First name is empty or contains invalid characters");
      $("#Rfirst").focus();
      handleTopOfToast();
      return false;
    } else if (
      !isValidContent(mad.viewModels.register.viewModel.data.get("lastname"))
    ) {
      mad.alerts.top("Last name is empty or contains invalid characters");
      $("#Rlast").focus();
      handleTopOfToast();
      return false;
    } else if (
      !isValidLength(mad.viewModels.register.viewModel.data.get("firstname"))
    ) {
      mad.alerts.top("First name is too long");
      $("#Rfirst").focus();
      handleTopOfToast();
      return false;
    } else if (
      !isValidLength(mad.viewModels.register.viewModel.data.get("lastname"))
    ) {
      mad.alerts.top("Last name is too long");
      $("#Rlast").focus();
      handleTopOfToast();
      return false;
    }
    return true;
  }

  return {
    viewModel: viewModel
  };
})();
