var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.start = (function () {

   "use strict";

   var viewModel = kendo.observable({ 
       // properties or functions we want to observe and expose to html
       common: mad.common.observables,

       init: initView,
       show: showView,
       afterShow: afterShow,
       isButtonVisibleL: true,
       leftButtonAction: leftButtonAction,
       isButtonVisibleR: true,
       rightButtonAction: rightButtonAction,
       /*
       enableIfOfflineL: checkifOnline,
       enableIfOfflineR: checkifOnline
       */
       enableIfOfflineL: true,
       enableIfOfflineR: true

   });

    function initView(e){
        console.log("init start");
    };

    function showView(e){
        console.log("show start");
        var that = this;                                    // all methods & properties of viewModel
        mad.common.setActualView(); mad.common.addViewToHistory();
        kendo.bind($(mad.common.$actualViewID), viewModel);
        mad.common.setLangForView();                        //add language name class to each class

        var contentHeight = parseInt(mad.mobileApp.view().content.height());
        $("#start-view .photo").css("height", contentHeight);
    }

    function afterShow(e){
        console.log("after show start");
        var contentHeight = parseInt(mad.mobileApp.view().content.height());
        $("#start-view .photo").css("height", contentHeight);

        mad.googleAnalytics.trackView("First Screen Ever");
        mad.appTelemetry.trackPageView("Start Screen");

    };

    function leftButtonAction(){
        if (this.common.ifOffline()){
            mad.alerts.realTop0(mad.common.translate("words", "offline"));
        }else{
            mad.mobileApp.navigate("ui/other/register.html", "slide:left");
        }
    }

    function rightButtonAction(){
        if (this.common.ifOffline()){
            mad.alerts.realTop0(mad.common.translate("words", "offline"));
        }else{
            mad.mobileApp.navigate("ui/other/login.html", "slide:left");
        }
    }

    function checkifOnline(){
        return this.common.ifOnline();
    };


    return {
        viewModel: viewModel
    };

}());

