var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.workoutVideo = (function() {
  "use strict";

  var viewModel = kendo.observable({
    // properties or functions we want to observe and expose to html
    common: mad.common.observables,
    selectedExercise: {},
    workoutImg: getWorkoutImg,
    openVideoModal: openVideoModal,
    closeVideoModal: closeVideoModal,
    onPlayVideoClick: onPlayVideoClick,
    folderName: "mdbrzvideo",
    filePath: "",
    videoUri: "",
    muscleIds: [],
    countdownTimerStopped: false,
    workoutTimerStopped: false,
    pauseTimerStopped: false,

    countdownTimerValue: 0,
    workoutTimerValue: 0,
    pauseTimerValue: 0,

    modalOpened: false,
    isIpad: false,

    playingVideo: false,
    videoIsOn: false
  });

  function getWorkoutImg() {
    return mad.common.showImage(
      viewModel.selectedExercise.get("ImageUrlMobile"),
      "exercise"
    );
  }

  function openVideoModal() {
    var imgPlaceholder, backImage;
    viewModel.set("videoIsOn", false);

    var ipad = device.model.indexOf("iPad") > -1;
    viewModel.set("isIpad", ipad);
    console.log(ipad);

    viewModel.set("modalOpened", true);

    $("#madbarzWorkoutVideo").removeClass("hidden");
    var mv = $("#madbarzWorkoutVideo").data("kendoMobileModalView");

    mv.open();

    var visina = $("#madbarzWorkoutVideo")
      .parent()
      .height();

    $("#madbarzWorkoutVideo").css("height", visina);
    $("#madbarzWorkoutVideoContainer").css("height", visina);
    mv.scroller.reset();

    console.log("selected exercise je", viewModel.get("selectedExercise"));

    imgPlaceholder = $("#madbarzWorkoutVideo .exercise-img");
    imgPlaceholder.css("height", parseInt(visina / 2.5));
    backImage = "";
    imgPlaceholder.css("background-image", 'url("' + backImage + '")');
    imgPlaceholder.removeClass("after-load").addClass("before-load");

    setTimeout(function() {
      imgPlaceholder.css("background-image", 'url("' + getWorkoutImg() + '")');
      imgPlaceholder.addClass("after-load");
    }, 500);

    $("#exercise-name").html(viewModel.get("selectedExercise.Name"));
    $("#exercise-desc").html(viewModel.get("selectedExercise.Description"));

    var exerciseIdToFind = viewModel.get("selectedExercise.ExerciseId");
    var nadjeno = _.find(
      mad.viewModels.createWorkoutExercises.viewModel.nonFilterData,
      "ExerciseId",
      exerciseIdToFind
    );
    if (nadjeno) {
      viewModel.set("muscleIds", nadjeno.MuscleIds);
    } else {
      viewModel.set("muscleIds", []);
    }

    // generate muscle man -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

    $("#madbarzWorkoutVideo .muscle-imgs").empty();
    $("#help-muscles")
      .removeClass("after-load")
      .addClass("before-load-no-scale");

    var musclesTemplate = kendo.template($("#general-muscles-template").html());
    var musclesHTML = musclesTemplate(viewModel); // za gender
    $("#help-muscles").html(musclesHTML);

    // generate muscle imgs
    musclesTemplate = kendo.template($("#MuscleMapTemplate").html(), {
      useWithBlock: false
    });
    musclesHTML = musclesTemplate(viewModel.get("muscleIds"));
    $("#madbarzWorkoutVideo .muscle-imgs").html(musclesHTML);

    var contentHeight = $(window).height();
    var contentWidth = $(window).width(); // jquery width

    var reduce = 25 / 100; //percentage
    var muscleManContainerHeight = contentHeight - contentHeight * reduce;

    $("#help-muscles .muscles-container").css(
      "height",
      muscleManContainerHeight
    );
    scaleMuscleMan(muscleManContainerHeight, contentWidth, 10);

    setTimeout(function() {
      $("#help-muscles").addClass("after-load");
    }, 999);

    mad.googleAnalytics.trackView("Exercise Description Modal");

    if (ipad) {
      var w = mad.common.actualView.content.width();
      $("#videoPlayerIpad").width(w);
      $("#videoPlayerIpad").css("height", parseInt(visina / 2.5));

      downloadIpadVideo();
    }
  }

  function closeVideoModal(e) {
    var player,
      isIpad = viewModel.get("isIpad");

    viewModel.set("modalOpened", false);
    viewModel.set("videoIsOn", false);

    /*
        if (isIpad) {
            player = document.getElementById("videoPlayerIpad");

        } else {
            player = document.getElementById("videoPlayer");

        }

        if (!player.paused) {
            player.pause();

        }
        */

    // $("#video")
    //   .children()
    //   .filter("video")
    //   .each(function() {
    //     this.pause(); // can't hurt
    //     delete this; // @sparkey reports that this did the trick (even though it makes no sense!)
    //     $(this).remove(); // this is probably what actually does the trick
    //   });
    $("#videoPlayer").each(function() {
      this.pause();
    });

    $("#videoPlayer").empty();
    $("#videoPlayerIpad").empty();

    var mv = $("#madbarzWorkoutVideo").data("kendoMobileModalView");
    mv.close();
    $("#madbarzWorkoutVideo").addClass("hidden");
    $("#video-place-holder").removeClass("hide-play");

    if (viewModel.get("pauseTimerStopped") == true) {
      // ako se islo gledat video na pauzi - pause counter je stopiran
      if (
        !mad.viewModels.madbarzExercising.viewModel.get("pauseStoppedStatus")
      ) {
        // ako pause counter nije stopiran gumbom start/stop nastavi odbrojavanje
        mad.viewModels.madbarzWorkout.pauza.brojac.resume(
          viewModel.get("pauseTimerValue")
        );
        viewModel.set("pauseTimerStopped", false);
      }
    } else if (viewModel.get("countdownTimerStopped") == true) {
      //mad.viewModels.madbarzExercising.odbrojavanje.brojac.resume(viewModel.get("countdownTimerValue"));
      var num = viewModel.get("countdownTimerValue");
      num -= 1;
      mad.viewModels.madbarzExercising.odbrojavanje.brojac.resume(num);
      viewModel.set("countdownTimerStopped", false);
    } else if (viewModel.get("workoutTimerStopped") == true) {
      mad.viewModels.madbarzExercising.vjezbanje.brojac.resume(
        viewModel.get("workoutTimerValue")
      );
      mad.viewModels.madbarzExercising.viewModel.set(
        "workoutTimerActive",
        true
      );

      viewModel.set("workoutTimerStopped", false);
    }
  }

  function scaleMuscleMan(tabContainerH, tabContainerW, reducePercent) {
    var w = tabContainerW - tabContainerW * (reducePercent / 100);
    var h = tabContainerH - tabContainerH * (reducePercent / 100);

    // original image dims
    var originalWidth = 398;
    var originalHeight = 450;

    var scaleFactorWidth = w / originalWidth;
    var scaleFactorHeight = h / originalHeight;
    var scaleFactor =
      scaleFactorWidth < scaleFactorHeight
        ? scaleFactorWidth
        : scaleFactorHeight;

    w = parseInt(originalWidth * scaleFactor);
    h = parseInt(originalHeight * scaleFactor);

    //console.log("muscleMan", w, h);

    $("#help-muscles .madbarz-muscle-map").css("width", w);
    $("#help-muscles .madbarz-muscle-map").css("height", h);
  }

  function onPlayVideoClick(e) {
    e.preventDefault(); // da ne probija

    if (mad.viewModels.profile.viewModel.common.ifOffline()) {
      mad.alerts.error("you are offline", "");
      return;
    }
    var exerciseName = viewModel
      .get("selectedExercise.Name")
      .replace(/\s+/g, "-");
    $("#videoPlayer").empty();
    getFilesystem(
      function(fileSystem) {
        var filePath = "";
        getFolder(
          fileSystem,
          viewModel.get("folderName"),
          function(folder) {
            if (device.platform === "Android") {
              filePath = folder.toURL() + "/" + exerciseName + ".mp4";
            } else {
              filePath =
                window.cordova.file.documentsDirectory +
                "/mdbrzvideo/" +
                exerciseName +
                ".mp4";
            }

            viewModel.set("filePath", filePath);
            viewModel.set("videoUri", filePath);
            window.resolveLocalFileSystemURL(filePath, playVideo, transferFile);
          },
          function() {
            console.log("failed to get folder");
          }
        );
      },
      function() {
        console.log("failed to get filesystem");
      }
    );
  }

  function transferFile() {
    mad.common.showLoader("downloading");
    console.log("krece download");

    var isOffline = mad.viewModels.profile.viewModel.common.ifOffline();

    if (isOffline) {
      mad.alerts.error("you are offline", "");
      return;
    }
    var transfer = new FileTransfer();
    transfer.download(
      viewModel.get("selectedExercise.VideoUrl"),
      viewModel.get("filePath"),
      function(entry) {
        var targetPath = entry.toURL();
        viewModel.set("videoUri", targetPath);
        playVideo();
      },
      function(error) {
        mad.common.hideLoader();
        console.log("download error source " + error.source);
        console.log("download error target " + error.target);
        console.log("upload error code" + error.code);
        mad.alerts.error("error downloading video");
      }
    );
  }
  function playVideo() {
    var player, player$, cssClass;

    mad.common.hideLoader();
    console.log("idem playat video");

    mad.viewModels.workoutVideo.viewModel.set("playingVideo", true);

    var uri = viewModel.get("videoUri");
    var androidUri = uri;

    if (device.platform === "Android") {
      if (window.plugins) {
        window.plugins.streamingMedia.playVideo(androidUri);
      }
    } else {
      var isIpad = viewModel.get("isIpad");

      if (isIpad) {
        player = document.getElementById("videoPlayerIpad");
        player$ = $("#videoPlayerIpad");
        cssClass = "before-load-no-scale";
      } else {
        player = document.getElementById("videoPlayer");
        player$ = $("#videoPlayer");
        cssClass = "before-load";
      }
      //player$.removeClass("after-load").addClass(cssClass);

      var source = document.createElement("source");
      source.src = uri;
      source.type = "video/mp4";
      player.appendChild(source);
      //player$.find("source").css("margin", "auto");
      viewModel.set("videoIsOn", true);
      player.load();
      $("#video-place-holder").addClass("hide-play");
      player.play();
      //   setTimeout(function() {
      //     player$.addClass("after-load");
      //   }, 500);
      //  $("#videoPlayer").show();
    }
  }

  function downloadIpadVideo() {
    var exerciseName = viewModel
      .get("selectedExercise.Name")
      .replace(/\s+/g, "-");
    $("#videoPlayerIpad").empty();

    getFilesystem(
      function(fileSystem) {
        var filePath = "";
        getFolder(
          fileSystem,
          viewModel.get("folderName"),
          function(folder) {
            filePath =
              window.cordova.file.documentsDirectory +
              "/mdbrzvideo/" +
              exerciseName +
              ".mp4";
            viewModel.set("filePath", filePath);
            viewModel.set("videoUri", filePath);
            window.resolveLocalFileSystemURL(filePath, playVideo, transferFile);
          },
          function() {
            console.log("failed to get folder");
          }
        );
      },
      function() {
        console.log("failed to get filesystem");
      }
    );
  }
  function getFilesystem(success, fail) {
    window.requestFileSystem =
      window.requestFileSystem || window.webkitRequestFileSystem;
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, success, fail);
  }

  function getFolder(fileSystem, folderName, success, fail) {
    fileSystem.root.getDirectory(
      folderName,
      { create: true, exclusive: false },
      success,
      fail
    );
  }

  return {
    viewModel: viewModel
  };
})();
