var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.plans = (function() {
  "use strict";
  var viewModel = kendo.observable({
    common: mad.common.observables,
    init: initView,
    before: beforeShow,
    show: showView,
    afterShow: afterShow,
    loadingListData: true,
    planoviDataSource: {},

    requirements: "",
    categoryImg: "",

    isModalOpened: false,

    firstTimeHere: false,
    refresh: false,
    reload: false,
    updateStatus: updateStatus,

    filterItemsCreated: false,
    brojPodataka: 0,
    imaPodataka: imaPodataka,
    filterSelectedGender: filterSelectedGender,
    closeFilter: closeFilter,
    resetFilterPlan: resetFilter,
    saveFilterPlan: saveFilter,
    planoviVecUcitani: false,

    threshold: 123,
    divisor: 6,

    allLoaded: false,
    noPlans: true,
    selectedPlan: {},
    origin: "",

    selectedCategory: "Beginner",
    selectedGender: "",
    previousFilterValues: {},
    filterValues: {},

    uCanTouchThis: false
  });

  /*
    viewModel.bind("change", function(e) {
        if (e.field == "selectedCategory"){
            console.log("   - - - selectedCategory", viewModel.get("selectedCategory"));
        }
    });
    */

  var filterTAGs = [
    {
      ime: "No equipment",
      tag: "No equipment",
      order: 1,
      selected: false
    },
    {
      ime: "Pullup bar",
      tag: "Pullup bar",
      order: 2,
      selected: false
    },
    {
      ime: "Dip bar",
      tag: "Dip bar",
      order: 3,
      selected: false
    }
  ];
  var filterOFF = {};

  var scroller;

  function initView(e) {
    console.log("planovi init view");

    var top = 0,
      lastTop = 0,
      osjetljivost = 0,
      visina = 555,
      tmpVisina;

    tmpVisina = $(window).height();
    if (tmpVisina > visina) {
      visina = tmpVisina;
    }
    visina *= 1.5;

    // for lazy loading images
    bLazy = new Blazy({
      offset: parseInt(visina), // Loads images (dev height) before they're visible (default 100px)
      success: function(ele) {
        // Image has loaded
        //console.log("loaded image", ele);
      },
      error: function(ele, msg) {
        console.log("error loading img", ele, msg);
        // pregazi defaultno da se vidi bar tekst
        $(ele)
          .addClass("b-loaded noImage")
          .removeClass("b-error");
      }
    });

    var viewID = "#plans";
    viewModel.set("filterItemsCreated", false);
    viewModel.set("uCanTouchThis", false);

    scroller = e.view.scroller;

    scroller.bind("scroll", function(e) {
      osjetljivost = viewModel.get("threshold");
      var top = parseInt(e.scrollTop);
      if (top < osjetljivost) {
        //$("#plans-bottom").removeClass("disappear");
      } else {
        //$("#plans-bottom").addClass("disappear");
        if (Math.abs(top - lastTop) > osjetljivost) {
          lastTop = top;
          bLazy.revalidate();
          //console.log("revalidate");
        }
      }
    });

    $(viewID).kendoTouch({
      filter: ".lButton, .filterButton, .presentPlan, .renew",

      touchstart: function(e) {
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          if (scroller) {
            if (scroller.enabled) {
              scroller.disable();
            }
          }
        } else {
          if (scroller) {
            if (!scroller.enabled) {
              scroller.enable();
            }
          }
        }
      },
      tap: function(e) {
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
        } else {
          handleTap(e);
        }
      }
    });

    var level = mad.local.loadVariable("FitnessLevel");
    if (!mad.common.isNullOrEmpty(level)) {
      viewModel.set("selectedCategory", level);
      viewModel.set("selectedLevel", level);
      mad.local.saveVariable("selectedLevel", level);
    } else {
      viewModel.set("selectedCategory", "Beginner");
    }

    viewModel.planoviDataSource = kendo.data.DataSource.create({ data: [] });

    $("#plans-all-list").kendoMobileListView({
      dataSource: viewModel.planoviDataSource,
      template: function(data) {
        var tpl = kendo.template($("#plans-list-template-full").text());
        console.log("element liste", data.WorkoutPlanData.Name);
        return tpl(data);
      },
      endlessScroll: false
    });

    viewModel.set("planoviVecUcitani", false);
  }

  function handleTap(e) {
    e.preventDefault(); // da ne probija

    var element = e.touch.target;

    if ($(element).hasClass("lButton")) {
      mad.mobileApp.navigate("ui/workouts/menu.html", "slide:left");
    } else if ($(element).hasClass("filterButton")) {
      openFilterModal();
    } else if ($(element).hasClass("presentPlan")) {
      presentPlan(e);
    } else if ($(element).hasClass("renew")) {
      explainPro();
    }
  }

  function beforeShow() {
    viewModel.set("uCanTouchThis", false);
    $(".plans .km-content").removeClass("loaded");
  }

  function showView(e) {
    var origin = e.view.params.origin;
    viewModel.set("origin", origin);

    mad.common.setActualView();
    mad.common.addViewToHistory();

    // bind viewModel to view
    if (mad.common.$actualViewID == "#plans") {
      kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    var level = mad.local.loadVariable("selectedLevel");
    if (!mad.common.isNullOrEmpty(level)) {
      viewModel.set("selectedCategory", level);
    } else {
      mad.local.saveVariable("selectedLevel", "Beginner");
      viewModel.set("selectedCategory", "Beginner");
    }

    viewModel.set("firstTimeHere", mad.common.checkTutorial("visitedPlans"));

    if (viewModel.get("firstTimeHere")) {
      showPreloader();
      setTimeout(closePreloader, 3444);
    }

    var winH = $(window).height();
    var winW = $(window).width();

    /*if (origin == "workoutMenu") {
            $(mad.common.$actualContainerID).css({"height": (winH + 2), "width": winW});

            viewModel.set("refresh", false);
            viewModel.set("reload", false);
            viewModel.set("threshold", winH / viewModel.get("divisor"));

            if (mad.common.isNullOrEmpty(viewModel.planoviDataSource) || viewModel.planoviDataSource.data().length == 0) {
                console.log("prazno - nema nista u planoviDataSource - ucitaj ih");
                if (!viewModel.get("planoviVecUcitani")) {
                    console.log("planovi jos nisu ucitani - ucitavanje");
                    viewModel.set("loadingListData", true);
                    readPlans();
                } else {
                    console.log("planovi su vec ucitani - primjeni filter");
                    viewModel.set("planoviVecUcitani", false);
                    applyFilter(false);
                }
            } else {
                console.log("postoje podaci u planovima - primjeni filter");
                applyFilter(false);
            }

        }*/

    if (origin == "settings" || origin == "workoutMenu") {
      $(mad.common.$actualContainerID).css({ height: winH + 2, width: winW });
      viewModel.set("refresh", false);
      viewModel.set("reload", false);
      viewModel.set("threshold", winH / viewModel.get("divisor"));
      viewModel.set("loadingListData", true);
      readPlans();
    } else {
      console.log("ne dolazi s workoutMenu");
      if (viewModel.get("refresh")) {
        if (viewModel.get("reload")) {
          console.log("potreban je reload");
          readPlans();
        } else {
          console.log("potreban je refresh");
          $("#plans-all-list")
            .data("kendoMobileListView")
            .refresh();
          bLazy.revalidate();
        }
      }
    }
  }

  function afterShow(e) {
    viewModel.set("uCanTouchThis", true);

    if (viewModel.get("origin") == "workoutMenu") {
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA, mad.analyticEvents.services.FB],
        mad.analyticEvents.categories.WORKOUTPLAN,
        mad.analyticEvents.types.VIEW,
        "Workout plan screen loaded",
        null,
        "Workout plan",
        "Screen loaded"
      );
      mad.appsFlyer.trackEvent("Workout plans screen loaded");
    }

    if (viewModel.get("firstTimeHere")) {
      mad.local.appendUsernameTo("visitedPlans", mad.common.variables.username);
    }
    $(".plans .km-content").addClass("loaded");
  }

  function readPlans() {
    console.log("ucitavanje planova za kategoriju");

    mad.models.plansCategory.read().then(
      function() {
        // read OK (promise finished)
        viewModel.set("noPlans", false);
        viewModel.set("loadingListData", false);
        viewModel.set("planoviVecUcitani", true);
        createListOfPlans();
      },
      function() {
        // read failed
        console.log("greska - planovi po kategorijama nisu ucitani");
      }
    );
  }

  function createListOfPlans() {
    console.log("createListOfPlans");
    $("#plans-all-list")
      .data("kendoMobileListView")
      .setDataSource(viewModel.get("planoviDataSource"));

    // loadaj lokalno spremljeni filter
    var savedFilterValues = mad.local.loadVariableParse("plans-filter");

    if (mad.common.isNullOrEmpty(savedFilterValues)) {
      //console.log("nema nista u plans-filter (local storage) - filtriraj po defaultu");
      var level = mad.local.loadVariable("FitnessLevel");
      if (!mad.common.isNullOrEmpty(level)) {
        viewModel.set("selectedCategory", level);
        viewModel.set("selectedLevel", level);
      } else {
        viewModel.set("selectedCategory", "Beginner");
      }
      $("#filterLevel li").removeClass("selected");
      $("#filterLevel ." + level).addClass("selected");

      var gender = $("#filterGenderPlan").data("kendoMobileButtonGroup");
      var userGender = mad.common.variables.gender;
      if (userGender == "m") {
        gender.select(0);
        viewModel.set("selectedGender", "Male");
      } else {
        gender.select(1);
        viewModel.set("selectedGender", "Female");
      }

      $("#filterPlanTags li").removeClass("selected");

      doFiltering(); // ce izmedju ostalog postavit filterValues na osnovu selectedCategory, selectedGender i selektiranih tagova

      // spremi filter parametre i zatvori
      mad.local.saveVariableParse(
        "plans-filter",
        viewModel.get("filterValues")
      );

      mad.common.scrollViewToTop();
      bLazy.revalidate(); // to show img before scrolling
    } else {
      //console.log("primjeni prethodno spremljeni filter");
      applyFilter();
    }
  }

  function applyFilter() {
    //console.log("applyFilter");

    var filterData,
      filter = getFilter();

    if (filter.reset) {
      filterData = filterOFF;
    } else {
      filterData = setFilter(filter);
    }

    viewModel.planoviDataSource.filter(filterData);

    if (mad.common.isNullOrEmpty(viewModel.planoviDataSource)) {
      viewModel.set("brojPodataka", 0);
    } else {
      viewModel.set("brojPodataka", viewModel.planoviDataSource.view().length);
    }

    mad.common.scrollViewToTop();
    bLazy.revalidate(); // to show img before scrolling

    mad.googleAnalytics.trackEvent(
      "Used Filter",
      "Click - Plans Filter",
      filter
    );
  }

  function presentPlan(e) {
    var listview = $("#plans-all-list").data("kendoMobileListView");
    var tappedElement = e.touch.target;
    var li = tappedElement.closest("li");
    var selectedItem = listview.dataSource.getByUid(li.attr("data-uid"));

    viewModel.set("selectedPlan", selectedItem);

    if (!mad.common.isNullOrEmpty(selectedItem)) {
      viewModel.set("refresh", false);
      viewModel.set("reload", false);

      mad.common.handleFeedTap(
        "plans",
        listview,
        tappedElement,
        selectedItem,
        0
      ); //parms:origin, listview, tappedElement, selectedItem, tab
    }
  }

  function explainPro() {
    var data = {
      Source: "Click on plan"
    };
    mad.analyticEvents.track(
      [mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP],
      mad.analyticEvents.categories.SALES,
      mad.analyticEvents.types.EVENT,
      "Pro Converter - Renew subscription",
      data,
      "Pro Converter",
      "Renew subscription",
      "Click on plan"
    );

    mad.mobileApp.navigate("ui/PRO/explain.html", "overlay:up");
  }

  function openFilterModal() {
    viewModel.set("isModalOpened", true);

    $("#plans").addClass("blured");

    var modalID = $("#planCategories");
    var modalIDheader = $("#planCategories header");
    var modalIDcontainer = $("#planCategoriesContainer");

    modalID.removeClass("hidden");

    var mv = modalID.data("kendoMobileModalView");
    mv.open();

    var modalParentH = parseInt(modalID.parent().height());
    var modalHeaderH = parseInt(modalIDheader.height());

    modalID.css("height", modalParentH);
    modalIDcontainer.css("height", modalParentH - modalHeaderH + 2);
    mv.scroller.reset();

    var gender = $("#filterGenderPlan").data("kendoMobileButtonGroup");
    var userGender = mad.common.variables.gender;
    var filterTags = document.getElementById("filterPlanTags");

    if (!viewModel.get("filterItemsCreated")) {
      viewModel.set("filterItemsCreated", true);
      $("#filterLevel .gumb").kendoTouch({
        tap: function(e) {
          filterSelectedLevel(e);
        }
      });
      createTagButtons(filterTags);
      assignTouchEventsToTags("#filterPlanTags li");
    }

    var filter = getFilter();

    // store previous filter
    viewModel.set("previousFilterValues", filter);

    if (filter.reset) {
      var levelName = mad.local.loadVariable("selectedLevel");

      $("#filterLevel li").removeClass("selected");
      $("#filterLevel ." + levelName).addClass("selected");

      // gender ce raditi s Male i Female
      if (userGender == "m") {
        gender.select(0);
        viewModel.set("selectedGender", "Male");
      } else {
        gender.select(1);
        viewModel.set("selectedGender", "Female");
      }
      $("#filterPlanTags li").removeClass("selected");
    } else {
      $("#filterLevel li").removeClass("selected");
      $("#filterLevel ." + filter.selectedCategory).addClass("selected");
      if (filter.selectedGender == "Male") {
        gender.select(0);
        viewModel.set("selectedGender", "Male");
      } else {
        gender.select(1);
        viewModel.set("selectedGender", "Female");
      }
      $("#filterPlanTags li").removeClass("selected");
      if (!mad.common.isNullOrEmpty(filter.selectedTags)) {
        _.forEach(filter.selectedTags, function(obj) {
          $("#filterPlanTags li[tag='" + obj + "']").addClass("selected");
        });
      }
    }

    doFiltering();
  }

  function closeModal(e) {
    var mv = $("#planCategories").data("kendoMobileModalView");
    mv.close();

    viewModel.set("isModalOpened", false);

    $("#planCategories").addClass("hidden");
    $("#plans").removeClass("blured");
  }

  function createTagButtons(container) {
    var sortiraniTagovi = _.sortBy(filterTAGs, "order");

    _.forEach(sortiraniTagovi, function(obj, n) {
      var newLi = document.createElement("li"); // mora se uvijek kreirati novi node
      container.appendChild(newLi);
      newLi.innerText = obj.ime;
      var klase = "tagGumb";
      if (obj.selected) {
        klase += " selected";
      }
      newLi.className = klase;
      newLi.setAttribute("tag", obj.tag);
    });
  }

  function assignTouchEventsToTags(objekt) {
    $(objekt).kendoTouch({
      tap: function(e) {
        e.preventDefault(); // da ne probija
        var element = e.touch.target.context;

        var tag = $(element).attr("tag");
        var selected = $(element).hasClass("selected");
        var noEquipTag = $("#filterPlanTags li[tag='No equipment']");

        /*
                if (tag == "No equipment" && !selected){
                    // ako je odabran no equipment odselektiraj sve tagove
                    $("#filterPlanTags li").removeClass("selected");
                }
                $(element).toggleClass("selected");
                */
        if (tag == "No equipment") {
          // ako je odabran no equipment
          if (!selected) {
            // i sad ce bit selektiran odselektiraj sve tagove
            $("#filterPlanTags li").removeClass("selected");
          }
        } else {
          // neki je drugi tag selektiran
          $("#filterPlanTags li[tag='No equipment']").removeClass("selected"); // odselektiraj No equipment
        }

        $(element).toggleClass("selected");

        doFiltering();
      }
    });
  }

  function getSelectedTags() {
    var rez = [];
    $("#filterPlanTags .selected").each(function() {
      rez.push($(this).attr("tag"));
    });
    return rez;
  }

  function updateStatus(status) {
    /* called from other view models
        purpose is to update status & indicate that
        list of plans/parts needs refresh or reload
         */

    var id = viewModel.get("selectedPlan.WorkoutPlanId");
    var podaciNaListi = viewModel.get("planoviDataSource").data();
    var nadjeno = _.find(podaciNaListi, "WorkoutPlanId", id);
    console.log("updateStatus plana - find je", nadjeno);

    if (nadjeno) {
      viewModel.set("refresh", true);
      if (status == "cancelled") {
        viewModel.set("reload", true);
      } else {
        nadjeno.WorkoutPlanData.Status = status;
      }
    }
  }

  function filterSelectedLevel(e) {
    var tappedElement = e.touch.target;
    var li = tappedElement.closest("li");
    var selectedLevelNum = parseInt($(tappedElement).attr("data-value"));
    var actualLevelName = li.attr("class");
    var selectedLevelName = fitLevels[selectedLevelNum];

    $(li).removeClass("selected");
    $("#filterLevel ." + selectedLevelName).addClass("selected");

    mad.local.saveVariable("selectedLevel", selectedLevelName);
    viewModel.set("selectedCategory", selectedLevelName);

    /*
        viewModel.set("filterValues.selectedCategory", selectedLevelName);
        mad.local.saveVariableParse("plans-filter", viewModel.get("filterValues"));
        */
    doFiltering();
  }

  function filterSelectedGender() {
    var spolovi = ["Male", "Female"];
    var index = this.current().index();
    //console.log("filterSelectedGender value", spolovi[index]);
    viewModel.set("selectedGender", spolovi[index]);

    /*
        viewModel.set("filterValues.selectedGender", spolovi[index]);
        mad.local.saveVariableParse("plans-filter", viewModel.get("filterValues"));
        */
    doFiltering();
  }

  function getFilter() {
    //console.log("getFilter - loadanje iz local storagea");
    var savedFilterValues = mad.local.loadVariableParse("plans-filter");
    if (mad.common.isNullOrEmpty(savedFilterValues)) {
      //console.log("getFilter - filter prazan - postavi na reset");
      viewModel.filterValues.set("reset", true);
    } else {
      //console.log("getFilter - postoje podaci - postavljen filterValues");
      viewModel.set("filterValues", savedFilterValues);
      viewModel.set("selectedCategory", savedFilterValues.selectedCategory);
    }
    return viewModel.get("filterValues");
  }

  function setFilter(filter) {
    var selectedTags = filter.selectedTags;
    selectedTags.push(filter.selectedGender);

    return {
      logic: "and",

      filters: [
        //{ field: "WorkoutPlanData.Level", operator: "eq", value: viewModel.get("selectedCategory") },
        {
          field: "WorkoutPlanData.Level",
          operator: "eq",
          value: filter.selectedCategory
        },
        {
          field: "WorkoutPlanData.Tags",
          operator: function(Tags) {
            if (!selectedTags) {
              //console.log("nema selektiranih tagova - vraca true")
              return true;
            }
            if (!Tags) {
              //console.log("nema Tags - vrati false");
              return false;
            }
            var rez = filterByTag(Tags, selectedTags);
            //console.log("  TAG pronađen", rez);
            return rez;
          }
        }
      ]
    };
  }

  function filterByTag(tagovi, selektiraniTagovi) {
    if (selektiraniTagovi.length == 0) {
      return true;
    }
    var svi = _.every(selektiraniTagovi, function(value) {
      var sadrzi = tagovi.filter(function(tag) {
        //console.log("  " + tag.Name);
        return tag.Name === value;
      });
      var postoji = sadrzi.length > 0; // vrati true ako tag iz rutine odgovara selektiranom tagu
      //console.log("    vraca", postoji);
      return postoji;
    });

    return svi;
  }

  function doFiltering() {
    //console.log("---- filtering -----");
    var selektiraniTagovi;
    var filterValues = {};

    selektiraniTagovi = getSelectedTags();

    // spremi u viewmodel sve sto je setirano
    filterValues.reset = false; // means apply filter
    filterValues.selectedCategory = viewModel.get("selectedCategory");
    filterValues.selectedGender = viewModel.get("selectedGender");
    filterValues.selectedTags = selektiraniTagovi;
    viewModel.set("filterValues", filterValues);

    var filterData = setFilter(filterValues);
    viewModel.planoviDataSource.filter(filterData); // resetira b-loaded

    updateNumbers(); //of filtered records

    return viewModel.planoviDataSource.view().length;
  }

  function updateNumbers() {
    if (viewModel.planoviDataSource.length == 0) {
      return;
    }

    //update number of filtered data(beside filter icon)
    var selected;
    selected = viewModel.planoviDataSource.view().length;
    viewModel.set("brojPodataka", selected);

    var zerofilled = ("00" + selected).slice(-2); // zadnja 2

    $(".saveFilterPlan").addClass("efekt");
    $(".saveFilterPlan .value").text("(" + zerofilled + ")");

    setTimeout(function() {
      $(".saveFilterPlan").removeClass("efekt");
    }, 333);
  }

  function resetFilter() {
    $("#filterPlanTags li").removeClass("selected");
    viewModel.filterValues.set("reset", true);
    mad.local.saveVariableParse("plans-filter", viewModel.get("filterValues"));
    closeFilter();
  }

  function saveFilter() {
    var brp = viewModel.get("brojPodataka");
    if (brp == 0 || brp == "") {
      mad.alerts.error("No results, please filter again", "");
    } else {
      // spremi filter parametre i zatvori
      mad.local.saveVariableParse(
        "plans-filter",
        viewModel.get("filterValues")
      );
      closeFilter();
    }
  }

  function closeFilter() {
    applyFilter();
    closeModal();
  }

  function imaPodataka() {
    return viewModel.get("brojPodataka") > 1;
  }

  function showPreloader() {
    var w = parseInt(mad.mobileApp.view().content.width());
    $("#creatingPreloader")
      .removeClass("hidden")
      .css("width", w);
    var mv = $("#creatingPreloader").data("kendoMobileModalView");
    mv.open();
  }

  function closePreloader(e) {
    var mv = $("#creatingPreloader").data("kendoMobileModalView");
    mv.close();
    $("#creatingPreloader").addClass("hidden");
  }

  return {
    viewModel: viewModel
  };
})();
