var mad = mad || {};

mad.viewModels = mad.viewModels || {};


mad.viewModels.plansPresent = (function () {

    "use strict";
    var viewModel = kendo.observable({
        common: mad.common.observables,
        init: initView,
        beforeShow: beforeShow,
        show: showView,
        afterShow: afterShow,

        typeText: typeText,
        isItFreePlan: isItFreePlan,
        isOtp: isOtp,
        btnTxtStart: setBtnTxtStart,
        btnTxtGo: setBtnTxtGo,
        selected: {},
        img: "",
        footerVisible: true,
        notActive: checknotActive,
        isStartEnabled: true,

        threshold: 123,
        divisor: 6,

        PartName: "",
        origin: "",
        uCanTouchThis: false

    });

    function initView(e){
        var scroller = e.view.scroller;
        scroller.bind("scroll", function(e) {
            var top, osjetljivost;
            osjetljivost = viewModel.get("threshold");
            top = parseInt(e.scrollTop);
            if (top < osjetljivost){
                $("#present-bottom").removeClass("disappear");
            } else {
                $("#present-bottom").addClass("disappear");
            }
        });

        var viewID = "#plansPresent";
        viewModel.set("uCanTouchThis", false);

        $(viewID).kendoTouch({
            filter: ".lButton, .dButton",

            touchstart: function(e) {
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    if(scroller){
                        if (scroller.enabled){
                            scroller.disable();
                        }
                    }
                }else{
                    if(scroller){
                        if (!scroller.enabled) {
                            scroller.enable();
                        }
                    }
                }
            },
            tap: function(e) {
                //console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                }else{
                    handleTap(e);
                }
            }
        });

    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target;

        if ($(element).hasClass("lButton")) {
            mad.common.goBack();
        }else if ($(element).hasClass("startPlanBtn")) {
            if (viewModel.get("isStartEnabled")){
                startPlan();
            }else{
                console.log("start disabled");
            }
        }else if ($(element).hasClass("gotoPlanBtn")) {
            if (viewModel.get("isStartEnabled")){
                gotoPlan();
            }else{
                console.log("start disabled");
            }
        }
    }

    function beforeShow(){
        viewModel.set("uCanTouchThis", false);
        $("#present-bottom").addClass("before-load").removeClass("after-load");
        $("#presentFotka").addClass("before-load").removeClass("after-load");
    }

    function showView(e){
        var contentHeight, contentWidth;

        viewModel.set("isStartEnabled", false);

        var origin = e.view.params.origin;
        viewModel.set("origin", origin);
        console.log("present - showView - origin=", origin);
        viewModel.set("hasPro", -1);

        if (origin == "work"){
            viewModel.set("footerVisible", false);
        }else{
            viewModel.set("footerVisible", true);
        }

        // povlaci plan iz popisa planova (pa cak i kad se vraca s plansWork viewa
        viewModel.set("selected", mad.viewModels.plans.viewModel.get("selectedPlan"));

        viewModel.set("isStartEnabled", true);

        viewModel.set("img", "url('" + viewModel.selected.get("WorkoutPlanData.ImageUrl") + "')");
        viewModel.set("PartName", "Part " + viewModel.selected.get("WorkoutPlanData.CategoryOrdinal"));
        viewModel.selected.set("DurationWeeks", viewModel.selected.get("WorkoutPlanData.Duration"));
        viewModel.selected.set("TypeOfPlan", viewModel.selected.get("WorkoutPlanData.Type"));
        viewModel.selected.set("Author", viewModel.selected.get("WorkoutPlanData.Author"));
        

        viewModel.selected.set("TagsList", viewModel.selected.get("WorkoutPlanData.Tags").join(", "));

        mad.common.setActualView(); mad.common.addViewToHistory();
        contentHeight = mad.common.stretchViewContentToBeElastic();
        kendo.bind($(mad.common.$actualViewID), viewModel);

        viewModel.set("threshold", contentHeight / viewModel.get("divisor"));
        mad.common.scrollViewToTop();
    }

    function afterShow(e) {
        viewModel.set("uCanTouchThis", true);
        $("#present-bottom").addClass("after-load");
        $("#presentFotka").addClass("after-load");
    }


    function checknotActive(){
        return !viewModel.selected.get("WorkoutPlanData.Active");
    }

    function startPlan() {
        //we disable button so user doesn't click too many times for nothing
        viewModel.set("isStartEnabled", false);
        $("#startPlanBtn").addClass("preloader");

        var isFreePlan = isItFreePlan();

        var additionalIfno = {
            "Plan type": isFreePlan ? "Free" : "Pro"
        };
       
        mad.analyticEvents.track([mad.analyticEvents.services.GA,  mad.analyticEvents.services.FB], mad.analyticEvents.categories.WORKOUTPLAN, mad.analyticEvents.types.EVENT,
            "Workout plan - Start Plan Clicked",
            additionalIfno,
            "Workout plan",
            "Start Plan Clicked", additionalIfno["Part type"]); 
        

        if (isFreePlan) {
            //if it is just start it
            handleStartingPlan(true);
        }else{
            if (mad.viewModels.workoutsMenu.viewModel.get("IsPro")){
                mad.appsFlyer.trackEvent("Workout Plan started");
                handleStartingPlan(false);

            } else {
                mad.appsFlyer.trackEvent("Workout Plan Start clicked - not pro");

                $("#startPlanBtn").removeClass("preloader");
                mad.mobileApp.navigate("ui/PRO/explain.html", "overlay:up");
            }
        }
    }

    function handleStartingPlan(isItFree) {
        console.log("start plan");

        viewModel.set("isStartEnabled", false);

        /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/WorkoutPlans/StartPlan";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = { id: viewModel.get("selected.WorkoutPlanData.Id") };
        */
        var link   = {putanja : mad.common.variables.serverUrl + "api/WorkoutPlans/StartPlan", akcija : "POST"};
        var podaci = {
            id: viewModel.get("selected.WorkoutPlanData.Id")
        };

        mad.data.post(link, podaci)
            .done(function (data, code) {
                console.log("start OK (selektirani plan i code)", data, code);
                viewModel.set("isStartEnabled", true);
                $("#startPlanBtn").removeClass("preloader");

                // update status in viewmodel for list
                mad.viewModels.plans.viewModel.updateStatus("active");

                //i idi na aktivni plan - execution
                mad.mobileApp.navigate("ui/plans/work.html?origin=present");

            })
            .fail(function (qXHR, textStatus, errorThrown) {
                console.log("start failed");
                viewModel.set("isStartEnabled", true);
                $("#startPlanBtn").removeClass("preloader");

                if (textStatus == 'timeout') {
                    if (mad.common.observables.askAboutWaiting) {
                        var msg = mad.glossary.messages.saveTimeout;
                        navigator.notification.alert(
                            msg.message[mad.common.observables.languageIndex()],
                            null,
                            msg.title[mad.common.observables.languageIndex()],
                            msg.button[mad.common.observables.languageIndex()]
                        );
                    }
                } else {
                    console.log("Error starting part ", qXHR, textStatus, errorThrown);
                    mad.alerts.error("Error starting part. Please contact Madbarz");
                }
            });

    }

    function gotoPlan(){
        //we disable button so user doesn't clikc too many times for nothing
        viewModel.set("isStartEnabled", false);
        $("#gotoPlanBtn").addClass("preloader");

        if (isItFreePlan()) { //if it is free just start it
            handleGoingToPlan();
        }else{ //if not, see whether user is pro
            if (mad.viewModels.workoutsMenu.viewModel.get("IsPro")){
                handleGoingToPlan();
            } else {
                // user doesn't have acces to pro, send him to sales page
                $("#gotoPlanBtn").removeClass("preloader");
                mad.mobileApp.navigate("ui/PRO/explain.html", "overlay:up");
            }
        }
    }

    function handleGoingToPlan() {
        viewModel.set("isStartEnabled", true);
        $("#gotoPlanBtn").removeClass("preloader");

        //idi na aktivni plan - execution
        mad.mobileApp.navigate("ui/plans/work.html?origin=present");
    }

    function typeText(){
        var isFreePlan = isItFreePlan();
        if (isFreePlan) {
            return "FREE"
        }else{
            return "PREMIUM"
        }
    }


    function isOtp() {
        var isOtp = false;
        // ovo je postavljeno na pocetku viewModel.set("selected", mad.viewModels.plans.viewModel.get("selectedPlan"));
        var groupsToWhichPlanBelongs = mad.viewModels.plans.viewModel.get("selectedPlan.WorkoutPlanData.Groups");

        if (groupsToWhichPlanBelongs.indexOf("Otp") > -1) {
            isOtp = true;
        }
        return isOtp;
    }
    function isItFreePlan(){
        var isFreePlan = false;
        // ovo je postavljeno na pocetku viewModel.set("selected", mad.viewModels.plans.viewModel.get("selectedPlan"));
        var groupsToWhichPlanBelongs = mad.viewModels.plans.viewModel.get("selectedPlan.WorkoutPlanData.Groups");

        if (groupsToWhichPlanBelongs.indexOf("Free") > -1){
            isFreePlan = true;
        }
        return isFreePlan;
    }

    function setBtnTxtStart(){
        var isFreePlan = isItFreePlan();
        var planType = viewModel.get("selected.TypeOfPlan");

        if (!planType) {
            planType = "plan";
        }
      
        if (isFreePlan) {
            return "<span>Start " + planType +  "</span>";
        }else{
            if (mad.viewModels.workoutsMenu.viewModel.get("IsPro")){
                //console.log("Start this plan now");
                return "<span>Start " + planType + " now</span>";
            }else{
                //console.log("Discover Premium");
                return "<span>Discover Premium</span>";
            }
        }
    }

    function setBtnTxtGo(){
        var isFreePlan = isItFreePlan();

        if (isFreePlan) {
            return "<span>Start this plan now</span>";
        }else {
            if (mad.viewModels.workoutsMenu.viewModel.get("IsPro")) {
                //console.log("Go to this plan");
                return "<span>Go to this plan</span>";
            } else {
                //console.log("Discover Premium");
                return "<span>Discover Premium</span>";
            }
        }
    }

    // -- not in viewModel Context  - - - - - - - - - - - - - - - -
    function setupView(){
        mad.common.stretchView();
        mad.common.setResolutionForView(parseInt(mad.mobileApp.view().content.width()), parseInt(mad.mobileApp.view().content.height()));
        mad.common.setLangForView();
    }

    return {
        viewModel: viewModel
    };

}());


