var mad = mad || {};

mad.viewModels = mad.viewModels || {};


mad.viewModels.plansWork = (function () {

    "use strict";
    var viewModel = kendo.observable({
        common: mad.common.observables,
        init: initView,
        before: beforeShow,
        show: showView,
        afterShow: afterShow,
        tStart: tStart,
        tEnd: tEnd,
        /*
                isButtonVisibleL: true,
                enableIfOfflineL: true,
                leftButtonAction: leftButtonAction,
                titlePressed: mad.common.titlePressed,
                isButtonVisibleR: true,
                enableIfOfflineR: checkifOnline,
                isButtonEnabled: true,
                 rightButtonAction: quitRestart,
                 showStat: showStat,
                 showInfo: showInfo,
                startWorkout: startWorkout,
                gotoNextWeek: gotoNextWeek,
        */
        closeModal: closeModal,
        weekInfoData: weekInfoData,
        finishedWeek: false,
        finishWeek: finishWeek,
        selectedPlan: {}, //plan - aktvni
        currWeek: currWeek,
        selectedWorkout: {},
        defaultData: {
            CurrentWeek: 0,
            ImageUrl: "",
            Progress: {
                TotalWeekCount: 1
            }
        },
        purchased: {
            Duration: "_"
        },
        isModalOpened: false,
        origin: "",

        uCanTouchThis: false

    });

    var scroller;

    function initView(e) {
        /*
        viewModel.set("uCanTouchThis", false);
        $("#plansWork").kendoTouch({
            tap: function(e) {
                //console.log(e.touch.target + " was tapped");
                console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    console.log("but canceled")
                }
            }
        });
        */
        /* ne radi jer jos nije generiran taj sadrzaj
        $("#plansWork .workout-txt").kendoTouch({
            tap: function(e) {
                //console.log(e.touch.target + " WEEK info was tapped");
                console.log(e.touch.target, "WEEK info  was tapped");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    console.log("but canceled")
                }
            }
        });
        */

        var viewID = "#plansWork";
        viewModel.set("uCanTouchThis", false);
        scroller = e.view.scroller;

        $(viewID).kendoTouch({
            filter: ".lButton, .rButton, .showInfo, .showStat, .startWorkout, .gotoNextWeek",
            touchstart: function (e) {
                //console.log("touchstart");
                if (!viewModel.get("uCanTouchThis")) {
                    e.sender.cancel();
                    //console.log("touchstart but canceled")
                    if (scroller) {
                        if (scroller.enabled) {
                            scroller.disable();
                        }
                    }
                } else {
                    if (scroller) {
                        if (!scroller.enabled) {
                            scroller.enable();
                        }
                    }
                }
            },
            tap: function (e) {
                //console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")) {
                    e.sender.cancel();
                    //console.log("but canceled")
                } else {
                    handleTap(e);
                }
            }
        });
    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target;
        //var elementId = element.attr("data-id");
        //var parentElement = $(e.touch.target.parent());

        if ($(element).hasClass("lButton")) {
            leftButtonAction();
        } else if ($(element).hasClass("rButton")) {
            quitRestart();
        } else if ($(element).hasClass("showInfo")) {
            if (viewModel.common.ifOffline()) {
                mad.alerts.realTop0("You are currently offline")
            } else {
                showInfo();
            }
        } else if ($(element).hasClass("showStat")) {
            if (viewModel.common.ifOffline()) {
                mad.alerts.realTop0("You are currently offline")
            } else {
                showStat();
            }
        } else if ($(element).hasClass("startWorkout")) {
            startWorkout(element);
        } else if ($(element).hasClass("gotoNextWeek")) {
            gotoNextWeek();
        }
    }

    function beforeShow() {
        $(".plansWork .km-content").removeClass("loaded");
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e) {
        var executionData;

        var origin = e.view.params.origin;
        viewModel.set("origin", origin);

        var skipped = e.view.params.skipped;

        mad.common.setActualView();
        mad.common.addViewToHistory();
        mad.common.stretchViewContentToBeElastic();

        if (mad.common.$actualViewID == "#plansWork") {
            kendo.bind($(mad.common.$actualViewID), viewModel);
        }

        viewModel.set("isButtonEnabled", true);

        if (origin == "madbarzWorkout" || origin == "workoutDetails" || origin == "planStat") {
            if (origin == "madbarzWorkout" && skipped == "yes") {
                executionData = viewModel.get("selectedPlan.ActiveExecution.ExecutionData");
                ispljuniHTMLiBindaj(executionData, true);
            }
            $(".plansWork .km-content").addClass("loaded"); // da ima gore crno / dolje bijelo
        } else {
            ispljuniHTMLiBindaj(viewModel.defaultData, false);  // without animation (just placeholders)
            if (viewModel.common.ifOffline()) {
                mad.alerts.realTop0("You are currently offline")
            } else {
                loadPlan();
            }
        }
    }

    function afterShow(e) {
        viewModel.set("uCanTouchThis", true);
    }

    function tStart(e) {
        $("#plansWork").addClass("transBack");
    }

    function tEnd(e) {
        $("#plansWork").removeClass("transBack");
    }

    function leftButtonAction() {
        if (viewModel.get("origin") == "present") {
            mad.common.removeLastFromHistory();
        }
        mad.common.goBack();
    }

    function showStat() {
        mad.viewModels.userProgress.viewModel.set("selectedWorkoutPlanId",
            mad.viewModels.plans.viewModel.selectedPlan.get("WorkoutPlanId"));
        mad.viewModels.planStat.viewModel.set("dataLoaded", false);
        mad.models.plansProgress.read();
        mad.mobileApp.navigate("ui/profile/stats/planStat.html");
    }

    function showInfo() {
        $("#weekInfo").removeClass("hidden");
        var mv = $("#weekInfo").data("kendoMobileModalView");
        viewModel.set("isModalOpened", true);
        mv.open();

        var h = parseInt(mad.mobileApp.view().content.height());
        var cH = parseInt($("#weekInfo .content").height());
        if (cH < h) {
            $("#weekInfo .content").css({ "height": h });
        }
    }

    function closeModal(e) {
        if (e) {
            e.preventDefault(); // da ne probija
        }
        var mv = $("#weekInfo").data("kendoMobileModalView");
        mv.close();
        $("#weekInfo").addClass("hidden");
        viewModel.set("isModalOpened", false);
    }


    // -- not in viewModel Context  - - - - - - - - - - - - - - - -
    function loadPlan() {

        var selectedPlan = {},
            WorkoutPlanData = {},
            executionData = {};

        viewModel.set("finishedWeek", false);

        mad.models.planData.read().then(
            function () { // read OK (promise finished)
                //console.log("timeline - plan je ucitan");

                WorkoutPlanData = mad.models.planData.data()[0];
                console.log("ucitani plan u work.js", WorkoutPlanData);
                var dataForAppsF = {
                    "Name": WorkoutPlanData.Name
                }
                mad.appsFlyer.trackEvent("Workout Plan loaded", dataForAppsF);

                viewModel.set("selectedPlan", WorkoutPlanData);

                selectedPlan.Ordinal = WorkoutPlanData.CategoryOrdinal;
                selectedPlan.WorkoutPlanId = WorkoutPlanData.Id;
                selectedPlan.WorkoutPlanData = WorkoutPlanData;

                //set selected also in plans.viewModel because of using shortcut in workoutsMenu where we spoiled that value to get this plan
                mad.viewModels.plans.viewModel.set("selectedPlan", selectedPlan);

                if (viewModel.get("selectedPlan.ActiveExecution")) {

                    executionData = WorkoutPlanData.ActiveExecution.ExecutionData;
                    executionData.ImageUrl = WorkoutPlanData.ImageUrl;
                    ispljuniHTMLiBindaj(executionData, true);

                } else {
                    console.log("greska - aktivni plan nema execution");
                    kendo.bind($(mad.common.$actualViewID), viewModel);
                    mad.common.goBack();
                    return;
                }

                $(".plansWork .km-content").addClass("loaded"); // da ima gore crno / dolje bijelo
            },
            function () { // read failed
                console.log("aktivni plan nije ucitan");
            }
        );
    }

    function ispljuniHTMLiBindaj(podaci, animiraj) {
        var template, result, weekNum, finished, total;

        console.log("ispljuniHTMLiBindaj (podaci za wkt iz plana,animacija)", podaci, animiraj);

        if (animiraj) mad.common.deAnimate();

        template = kendo.template($("#plansWork-items-template").html(), { useWithBlock: false });
        result = template(podaci); //Pass the data to the compiled template
        $("#plans-work-list").html(result);

        if (podaci.CurrentWeek == 0) {
            viewModel.set("finishedWeek", false);
        } else {
            weekNum = podaci.CurrentWeek - 1;
            finished = podaci.Weeks[weekNum].Progress.FinishedWorkoutCount;
            total = podaci.Weeks[weekNum].Progress.TotalWorkoutCount;
            if (finished == total) {
                viewModel.set("finishedWeek", true);
            }
        }
        // bind viewModel to view (porebno zbog finishedWeek varijable koja je bindana s HTMLom koji je upravo generiran ovdje templateom)
        if (mad.common.$actualViewID == "#plansWork") {
            kendo.bind($(mad.common.$actualViewID), viewModel);
        }

        if (animiraj) mad.common.animate();
    }

    function currWeek() {
        return "Week " + viewModel.get("selectedPlan.ActiveExecution.ExecutionData.CurrentWeek");
    }

    function weekInfoData() {
        var data = viewModel.get("selectedPlan");
        var currentWeek,
            podaci = "";

        if (data.ActiveExecution) {
            currentWeek = data.ActiveExecution.ExecutionData.CurrentWeek - 1;
            podaci = data.Weeks[currentWeek].Description;
        }
        return podaci;
    }

    function startWorkout(target) {
        var goWhere, wktID, ordinal, delay;

        delay = 444 * 1;

        $(target).addClass("tap");

        if ($(target).hasClass("ready")) {
            // go to workout
            goWhere = $(target).attr("data-workout");
            ordinal = $(target).attr("data-ordinal"); // drazen - get ordinal cause getWorkout will return 0
            console.log("idi na workout", goWhere);
            getWorkoutFromServer(goWhere, ordinal, target, delay);

        } else if ($(target).hasClass("finished")) {
            // see the workout
            wktID = $(target).attr("data-workoutid");
            setTimeout(function () {
                $(target).removeClass("tap");
                setTimeout(function () {
                    mad.mobileApp.navigate("ui/workoutDetails/workoutDetails.html?origin=plan&fromPlan=true&WorkoutId=" + wktID, "slide:left");
                }, delay);
            }, delay);

        } else if ($(target).hasClass("skipped")) {
            mad.alerts.error("You have skipped this workout");
            setTimeout(function () {
                $(target).removeClass("tap");
            }, delay);
        }

    }

    function getWorkoutFromServer(workoutId, ordinal, target, delay) {
        var route = {
            putanja: mad.common.variables.serverUrl + "api/WorkoutPlans/GetWorkout",
            akcija: "GET"
        };
        var options = {
            id: workoutId
        };
        mad.data.load(route, options, false, true)
            .done(function (data) {
                viewModel.set("selectedWorkout", data);
                viewModel.set("selectedWorkout.WorkoutOrdinal", ordinal); // add ordinal from execution
                mad.viewModels.madbarzWorkout.viewModel.set("workoutType", "Plan");

                $(target).removeClass("tap");
                // malo pricekaj i navigiraj
                setTimeout(function () {
                    mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkout.html", "slide:left");
                }, delay);

            })
            .fail(function (qXHR, textStatus, errorThrown) {
                mad.alerts.error("Error loading workout");
                console.log("Error loading workout", qXHR, textStatus, errorThrown);
            });

    }

    function gotoNextWeek() {

        if (allWorkoutsFinished()) {
            mad.viewModels.popups.viewModel.openModalWindow("nextWeek", "Nicely done!", "You have successfully finished this week!", "Yeeeah!");
        }
    }

    function allWorkoutsFinished() {
        var executionData = viewModel.get("selectedPlan.ActiveExecution.ExecutionData");
        var weekNum = executionData.CurrentWeek - 1;
        var finished = executionData.Weeks[weekNum].Progress.FinishedWorkoutCount;
        var total = executionData.Weeks[weekNum].Progress.TotalWorkoutCount;
        if (finished < total) {
            mad.alerts.error("You need to finish or skip all the workouts in this week");
            return false;
        }
        return true;
    }

    function quitRestart() {
        var msg,
            planName = viewModel.get("selectedPlan.Name"),
            mobDevice = kendo.support.mobileOS.device;

        if (kendo.support.mobileOS.device == "android" || device.platform == "Android" || device.platform == "android") {
            msg = mad.glossary.messages.quitPlanAndroid;

            navigator.notification.confirm(
                msg.message[mad.common.observables.languageIndex()] + planName,
                function (button) {
                    if (button == 1) { // show description
                        mad.mobileApp.navigate("ui/plans/present.html?origin=work");
                    } else if (button == 2) { // restart
                        if (viewModel.common.ifOffline()) {
                            mad.alerts.realTop0("You are currently offline");
                        } else {
                            // request confirmation
                            $.when(yesNoAnswered("restart")).then(
                                function (answer) {
                                    if (answer == "yes") {
                                        console.log("odgovor je yes");
                                        restartPlan();
                                    } else if (answer == "no") {
                                        console.log("odgovor je no");
                                    }
                                }
                            );
                        }
                    } else if (button == 3) { // quit
                        if (viewModel.common.ifOffline()) {
                            mad.alerts.realTop0("You are currently offline")
                        } else {
                            // request confirmation
                            $.when(yesNoAnswered("abort")).then(
                                function (answer) {
                                    if (answer == "yes") {
                                        console.log("odgovor je yes");
                                        abortPlan();
                                    } else if (answer == "no") {
                                        console.log("odgovor je no");
                                    }
                                }
                            );
                        }
                    }
                },
                msg.title[mad.common.observables.languageIndex()],
                [
                    msg.button1[mad.common.observables.languageIndex()],
                    msg.button2[mad.common.observables.languageIndex()],
                    msg.button3[mad.common.observables.languageIndex()]
                ]);
        } else {
            // for iOS
            msg = mad.glossary.messages.quitPlan;

            navigator.notification.confirm(
                msg.message[mad.common.observables.languageIndex()] + planName,
                function (button) {
                    if (button == 4) { // cancel - do nothing
                    } else if (button == 3) { // show description
                        mad.mobileApp.navigate("ui/plans/present.html?origin=work");
                    } else if (button == 2) { // restart
                        if (viewModel.common.ifOffline()) {
                            mad.alerts.realTop0("You are currently offline")
                        } else {
                            // request confirmation
                            $.when(yesNoAnswered("restart")).then(
                                function (answer) {
                                    if (answer == "yes") {
                                        console.log("odgovor je yes");
                                        restartPlan();
                                    } else if (answer == "no") {
                                        console.log("odgovor je no");
                                    }
                                }
                            );
                        }
                    } else if (button == 1) { // quit
                        if (viewModel.common.ifOffline()) {
                            mad.alerts.realTop0("You are currently offline")
                        } else {
                            // request confirmation
                            $.when(yesNoAnswered("abort")).then(
                                function (answer) {
                                    if (answer == "yes") {
                                        console.log("odgovor je yes");
                                        abortPlan();
                                    } else if (answer == "no") {
                                        console.log("odgovor je no");
                                    }
                                }
                            );
                        }
                    }
                },
                msg.title[mad.common.observables.languageIndex()],
                [
                    msg.button1[mad.common.observables.languageIndex()],
                    msg.button2[mad.common.observables.languageIndex()],
                    msg.button3[mad.common.observables.languageIndex()],
                    msg.button4[mad.common.observables.languageIndex()]
                ]);
        }
    }

    function yesNoAnswered(type) {
        var message = "Progress for this plan will be lost if you quit this plan";
        if (type == "restart") {
            message = "Progress for this plan will be lost if you restart this plan";

        }
        var dfd = jQuery.Deferred();
        var msg = mad.glossary.messages.sure, language = mad.common.observables.languageIndex();
        navigator.notification.confirm(
            message,
            function (button) {
                if (button == 1) { // if yes
                    dfd.resolve("yes");
                } else {
                    dfd.resolve("no");
                }
            },
            msg.title[language],
            [msg.button1[language], msg.button2[language]]);
        return dfd.promise();
    }

    //this method is for restarting plan on the server
    function restartPlan() {

        //we have to show restarting loader for at least 2s so user can at least read what is happening
        // so loader will be always visible for min 2s, 
        // if server request takes less than 2s loader will be shown nevertheless
        // but if server request for some reason takes longer we still have to show loader till the request is finished (or it fails)
        //purpose of vars isQuittingOnServerFinished and isTimeoutToHideLoaderFinished is synchronization between server request
        //and setTimeout which waits for minTimeForShowingLoader to pass
        var isRestartingOnServerFinsihed = false;
        var isTimeoutToHideLoaderFinished = false;
        var minTimeForShowingLoader = 2000; // this is in ms
        var dataFromServer = null; // response from server

        //ispljuniHTMLiBindaj(viewModel.defaultData, false);  // without animation (just placeholders)

        mad.common.showLoader("Restarting");
        var route = {
            putanja: mad.common.variables.serverUrl + "api/WorkoutPlans/RestartPlan",
            akcija: "POST"
        };
        var options = {
            Id: viewModel.get("selectedPlan.ActiveExecution.ExecutionData.Id")
        };

        var handleRestartingPlan = function (data) {
            console.log("restartPlan response", data);

            ispljuniHTMLiBindaj(viewModel.defaultData, false);  // without animation (just placeholders)
            loadPlan();

            if (mad.common.variables.navigationHistory.length >= 1) {
                if (mad.common.variables.navigationHistory[1].viewId == "plansPresent") {
                    mad.common.removeLastFromHistory();
                }
            }
            mad.common.hideLoader();
        };
        var restartLoaderTimer = setTimeout(function () {
            isTimeoutToHideLoaderFinished = true;
            if (isRestartingOnServerFinsihed) {
                if (dataFromServer) {
                    handleRestartingPlan(dataFromServer);

                }
            }
        },
            minTimeForShowingLoader);


        mad.data.post(route, options, false)
            .done(function (data) {
                dataFromServer = data;
                isRestartingOnServerFinsihed = true;
                if (isTimeoutToHideLoaderFinished) {
                    handleRestartingPlan(data);
                }

            })
            .fail(function (qXHR, textStatus, errorThrown) {
                clearTimeout(restartLoaderTimer);
                mad.common.hideLoader();

                mad.alerts.error("Error restarting plan");
                console.log("Error restarting plan", qXHR, textStatus, errorThrown);
            });
    }

    //this method is for quitting plan on the server
    function abortPlan() {

        //we have to show quitting loader for at least 2s so user can at least read what is happening
        // so loader will be always visible for min 2s, 
        // if server request takes less than 2s loader will be shown nevertheless
        // but if server request for some reason takes longer we still have to show loader till the request is finished (or it fails)
        //purpose of vars isQuittingOnServerFinished and isTimeoutToHideLoaderFinished is synchronization between server request
        //and setTimeout which waits for minTimeForShowingLoader to pass
        var isQuittingOnServerFinished = false;
        var isTimeoutToHideLoaderFinished = false;
        var minTimeForShowingLoader = 2000; // this is in ms
        //console.log("ex id", viewModel.get("selectedPlan.ActiveExecution.ExecutionData.Id"));
        mad.common.showLoader("Quitting");

        //info about server request
        var route = {
            putanja: mad.common.variables.serverUrl + "api/WorkoutPlans/AbortPlan",
            akcija: "POST"
        };
        var options = {
            Id: viewModel.get("selectedPlan.ActiveExecution.ExecutionData.Id")
        };

        //this function handles what happens when part has been successfully quited 
        var handleQuitingOfPart = function () {
            mad.common.hideLoader();

            // pronađi podatak u datasourceu liste planova i azuriraj status
            mad.viewModels.plans.viewModel.updateStatus("cancelled");
            mad.common.goBack();
        };
        var quitLoaderTimer = setTimeout(function () {
            isTimeoutToHideLoaderFinished = true;
            if (isQuittingOnServerFinished) {
                handleQuitingOfPart();
            }
        },
            minTimeForShowingLoader);


        mad.data.post(route, options, false)
            .done(function (data) {
                console.log("abortPlan response", data);
                isQuittingOnServerFinished = true;
                if (isTimeoutToHideLoaderFinished) {
                    handleQuitingOfPart();
                }

            })
            .fail(function (qXHR, textStatus, errorThrown) {
                clearTimeout(quitLoaderTimer);
                mad.common.hideLoader();
                mad.alerts.error("Error quiting  plan");
                console.log("Error quiting plan", qXHR, textStatus, errorThrown);
            });
    }

    function finishWeek() {
        //mad.alerts.success("preparing workouts for next week");

        viewModel.set("isButtonEnabled", false);
        $("#nextWeekBtn").addClass("preloader");

        var route = {
            putanja: mad.common.variables.serverUrl + "api/WorkoutPlans/FinishPlanWeek",
            akcija: "POST"
        };
        var options = {
            ExecutionId: viewModel.get("selectedPlan.ActiveExecution.ExecutionData.Id"),
            WeekOrdinal: viewModel.get("selectedPlan.ActiveExecution.ExecutionData.CurrentWeek")
        };
        mad.data.post(route, options, false)
            .done(function (data) {
                viewModel.set("isButtonEnabled", true);
                $("#nextWeekBtn").removeClass("preloader");
                console.log("execution je", data);

                var additionalInfo = {
                    "Part Name": mad.viewModels.plansWork.viewModel.get("selectedPlan.Name"),
                    "Part Ordinal Name": mad.viewModels.plansWork.viewModel.get("selectedPlan.CategoryOrdinalName"),
                    "Week": "Week: " + options.WeekOrdinal
                };

                //analytics services where we send data, category of evenet (max is allways sent), event type (such as event, view, purchase), event name, any additional info, event categorz, event action
                mad.analyticEvents.track([mad.analyticEvents.services.GA], mad.analyticEvents.categories.WORKOUTPLAN, mad.analyticEvents.types.EVENT,
                    "Workout Plan - Week - Finished",
                    additionalInfo,
                    "Workout Plan",
                    "Week", "Finished");
                ispljuniHTMLiBindaj(viewModel.defaultData, false);  // without animation (just placeholders)
                loadPlan();
                scroller.reset();
            })
            .fail(function (qXHR, textStatus, errorThrown) {
                viewModel.set("isButtonEnabled", true);
                $("#nextWeekBtn").removeClass("preloader");
                mad.alerts.error("Error moving to next week");
                console.log("Error moving to next week", qXHR, textStatus, errorThrown);
            });
    }

    return {
        viewModel: viewModel
    };

}());