var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.editInstaUsername = (function() {
  "use strict";

  var viewModel = kendo.observable({
    // properties or functions we want to observe and expose to html
    common: mad.common.observables,

    init: initView,
    show: showView,
    afterShow: afterShow,

    titlePressed: mad.common.titlePressed,

    isButtonVisibleL: true,
    enableIfOfflineL: true,
    leftButtonAction: leftButtonAction,

    isButtonVisibleR: true,
    enableIfOfflineR: true,
    rightButtonAction: rightButtonAction,

    dropDownOpened: false,
    instaUsername: ""
  });

  function initView(e) {
    console.log("init instagram edit");
  }

  function showView(e) {
    console.log("edit instagram show");
    mad.common.setActualView();
    mad.common.addViewToHistory();
    setupView();

    var instaUsername = mad.viewModels.profile.viewModel.get(
      "user.InstagramLink"
    );

    if (
      instaUsername.indexOf("instagram.com/") > -1 &&
      instaUsername.length > 0
    ) {
      instaUsername = /[^/]*$/.exec(instaUsername)[0];
    }

    viewModel.set("instaUsername", instaUsername);

    $("#OTPcode").val(viewModel.get("instaUsername"));
    kendo.bind($(mad.common.$actualViewID), viewModel);
  }

  function afterShow(e) {}

  function leftButtonAction(e) {
    e.preventDefault(); // da ne probija
    // automatically close the keyboard on iOS
    document.activeElement.blur();
    mad.common.goBack();
  }

  function rightButtonAction(e) {
    // send
    e.preventDefault(); // da ne probija
    console.log("button clicked");

    var messageValue = $("#OTPcode").val();

    if (messageValue == "" || messageValue.length === 0) {
      postToServer("");
      return;
    }

    messageValue = messageValue.trim();

    if (messageValue.charAt(0) == "@") {
      messageValue = messageValue.substring(1);
    }

    if (checkIfUserNameIsOk(messageValue)) {
      postToServer(messageValue);
    }
  }

  function checkIfUserNameIsOk(username) {
    if (!username) {
      mad.alerts.info("Please enter your Instagram handle", "");
      return false;
    }

    if (username.length > 30) {
      mad.alerts.info("Please enter your Instagram handle", "");
      return false;
    }

    if (/^([a-zA-Z0-9 _,.]+)$/.test(username)) {
      return true;
    } else {
      mad.alerts.info("Please enter valid Instagram handle", "");
      return false;
    }
  }

  function postToServer(username) {
    mad.common.showBusyLoader("Saving");

    var link = {
      putanja:
        mad.common.variables.serverUrl + "api/user/UpdateInstagramUsername",
      akcija: "POST"
    };

    var podaci = {
      Data: username
    };

    mad.data
      .post(link, podaci)
      .done(function(data) {
        document.activeElement.blur();
        mad.viewModels.profile.viewModel.set("user.InstagramLink", username);
        mad.common.hideLoader();
        mad.alerts.success("Instagram handle updated!");
      })
      .fail(function(qXHR) {
        mad.common.hideLoader();

        // automatically close the keyboard on iOS
        document.activeElement.blur();
        var odgovor = qXHR.responseText;
        var poruka = JSON.parse(odgovor);
        mad.alerts.error(poruka.Message);
      });
  }

  // -- not in viewModel Context  - - - - - - - - - - - - - - - -
  function setupView() {
    mad.common.stretchView();
    mad.common.setResolutionForView(
      parseInt(mad.mobileApp.view().content.width()),
      parseInt(mad.mobileApp.view().content.height())
    );
  }

  return {
    viewModel: viewModel
  };
})();
