var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.editProfile = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,
        inputChanged: inputChanged,
        inputChangedAlpha: inputChangedAlpha,
        hideKbd: hideKbd,

        has2navbars: true,

        isButtonVisibleL: true,
        enableIfOfflineL: true,
        leftButtonAction: leftButtonAction,

        isButtonVisibleL2: true,
        enableIfOfflineL2: true,
        leftButtonAction2: cancelEdit,

        isButtonVisibleR: false,
        enableIfOfflineR: false,
        rightButtonAction: rightButtonAction,

        isButtonVisibleR2: true,
        enableIfOfflineR2: checkifOnline,
        rightButtonAction2: saveSettings,

        inputChangedIndicator: false,
        showSecondMenu: false,

        pozovi: formSubmit,
        goWeight: goWeight,

        titlePressed: mad.common.titlePressed,
        unitsChanged: unitsChanged,
        genderChanged: genderChanged,

        user: {},
        countryBefore: "",
        stateBefore: "",

        before: {
            firstName: "",
            lastName: "",
            email: "",
            bio: ""
        },

        unitsLabel: unitsLabel,
        //getWeight: getWeight,
        getHeight: getHeight,
        getBorn: getBorn,
        deleteLabel: deleteLabel,
        deleteAccount: deleteAccount,

        translateWord: getWord,
        ifNotUSA: ifNotUSA
    });

    function rightButtonAction(){};

    function initView(e){
        console.log("init settings -------------------");

        /*
        var regex = /^[a-zA-Z] +$/;

        $('#editFirst').on('blur', function (event) {
            if (!isValidContent(event.target.value, regex)) {
                mad.alerts.realTop0(event.target.name + " contains invalid characters");
            } else if (!isValidLength(event.target.value)) {
                mad.alerts.realTop0(event.target.name + " is too long");
            }
        });

        $('#editLast').on('blur', function (event) {
            if (!isValidContent(event.target.value, regex)) {
                mad.alerts.realTop0(event.target.name + " contains invalid characters");
            } else if (!isValidLength(event.target.value)) {
                mad.alerts.realTop0(event.target.name + " is too long");
            }
        });
        */

    }

    function showView(e){
        console.log("show settings ----- -");
        var that = this;            // all methods & properties of mad.viewModels.settings

        mad.common.setActualView(); mad.common.addViewToHistory(); setupView();

        viewModel.set("inputChangedIndicator", false);
        viewModel.set("showSecondMenu", false);

        viewModel.before.set("firstName", viewModel.user.get("FirstName"));
        viewModel.before.set("lastName", viewModel.user.get("LastName"));
        viewModel.before.set("email", viewModel.user.get("Email"));
        viewModel.before.set("bio", viewModel.user.get("Bio"));

        var template = kendo.template($("#editProfile-template").html());
        var templateData = template(viewModel); //Execute the template
        $("#editProfile-list").html(templateData);

        var visinaFootera =  $("#editProfile .km-footer").outerHeight(true);

        kendo.bind($(mad.common.$actualViewID), viewModel);

        initMobiscrollFields();

        var initCountry = $('#country').mobiscroll('getVal');
        console.log("country na pocetku je", initCountry);
        if (mad.common.isNullOrEmpty(initCountry)){
            $('#country').mobiscroll('setVal', "Croatia");
        }

        // drazen - todo / ovo primjeni svugdje ili postavi na after show
        setTimeout(function() {
            $("#editProfile-list-scroller").css("height", mad.mobileApp.view().content.height());
        }, 11);

        mad.common.selectMenuTab("profile");
    }

    function cancelEdit(){
        viewModel.set("inputChangedIndicator", false);
        viewModel.set("showSecondMenu", false);

        viewModel.user.set("FirstName", viewModel.before.get("firstName"));
        viewModel.user.set("LastName", viewModel.before.get("lastName"));
        viewModel.user.set("Email", viewModel.before.get("email"));
        viewModel.user.set("Bio", viewModel.before.get("bio"));

    }

    function countryChanged(e) {
        var selectedCountry = mad.viewModels.editProfile.viewModel.user.get("Country");

        if (selectedCountry != "USA" && selectedCountry != "United States of America (the)"){
            mad.viewModels.editProfile.viewModel.user.set("State", "");
        }
        console.log("izabrana zemlja je", selectedCountry);
        //set up in leaderbord view model !!
        mad.viewModels.leaderboard.viewModel.set("userCountry", selectedCountry);

        saveSettings();
    }

    function stateChanged(e) {
        console.log("izabrani state je", mad.viewModels.editProfile.viewModel.user.get("State"));
        saveSettings();
    }

    function afterShow(e) {
        console.log("after show settings --");
    }

    function inputChanged(e){
        //console.log(e);

        var regex = /^[a-zA-Z0-9-_ @\.]+$/;
        var inp = e.keyCode;
        var znak = e.key;

        if (inp == 8 || inp == 32 || inp == 46) {            //backspace , space or del
            viewModel.set("inputChangedIndicator", true);
            viewModel.set("showSecondMenu", true);

            //console.log("backspace space or del");
        } else {
            if (inp > 46) {
                if (regex.test(znak)){              //ili slova, brojevi,-,_, blank, .,@
                    viewModel.set("inputChangedIndicator", true);
                    viewModel.set("showSecondMenu", true);
                }else{
                    //console.log("other > 46");
                }
            }else{
                //console.log("other < 47");
            }
        }
    }


    function inputChangedAlpha(e){
        var regex = /^[a-zA-Z]+$/;
        var inp = e.keyCode;
        var znak = e.key;

        if (inp == 8 || inp == 32 || inp == 46) {            //backspace , space or del
            viewModel.set("inputChangedIndicator", true);
            viewModel.set("showSecondMenu", true);
        } else {
            if (inp > 46) {
                if (regex.test(znak)){              //ili slova
                    viewModel.set("inputChangedIndicator", true);
                    viewModel.set("showSecondMenu", true);
                    //console.log("/[a-zA-Z0-9-_ @\.]/");
                }else{
                    //console.log("other > 46");
                }
            }else{
                //console.log("other < 47");
            }
        }
    }

    function isValidContent(value, regex) {
        return regex.test(value);
    }

    function hideKbd(e){
        $("#dummy").focus();
        console.log("hideKbd", "#" + this.element.context.id);
    }

    function leftButtonAction() {
       // mad.mobileApp.navigate("ui/profile/settings.html", "slide:right");
        mad.common.goBack();
    }

    function getUserData(){
        return mad.viewModels.settings.viewModel.get("user");
    }

    function goWeight(e){
        e.event.stopPropagation();
        mad.mobileApp.navigate("ui/profile/stats/weight.html", "slide:left");
    }

    function formSubmit(e){
        e.preventDefault();
        // automatically close the keyboard on iOS
        document.activeElement.blur();

        console.log("pozovi saveSettings", e);
        saveSettings();
    }

    function saveSettings(e){
        console.log("save pressed");

        var regex = /^[a-zA-Z]+$/;

        var msg = mad.glossary.messages.offline,
            language = mad.common.observables.languageIndex();

        if (mad.viewModels.editProfile.viewModel.common.ifOffline()){
            navigator.notification.confirm(
                msg.message[language],
                function (button) {
                    console.log("stisnut OK");
                },
                msg.title[language], [msg.button1[language]]);
        }else{
            viewModel.set("inputChangedIndicator", false);
            viewModel.set("showSecondMenu", false);

            if (viewModel.before.get("email") != viewModel.user.get("Email")){  //if email is changed
                checkEmailAndUpdate();
            }else{
                if (!isValidContent(viewModel.user.get("FirstName"), regex)){
                    mad.alerts.realTop0("First Name contains invalid characters");
                }else if (!isValidContent(viewModel.user.get("LastName"), regex)) {
                    mad.alerts.realTop0("Last Name contains invalid characters");
                }else{
                    updateUserProfile();
                }
            }

        }
    }

    function checkEmailAndUpdate(){

        if (mad.viewModels.editProfile.viewModel.common.ifOnline()){
            var route = {
                putanja: mad.common.variables.serverUrl + "api/user/CheckIfEmailExsists",
                akcija: "GET"
            };
            var options = {
                email: mad.viewModels.editProfile.viewModel.user.get("Email")
            };
            mad.data.load(route, options, NOstringify, ForceGet)
                .done(function(data) {
                    if(data){           // if true
                        mad.alerts.error("This email already exists!", "");
                    }else{
                        updateUserProfile();
                    }
                })
                .fail(function (e) {
                    console.log("error checking email", e.statusText);
                    mad.alerts.error("Error checking email!", "");
                });
        };
    }

    function updateUserProfile(){

        var originalData = mad.viewModels.editProfile.viewModel.get("user");

        var dataToUpdate = _.clone(originalData);

        if(originalData.IsMetric){
            dataToUpdate.Height = originalData.HeightInCm;
        }else{
            dataToUpdate.Height = parseInt(originalData.HeightInCm * 0.393700787);
        }

        dataToUpdate = _.omit(dataToUpdate, 'HeightInCm', 'WeightInKg', '_events', 'parent', '__proto__', 'uid');      // that's bothering us

        //quick fix for inital settings update
        dataToUpdate.GoalInt = parseInt(dataToUpdate.Goal);

        if (mad.viewModels.profile.viewModel.common.ifOnline()){
            var route = {
                putanja: mad.common.variables.serverUrl + "api/user/PostSettingsModel",
                akcija: "POST"
            };

            mad.common.showLoader("Saving");

            mad.data.post(route, dataToUpdate, NOstringify)
                .done(function(data) {
                    // ne vraca nista

                    //console.log("azurirani podaci su", dataToUpdate);

                    // postavi IsMetric u profile viewModelu jer se ne ucitava ponovo kad se dolazi odizad
                    // taj isMetric se koristi kao default tj. korisnikov GLAVNI postavljeni mjerni sustav
                    mad.viewModels.profile.viewModel.user.set("IsMetric", dataToUpdate.IsMetric);
                    // bio se azurira da bi se vidjela eventualna promjena na profilu
                    mad.viewModels.profile.viewModel.user.set("Bio", dataToUpdate.Bio);


                    mad.common.hideLoader();
                })
                .fail(function (e) {
                    mad.common.hideLoader();
                    //console.log("error updating user info", e.statusText);
                    mad.alerts.error("Error updating user info!", "");
                });
        }
    }

    function checkifOnline(){
        return this.common.ifOnline();
    }

    function unitsLabel(){
        return viewModel.user.get("IsMetric") ? "Kg/Cm" : " Foot/Lbs";
    }

    function unitsChanged(e){

        var heightTxt, weightTxt, valueText, feet, inches, cm, lbs, kg, units;

        units = e.target.id;

        heightTxt = getHeightSwitch();

        if (units == "metric") {

            viewModel.user.set("IsMetric", true);

            valueText = heightTxt;

            $('#userHeight').mobiscroll('option', 'wheels', wCentimeters);      //change wheels
            if (valueText) {
                valueText = valueText.toString().split(' ');
                feet = valueText[0];
                inches = valueText[2];
                cm = parseInt(feet * 30.48 + inches * 2.54);
            } else {
                cm = 177;
            }

            // drazen - todo / pretpostavio sam da je u polju height visina u inchima a izgleda da nije (provjeri s nikolom)

            $('#userHeight').mobiscroll('setArrayVal', [cm], true, false);       // change data

        }else{
            viewModel.user.set("IsMetric", false);

            valueText = heightTxt;

            $('#userHeight').mobiscroll('option', 'wheels', wInches);
            inches = (parseInt(valueText) * 0.393700787).toFixed(0);
            feet = Math.floor(inches / 12);
            inches %= 12;

            $('#userHeight').mobiscroll('setArrayVal', [feet, inches], true, false);
        }

        saveSettings();

    }

    function genderChanged(e){
        var selectedGender = e.target.value;
        console.log("gender changed to", selectedGender);
        viewModel.user.set("Gender", selectedGender);

        mad.common.variables.gender = selectedGender == "Female" ? "f" : "m"; // drazen - not stored locally

        saveSettings();
    }

    function getHeight(){
        var retVal;

        var tmpTxt;

        if (viewModel.user.get("IsMetric") == "true" || viewModel.user.get("IsMetric") == true){
            retVal = Math.ceil(viewModel.user.get("HeightInCm")) + " cm";
            tmpTxt = "metric";
        }else{
            retVal = viewModel.user.get("Height");
            tmpTxt = "imperial";
        }

        //console.log("getHeight", tmpTxt, retVal);
        return retVal;
    }

    function getHeightSwitch(){
        var retVal;

        if (viewModel.user.get("IsMetric") == "true" || viewModel.user.get("IsMetric") == true){
            retVal = viewModel.user.get("Height");
        }else{
            retVal = Math.ceil(viewModel.user.get("HeightInCm")) + " cm";
        }

        console.log("getHeight", retVal);
        return retVal;
    }

    function getWeight(){
        var retVal;

        if (viewModel.user.get("IsMetric") == "true" || viewModel.user.get("IsMetric") == true){
            retVal = Math.ceil(viewModel.user.get("WeightInKg")) + " kg";
        }else{
            retVal = Math.ceil(viewModel.user.get("Weight")) + " lbs";
        }

        //console.log("getWeight", retVal);
        return retVal;
    }

    function getWeightSwitch(){
        var retVal;

        if (viewModel.user.get("IsMetric") == "true" || viewModel.user.get("IsMetric") == true){
            retVal = Math.ceil(viewModel.user.get("Weight")) + " lbs";
        }else{
            retVal = Math.ceil(viewModel.user.get("WeightInKg")) + " kg";
        }

        console.log("getWeight", retVal);
        return retVal;
    }

    function getBorn(){
        return viewModel.user.get("MonthBorn") + " " + viewModel.user.get("YearBorn");
    }

    function deleteLabel(){
        return mad.glossary.ui.editProfile.labels.delete[mad.common.observables.languageIndex()];
    }

    function deleteAccount(e){
        e.event.stopPropagation();

        var msg = mad.glossary.messages.deleteAccount, language = mad.common.observables.languageIndex();
        navigator.notification.confirm(
            msg.message[language],
            function (button) {
                if (button == 2) {              // Cancel
                    mad.alerts.success("Good idea!<br>Thanks for staying with us.");
                } else if (button == 1){                        // OK
                    askSecondTime();
                }
            },
            msg.title[language], [msg.button1[language], msg.button2[language]]);
    }

    function askSecondTime(){
        var msg = mad.glossary.messages.sure2, language = mad.common.observables.languageIndex();
        navigator.notification.confirm(
            msg.message[language],
            function (button) {
                if (button == 2) {              // Cancel
                    mad.alerts.success("Very clever of you! :)<br>Thanks for staying with us.");
                } else  if (button == 1){                        // OK
                    doDeleteAccount();
                }
            },
            msg.title[language], [msg.button1[language], msg.button2[language]]);
    }

    function doDeleteAccount(){
        var route = {
            putanja: mad.common.variables.serverUrl + "api/User/DeleteUser",
            akcija: "GET"
        };

        mad.common.showLoader("Deleting");

        var options = {};
        mad.data.load(route, options, NOstringify, ForceGet)
            .done(function(data) {
                mad.common.hideLoader();
                if(data){           // if true
                    mad.alerts.success("User account deleted!<br>Thanks for using Madbarz!");

                    // Clear local storage, but preserve installationId and PNS handle
                    var installationId = mad.local.loadVariable("installationId");
                    var pnsHandle = mad.local.loadVariable("pnsHandle");
                    localStorage.clear();
                    mad.local.saveVariable("installationId", installationId);
                    mad.local.saveVariable("pnsHandle", pnsHandle);

                    mad.loginToken = "";
                    mad.mobileApp.navigate("ui/other/start.html");
                }else{
                    console.log("doDeleteAccount status", data);
                    mad.alerts.error("Account not deleted.");
                }
            })
            .fail(function (e) {
                mad.common.hideLoader();
                console.log("error deleting account", e.statusText);
                mad.alerts.error("Error deleting account!", "");
            });
    }

    function getWord(word){
        return mad.common.translate("words", word);
    }

    function ifNotUSA(){
        return (viewModel.user.get("Country") != "USA" && viewModel.user.get("Country") != "United States of America (the)");
    }

    // -- not in viewModel Context  - - - - - - - - - - - - - - - -
    function setupView(){
        mad.common.stretchView();
        mad.common.actualView.title = mad.glossary.ui[mad.common.actualViewID].header.title[mad.common.observables.languageIndex()];
        setViewTitle(mad.common.actualView.title);

        mad.common.setResolutionForView(parseInt(mad.mobileApp.view().content.width()), parseInt(mad.mobileApp.view().content.height()));
        mad.common.setLangForView();

    }

    function setViewTitle(naslov) {
        mad.common.actualView.title = naslov;
        mad.common.actualView.header.find(".km-navbar [data-role='view-title']").text(naslov);
    }

    function initMobiscrollFields(){
        var theme, mode, display, lang;

        theme = $.mobiscroll.defaults.theme,
            mode = 'scroller',
            display = 'bottom',
            lang = 'hr';

        function getLenWheels(){
            if (viewModel.user.get("IsMetric") == "true" || viewModel.user.get("IsMetric") == true){
                return wCentimeters;
            }else{
                return wInches;
            }
        };

        $('#userHeight').mobiscroll({
            theme: theme,
            mode: mode,
            display: display,
            buttons: buttons,
            lang: lang,
            showLabel: true,
            wheels: getLenWheels(),
            height: 40,
            maxWidth: 150,

            onClose: function(valueText, botun, inst) {
                var feet, inches, cm;

                if (botun == "set") {
                    // postavljanje - metric
                    valueText = valueText.toString().split(' ');
                    if (viewModel.user.get("IsMetric") == "true" || viewModel.user.get("IsMetric") == true){
                        cm = parseInt(valueText[0]);
                    } else {                                      // konverzija u cm
                        feet = valueText[0];
                        inches = valueText[2];
                        cm = parseInt(feet * 30.48 + inches * 2.54);
                    }
                    viewModel.user.set("HeightInCm", cm)

                    // konverzija u imperial
                    inches = (parseInt(cm) * 0.393700787).toFixed(0);
                    feet = Math.floor(inches / 12);
                    inches %= 12;
                    viewModel.user.set("Height", feet + " ft " + inches + " in");

                    console.log("height changed", cm, feet, inches);

                    saveSettings();
                }
            },

            formatResult: function (data) {
                if (viewModel.user.get("IsMetric") == "true" || viewModel.user.get("IsMetric") == true){
                    //console.log("height before format METRIC", data);
                    return data + " cm";
                } else {
                    //console.log("height before format IMPERIAL", data);
                    return data[0] + " ft " + data[1] + " in";
                }
            },

            parseValue: function (valueText) {
                //console.log("parseValue before format", valueText);
                if (viewModel.user.get("IsMetric") == "true" || viewModel.user.get("IsMetric") == true){
                    if (valueText) {
                        valueText = valueText.toString().split(' ');
                        return [valueText[0]];
                    } else {
                        return ["177"];
                    }
                } else {
                    if (valueText) {
                        valueText = valueText.toString().split(' ');
                        return [valueText[0], valueText[2]];
                    } else {
                        return ["5", "10"];
                    }
                }
            }
        });

        function getWeightWheels(){
            if (viewModel.user.get("IsMetric") == "true" || viewModel.user.get("IsMetric") == true){
                return wKilograms;
            }else{
                return wLbs;
            }
        }

        $('#bDay').mobiscroll().date({
            theme: theme,     // Specify theme like: theme: 'ios' or omit setting to use default
            mode: mode,       // Specify scroller mode like: mode: 'mixed' or omit setting to use default
            display: display, // Specify display mode like: display: 'inline' or omit setting to use default
            buttons: buttons,
            defaultValue: new Date(1995,7,1),
            lang: lang,       // Specify language like: lang: 'pl' or omit setting to use default
            onClose: function(valueText, botun, inst) {
                if (botun == "set"){
                    valueText = valueText.toString().split(' ');
                    var mnth = valueText[0],
                        year = valueText[1];

                    viewModel.user.set("MonthBorn", mnth);
                    viewModel.user.set("YearBorn", year);

                    console.log("bday promjena", mnth, year, botun);

                    saveSettings();
                }
            }
        });

        $('#country').mobiscroll().select({
                theme: theme,
                mode: mode,
                display: display,
                buttons: [],
                lang: lang,
                showLabel: false,
                showInput: true,
                data: mad.common.variables.countries,
                dataText: "value",
                dataValue: "value",
                dataGroup: "letter",
                placeholder: "please select Country",
                height: 40,
                rows: 9,
                readonly: false,
                group: false,
                layout: 'liquid',
                onValueTap: function (item, inst) {
                    var obj = $(item.context);
                    if (!mad.common.isNullOrEmpty(obj)){
                        console.log("odabrano je", obj.context.textContent);
                        mad.viewModels.editProfile.viewModel.user.set("Country", obj.context.textContent);
                        countryChanged();
                        inst.hide(false,"set");
                    }
                },
                onClose: function (valueText, botun, inst) {
                    console.log("close s botunom", botun);
                    if (botun == 'cancel'){
                        inst.setVal(mad.viewModels.editProfile.viewModel.get("countryBefore"),true,false,false,0);
                        mad.viewModels.editProfile.viewModel.user.set("Country", mad.viewModels.editProfile.viewModel.get("countryBefore"));
                    }
                },
                onInit: function(inst) {
                    if (mad.common.isNullOrEmpty(mad.viewModels.editProfile.viewModel.user.get("Country"))) {
                        inst.setValue([""], true, 0, false);
                    }
                },
                onBeforeShow: function(inst) {
                    mad.viewModels.editProfile.viewModel.set("countryBefore", mad.viewModels.editProfile.viewModel.user.get("Country"));
                }
        });

        $('#state').mobiscroll().select({
            theme: theme,
            mode: mode,
            display: display,
            buttons: [],
            lang: lang,
            showLabel: false,
            showInput: true,
            data: mad.common.variables.USAstates,
            dataText: "value",
            dataValue: "value",
            dataGroup: "letter",
            height: 40,
            rows: 9,
            readonly: false,
            group: false,
            layout: 'liquid',
            onValueTap: function (item, inst) {
                var obj = $(item.context);
                if (!mad.common.isNullOrEmpty(obj)){
                    console.log("odabrano je", obj.context.textContent);
                    mad.viewModels.editProfile.viewModel.user.set("State", obj.context.textContent);
                    stateChanged();
                    inst.hide(false,"set");
                }
            },
            onClose: function (valueText, botun, inst) {
                console.log("close s botunom", botun);
                if (botun == 'cancel'){
                    inst.setVal(mad.viewModels.editProfile.viewModel.get("stateBefore"),true,false,false,0);
                    mad.viewModels.editProfile.viewModel.user.set("State", mad.viewModels.editProfile.viewModel.get("stateBefore"));
                }
            },
            onBeforeShow: function(inst){
                mad.viewModels.editProfile.viewModel.set("stateBefore", mad.viewModels.editProfile.viewModel.user.get("State"));
            }
        });
    }

    return {
        viewModel: viewModel,
        updateUserProfile: updateUserProfile
    };

}());

