var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.profile = (function() {
  "use strict";

  var viewModel = kendo.observable({
    // properties or functions we want to observe and expose to html
    common: mad.common.observables,

    init: initView,
    show: showView,
    afterShow: afterShow,

    beforeShow: beforeShow,

    editPhoto: editPhoto,

    origin: "menu",

    isButtonVisibleL: true,
    odgovarajucaSlika: "",
    leftButtonIs: "nothing",

    enableIfOfflineMenu: checkifOnline,
    enabled: true,

    hasWorkouts: false,
    workoutsText: "",

    coords: null,

    IsPro: false,

    generatedMenu: "",
    user: {},
    userDataDefault: {
      UserName: "",
      DisplayName: "",
      ProfilePhoto: "images/photo.png",
      ImageUrl: "images/photo.png",
      img: "images/photo.png", // ovdje ce doci slika koja se prikazuje (iz cachea ili link)
      Bio: "",
      Level: 0,
      NumberOfRespects: 0,
      NumberOfFollowers: 0,
      NumberOfFollowing: 0,
      IsCurrentUserFollowingThisOne: false,
      InstagramUrl: ""
    },

    uCanTouchThis: false,

    loadUser: loadUser,
    reload: false,

    editModalOpened: false,
    showNextLevel: false,
    nextLevel: nextLevel,
    ptsProgress: ptsProgress
  });

  function initView(e) {
    var viewID = "#profile";

    viewModel.set("uCanTouchThis", false);
    viewModel.set("reload", false);

    var scroller = e.view.scroller;

    $(viewID).kendoTouch({
      filter:
        ".lButton, .rButton, .imgTap, .showLevel, .showFollowers, .menuTap, .instaTap",
      touchstart: function(e) {
        //console.log("touchstart");
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          //console.log("touchstart but canceled")
          if (scroller) {
            if (scroller.enabled) {
              scroller.disable();
              //console.log("scroller.disabled", scroller);
            }
          }
        } else {
          if (scroller) {
            if (!scroller.enabled) {
              scroller.enable();
              //console.log("scroller.enabled")
            }
          }
        }
      },
      tap: function(e) {
        //console.log(e.touch.target, " was tapped");
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          //console.log("but canceled")
        } else {
          handleTap(e);
        }
      }
    });

    //mad.models.currentUser.bind("change", dataLoaded); // on currentUser datasource change (GetCurrentUser)

    generateMenu();
    //prepareMobiscroll();
  }

  function handleTap(e) {
    e.preventDefault(); // da ne probija

    //var element = e.touch.target;
    var element = e.touch.target.context;

    if ($(element).hasClass("lButton")) {
      leftButtonAction();
    } else if ($(element).hasClass("rButton")) {
      userSettings();
    } else if ($(element).hasClass("imgTap")) {
      editPhoto(e);
    } else if ($(element).hasClass("showLevel")) {
      //$("#nextlevel").slideToggle("fast");
    } else if ($(element).hasClass("showFollowers")) {
      showFollowers(element);
    } else if ($(element).hasClass("menuTap")) {
      viewModel.common.goTo(e);
    } else if ($(element).hasClass("instaTap")) {
      editInstagramUsername();
    }
  }

  function beforeShow(e) {
    viewModel.set("uCanTouchThis", false);
  }

  function showView(e) {
    console.log("profile - show", mad.common.actualViewID);

    var origin = e.view.params.origin;
    viewModel.set("origin", origin);

    mad.common.setActualView();

    kendo.bind($(mad.common.$actualViewID), viewModel);

    if (origin == "menu") {
      mad.common.addViewToHistory("reset");
    } else {
      mad.common.addViewToHistory();
    }

    mad.common.stretchViewContentToBeElastic();

    var respectsChanged = viewModel.get("reload");

    if (
      origin == "menu" ||
      origin == "feed" ||
      origin == "notifications" ||
      origin == "workoutDetails"
    ) {
      // inicijaliziranje info o useru za brzi i fluidniji prikaz
      viewModel.set("user", viewModel.userDataDefault);
      var tpl = kendo.template($("#userProfile-template").html());
      var output = tpl(viewModel.get("user"));
      $("#userProfile").html(output);
      mad.viewModels.editPhoto.viewModel.prepareMobiscroll();

      checkPRO();

      loadUser(); // view model binding inside
    } else if (origin == "settings") {
      //update bio in case you want to be sure that updated data is visible because
      //this data is generated in template (not binded)
      $("#profileStatus").html(
        mad.viewModels.profile.viewModel.user.get("Bio")
      );
      mad.common.animate();
    } else if (respectsChanged) {
      loadUser();
    } else {
      //samo da se pobindaju nav. gumbi i podaci ucine vidljivim (npr. s following)
      //kendo.bind($(mad.common.$actualViewID), viewModel);
      mad.common.animate();
    }

    if (origin != "menu") {
      // rucno selektiranje taba ako se nije doslo s menija
      mad.common.selectMenuTab("profile");
    }

    mad.common.scrollViewToTop();

    mad.googleAnalytics.trackView("Profile");
  }

  function afterShow(e) {
    viewModel.set("uCanTouchThis", true);
    viewModel.set("reload", false);

    var viewName = "Profile screen loaded";
    mad.analyticEvents.track(
      [mad.analyticEvents.services.GA, mad.analyticEvents.services.FB],
      mad.analyticEvents.categories.MENUSCREEN,
      mad.analyticEvents.types.VIEW,
      viewName,
      null,
      viewName,
      "Screen loaded"
    );
  }

  function checkPRO() {
    console.log("PROFILE - checking pro & setting left button");

    var isUserProPromise = $.Deferred();

    isUserProPromise.then(
      function(success) {
        console.log("promise done", success);

        var hasPro;

        if (success) {
          // ako ima access to pro
          viewModel.set("IsPro", true);
        } else {
          viewModel.set("IsPro", false);
        }

        hasPro = viewModel.get("IsPro");

        if (mad.common.variables.navigationHistory.length == 1) {
          // if we came directly to profile from menu
          if (hasPro) {
            viewModel.set("leftButtonIs", "nothing");
            viewModel.set("isButtonVisibleL", false);
          } else {
            viewModel.set("leftButtonIs", "nothing");
            viewModel.set("isButtonVisibleL", false);
          }
        } else {
          if (
            mad.common.variables.navigationHistory[1].viewId ==
              "notifications" ||
            mad.common.variables.navigationHistory[1].viewId ==
              "workoutDetails" ||
            mad.common.variables.navigationHistory[1].viewId ==
              "workoutDetailsComments" ||
            mad.common.variables.navigationHistory[1].viewId == "feed"
          ) {
            viewModel.set("leftButtonIs", "back");
            viewModel.set("isButtonVisibleL", true);
          } else {
            if (hasPro) {
              viewModel.set("leftButtonIs", "nothing");
              viewModel.set("isButtonVisibleL", false);
            } else {
              viewModel.set("leftButtonIs", "nothing");
              viewModel.set("isButtonVisibleL", false);
            }
          }
        }
      },
      function(fail) {
        console.log("hasUserAccessToPro failed !!");
        viewModel.set("IsPro", false);
        viewModel.set("leftButtonIs", "nothing");
        viewModel.set("isButtonVisibleL", false);
      }
    );

    //check if user has access to pro or not
    mad.common.hasUserAccessToPro(isUserProPromise);
  }

  function editPhoto(e) {
    var inst;
    if (viewModel.common.ifOffline()) {
      mad.alerts.realTop0("You are currently offline");
      e.event.stopPropagation();
    } else {
      if ($("#profile-user-img img").hasClass("biggerPhoto")) {
        $("#profile-user-img img").removeClass("biggerPhoto");
      } else {
        inst = $(".actionsheetphotosource").mobiscroll("getInst");
        //with a little delay because it sometimes closes automatically
        setTimeout(function() {
          inst.show(false, false);
        }, 22);
      }
    }
  }

  function showFollowers(element) {
    if (element.className.indexOf("followers") > -1) {
      mad.mobileApp.navigate(
        "ui/following/following.html?origin=profile&UserName=" +
          encodeURIComponent(viewModel.get("user.DisplayName")) +
          "&UserId=" +
          viewModel.get("user.UserId") +
          "&followers=" +
          viewModel.get("user.NumberOfFollowers") +
          "&following=" +
          viewModel.get("user.NumberOfFollowing") +
          "&tab=0",
        "slide:left"
      );
    } else {
      mad.mobileApp.navigate(
        "ui/following/following.html?origin=profile&UserName=" +
          encodeURIComponent(viewModel.get("user.DisplayName")) +
          "&UserId=" +
          viewModel.get("user.UserId") +
          "&followers=" +
          viewModel.get("user.NumberOfFollowers") +
          "&following=" +
          viewModel.get("user.NumberOfFollowing") +
          "&tab=1",
        "slide:left"
      );
    }
  }

  function generateMenu() {
    var template = kendo.template($("#profile-tap-menu-template").html(), {
      useWithBlock: false
    });
    var data = mad.glossary.ui.profile.menu;
    var result = template(data); //Pass the data to the compiled template
    mad.viewModels.profile.viewModel.set("generatedMenu", result);
    $("#userMenu-list").html(
      mad.viewModels.profile.viewModel.get("generatedMenu")
    ); // display
  }

  function checkifOnline() {
    return this.common.ifOnline();
  }

  function leftButtonAction(e) {
    var gumb = viewModel.get("leftButtonIs");

    if (gumb == "back") {
      mad.common.goBack();
    } else if (gumb == "goPro") {
      var data = {
        Source: "Profile"
      };
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA, mad.analyticEvents.services.FB],
        mad.analyticEvents.categories.SALES,
        mad.analyticEvents.types.EVENT,
        "Pro Converter - Crown Click",
        data,
        "Pro Converter",
        "Crown Click"
      );

      mad.mobileApp.navigate("ui/PRO/explain.html", "overlay:up");
    }
  }

  function userSettings() {
    // postavi user objekt u settings view modelu
    mad.viewModels.settings.viewModel.set(
      "user",
      mad.viewModels.profile.viewModel.get("user")
    );
    mad.mobileApp.navigate("ui/profile/settings.html", "slide:left");
  }

  function editInstagramUsername() {
    // postavi user objekt u settings view modelu
    mad.viewModels.settings.viewModel.set(
      "user",
      mad.viewModels.profile.viewModel.get("user")
    );
    mad.mobileApp.navigate("ui/profile/editInstaUsername.html", "slide:left");
  }

  function nextLevel() {
    return viewModel.user.get("Level") + 1 || "x";
  }

  function ptsProgress() {
    var tmpPosto =
      viewModel.user.get("PercentageToNextLevel") < 5
        ? 5
        : viewModel.user.get("PercentageToNextLevel");
    tmpPosto = tmpPosto > 97 ? 97 : tmpPosto;
    return tmpPosto + "%";
  }

  function loadUser() {
    mad.models.currentUser.online(false);
    mad.models.currentUser.read().then(function() {
      if (viewModel.common.ifOnline()) {
        mad.models.currentUser.online(true);
        mad.models.currentUser
          .read()
          .then(function() {
            // ovdje ide ono na change
            dataLoaded();

            kendo.bind($(mad.common.$actualViewID), viewModel);
            mad.common.animate();
          })
          .fail(function() {
            console.log("user nije ucitan");
            //kendo.bind($(mad.common.$actualViewID), viewModel);
            mad.common.animate();
          });
      } else {
        //kendo.bind($(mad.common.$actualViewID), viewModel);
        mad.common.animate();
      }
    });
  }

  function dataLoaded(e) {
    console.log("data changed");

    //used for offline & online
    var data, dataForTemplate;
    var template = kendo.template($("#userProfile-template").html(), {
      useWithBlock: false
    });

    if (mad.models.currentUser.online()) {
      // ako je online
      //data = this.data();
      data = mad.models.currentUser.data();
    } else {
      var offlineData = mad.models.currentUser.offlineData();
      data = offlineData;
    }

    viewModel.set("hasWorkouts", false);
    viewModel.set("workoutsText", "");

    if (data.length > 0) {
      dataForTemplate = data[0];
      viewModel.set("user", dataForTemplate);

      if (dataForTemplate.NumberOfWorkouts) {
        dataForTemplate.NumberOfFeedItems = dataForTemplate.NumberOfWorkouts;
      }

      if (dataForTemplate.NumberOfFeedItems > 0) {
        viewModel.set("hasWorkouts", true);
        if (dataForTemplate.NumberOfFeedItems == 1) {
          viewModel.set("workoutsText", "1 workout");
        } else {
          viewModel.set(
            "workoutsText",
            dataForTemplate.NumberOfFeedItems + " workouts"
          );
        }
      }

      if (mad.models.currentUser.online()) {
        dataForTemplate.img =
          dataForTemplate.ProfilePhoto != "/img/profile.jpg" &&
          dataForTemplate.ProfilePhoto !=
            "https://mdbrzallpics.azureedge.net/madbarzphotoicon.png"
            ? dataForTemplate.ProfilePhoto
            : "images/photo.png";
      } else {
        dataForTemplate.img = mad.common.getCachedImage("ProfilePhoto");
        if (dataForTemplate.img == "") {
          dataForTemplate.img = "images/photo.png";
        }
      }

      $("#userProfile").html(template(dataForTemplate));

      var w = parseInt(mad.mobileApp.view().content.width());
      var p =
        $("#userProfile .navbar").innerWidth() -
        $("#userProfile .navbar").width();
      var l = $("#userProfile .lButtonContainer").width();
      var r = $("#userProfile .rButtonContainer").width();
      var t = parseInt(w - p - l - r);
      $("#userProfile .mTitle").css("maxWidth", t);

      //set up in leaderbord view model !!
      mad.viewModels.leaderboard.viewModel.set(
        "userCountry",
        dataForTemplate.Country
      );

      console.log("podaci za tpl", dataForTemplate);
    }
  }

  return {
    viewModel: viewModel
  };
})();
