var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.settings = (function() {
  "use strict";

  var viewModel = kendo.observable({
    // properties or functions we want to observe and expose to html
    common: mad.common.observables,

    init: initView,
    show: showView,
    afterShow: afterShow,
    leftButtonAction: leftButtonAction,
    rightButtonAction: saveSettings,
    saveSettings: saveSettings,

    goPro: goPro,
    goEditProfile: goEditProfile,
    goChangeInitial: goChangeInitial,
    goChangeNotif: goChangeNotif,
    gotoContact: gotoContact,
    activateOTP: activateOTP,
    goToVideoExerciseList: goToVideoExerciseList,
    gotoTOU: gotoTOU,
    gotoPP: gotoPP,
    logOut: logOut,

    goEditLevel: goEditLevel,
    goEditGoal: goEditGoal,
    goEditFat: goEditFat,
    goEditNutrition: goEditNutrition,
    goEditInstaUsername: goEditInstaUsername,
    restorePurchase: restorePurchase,

    titlePressed: mad.common.titlePressed,

    isButtonVisibleL: true,
    isButtonVisibleR: false,

    enableIfOfflineL: true,

    user: {},

    getLabel: getLabel,
    version: "2.0.4",

    unitsLabel: unitsLabel,
    getWeight: getWeight,
    getHeight: getHeight,
    getBorn: getBorn,

    fitLevelLabel: getFitnessLevelLabel,
    fitLevelLabelChange: getFitnessLevelLabelChange,
    goalLabel: getGolLabel,
    goalLabelChange: getGolLabelChange,
    fatLabel: getFatLabel,
    nutritionLabelChange: nutritionLabelChange,

    translateWord: getWord,
    ifNotUSA: ifNotUSA,
    sleep: getSleepStatus,
    mute: getMuteSelection,
    tts: getTTSsettings,

    PRO: getProStatus,
    onPROChange: onPROChange,

    respect: getNotifRespectStatus,
    comment: getNotifCommentStatus,
    favorit: getNotifFavoritStatus,
    follow: getNotifFollowStatus,
    trending: getNotifTrendingStatus,
    notificationSettingsChange: notificationSettingsChange,

    localStorageClear: localStorageClear
  });

  function initView(e) {
    console.log("init settings -------------------");
    // console.log("sleep na init", $("#settings-sleep"));

    var version = mad.common.getVersion();

    viewModel.set("version", "Version " + version);
  }

  function showView(e) {
    console.log("show settings ----- -");
    var that = this; // all methods & properties of mad.viewModels.settings
    var template, templateData, result;
    mad.common.setActualView();
    mad.common.addViewToHistory();
    setupView();

    mad.common.selectMenuTab("profile");

    if (mad.common.actualViewID == "settings") {
      template = kendo.template($("#settings-personal-template").html());
      templateData = template(viewModel); //Execute the template
      $("#settings-list").html(templateData);

      // drazen -tmp
      var psw = $("#PROswitch").kendoMobileSwitch({
        change: onPROChange
      });

      var sleepInstance = $("#settings-sleep").kendoMobileSwitch({
        change: function(e) {
          mad.local.saveVariable("sleep", e.checked);
          /*
                        if (e.checked){
                            mad.common.turnInsomniaON();
                        }else{
                            mad.common.turnInsomniaOFF();
                        }
                        */
        }
      });
      var muteInstance = $("#settings-mute").kendoMobileSwitch({
        change: function(e) {
          mad.local.saveVariable("mute", e.checked);
        } /* ,
                     onLabel: "on",
                     offLabel: "off"
                    */
      });
      var ttsInstance = $("#settings-tts").kendoMobileSwitch({
        change: function(e) {
          mad.local.saveVariable("tts", e.checked);
        }
      });
    } else if (mad.common.actualViewID == "editProfile") {
      template = kendo.template($("#editProfile-template").html());
      templateData = template(viewModel); //Execute the template
      $("#editProfile-list").html(templateData);
    } else if (mad.common.actualViewID == "editInitialSettings") {
      template = kendo.template($("#editInitialSettings-template").html());
      templateData = template(viewModel); //Execute the template
      $("#editInitialSettings-list").html(templateData);
    } else if (mad.common.actualViewID == "editInitialLevel") {
      template = kendo.template($("#editInitialLevel-template").html(), {
        useWithBlock: false
      });
      templateData = mad.glossary.ui.editInitialLevel.options;
      result = template(templateData); //Pass the data to the compiled template
      $("#editInitialLevel-list").html(result);
    } else if (mad.common.actualViewID == "editInitialGoal") {
      template = kendo.template($("#editInitialGoal-template").html(), {
        useWithBlock: false
      });
      templateData = mad.glossary.ui.editInitialGoal.options;
      result = template(templateData); //Pass the data to the compiled template
      $("#editInitialGoal-list").html(result);
    } else if (mad.common.actualViewID == "editInitialFat") {
      template = kendo.template($("#editInitialFat-template").html(), {
        useWithBlock: false
      });
      templateData = mad.glossary.ui.editInitialFat.options;
      result = template(templateData); //Pass the data to the compiled template
      $("#editInitialFat-list").html(result);
    } else if (mad.common.actualViewID == "editInitialNutrition") {
      template = kendo.template($("#editInitialNutrition-template").html(), {
        useWithBlock: false
      });
      templateData = mad.glossary.ui.editInitialNutrition.options;
      result = template(templateData); //Pass the data to the compiled template
      $("#editInitialNutrition-list").html(result);
    } else if (mad.common.actualViewID == "notificationSettings") {
      template = kendo.template($("#notificationSettings-template").html(), {
        useWithBlock: false
      });
      templateData = template(viewModel); //Execute the template
      result = template(templateData); //Pass the data to the compiled template
      $("#notificationSettings-list").html(result);

      $("#settings-respect").kendoMobileSwitch({
        change: function(e) {
          //mad.local.saveVariable("notif-respects", e.checked);
          mad.common.events.trigger("notificationsSettings", {
            type: "respects",
            value: e.checked
          });
        }
      });
      $("#settings-comment").kendoMobileSwitch({
        change: function(e) {
          //mad.local.saveVariable("notif-comments", e.checked);
          mad.common.events.trigger("notificationsSettings", {
            type: "comments",
            value: e.checked
          });
        }
      });
      $("#settings-favorit").kendoMobileSwitch({
        change: function(e) {
          //mad.local.saveVariable("notif-favorites", e.checked);
          mad.common.events.trigger("notificationsSettings", {
            type: "favorites",
            value: e.checked
          });
        }
      });
      $("#settings-follow").kendoMobileSwitch({
        change: function(e) {
          //mad.local.saveVariable("notif-follows", e.checked);
          mad.common.events.trigger("notificationsSettings", {
            type: "follows",
            value: e.checked
          });
        }
      });
      $("#settings-trending").kendoMobileSwitch({
        change: function(e) {
          //mad.local.saveVariable("notif-follows", e.checked);
          mad.common.events.trigger("notificationsSettings", {
            type: "trending",
            value: e.checked
          });
        }
      });
    }

    kendo.bind($(mad.common.$actualViewID), viewModel);
  }

  function notificationSettingsChange(e) {
    var notifType = e.type,
      notifValue = e.value;
    console.log(
      "triggered event - nottification settings changed for " +
        notifType +
        ", value is " +
        notifValue
    );

    mad.installation.subscribeToNotifications(notifType, notifValue);
  }

  function afterShow(e) {
    console.log("after show settings --");
    var h = mad.mobileApp.view().content.height();
    if (mad.common.actualViewID == "settings") {
      $("#settings-list-scroller").css("height", h);
      //$("#settings-list-scroller").data("kendoMobileScroller").reset();
    } else if (mad.common.actualViewID == "editProfile") {
      $("#editProfile-list-scroller").css("height", h);
    } else if (mad.common.actualViewID == "editInitialSettings") {
      $("#editInitialSettings-list-scroller").css("height", h);
    } else if (mad.common.actualViewID == "editInitialLevel") {
      $("#editInitialLevel-list-scroller").css("height", h);
    } else if (mad.common.actualViewID == "editInitialGoal") {
      $("#editInitialGoal-list-scroller").css("height", h);
    } else if (mad.common.actualViewID == "editInitialFat") {
      $("#editInitialFat-list-scroller").css("height", h);
    } else if (mad.common.actualViewID == "editInitialNutrition") {
      $("#editInitialNutrition-list-scroller").css("height", h);
    } else if (mad.common.actualViewID == "notificationSettings") {
      $("#notificationSettings-list-scroller").css("height", h);
    }

    mad.googleAnalytics.trackView("Settings");
  }

  function leftButtonAction() {
    mad.common.goBack();
  }

  function saveSettings(e) {
    console.log("save pressed");
    // wait for a while that checked updates variables
    setTimeout(function() {
      mad.viewModels.editProfile.updateUserProfile();
    }, 22);
  }

  function getVersion() {
    return mad.common.getVersion();
  }

  function setRightBtnVisibility() {
    if (
      mad.common.actualViewID == "editInitialSettings" ||
      mad.common.actualViewID == "settings"
    ) {
      return false;
    } else {
      return true;
    }
  }

  function checkifOnline() {
    return this.common.ifOnline();
  }

  function goPro(e) {
    e.event.stopPropagation();

    console.log("SETTINGS - going pro");

    mad.analyticEvents.track(
      [mad.analyticEvents.services.GA],
      mad.analyticEvents.categories.SALES,
      mad.analyticEvents.types.EVENT,
      "Settings - Madbarz Premium Click",
      null,
      "Settings",
      "Madbarz premium click"
    );

    // privremeno umjesto ovog dolje todo
    //mad.viewModels.popups.viewModel.openModalWindow("buySaved", "Out of free space", "Hmm... your subscription has run out of battery, only 3 latest workouts are visible now. To see all workouts please renew your subscription.", "Get unlimtied space!");
    //mad.viewModels.popups.viewModel.openModalWindow("buyProSuccess", "You are now premium!", "Stay sharp and focused!", "Nice!");
    //mad.viewModels.popups.viewModel.openModalWindow("PRO", "Premium workout", "Only premium members can see this workout. By being a premium member you get", "Learn more");

    mad.mobileApp.navigate("ui/PRO/explain.html", "slide:left");
  }

  function goEditProfile(e) {
    e.event.stopPropagation();
    // postavi user objekt u editProfile view modelu
    mad.viewModels.editProfile.viewModel.set(
      "user",
      mad.viewModels.settings.viewModel.get("user")
    );
    mad.mobileApp.navigate("ui/profile/editProfile.html", "slide:left");
  }

  function goChangeInitial(e) {
    e.event.stopPropagation();
    // postavi user objekt u editProfile view modelu
    mad.viewModels.editProfile.viewModel.set(
      "user",
      mad.viewModels.settings.viewModel.get("user")
    );
    mad.mobileApp.navigate("ui/profile/initialSettings.html", "slide:left");
  }

  function goChangeNotif(e) {
    e.event.stopPropagation();
    // postavi user objekt u editProfile view modelu
    mad.viewModels.editProfile.viewModel.set(
      "user",
      mad.viewModels.settings.viewModel.get("user")
    );
    mad.mobileApp.navigate(
      "ui/profile/notificationSettings.html",
      "slide:left"
    );
  }

  function restorePurchase(e) {
    e.event.stopPropagation();

    mad.common.showLoaderNoCancel("Restoring");

    var productCode = "madbarzpro";

    var promiseToResolve = $.Deferred();

    promiseToResolve
      .then(function() {
        mad.alerts.success("Purchases restored");
        mad.common.hideLoaderNoCancel();
      })
      .fail(function(data) {
        console.log("restoring failed: ", data);
        mad.alerts.error("There was some error, please try again");

        mad.common.hideLoaderNoCancel();
      });

    mad.subscriptionService.restorePurchases(productCode, promiseToResolve);
  }

  function gotoContact(e) {
    e.event.stopPropagation();
    mad.mobileApp.navigate("ui/other/contactUs.html", "slide:left");
  }

  function activateOTP(e) {
    e.event.stopPropagation();
    mad.mobileApp.navigate("ui/other/OTPactivation.html", "slide:left");
  }

  function goToVideoExerciseList(e) {
    e.event.stopPropagation();
    mad.mobileApp.navigate("ui/other/VideoExerciseList.html", "slide:left");
  }

  function gotoTOU(e) {
    e.event.stopPropagation();
    mad.mobileApp.navigate("ui/other/ToU.html", "slide:left");
  }

  function gotoPP(e) {
    e.event.stopPropagation();
    mad.mobileApp.navigate("ui/other/PP.html", "slide:left");
  }

  function logOut(e) {
    console.log("logout klik on down event", e);
    e.event.stopPropagation();

    var msg = mad.glossary.messages.logOut,
      language = mad.common.observables.languageIndex();
    navigator.notification.confirm(
      msg.message[language],
      function(button) {
        if (button == 1) {
          // if yes
          doLogout();
        }
      },
      msg.title[language],
      [msg.button1[language], msg.button2[language]]
    );
  }

  function doLogout() {
    clearInterval(mad.common.variables.timers.notifications);
    console.log("Logout");

    //delete auth token
    mad.loginToken = "";
    mad.local.removeVariable("token");
    mad.nativeStorage.removeItem(
      "token",
      function() {
        console.log("native storage: token deleted success");
      },
      function(error) {
        console.log("native storage: token delete failed, error: ", error.code);
      }
    );

    mad.local.removeVariable("userId");

    mad.local.removeVariable("plans-filter");
    mad.local.removeVariable("selectedLevel");
    mad.viewModels.plans.viewModel.set("listviewData", []);
    mad.viewModels.plans.viewModel.planoviDataSource = kendo.data.DataSource.create(
      { data: [] }
    );

    mad.local.removeVariable("routines-filter");
    mad.local.removeVariable("exercise-filter");
    mad.local.removeVariable("savedWorkouts");
    mad.local.removeVariable("fbUserId");
    mad.local.removeVariable("SubscriptionInfo");
    mad.common.variables.HasUserAccesToPro = -1;

    // Disassociate the logged out user from the app installation registration.
    mad.installation.disassociateUser();

    // stop checking notifications
    clearInterval(mad.common.variables.timers.notifications);

    // Clear badge (on iOS)
    mad.common.clearBadge();

    mad.viewModels.feed.viewModel.set("selectedTab", -1);

    if ($("#feed").length > 0) {
      $("#feed")
        .data("kendoMobileView")
        .destroy();
      $("#feed").remove();
    }

    mad.analyticEvents.track(
      [mad.analyticEvents.services.GA],
      mad.analyticEvents.categories.SETTINGS,
      mad.analyticEvents.types.EVENT,
      "Settings - Logout Click",
      null,
      "Settings",
      "Logout click"
    );

    mad.appTelemetry.removeUserIdFromAzureAppInsights();
    mad.mixpanel.reset();

    if (!window.navigator.simulator && facebookConnectPlugin) {
      facebookConnectPlugin.getLoginStatus(
        function(status) {
          //user is logged in, do logout form fb
          facebookConnectPlugin.logout(
            function(success) {
              console.log("cleared app data");
              mad.mobileApp.navigate("ui/other/start.html");
              console.log("Success - FB Logout", success);
            },
            function(err) {
              console.log("cleared app data");
              mad.mobileApp.navigate("ui/other/start.html");
            }
          );
        },
        function(err) {
          console.log("cleared app data");
          mad.mobileApp.navigate("ui/other/start.html");
        }
      );
    } else {
      console.log("cleared app data");
      mad.mobileApp.navigate("ui/other/start.html");
    }
  }

  function goEditLevel() {
    mad.mobileApp.navigate("ui/profile/level.html", "slide:left");
  }

  function goEditGoal() {
    mad.mobileApp.navigate("ui/profile/goal.html", "slide:left");
  }

  function goEditInstaUsername(e) {
    e.event.stopPropagation();
      mad.mobileApp.navigate("ui/profile/editInstaUsername.html", "slide:left");
  }

  function goEditNutrition() {
    mad.mobileApp.navigate("ui/profile/nutrition.html", "slide:left");
  }

  function goEditFat() {
    mad.mobileApp.navigate("ui/profile/fat.html", "slide:left");
  }

  function unitsLabel() {
    return viewModel.user.get("IsMetric") ? "Kg/cm" : " Ft/Lbs";
  }

  function getHeight() {
    return parseInt(viewModel.user.get("HeightInCm"));
  }

  function getWeight() {
    return parseInt(viewModel.user.get("WeightInKg"));
  }

  function getBorn() {
    return (
      viewModel.user.get("MonthBorn") + " " + viewModel.user.get("YearBorn")
    );
  }

  function getFitnessLevelLabel() {
    //return mad.common.translate("ui","labels.fitnessL");
    return mad.glossary.ui.editInitialLevel.labels.fitnessL[
      mad.common.observables.languageIndex()
    ];
  }

  function getFitnessLevelLabelChange() {
    //return mad.common.translate("ui","labels.fitnessL");
    return mad.glossary.ui.editInitialLevel.labels.fitnessLChange[
      mad.common.observables.languageIndex()
    ];
  }

  function getGolLabel() {
    return mad.glossary.ui.editInitialGoal.labels.goal[
      mad.common.observables.languageIndex()
    ];
  }
  function getGolLabelChange() {
    return mad.glossary.ui.editInitialGoal.labels.goalChange[
      mad.common.observables.languageIndex()
    ];
  }

  function nutritionLabelChange() {
    return mad.glossary.ui.editInitialNutrition.labels.title[
      mad.common.observables.languageIndex()
    ];
  }

  function getFatLabel() {
    return mad.glossary.ui.editInitialFat.labels.fat[
      mad.common.observables.languageIndex()
    ];
  }

  function getLabel(label) {
    return mad.common.translate("ui", label);
  }

  function getWord(word) {
    return mad.common.translate("words", word);
  }

  function ifNotUSA() {
    return viewModel.user.get("Country") != "USA";
  }

  function getSleepStatus() {
    var status = mad.local.loadVariableParse("sleep");
    return status;
  }

  function getProStatus() {
    var vrati;

    if (mad.common.variables.HasUserAccesToPro == 0) {
      vrati = false;
    } else {
      vrati = true;
    }
    //return mad.common.variables.HasUserAccesToPro;
    return vrati;
  }

  function onPROChange(e) {
    //mad.common.variables.HasUserAccesToPro = e.currentTarget.checked ? 1 : 0;
    console.log(e.checked);
    mad.common.variables.HasUserAccesToPro = e.checked ? 1 : 0;
  }

  function getMuteSelection() {
    var status = mad.local.loadVariableParse("mute");
    return status;
  }

  function getTTSsettings() {
    var status = mad.local.loadVariableParse("tts");
    return status;
  }

  function getNotifRespectStatus() {
    return mad.installation.isSubscribedToNotifications("respects");
  }
  function getNotifCommentStatus() {
    return mad.installation.isSubscribedToNotifications("comments");
  }
  function getNotifFavoritStatus() {
    return mad.installation.isSubscribedToNotifications("favorites");
  }
  function getNotifFollowStatus() {
    return mad.installation.isSubscribedToNotifications("follows");
  }
  function getNotifTrendingStatus() {
    return mad.installation.isSubscribedToNotifications("trending");
  }

  function localStorageClear(e) {
    e.event.stopPropagation();
    var msg = mad.glossary.messages.deleteCache,
      language = mad.common.observables.languageIndex();
    navigator.notification.confirm(
      msg.message[language],
      function(button) {
        if (button == 1) {
          // if yes
          // Clear local storage, but preserve installationId and PNS handle
          mad.local.clear(); //  pendingSync, trenings, treningsPlan, updates, installationId, ProfilePhoto i pnsHandle su sacuvani (ili app kolekcija u lokiju)
          // a madbarz rutine su ponovo loadane sa servera i spremljene
          mad.alerts.success("Done");
        }
      },
      msg.title[language],
      [msg.button1[language], msg.button2[language]]
    );
  }

  // -- not in viewModel Context  - - - - - - - - - - - - - - - -
  function setupView() {
    mad.common.stretchView();
    mad.common.setActualViewTitle();
    mad.common.setResolutionForView(
      parseInt(mad.mobileApp.view().content.width()),
      parseInt(mad.mobileApp.view().content.height())
    );
    mad.common.setLangForView();
  }

  function initMobiscrollFields() {
    var theme, mode, display, lang;

    (theme = $.mobiscroll.defaults.theme),
      (mode = "scroller"),
      (display = "bottom"),
      (lang = "hr");

    $("#bDay")
      .mobiscroll()
      .date({
        theme: theme, // Specify theme like: theme: 'ios' or omit setting to use default
        mode: mode, // Specify scroller mode like: mode: 'mixed' or omit setting to use default
        display: display, // Specify display mode like: display: 'inline' or omit setting to use default
        buttons: buttons,
        defaultValue: new Date(1995, 7, 1),
        lang: lang // Specify language like: lang: 'pl' or omit setting to use default
      });

    $("#userHeight").mobiscroll({
      theme: theme,
      mode: mode,
      display: display,
      buttons: buttons,
      lang: lang,
      showLabel: true,
      wheels: centimeters,
      height: 40,
      maxWidth: 150,

      onClose: function(valueText, botun, inst) {},

      formatResult: function(data) {
        // console.log("height before format", data);
        if (viewModel.user.get("IsMetric")) {
          return data + " cm";
        } else {
          return data[0] + " ft " + data[1] + " in";
        }
      },

      parseValue: function(valueText) {
        // console.log("parseValue before format", valueText);
        if (viewModel.user.get("IsMetric")) {
          if (valueText) {
            valueText = valueText.toString().split(" ");
            return valueText[0];
          } else {
            return ["177"];
          }
        } else {
          if (valueText) {
            valueText = valueText.toString().split(" ");
            return [valueText[0], valueText[2]];
          } else {
            return ["5", "10"];
          }
        }
      }
    });

    $("#userWeight").mobiscroll({
      theme: theme,
      mode: mode,
      display: display,
      buttons: buttons,
      lang: lang,
      showLabel: true,
      wheels: kilograms,
      height: 40,
      maxWidth: 150,

      onClose: function(valueText, botun, inst) {},

      formatResult: function(data) {
        //  console.log("weight before format", data);
        if (viewModel.user.get("IsMetric")) {
          return data + " kg";
        } else {
          return data + " lbs";
        }
      },

      parseValue: function(valueText) {
        //     console.log("parseValue before format", valueText);
        if (viewModel.user.get("IsMetric")) {
          if (valueText) {
            valueText = valueText.toString().split(" ");
            return valueText[0];
          } else {
            return ["77"];
          }
        } else {
          if (valueText) {
            valueText = valueText.toString().split(" ");
            return valueText[0];
          } else {
            return ["170"];
          }
        }
      }
    });
  }

  return {
    viewModel: viewModel,
    getMuteSelection: getMuteSelection,
    getSleepStatus: getSleepStatus,
    getTTSsettings: getTTSsettings,
    doLogout: doLogout
  };
})();
