var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.graphProgress = (function () {

    "use strict";

    var dispatch;

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,

        leftButtonAction: leftButtonAction,

        selectedGraphType: "",
        selectedGranularity: 2,
        granularitySelected: granularitySelected,
        waitForNullification: false,

        goLeft: goLeft,
        goRight: goRight,
        titlePressed: mad.common.titlePressed,

        selectedWorkoutName: "",

        selectedExercise: {},
        selectedExerciseName: "",

        infoObject: {
            secsReps: "",
            selectedImage: "",
        },
        exercises: {},
        //filteredData: [],

        exercisesCurrent: 0,
        exercisesLength: 0,
        allExercisesLoaded: false,

        workoutsCount: 0,
        noUserProgress: false

    });

    viewModel.bind("callSwipe", function (e) {
        doSwipe(e);
    });
    function initView(e){
        console.log("init graphProgress");

        var width = window.innerWidth;
        $('.UserWorkoutExercisesGraphButtonGroup').css('width', width);
        $(".touchable").kendoTouch({
            enableSwipe: true,
            swipe: function (e) { doSwipe(e); }
        });

    }

    function showView(e){
        var that = this;
        console.log("show graphProgress");

        mad.common.setActualView(); mad.common.addViewToHistory(); setupView();

        showGraph();
        showKruzic();

        kendo.bind($(mad.common.$actualViewID), viewModel);
    };

    function afterShow(){
        console.log("after show graphProgress");
    }

    function leftButtonAction() {
        mad.common.goBack();
    }

    function showGraph() {
        /*
        var chart = d3.dr.graf1()
            .type(mad.viewModels.graphProgress.viewModel.get("selectedGraphType"))
            .granularity(mad.viewModels.graphProgress.viewModel.get("selectedGranularity"));

        chart.info(mad.viewModels.graphProgress.viewModel.get("infoObject"))
        d3.select("#exerGraf").datum(mad.viewModels.userProgress.viewModel.get("filteredData")).call(chart);
        */

        prepareData();

        var currentData =  mad.viewModels.userProgress.viewModel.get("filteredData");
        var prevoiusData = emptyData(currentData);

        drawGraph ("#exerGraf", prevoiusData, currentData, "tween");
    }

    function prepareData(){
        var selExer =  mad.viewModels.graphProgress.viewModel.get("exercises")[mad.viewModels.graphProgress.viewModel.get("exercisesCurrent")];
        setTimeout(function() {
            mad.viewModels.graphProgress.viewModel.set("selectedExerciseName", selExer.Name);
        }, 555);
        mad.viewModels.graphProgress.viewModel.infoObject.set("secReps", selExer.secReps);
        mad.viewModels.graphProgress.viewModel.infoObject.set("selectedImage",selExer.ImageUrl);

        filterData(selExer.graphData);
    }

    function drawGraph( selector, previousData, currentData, mode ) {

        console.log("podaci za graf", currentData);

        // fade in exercise name
        setTimeout(function() {
            mad.common.animate();
        }, 555);

        // -- default values ----------------------------------
        var margin = {top: 30, right: 0, bottom: 15, left: 0},
            yOffset = {top: 60, bottom: 20},                        //additional y offset for graph
            width = $(window).width(),
            height = $(window).height() * 0.55,
            graphWidth = width - margin.left - margin.right,
            graphHeight = height - margin.top - margin.bottom - yOffset.bottom,

            formatDateLine1 = d3.time.format("%d %b"),
            formatDateLine2 = d3.time.format("%Y"),

            d3container, svg, svgDefs, gradientDef,

            xScale = d3.scale.linear()
                             .range([0, graphWidth ])
                             .domain([0, currentData.length - 1]),
            xAxis = d3.svg.axis()
                          .scale(xScale)
                          .orient("bottom"),
            xValueScaled = function (d, i) {return xScale(i)},          // Ith value for x scaled

            prepareXlabels = function (v, i) {
                // i je index a v je skalirani index
                var line1 = formatDateLine1(currentData[v].Date);
                var line2 = formatDateLine2(currentData[v].Date);
                return  line1 + '|' + line2;                    // format koji ce se parsati u dva reda
            },

            yValue = function (d) {return d.Value;},
            yValueShow = function (d) {console.log(d.Value);},

            yMin = 0,
            yMax = d3.max(currentData, yValue) + 1,
            yMax = yMax < 5 ? 5 : yMax,
            yScale = d3.scale.linear()
                             .rangeRound([graphHeight, yOffset.top])
                             .domain([yMin, yMax])
                             .nice(),
            yAxis = d3.svg.axis()
                          .scale(yScale)
                          .orient("left"),
            yValueScaled = function(d) {return yScale(d.Value);},        // 2nd value for y scaled
            yTicks = 5,

            prepareYlabels = function (v, i) {
                if (jmj == "Sec's"){
                    return mad.common.formatTimeForDisplayingTimedExercises(v);
                }else{
                    return v;
                }
            },

            tickLabels,
            tickLines,
            xAxisGroup,
            yAxisGroup,
            graphLine,
            graphArea,
            jmj,
            circleContainer,

            duration = 777,
            delay = 200;


        d3container = d3.select( selector );

        svg = d3container.select('svg');

        if (svg.empty()){
            svg = d3container.append( 'svg' )
                .attr( 'height', height )
                .attr( 'width', width);

            // dodaj definiciju gradienta
            svgDefs = svg.append('defs');
            gradientDef = svgDefs.append('linearGradient')
                .attr('id', 'backgroundZaProgress')
                .attr('x1', '0')
                .attr('x2', '0')
                .attr('y1', '0')
                .attr('y2', '1');
            gradientDef.append('stop')
                .attr('class', 'area-grad-pocetna')
                .attr('offset', '0');
            gradientDef.append('stop')
                .attr('class', 'area-grad-zavrsna')
                .attr('offset', '1');

            graphArea   = svg.append( 'path' ).attr( 'class', 'area-progress');
            xAxisGroup  = svg.append( 'g' ).attr( 'class', 'x axis' );
            graphLine   = svg.append( 'path' ).attr( 'class', 'line-progress');
            yAxisGroup  = svg.append( 'g' ).attr( 'class', 'y axis' );
            circleContainer = svg.append( 'g' ).attr( 'class', 'kruzici');

        }else{
            xAxisGroup = svg.select(".x.axis");
            yAxisGroup = svg.transition().duration(duration).select(".y.axis");
            graphArea  = svg.select(".area-progress");
            graphLine  = svg.select(".line-progress");
            circleContainer  = svg.select(".kruzici");
        }

        var brPodataka = currentData.length - 1;
        if (brPodataka > 0){
            jmj = currentData[0].secReps;
        }else{
            jmj = "";
        }

        /* handle X ticks  - - - - - - - - - - - - - - */
        var brTikova = (brPodataka < 6) ? brPodataka : 6;

        xAxis
            .ticks(brTikova)
            .tickFormat(prepareXlabels);

        // pozicioniraj x-os
        xAxisGroup.call(xAxis)                              // generate it
        tickLabels = xAxisGroup.selectAll('.tick text');    // select label's text
        tickLabels.call(fixXlabels);                        // parsaj sadrzaj - godina u drugi red, ako ih ima vise od 7 u 2 reda

        xAxisGroup                                          // move X axis down
            .attr("transform", "translate(0," + yScale.range()[0] + ")");

        /* handle Y ticks  - - - - - - - - - - - - - - */
        var yLabelValues = generateYaxisTicks();
        yAxis
            .tickSize(-width, 0, 0)
            .tickValues(yLabelValues)
            .tickPadding(-width * .5)
            .tickFormat(prepareYlabels);

        yAxisGroup.call(yAxis)
            .style("opacity", "0.5")                        // change opacity
            .selectAll("text")
            //.attr("dy", "-0.2em").style("text-anchor", "start");    // & move labels above line
            .attr("dy", "-0.2em").style("text-anchor", "middle");    // & move labels above line

        // i dodaj JMJ na top line ako nisu sekunde
        if (jmj != "Sec's") {
            tickLabels = svg.selectAll('.y.axis .tick text');
            tickLabels.last().append("tspan").attr("dx", 5).attr("dy", 0).text(jmj);
        }

        // bottom line is solid
        tickLines = svg.selectAll('.y.axis .tick line');
        tickLines.first().attr('class', 'single');


        drawArea(svg, currentData, mode);

        function fixXlabels(labels){
            var n = 0, last = labels.size(), pomak;
            labels.each(function(){
                var sadrzaj = d3.select(this),
                    text = sadrzaj.text(),
                    red = text.split('|');
                ++n;

                if (red[1]) {
                    sadrzaj.text(null).append("tspan").attr("x", 0).attr("dy", 10).text(red[0]);
                    sadrzaj.append("tspan").attr("x", 0).attr("dy", 12).text(red[1]);
                }
                if (n == 1){
                    sadrzaj.style("text-anchor", "start");       // prva labela - lijevo poravnana
                }else if (n == last){
                    sadrzaj.style("text-anchor", "end");         // zadnja desno
                }

                if (last > 7) {
                    pomak = (n % 2 != 0) ? 22 : 0;              // svaku drugu spusti dolje
                }else{
                    pomak = 0;
                }
                sadrzaj.attr("transform", "translate(" + 0 + "," + pomak + ")");
            })
        }

        function generateYaxisTicks(){
            var korak =  stepY(yMin, yMax);
            var tickArray = d3.range(yMin, yMin + korak * yTicks + 1, korak);
            return tickArray;
        }

        function drawArea( svg, currentData, mode ) {
            var areaFunction = d3.svg.area()
                .x(xValueScaled)
                .y1(yValueScaled)
                .y0(graphHeight)
                .interpolate( 'monotone' );

            var lineFunction = d3.svg.line()
                .x(xValueScaled).y(yValueScaled).interpolate("monotone");

            if (mode == "render"){
                render();
            }else{
                graphArea.datum( previousData )
                    .attr( 'd', areaFunction )
                    .transition()
                    .delay( delay )
                    .duration( duration )
                    .attrTween( 'd', tweenArea( currentData, areaFunction ) );

                graphLine.datum( previousData )
                    .attr( 'd', lineFunction )
                    .transition()
                    .delay( delay )
                    .duration( duration )
                    .attrTween( 'd', tweenArea( currentData, lineFunction ) );
            }

            function render() {
                var path  = graphArea.data([currentData]);
                var pathL = graphLine.data([currentData]);

                // enter
                path.enter().append('svg:path')
                    .transition()
                    .delay( delay )
                    .duration( duration )
                    .attr( 'd', areaFunction )
                    .attr('class', 'area-progress');
                pathL.enter().append('svg:path')
                    .transition()
                    .delay( delay )
                    .duration( duration )
                    .attr( 'd', lineFunction )
                    .attr('class', 'line-progress');

                // update
                path.transition()
                    .ease('cubic-in-out')
                    .delay( delay )
                    .duration( duration )
                    .attr( 'd', areaFunction )
                    .attr('class', 'area-progress');
                pathL.transition()
                    .call(transitionFinished, function() {
                        if (viewModel.get("waitForNullification")){
                            showNewGranularity();
                        }else{
                            //console.log("data for circles", currentData);
                            //drawCircles( currentData );
                        }
                    })
                    .ease('cubic-in-out')
                    .delay( delay )
                    .duration( duration )
                    .attr( 'd', lineFunction )
                    .attr('class', 'line-progress');

                // remove
                path.exit().transition()
                    .ease('bounce-out')
                    .duration( duration )
                    .style({opacity: 0});
                    //.remove();
                pathL.exit().transition()
                    .ease('bounce-out')
                    .duration( duration )
                    .style({opacity: 0});
                //.remove();
            }

            function tweenArea( currentData, callback ) {                       // tween for attribute d & return callback function

                return function( previousData ) {
                    // create interpolator which will be able to handle `current normalized time`
                    var interpolator = d3.interpolateArray( previousData, currentData );
                    previousData.forEach( function( datum, index ) {
                        previousData[ index ] = currentData[ index ]
                    });
                    // this function is called several times with values from 0.0 to 1.0
                    return function( t ) {
                        // calculate values to represent 'area' path with interpolated Array
                        // & return it for 'd' attribute
                        return callback( interpolator ( t ) );
                    };
                };
            }

            function drawCircle( d, i ) {
                circleContainer.datum( d, i )
                    .append( 'circle' )
                    .attr( 'class', 'kruzic' )
                    .attr( 'r', 0 )
                    .attr( 'cx', xValueScaled(d,i))
                    .attr( 'cy', yValueScaled)
                    .transition()
                    .delay( duration / 10 * i )
                    .attr( 'r', 5 );
            }

            function drawCircles( data ) {
                //var kruziciData = circleContainer.data([data]);

                var kruziciData = circleContainer.selectAll('.kruzic').data([data]);

                kruziciData.enter()
                    .append('circle')
                    .attr( 'class', 'kruzic' )
                    .attr( 'r', 0 )
                    .attr( 'cx', xValueScaled(data,i))
                    //.attr( 'cy', yValueScaled(data))
                    .attr( 'cy', yValueScaled)
                    .transition()
                    .delay( duration / 10 * i )
                    .attr( 'r', 5 );

                kruziciData
                    .transition()
                    .attr( 'cx', xValueScaled)
                    .attr( 'cy', yValueScaled);

                kruziciData.exit()
                    .transition()
                    .ease('bounce-out')
                    .duration( duration )
                    .style({opacity: 0})
                    .remove();

/*
                data.forEach( function( datum, index ) {
                    drawCircle( datum, index );
                } );
*/
                var sviKruzici = circleContainer.selectAll(".kruzic");


                /*
                sviKruzici.exit().transition()
                    .duration( duration )
                    .style({opacity: 0})
                    .remove();
                */
            }

        }

        function transitionStarteded(transition, callback) {
            if (transition.size() === 0) { callback() }
            var n = 0;
            transition
                //.each(function() { ++n; })
                .each("start", function() {
                    callback();
                    //console.log("tran start n je ", n);
                    //if (!--n) callback.apply(this, arguments);
                });
        }

        function transitionFinished(transition, callback) {
            if (transition.size() === 0) { callback() }
            var n = 0;
            transition
                .each(function() { ++n; })
                .each("end", function() { if (!--n) callback.apply(this, arguments); });
        }

        function drawArea2(){
            // Add the line path.
            svg.append( 'path' )
                .datum( startData )
                .attr( 'class', 'lineChart--areaLine' )
                .attr( 'd', line )
                .transition()
                .duration( DURATION )
                .delay( DURATION / 2 )
                .attrTween( 'd', tween( data, line ) )
                .each( 'end', function() {
                    drawCircles( data );
                } );


            // Add the area path.
            svg.append( 'path' )
                .datum( startData )
                .attr( 'class', 'lineChart--area' )
                .attr( 'd', area )
                .transition()
                .duration( DURATION )
                .attrTween( 'd', tween( data, area ) );

            // Helper functions!!!
            function drawCircle( datum, index ) {
                circleContainer.datum( datum )
                    .append( 'circle' )
                    .attr( 'class', 'lineChart--circle' )
                    .attr( 'r', 0 )
                    .attr(
                    'cx',
                    function( d ) {
                        return x( d.date ) + detailWidth / 2;
                    }
                )
                    .attr(
                    'cy',
                    function( d ) {
                        return y( d.value );
                    }
                )
                    .on( 'mouseenter', function( d ) {
                        d3.select( this )
                            .attr(
                            'class',
                            'lineChart--circle lineChart--circle__highlighted'
                        )
                            .attr( 'r', 7 );

                        d.active = true;

                        showCircleDetail( d );
                    } )
                    .on( 'mouseout', function( d ) {
                        d3.select( this )
                            .attr(
                            'class',
                            'lineChart--circle'
                        )
                            .attr( 'r', 6 );

                        if ( d.active ) {
                            hideCircleDetails();

                            d.active = false;
                        }
                    } )
                    .on( 'click touch', function( d ) {
                        if ( d.active ) {
                            showCircleDetail( d )
                        } else {
                            hideCircleDetails();
                        }
                    } )
                    .transition()
                    .delay( DURATION / 10 * index )
                    .attr( 'r', 6 );
            }

            function drawCircles( data ) {
                circleContainer = svg.append( 'g' );

                data.forEach( function( datum, index ) {
                    drawCircle( datum, index );
                } );
            }

            function tween( currentData, callback ) {
                return function( previousData ) {
                    var i = d3.interpolateArray( previousData, currentData );
                    return function( t ) {
                        return callback( i ( t ) );
                    };
                };
            }

        }

        function razdvoji(text){
            var n = 0;
            text.each(function(){
                var sadrzaj = d3.select(this),
                    text = sadrzaj.text(),
                    red = text.split('|');
                ++n; console.log(n, "labela",sadrzaj);

                if (red[1]) {
                    sadrzaj.text(null).append("tspan").attr("x", 0).attr("dy", 10).text(red[0]);
                    sadrzaj.append("tspan").attr("x", 0).attr("dy", 12).text(red[1]);
                }
            })
        }

        function stepY(min, max) {
            var step = Math.round((max - min) / yTicks);
            var stepOut =  step < 1 ? .5 : step;
            //console.log("--- mi, ma, st", min, max, stepOut);
            return stepOut;
        }

    }

    function emptyData(data){
        // set all y values to 0
        var newData = data.map( function( datum ) {
            return {
                Date  : datum.Date,
                Value : 0
            };
        });
        return newData;
    }

    function showKruzic() {
        var kruzici = d3.select("#kruzici"),
            brojac = mad.viewModels.graphProgress.viewModel.get("exercisesCurrent"),
            brojacMax = mad.viewModels.graphProgress.viewModel.get("exercisesLength");   // zato jer su scores na 0-toj poziciji

        kruzici.html("");

        for (i = 0; i <= brojacMax; i++) {
            kruzici.append("span").attr('class', "grafKruziciSpan");
        };
/*
        kruzici.selectAll("span").append("img").attr("src", function (d, i) {
            return i == brojac ? "images/bullet-active.png" : "images/bullet-passive.png";
        });
*/
        kruzici.selectAll("span").append("img").attr({
            "id" : function (d, i) {
                return "prog-kruzic-" + i;
            },
            "src" : function (d, i) {
               // return i == brojac ? "images/bullet-active.png" : "images/bullet-passive.png";
                return i == brojac ? "images/bullet-passive.png" : "images/bullet-active.png";
            }});
    }

    function filterData(data) {
        var index = mad.viewModels.graphProgress.viewModel.get("selectedGranularity");

        var ukupno = data.length,
            interval = [7, 30, ukupno];

        mad.viewModels.userProgress.viewModel.filteredData = data.filter(function (d, i) {
            return i >= ukupno - interval[index];
        })
    }

    function goLeft(){
       // mad.common.deAnimate();
        this.trigger('callSwipe', { direction: 'right' });
    }

    function goRight(){
        //mad.common.deAnimate();
        this.trigger('callSwipe', { direction: 'left' });
    }

    function granularitySelected(){

        var prevoiusData =  mad.viewModels.userProgress.viewModel.get("filteredData");
        var nullData = emptyData(prevoiusData);
        viewModel.set("waitForNullification", true);
        drawGraph ("#exerGraf", prevoiusData, nullData, "render");

        mad.viewModels.graphProgress.viewModel.set("selectedGranularity", this.current().index());

    }
    function showNewGranularity(){
        console.log("graphToZeroFinished - showNewGranularity");
        viewModel.set("waitForNullification", false);
        prepareData();
        var currentData =  mad.viewModels.userProgress.viewModel.get("filteredData")
        var nullData = emptyData(currentData);
        drawGraph ("#exerGraf", nullData, currentData, "render");
    }

    function setupView(id){
        mad.common.stretchView();
        setViewTitle();
    }

    function setViewTitle(){
        var naslov = mad.viewModels.graphProgress.viewModel.get("selectedWorkoutName");

        mad.common.actualView.title = naslov;
        setTimeout(function() {
            mad.common.actualView.header
                .find(".km-navbar")
                .data("kendoMobileNavBar").title(naslov);
        }, 22);

    }

    function doSwipe(e) {
        // metoda s neogranicenim muvanjem
        //console.log("swipeing");

        mad.common.deAnimate();

        var graphType, slideDirection ;

        if (mad.viewModels.graphProgress.viewModel.get("allExercisesLoaded") == false) {
            console.log("nije sve ucitano");
            return;
        }
        var brojac = mad.viewModels.graphProgress.viewModel.get("exercisesCurrent"),
            brojacMax = mad.viewModels.graphProgress.viewModel.get("exercisesLength");   //zato jer su scores 0-ti element

        var prevoiusData =  mad.viewModels.userProgress.viewModel.get("filteredData");

        if (e.direction == 'right') {
            if (brojac > 0) {
                // console.log("desno");
                mad.viewModels.graphProgress.viewModel.set("exercisesCurrent", brojac - 1);
                slideDirection = "right";
            } else {
                //console.log("s desna");
                mad.viewModels.graphProgress.viewModel.set("exercisesCurrent", brojacMax);
                slideDirection = "left";
            }
        } else if (e.direction == 'left') {
            if (brojac < brojacMax) {
                // console.log("lijevo");
                mad.viewModels.graphProgress.viewModel.set("exercisesCurrent", brojac + 1);
                slideDirection = "left";
            } else {
                mad.viewModels.graphProgress.viewModel.set("exercisesCurrent", 0);
                slideDirection = "right";
            }
        }

        prepareData();

        var currentData =  mad.viewModels.userProgress.viewModel.get("filteredData");
        drawGraph ("#exerGraf", prevoiusData, currentData, "render");

        showKruzic();
    }

    function reopenView(slideDirection, brojac) {
        var graphType;

        if (brojac > 0) {
            mad.viewModels.graphProgress.viewModel.set("selectedGraphType", "exercises");
        }else{
            mad.viewModels.graphProgress.viewModel.set("selectedGraphType", "scores");
        }
        mad.mobileApp.navigate("ui/profile/stats/graphProgress.html?type=" + mad.viewModels.graphProgress.viewModel.get("selectedGraphType") + "&strana=" + brojac, "slide:" + slideDirection);

    }
    // ------
    return {
        viewModel: viewModel
    };

}());

