var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.statTotal = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,
        leftButtonAction: leftButtonAction,
        showWorkouts: showWorkouts,
        showTotalT: showTotalT,
        showAvgT: showAvgT,
        noTotalText: "Once you finish your first workout you will unlock total tracking graph!",
        overviewData: {},
        overviewGraphData: {},
        noGraphData: false

    });

    function initView(e){
        //console.log("init statTotal");
    }

    function showView(e){
        var that = this;
        //console.log("show statTotal");

        mad.common.setActualView(); mad.common.addViewToHistory();
        mad.common.stretchView();

        var userId, origin = e.view.params.origin;
        if (origin) {
            var viewName;
            if (origin == 'profile') {
                userId = mad.common.variables.userId;
                viewModel.set("noTotalText", "Once you finish your first workout you will unlock total tracking graph!");

                viewName = "Profile - Total loaded";
                mad.analyticEvents.track([mad.analyticEvents.services.GA], mad.analyticEvents.categories.PROFILE, mad.analyticEvents.types.VIEW,
                    viewName,
                    null,
                    viewName,
                    "Screen loaded");

            } else if (origin == 'profileOtherUser') {
                console.log("user id za graph je", mad.common.actualView.params.UserId);
                userId = mad.common.actualView.params.UserId
                viewModel.set("noTotalText", "Total graph is for statistics tracking");

                viewName = "Profile Other - Total loaded";
                mad.analyticEvents.track([mad.analyticEvents.services.GA], mad.analyticEvents.categories.PROFILEOTHER, mad.analyticEvents.types.VIEW,
                    viewName,
                    null,
                    viewName,
                    "Screen loaded");

            }
            getOverviewData(userId);
            getGraphData(userId);
        }else{
            console.log("there is no origin parm.");
        }

        kendo.bind($(mad.common.$actualViewID), viewModel);

    }

    function afterShow (e) {
    }


    function leftButtonAction() {
        mad.common.goBack();
    }

    function showWorkouts(){
        return viewModel.overviewData.get("NumberOfWorkouts");
    }

    function showTotalT() {
        var tt = viewModel.overviewData.get("TotalTime");
        if (mad.common.isNullOrEmpty(tt)){
            tt = 0;
        }
        return secondsToHms(tt);
    }

    function showAvgT() {
        var at = viewModel.overviewData.get("AverageTime");
        if (mad.common.isNullOrEmpty(at)){
            at = 0;
        }
        return secondsToHms(at);
    }

    // ------
    function getOverviewData(userId){
        if (mad.viewModels.profile.viewModel.common.ifOffline()){
            mad.alerts.error("you are offline","");
        }else{
            var route = {
                putanja: mad.common.variables.serverUrl + "api/Statistics/GetOverviewData",
                akcija: "GET"
            };

            var options = {
                userId:  userId
            };
            //mad.common.showLoader();
            mad.data.load(route, options, false, true)
                .done(function(data) {
                    //console.log("dohvatio overview data -" , data);
                    mad.viewModels.statTotal.viewModel.set("overviewData", data);
                })
                .fail(function (e) {
                    console.log("error getting overview data", e.statusText);
                    mad.alerts.error("Error getting overview data!", "");
                })
                .always(function(){
                    //mad.common.hideLoader();
                });

        }
    }

    function getGraphData(userId){
        if (mad.viewModels.profile.viewModel.common.ifOffline()){
            mad.alerts.error("you are offline","");
        }else{
            var route = {
                putanja: mad.common.variables.serverUrl + "api/Statistics/GetOverviewGraph",
                akcija: "GET"
            };
            var options = {
                userId:  userId
            };
            //mad.common.showLoader();
            mad.data.load(route, options, false, true)
                .done(function(data) {
                    //console.log("dohvatio graph data -" , data);
                    mad.viewModels.statTotal.viewModel.set("overviewGraphData", data);

                    if (mad.viewModels.statTotal.viewModel.get("overviewGraphData").length == 0){
                        mad.viewModels.statTotal.viewModel.set("noGraphData", true);
                    }else{
                        mad.viewModels.statTotal.viewModel.set("noGraphData", false);
                        showGraph();
                    }
                })
                .fail(function (e) {
                    console.log("error getting graph data", e.statusText);
                    mad.alerts.error("Error getting graph data!", "");
                })
                .always(function(){
                    //mad.common.hideLoader();
                });

        }

    }

    function showGraph(){
        var element     = "#statTotalGraph",
            containerEl = $(element),
            widthFull   = containerEl.width(),
            heightFull  = widthFull + 40,
            width       = widthFull * 0.6,
            height      = width * 1,
            radius      = Math.min( width, height ) / 2,
            container   = d3.select( element );

        // var color = d3.scale.category20();
        // boje kao na webu
        var color = d3.scale.ordinal()
            .range(["#FF5D37", "#69ddff", "#14caff", "#8dff8a", "#fef72d"])

        // brisanje - ako je postojalo
        d3.selectAll("svg").remove();

        var svg = container.append("svg")
            .attr("width", widthFull)
            .attr("height", heightFull);
        var graf = svg.append("g")
            .attr("transform", "translate(" + parseInt(widthFull / 2) + "," + parseInt(height / 2) + ")");

        var pie = d3.layout.pie()
            .sort(null);

        var pieData = d3.layout.pie()
            .value( function( d ) { return d.Score; } );

        var inRadius = radius - parseInt(radius * .5);
        var ouRadius = radius - parseInt(radius * .05);
        var arc = d3.svg.arc()
            .innerRadius(inRadius)
            .outerRadius(ouRadius);

        var podaci = _.sortBy(mad.viewModels.statTotal.viewModel.get("overviewGraphData"), function(x){return -x.Score});

        var path = graf.selectAll("path")
            .data(pieData(podaci))
            .enter().append("path")
            .attr("data-legend", function(d, i) { return podaci[i].Score + ' Pts. ' + podaci[i].ExerciseName + ' ' + podaci[i].Reps })
            .attr("data-legend-pos", function(d, i) { return i+1})
            .attr("fill", function(d, i) { return color(i); })
            .attr("d", arc);

        var legend = svg.append("g")
            .attr("class", "legend")
            .attr("transform", "translate(" + parseInt((widthFull / 2) - 80) + "," + parseInt(height + 25) + ")")
            .style("font-size", "16px")
            .style("line-height", "30px")
            .call(d3.legend);
    }

    function secondsToHms(d) {
        d = Number(d);
        var hours = Math.floor(d / 3600);
        var minutes = Math.floor(d % 3600 / 60);
        var seconds = Math.floor(d % 3600 % 60);
        return ((hours < 10 ? "0" + hours + ":" : hours + ":") + (minutes < 10 ? "0" + minutes + ":" : minutes + ":") + (seconds < 10 ? "0" : "") + seconds).toString();
    }

    return {
        viewModel: viewModel
    };

}());

