var mad = mad || {};

mad.viewModels = mad.viewModels || {};


mad.viewModels.leaderboard = (function () {

    "use strict";
    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,
        tabs: getTabs,
        showUserImage: showUserImage,
        selectedTab: 0,
        sameTabFromBeginning: false,
        duration: 222,
        leftButtonAction: leftButtonAction,
        followersCount: 0,
        followingsCount: 0,
        filterOpen: filterOpen,
        search: gotoSearch,

        IsCurrentUser: true,
        position: 1,
        total: 1,
        userCountry: "",
        selectedCountry: "",
        countryBefore: "",
        selectedGender: "Show Me",
        genderBefore: "Show Me",

        loadingData: true,

        followersDataLoaded: false,
        followingDataLoaded: false,
        noLeaderBoardFollowing: true,
      
        origin: "",
        isButtonVisibleR: false,
        enableIfOfflineR: false

    });

    function initView(e){
        console.log("init leaderboard -------------------");
        var taboviString = JSON.stringify(mad.glossary.ui.leaderboard.tabs[mad.common.observables.languageIndex()].dataSource, mad.common.replacer);
        var taboviJSON = JSON.parse(taboviString);

        // create submenu tabstrip
        $("#leaderboard-submenu").kendoTabStrip({
            dataTextField: "Name",
            dataContentField: "Content",
            animation: false,

            show: function(e) {
                console.log("show tab",$(e.item).index());
                var tabJe = $(e.item).index();

                var visinaTabova =  $("#leaderboard-submenu .k-tabstrip-items").outerHeight(true);
                var contentHeight = parseInt(mad.mobileApp.view().content.height() - visinaTabova );

                $("#leaderboard-submenu .preloaderContainer").css("height", contentHeight);

                if (tabJe == 0) {
                    $("#leaderboard-w-scroller").css("height", contentHeight);
                } else if (tabJe == 1) {
                    $("#leaderboard-f-scroller").css("height", contentHeight);
                    $("#leaderboard .noOneL").css("height", contentHeight);
                }

            },
            select: function(e) {
                console.log("select tab",$(e.item).index());
            },
            activate: function(e) {
                console.log("activate tab",$(e.item).index());

                var promise = $.Deferred();
                promise.then(function (success) {
                    handleActiveTab();
                }, function (fail) {
                    console.log("slide failed");
                });

                mad.common.handleTabSliding($(e.item), promise);

            }
        }).data("kendoTabStrip").setDataSource(taboviJSON);

        initWorld();
        initFollowing();
    }

    function showView(e){
        console.log("show leaderboard ----- -");

        var origin = e.view.params.origin;
        viewModel.set("origin", origin);
        console.log("origin", origin);

        mad.common.setActualView(); mad.common.addViewToHistory();
        mad.common.stretchView();

        if (origin == "profile") {
            var userCntry = viewModel.get("userCountry");
            
            if (userCntry) {
                viewModel.set("selectedCountry", userCntry);
                viewModel.set("countryBefore", userCntry);

            } else {
                viewModel.set("selectedCountry", "World");
                viewModel.set("countryBefore", "World");
            }

            viewModel.set("selectedGender", "Show Me");
            viewModel.set("genderBefore", "Show Me");
        }

        $('#filterCountry').mobiscroll('setVal', viewModel.get("selectedCountry"), true);
        $('#filterGender').mobiscroll('setVal', [viewModel.get("selectedGender")], true);


        // bind viewModel to view
        kendo.bind($(mad.common.$actualViewID), viewModel);

        // add menu slide line
        mad.common.appendSlideLine();

        // no data loaded in the beginning
        viewModel.set("loadingData", true);
        readWorld();        // first time

        // setup submenu tabstrip
        var tabstrip = $(mad.common.$actualViewID + "-submenu").data("kendoTabStrip");
        var selectTab = viewModel.selectedTab == -1 ? 1 : viewModel.selectedTab;
        tabstrip.select(selectTab);     // this will also fetch data first time

        var scroller1 = $("#leaderboard-w-scroller");
        if (scroller1.length) {
            console.log("resetiranje skrolera");
            scroller1.data("kendoMobileScroller").reset();
        }


    }

    function afterShow(e) {
        console.log("after show leaderboatd --");

        var viewName = "Profile - Rankings loaded";
        mad.analyticEvents.track([mad.analyticEvents.services.GA], mad.analyticEvents.categories.PROFILE, mad.analyticEvents.types.VIEW,
            viewName,
            null,
            viewName,
            "Screen loaded");
    }

    function leftButtonAction() {
        mad.common.goBack();
    }

    function getTabs(){
       return mad.glossary.ui.leaderboard.tabs[mad.common.observables.languageIndex()];
    }

    function showUserImage(img) {
        return (img != "/img/profile.jpg" && img != "https://madbarzpictures.blob.core.windows.net/madbarzpictures/profile-web-retina.jpg") ? img : "images/profile-web-retina.jpg";
    }

    // -- not in viewModel Context  - - - - - - - - - - - - - - - -
    function filterOpen(e){
        e.preventDefault();     // da ne probija

        var ikona = $(".filterClosed .icon"); ikona.toggleClass("spin-anim");
        $(".filterOpened").slideToggle("fast");
    }

    function handleActiveTab(){
        console.log("handleActiveTab");


        // drazen - ovo je fix jer scroller.reset(); ne radi (ili zbog endels scrolla ili zato sto u containeru iznad scrollera ima jedan DIV
        var scrollContainerFIX = ($("#leaderboardContainer .k-content.k-state-active"))
        if (scrollContainerFIX){
            scrollContainerFIX.css("-webkit-transform", "translateX(0px)");
        }

        var selectedTab = mad.viewModels.leaderboard.viewModel.get("selectedTab");

        //googleAnalytics
      
        var viewName = selectedTab === 0 ? "Leaderboard World List" : "Leaderboard Following List";
        mad.googleAnalytics.trackView(viewName);
        

        if ( selectedTab == 0){            // world tab
            readWorld();
        } else if (selectedTab == 1) {    // following tab
            readFollowing();
        }

    }

    function initWorld(){
        console.log("init world");
        $("#leaderboard-w-scroller").kendoMobileScroller();
        $("#leaderboard-w-list").kendoMobileListView({
            dataSource: mad.models.leaderboard,
            autoBind: false,
            dataBound: function(e){
                if (this.dataSource._online){
                    mad.common.removeTouchEventsFromList(this, false);
                }
            },

            template: function(data) {
                var tpl = kendo.template($("#leaderboard-list-template").text());
                return tpl(data);
            }
        }).kendoTouch({
            filter: ".gotoUser",
            tap: somethingSelected
        });

        initMobiscrollFields();
    }

    function readWorld(){

        //viewModel.set("loadingData", true);

        console.log(mad.viewModels.leaderboard.viewModel.get("IsCurrentUser"), mad.viewModels.leaderboard.viewModel.get("selectedCountry"), mad.viewModels.leaderboard.viewModel.get("selectedGender"));

        mad.models.leaderboard.read()
            .then(function(e) {
                viewModel.set("loadingData", false);
            })
            .fail(function(e) {
                viewModel.set("loadingData", false);
                console.log("error fetching leaderboard", e.statusText);
                mad.alerts.error("Error fetching leaderboard!", "");
            });
    }

    function initFollowing() {
        console.log("init following");
        $("#leaderboard-f-scroller").kendoMobileScroller({
                pullToRefresh: true,
                pullOffset: 100,
                messages: {
                    pullTemplate: "",
                    releaseTemplate: "",
                    refreshTemplate: ""
                },

                pull: function(e){
                    var scroller = e.sender;
                    var listview = $("#leaderboard-f-list").data("kendoMobileListView");
                    var ikona$ = $(".following-ikona .ikona");
                    ikona$.addClass("animation-started").removeClass("animation-finished");
                    listview.dataSource.read()
                        .then(function(){
                            setTimeout(function() {
                                ikona$.removeClass("animation-started").addClass("animation-finished");
                                scroller.pullHandled();
                                scroller.animatedScrollTo(0,0);
                            }, 0);
                        })
                        .fail(function(e){
                            ikona$.removeClass("animation-started").addClass("animation-finished");
                            scroller.pullHandled();
                            scroller.animatedScrollTo(0,0);
                        });
                }
            }
        );

        $("#leaderboard-f-list").kendoMobileListView({
            dataSource: mad.models.leaderboardFollowing,
            autoBind: false,
            dataBound: function(e){
                if (this.dataSource._online){
                    mad.common.removeTouchEventsFromList(this, false);
                }
            },

            template: function(data) {
                var tpl = kendo.template($("#leaderboard-list-template").text());
                return tpl(data);
            }
        }).kendoTouch({
            filter: ".gotoUser",
            tap: somethingSelected
        });
    }

    function readFollowing(){
        mad.models.leaderboardFollowing.read()
            .then(function(e) {
            })
            .fail(function(e) {
                console.log("error fetching leaderboard following", e.statusText);
                mad.alerts.error("Error fetching leaderboard following!", "");
            });
    }

    function somethingSelected (e){

        e.preventDefault();     // da ne probija

        var listview ;
        var tabJe = mad.viewModels.leaderboard.viewModel.get("selectedTab");
        if (tabJe == 0){
            listview = $("#leaderboard-w-list").data("kendoMobileListView");
        } else if (tabJe == 1) {
            listview = $("#leaderboard-f-list").data("kendoMobileListView");
        }
        //var tappedElement = $(e.touch.currentTarget);          //za klik je $(e.target)
        var tappedElement = e.touch.target;  // drazen - zbog nove verzije kenda

        var li = tappedElement.closest("li");
        var selectedItem = listview.dataSource.getByUid(li.attr("data-uid"));

        if (!mad.common.isNullOrEmpty(selectedItem)){
            mad.common.handleFeedTap("leaderboard", listview, tappedElement, selectedItem, tabJe);   //parms:origin, listview, tappedElement, selectedItem, tab
           
        }
    }

    function gotoSearch() {
        mad.mobileApp.navigate("ui/search/search.html?origin=feed&tab=0");
    }

    function initMobiscrollFields() {
        var theme, mode, display, lang;

        theme = $.mobiscroll.defaults.theme,
            mode = 'scroller',
            display = 'bottom',
            lang = 'hr';

        var allCountries = _.clone(mad.common.variables.countries);
        var domicileCountry = viewModel.get("userCountry");
        var myCountryIndex = _.findIndex(allCountries, function(o) { return o.value == domicileCountry });

        if (myCountryIndex > 0){
            //allCountries.splice(myCountryIndex,1);                                  // remove domicile from array
            allCountries.unshift({ letter: "Quick:", value: domicileCountry });   // put domicile on 1st place
        }
        allCountries.unshift({ letter: "Quick:", value: "World" });                 // put World on top

        $('#filterCountry').mobiscroll().select({
            theme: theme,
            mode: mode,
            display: display,
            buttons: [],
            lang: lang,
            showLabel: false,
            showInput: true,
            data: allCountries,
            dataText: "value",
            dataValue: "value",
            dataGroup: "letter",
            height: 40,
            rows: 9,
            readonly: false,
            group: false,
            layout: 'liquid',
            onValueTap: function (item, inst) {
                var obj = $(item.context);
                if (!mad.common.isNullOrEmpty(obj)) {
                    //viewModel.set("selectedCountry", obj.textContent);
                    viewModel.set("selectedCountry",  item.context.textContent);

                    if (viewModel.get("selectedCountry") == viewModel.get("userCountry")){
                        $('#filterGender').mobiscroll('setVal', ["Show Me"], true);
                    }else{
                        if (viewModel.get("selectedCountry") != "World") {
                            $('#filterGender').mobiscroll('setVal', ["Top 10"], true);
                        }
                    }
                    inst.hide(false, "set");
                    readWorld();
                }
            },
            onClose: function (valueText, botun, inst) {
                if (botun == 'cancel') {
                    viewModel.set("selectedCountry", viewModel.get("countryBefore"));
                    $('#filterCountry').mobiscroll('setVal', viewModel.get("selectedCountry"), true);
                }
            },
            onBeforeShow: function (inst) {
                viewModel.set("countryBefore", viewModel.get("selectedCountry"));
            }
        });

        var podaci = [  // Wheel groups array
            [
                {       // Wheel object
                    values: ['Top 10 Females', 'Top 10 Males', "Top 10", "Show Me"]
                }
            ]
        ]

        $('#filterGender').mobiscroll({
            theme: theme,
            mode: mode,
            display: display,
            buttons: [],
            lang: lang,
            showLabel: false,
            showInput: true,
            wheels: podaci,
            height: 40,
            rows: 7,
            readonly: false,
            group: false,
            layout: 'liquid',
            onValueTap: function (item, inst) {
                var obj = $(item.context);
                if (!mad.common.isNullOrEmpty(obj)) {

                    console.log("izabrano", item.context.textContent);

                    viewModel.set("selectedGender", item.context.textContent);
                    viewModel.set("genderBefore", item.context.textContent);

                    if(item.context.textContent == "Show Me") {
                        viewModel.set("IsCurrentUser", true);
                        if (viewModel.get("selectedCountry") != "World") {
                            if (viewModel.get("selectedCountry") != viewModel.get("userCountry")) {
                                $('#filterCountry').mobiscroll('setVal', viewModel.get("userCountry"), true);
                            }
                        }

                    }else{
                        viewModel.set("IsCurrentUser", false);
                    }
                    inst.hide(false, "set");
                    readWorld();
                }
            },
            onClose: function (valueText, botun, inst) {
                if (botun == 'cancel') {
                    viewModel.set("selectedGender", viewModel.get("genderBefore"));
                }
            },
            onShow: function (html, valueText, inst) {
                console.log("gender on show", html, valueText);
            },
            onBeforeShow: function (inst) {
                viewModel.set("genderBefore", viewModel.get("selectedGender"));
            }
        });
    }

    return {
        viewModel: viewModel
    };

}());

