var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.userProgress = (function() {
  "use strict";

  var viewModel = kendo.observable({
    // properties or functions we want to observe and expose to html
    common: mad.common.observables,

    init: initView,
    beforeShow: beforeShow,
    show: showView,
    afterShow: afterShow,

    mergedData: new kendo.data.DataSource({
      data: [],
      //group: "RoutineCreator"     // zanimljivo za vidjet
      group: "Group"
    }),

    selectedId: 0,
    selectedWorkoutPlanId: 0,

    workoutsCount: 0,
    noUserProgress: false, // postavlja se u modelz.userRoutines

    scores: {
      Name: "",
      secsReps: "",
      ImageUrl: "",
      graphData: []
    },

    tmpExercises: [], //0-ti element je scores
    preparedData: [],
    filteredData: [],

    loadingData: true,

    selectedExercisesId: 0,
    selectedWorkoutName: "",
    selectedExerciseName: "",
    selectedImage: "",

    canMoveLeft: true,
    canMoveRight: true,

    uCanTouchThis: false
  });

  var scroller;

  function initView(e) {
    var viewID = "#userProgress";
    viewModel.set("uCanTouchThis", false);
    scroller = e.view.scroller;

    $(viewID).kendoTouch({
      //filter: ".lButton, >li>ul li",
      filter: ".lButton, .prst",

      touchstart: function(e) {
        //console.log("touchstart");
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          //console.log("touchstart but canceled")
          if (scroller) {
            if (scroller.enabled) {
              scroller.disable();
            }
          }
        } else {
          if (scroller) {
            if (!scroller.enabled) {
              scroller.enable();
            }
          }
        }
      },
      tap: function(e) {
        console.log(e.touch.target, " was tapped");
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          console.log("but canceled");
        } else {
          handleTap(e);
        }
      }
    });

    $("#uProgress").kendoMobileListView({
      dataSource: mad.viewModels.userProgress.viewModel.mergedData,
      fixedHeaders: false,
      autoBind: false,
      pullToRefresh: false,
      virtualViewSize: 42,
      template: function(data) {
        var tpl;
        if (data.RoutineCreator == "Plan") {
          tpl = kendo.template($("#userProgress-plan-template").text());
        } else {
          tpl = kendo.template($("#userProgress-madbarz-template").text());
        }
        return tpl(data);
      }
    });
  }

  function handleTap(e) {
    e.preventDefault(); // da ne probija

    var element = e.touch.target;

    if ($(element).hasClass("lButton")) {
      mad.common.goBack();
    } else if ($(element).hasClass("prst")) {
      odabranWorkout(e);
    }
  }

  function beforeShow(e) {
    viewModel.set("uCanTouchThis", false);
  }

  function showView(e) {
    var contentHeight;

    var origin = e.view.params.origin;

    mad.common.setActualView();
    mad.common.addViewToHistory();
    contentHeight = mad.common.stretchViewContentToBeElastic();
    $("#userProgressContainer .preloaderContainer").css(
      "height",
      contentHeight
    );
    $("#userProgressContainer .noProgress").css("height", contentHeight);

    kendo.bind($(mad.common.$actualViewID), viewModel);

    viewModel.set("loadingData", false);

    if (origin != "graphProgress" && origin != "planStat") {
      viewModel.set("loadingData", true);

      mad.models.plansProgressList.read().then(function() {
        mad.models.userRoutines.read().then(function() {
          viewModel.set("loadingData", false);

          var plans = mad.common.objectCopy(
            mad.models.plansProgressList.data()
          );
          var madbarz = mad.common.objectCopy(mad.models.userRoutines.data());
          var merged = _.union(plans, madbarz);

          if (merged.length == 0) {
            mad.viewModels.userProgress.viewModel.set("noUserProgress", true);
          } else {
            mad.viewModels.userProgress.viewModel.set("noUserProgress", false);
          }
          mad.viewModels.userProgress.viewModel.mergedData.data(merged);

          if (scroller) scroller.reset(); // go to top !
        });
      });
    }
  }

  function afterShow() {
    viewModel.set("uCanTouchThis", true);

    var viewName = "Profile - Progress loaded";
    mad.analyticEvents.track(
      [mad.analyticEvents.services.GA],
      mad.analyticEvents.categories.PROFILE,
      mad.analyticEvents.types.VIEW,
      viewName,
      null,
      viewName,
      "Screen loaded"
    );
  }

  function odabranWorkout(e) {
    var dataItem;
    //var tappedElement = $(e.touch.currentTarget);
    var tappedElement = e.touch.target; // drazen - zbog nove verzije kenda
    var li = tappedElement.closest("li");
    var itemUID = li.attr("data-uid");

    if (tappedElement.hasClass("plan")) {
      dataItem = mad.models.plansProgressList.getByUid(itemUID);
      viewModel.set("selectedWorkoutPlanId", dataItem.WorkoutPlanId);

      mad.viewModels.planStat.viewModel.set("dataLoaded", false);
      mad.models.plansProgress.read();
      mad.mobileApp.navigate("ui/profile/stats/planStat.html");
      return;
    } else {
      dataItem = mad.models.userRoutines.getByUid(itemUID);
    }

    if (dataItem === undefined) {
      // kliknuto na load more
      return;
    } else {
      //console.log("odabrani item - data", dataItem);
    }

    if (dataItem.IsPro) {
      var checkIfUserHasAccesToProPromise = $.Deferred();
      checkIfUserHasAccesToProPromise
        .then(function(hasUserAccessToPRo) {
          if (hasUserAccessToPRo) {
            handleNavigationFromProgressToRoutines(dataItem);
          } else {
            mad.viewModels.popups.viewModel.openModalWindow(
              "proRutine",
              "Premium workout",
              "Only premium members can see this workout. Premium members:",
              "Learn more"
            );
          }
        })
        .fail(function(err) {
          console.log(
            "There has been some errr determing if user is pro or not: ",
            err
          );
          mad.viewModels.popups.viewModel.openModalWindow(
            "proRutine",
            "Premium workout",
            "Only premium members can see this workout. Premium members:",
            "Learn more"
          );
        });
      mad.common.hasUserAccessToPro(checkIfUserHasAccesToProPromise);
    } else {
      handleNavigationFromProgressToRoutines(dataItem);
    }
  }

  function handleNavigationFromProgressToRoutines(dataItem) {
    if (dataItem.NumberOfTimesUserHasTakenRoutine == 1) {
      var msg =
        "You need to finish 2 or more workouts to see the progress graph";
      navigator.notification.alert(msg, null, "Oops!");
    } else {
      // spremanje Id-a i imena workouta
      mad.viewModels.userProgress.viewModel.set("selectedId", dataItem.Id);
      mad.viewModels.graphProgress.viewModel.set(
        "selectedWorkoutName",
        dataItem.Name
      );

      if (mad.viewModels.profile.viewModel.common.ifOffline()) {
        mad.alerts.error("you are offline", "");
      } else {
        mad.viewModels.graphProgress.viewModel.set("tmpGraphData", []);
        loadScores();
      }
    }
  }

  function loadScores() {
    var route = {
      putanja:
        mad.common.variables.serverUrl + "api/Statistics/GetScoresForRoutine",
      akcija: "GET"
    };
    var options = {
      id: mad.viewModels.userProgress.viewModel.get("selectedId")
    };

    mad.common.showLoader();
    mad.data
      .load(route, options, false, true)
      .done(function(data) {
        mad.viewModels.userProgress.viewModel.set(
          "preparedData",
          prepareData("scores", data, "Points")
        );
        mad.viewModels.userProgress.viewModel.scores.set(
          "Name",
          "Overall Score"
        );
        mad.viewModels.userProgress.viewModel.scores.set("secReps", "Points");
        mad.viewModels.userProgress.viewModel.scores.set("ImageUrl", "");
        mad.viewModels.userProgress.viewModel.scores.set(
          "graphData",
          mad.viewModels.userProgress.viewModel.get("preparedData")
        );
        mad.viewModels.userProgress.viewModel
          .get("tmpExercises")
          .push(mad.viewModels.userProgress.viewModel.get("scores"));

        loadExercises();
      })
      .fail(function(e, r, t) {
        mad.common.hideLoader();
        console.log("Error loading scores graph.", e);
        mad.alerts.error("Error loading scores graph.");
      });
  }

  // a simple factory function
  // pri svakom pozivu umanjuje limit za 1 i kad dođe do 0 pozove callback funkciju
  function countdown(limit, callback) {
    return function() {
      if (--limit === 0) {
        callback();
      }
    };
  }

  var finishedLoading; // will be a funnction that calls countdown;

  function loadExercises() {
    /* dohvacanje svih vjezbi workouta i spremanje u exercises */

    mad.viewModels.graphProgress.viewModel.set("exercises", {});
    mad.viewModels.graphProgress.viewModel.set("exercisesLength", 0);
    mad.viewModels.graphProgress.viewModel.set("exercisesCurrent", 0);
    mad.viewModels.graphProgress.viewModel.set("allExercisesLoaded", false);

    var route = {
      putanja:
        mad.common.variables.serverUrl +
        "api/Statistics/GetDetailsForSingleRoutine",
      akcija: "GET"
    };
    var options = {
      id: mad.viewModels.userProgress.viewModel.get("selectedId")
    };
    mad.data
      .load(route, options, false, true)
      .done(function(data) {
        var ukupnoLoadanja = data.Exercises.length;
        mad.viewModels.graphProgress.viewModel.set(
          "exercisesLength",
          ukupnoLoadanja
        );

        mad.viewModels.graphProgress.viewModel.set(
          "exercises",
          mad.viewModels.userProgress.viewModel.get("tmpExercises")
        );

        //console.log("exercises nakon scores i info", mad.viewModels.graphProgress.viewModel.get("exercises"),data);

        mad.mobileApp.navigate(
          "ui/profile/stats/graphProgress.html?type=scores&strana=0"
        );

        //this fn is called each time getDataForGraph loads data
        finishedLoading = countdown(ukupnoLoadanja, function() {
          // all exercises loaded!
          $.merge(
            mad.viewModels.userProgress.viewModel.get("tmpExercises"),
            data.Exercises
          );
          mad.viewModels.graphProgress.viewModel.set(
            "exercises",
            mad.viewModels.userProgress.viewModel.get("tmpExercises")
          );
          mad.viewModels.userProgress.viewModel.tmpExercises.length = 0;
          mad.viewModels.graphProgress.viewModel.set(
            "allExercisesLoaded",
            true
          );

          //console.log("dohvacene sve vjezbe",mad.viewModels.graphProgress.viewModel.get("exercises"));
        });

        _.each(data.Exercises, function(element, index) {
          _.extend(element, { Rbr: index }); // dodan redni broj
          _.extend(element, { secReps: element.IsTimed ? "Sec's" : "Rep's" }); // jmj
          _.extend(element, { graphData: [] }); // i area u koju ce se smjestiti podaci za graph
          getDataForGraph(element);
        });
      })
      .fail(function(e) {
        console.log("error getting exercises data", e.statusText);
        mad.alerts.error("Error getting exercises data!", "");
      })
      .always(function() {
        mad.common.hideLoader();
      });
  }

  function getDataForGraph(element) {
    // ucitavanje exercises

    var route = {
      putanja:
        mad.common.variables.serverUrl +
        "api/Statistics/GetExercisesForRoutine",
      akcija: "GET"
    };
    var options = {
      routineId: mad.viewModels.userProgress.viewModel.get("selectedId"),
      exerciseId: element.ExerciseId
    };
    mad.data
      .load(route, options, false, true)
      .done(function(data) {
        //console.log("api/Statistics/GetExercisesForRoutine", data);
        mad.viewModels.userProgress.viewModel.set(
          "preparedData",
          prepareData("exercises", data, element.secReps)
        );
        element.graphData = mad.viewModels.userProgress.viewModel.get(
          "preparedData"
        );
        //console.log("ucitan exercise ", element.Rbr);
        $("#prog-kruzic-" + (element.Rbr + 1)).addClass("animatedC loaded");
        finishedLoading();
      })
      .fail(function(e, r, t) {
        console.log("Error loading exercises graph.", e);
        mad.alerts.error("Error loading exercises graph.");
        element.graphData = [];
        finishedLoading();
      });
  }

  function prepareData(type, podaci, secReps) {
    var parseDate = d3.time.format("%B %d, %Y").parse;

    podaci.forEach(function(d) {
      d.Date = parseDate(d.Date);
      d.secReps = secReps;
      if (type == "scores") {
        d.Value = +d.Score;
      } else {
        d.Value = +d.Value;
      }
    });
    return podaci;
  }

  return {
    viewModel: viewModel
  };
})();
