var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.weight = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,

        isButtonVisibleL: true,
        enableIfOfflineL: true,
        leftButtonAction: leftButtonAction,

        isThereEnoughData: isThereEnoughData,
        isButtonVisibleR: isThereEnoughData,
        enableIfOfflineR: checkifOnline,
        rightButtonAction: editWeight,
        closeEditWeight: closeEditWeight,
        deleteWeight: deleteWeight,
        srediDatum: srediDatum,
        srediKile: srediKile,
        editTitle: editTitle,
        tapToDelete: tapToDelete,
        noData: noData,

        selectedGraphType: "",
        selectedGranularity: 2,
        granularitySelected: granularitySelected,
        titlePressed: mad.common.titlePressed,

        enableIfOfflineF: checkifOnline,
        footerBtnPressed: addWeight,

        getLabel: getLabel,
        getWord: getWord,

        selectedWorkoutName: "",

        userWeight: 0,
        lastWeight: 0,

        weightGraph: [],
        preparedData: [],
        reversedData: [],
        filteredData: [],
        units: "",
        itemsDeleted: false,
        isModalOpened: false,

        notEnoughLabel: notEnoughLabel,
        notEnoughData: false

    });

    function initView(){
        console.log("init weight");

        var w = window.innerWidth - 34;
        $('.weightInterval').css('width', w);

        var theme, mode, display, lang;

        theme = $.mobiscroll.defaults.theme,
            mode = 'scroller',
            display = 'bottom',
            lang = 'hr';

        $('#WeightUserWeight').mobiscroll({
            theme: theme,
            mode: mode,
            display: display,
            buttons: buttons,
            lang: lang,
            showLabel: true,
            wheels: getWeightWheels(),
            height: 40,
            maxWidth: 150,
            onClose: function(valueText, botun, inst) {
                var kg, lbs;

                if (botun == "set") {
                    // postavljanje - metric
                    valueText = valueText.toString().split(' ');
                    if (mad.viewModels.profile.viewModel.user.get("IsMetric")){
                        kg = parseInt(valueText[0]);
                    } else {
                        kg = parseInt(valueText[0] * 0.45359237);   // konverzija u kg
                    }
                    console.log("WeightInKg on OK", kg)

                    // konverzija u imperial
                    lbs = Math.ceil(kg * 2.20462).toFixed(0);
                    console.log("Weight in lbs on OK", lbs);

                    var tezina = setWeight(kg, lbs)     // postavi tezinu prema mjernom sustavu

                    var danas = new Date();
                    addToDatabase(tezina, danas);

                   // saveUserInfo(tezina);
                }
            },

            formatResult: function (data) {
                //console.log("weight before format", data);
                if (mad.viewModels.profile.viewModel.user.get("IsMetric")){
                    return data + " kg";
                } else {
                    return data + " lbs";
                }
            },

            parseValue: function (valueText) {
                //console.log("parseValue before format", valueText);
                if (mad.viewModels.profile.viewModel.user.get("IsMetric")){
                    if (valueText) {
                        valueText = valueText.toString().split(' ');
                        return [valueText[0]];
                    } else {
                        return ["77"];
                    }
                } else {
                    if (valueText) {
                        valueText = valueText.toString().split(' ');
                        return [valueText[0]];
                    } else {
                        return ["170"];
                    }
                }
            }
        });

    }

    function getWeightWheels(){
        if (mad.viewModels.profile.viewModel.user.get("IsMetric")){
            return wKilograms;
        }else{
            return wLbs;
        }
    }

    function showView(e){
        var that = this;
        console.log("show weight");

        mad.common.setActualView(); mad.common.addViewToHistory();

        loadData("show"); // load data & show graph



    }

    function afterShow(){
        console.log("after show weight");
        mad.common.stretchView();
        mad.common.setLangForView();                        //add language name class to each class

        mad.googleAnalytics.trackView("Track Weight");

    }

    function leftButtonAction() {
        console.log("left button clicked");
        //mad.mobileApp.navigate("ui/profile/editProfile.html", "slide:right");
        mad.common.goBack();
    }

    function editWeight(){
        mad.viewModels.weight.viewModel.set("isModalOpened", true);
        mad.viewModels.weight.viewModel.set("itemsDeleted", false);
        $("#weightBrisanje").data("kendoMobileModalView").open();
    }

    function closeEditWeight(){
        if (mad.viewModels.weight.viewModel.get("itemsDeleted") == true){
            console.log("show again");
            showView();                 // ponovni prikaz i loadanje podataka
        }
        $("#weightBrisanje").data("kendoMobileModalView").close();
        mad.viewModels.weight.viewModel.set("isModalOpened", false);
    }

    function getLabel(label){
        return mad.common.translate("ui", label);
    }

    function getWord(word){
        return mad.common.translate("words", word);
    };

    function loadData(fromWhere){

        console.log("loading data");
        mad.common.showLoader("Loading");

        /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/Statistics/GetWeight";
        mad.common.variables.forAjax.akcija = "GET";
        mad.common.variables.dataOptions = {};
        */
        var link   = {putanja : mad.common.variables.serverUrl + "api/Statistics/GetWeight", akcija : "GET"};

        mad.data.load(link, {}, false, true)
        .done(function (data) {
                //console.log("tezine", data);

            if (data.Weights.length > 1 ){
                mad.viewModels.weight.viewModel.set("notEnoughData", false);
            }else{
                mad.viewModels.weight.viewModel.set("notEnoughData", true);
            }

            mad.viewModels.weight.viewModel.set("userWeight", getWeight(false));
            mad.viewModels.weight.viewModel.set("weightGraph", data.Weights);
            mad.viewModels.weight.viewModel.set("units", data.IsMetric ? "kg" : "lbs");
            mad.viewModels.weight.viewModel.set("preparedData", prepareData());
            mad.viewModels.weight.viewModel.set("reversedData", _.sortBy(mad.viewModels.weight.viewModel.get("preparedData"), function (x) {
                return -x.Date
            }));

            console.log( mad.viewModels.weight.viewModel.get("reversedData"));

            filterData(mad.viewModels.weight.viewModel.get("preparedData"));

            if (fromWhere == "show"){showGraph();}

            $('#WeightUserWeight').mobiscroll('option', 'wheels', getWeightWheels());

            kendo.bind($(mad.common.$actualViewID), viewModel);

            setViewTitle();
            mad.common.hideLoader();

        })
        .fail(function (e, r, t) {
            console.log("Error loading weight graph.", e);
            //mad.alerts.error("Error loading weight graph.");
            //setupView();
            kendo.bind($(mad.common.$actualViewID), viewModel);
            mad.common.hideLoader();
        });
    }

    function isThereEnoughData(){
        return !mad.viewModels.weight.viewModel.get("notEnoughData");
    }

    function prepareData() {
        var podaci = mad.viewModels.weight.viewModel.get("weightGraph");
        var parseDate = d3.time.format("%B %d, %Y").parse;
        var tmpUnit = mad.viewModels.weight.viewModel.get("units");

        podaci.forEach(function (d) {
            d.Date = parseDate(d.Date);
            d.Value = +d.Weight;
            d.Unit = tmpUnit;
        });
        return podaci;
    }

    function filterData(data) {
        var index = mad.viewModels.weight.viewModel.get("selectedGranularity");

        var ukupno = data.length,
            interval = [7, 30, ukupno];

        mad.viewModels.weight.viewModel.filteredData = data.filter(function (d, i) {
            return i >= ukupno - interval[index];
        })
    }

    function granularitySelected(){
        mad.viewModels.weight.viewModel.set("selectedGranularity", this.current().index());
        filterData(mad.viewModels.weight.viewModel.get("preparedData"));
        showGraph();
    };

    function showGraph() {

        var chart = d3.dr.graf1()
            .type(mad.viewModels.weight.viewModel.get("units"))
            .granularity(mad.viewModels.weight.viewModel.get("selectedGranularity"));

       // chart.info(mad.viewModels.weight.viewModel.get("infoObject"))
        d3.select("#weightGraf").datum(mad.viewModels.weight.viewModel.get("filteredData")).call(chart);

    }

    function setupView(id){
        mad.common.stretchView();
        setViewTitle();
        mad.common.setResolutionForView(parseInt(mad.mobileApp.view().content.width()), parseInt(mad.mobileApp.view().content.height()));
        mad.common.setLangForView();

    };

    function setViewTitle(){
        var naslov = titleWeight();

        mad.common.actualView.title = naslov;
        mad.common.actualView.header
            .find(".km-navbar")
            .data("kendoMobileNavBar").title(naslov);
    };

    function titleWeight(){
        //return mad.glossary.ui.weightView.labels.yourWeight[mad.common.observables.languageIndex()] + " " + getLastUserWeightWithJMJ();
        return mad.glossary.ui.weight.labels.yourWeight[mad.common.observables.languageIndex()] + " " + getLastUserWeightWithJMJ();
       // return getLabel('labels.yourWeight') + " " + getLastUserWeightWithJMJ();
    }

    function getLastUserWeightWithJMJ(){
        var podaci = mad.viewModels.weight.viewModel.get("reversedData");
        var vrati;
        if (!mad.common.isNullOrEmpty(podaci) && podaci.length > 0){
            vrati = podaci[0].Weight + " " + podaci[0].Unit;
        }else{
            vrati = "???";
        }
        return vrati;
    }

    function checkifOnline(){
        return this.common.ifOnline();
    };

    function getWeight(withUnits){
        var weight, jmj, retVal;

        if (mad.viewModels.profile.viewModel.user.get("IsMetric")){
            weight = mad.viewModels.profile.viewModel.user.get("WeightInKg");
            jmj = " kg";
        }else{
            weight = mad.viewModels.profile.viewModel.user.get("Weight");
            jmj = " lbs";
        }

        if (typeof weight === 'undefined'){
            weight = withUnits ? "?" : "0"
        }

        retVal = weight + (withUnits ? jmj : "");
        return retVal;
    }

    function getLastUserWeight(){
        var podaci = mad.viewModels.weight.viewModel.get("reversedData");
        var vrati;
        if (!mad.common.isNullOrEmpty(podaci) && podaci.length > 0){
            vrati = parseInt(podaci[0].Weight);
        }else{
            vrati = 0;
        }
        return vrati;
    }

    function setWeight(metricW, imperialW){
        var weight;

        if (mad.viewModels.profile.viewModel.user.get("IsMetric")){
            weight = metricW;
        }else{
            weight = imperialW;
        }
        return weight;
    };

    function getWeightAll(){
        var weight, jmj, retVal;

        if (mad.viewModels.profile.viewModel.user.get("IsMetric")){
            weight = mad.viewModels.profile.viewModel.user.get("WeightInKg");
            retVal = Math.ceil(mad.viewModels.profile.viewModel.user.get("WeightInKg")) + " kg";
        }else{
            weight = mad.viewModels.profile.viewModel.user.get("Weight");

            retVal = Math.ceil(mad.viewModels.profile.viewModel.user.get("Weight")) + " lbs";
            jmj = " lbs";
        }

        if (typeof weight === 'undefined'){
            weight = "?"
        }

        retVal = weight + jmj;
        return retVal;
    };

    function addWeight(){
        var inst = $('#WeightUserWeight').mobiscroll('getInst');
        //var v = mad.viewModels.weight.viewModel.get("userWeight").toString().split(',');
        var v = getLastUserWeight();
        console.log("zadnja je", v);

        inst.setVal(v, true, false, false, 2);
        inst.show(); // Call the show method;
    }

    function addToDatabase(w,d){
        var parseDate;
        if (mad.viewModels.profile.viewModel.user.get("IsMetric")){
            parseDate = d3.time.format("%d.%m.%Y");   // dd.mm.gg
        }else{
            parseDate = d3.time.format("%m.%d.%Y");   // mm.dd.gg
        }
        console.log("tezina se sprema s datumom", parseDate(d));

        mad.common.showLoader();

        /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/Statistics/CreateWeightEntry";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = {
            weight:  w ,
            date: parseDate(d)
        };
        */

        var link   = {putanja : mad.common.variables.serverUrl + "api/Statistics/CreateWeightEntry", akcija : "POST"};
        var podaci = {
            weight:  w ,
            date: parseDate(d)
        };

        mad.data.post(link, podaci)
            .done(function (data) {
                console.log("nakon add", data);
                showView();
            })
            .fail(function (e, r, t) {
                console.log("Error adding weight info.", e);
                mad.alerts.error("Error adding weight info.");
            })
            .always(function(){
                mad.common.hideLoader();
            });
    }

    function deleteWeight(e){
       // e.preventDefault();
        var id = e.dataItem.Id;
        var msg = mad.glossary.messages.delete,
            language = mad.common.observables.languageIndex();
        navigator.notification.confirm(
            msg.message[language],
            function (button) {
                if (button == 1) {                  // yes
                    doDelete(id);
                }
            },
            "",
            [msg.button1[language], msg.button2[language]]);
    }

    function doDelete(id){
        mad.common.showLoader("Deleting");

        /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/Statistics/DeleteWeightEntry";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = {
            id:  id
        };
        */
        var link   = {putanja : mad.common.variables.serverUrl + "api/Statistics/DeleteWeightEntry", akcija : "POST"};
        var podaci = {
            id:  id
        };

        mad.data.post(link, podaci)
            .done(function (data) {
                console.log("nakon delete", data);
                if (data == true){
                    mad.viewModels.weight.viewModel.set("itemsDeleted", true);
                    loadData("delete");
                }else{
                    mad.alerts.error("Item is not deleted.");
                }
                mad.common.hideLoader();
            })
            .fail(function (e, r, t) {
                console.log("Error deleting weight info.", e);
                mad.alerts.error("Error deleting weight info.");
                mad.common.hideLoader();
            });

    }

    function editTitle(){
        return mad.glossary.ui.weight.labels.weightData[mad.common.observables.languageIndex()];
    }

    function tapToDelete(){
        return mad.glossary.ui.weight.labels.tapToDelete[mad.common.observables.languageIndex()];
    }

    function noData(){
        return mad.glossary.ui.weight.labels.noData[mad.common.observables.languageIndex()];
    }

    function saveUserInfo(tezina){
        mad.alerts.info("SAVEing weight for User",tezina);
    }

    function srediDatum (datum) {
        var formatDat = d3.time.format("%b %d, %Y");
        return formatDat(datum);
    }

    function srediKile (k, j) {
        return k + " " + j;
    }

      function notEnoughLabel(){
        return mad.glossary.ui.weight.labels.noWeight[mad.common.observables.languageIndex()];
    }

    return {
        viewModel: viewModel
    };

}());

