var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.otherUserHistory = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        beforeShow: beforeShow,
        show: showView,
        afterShow: afterShow,

        showUserImage: showUserImage,

        setRespectClass: setRespectClass,

        selectedId: 0,
        selectedItem: {},       //ne treba jer se lista uvijek reloada od pocetka

        workoutsCount: 0,
        noUserWorkouts: false,

        UserId: "",
        previousUserId: "",
        currentUsername: "",

        cameFrom: "",
        selectedWorkoutName: "",

        uCanTouchThis: false,

        removeSelectedItemFromDS: removeSelectedItemFromDS
    });

    var feed = "otherUserHistory",
        ds = mad.models.profileOtherUserFeed;

    function initView(e){
        initFeedList();

        viewModel.set("previousUserId", "");

        var viewID = "#otherUserHistory";

        viewModel.set("uCanTouchThis", false);

        var scrl = $("#otherUserHistory-scroller");
        var scroller;

        if (scrl.length) {
            scroller = scrl.data("kendoMobileScroller");
        }else{
            console.log("neka greska s scrollerom - nema ga");
        }

        $(viewID).kendoTouch({
            filter: ".lButton, .gotoWorkout, .respectClick",

            touchstart: function(e) {
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    if(scroller){
                        if (scroller.enabled){
                            scroller.disable();
                        }
                    }
                }else{
                    if(scroller){
                        if (!scroller.enabled) {
                            scroller.enable();
                        }
                    }
                }
            },
            tap: function(e) {
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                }else{
                    handleTap(e);
                }
            }
        });
    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target;

        if ($(element).hasClass("lButton")) {
            mad.common.goBack();
        }else if ($(element).hasClass("gotoWorkout") ||
                  $(element).hasClass("respectClick")){
            somethingSelected(e);
        }
    }

    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e){
        var contentWidth,
            contentHeight,
            currentUsername = "",
            currenUserId = "",
            previousUserId = viewModel.get("previousUserId");

        mad.common.setActualView(); mad.common.addViewToHistory();

        contentHeight = mad.common.stretchViewContentToBeElastic();
        contentWidth =  $(window).width();

        $("#" + feed + "-scroller").css("height", contentHeight);
        $("#otherUserHistory .noProgress").css({
            "height": contentHeight,
            "width": contentWidth
        });

        kendo.bind($(mad.common.$actualViewID), viewModel);

        if (e.view.params.UserName) {
            currentUsername = e.view.params.UserName;
            viewModel.set("currentUsername", currentUsername);
        }

        if (e.view.params.UserId) {
            currenUserId = e.view.params.UserId;
            viewModel.set("UserId", currenUserId);
        }

        setViewTitle(viewModel.get("currentUsername"));

        if (previousUserId = "" || previousUserId != currenUserId){
            viewModel.set("previousUserId", currenUserId);
            doQuery();
        }
    }

    function afterShow(){
        viewModel.set("uCanTouchThis", true);

        var viewName = "Profile Other - Workouts loaded";
        mad.analyticEvents.track([mad.analyticEvents.services.GA], mad.analyticEvents.categories.PROFILEOTHER, mad.analyticEvents.types.VIEW,
            viewName,
            null,
            viewName,
            "Screen loaded");

        var selectedItem = viewModel.get("selectedItem");
        if (mad.common.isNullOrEmpty(selectedItem.WorkoutId)){
            return  // no selectedItem - exit
        }

        var respectIcon = $("#respectBtn-OUH-" + selectedItem.WorkoutId);
        if (selectedItem.HasRespected) {
            respectIcon.removeClass("respect").addClass("respected");
        } else {
            respectIcon.removeClass("respected").addClass("respect");
        }

        mad.common.updateRespectTxt("-OUH-", selectedItem);

    }

    function setViewTitle(naslov) {
        mad.common.actualView.title = naslov;
        mad.common.actualView.header
            .find(".km-navbar")
            .data("kendoMobileNavBar").title(naslov);
    }

    function initFeedList() {
        $("#" + feed + "-scroller").kendoMobileScroller({
            pullToRefresh: true,
            pullOffset: 80,
            messages: {
                pullTemplate: $("#refresh-template").html(),
                releaseTemplate: $("#refresh-template").html(),
                refreshTemplate: $("#refresh-template").html()
            },
            pull: function(e){
                var scroller = e.sender;
                var listview = $("#" + feed + "-list").data("kendoMobileListView");
                listview.dataSource.read()
                    .then(function(){
                        scroller.animatedScrollTo(0,0);
                        scroller.pullHandled();
                    })
                    .fail(function(e){
                        scroller.animatedScrollTo(0,0);
                        scroller.pullHandled();
                    });
            }
        });

        $("#" + feed + "-list").kendoMobileListView({
            dataSource: ds,
            autoBind: false,
            endlessScroll: true,
            template: function (data) {
                //console.log("workout template item", data);
                var tpl = kendo.template($("#feed-workouts-template").text());
                return tpl(data);
            }
        });
    }

    function somethingSelected (e){
        var listview =  $("#" + feed + "-list").data("kendoMobileListView");
        //var tappedElement = $(e.touch.currentTarget);          //za klik je $(e.target)
        var tappedElement = e.touch.target;  // drazen - zbog nove verzije kenda

        var li = tappedElement.closest("li");
        var selectedItemData = listview.dataSource.getByUid(li.attr("data-uid"));
        mad.viewModels.otherUserHistory.viewModel.set("selectedItem", selectedItemData);

        if (!mad.common.isNullOrEmpty(selectedItemData)){
            mad.common.handleFeedTap("otherUserHistory", listview, tappedElement, selectedItemData, 0);   //parms:origin, listview, tappedElement, selectedItem, tab
        }
    }

    function doQuery() {
        var scroller = $("#" + feed + "-scroller").data("kendoMobileScroller");

        if (!ds.online()){                          // if offline - move down to see preloader
            scroller.animatedScrollTo(0,30);
        }

        var options = {
            pageSize: 24,
            take: 24,
            skip: 0,
            page: 1
        };

        scroller.reset();                           // go to top

        ds.query(options)
            .then(function(e){
                if (ds.online()){                   // when data fetched when online hide preloader

                    if (ds.data().length === 0) {
                        viewModel.set("noUserWorkouts", true);
                    }else{
                        viewModel.set("noUserWorkouts", false);
                        setTimeout(function() {
                            scroller.animatedScrollTo(0,0);
                        },444);
                    }
                }
            })
            .fail(function(e){
                console.log("error fetching other user history" + feed, e.statusText);
                mad.alerts.error("Problem fetching user workouts!","");
            });
    }

    function showUserImage(img) {
        return (img != "/img/profile.jpg" && img != "https://madbarzpictures.blob.core.windows.net/madbarzpictures/profile-web-retina.jpg") ? img : "images/workout-icon.png";
    }

    function setRespectClass(hasResected) {
        if (hasResected) {
            return "respected";
        } else {
            return "respect";
        }
    }
    function removeSelectedItemFromDS(){
        return; // brisanje tuđih workouta ne bi trebalo ici
        var listview = $("#otherUserHistory-list").data("kendoMobileListView");
        var selectedItem = viewModel.get("selectedItem");
        var ds = listview.dataSource;
        ds.remove(selectedItem);
        listview.refresh();
    }

    return {
        viewModel: viewModel
    };

}());

