var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.profileOtherUser = (function() {
  "use strict";

  var viewModel = kendo.observable({
    // properties or functions we want to observe and expose to html
    common: mad.common.observables,
    init: initView,
    beforeShow: beforeShow,
    show: showView,
    afterShow: afterShow,

    currentUsername: "",
    currentDispalyName: "",
    UserId: "",

    NumberOfFollowers: 0,
    NumberOfFollowing: 0,
    showInstagram: false,

    origin: "feed",
    user: {},
    userDataDefault: {
      UserName: "",
      DisplayName: "",
      Country: "",
      Age: "",
      Gender: "",
      ProfilePhoto: "/img/profile.jpg",
      ImageUrl: "images/profile-web-retina.jpg",
      Bio: "",
      Level: "0",
      ScoreToNextLevel: 0,
      PercentageToNextLevel: 0,
      NumberOfFollowers: "",
      NumberOfFollowing: "",
      NumberOfRespects: "",
      IsCurrentUserFollowingThisOne: false
    },

    hasWorkouts: false,
    workoutsText: "",

    showBig: false,
    bigImageSrc: "",
    bigPhotoLoaded: false,
    bigPhoto: bigPhoto,
    hideBigPhoto: hideBigPhoto,
    showFollowers: showFollowers,

    enabled: true,
    uCanTouchThis: false,

    generatedMenu: "",
    workoutId: null,
    titlePressed: null
  });

  function initView(e) {
    //$("#feed-otherUserProfile-scroller").kendoMobileScroller();
    var viewID = "#profileOtherUser";

    viewModel.set("uCanTouchThis", false);

    var scroller = e.view.scroller;

    $(viewID).kendoTouch({
      filter:
        ".lButton, .hideBigPhoto, .smallPhoto, .onFollowClick, .showFollowers, .menuTap, .instaTap",
      touchstart: function(e) {
        //console.log("touchstart");
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          //console.log("touchstart but canceled")
          if (scroller) {
            if (scroller.enabled) {
              scroller.disable();
              //console.log("scroller.disabled", scroller);
            }
          }
        } else {
          if (scroller) {
            if (!scroller.enabled) {
              scroller.enable();
              //console.log("scroller.enabled")
            }
          }
        }
      },
      tap: function(e) {
        //console.log(e.touch.target, " was tapped");
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          //console.log("but canceled")
        } else {
          handleTap(e);
        }
      }
    });
  }

  function handleTap(e) {
    e.preventDefault(); // da ne probija

    var element = e.touch.target;

    if ($(element).hasClass("lButton")) {
      mad.common.goBack();
    } else if ($(element).hasClass("hideBigPhoto")) {
      hideBigPhoto();
    } else if ($(element).hasClass("smallPhoto")) {
      bigPhoto();
    } else if ($(element).hasClass("showFollowers")) {
      showFollowers(element);
    } else if ($(element).hasClass("onFollowClick")) {
      onFollowClick();
    } else if ($(element).hasClass("menuTap")) {
      viewModel.common.goTo(e);
    } else if ($(element).hasClass("instaTap")) {
      handleInstagramTap();
    }
  }

  function beforeShow(e) {
    viewModel.set("uCanTouchThis", false);
  }

  function initList() {
    $("#feed-otherUserProfile-list")
      .kendoMobileListView({
        autoBind: false,
        endlessScroll: true,
        dataSource: mad.models.profileOtherUserFeed,
        template: function(data) {
          var tpl, output;
          tpl = kendo.template($("#feed-workouts-template").text());
          output = tpl(data);
          //console.log("workout", data.WorkoutName, data.Points)
          return output;
        }
      })
      .kendoTouch({
        filter: ".follow-container, .gotoWorkout, .respectClick",
        tap: somethingSelected
      });
  }

  function showView(e) {
    /*
        var fotkaB = $("#profile-user-img .bigPhoto");
        fotkaB.on('load', function(){
            console.log("img loaded");
        });
        */

    viewModel.set("showBig", false);
    viewModel.set("bigPhotoLoaded", false);
    viewModel.set("showInstagram", false);

    var fotkaS = $("#profile-user-img .loading-thumb");
    fotkaS.removeClass("noOpacity");

    mad.common.pushNotificationSemaphore.lock();

    var currentUsername = "",
      currenUserId = "";

    var origin = e.view.params.origin;
    if (origin) {
      viewModel.set("origin", origin);

      console.log("origin", origin);
    }

    if (e.view.params.UserName) {
      currentUsername = e.view.params.UserName;
      viewModel.set("currentUsername", currentUsername);

      currenUserId = e.view.params.UserId;
      viewModel.set("UserId", currenUserId);

      if (e.view.params.WorkoutId) {
        viewModel.set("workoutId", e.view.params.WorkoutId);
      }
    } else {
      console.log("nema UserName parametra", e.view.params);
      return;
    }

    mad.common.setActualView();
    mad.common.addViewToHistory();
    mad.common.stretchViewContentToBeElastic();

    mad.common.scrollViewToTop();

    // inicijaliziranje info o useru
    viewModel.set("user", viewModel.userDataDefault);
    var tpl = kendo.template($("#otherUserProfile-info-template").html());
    var output = tpl(viewModel.get("user"));
    $("#otherUserFeed").html(output);

    generateMenu();

    // da bi se sto prije prikazao (un)follow gumb na osnovu IsCurrentUserFollowingThisOne varijable
    // sakrio nepotreban header vezan uz noNavbar
    kendo.bind($(mad.common.$actualViewID), viewModel);

    loadUserInfo(currenUserId);
  }

  function afterShow(e) {
    viewModel.set("uCanTouchThis", true);
    mad.common.pushNotificationSemaphore.unlock();

    mad.analyticEvents.track(
      [mad.analyticEvents.services.GA, mad.analyticEvents.services.FB],
      mad.analyticEvents.categories.PROFILEOTHER,
      mad.analyticEvents.types.VIEW,
      "Profile Other - Screen Loaded",
      null,
      "Profile other",
      "Screen loaded"
    );
  }

  function loadUserInfo(user) {
    var w, p, l, r, t;

    var route = {
      putanja: mad.common.variables.serverUrl + "api/user/GetUserById",
      akcija: "GET"
    };

    var options = {
      id: user
    };

    viewModel.set("hasWorkouts", false);
    viewModel.set("workoutsText", "");

    mad.data
      .load(route, options, false, true)
      .done(function(data) {
        console.log("dohvatio podatke za usera -" + data.UserName + " -", data);

        if (mad.common.isNullOrEmpty(data.Bio)) {
          data.Bio = "";
        }

        viewModel.set("user", data);
        viewModel.set("currentUsername", data.UserName);
        viewModel.set("currentDispalyName", data.DisplayName);
        viewModel.set("showInstagram", data.InstagramLink.length > 0);

        if (data.NumberOfFeedItems > 0) {
          viewModel.set("hasWorkouts", true);
          if (data.NumberOfFeedItems == 1) {
            viewModel.set("workoutsText", "1 workout");
          } else {
            viewModel.set("workoutsText", data.NumberOfFeedItems + " workouts");
          }
        }

        viewModel.set("NumberOfFollowers", data.NumberOfFollowers);
        viewModel.set("NumberOfFollowing", data.NumberOfFollowing);

        var tpl = kendo.template($("#otherUserProfile-info-template").html());
        var output = tpl(viewModel.get("user"));
        $("#otherUserFeed").html(output);

        w = parseInt(mad.mobileApp.view().content.width());
        p =
          $("#otherUserFeed .navbar").innerWidth() -
          $("#otherUserFeed .navbar").width();
        l = $("#otherUserFeed .lButtonContainer").width();
        r = $("#otherUserFeed .rButtonContainer").width();
        t = parseInt(w - p - l - r);
        $("#otherUserFeed .mTitle").css("maxWidth", t);

        kendo.bind($(mad.common.$actualViewID), viewModel);

        mad.common.animate();
      })
      .fail(function(data) {
        console.log("error");
        mad.alerts.error("Error fetching user data!", "");
        viewModel.set("user", viewModel.userDataDefault);

        var tpl = kendo.template($("#otherUserProfile-info-template").html());
        var output = tpl(viewModel.get("user"));
        $("#otherUserFeed").html(output);

        kendo.bind($(mad.common.$actualViewID), viewModel);

        mad.common.animate();
      });
  }

  function generateMenu() {
    var template = kendo.template($("#profile-tap-menu-template").html(), {
      useWithBlock: false
    });
    // kloniranje array of objects (objekt je u stvari JSON serializable sadržaj)
    var data = JSON.parse(
      JSON.stringify(mad.glossary.ui.profileOtherUser.menu)
    );

    var userInfo =
      "&UserId=" +
      viewModel.get("UserId") +
      "&UserName=" +
      encodeURIComponent(viewModel.get("currentUsername"));

    _.each(data, function(obj) {
      obj.link += userInfo;
    });
    console.log("generiranje menija - podaci", data);

    var result = template(data); //Pass the data to the compiled template
    mad.viewModels.profileOtherUser.viewModel.set("generatedMenu", result);
    $("#otherUserMenu-list").html(viewModel.generatedMenu); // display menu
  }

  function showFollowers(element) {
    if (element.context.className.indexOf("followers") > -1) {
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA],
        mad.analyticEvents.categories.PROFILEOTHER,
        mad.analyticEvents.types.EVENT,
        "Profile Other - Followers click",
        null,
        "Profile other",
        "Followers click"
      );

      mad.mobileApp.navigate(
        "ui/following/following.html?origin=profileOtherUser&UserName=" +
          encodeURIComponent(viewModel.get("user.DisplayName")) +
          "&UserId=" +
          viewModel.get("UserId") +
          "&followers=" +
          viewModel.get("NumberOfFollowers") +
          "&following=" +
          viewModel.get("NumberOfFollowing") +
          "&tab=0",
        "slide:left"
      );
    } else {
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA],
        mad.analyticEvents.categories.PROFILEOTHER,
        mad.analyticEvents.types.EVENT,
        "Profile Other - Following click",
        null,
        "Profile other",
        "Following click"
      );

      mad.mobileApp.navigate(
        "ui/following/following.html?origin=profileOtherUser&UserName=" +
          encodeURIComponent(viewModel.get("user.DisplayName")) +
          "&UserId=" +
          viewModel.get("UserId") +
          "&followers=" +
          viewModel.get("NumberOfFollowers") +
          "&following=" +
          viewModel.get("NumberOfFollowing") +
          "&tab=1",
        "slide:left"
      );
    }
  }

  function somethingSelected(e) {
    /* drazen - zasto ne bi imali reason to follow ili comment - kod folovanja */

    var listview = $("#feed-otherUserProfile-list").data("kendoMobileListView");
    //var tappedElement = $(e.touch.currentTarget);
    var tappedElement = e.touch.target; // drazen - zbog nove verzije kenda

    var li = tappedElement.closest("li");
    var selectedItem = listview.dataSource.getByUid(li.attr("data-uid"));

    if (!mad.common.isNullOrEmpty(selectedItem)) {
      mad.common.handleFeedTap(
        "profileOtherUser",
        listview,
        tappedElement,
        selectedItem,
        0
      ); //parms:origin, listview, tappedElement, selectedItem, tab
    }
  }

  function bigPhoto() {
    viewModel.set("bigPhotoLoaded", true);

    var w = parseInt(mad.mobileApp.view().content.width()) * 0.8,
      fotkaB,
      bgi = "",
      exchangeImages = function(newImgLink) {
        console.log("exchangeImages, link=", newImgLink);
        if (newImgLink) {
          fotkaB.removeClass("noOpacity opacity");
          fotkaB.removeClass("km-icon km-photoLoading");
          fotkaB.css("background-image", 'url("' + newImgLink + '")');
        }
        fotkaB.addClass("opacity");
      };

    // show big placeholder
    viewModel.set("showBig", true);
    fotkaB = $("#profile-user-img .bigPhoto");
    fotkaB.css({ width: w, height: w });

    bgi = fotkaB.css("background-image");
    if (bgi == "none") {
      fotkaB.addClass("km-icon km-photoLoading opacity");
    }

    // load img link
    mad.data
      .load(
        {
          putanja:
            mad.common.variables.serverUrl + "api/user/GetUserLargePicture",
          akcija: "GET"
        },
        { id: viewModel.get("UserId") },
        false,
        true
      )
      .done(function(data, textStatus, jqXHR) {
        console.log("img link loaded", data);
        mad.common.preloadImage(data, exchangeImages);
      })
      .fail(function(jqXHR, textStatus, errorThrown) {
        console.log("GetUserLargePicture error", textStatus, errorThrown);
        fotkaB.addClass("opacity");
      });

    mad.analyticEvents.track(
      [mad.analyticEvents.services.GA],
      mad.analyticEvents.categories.PROFILEOTHER,
      mad.analyticEvents.types.EVENT,
      "Profile Other - Photo click",
      null,
      "Profile other",
      "Photo click"
    );
  }

  function hideBigPhoto() {
    viewModel.set("bigPhotoLoaded", false);

    var fotka = $("#profile-user-img .bigPhoto");
    fotka.css({ width: "6rem", height: "6rem" });
    fotka.addClass("noOpacity");

    setTimeout(function() {
      viewModel.set("showBig", false);
    }, 0);
  }

  function onFollowClick() {
    var route,
      isFollowing = viewModel.get("user.IsCurrentUserFollowingThisOne");
    var currentUserNoOfFollowing = parseInt(
      mad.common.variables.userNoFollowing
    );
    var thisUserNoOfFollwoing = parseInt(
      viewModel.get("user.NumberOfFollowers")
    );

    if (isFollowing) {
      route = {
        putanja: mad.common.variables.serverUrl + "api/follow/UnFollow",
        akcija: "POST"
      };
      viewModel.set("user.IsCurrentUserFollowingThisOne", false);
      currentUserNoOfFollowing--;
      thisUserNoOfFollwoing--;
      viewModel.set("user.NumberOfFollowers", thisUserNoOfFollwoing);
      mad.common.variables.userNoFollowing = currentUserNoOfFollowing;
    } else {
      route = {
        putanja: mad.common.variables.serverUrl + "api/follow/Follow",
        akcija: "POST"
      };
      viewModel.set("user.IsCurrentUserFollowingThisOne", true);
      currentUserNoOfFollowing++;
      thisUserNoOfFollwoing++;

      viewModel.set("user.NumberOfFollowers", thisUserNoOfFollwoing);
      mad.common.variables.userNoFollowing = currentUserNoOfFollowing;

      mad.googleAnalytics.trackEvent(
        "Social",
        "Follow",
        "From Other Users Profile"
      );

      var analyticsData = {
        Source: "Profile other"
      };
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA],
        mad.analyticEvents.categories.SOCIAL,
        mad.analyticEvents.types.EVENT,
        "Follow clicked",
        analyticsData,
        "Social",
        "Follow",
        "From Other Users Profile"
      );
    }

    var options = {
      Id: viewModel.get("UserId")
    };

    mad.data.load(route, options, false, true).done(function(data) {
      if (data.Result) {
        /*
             ako je dosao npr. iz searcha
             azurirati u mad.viewModels.search.selectedItem.IsCurrentUserFollowingThisOne
                */

        var promise = $.Deferred();
        mad.common.getUserInfo(promise, false); //to update global NumberOfFeedItemsInFeedFollowing

        if (viewModel.get("origin") == "search") {
          console.log("dosli smo sa searcha");
          // azuriraj view model kako bi se to reflektiralo na listu
          mad.viewModels.search.viewModel.set(
            "selectedItem.IsCurrentUserFollowingThisOne",
            viewModel.get("user.IsCurrentUserFollowingThisOne")
          );
        }
      } else {
        console.log("greska kod updata following", data.Message);
        viewModel.set(
          "user.IsCurrentUserFollowingThisOne",
          !viewModel.get("user.IsCurrentUserFollowingThisOne")
        );
        if (viewModel.get("user.IsCurrentUserFollowingThisOne")) {
          viewModel.set(
            "user.NumberOfFollowers",
            parseInt(viewModel.get("user.NumberOfFollowers")) + 1
          );
        } else {
          viewModel.set(
            "user.NumberOfFollowers",
            parseInt(viewModel.get("user.NumberOfFollowers")) - 1
          );
        }
      }
    });
  }

  function handleInstagramTap() {
    console.log("clicked instagram");
    var instaLink = viewModel.get("user.InstagramLink");
    if(instaLink.length > 0){
        window.open(instaLink, "_system");

    } else{
      mad.alerts.error("There has been some error, please try again or contact support");
    }
  }

  return {
    viewModel: viewModel
  };
})();
