var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.search = (function() {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,
        beforeHide: beforeHide,
        leftButtonAction: mad.common.goBack,

        selectedItem: {},
        selectedListview: {},

        usersCount: 0,
        usersDiscoverCount: 0,
        usersHotCount: 0,
        pulling: false,
        noUsers: false,
        noUsersHot: false,
        noUsersDiscover: false,

        listviewReady: false,
        arePillsVisible: arePillsVisible,
        pillsVisible: true,

        hasFocus: hasFocus,
        inputHasSomething: false,

        onSearchClick: onSearchClick,
        inputChanged: inputChanged


    });

    function initView(e) {
        initSubmenu();
    }

    function initSubmenu() {
        var listviews = $(".searchOptions");
        listviews.hide().eq(0);

        $("#searchMenu").kendoMobileButtonGroup({
            select: function(e) {
                var listviews = $(".searchOptions");
                listviews.hide().eq(e.index).show();
                console.log("odabran", e.index);
                var data;
                if (e.index == 0){                          // near you - discover
                    $("#searchHotTab").find(".k-state-selected").removeClass('k-state-selected');
                    loadDiscovered();
                    var scroller1 = $("#discover-scroller");
                    if (scroller1.length) {
                        //scroller1.data("kendoMobileScroller").reset();
                    }
                    data = {
                        "Type": "Near you"
                    };
                    mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.FB], mad.analyticEvents.categories.PEOPLE, mad.analyticEvents.types.VIEW,
                        "People screen loaded",
                        data,
                        "People screen loaded",
                        "Screen loaded");


                }else{
                    $("#searchDiscoverTab").find(".k-state-selected").removeClass('k-state-selected');
                    loadTrending();
                    var scroller1 = $("#hot-scroller");
                    if (scroller1.length) {
                        //scroller1.data("kendoMobileScroller").reset();
                    }
                    data = {
                        "Type": "Trending"
                    };
                    mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.FB], mad.analyticEvents.categories.PEOPLE, mad.analyticEvents.types.VIEW,
                        "People screen loaded",
                        data,
                        "People screen loaded",
                        "Screen loaded");

                }
            }
        });

        initSearchUsersModel();
        initDiscoverModel();
        initHotModel();
    }

    function showView(e) {
        var origin = e.view.params.origin;
        console.log("origin", origin);

        mad.common.setActualView();
        mad.common.addViewToHistory();

        mad.common.stretchView();
        viewModel.set("pulling", false);

        var buttongroup = $("#searchMenu").data("kendoMobileButtonGroup");
        var listviews = $(".searchOptions");

        if (origin == "feed" || origin =="following") {
            loadDiscovered();
            $("#searchFollowing").val("");
            viewModel.set("inputHasSomething", false);
            viewModel.set("pillsVisible", true);

            buttongroup.select(0);
            listviews.hide().eq(0).show();
        }

        kendo.bind($(mad.common.$actualViewID), viewModel);

        var lastListView = viewModel.get("selectedListview");
        if (!mad.common.isNullOrEmpty(lastListView.dataSource) && lastListView.dataSource.data().length>0){
            lastListView.refresh();
        }

    }

    function afterShow(e){
        var visinaSearcha =  $("#searchCustomNavbar").outerHeight(true);
        var visinaPilula =  $("#searchMenu").outerHeight(true);
        var contentHeight = mad.mobileApp.view().content.height();
        var contentWidth = parseInt(mad.mobileApp.view().content.width());

        $("#search-scroller").css({ "height": Math.ceil(contentHeight - visinaSearcha), "width": contentWidth });
        $("#discover-scroller").css({ "height": Math.ceil(contentHeight - visinaSearcha - visinaPilula), "width": contentWidth });
        $("#hot-scroller").css({ "height": Math.ceil(contentHeight - visinaSearcha - visinaPilula), "width": contentWidth });

        var data = {
            "Type": "Near you"
        };
        mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.FB], mad.analyticEvents.categories.PEOPLE, mad.analyticEvents.types.VIEW,
            "People screen loaded",
            data,
            "People screen loaded",
            "Screen loaded");
    }

    function beforeHide(){
        // sakrij kbd kad negdje ides

        if (cordova.plugins && cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.close();
        }
        // automatically close the keyboard on iOS
        document.activeElement.blur();
    }

    function inputChanged(e) {
        if (e.currentTarget.value.length > 0) {
            viewModel.set("inputHasSomething", true);
        }else{
            viewModel.set("inputHasSomething", false);
            viewModel.set("pillsVisible", true);
        }
    }

    function loadDiscovered(){
        mad.models.searchDiscover.online(false);

        var scroller =  $("#" + "discover" + "-scroller");
        var scrollerWidget;
        if (scroller.length){
            scrollerWidget = scroller.data("kendoMobileScroller");
        }
        $(".nearby .ikona").removeClass("animation-started").removeClass("animation-finished");

        mad.models.searchDiscover.read().fail(function(e) {
            console.log("Error discovering users", e.statusText);
            mad.alerts.error("Error discovering users!", "");
        });

        mad.models.searchDiscover.online(true);
        if (scroller.length){
            //scrollerWidget.reset();       // go to top
        }
        mad.models.searchDiscover.read()
            .then(function(e) {
                mad.common.animate();
            })
            .fail(function(e) {
                console.log("Error discovering users", e.statusText);
                mad.alerts.error("Error discovering users!", "");
            });

        mad.googleAnalytics.trackView("Search - Discover");
    }

    function loadTrending(){
        viewModel.set("listviewReady", false);

        mad.models.searchHot.online(false);

        var scroller =  $("#" + "hot" + "-scroller");
        var scrollerWidget;
        if (scroller.length){
            scrollerWidget = scroller.data("kendoMobileScroller");
        }
        mad.models.searchHot.read()
            .then(function(e) {
                mad.models.searchHot.online(true);
                mad.models.searchHot.read()
                    .then(function(e) {
                        viewModel.set("listviewReady", true);
                        mad.common.animate();
                    })
                    .fail(function(e) {
                        console.log("Error discovering users", e.statusText);
                        scrollerWidget.enable();
                        mad.alerts.error("Error discovering users!", "");
                    });

            })
            .fail(function(e) {
                console.log("Error discovering users", e.statusText);
                mad.alerts.error("Error discovering users!", "");
            });

        mad.googleAnalytics.trackView("Search - Trending");
    }

    function initSearchUsersModel() {
        $("#search-scroller").kendoMobileScroller();

        $("#search-list").kendoMobileListView({
            dataSource: mad.models.searchResults,
            autoBind: false,
            pullToRefresh: false,

            template: function(data) {
                var tpl = kendo.template($("#search-template").text(), { useWithBlock: false });
                return tpl(data);
            }
        }).kendoTouch({
            filter: ".gotoUser, .onFollowClick",
            tap: somethingSelected
        });
    }

    function initDiscoverModel() {
        $("#discover-scroller").kendoMobileScroller({
                pullToRefresh: true,
                pullOffset: 100,
                messages: {
                    pullTemplate: $("#refresh-template").html(),
                    releaseTemplate: $("#refresh-template").html(),
                    refreshTemplate: $("#refresh-template").html()
                },
                pull: function(e){
                    var scroller = e.sender;
                    var listview = $("#discover-list").data("kendoMobileListView");
                    listview.dataSource.read()
                        .then(function(){
                            setTimeout(function() {
                                console.log("ide na vrh");
                                scroller.animatedScrollTo(0,0);
                                scroller.pullHandled();
                            }, 999);
                        })
                        .fail(function(e){
                            scroller.animatedScrollTo(0,0);
                            scroller.pullHandled();
                        });
                }
            });
        $("#discover-list").kendoMobileListView({
            dataSource: mad.models.searchDiscover,
            autoBind: false,
            template: function(data) {
                var tpl = kendo.template($("#search-discover-template").text(), { useWithBlock: false });
                return tpl(data);
            }
        }).kendoTouch({
            filter: ".gotoUser, .onFollowClick",
            tap: somethingSelected
        });
    }

    function initHotModel() {
        $("#hot-scroller").kendoMobileScroller({});

        $("#hot-list").kendoMobileListView({
            dataSource: mad.models.searchHot,
            autoBind: false,
            template: function(data) {
                var tpl = kendo.template($("#search-hot-template").text(), { useWithBlock: false });
                return tpl(data);
            }
        }).kendoTouch({
            filter: ".gotoUser, .onFollowClick",
            tap: somethingSelected
        });
    }

    function checkFollowing(user){
        var route = {
            putanja: mad.common.variables.serverUrl + "api/user/GetUserByUserName",
            akcija: "GET"
        };
        var options = {
            username: user
        };
        mad.data.load(route, options, false, true)
            .done(function(data) {
                /*
                if (data.IsCurrentUserFollowingThisOne) {
                    return true;
                }else {
                    return false;
                }
                */
                return data.IsCurrentUserFollowingThisOne;
            })
            .fail(function(e) {
                return false;
            });

    }

    function somethingSelected (e) {

        e.preventDefault();     // da ne probija
        var listview, tabJe;

        if (!arePillsVisible()){
            tabJe = 2;              // ak se ne vide pilule search je
        }else {
            tabJe = $("#searchMenu").data("kendoMobileButtonGroup").current().index();
        }

        if (tabJe == 0) {
            listview = $("#discover-list").data("kendoMobileListView");
        } else if (tabJe == 1) {
            listview = $("#hot-list").data("kendoMobileListView");
        } else if (tabJe == 2) {
            listview = $("#search-list").data("kendoMobileListView");
        }
        //var tappedElement = $(e.touch.currentTarget);          //za klik je $(e.target)
        var tappedElement = e.touch.target;  // drazen - zbog nove verzije kenda

        var li = tappedElement.closest("li");
        var selectedItem = listview.dataSource.getByUid(li.attr("data-uid"));

        viewModel.set("selectedItem", selectedItem);    // for updating from other models
        viewModel.set("selectedListview", listview);

        if (!mad.common.isNullOrEmpty(selectedItem)){
            mad.common.handleFeedTap("search", listview, tappedElement, selectedItem, tabJe);   //parms:origin, listview, tappedElement, selectedItem, tab
        }

    }

    function onSearchClick(e) {
        console.log("search clikced");
        e.preventDefault();
        var searchTerm = $("#searchFollowing").val();
        // automatically close the keyboard on iOS
        document.activeElement.blur();
        viewModel.set("inputHasSomething", false);  //make input field smaller again

        if (searchTerm) {
            mad.models.commonVars.set("searchTerm", searchTerm);

            // get data for data source (actaully gets data from server)
            mad.models.searchResults.read().then(function(e) {
                //pillsVisible postavljen kod čitanja
                mad.common.animate();

            }).fail(function(e) {
                toastr.options.timeOut = 8888;
                toastr.error("No users found", "", toastr.options);
                toastr.options.timeOut = 4444;
            });

            if ($("#search-scroller").data("kendoMobileScroller"))
                $("#search-scroller").data("kendoMobileScroller").reset();

            mad.analyticEvents.track([mad.analyticEvents.services.GA], mad.analyticEvents.categories.PEOPLE, mad.analyticEvents.types.EVENT,
                "People screen - Search performed",
                null,
                "People screen",
                "Search performed");
        } else {
            mad.alerts.error("Search field is empty!", "");
        }
    }

    function hasFocus(e){
        //console.log("input has focus", e.currentTarget.value.length);
        if (e.currentTarget.value.length > 0) {
            viewModel.set("inputHasSomething", true);
        }else{
            viewModel.set("inputHasSomething", false);
        }
    }
    function arePillsVisible(){
        return viewModel.get("pillsVisible");
    }
   
    return {
        viewModel: viewModel,
        checkFollowing: checkFollowing
    };

}());