var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.workoutDetails = (function() {
  "use strict";

  var viewModel = kendo.observable({
    // properties or functions we want to observe and expose to html
    common: mad.common.observables,

    init: initView,
    beforeShow: beforeShow,
    show: showView,
    afterShow: afterShow,
    beforeHide: beforeHide,

    initComments: initComments,
    beforeShowComments: beforeShowComments,
    showComments: showOfComments,
    afterShowComments: afterShowComments,
    beforeHideComments: beforeHideComments,

    ifOnline: checkifOnline,
    ownWorkout: ownWorkout,

    showKantica: false, // prikazuje li se delete?
    showMore: mad.common.showMore,
    showFollowButton: false,

    defaultData: {
      Exercises: [],
      Muscles: [],
      Comments: [],
      CommentsLoaded: false,
      IsAlreadyRespected: false,
      IsCurrentUserOneWhoCreatedWorkout: false,
      ShortPause: 0,
      LongPause: 0,
      IsSaved: false,
      IsWorkoutFromPlan: false,
      Name: "",
      UserImageUrl: "",
      NumberOfCycles: 0,
      NumberOfRespects: 0,
      NumberOfComments: 0,
      Points: 0,
      StrengthPercentage: 0,
      CardioPercentage: 0,
      TotalLengthInSeconds: 0,
      WorkoutLength: "00:00",
      IsCurrentUserFollowingThisOne: true
    },
    getName: getName,
    buttonsDisabled: true,
    wktInfoFormated: wktInfoFormated,
    hasWktInfo: hasWktInfo,

    selectedWorkout: {
      UserImageUrl: "images/icons/comment.svg"
    },
    exericesList: [],
    commentsList: new kendo.data.DataSource({
      data: [],
      change: function(e) {
        var data = this.data();
        //console.log("skomentari change event", data);
      }
    }),

    workoutPhoto: workoutPhoto,

    takenPhoto: "",
    takenPhotoInfo: {},

    addWorkoutDetailsPhoto: addWorkoutDetailsPhoto,
    removeWorkoutDetailsPhoto: removeWorkoutDetailsPhoto,

    wktNameFormated: wktNameFormated,
    wktDetailsFormated: wktDetailsFormated,

    comment: "",
    commentBeforeChange: "",
    typeOfComment: "",

    userComment: "",
    newCommentAdded: false,
    commentDeleted: false,

    nemaSvojKomentar: nemaSvojKomentar,
    showAddComments: showAddComments,
    adjustHeight: adjustHeight,
    editting: false,

    toRespect: respect,
    toSavedWorkouts: saveWorkout,
    isSaved: false,
    noImage: true,

    isAlreadyRespected: false,
    WorkoutId: "",
    isFromPlan: false,
    hasMoreComments: hasMoreComments,
    writingComment: false,
    writingUserComment: false,

    hideSaveButton: hideSaveButton,
    numberOfRespects: 0,
    numberOfRespectsLabel: getRespectsLabel,
    hasRespects: hasRespects,
    workoutId: 0,
    origin: "",
    userNameOrigin: "",
    userIdOrigin: "",
    firstTimeHere: false,
    hideTooltip: hideTooltip,
    tooltip: "Comments",
    openKeyboard: false,
    initialUserEntryFieldHeight: 0,
    initialEntryFieldHeight: 0,

    uCanTouchThis: false,
    uCanTouchThisComments: false,
    followButtonText: "Follow"
  });

  var wdScroller$, wdScroller; //za workout details view
  var scroller$, scroller; //za comments view

  var scrollPomak = 0,
    lastPomak = 0;

  function initView(e) {
    var viewID = "#workoutDetails";
    viewModel.set("uCanTouchThis", false);

    var osjetljivost = 50;
    var lastTop = 0;
    var smjer = "?";

    wdScroller$ = $("#workoutDetails-scroller");
    wdScroller = wdScroller$.data("kendoMobileScroller");

    wdScroller.bind("scroll", function(e) {
      var top = parseInt(e.scrollTop);
      if (top < 0) return;
      if (Math.abs(top - lastTop) > osjetljivost) {
        if (top > osjetljivost) {
          smjer = "gore";
          $(".follow-container").addClass("show");
        } else {
          smjer = "dolje";
          $(".follow-container").removeClass("show");
        }
        lastTop = top;
      }
    });

    $(viewID).kendoTouch({
      filter:
        ".mainContainer, .sveOstalo, .lButton, .editPhotoGumb, .editComment, .wd-comment-value, .wd-comment-OK, .gotoProfile, .toSavedWorkouts, .shareWrap, .toRespect, .confirmDelete, .toInstructions, .moreComments, .moreCommentsKbd, .gotoUser, .follow-gumb",
      touchstart: function(e) {
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          if (wdScroller) {
            if (wdScroller.enabled) {
              wdScroller.disable();
            }
          }
        } else {
          if (wdScroller) {
            if (!wdScroller.enabled) {
              wdScroller.enable();
            }
          }
        }
      },
      tap: function(e) {
        //console.log(e.touch.target, " was tapped");
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
        } else {
          handleTap(e);
        }
      }
    });
    viewModel.set(
      "initialUserEntryFieldHeight",
      $(".wd-comment-value").css("height")
    );

    /* textarea polje je bindano za userComment varijablu i azurira se on 'key up' al nije radio paste
           ovo je nacin (on input) da i paste radi */

    $(".wd-comment-value").on({
      input: function(e) {
        //console.log("set on iput update", $(this).val());
        viewModel.set("comment", $(this).val());
      },
      focus: function(e) {
        adjustHeight(e);
      }
    });

    // prepare mobiscroll options
    $(".shareOptions-wd").mobiscroll({
      theme: $.mobiscroll.defaults.theme,
      mode: "static",
      display: "bottom",
      buttons: [],
      lang: "hr",
      showLabel: false,
      showInput: false,
      wheels: [[{ values: ["share photo", "share link"] }]],
      height: 45,
      rows: 2,
      readonly: false,
      group: false,
      layout: "liquid",
      onShow: function(html, valueText, inst) {
        html.addClass("mobi-shareOptions");
        var winH = $(window).height();
        var dialogEl = html.find("[role='dialog']");
        var dialogElHight = dialogEl.height();
        dialogEl.css({ top: winH - dialogElHight }); // korigiraj top poziciju
      },
      onValueTap: function(item, inst) {
        if (item.context.textContent == "share photo") {
          sharePhoto();
        } else if (item.context.textContent == "share link") {
          shareLink();
        }
        inst.hide(false, "set");
      }
    });
  }

  function handleTap(e) {
    e.preventDefault(); // da ne probija

    var element = e.touch.target;
    var elementNdx = element.attr("data-ndx");

    if ($(element).hasClass("lButton")) {
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        if (mad.common.variables.navigationHistory.length > 0) {
          mad.common.goBack();
        } else {
          mad.mobileApp.navigate("ui/feed/feed.html");
        }
      }
    } else if ($(element).hasClass("editPhotoGumb")) {
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        newPhoto();
      }
    } else if ($(element).hasClass("gotoProfile")) {
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        gotoProfile();
      }
    } else if ($(element).hasClass("editComment")) {
      /* defocus & clear previosu comment */
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        if (viewModel.selectedWorkout.IsCurrentUserOnewWhoCreatedWorkout) {
          //viewModel.set("comment", "");
          editComment();
          focusComment();
        }
      }
    } else if ($(element).hasClass("moreCommentsKbd")) {
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        gotoComments(true);
      }
    } else if ($(element).hasClass("moreComments")) {
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        gotoComments(false);
      }
    } else if ($(element).hasClass("toSavedWorkouts")) {
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        saveWorkout();
      }
    } else if ($(element).hasClass("shareWrap")) {
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        share(element);
      }
    } else if ($(element).hasClass("toRespect")) {
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        respect();
      }
    } else if ($(element).hasClass("confirmDelete")) {
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        confirmDelete();
      }
    } else if ($(element).hasClass("toInstructions")) {
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        openInstructions(element);
      }
    } else if ($(element).hasClass("wd-comment-OK")) {
      if (viewModel.get("comment").trim().length > 0) {
        defocusComment();
        saveComment();
      } else {
        focusComment();
        mad.alerts.error("You must enter a comment");
      }
    } else if ($(element).hasClass("gotoUser")) {
      var selectedItemData = viewModel.get("selectedWorkout.Comments")[
        elementNdx
      ];
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        if (!mad.common.isNullOrEmpty(selectedItemData)) {
          mad.common.handleFeedTap(
            "workoutDetails",
            null,
            element,
            selectedItemData,
            0
          );
        } else {
          gotoProfile();
        }
      }
    } else if ($(element).hasClass("follow-gumb")) {
      if (viewModel.get("writingComment")) {
        defocusComment();
      } else {
        followUser();
      }
    } else {
      // za cijeli kontejner
      if (!$(element).hasClass("wd-comment-value")) {
        defocusComment();
      }
    }
  }

  function beforeShow(e) {
    $("#workoutDetails").removeClass("transBack");
    viewModel.set("uCanTouchThis", false);
  }

  function showView(e) {
    mad.common.pushNotificationSemaphore.lock();

    viewModel.set("firstTimeHere", checkTutorial());
    viewModel.set("showFollowButton", false);
    viewModel.set("followButtonText", "Follow");

    mad.common.setActualView();
    mad.common.addViewToHistory(); //*   ovaj ne ide u nav. history jer je zadnji

    var contentHeight, contentWidth;

    /*
        mad.common.stretchViewContentToBeElastic();
        contentHeight = parseInt(mad.mobileApp.view().content.height());
        contentWidth  = parseInt(mad.mobileApp.view().content.width());
        */
    contentHeight = mad.common.stretchViewContentToBeElasticWOhead();
    contentWidth = $(window).width(); // jquery width

    wdScroller$.css({ height: contentHeight, width: contentWidth });

    // bind viewModel to view
    if (mad.common.$actualViewID == "#workoutDetails") {
      kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    mad.viewModels.editPhoto.viewModel.prepareMobiscroll();

    mad.common.deAnimate();

    //$("#workoutDetails-muscles").show();

    var workoutId;
    var origin = e.view.params.origin;
    viewModel.set("origin", origin);
    //console.log("origin", origin);

    workoutId = e.view.params.WorkoutId;
    if (workoutId) {
      var userName = e.view.params.UserName;
      var userIdOrigin = e.view.params.UserId;
      if (userName) {
        viewModel.set("userNameOrigin", userName);
        viewModel.set("userIdOrigin", userIdOrigin);
      }
      viewModel.set("workoutId", workoutId);
      viewModel.set("isFromPlan", e.view.params.fromPlan == "true"); //kao cast u boolean (mamicu mu)
    } else {
      console.log("nema workoutId");
      return;
    }

    console.log(
      "origin, userName, userIdOrigin, workoutId",
      origin,
      userName,
      userIdOrigin,
      workoutId
    );

    if (
      origin == "feed" ||
      origin == "userHistory" ||
      origin == "otherUserHistory"
    ) {
      wdScroller.reset(); // go to top
    }

    if (origin == "workoutDetailsComments") {
      if (viewModel.get("newCommentAdded") || viewModel.get("commentDeleted")) {
        generateView(origin, workoutId, contentWidth);
      } else {
        mad.common.animate();
      }
    } else {
      generateView(origin, workoutId, contentWidth);
    }

    mad.googleAnalytics.trackView("Workout Details");
  }

  function afterShow(e) {
    viewModel.set("uCanTouchThis", true);

    mad.common.pushNotificationSemaphore.unlock();

    if (viewModel.get("firstTimeHere")) {
      mad.local.appendUsernameTo(
        "visitedWorkoutDetails",
        mad.common.variables.username
      );
    }
  }

  function beforeHide(e) {
    //console.log("before hide - workoutdetails");
    //$("#workoutDetails-muscles").hide();
    $("#workoutDetails").addClass("transBack");
  }

  function generateView(origin, workoutId, contentWidth) {
    // reset data
    viewModel.set("buttonsDisabled", true);
    viewModel.set("selectedWorkout", viewModel.defaultData); //CommentsLoaded also set to false
    viewModel.set("isSaved", false);
    viewModel.set("noImage", true);
    viewModel.set("numberOfRespects", 0);
    viewModel.set("comment", "");
    viewModel.set("writingComment", false);
    viewModel.set("isAlreadyRespected", false);

    generateTabContent(false); // without animation (just placeholders)

    getWorkoutFromServer(workoutId); // load data

    if (origin != "workoutDetailsComments") {
      wdScroller.reset();
    }

    $("#workoutDetails .margin-wrapper").css("width", contentWidth);
  }

  function workoutPhoto() {
    var url = viewModel.get("selectedWorkout.ImageUrl");
    var profilna = viewModel.get("selectedWorkout.UserImageUrl");
    var placeholder = "images/no_photo_workout.jpg";
    //if user has uploaded photo after finishing workout, return it
    if (url) {
      return url;
    } else {
      if (profilna) {
        if (profilna.indexOf("profile-web-retina") > 0) {
          return placeholder;
        } else {
          return profilna;
        }
      } else {
        return "";
      }
    }
  }

  function newPhoto() {
    var profilna = viewModel.get("selectedWorkout.UserImageUrl");
    var inst = $(".actionsheetphotoupload").mobiscroll("getInst");
    if (!profilna || profilna == "images/no_photo_workout.jpg") {
      inst.settings.wheels = [[{ values: ["Camera", "Gallery"] }]];
      inst.settings.rows = 2;
    } else {
      inst.settings.wheels = [[{ values: ["Camera", "Gallery", "Remove"] }]];
      inst.settings.rows = 3;
    }
    setTimeout(function() {
      inst.show(false, false);
    }, 22);
  }

  function getName() {
    if (mad.common.isNullOrEmpty(viewModel.selectedWorkout.get("FirstName"))) {
      return viewModel.selectedWorkout.get("UserName");
    } else {
      return viewModel.selectedWorkout.get("FirstName");
    }
  }

  function addWorkoutDetailsPhoto() {
    mad.common.showBusyLoader("Uploading");

    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/workout/UpdateWorkoutImage?api-version=2.0";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = {
            Id: viewModel.get("workoutId"),
            IsWorkoutFromPlan: viewModel.get("isFromPlan"),
            Width: viewModel.get("takenPhotoInfo.width"),
            Height: viewModel.get("takenPhotoInfo.height"),
            Extension: "jpeg",
            ImageBase64: viewModel.get("takenPhoto")
        };
        */
    var link = {
      putanja:
        mad.common.variables.serverUrl +
        "api/workout/UpdateWorkoutImage?api-version=2.0",
      akcija: "POST"
    };
    var podaci = {
      Id: viewModel.get("workoutId"),
      IsWorkoutFromPlan: viewModel.get("isFromPlan"),
      Width: viewModel.get("takenPhotoInfo.width"),
      Height: viewModel.get("takenPhotoInfo.height"),
      Extension: "jpeg",
      ImageBase64: viewModel.get("takenPhoto")
    };

    mad.data
      .post(link, podaci)
      .done(function(data) {
        mad.common.hideLoader();

        //console.log("upload fotke prosao - vratio", data);
        viewModel.set("selectedWorkout.ImageUrl", viewModel.get("takenPhoto"));
      })
      .fail(function(qXHR, textStatus, errorThrown) {
        mad.common.hideLoader();

        console.log("Error uploading img", textStatus, qXHR);
        mad.alerts.error("photo Upload failed");
      });
  }

  function removeWorkoutDetailsPhoto() {
    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/workout/RemoveImageFromWorkout?api-version=2.0";
        mad.common.variables.forAjax.akcija = "POST";

        mad.common.variables.dataOptions = {
            Id: viewModel.get("workoutId")
        };
        */
    var link = {
      putanja:
        mad.common.variables.serverUrl +
        "api/workout/RemoveImageFromWorkout?api-version=2.0",
      akcija: "POST"
    };
    var podaci = {
      Id: viewModel.get("workoutId")
    };

    mad.data
      .post(link, podaci)
      .done(function(data) {
        //console.log("remove fotke prosao - vratio", data);
        viewModel.set("selectedWorkout.ImageUrl", null);
      })
      .fail(function(qXHR, textStatus, errorThrown) {
        console.log("Error removing img", textStatus, qXHR);
        mad.alerts.error("photo Remove failed");
      });
  }

  function beforeHideComments(e) {
    //console.log("before hide - comments");

    if (mad.common.variables.keyboard.opened) {
      if (cordova.plugins && cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.close();
        $("#workoutDetailsComments-bottom").animate({ bottom: 0 }, 222);
      }
    }
  }

  function checkTutorial() {
    return mad.common.checkTutorial("visitedWorkoutDetails");
  }

  function gotoComments(openKbd) {
    var wktFromPlan = viewModel.get("isFromPlan");
    var workoutId = viewModel.get("workoutId");
    mad.mobileApp.navigate(
      "ui/workoutDetails/workoutDetailsComments.html?origin=workoutDetails&WorkoutId=" +
        workoutId +
        "&fromPlan=" +
        wktFromPlan +
        "&openKbd=" +
        openKbd
    );
  }

  function gotoProfile(e) {
    if (viewModel.get("buttonsDisabled")) {
      if (e) {
        e.preventDefault();
      }
      return;
    }
    var wkt = viewModel.get("selectedWorkout");
    mad.mobileApp.navigate(
      "ui/profileOtherUser/profileOtherUser.html?origin=workoutDetails&UserName=" +
        wkt.UserName +
        "&UserId=" +
        wkt.UserId
    );
  }

  function share(el) {
    var message, subject, image, link;
    message = null;
    subject = null;
    image = null;
    link = null;

    console.log("wd", viewModel.get("selectedWorkout"));
    var userDisplayName = viewModel.get("selectedWorkout.DisplayName");
    var isPlan = viewModel.get("selectedWorkout.IsWorkoutFromPlan");
    link =
      "https://www.madbarz.com/workout/" +
      userDisplayName +
      "/" +
      viewModel.get("selectedWorkout.WorkoutId") +
      "?p=" +
      (isPlan ? "t" : "f");
    link = link.replace(/\s+/g, "-");

    var inst = $(".shareOptions-wd").mobiscroll("getInst");
    if (viewModel.get("noImage")) {
      // ak nema slike sheraj link

      if (!checkSimulator()) {
        window.plugins.socialsharing.share(
          message,
          subject,
          image,
          link,
          onSuccessLink,
          onError
        );
      }
    } else {
      // ak ima sliku

      if (
        viewModel.get("selectedWorkout.UserId") != mad.common.variables.userId
      ) {
        // a tudji je workout - sheraj link

        if (!checkSimulator()) {
          window.plugins.socialsharing.share(
            message,
            subject,
            image,
            link,
            onSuccessLink,
            onError
          );
        }
      } else {
        // pitaj sto hoce sherat
        setTimeout(function() {
          inst.show(false, false);
        }, 22);
      }
    }
  }

  function checkSimulator() {
    if (window.navigator.simulator === true) {
      alert("This plugin is not available in the simulator.");
      return true;
    } else if (
      window.plugins === undefined ||
      window.plugins.socialsharing === undefined
    ) {
      alert(
        "Plugin not found. Maybe you are running in AppBuilder Companion app which currently does not support this plugin."
      );
      return true;
    } else {
      return false;
    }
  }

  function sharePhoto() {
    var message, subject, image, link;
    message = null;
    subject = null;
    link = null;

    /*
        var imageConverted = $.Deferred();

        image = viewModel.get("selectedWorkout.ShareImageUrl");

        if (!checkSimulator()) {
            console.log("call img conversion");
            mad.common.imageToBase64(imageConverted, image);
        }

        imageConverted.then(function(base64Img){
            console.log("img conversion successfull, going to share");
            window.plugins.socialsharing.share(message, subject, base64Img, link, onSuccess, onError);
        }).fail(function(){
            mad.alerts.error("error converting image");
        });
        */

    image = viewModel.get("selectedWorkout.ShareImageUrl");

    if (!checkSimulator()) {
      window.plugins.socialsharing.share(
        message,
        subject,
        image,
        link,
        onSuccessPic,
        onError
      );
    }
  }

  function shareLink() {
    var message, subject, image, link;
    message = null;
    subject = null;
    image = null;

    var userDisplayName = viewModel.get("selectedWorkout.DisplayName");
    var isPlan = viewModel.get("selectedWorkout.IsWorkoutFromPlan");
    link =
      "https://www.madbarz.com/workout/" +
      userDisplayName +
      "/" +
      viewModel.get("selectedWorkout.WorkoutId") +
      "?p=" +
      (isPlan ? "t" : "f");
    link = link.replace(/\s+/g, "-");

    if (!checkSimulator()) {
      window.plugins.socialsharing.share(
        message,
        subject,
        image,
        link,
        onSuccessLink,
        onError
      );
    }
  }

  // callbacks
  function onSuccessLink(msg) {
    console.log("SocialSharing success: " + msg);
    var isCurrentCreator = viewModel.get(
      "selectedWorkout.IsCurrentUserOnewWhoCreatedWorkout"
    );
    sendDataToAnalytics("link", isCurrentCreator);
  }

  function onSuccessPic(msg) {
    console.log("SocialSharing success: " + msg);
    var isCurrentCreator = viewModel.get(
      "selectedWorkout.IsCurrentUserOnewWhoCreatedWorkout"
    );
    sendDataToAnalytics("photo", isCurrentCreator);
  }

  function onError(msg) {
    console.log("SocialSharing error: " + msg);
    mad.alerts.top0("Share problem / " + msg);
  }

  function openInstructions(element) {
    var elementId = element.attr("data-id");
    var exerciseList = mad.viewModels.workoutDetails.viewModel.exericesList.data();
    var selectedExercise;

    for (var i = 0; i < exerciseList.length; i++) {
      if (exerciseList[i].ExerciseId == elementId) {
        selectedExercise = exerciseList[i];
      }
    }
    //potrebno za video
    mad.viewModels.workoutVideo.viewModel.set(
      "selectedExercise",
      selectedExercise
    );
    mad.viewModels.workoutVideo.viewModel.openVideoModal();
  }

  function confirmDelete(e) {
    if (viewModel.get("buttonsDisabled")) {
      e.preventDefault();
      return;
    }

    var msg = mad.glossary.messages.deleteWorkout,
      language = mad.common.observables.languageIndex();

    navigator.notification.confirm(
      msg.message[language],
      function(button) {
        if (button == 1) {
          // if yes
          deleteWorkout();
        }
      },
      msg.title[language],
      [msg.button1[language], msg.button2[language]]
    );
  }

  function deleteWorkout() {
    mad.common.showLoader("Deleting");
    var workout = viewModel.get("selectedWorkout");

    var options = {
      Id: workout.WorkoutId
    };
    var route = {
      putanja: mad.common.variables.serverUrl + "api/Trening/DeleteWorkout",
      akcija: "POST"
    };

    mad.data
      .load(route, options, false, true)
      .done(function(data) {
        if (data) {
          /* update profile view data ( to reflect this delete */
          mad.viewModels.profile.viewModel.set("hasWorkouts", false);
          mad.viewModels.profile.viewModel.set("workoutsText", "");
          var dataForTemplate = mad.viewModels.profile.viewModel.get("user");
          dataForTemplate.NumberOfFeedItems -= 1;
          if (dataForTemplate.NumberOfFeedItems > 0) {
            mad.viewModels.profile.viewModel.set("hasWorkouts", true);
            if (dataForTemplate.NumberOfFeedItems == 1) {
              mad.viewModels.profile.viewModel.set("workoutsText", "1 workout");
            } else {
              mad.viewModels.profile.viewModel.set(
                "workoutsText",
                dataForTemplate.NumberOfFeedItems + " workouts"
              );
            }
          }

          var origin = viewModel.get("origin");
          if (origin == "feed") {
            mad.viewModels.feed.viewModel.removeSelectedItemFromDS();
          } else if (origin == "userHistory") {
            mad.viewModels.userHistory.viewModel.removeSelectedItemFromDS();
          } else if (origin == "otherUserHistory") {
            //mad.viewModels.otherUserHistory.viewModel.removeSelectedItemFromDS();
          }

          mad.common.hideLoader();
          mad.common.goBack();
        } else {
          mad.common.hideLoader();
          mad.alerts.error("There has been an error please try again!", "");
        }
      })
      .fail(function(err) {
        console.log(err);
        mad.common.hideLoader();
        mad.alerts.error("There has been an error please try again!", "");
      });
  }

  function checkifOnline() {
    return this.common.ifOnline();
  }

  function editComment() {
    viewModel.set("editting", true);
    viewModel.set("typeOfComment", "workout");

    var komentar = viewModel.get("selectedWorkout.WorkoutComment");

    viewModel.set("commentBeforeChange", komentar);

    if (komentar.lastIndexOf("Tap", 0) === 0) {
      komentar = "";
    }

    viewModel.set("comment", komentar);
  }

  function saveComment() {
    mad.common.showLoader("updating");

    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/FeedV3/AddWorkoutComment";
        mad.common.variables.forAjax.akcija = "POST";

        var dataToSend = {
            Id: viewModel.get("selectedWorkout.WorkoutId"),
            IsWorkoutFromPlan: viewModel.get("isFromPlan"),
            Comment: viewModel.get("comment")
        };

        mad.common.variables.dataOptions = dataToSend;
        */

    var link = {
      putanja: mad.common.variables.serverUrl + "api/FeedV3/AddWorkoutComment",
      akcija: "POST"
    };
    var podaci = {
      Id: viewModel.get("selectedWorkout.WorkoutId"),
      IsWorkoutFromPlan: viewModel.get("isFromPlan"),
      Comment: viewModel.get("comment")
    };

    mad.data
      .post(link, podaci)
      .done(function(data) {
        mad.common.hideLoader();
        // prepare for update in feed
        mad.viewModels.feed.viewModel.set(
          "selectedItem.WorkoutComment",
          viewModel.get("comment")
        );
        // prepare for update in user history
        mad.viewModels.userHistory.viewModel.set(
          "selectedItem.WorkoutComment",
          viewModel.get("comment")
        );

        viewModel.set(
          "selectedWorkout.WorkoutComment",
          viewModel.get("comment")
        );
        $(".wd-workout-comment").html(viewModel.get("comment")); //update in DOM 'cause of template
        viewModel.set("editting", false);
      })
      .fail(function(qXHR, textStatus, errorThrown) {
        mad.common.hideLoader();
        mad.alerts.error("Error writing comment");
        viewModel.set("editting", false);
      });
  }

  function postComment() {
    var comment = viewModel.get("userComment");

    if (comment) {
      // privremeno dodaj na kraj liste a nakon azuriranja u bazi stavi prave info mjesto privremenih ili obrisi privremenog
      var commentListArray = viewModel.get("commentsList");
      var tmp = {
        Date: "Just now",
        IsPremium: false,
        IsItCommentFromThisUser: false
      };
      tmp.DisplayName = mad.common.variables.displayName;
      tmp.ImageUrl = "images/ff3000-0.png";
      setPRO(tmp);
      tmp.Content = comment;
      commentListArray.add(tmp);
      var poz = commentListArray.data().length - 1;
      var novi = commentListArray.at(poz);
      viewModel.set("commentsList", commentListArray);

      $(".comm-comment-OK").addClass("sending");
      var workout = viewModel.get("selectedWorkout");
      var route = {
        putanja: mad.common.variables.serverUrl + "api/feedV3/PostComment",
        akcija: "Post"
      };
      var options = {
        WorkoutId: workout.WorkoutId,
        IsWorkoutFromPlan: viewModel.get("isFromPlan"),
        Comment: comment
      };
      mad.data
        .load(route, options, false, true)
        .done(function(data) {
          $(".comm-comment-OK").removeClass("sending");
          if (data) {
            var commentListArray = viewModel.get("commentsList");
            commentListArray.remove(novi); // brisi privremeni

            setPRO(data); // postavi IsPremium

            commentListArray.add(data); //dodaj novi
            viewModel.set("commentsList", commentListArray);

            viewModel.set("userComment", ""); // obrisi dodani komentar
            viewModel.set("newCommentAdded", true);
            scrollToBottom();

            /* for feed update */
            mad.viewModels.feed.viewModel.set(
              "selectedItem.NumberOfComments",
              mad.viewModels.feed.viewModel.get(
                "selectedItem.NumberOfComments"
              ) + 1
            );

            mad.googleAnalytics.trackEvent("Social", "Comment", "On Workout");
          }
        })
        .fail(function(data) {
          $(".comm-comment-OK").removeClass("sending");
          console.log("comment sent failed");
          var commentListArray = viewModel.get("commentsList");
          commentListArray.remove(novi); // brisi privremeni
        });
    } else {
      mad.alerts.error("You must enter a comment");
    }
  }

  function setPRO(objekt) {
    var isUserProPromise = $.Deferred();

    isUserProPromise.then(
      function(success) {
        if (success) {
          // ako ima access to pro
          objekt.IsPremium = true;
        } else {
          objekt.IsPremium = false;
        }
      },
      function(fail) {
        console.log("setPRO failed !!");
      }
    );

    //check if user has access to pro or not
    mad.common.hasUserAccessToPro(isUserProPromise);
  }

  function getWorkoutFromServer(workoutId) {
    //console.log("get workout form server ----- -");

    var wktFromPlan = viewModel.get("isFromPlan");
    var route = {
      putanja:
        mad.common.variables.serverUrl +
        "api/workout/GetWorkout?api-version=2.0",
      akcija: "GET"
    };
    var options = {
      id: workoutId,
      isWorkoutFromPlan: wktFromPlan,
      //width: $("#workoutDetailsPhoto").width(),
      width: parseInt(mad.mobileApp.view().content.width()),
      height: 1
    };
    mad.data
      .load(route, options, false, true)
      .done(function(data) {
        //console.log("dohvatio podatke za workout: " + workoutId + ", data je:", data);

        if (mad.common.isNullOrEmpty(data)) {
          mad.alerts.error("No workout info. Please go back.");
          return;
        }

        mad.common.variables.showGender =
          data.UserGender == "Female" ? "f" : "m";

        if (data.UserImageUrl == "") {
          data.UserImageUrl = "images/no_photo_workout.jpg";
        }

        viewModel.set("selectedWorkout", data);

        viewModel.set("selectedWorkout.CommentsLoaded", true);
        setCommentsClass();

        var exercisesDs = new kendo.data.DataSource({
          data: data.Exercises
        });
        exercisesDs.read();

        viewModel.set("exericesList", exercisesDs);
        viewModel.set("isSaved", data.IsSaved);

        viewModel.set("noImage", mad.common.isNullOrEmpty(data.ShareImageUrl));

        viewModel.set("isAlreadyRespected", data.IsAlreadyRespected);
        viewModel.set("numberOfRespects", data.NumberOfRespects);

        if (
          !data.IsCurrentUserFollowingThisOne &&
          !data.IsCurrentUserOnewWhoCreatedWorkout
        ) {
          viewModel.set("showFollowButton", true);
          viewModel.set("followButtonText", "Follow");
        }

        if (data.IsCurrentUserFollowingThisOne) {
          viewModel.set("followButtonText", "Following");
        }

        // add formatted reps
        $.each(viewModel.selectedWorkout.get("Exercises"), function(idx, elem) {
          if (!elem.IsTimed) {
            elem.formatedReps = elem.Reps + " " + elem.Unit;
          } else {
            elem.formatedReps = mad.common.formatTimeForDisplayingTimedExercises(
              elem.Reps
            );
          }
        });

        if (data.IsCurrentUserOnewWhoCreatedWorkout) {
          if (wktFromPlan) {
            viewModel.set("showKantica", false);
          } else {
            viewModel.set("showKantica", true);
          }
        } else {
          viewModel.set("showKantica", false);
        }
        generateTabContent(true);
      })
      .fail(function(qXHR, textStatus, errorThrown) {
        mad.alerts.error("Error loading workout");
        generateTabContent(true);
      });
  }

  function getComments(workoutId) {
    var wktFromPlan = viewModel.get("isFromPlan");

    $("#workoutDetails-list").css("padding", 0);

    var route = {
      putanja:
        mad.common.variables.serverUrl + "api/feedv3/GetCommentsOnWorkout",
      akcija: "GET"
    };
    var options = {
      id: workoutId,
      IsWorkoutFromPlan: wktFromPlan
    };
    mad.data
      .load(route, options, false, true)
      .done(function(data) {
        viewModel.commentsList.data(data);

        if (mad.common.$actualViewID == "#workoutDetailsComments") {
          kendo.bind($(mad.common.$actualViewID), viewModel);
        }

        scrollToBottom();
      })
      .fail(function(qXHR, textStatus, errorThrown) {
        console.log("comments load error", errorThrown);
        mad.alerts.error("Error loading comments");
      });
  }

  function setCommentsClass() {
    var komentari = viewModel.selectedWorkout.get("Comments");
    if (komentari) {
      var brojKomentara = komentari.length;
      if (brojKomentara == 0) {
        $(mad.common.$actualViewID + " .rButton")
          .addClass("noComments")
          .removeClass("hasComments")
          .removeClass("loadingComments");
      } else {
        $(mad.common.$actualViewID + " .rButton")
          .addClass("hasComments")
          .removeClass("noComments")
          .removeClass("loadingComments");
      }
    }
  }

  function generateTabContent(animate) {
    if (animate) mad.common.deAnimate();

    showExercises();
    // zbog save botuna (jer skace)
    if (mad.common.$actualViewID == "#workoutDetails") {
      kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    showMuscles();

    viewModel.set("buttonsDisabled", false);
    if (mad.common.$actualViewID == "#workoutDetails") {
      kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    if (animate) mad.common.animate();
  }

  function respect(e) {
    if (viewModel.get("buttonsDisabled")) {
      e.preventDefault();
      return;
    }

    var selectedWorkout = viewModel.get("selectedWorkout");
    //console.log("selectedWorkout prije respect", selectedWorkout);

    var options = {
      workoutId: selectedWorkout.WorkoutId,
      IsWorkoutFromPlan: viewModel.get("isFromPlan")
    };

    if (selectedWorkout.IsAlreadyRespected) {
      // handle unsrespect

      setUnrespectValues();

      var route = {
        putanja: mad.common.variables.serverUrl + "api/FeedV3/PostUnRespect",
        akcija: "POST"
      };
      mad.data
        .load(route, options, false, true)
        .done(function(data) {
          if (data.Result) {
            setInOtherModels(false); // no respect
          }
        })
        .fail(function(data) {
          console.log("respect error - fail");
          setRespectValues();
        });
    } else {
      /* handle resepct*/

      setRespectValues();

      var route = {
        putanja: mad.common.variables.serverUrl + "api/FeedV3/PostRespect",
        akcija: "POST"
      };
      mad.data
        .load(route, options, false, true)
        .done(function(data) {
          if (data.Result) {
            setInOtherModels(true);
            mad.googleAnalytics.trackEvent(
              "Social",
              "Respect",
              "Workout Screen"
            );
          }
        })
        .fail(function(data) {
          console.log("respect error - fail");
          setUnrespectValues();
        });
    }
  }

  function setUnrespectValues() {
    var selectedWorkout = viewModel.get("selectedWorkout");
    selectedWorkout.IsAlreadyRespected = false;
    selectedWorkout.NumberOfRespects--;
    viewModel.set("selectedWorkout", selectedWorkout);
    viewModel.set("isAlreadyRespected", false);
    viewModel.set("numberOfRespects", selectedWorkout.NumberOfRespects);
  }

  function setRespectValues() {
    var selectedWorkout = viewModel.get("selectedWorkout");
    selectedWorkout.IsAlreadyRespected = true;
    selectedWorkout.NumberOfRespects++;
    viewModel.set("selectedWorkout", selectedWorkout);
    viewModel.set("isAlreadyRespected", true);
    viewModel.set("numberOfRespects", selectedWorkout.NumberOfRespects);
  }

  function setInOtherModels(respect) {
    var origin = viewModel.get("origin");
    var selectedWorkout = viewModel.get("selectedWorkout");

    if (origin == "feed") {
      /* for feed update */
      mad.viewModels.feed.viewModel.set("selectedItem.HasRespected", respect);
      mad.viewModels.feed.viewModel.set(
        "selectedItem.NumberOfRespects",
        selectedWorkout.NumberOfRespects
      );
    } else if (origin == "otherUserHistory") {
      mad.viewModels.otherUserHistory.viewModel.set(
        "selectedItem.HasRespected",
        respect
      );
      mad.viewModels.otherUserHistory.viewModel.set(
        "selectedItem.NumberOfRespects",
        selectedWorkout.NumberOfRespects
      );
    } else if (origin == "userHistory") {
      mad.viewModels.userHistory.viewModel.set(
        "selectedItem.HasRespected",
        respect
      );
      mad.viewModels.userHistory.viewModel.set(
        "selectedItem.NumberOfRespects",
        selectedWorkout.NumberOfRespects
      );
      mad.viewModels.profile.viewModel.set("reload", true);
    }
  }

  function hasRespects() {
    var respects;
    if (viewModel.get("numberOfRespects") > 0) {
      respects = true;
    } else {
      respects = false;
    }
    return respects;
  }

  function getRespectsLabel() {
    var label;
    if (viewModel.get("numberOfRespects") == 1) {
      label =
        mad.glossary.ui.workoutDetails.labels.respect[
          mad.common.observables.languageIndex()
        ];
    } else {
      label =
        mad.glossary.ui.workoutDetails.labels.respects[
          mad.common.observables.languageIndex()
        ];
    }
    return label;
  }

  var saveWorkoutFeedOnServer = function(hasPro, options) {
    /* handle save*/

    viewModel.set("isSaved", true);
    viewModel.set("selectedWorkout.IsSaved", true);

    var route = {
      putanja: mad.common.variables.serverUrl + "api/Saved/SaveWorkoutFromFeed",
      akcija: "POST"
    };

    mad.data
      .load(route, options, false, true)
      .done(function(data) {
        if (data.Result !== "00000000-0000-0000-0000-000000000000") {
          mad.googleAnalytics.trackEvent(
            "Social",
            "Saved workout by other user"
          );
          mad.facebookAnalytics.trackEvent(
            "Workout Saved",
            { Origin: "Other user's workout" },
            0
          );

          mad.local.removeVariable("savedWorkouts"); // clear cache
          mad.viewModels.madbarzSavedWorkoutS.readSavedWorkouts(); // read saved and put in cache
        } else {
          viewModel.set("isSaved", false);
          viewModel.set("selectedWorkout.IsSaved", false);

          if (data.Message == "max") {
            mad.viewModels.popups.viewModel.openModalWindow(
              "buySavedPRO",
              "You reached your limit of 5",
              "Premium account lets you save unlimited workouts and much more",
              "Get unlimited space!"
            );
          } else {
            mad.alerts.error(
              "Workout was not saved.</br>You have reached your maximum</br>number of saved workouts."
            );
          }
        }
      })
      .fail(function(e, r, t) {
        viewModel.set("isSaved", false);
        viewModel.set("selectedWorkout.IsSaved", false);

        mad.alerts.error(
          "There were some troubles saving workout. Please contact support."
        );
      });
  };

  function saveWorkout(e) {
    if (viewModel.get("buttonsDisabled")) {
      e.preventDefault();
      return;
    }

    var selectedWorkout = viewModel.get("selectedWorkout");

    var options = {
      WorkoutId: selectedWorkout.WorkoutId
    };

    if (selectedWorkout.IsSaved) {
      /* handle unsave*/
      viewModel.set("isSaved", false);
      viewModel.set("selectedWorkout.IsSaved", false);

      var route = {
        putanja:
          mad.common.variables.serverUrl + "api/Saved/FeedDeleteSavedWorkout",
        akcija: "POST"
      };
      mad.data
        .load(route, options, false, true)
        .done(function(data) {
          if (data) {
            mad.local.removeVariable("savedWorkouts"); // clear cache
            mad.viewModels.madbarzSavedWorkoutS.readSavedWorkouts(); // read saved and put in cache
          }
        })
        .fail(function(e, r, t) {
          viewModel.set("isSaved", true);
          viewModel.set("selectedWorkout.IsSaved", true);
          mad.alerts.error("Error while unsaving workout.");
        });
    } else {
      //this is updated code for saving workouts from feed depending whether user has pro or not
      var isUserProPromise = $.Deferred();
      var hasUserPRo = false;

      isUserProPromise.then(
        function(hasAccessToPro) {
          if (typeof hasAccessToPro === "boolean") {
            hasUserPRo = hasAccessToPro;
          }
          options = {
            WorkoutId: selectedWorkout.WorkoutId,
            HasUserAccessToPro: hasUserPRo
          };
          saveWorkoutFeedOnServer(hasUserPRo, options);
        },
        function(fail) {
          console.log("hasUserAccessToPro failed !!");
          options = {
            WorkoutId: selectedWorkout.WorkoutId,
            HasUserAccessToPro: hasUserPRo
          };
          saveWorkoutFeedOnServer(hasUserPRo, options);
        }
      );

      //check if user has access to pro or not
      mad.common.hasUserAccessToPro(isUserProPromise);
    }
  }

  function showExercises() {
    var template, result;

    template = kendo.template($("#workoutDetails-list-template").html(), {
      useWithBlock: false
    });
    result = template(viewModel.get("selectedWorkout")); //Pass the data to the compiled template
    $("#workoutDetails-list").html(result);

    template = kendo.template($("#workoutDetails-comments-template").html(), {
      useWithBlock: false
    });
    result = template(viewModel.get("selectedWorkout")); //Pass the data to the compiled template
    $(".workout-comment-list").html(result);

    template = kendo.template($("#workoutDetails-bottom-template").html(), {
      useWithBlock: false
    });
    result = template({});
    $(".workout-exer-bottom").html(result);

    $("#workoutDetails-list").css("padding", "");
  }

  function showMuscles() {
    // generate muscle man & percentages  -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
    var musclesTemplate = kendo.template(
      $("#workoutDetails-muscles-template").html()
    );
    var musclesHTML = musclesTemplate(mad.viewModels.workoutDetails.viewModel);
    $("#workoutDetails-muscles").html(musclesHTML);

    var contentHeight = parseInt(mad.mobileApp.view().content.height());
    var reduce = 25 / 100; //percentage
    var muscleManContainerHeight = contentHeight - contentHeight * reduce;
    var contentWidth = parseInt(mad.mobileApp.view().content.width());

    //$("#workoutDetails-muscles .muscles-container").css("height", muscleManContainerHeight);

    // generate muscle imgs
    musclesTemplate = kendo.template($("#MuscleMapTemplate").html(), {
      useWithBlock: false
    });
    musclesHTML = musclesTemplate(
      mad.viewModels.workoutDetails.viewModel.selectedWorkout.Muscles
    );
    $("#workoutDetails-muscles-imgs").html(musclesHTML);

    mad.common.scaleMuscleMan2(muscleManContainerHeight, contentWidth, 10);
  }

  function followUser() {
    onFollowClick();
  }

  function wktNameFormated() {
    var name = mad.viewModels.workoutDetails.viewModel.get(
      "selectedWorkout.Name"
    );
    return name;
  }
  function wktInfoFormated() {
    var name =
      mad.viewModels.workoutDetails.viewModel.get("selectedWorkout.Info") || "";
    return name;

    /* parsanje iz feeda (nema koristi ako se dolazi s notifikacija
        var name = mad.viewModels.feed.viewModel.get("selectedItem.FormattedWorkoutContext");
        if (name == "" || name === undefined){
            return ""
        }
        var nameSplitani = name.split(" - ");
        return nameSplitani[2] + " in " + nameSplitani[1];
         */
  }

  function hasWktInfo() {
    //var name = mad.viewModels.feed.viewModel.get("selectedItem.FormattedWorkoutContext");
    var name = mad.viewModels.workoutDetails.viewModel.get(
      "selectedWorkout.Info"
    );
    return name != "";
  }

  function wktDetailsFormated() {
    var rounds = viewModel.selectedWorkout.get("NumberOfCycles"),
      roundsFormatted = "",
      time = viewModel.selectedWorkout.get("WorkoutLength"),
      points = viewModel.selectedWorkout.get("Points");

    if (time == "00:00" && points == 0) {
      return "";
    }

    if (rounds == 0) {
      roundsFormatted = "";
    } else if (rounds == 1) {
      roundsFormatted = "1 round, ";
    } else {
      roundsFormatted = rounds + " rounds, ";
    }

    return roundsFormatted + time + ", " + points + " pts";
  }

  function hideTooltip(e) {
    viewModel.set("firstTimeHere", false);
  }

  function ownWorkout() {
    var response =
      viewModel.selectedWorkout.get("UserName") == mad.common.variables.username
        ? true
        : false;
    return response;
  }

  // - - - - - - - - - - - - - - - for comments view - - - - - - - - -
  function initComments(e) {
    var viewID = "#workoutDetailsComments";
    viewModel.set("uCanTouchThisComments", false);

    scroller$ = $("#workoutDetailsComments-scroller");
    scroller = scroller$.data("kendoMobileScroller");

    $(viewID).kendoTouch({
      filter:
        ".mainContainer, .lButton, .comm-comment-value, .comm-comment-OK, .gotoUser, .delete",
      touchstart: function(e) {
        if (!viewModel.get("uCanTouchThisComments")) {
          e.sender.cancel();
          if (scroller) {
            if (scroller.enabled) {
              scroller.disable();
            }
          }
        } else {
          if (scroller) {
            if (!scroller.enabled) {
              scroller.enable();
            }
          }
        }
      },
      tap: function(e) {
        if (!viewModel.get("uCanTouchThisComments")) {
          e.sender.cancel();
        } else {
          handleTapComments(e);
        }
      }
    });

    $("#workoutDetailsComments-list").kendoMobileListView({
      dataSource: mad.viewModels.workoutDetails.viewModel.commentsList,
      template: function(data) {
        var tpl = kendo.template(
          $("#workoutDetailsComment-list-template").text(),
          { useWithBlock: false }
        );
        return tpl(data);
      },
      endlessScroll: false
    });

    viewModel.set(
      "initialEntryFieldHeight",
      $(".comm-comment-value").css("height")
    );

    /* textarea polje je bindano za userComment varijablu i azurira se on 'key up' al nije radio paste
           ovo je nacin (on input) da i paste radi */

    $(".comm-comment-value").on({
      input: function(e) {
        //console.log("set on iput update", $(this).val());
        viewModel.set("userComment", $(this).val());
      },
      focus: function(e) {
        adjustHeight(e);
      }
    });
  }

  function handleTapComments(e) {
    e.preventDefault(); // da ne probija

    var element = e.touch.target;

    if ($(element).hasClass("lButton")) {
      if (viewModel.get("writingUserComment")) {
        defocusUserComment();
      } else {
        mad.common.goBack();
      }
    } else if ($(element).hasClass("comm-comment-value")) {
      focusUserComment();
    } else if ($(element).hasClass("comm-comment-OK")) {
      if (viewModel.get("userComment").trim().length > 0) {
        postComment(); // mora bit ispred jer se u defocusUserComment brise input polje
        defocusUserComment();
      } else {
        focusUserComment();
        mad.alerts.error("You must enter a comment");
      }
    } else if (
      $(element).hasClass("gotoUser") ||
      $(element).hasClass("delete")
    ) {
      if (viewModel.get("writingUserComment")) {
        defocusUserComment();
      } else {
        itemTapped(element);
      }
    } else {
      if (!$(element).hasClass("comm-comment-value")) {
        defocusUserComment();
      }
    }
  }

  function itemTapped(element) {
    var listview = $("#workoutDetailsComments-list").data(
      "kendoMobileListView"
    );
    var li = element.closest("li");
    var selectedItemData = listview.dataSource.getByUid(li.attr("data-uid"));

    if (!mad.common.isNullOrEmpty(selectedItemData)) {
      if (element.hasClass("gotoUser")) {
        mad.common.handleFeedTap(
          "workoutDetails",
          listview,
          element,
          selectedItemData,
          0
        );
      } else if (element.hasClass("delete")) {
        var msg = {
          title: "Delete comment?",
          message: "",
          button1: "Yes",
          button2: "No"
        };

        navigator.notification.confirm(
          msg.message,
          function(button) {
            if (button == 1) {
              // if yes
              doDelete(listview.dataSource, selectedItemData);
            }
          },
          msg.title,
          [msg.button1, msg.button2]
        );
      }
    }
  }

  function doDelete(ds, item) {
    var options = {
      WorkoutId: item.Id,
      IsWorkoutFromPlan: viewModel.get("isFromPlan")
    };

    var route = {
      putanja: mad.common.variables.serverUrl + "/api/FeedV3/PostDeleteComment",
      // putanja: 'https://test-madbarz-api.azurewebsites.net/api/FeedV3/PostDeleteComment',
      akcija: "POST"
    };

    mad.common.showLoader("deleting");
    mad.data
      .load(route, options, false, true)
      .done(function(data) {
        mad.common.hideLoader();
        if (data.Result) {
          ds.remove(item);

          var visinaSadrzajaUscrolleru, stvarnaVisinaScrollera;
          visinaSadrzajaUscrolleru = scroller.scrollHeight();
          stvarnaVisinaScrollera = scroller.height();
          // drazen - kad vise nema potrebe za scrollom pozicionraj na vrh
          if (visinaSadrzajaUscrolleru < stvarnaVisinaScrollera) {
            scroller.animatedScrollTo(0, 0);
          }
          /* for feed update */
          viewModel.set("commentDeleted", true);
          mad.viewModels.feed.viewModel.set(
            "selectedItem.NumberOfComments",
            mad.viewModels.feed.viewModel.get("selectedItem.NumberOfComments") -
              1
          );
        } else {
          mad.alerts.error(data.Message, "");
        }
      })
      .fail(function(e, r, t) {
        mad.common.hideLoader();
        console.log("brisanje - greška");
        mad.alerts.error("Sorry! Error deleting comment", "");
      });
  }

  function onFollowClick() {
    var currentUserNoOfFollowing = parseInt(
      mad.common.variables.userNoFollowing
    );
    var isFollowing = viewModel.get(
      "selectedWorkout.IsCurrentUserFollowingThisOne"
    );
    var route;
    //if is following then unfollow,
    if (isFollowing) {
      route = {
        putanja: mad.common.variables.serverUrl + "api/follow/UnFollow",
        akcija: "POST"
      };

      currentUserNoOfFollowing--;
      viewModel.set("followButtonText", "Follow");
    } else {
      route = {
        putanja: mad.common.variables.serverUrl + "api/follow/Follow",
        akcija: "POST"
      };

      currentUserNoOfFollowing++;
      viewModel.set("followButtonText", "Following");

      var analyticsData = {
        Source: "Workout Details"
      };
      mad.analyticEvents.track(
        [mad.analyticEvents.services.GA],
        mad.analyticEvents.categories.SOCIAL,
        mad.analyticEvents.types.EVENT,
        "Follow clicked",
        analyticsData,
        "Social",
        "Follow",
        "From Workout Details"
      );
    }

    mad.common.variables.userNoFollowing = currentUserNoOfFollowing;

    isFollowing = !isFollowing;

    viewModel.set("selectedWorkout.IsCurrentUserFollowingThisOne", isFollowing);

    var options = {
      Id: viewModel.get("selectedWorkout.UserId")
    };

    mad.data.load(route, options, false, true).done(function(data) {
      if (data.Result) {
        var promise = $.Deferred();

        mad.common.getUserInfo(promise, false); //to update global NumberOfFeedItemsInFeedFollowing
        //viewModel.set("showFollowButton", false);
      } else {
        console.log("greska kod updata following", data.Message);

        if (isFollowing) {
          currentUserNoOfFollowing++;
          viewModel.set("followButtonText", "Following");
        } else {
          currentUserNoOfFollowing--;
          viewModel.set("followButtonText", "Follow");
        }

        mad.common.variables.userNoFollowing = currentUserNoOfFollowing;

        isFollowing = !isFollowing;

        viewModel.set(
          "selectedWorkout.IsCurrentUserFollowingThisOne",
          isFollowing
        );
      }
    });
  }

  function hideSaveButton() {
    var isFromPlan = viewModel.get("isFromPlan");
    var isProRoutine = viewModel.get("selectedWorkout.IsProWorkout");

    return isFromPlan || isProRoutine;
  }

  function beforeShowComments(e) {
    $("#workoutDetails").removeClass("transBack");
    viewModel.set("uCanTouchThisComments", false);
  }

  function showOfComments(e) {
    //console.log("show - comments");

    mad.common.setActualView();
    mad.common.addViewToHistory(); //*   ovaj ne ide u nav. history jer je zadnji
    mad.common.stretchViewContentToBeElastic();

    var workoutId = e.view.params.WorkoutId;
    var origin = e.view.params.origin;
    var isFromPlan = e.view.params.fromPlan == "true";
    var openKeyboard = e.view.params.openKbd == "true";

    viewModel.set("isFromPlan", isFromPlan);
    viewModel.set("openKeyboard", openKeyboard);
    viewModel.set("editting", false);
    viewModel.set("firstTimeHere", false);
    viewModel.set("writingUserComment", false);

    scrollPomak = 0;
    lastPomak = 0;

    $("#workoutDetailsComments-scroller").css("margin-top", 0);

    var contentHeight, contentWidth, visinaFootera, visina;

    contentHeight = parseInt(mad.mobileApp.view().content.height());
    contentWidth = parseInt(mad.mobileApp.view().content.width());
    visinaFootera = $(".comm-entryField-comment").height();
    visina = contentHeight - visinaFootera;

    if (origin == "workoutDetails") {
      // postavi indikator: jeli bilo komentara ili brisanja
      viewModel.set("newCommentAdded", false);
      viewModel.set("commentDeleted", false);

      // resetiraj prethodne visine i postavi visinu scrollera na max mogucu
      $("#workoutDetailsComments-list").css({ height: "" });
      $("#workoutDetailsComments-scroller").css({ height: "" });
      scroller$.css({ height: visina, width: contentWidth });

      if (viewModel.selectedWorkout.get("NumberOfComments") > 3) {
        getComments(workoutId);
      } else {
        viewModel.commentsList.data(viewModel.selectedWorkout.get("Comments"));
        scrollToBottom();
      }
      // postavi visinu liste malo vecu od visine scrollera da bude elastic
      $("#workoutDetailsComments-list").css({ height: visina + 2 });
    }

    mad.googleAnalytics.trackView("Workout Details - comments");
  }

  function afterShowComments() {
    //console.log("after show - comments");
    viewModel.set("uCanTouchThisComments", true);

    if (viewModel.get("openKeyboard")) {
      focusUserComment();
    }
    viewModel.set("userComment", "");
  }

  function hasMoreComments() {
    return viewModel.get("selectedWorkout.NumberOfComments") > 3;
  }

  function nemaSvojKomentar() {
    var komentar = viewModel.get("selectedWorkout.WorkoutComment");
    if (komentar) {
      if (komentar.lastIndexOf("Tap", 0) === 0 || komentar == "") {
        return true;
      } else {
        return false;
      }
    } else {
      return true;
    }
  }

  function showAddComments() {
    var komentar = viewModel.get("selectedWorkout.WorkoutComment");
    var vlastitiWorkout = viewModel.get(
      "selectedWorkout.IsCurrentUserOnewWhoCreatedWorkout"
    );
    var brojKomentara = viewModel.get("selectedWorkout.NumberOfComments")
      .length;

    if (mad.common.isNullOrEmpty(komentar)) {
      return false;
    }

    if (nemaSvojKomentar()) {
      return false;
    } else {
      if (vlastitiWorkout && !hasMoreComments()) {
        return false;
      } else {
        return true;
      }
    }
  }

  function focusComment() {
    $(".wd-entryField-comment").removeClass("hidden");
    $(".wd-comment-value").focus();
    $("#workoutDetailsContainer .zamraci").addClass("defocus");
    viewModel.set("writingComment", true);
  }
  function defocusComment() {
    $(".wd-comment-value").blur();
    $(".wd-entryField-comment").addClass("hidden");
    $("#workoutDetailsContainer .zamraci").removeClass("defocus");
    $(".wd-comment-value").css(
      "height",
      viewModel.get("initialUserEntryFieldHeight")
    );
    $("#workoutDetails-scroller").css("margin-top", 0);
    viewModel.set("writingComment", false);
  }

  function focusUserComment() {
    $(".comm-comment-value").focus();
    viewModel.set("writingUserComment", true);
    lastPomak = 0;
  }
  function defocusUserComment() {
    $(".comm-comment-value").blur();
    $(".comm-comment-value").css(
      "height",
      viewModel.get("initialEntryFieldHeight")
    );
    $("#workoutDetailsComments-scroller").css("margin-top", 0);

    viewModel.set("writingUserComment", false);
  }

  function scrollToBottom() {
    var visinaSadrzajaUscrolleru = scroller.scrollHeight();
    var stvarnaVisinaScrollera = scroller.height();

    if (visinaSadrzajaUscrolleru < stvarnaVisinaScrollera) {
      scroller.animatedScrollTo(0, 0);
    } else {
      scroller.animatedScrollTo(
        0,
        stvarnaVisinaScrollera - visinaSadrzajaUscrolleru
      );
    }
  }

  function adjustHeight(o) {
    //console.log("adjustHeight");

    var visinaSadrzajaUscrolleru, stvarnaVisinaScrollera, scrollObj;
    var thatScroller, translateY, preostaloProstora;
    var minHeight = 3;
    var visinaPolja = 44;
    var object = o.currentTarget;
    object.style.height = "1px";

    // kalkuliranje i postavlanje nove visine textarea polja
    var visinaSadrzaja = minHeight + object.scrollHeight;
    object.style.height = visinaSadrzaja + "px";

    // pomicanje scrollera samo za komentare
    if (
      visinaSadrzaja > visinaPolja &&
      mad.common.actualViewID == "workoutDetailsComments"
    ) {
      scrollPomak = (visinaSadrzaja - visinaPolja) * -1;
      if (scrollPomak != lastPomak) {
        //samo ako je otislo u novi red

        lastPomak = scrollPomak;

        visinaSadrzajaUscrolleru =
          mad.common.actualViewID == "workoutDetailsComments"
            ? scroller.scrollHeight()
            : wdScroller.scrollHeight();
        stvarnaVisinaScrollera =
          mad.common.actualViewID == "workoutDetailsComments"
            ? scroller.height()
            : wdScroller.height();
        scrollObj =
          mad.common.actualViewID == "workoutDetailsComments"
            ? $("#workoutDetailsComments-scroller")
            : $("#workoutDetails-scroller");

        thatScroller = scrollObj.find(".km-scroll-container");
        translateY = getTranslateY(thatScroller);

        //potrebno je uzeti u obzir i vrijednost translateY za scroller koju kendo sam izracuna
        preostaloProstora =
          stvarnaVisinaScrollera -
          visinaSadrzajaUscrolleru +
          scrollPomak -
          translateY;

        if (preostaloProstora < 0) {
          // vise sve skupa nestane pa pomakni scroller gore
          scrollObj.css("margin-top", preostaloProstora);
        } else {
          scrollObj.css("margin-top", 0);
        }
      }
    }
  }

  function getValues(obj) {
    var x, y;
    var matrix = obj
      .css("transform")
      .replace(/[^0-9\-.,]/g, "")
      .split(",");
    if (matrix === undefined || matrix[0] == "") {
      x = 0;
      y = 0;
    } else {
      x = matrix[12] || matrix[4];
      y = matrix[13] || matrix[5];
    }
    //console.log("translateY", y);
  }
  function getTranslateY(obj) {
    var y;
    var matrix = obj
      .css("transform")
      .replace(/[^0-9\-.,]/g, "")
      .split(",");
    if (matrix === undefined || matrix[0] == "") {
      y = 0;
    } else {
      y = matrix[13] || matrix[5];
    }
    //console.log("translateY", y);
    return parseInt(y);
  }
  function sendDataToAnalytics(type, isCurrentUserOneWhoFinished) {
    var isPlan = viewModel.get("selectedWorkout.IsWorkoutFromPlan");

    var data = {
      Source: "Feed (W.Details)",
      Type: type, // link or picture,
      "Current user w.": isCurrentUserOneWhoFinished
        ? "Current user"
        : "Other user",
      "Workout type": isPlan ? "From Plan" : "Single"
    };

    mad.analyticEvents.track(
      [mad.analyticEvents.services.MIXP],
      mad.analyticEvents.categories.MAX,
      mad.analyticEvents.types.EVENT,
      "Share workout",
      data,
      "Share workout",
      "",
      "Click on share"
    );
  }

  return {
    viewModel: viewModel,
    defocusComment: defocusComment
  };
})();
