var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.createWorkoutDone = (function () {

    "use strict";

    var viewModel = kendo.observable( {
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,
        model: window.createWorkout.model,

        show: showView,

        leftButtonAction: leftButtonAction,
        rightButtonAction: tapDone,
        footerEnabled: true,
        footerBtnPressed: tapStart,

        saveWorkoutToFavourites: saveWorkoutToFavourites,

        isSaved: isSaved,

        favouritesIcon: favouritesIcon,
        canSaveWorkouts: true
    });

    viewModel.bind("change", function(e) {
        //console.log("promjenjeno polje", e.field);
        if (e.field == "model.isSaved"){
            //console.log("promjenjen je isSaved u ", viewModel.model.get("isSaved"));
            var desniGumb = $(".createWorkoutDone .km-view-title .rButtonContainer .rButton span")
            if (viewModel.model.get("isSaved")){
                desniGumb.html("done");
            }else{
                desniGumb.html("cancel");
            }
        }
    });

    function showView(e){
        //console.log("show done ----- -");
        mad.common.setActualView(); mad.common.addViewToHistory(); setupView();
        kendo.bind($(mad.common.$actualViewID), viewModel);
        mad.googleAnalytics.trackView("Create Workout - Finish");
    }

    function leftButtonAction(){
        mad.common.goBack();
    }

    function tapDone() {
        var done = mad.viewModels.createWorkoutDone.viewModel;

        if (!done.model.needsSaving()) {
            done.model.clearCreateWorkout();
            mad.viewModels.createWorkoutName.viewModel.exercisesShowed = false;

            var data = {
                "Was MuscleMan used": false,
                "Was Search for all exercises used": true
            };

            mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.FB], mad.analyticEvents.categories.MAX, mad.analyticEvents.types.EVENT,
                "Create Workout Overall",
                data,
                "Create Workout",
               "Saved Created Workout Before Start");
            mad.appsFlyer.trackEvent("Create Workout Overall", data);
            
            mad.mobileApp.navigate("ui/workouts/menu.html?origin=createWorkout");
        } else {
            var msg = mad.glossary.messages.exitWOsave,
                language = mad.common.observables.languageIndex();
            navigator.notification.confirm(
                msg.message[language],
                function (button) {
                    if (button === 1) {              // if yes
                        var doneN = mad.viewModels.createWorkoutDone.viewModel;
                        doneN.model.clearCreateWorkout();
                        mad.viewModels.createWorkoutName.viewModel.exercisesShowed = false;
                        //mad.mobileApp.navigate("ui/workouts/saved/madbarzSavedWorkoutsList.html?origin=createWorkout");
                        mad.mobileApp.navigate("ui/workouts/menu.html?origin=createWorkout");
                    }
                },
                msg.title[language], [msg.button1[language], msg.button2[language]]);
        }
    }

    function tapStart(){
        var done = mad.viewModels.createWorkoutDone.viewModel;

        var data = {
            "Was MuscleMan used": false,
            "Was Search for all exercises used": true
        };


        mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.FB], mad.analyticEvents.categories.MAX, mad.analyticEvents.types.EVENT,
            "Create Workout Overall",
            data,
            "Create Workout",
            "Started Workout Right After Create Process");

            mad.appsFlyer.trackEvent("Create Workout Overall", data);


        if (!done.model.needsSaving()) {
            mad.viewModels.createWorkoutName.viewModel.exercisesShowed = false;

            mad.common.showLoader();
            var deferred = jQuery.Deferred();
            deferred.then(function (sucess) {
                mad.common.hideLoader();
                done.model.startWorkout(sucess);
                if (viewModel.common.ifOnline()){
                    mad.googleAnalytics.trackEvent("Create Workout", "Saved Created Workout Before Start");
                }
            }, function (fail) {
                mad.common.hideLoader();
            });
            done.model.getModelForStartAlreadySaved(deferred);
        } else {

            var msg = mad.glossary.messages.startWOsave,
                language = mad.common.observables.languageIndex();
            navigator.notification.confirm(
                msg.message[language],
                function (button) {
                    if (button == 1) {              // if yes
                        mad.viewModels.createWorkoutName.viewModel.exercisesShowed = false;
                        startWorkoutWOsaving();
                    }
                },
                msg.title[language], [msg.button1[language], msg.button2[language]]);

        }
    };

    function startWorkoutWOsaving(){
        var done = mad.viewModels.createWorkoutDone.viewModel;

        mad.common.showLoader();
        var deferred = jQuery.Deferred();
        deferred.then(function (sucess) {
            mad.common.hideLoader();
            done.model.startWorkout(sucess);

        }, function (fail) {
            mad.common.hideLoader();
        });
        done.model.getModelForStartWithoutSaving(deferred);
    }


    function isSaved() {
        return mad.viewModels.createWorkoutDone.viewModel.model.get("isSaved");
    }

    //** ---- not in viewModel Context - - - - - - - - - - -  - - - - - -
    function setupView(){
        mad.common.stretchView();
        setViewTitle();
    }

    function setViewTitle(){
        var naslov = mad.viewModels.createWorkoutMain.viewModel.model.workoutName;
        mad.common.actualView.title = naslov;
        setTimeout(function() {
            mad.common.actualView.header
                .find(".km-navbar")
                .data("kendoMobileNavBar").title(naslov);
        }, 22);
    }

    function favouritesIcon() {
        var done = mad.viewModels.createWorkoutDone.viewModel;
        if (done.model.get("isSaved"))
            return "images/icons/unsaved.svg";
        else
            return "images/icons/saved.svg";
    }

    function saveWorkoutToFavourites() {
        var done = mad.viewModels.createWorkoutDone.viewModel;
        if (done.model.get("isSaved")) {

            done.model.set("isSaved", !done.model.get("isSaved"));

            mad.common.showLoader();
            var deferred = jQuery.Deferred();
            deferred.then(function (success) {
                mad.common.hideLoader();
            }, function (fail) {
                done.model.set("isSaved", !done.model.get("isSaved"));
                mad.common.hideLoader();
            });
            done.model.removeFromSaved(deferred);
        }else{

            done.model.set("isSaved", !done.model.get("isSaved"));

            mad.common.showLoader();
            var deferred = jQuery.Deferred();
            deferred.then(function (success) {
                console.log("save success - prije hide")
                mad.common.hideLoader();
            }, function (fail) {

                done.model.set("isSaved", !done.model.get("isSaved"));
                console.log("save fail - prije hide")
                mad.common.hideLoader();
            });

            console.log("prije poziva sejvanja")
            done.model.saveWorkout(deferred);
        }
    }

    return {
        viewModel: viewModel
    };

}());


