var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.editRepsCreate = (function () {

    "use strict";

    var viewModel = kendo.observable({
        common: mad.common.observables,
        init: initView,
        show: showView,
        afterShow: afterShow,

        leftButtonAction: leftButtonAction,
        checkEnter: checkEnter,
        inputChanged: inputChanged,

        rightButtonAction: tapRemoveExercise,

        editWorkoutModel: {}

    });


    function initView(e){
        //console.log("init editReps -------------------");
    }

    function showView(e){
        //console.log("on show editReps --");

        viewModel.set("editWorkoutModel",mad.viewModels.createWorkoutMain.viewModel.get("editWorkoutModel"));   // copy exercise from createWorkoutMain
        viewModel.set("editWorkoutModel.OldValue", viewModel.get("editWorkoutModel.Reps"));                     // store copy of reps to OldValue

        mad.common.setActualView();
        mad.common.stretchView();

        kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    function afterShow(e) {
        $("#repsEditContainer").css("width", mad.common.actualView.content.width()); // ovo je bitno jer se nece dobro posloziti widget
        $("#EditWorkoutCreateValPicker").data("kendoValuePicker").initNumbers();

        mad.googleAnalytics.trackView("Create Workout - Edit Reps");

    }

    /* not in viewModel Context  - - - - - -  */
    function leftButtonAction(e){

        e.preventDefault();     // da ne probija

        $("#editRepsCreateField").blur();

        mad.viewModels.createWorkoutMain.viewModel.set("editWorkoutModel", viewModel.get("editWorkoutModel"));
        mad.viewModels.createWorkoutMain.viewModel.set("editWorkoutModel.OldValue", mad.viewModels.createWorkoutMain.viewModel.get("editWorkoutModel.Reps"));

        $(".madbarz-value-picker-list").empty();    // brisi elemente liste

        //mad.common.goBack();
        mad.mobileApp.navigate("ui/workouts/createWorkout/Main.html?origin=editReps", "slide:left reverse");

    }

    function inputChanged(e) {
        //console.log(e)
        var inp = e.keyCode;


        var brj = parseInt(viewModel.get("editWorkoutModel.Reps"));
        if (brj > 3600){
            viewModel.set("editWorkoutModel.Reps", 3600);
        }
    }

    function checkEnter(e) {
        //console.log("checkEnter");
        if (e.keyCode == 13) {
            leftButtonAction(e);
        }
    }

    function tapRemoveExercise(e){
        e.preventDefault(); // da ne probija

        var msg = mad.glossary.messages.delete, language = mad.common.observables.languageIndex();
        navigator.notification.confirm(
            msg.message[language],
            function (button) {
                if (button == 1) { // if yes
                    var main = mad.viewModels.createWorkoutMain.viewModel;
                    main.set("exerciseForDelete", main.get("editWorkoutModel"));
                    $('#createWorkoutMain-scroller').data('kendoMobileScroller').reset();
                    main.model.removeExercise(main.get("exerciseForDelete"));
                    mad.mobileApp.navigate("ui/workouts/createWorkout/Main.html", "slide:left reverse");
                }
            },
            "", [msg.button1[language], msg.button2[language]]);
    }

    return {
        viewModel: viewModel
    };

}());

