var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.createWorkoutExercises = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,
        model: window.createWorkout.model,

        init: initView,
        beforeShow: beforeShow,
        show: showView,
        afterShow: afterShow,
        titlePressed: toTop,
        actionsheetOpened: false,
        //handleFilter: handleFilter,
        doneButton: doneButton,
        resetView: resetView,
        removeTagFilter: removeTagFilter,
        doTagFiltering: doTagFiltering,
        lastFilterName: "",
        uCanTouchThis: false,

        totalNumberOfExercises: 0,
        brojPodataka: 0,
        showBrojPodataka: false,
        listOfExercises: new kendo.data.DataSource({
            data: []
        }),
        nonFilterData: [],
        tagFilterOn: false,
        firstTimeShow: true,
        counter: 0,
        timeLastAdded: 0,
        onSearch: false,
        lastTimeSearched: null,
        selectedTag: "",
        selectedTagValue: "0",
        // za novi filter - - - -
        openModal: openModal,
        modalOpened: false,
        filterItemsCreated: false,
        filterValues: {},
        closeFilter: closeFilter,
        resetFilter: resetFilter,
        saveFilter: saveFilter,
        isFemale: false,

    });

    var filterTAGs = [
        {
            order: 1,
            show: true,
            Id: "0",
            Name: "None"
        },
        {
            order: 2,
            show: true,
            Id: "4048BDC8-AC86-489A-8C03-0353B480A9DD",
            Name: "Low Pull-up Bar"
        },
        {
            order: 3,
            show: true,
            Id: "8B3CE6E2-E7B1-4A5A-B133-03868EF2179E",
            Name: "Ab Roller"
        },
        {
            order: 4,
            show: false,
            Id: "06667096-2217-4EFC-8E34-079117934991",
            Name: "Rings"
        },
        {
            order: 5,
            show: true,
            Id: "21E54970-9CF5-4288-92B5-2FC9EAA8E64A",
            Name: "No Equipment"
        },
        {
            order: 6,
            show: true,
            Id: "BC55080B-C26F-49C7-A082-38ADABD539FE",
            Name: "Pull-up Bar"
        },
        {
            order: 7,
            show: true,
            Id: "585A9A3C-6F7F-4A9B-ADBD-3C5A9E2E5F9A",
            Name: "Jumping Rope"
        },
        {
            order: 8,
            show: false,
            Id: "9A748CE7-B51F-40AA-B09F-6690CEFDD08A",
            Name: "TRX"
        },
        {
            order: 9,
            show: false,
            Id: "352CE4A6-1C4C-4C59-B661-79B8103985D3",
            Name: "Dumbbell"
        },
        {
            order: 10,
            show: false,
            Id: "2BB99960-104B-460E-9BFF-8BB6549C342F",
            Name: "Kettlebell"
        },
        {
            order: 11,
            show: false,
            Id: "921AFAA3-E41F-46FF-8EA7-76F06AB02A85",
            Name: "Butt"
        },
        {
            order: 12,
            show: true,
            Id: "26BB7BF8-A0E5-4190-B3CD-AB8F8CAC7D31",
            Name: "Dip Bar"
        },
        {
            order: 13,
            show: true,
            Id: "F4729283-592E-47EA-895E-F0BA6C9FCCD7",
            Name: "Pole"
        },
        {
            order: 14,
            show: true,
            Id: "9A748CE7-B51F-40AA-B09F-6690CEFDD08A",
            Name: "TRX"
        },
        {
            order: 14,
            show: true,
            Id: "06667096-2217-4EFC-8E34-079117934991",
            Name: "Rings"
        }

    ];

    var filterMISCs = [
        {
            ime: 'Shoulders',
            tag: '2',
            order: 2,
            type: "muscle",
            selected: false
        },
        {
            ime: 'Back',
            tag: '5',
            order: 3,
            type: "muscle",
            selected: false
        },
        {
            ime: 'Chest',
            tag: '4',
            order: 4,
            type: "muscle",
            selected: false
        },
        {
            ime: 'Arms',
            tag: '1',
            order: 5,
            type: "muscle",
            selected: false
        },
        {
            ime: 'Core',
            tag: '6',
            order: 6,
            type: "muscle",
            selected: false
        },
        {
            ime: 'Legs',
            tag: '3',
            order: 8,
            type: "muscle",
            selected: false
        },
        {
            ime: 'Butt',
            tag: '921AFAA3-E41F-46FF-8EA7-76F06AB02A85',
            order: 9,
            type: "tag",
            selected: false
        }
    ];

    var filterON = {};
    var filterOFF = {};

    var scroller;

    function initView(e){

        var viewID = "#createWorkoutExercises";

        /*
        $("#createWorkoutExercises").kendoTouch({
            touchstart: function(e) {
                console.log("touchstart",e);
                if (viewModel.get("onSearch")){
                    $("#createWorkoutExercises input").blur();
                }
            }
        });
        */

        scroller = e.view.scroller;
        viewModel.set("uCanTouchThis", false);

        $(viewID).kendoTouch({
            filter: ".filterButton, .rButton",

            /* drazen - trebalo bi tu handlat
            filter: "li, .add, .toInstructions",   - za listu

            i prebacit logiku iz exerciseTapped u handleTap tj. povezati to
            al me brine sto je u filteru li (provjeri - moze li se izbaciti)
             */

            touchstart: function(e) {
                //console.log("touchstart");

                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    if(scroller){
                        if (scroller.enabled){
                            scroller.disable();
                        }
                    }
                }else{
                    if(scroller){
                        if (!scroller.enabled) {
                            scroller.enable();
                        }
                    }
                }
            },
            tap: function(e) {
                //console.log("kendo tap");

                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                }else{
                    handleTap(e);
                }
            }
        });

        $("#createWorkoutExercisesScrollView").kendoMobileListView({
            dataSource: viewModel.listOfExercises,
            autoBind: true,
            template: function(data) {
                if (mad.common.isNullOrEmpty(data)){
                    console.log("nema nesto podataka");
                }else{
                    if (data.selectedXtimes > 1){
                        data.displayTimes = data.selectedXtimes
                    }else{
                        data.displayTimes = ""
                    }
                    var tpl = kendo.template($("#CreateWorkoutAddExercisesTemplate").html(), {useWithBlock:false});
                    return tpl(data);
                }
            },
            filterable: {
                field: "Name",
                operator: "contains"
            },

            endlessScroll: true,
            virtualViewSize: 46

        }).kendoTouch({
            filter: "li, .add, .toInstructions",
            tap: exerciseTapped
        });

        $("#createWorkoutExercises input").focus(function() {
            viewModel.set("onSearch", true);
        });
        $("#createWorkoutExercises input").blur(function() {
            //$( this ).blur();
            viewModel.set("onSearch", false);
        });

        var forma = $("#createWorkoutExercises .km-filter-form");
        if (forma.length){
            forma.submit(function( event ) {
                event.preventDefault();
                if (cordova.plugins && cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.close();
                    document.activeElement.blur();
                }
            });
        }

        $("#filterExercisesModal .time-container").kendoTouch({
            tap: function (e) {
                e.preventDefault(); // da ne probija
                selectTime(e);
            }
        });

        prepareMobiscroll();

    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target.context;

        if ($(element).hasClass("rButton")) {
            doneButton();
        }else if ($(element).hasClass("filterButton")) {
            openModal();
        }
    }

    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e){

        viewModel.set("isFemale", checkIsFemale());

        mad.common.setActualView();
        mad.common.stretchViewContentToBeElastic();

        kendo.bind($(mad.common.$actualViewID), viewModel);

        if (viewModel.get("firstTimeShow")){
            viewModel.set("firstTimeShow", false);

            var view = $("#createWorkoutExercisesScrollView").data("kendoMobileListView");
            if (view) view.refresh();
        }

        /*
        // show last filtername
        var filterName = viewModel.get("lastFilterName");

        if (filterName == "All" || filterName == "") {
            $('#workoutsCreateAddExercisesFilterTags span').text("filter");
        } else {
            $('#workoutsCreateAddExercisesFilterTags span').text("filter: " + filterName);
        }

        // mark selected
        $('#workoutsCreateAddExercisesTagFilterActionsheet').find(".selected").removeClass("selected");
        $('#workoutsCreateAddExercisesTagFilterActionsheet').find("." + filterName).addClass("selected");
        */
    }

    function afterShow() {
        $("#createWorkoutMain .km-footer .dButton").removeClass("preloader");
        viewModel.set("uCanTouchThis", true);

        mad.googleAnalytics.trackView("Create Workout - Add Exercises");
    }

    function doneButton(e){
        if(!mad.common.isNullOrEmpty($('#createWorkoutMain-list').data("kendoMobileListView"))) {
            $("#createWorkoutMain-list").data("kendoMobileListView").refresh();
        }
        mad.mobileApp.navigate("ui/workouts/createWorkout/Main.html");
    }

    function resetView(){
        $('#workoutsCreateAddExercisesFilter').val('');

        if (!mad.common.isNullOrEmpty(viewModel.listOfExercises.filter())){
            viewModel.listOfExercises.filter({});
        }
        removeTagFilter();
    }

    function handleFilter(e) {
        e.preventDefault(); // da ne probija

        setTimeout(function () {
            $('#workoutsCreateAddExercisesTagFilterActionsheet').data("kendoMobileActionSheet").open($('#workoutsCreateAddExercisesFilterTags'));
        }, 11);
        mad.viewModels.createWorkoutExercises.viewModel.set("actionsheetOpened", true);
    }

    function removeTagFilter(param){
        console.log("removeTagFilter", param);
        mad.viewModels.createWorkoutExercises.viewModel.set('tagFilterOn', false);
        $('#workoutsCreateAddExercisesFilterTags').addClass('filterNotActive');

        viewModel.set("lastFilterName", "All");
        $('#workoutsCreateAddExercisesFilterTags span').text("filter");

        viewModel.listOfExercises.data(viewModel.get("nonFilterData"));
    }

    function doTagFiltering(filterName, muscleIdsFilter) {

        // mark selected
        $('#workoutsCreateAddExercisesTagFilterActionsheet').find(".selected").removeClass("selected");
        $('#workoutsCreateAddExercisesTagFilterActionsheet').find("." + filterName).addClass("selected");

        var data = this.get("nonFilterData");
        if (data.length === 0) return null;

        scroller.reset();

        viewModel.set("lastFilterName", filterName);

        mad.googleAnalytics.trackEvent("Used Filter", "Click - Exercise Filter in CW", filterName);

        if (filterName == "All") {
            $('#workoutsCreateAddExercisesFilterTags span').text("filter");
            removeTagFilter();
            return;
        } else {
            $('#workoutsCreateAddExercisesFilterTags span').text("filter: " + filterName);
        }

        var filteredData = [];

        _.forEach(data, function(exercise){
            var filtrirano = _.some(exercise.MuscleIds, function(muscleId){
                var postoji = _.some(muscleIdsFilter, function(muscleUfilteru){
                    var jednak = muscleUfilteru === muscleId;
                    return jednak
                });
                if (postoji){
                    filteredData.push(exercise);
                }else{
                    //console.log("     id " + muscleId + " NE postoji u filter tagovima")
                }
                return postoji;
            });
        });
        viewModel.listOfExercises.data(filteredData);
        this.set('tagFilterOn', true);
    }

    //** ---- not in viewModel Context - - - - - - - - - - -  - - - - - -

    function toTop(){
        scroller.reset();

        var view = $("#createWorkoutExercisesScrollView").data("kendoMobileListView");
        if (view) {
            view.refresh();
        }
    }

    function exerciseTapped(e) {

        e.preventDefault(); // da ne probija

        var element = e.touch.target;
        var uidElement = element.closest("li");
        var uid = uidElement.attr('data-uid');
        var exercise = viewModel.listOfExercises.getByUid(uid);
        //potrebno za video
        mad.viewModels.workoutVideo.viewModel.set("selectedExercise",exercise);

        if ($(element).hasClass("toInstructions")) {
            mad.viewModels.workoutVideo.viewModel.openVideoModal();

        } else if ($(element).hasClass("add")) {

            console.log("add tap");

            // drazen - ovo valja ako se refresha (al refresh ne radi dobro na kraju liste)
            // tako da cemo azurirati datasource
            exercise.selectedXtimes += 1;
            if (exercise.selectedXtimes > 1){
                exercise.displayTimes = exercise.selectedXtimes
            }else{
                exercise.displayTimes = ""
            }

            // i azurirati direktno u DOMu bez refreshanja
            var item = $("#createWorkoutExercisesScrollView [data-uid='" + uid + "']");
            if (item.length) {
                item.find(".exercise-selected2").html(function() {
                    return '<div class="done" style="background-image: url(\'images/icons/done.svg\');">' + exercise.displayTimes + '</div>';
                });
            }

            //dodaj na listu izabranih exercisea i postavi repse
            mad.viewModels.createWorkoutExercises.viewModel.timeLastAdded = (new Date()).getTime();
            var id = mad.viewModels.createWorkoutExercises.viewModel.model.addExercise(exercise);
            $.ajax({
                data: {
                    id: exercise.ExerciseId
                },
                type: "GET",
                beforeSend: function (request) {
                    request.setRequestHeader("Authorization", "Bearer " + mad.loginToken);
                },
                url: mad.common.variables.serverUrl + "api/CreateRoutine/GetNumberOfRepsForExercise",
                success: function (data) {
                    var exercise2 = mad.viewModels.createWorkoutExercises.viewModel.model.routines.get(id);
                    exercise2.loading = false;
                    exercise2.Reps = data;
                },
                error: function (data) {
                    var exercise2 = mad.viewModels.createWorkoutExercises.viewModel.model.routines.get(id);
                    exercise2.loading = false;
                    exercise2.Reps = 0;
                }
            });
        }
    }

    // za novi filter - - - -
    function openModal(){
        viewModel.set("modalOpened", true);

        var modalID = $("#filterExercisesModal");
        var mv = modalID.data("kendoMobileModalView");

        var WheelValue = "";

        modalID.removeClass("hidden");
        mv.open();
        modalID.css("height", modalID.parent().height());
        $("#filterContainer").css("height", modalID.parent().height());
        mv.scroller.reset();

        var miscTags = document.getElementById('miscTagsCR');

        if (!viewModel.get("filterItemsCreated")){
            viewModel.set("filterItemsCreated", true);
            createTagButtons(miscTags, "misc");
            assignTouchEventsToTags("#miscTagsCR li")
        }

        var filter = getFilter();

        if (filter.reset){
            // reset TAGS

            $('#exercisesFilterMenu').mobiscroll('setVal', "None");
            viewModel.set("selectedTag", "Select");
            viewModel.set("selectedTagValue", "0");

            // reset misc tags
            $("#miscTagsCR li").removeClass("selected");
        }else {

            // handle tags
            $('#exercisesFilterMenu').mobiscroll('setVal', filter.selectedTag);

            if (filter.selectedTag == "None"){
                viewModel.set("selectedTag", "Select");
            }else{
                viewModel.set("selectedTag", filter.selectedTag);
            }
            viewModel.set("selectedTagValue", filter.selectedTagValue);

            // remove all selected tags
            $("#miscTagsCR li").removeClass("selected");


            if (!mad.common.isNullOrEmpty(filter.selectedTagValues)) {
                _.forEach(filter.selectedTagValues, function (obj) {
                    if (obj == "921AFAA3-E41F-46FF-8EA7-76F06AB02A85") { // ovo je sifra za "Butt"
                        $("#miscTagsCR li[tag='921AFAA3-E41F-46FF-8EA7-76F06AB02A85']").addClass("selected");
                    }
                });
            }

            // handle misc tags
            if (!mad.common.isNullOrEmpty(filter.selectedMiscTags)) {
                _.forEach(filter.selectedMiscTags, function (obj) {
                    $("#miscTagsCR li[tag='" + obj + "']").addClass("selected");
                });
            }

        }

        doFiltering();
    }

    function createTagButtons(container, which){

        var sortiraniTagovi;

        if ("tag" == which){
            sortiraniTagovi = _.sortBy(filterTAGs, 'order');
        }else{
            sortiraniTagovi = _.sortBy(filterMISCs, 'order');
        }

        _.forEach(sortiraniTagovi, function (obj, n) {
            var newLi = document.createElement("li");   // mora se uvijek kreirati novi node
            container.appendChild(newLi);
            newLi.innerText = obj.ime;
            var klase = "tagGumb";
            if (obj.selected){
                klase += " selected";
            }
            newLi.className = klase;
            newLi.setAttribute('tag', obj.tag);

            if ("misc" == which){
                newLi.setAttribute('type', obj.type);
            }
        });
    }

    function assignTouchEventsToTags(objekt){

        $(objekt).kendoTouch({
            tap: function(e) {
                e.preventDefault(); // da ne probija
                var element = e.touch.target.context;
                $(element).toggleClass("selected");
                doFiltering();
            }
        });
    }

    function getFilter(){
        // loads saved filter values
        var savedFilterValues = mad.local.loadVariableParse("exercise-filter");
        if (mad.common.isNullOrEmpty(savedFilterValues)){
            viewModel.filterValues.set("reset", true);
        }else{
            viewModel.set("filterValues", savedFilterValues);
        }
        return viewModel.get("filterValues");
    }

    function setFilter(filter){
        var  rez;

        console.log("setFilter", filter);
        rez =  {
            logic: "and",
            filters: [
                {
                    field: "MusclegroupIds",
                    operator: function (Tags) {
                        var selectedTags = viewModel.get("filterValues.selectedMiscTags");
                        if (!selectedTags){
                            //console.log("selektiraniTagovi jos nisu definirani vrati true");
                            return true
                        }
                        if (!Tags){
                            //console.log("nema Tags - vrati false");
                            return false;
                        }
                        return filterByMuscles(Tags, selectedTags);
                    }
                },
                {
                    field: "Tags",
                    operator: function (Tags) {
                        var selectedTags = viewModel.get("filterValues.selectedTagValues");
                        var pozicijaNule = selectedTags.indexOf("0");
                        if (pozicijaNule > -1) {
                            selectedTags.splice(pozicijaNule, 1);
                            console.log("u selektiranim je bila 0 i sad je vise nema", selectedTags);
                        }

                        if (!selectedTags){
                            //console.log("selektiraniTagovi a dropdowna jos nisu definirani vrati true");
                            return true
                        }
                        if (!Tags){
                            //console.log("nema Tags za dropdown - vrati false");
                            return false;
                        }
                        //console.log("--- sel ddown tag je", selectedTags);
                        return filterByTags(Tags, selectedTags);
                    }
                }
            ]
        };
        return rez;
    }

    function applyFilter() {
        var filter = getFilter();
        var applyFilter;

        if (filter.reset){
            applyFilter = filterOFF;
        }else{
            filterON.value = filter;
            applyFilter = setFilter(filter);
        }
        viewModel.listOfExercises.filter(applyFilter);

        if (mad.common.isNullOrEmpty(viewModel.listOfExercises)){
            viewModel.set("brojPodataka", 0);
            viewModel.set("showBrojPodataka", false);
        } else {
            var lngth = viewModel.listOfExercises.view().length;
            viewModel.set("brojPodataka", lngth ); 
            viewModel.set("showBrojPodataka", lngth > 0);

        }

        mad.common.scrollViewToTop();

        mad.googleAnalytics.trackEvent("Used Filter", "Click - Workout Filter", filter);

        //bLazy.revalidate();

    }

    function doFiltering(){
        console.log("---- filtering -----");

        var selektiraniTagovi, selektiraniMiscTagovi;
        var filterValues = {};
        var filterData;

        selektiraniTagovi = getSelectedTags();  // onaj s dropdown liste
        //selektiraniMiscTagovi = getSelectedMiscTags();
        selektiraniMiscTagovi = getSelectedMiscTags(selektiraniTagovi); // prebacit ce guzicu u selektiraniTagovi ako je ima

        if (selektiraniMiscTagovi.length == 0 && selektiraniTagovi.length == 1 && viewModel.get("selectedTag") == "Select"){
            filterValues.reset = true;                         // means apply filter
            filterData= filterOFF;
        }else{
            filterValues.reset = false;                         // means apply filter
            filterValues.selectedMiscTags = selektiraniMiscTagovi;
            filterValues.selectedTag = viewModel.get("selectedTag");
            filterValues.selectedTagValue = viewModel.get("selectedTagValue");
            filterValues.selectedTagValues = selektiraniTagovi;
            filterData = setFilter(filterValues);
        }

        viewModel.set("filterValues", filterValues);
        console.log("filter je", filterValues);

        viewModel.listOfExercises.filter(filterData);

        console.log("podaci", viewModel.listOfExercises);

        updateNumbers(); //of filtered records
    }

    function getSelectedTags(){
        var rez = [];

        var selektiraniSliste = viewModel.get("selectedTagValue");  //viewModel.get("selectedTag");
        rez.push(selektiraniSliste);
        return rez;
    }

    function getSelectedMiscTags(tagsArray){
        var rez = [];
        $("#miscTagsCR .selected").each(function(){
            var tagJe = $(this).attr("tag");
            var typeJe = $(this).attr("type");
            if ("muscle" == typeJe){
                rez.push(parseInt(tagJe));
            }else{
                tagsArray.push(tagJe);
            }
        });
        return rez;
    }

    function updateNumbers(){
        if (viewModel.listOfExercises.length == 0){return}

        //update number of filtered data(beside filter icon)
        var selected;
        selected = viewModel.listOfExercises.view().length;
        viewModel.set("brojPodataka", selected);
        viewModel.set("showBrojPodataka", selected > 0);


        //var zerofilled = ('000'+selected).slice(-3);    // zadnja 2
        var zerofilled = selected;

        $(".saveFilter").addClass("efekt");
        $(".saveFilter .value").text("("+zerofilled+")");

        setTimeout(function () {
            $(".saveFilter").removeClass("efekt");
        }, 333);

    }

    function filterByMuscles(tagovi, selektiraniTagovi) {
        if (selektiraniTagovi.length == 0){
            //console.log("filterByMuscles - selektiraniTagovi su prazni")
            return true
        }
        return _.every(selektiraniTagovi, function (value) {
            console.log("filterByMuscles - trazi selektiraniTag", value);
            var sadrzi = tagovi.filter(function(tag){
                console.log(tag, tag == value);
                return tag == value; // bez typea jer imamo string i int
            });
            if (sadrzi.length>0){
                console.log("           prolazi ---");
            }
            return sadrzi.length>0;    // vrati true ako tag iz rutine odgovara selektiranom tagu
        });
    }

    function filterByTags(tagovi, selektiraniTagovi) {
        console.log("*** filterByTags/ trazi dropdown tagove", selektiraniTagovi);

        if (selektiraniTagovi.length == 0){
            console.log("filterByTags - selektiraniTag su prazni")
            return true
        }
        return _.every(selektiraniTagovi, function (value) {
            console.log("filterByTags - trazi selektiraniTag", value);
            var sadrzi = tagovi.filter(function(tag){
                var tagID = tag.Id;
                console.log("filterByTags - tag u podacima", tagID.toUpperCase(), tagID.toUpperCase() == value);
                return tagID.toUpperCase() == value;
            });
            if (sadrzi.length>0){
                console.log("           moze selektirani ---");
            }else{
                console.log("           ovaj nije dobar ---");
            }
            return sadrzi.length>0;    // vrati true ako tag iz rutine odgovara selektiranom tagu
        });

    }

    function filterByTagsSjednimNaListi(tagovi, selektiraniTag) {
        console.log("*** filterByTags/ trazi dropdown tag", selektiraniTag);

        if (selektiraniTag.length == 0){
            console.log("filterByTags - selektiraniTag su prazni")
            return true
        }
        if (selektiraniTag == "0"){
            console.log("filterByTags - selektiraniTag je Select tj. None")
            return true
        }

        var sadrzi = tagovi.filter(function(tag){
            //console.log("filterByTags - tag u podacima", tag);
            var tagID = tag.Id;
            console.log(tagID.toUpperCase(), tagID.toUpperCase() == selektiraniTag);
            return tagID.toUpperCase() == selektiraniTag;
        });

        if (sadrzi.length>0){
            console.log("           bingo - moze");
        }
        return sadrzi.length>0;    // vrati true ako tag iz rutine odgovara selektiranom tagu
    }

    function closeFilter(){
        applyFilter();
        closeModal();
    }

    function closeModal(){
        viewModel.set("modalOpened", false);

        var modalID = $("#filterExercisesModal");
        var mv = modalID.data("kendoMobileModalView");
        mv.close();

        modalID.addClass("hidden");
        //bLazy.revalidate();
    }

    function resetFilter(){
        $('#exercisesFilterMenu').mobiscroll('setVal', "None");
        viewModel.set("selectedTag", "Select");
        viewModel.set("selectedTagValue", "0");

        $("#miscTagsCR li").removeClass("selected");

        viewModel.filterValues.set("reset", true);

        mad.local.saveVariableParse("exercise-filter", viewModel.get("filterValues"));
        closeFilter();

        mad.common.scrollViewToTop();
    }

    function saveFilter(){
        var brp = viewModel.get("brojPodataka");
        if (brp == 0 || brp== ""){
            mad.alerts.error("No results, please filter again","");
        }else{
            // spremi filter parametre i zatvori
            mad.local.saveVariableParse("exercise-filter", viewModel.get("filterValues"));
            closeModal();
            mad.common.scrollViewToTop();
        }
    }

    function checkIsFemale() {
        console.log("comm vars", mad.common.variables);
        return (mad.common.variables.gender == "f");
    }

    function prepareMobiscroll() {
        var theme = $.mobiscroll.defaults.theme,
            mode = "static",
            display = "bottom",
            lang = "hr";

        var names = filterTAGs.filter(function(obj){
            return obj.show
        }).map(function(obj){
            return obj.Name
        });
        //console.log(" - - - - names", names);

        var keys = filterTAGs.filter(function(obj){
            return obj.show
        }).map(function(obj){
            return obj.Id
        });

        var podaci = [// Wheel groups array
            [
                { // Wheel object
                    values: names,
                    keys: keys
                }
            ]
        ];

        $("#exercisesFilterMenu").mobiscroll({
            theme: theme,
            mode: mode,
            display: display,
            buttons: [],
            lang: lang,
            showLabel: false,
            showInput: false,
            wheels: podaci,
            //height: 60,
            rows: names.length,
            readonly: false,
            group: false,
            layout: "liquid",
            onShow: function (html, valueText, inst) {

                html.addClass("exercisesFilterMenuOpened");

                var winH = $(window).height();
                var dialogEl = html.find("[role='dialog']");
                var dialogElHight = dialogEl.height();
                // korigiraj top poziciju
                dialogEl.css({"top": winH - dialogElHight});

            },
            onValueTap: function (item, inst) {

                console.log("!!!!", item);

                if (item.context.textContent == "None"){
                    viewModel.set("selectedTag", "Select");
                }else{
                    viewModel.set("selectedTag", item.context.textContent);
                }
                viewModel.set("selectedTagValue", $(item.context).attr("data-val"));

                inst.hide(false, "set");

                doFiltering();

            }
        });

    }

    function selectTime(e) {
        var inst = $("#exercisesFilterMenu").mobiscroll("getInst");
        //with a little delay because it sometimes closes automatically
        setTimeout(function() {
            inst.show(false, false); // Call the show method with animate & focus
        }, 22);
    }

    return {
        viewModel: viewModel
    };

}());
