var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.createWorkoutMain = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,
        model: window.createWorkout.model,

        init: initView,
        show: showView,
        afterShow: afterShow,

        leftButtonAction: leftButtonAction,
        rightButtonAction: finishCreate,
        titlePressed: mad.common.titlePressed,

        footerBtnPressed: createButton,

        exercisesNoneAddedMessage: exercisesNoneAddedMessage,
        changePause: changePause,

        tabsShown: false,

        duration: 222,
        selectedTab: 0,
        timeLastTaped:0,
        timeToWait: 444,
        brojac: 0,

        origin: "?",

        editWorkoutModel: {
            m_Item2: 2,
            RoutineId: 1,
            m_Item1: {
                Exercise: {
                    Name: "naziv",
                    isTimed: true,
                    ImageUrl: "images/exercise/Diamond Push Ups.png",
                    hasSrc: true
                }
            }
        },
        exerciseForDelete: {},
        selectedItem: {}
    });

    function initView(e){
        viewModel.set("tabsShown", false);
        initSubmenu();
        generateListOfWorkouts();
    }

    function showView(e){
        mad.common.setActualView(); mad.common.addViewToHistory(); setupView();

        var tabstrip, origin, scroller, scrollerWidget;

        // setup submenu tabstrip                   // za slucaj da se u međuvremenu promjenio jezik
        tabstrip = $(mad.common.$actualViewID+"-submenu").data("kendoTabStrip");

        // add menu slide line
        mad.common.appendSlideLine();

        tabstrip.select(0);

        origin = e.view.params.origin;
        viewModel.set("origin", origin);
        //console.log("origin je", origin);

        mad.common.variables.showGender = mad.common.variables.gender;

        if (!viewModel.get("tabsShown")){
            show1stTab();
            showSettingsTab();
        }
        // misice uvjek prikazi jer je moguca promjena spola
        showMusclesTab();

        if (origin == "editReps"){
            $("#createWorkoutMain-list").data("kendoMobileListView").refresh();
            return
        }else if (origin == "name"){
            scroller =  $("#createWorkoutMain-scroller");
            if (scroller.length){
                scrollerWidget= scroller.data("kendoMobileScroller");
                scrollerWidget.reset();                                         // go to top
            }
        }
        kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    function afterShow(e){
    }

    function leftButtonAction(){
        mad.common.goBack();
    }

    function createButton(){
        $("#createWorkoutMain .km-footer .dButton").addClass("preloader");
        mad.mobileApp.navigate("ui/workouts/createWorkout/Exercises.html");
    }

    function exercisesNoneAddedMessage () {
        return mad.viewModels.createWorkoutMain.viewModel.get("model.routines").total() == 0;
    }

//** ---- not in viewModel Context - - - - - - - - - - -  - - - - - -
    function setupView(){
        mad.common.stretchView();
        setViewTitle();
    }

    function setViewTitle(){
        var naslov = mad.viewModels.createWorkoutMain.viewModel.model.get("workoutName");
        mad.common.actualView.title = naslov;
        setTimeout(function() {
            mad.common.actualView.header
                .find(".km-navbar")
                .data("kendoMobileNavBar").title(naslov);
        }, 22);
    }

    function initSubmenu(){
        // generate submenu tabstrip and construct tab's content structure, assign events for tabs
        var submenuElement = $("#createWorkoutMain-submenu").kendoTabStrip({
            dataTextField: "Name",
            dataContentField: "Content",
            animation: false,
            show: function(e) {                     // on show tab - recalculate & update hights
                var tabJe = $(e.item).index();
                //console.log("showed tab", tabJe);

                var contentHeight, contentWidth, visinaTabova;

                visinaTabova =  $(mad.common.$actualViewID+"-submenu .k-tabstrip-items").outerHeight(true) - 1;

                if (tabJe == 0) {
                    setTimeout(function() {
                        contentHeight = parseInt(mad.mobileApp.view().content.height() - visinaTabova);
                        $("#createWorkoutMain-scroller").css("height", contentHeight);
                        $("#createWorkoutMain-list").css("height", contentHeight + 2);
                    }, 11)
                }else if (tabJe == 1) {
                        contentHeight = parseInt(mad.mobileApp.view().content.height() - visinaTabova);
                        $("#createWorkoutMain-pauses").css("height", contentHeight);
                }else if (tabJe == 2) {
                        contentHeight = parseInt(mad.mobileApp.view().content.height() - visinaTabova);
                        contentWidth  = parseInt(mad.mobileApp.view().content.width());
                        $("#createWorkoutMain-muscles").css("height", contentHeight);
                        //mad.common.scaleMuscleMan(contentHeight,contentWidth )
                    var reduce = 25 / 100                               //percentage
                    var muscleManContainerHeight = contentHeight - (contentHeight * reduce);

                    $("#createWorkoutMain-muscles .muscles-container").css("height", muscleManContainerHeight);
                    mad.common.scaleMuscleMan2(muscleManContainerHeight,contentWidth, 10);

                }
            },

            select: function (e) {
                //console.log("select tab");
            },
            activate: function (e) {
                //console.log("activate tab");
                var promise = $.Deferred();
                promise.then(function (success) {
                    handleActiveTab();
                }, function (fail) {
                    //slide failed
                    console.log("slide failed");
                });

                mad.common.handleTabSliding($(e.item), promise);

            }
        }).data("kendoTabStrip").setDataSource(mad.glossary.ui.createWorkoutMain.tabs[mad.common.observables.languageIndex()].dataSource);
    };

    function handleActiveTab(){
        if (mad.viewModels.createWorkoutMain.viewModel.get("selectedTab") == 0) {
            mad.googleAnalytics.trackView("Create Workout - Main - Exercises");
        } else if (mad.viewModels.createWorkoutMain.viewModel.get("selectedTab") == 1) {
            mad.googleAnalytics.trackView("Create Workout - Main - Setup");

        } else if (mad.viewModels.createWorkoutMain.viewModel.get("selectedTab") == 2) {
            mad.googleAnalytics.trackView("Create Workout - Main - Muscles");
        }
    }

    function show1stTab(){
        console.log("show1stTab");
        // generate arrow icon
        var tTemplate = kendo.template($("#CreateWorkoutAddIconTemplate").html());
        var tHTML = tTemplate(mad.viewModels.createWorkoutMain.viewModel);
        $("#addIcon").html(tHTML);
        viewModel.set("tabsShown", true);
    }

    function generateListOfWorkouts(){

        var listScroller = $("#createWorkoutMain-scroller").kendoMobileScroller().data("kendoMobileScroller");

        var main = mad.viewModels.createWorkoutMain.viewModel;

        var listOfExercises = $("#createWorkoutMain-list").kendoMobileListView({
            dataSource: main.model.routines,

            autoBind: true,
            dataBinding: function(e) {
                console.log("dataBinding");
                viewModel.set("brojac",0);
            },
            template: function(data) {
                console.log("podaci za tpl - izabrani exer", data);
                var br = viewModel.get("brojac") + 1;
                viewModel.set("brojac", br);

                var tpl = kendo.template($("#CreateWorkoutEditWorkoutTemplate").text());
                return tpl(data);
            },
            virtualViewSize: 20
        });

        listOfExercises.data("kendoMobileListView");

        listOfExercises.kendoTouch({
            filter: ".toInstructions, .toReps, .repsHint, .dragHint",
            tap: tapped
        });

        listOfExercises.kendoTouch({
            filter: ".handler",
            minHold: 11,
            touchstart: function (e) {
                //var selectedTarget = $(e.touch.currentTarget).closest("li");
                var element = e.touch.target;
                var selectedTarget = $(element).closest("li"); // drazen - zbog nove verzije kenda
                $("#createWorkoutMain-list .exerciseSelected").removeClass("exerciseSelected"); // odznaci sve prethodno selektirane
                selectedTarget.addClass("exerciseSelected");
                listScroller.disable();
                main.timeLastTaped = (new Date()).getTime();
                setTimeout(function() {
                    selectedTarget.addClass("andReady");
                }, main.timeToWait);                                               // after some time
                var ul = $("#createWorkoutMain-list");
                ul.addClass("draggingActivated");
            },
            drag: function (e) {
                $("#createWorkoutMain-list .exerciseSelected").removeClass("exerciseSelected").removeClass("andReady"); // odznaci sve selektirane
            },
            dragend: function (e) {
                $("#createWorkoutMain-list .exerciseSelected").removeClass("exerciseSelected").removeClass("andReady"); // odznaci sve selektirane
                listScroller.enable();
                var ul = $("#createWorkoutMain-list");
                ul.removeClass("draggingActivated");
            }
        });

        listOfExercises.kendoSortable({
            handler: ".handler",
            cursor: "move",
            container: $("#createWorkoutMain-scroller"),
            holdToDrag: true,
            hint: function (element) {
                element.removeClass("draggingExercise");
                var klonirani = element.clone();
                klonirani.addClass("draggingExercise").removeClass('exerciseSelected');
                return klonirani
            },
            start: function (e) {
                var timeNow =  (new Date()).getTime();
                if ((timeNow - main.timeLastTaped) <  main.timeToWait ){
                    e.preventDefault();
                    $("#createWorkoutMain-list .exerciseSelected").removeClass("exerciseSelected").removeClass("andReady"); // odznaci sve selektirane
                    listScroller.enable();
                };
            },
            change: function (e) {
                var skip = main.model.routines.skip(),
                    newIndex = e.newIndex + skip,
                    dataItem = main.model.routines.getByUid(e.item.data("uid"));

                main.model.routines.remove(dataItem);
                main.model.routines.insert(newIndex, dataItem);
            }
        });
   }

    //hold bez move aktivira tap
    function tapped(e) {
        //console.log("tapped");

        e.preventDefault();     // da ne probija

        var main = mad.viewModels.createWorkoutMain.viewModel;
        var element = e.touch.target;
        var uidElement = element.closest("li");
        var exercise = mad.viewModels.createWorkoutMain.viewModel.model.routines.getByUid(uidElement.attr('data-uid'));

        if ($(element).hasClass("toInstructions")) {
            //potrebno za video
            mad.viewModels.workoutVideo.viewModel.set("selectedExercise",exercise);
            mad.viewModels.workoutVideo.viewModel.openVideoModal();
        }else if ($(element).hasClass("toReps")) {
            main.set("editWorkoutModel", exercise);
            var listview = $("#createWorkoutMain-list").data("kendoMobileListView");
            //var tappedElement = $(e.touch.currentTarget);
            var tappedElement = e.touch.target; // drazen - zbog nove verzije kenda

            var li = tappedElement.closest("li");
            var selectedItemData = listview.dataSource.getByUid(li.attr("data-uid"));
            mad.viewModels.createWorkoutMain.viewModel.set("selectedItem", selectedItemData);
            mad.mobileApp.navigate("ui/workouts/createWorkout/editRepsCreate.html");
        }
    }

    function finishCreate(e){
        e.preventDefault(); // da ne probija

        var main = mad.viewModels.createWorkoutMain.viewModel;
        var rutine =  main.model.routines.data();
        var koliko = rutine.length;
        var noErrors = true;
        var editMode = createWorkout.model.get("editMode");
        if (koliko == 0) {
            mad.alerts.error("You must add at least one exercise");
            noErrors = false;
        } else if (koliko > 50){
            mad.alerts.error("You can add max. 50 exercises");
            noErrors = false;
        }else{
            for (var i = 0; koliko > i; i++) {
                if (rutine[i].Reps == 0) {
                    var measure = rutine[i].IsTimed ? "Secs" : "Reps";
                    mad.alerts.error("You have at least one exercise with 0 " + measure);
                    noErrors = false;
                    break;
                }
            }
        }
        if (noErrors) {
            if (editMode){
                // azuriraj wkt i vrati se na listu sejvanih
                mad.common.showLoader();
                var deferred = jQuery.Deferred();
                deferred.then(function (success) {
                    console.log("update success - prije hide");
                    mad.common.hideLoader();
                    mad.mobileApp.navigate("ui/workouts/saved/madbarzSavedWorkoutsList.html?origin=finishedEdit");
                }, function (fail) {
                    console.log("update fail - prije hide");
                    //mad.alerts.error("Error in update","");
                    mad.common.hideLoader();
                });

                console.log("prije poziva sejvanja")
                createWorkout.model.updateWorkout(deferred);

            }else{
                mad.mobileApp.navigate("ui/workouts/createWorkout/Done.html");
            }
        }
    }

    function showSettingsTab(){
        var tTemplate = kendo.template($("#createSettingsTemplate").html());
        var tHTML = tTemplate(mad.viewModels.createWorkoutMain.viewModel);
        $("#createWorkoutMain-pauses").html(tHTML);
    }

    function changePause(e){
        //var target = e.touch.currentTarget;
        var target = e.touch.target;
        var val = $(target).attr('data-val');
        var step = parseInt($(target).attr('data-step'));
        var oldValue = this.model.get(val);
        var newValue = oldValue + step;

        if (newValue < Math.abs(step)) newValue = Math.abs(step);

        this.model.set(val, newValue);
        this.model.updateStrenghAndCardio();
    }

    function showMusclesTab(){
        // generate whole tab content
        var musclesTemplate = kendo.template($("#createMusclesTemplate").html());
        var musclesHTML = musclesTemplate(mad.viewModels.madbarzWorkout.viewModel);
        $("#createWorkoutMain-muscles").html(musclesHTML);

        // add language to class
        //$("#createWorkoutMain-muscles").addClass(mad.common.observables.selectedLanguage);

    }

    return {
        viewModel: viewModel
    };

    }());



