var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.createWorkoutName = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,
        model: window.createWorkout.model,

        show: showView,
        leftButtonAction: leftButtonAction,
        footerBtnPressed: goToNextStep,
        exercisesShowed: false

    });

    function showView(e) {
        var cameFrom = e.view.params.origin;

        console.log("cameFrom", cameFrom);

        // if it is comming from menu clear all data
        if ("menu" == cameFrom){
            this.model.clearCreateWorkout();
            this.model.set("isSaved", false);
            this.model.set("editMode", false);
        }else if ("madbarzWorkout" == cameFrom){
            this.model.set("isSaved", true);
            this.model.set("editMode", true);
        }

        mad.common.setActualView(); mad.common.addViewToHistory(); setupView();

        kendo.bind($(mad.common.$actualViewID), viewModel);

        mad.googleAnalytics.trackView("Create Workout - Enter Name");
    }

    function leftButtonAction(){

        if (mad.common.variables.navigationHistory.length >= 1) {
            if (mad.common.variables.navigationHistory[1].viewId == "madbarzWorkout") {
                mad.common.removeLastFromHistory();
            }
        }
        mad.common.goBack();
    }


    function goToNextStep(e) {
        e.preventDefault();

        if (this.model.workoutName == '') {
            mad.alerts.error("please enter workout name","");
        }else{
            document.activeElement.blur();  // automatically close the keyboard on iOS
            mad.mobileApp.navigate("ui/workouts/createWorkout/Main.html?origin=name");
        }
    }

    //** ---- not in viewModel Context - - - - - - - - - - -  - - - - - -
    function setupView(){
        mad.common.stretchView();
        setViewTitle();
    }

    function setViewTitle(){
        var naslov;

        if (viewModel.model.get("editMode")){
            naslov = "Edit workout"
        }else{
            naslov = "Create workout";
        }

        mad.common.actualView.title = naslov;

        setTimeout(function() {
            mad.common.actualView.header
                .find(".km-navbar")
                .data("kendoMobileNavBar").title(naslov);
        }, 22);

    }

    return {
        viewModel: viewModel
    };

}());


