var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.madbarzRoutines = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        beforeShow: beforeShow,
        beforeHide: beforeHide,
        show: showView,
        afterShow: afterShow,
        uCanTouchThis: false,
        selectedWorkout: {},
        tags: [],
        //routinesDataSource: new kendo.data.DataSource({}),

        routinesDataSource: new kendo.data.DataSource({
            data: [],
            group: { field: "IsTop"}
        }),
        filterActivated: false,

        dolazimIzInit: false,
        brojPodataka: "",
        modalOpened: false,
        filterValues: {},
        filterItemsCreated: false,
        selectedTime: "All durations",
        selectedTimeValue: 0,
        thisIsNotIpad: true,
        brojac: 0,
        menustripTap: false,
        closeFilter: closeFilter,
        resetFilter: resetFilter,
        saveFilter: saveFilter,
        isFemale: false,
        firstTimeHere: false


    });

    var filterTAGs = [
        {
            ime: 'Fat burn',
            tag: 'Fat burn',
            order: 1,
            selected: false
        },
        {
            ime: 'No equipment',
            tag: 'No equipment',
            order: 2,
            selected: false
        }
    ];

    var filterMISCs = [
        {
            ime: 'Full body',
            tag: 'Full body',
            order: 1,
            type: "tag",
            selected: false
        },
        {
            ime: 'Shoulders',
            tag: '2',
            order: 2,
            type: "muscle",
            selected: false
        },
        {
            ime: 'Back',
            tag: '5',
            order: 3,
            type: "muscle",
            selected: false
        },
        {
            ime: 'Chest',
            tag: '4',
            order: 4,
            type: "muscle",
            selected: false
        },
        {
            ime: 'Arms',
            tag: '1',
            order: 5,
            type: "muscle",
            selected: false
        },
        {
            ime: 'Core',
            tag: '6',
            order: 6,
            type: "muscle",
            selected: false
        },
        {
            ime: 'Butt',
            tag: 'Butt',
            order: 7,
            type: "tag",
            selected: false
        },
        {
            ime: 'Legs',
            tag: '3',
            order: 8,
            type: "muscle",
            selected: false
        }
    ];

    var filterON = {};
    var filterOFF = {};

    var timeStart;

    var scroller;

    function initView(e) {
        console.log("init view");

        var iPad = device.model.indexOf("iPad") > -1;
        viewModel.set("thisIsNotIpad", !iPad);

        var lastTop = 0, topBefore = 0,
            visina = 555,
            tmpVisina =  $(window).height();

        if (tmpVisina > visina){
            visina = tmpVisina * 2
        }

        viewModel.set("dolazimIzInit", true);

        var viewID = "#madbarzRoutines";
        scroller = e.view.scroller;

        scroller.bind("scroll", function(e) {
            var top = parseInt(e.scrollTop);

            if (Math.abs(top - lastTop) > visina){
                lastTop = top;
                bLazy.revalidate();
            }

        });

        viewModel.set("filterItemsCreated", false);
        viewModel.set("uCanTouchThis", false);

        $("#listOfRoutines").kendoMobileListView({
            dataSource: viewModel.routinesDataSource,

            fixedHeaders: false,
            headerTemplate: function(data) {
                console.log("--- header", data);
                if (data.value){
                    data.value = data.value.substring(2);
                    var tpl = kendo.template($("#routines-header-template").text());
                    return tpl(data);
                }
            },
            template: function(data) {
                var tpl = kendo.template($("#RoutineTemplate").text());
                return tpl(data);
            },
            endlessScroll: false
        });

        // for lazy loading images
        bLazy = new Blazy({
            offset: visina,
            success: function(ele){
                // Image has loaded
            },
            error: function(ele, msg){
                //console.log("error loading img", ele, msg);
                // pregazi defaultno da se vidi bar tekst
                $(ele).addClass("b-loaded noImage").removeClass("b-error");
            }
        });

        $(viewID).kendoTouch({
            filter: ".lButton, .rButton, .toWorkout, .filterButton, .arrow_box",

            touchstart: function(e) {
                //console.log("touchstart");

                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    if(scroller){
                        if (scroller.enabled){
                            scroller.disable();
                        }
                    }
                }else{
                    if(scroller){
                        if (!scroller.enabled) {
                            scroller.enable();
                        }
                    }
                }
            },
            tap: function(e) {
                //console.log("kendo tap");

                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                }else{
                    handleTap(e);
                }
            }
        });

        $("#filterModal .time-container").kendoTouch({
            tap: function (e) {
                e.preventDefault(); // da ne probija
                selectTime(e);
            }
        });

        prepareMobiscroll();

    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target.context;

        if ($(element).hasClass("lButton")) {
            mad.common.goBack();
        }else if ($(element).hasClass("arrow_box")) {
            hideTooltip();
        }else if ($(element).hasClass("rButton")) {
            mad.mobileApp.navigate("ui/workouts/saved/madbarzSavedWorkoutsList.html?origin=menu", "slide:left");
        }else if ($(element).hasClass("toWorkout")) {
            handleSelection(element);
        }else if ($(element).hasClass("filterButton")) {
            openModal();
        }
    }

    function handleSelection(element){
        var uidElement = $(element).parent();
        var selectedItem = viewModel.routinesDataSource.getByUid(uidElement.attr("data-uid"));

        if (!selectedItem.IsPro) {
            goToSelectedRoutine(selectedItem);
        } else {
            var checkIfUserHasAccesToProPromise = $.Deferred();
            checkIfUserHasAccesToProPromise.then(function (hasUserAccessToPRo) {
                if (hasUserAccessToPRo) {
                    goToSelectedRoutine(selectedItem);
                } else {
                    mad.viewModels.popups.viewModel.openModalWindow("proRutine", "Premium workout", "Only premium members can see this workout. Premium members:", "Learn more");
                }
            }).fail(function (err) {
                console.log("There has been some errr determing if user is pro or not: ", err);
                mad.viewModels.popups.viewModel.openModalWindow("proRutine", "Premium workout", "Only premium members can see this workout. Premium members:", "Learn more");
            });
            mad.common.hasUserAccessToPro(checkIfUserHasAccesToProPromise);
        }

    }

    function selectTime(e) {
        if (viewModel.common.ifOffline()) {
            mad.alerts.realTop0("You are currently offline");
            e.event.stopPropagation();
            return;
        }

        var inst = $("#routinesFilterMenu").mobiscroll("getInst");
        //with a little delay because it sometimes closes automatically
        setTimeout(function() {
            inst.show(false, false); // Call the show method with animate & focus
        }, 22);
    }

    function beforeShow(e){
        $("#madbarzRoutines").removeClass("transBack");
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e) {
        console.log("show view");

        viewModel.set("isFemale", checkIsFemale());

        viewModel.set("firstTimeHere", checkTutorial());

        mad.common.setActualView(); mad.common.addViewToHistory();

        if (mad.common.$actualViewID == "#madbarzRoutines"){
            kendo.bind($(mad.common.$actualViewID), viewModel);
        }

        var origin = e.view.params.origin;
        console.log("origin", origin);

        var winH = $(window).height();
        var winW = $(window).width();

        // ako se ne vraca s workouta
        if (origin != "madbarzWorkout"){
            $("#madbarzWorkoutsListContainer").css({
                "height": (winH + 2),
                "width": winW
            });

            $("#listOfRoutines").css({
                "width": winW
            });

            console.log("dolazi iz init",         viewModel.get("dolazimIzInit"));
            if (viewModel.get("dolazimIzInit")){
                viewModel.set("dolazimIzInit", false);
            }

            if (mad.common.isNullOrEmpty(viewModel.routinesDataSource)){
                console.log("viewModel.routinesDataSource je prazan - ucitaj rutine");
                loadRoutines();
            }else{
                console.log("viewModel.routinesDataSource nije prazan - applyFilter");

                $("#listOfRoutines").data("kendoMobileListView").setDataSource(viewModel.get("routinesDataSource"));
                applyFilter();
            }
        }
        if (origin == "exercising"){
            mad.common.removeLastFromHistory();
            mad.common.removeLastFromHistory();
        }
    }

    function afterShow(e) {
        viewModel.set("uCanTouchThis", true);
        mad.googleAnalytics.trackView("Workouts - Madbarz");

        if (viewModel.get("firstTimeHere")) {
            mad.local.appendUsernameTo("visitedMadbarzRoutines", mad.common.variables.username);
        }

        mad.appsFlyer.trackEvent("Madbarz Routines Screen Loaded")
    }

    function beforeHide(e){
        //$("#madbarzWorkout-muscles").hide();
        $("#madbarzRoutines").addClass("transBack");
    }

    function hideTooltip(){
        viewModel.set("firstTimeHere", false);
    }

    function checkTutorial() {
        return mad.common.checkTutorial("visitedMadbarzRoutines");
    }


    function loadRoutines(){

        console.log("load routines");

        var loadedRoutines = mad.local.loadMadbarzRoutines(),
            routines = loadedRoutines.data,
            expired = loadedRoutines.expired;

        if (navigator.connection.type == Connection.UNKNOWN ||
            navigator.connection.type == Connection.NONE) {
            viewModel.routinesDataSource = kendo.data.DataSource.create({ data: routines });
            viewModel.routinesDataSource.group({field: "IsTop"});
            viewModel.set("filterActivated", false);

            $("#listOfRoutines").data("kendoMobileListView").setDataSource(viewModel.get("routinesDataSource"));
            applyFilter();
        } else {
            if (expired || routines.length == 0) {
                mad.local.removeMadbarzRoutines();
                console.log("ponovno ucitavanje rutina");
                mad.models.routines.read().then(function () {
                    $("#listOfRoutines").data("kendoMobileListView").setDataSource(viewModel.get("routinesDataSource"));
                    applyFilter();
                });
            } else {
                console.log("rutine napunjene iz cachea");
                viewModel.routinesDataSource = kendo.data.DataSource.create({ data: routines });
                viewModel.routinesDataSource.group({field: "IsTop"});
                viewModel.set("filterActivated", false);

                $("#listOfRoutines").data("kendoMobileListView").setDataSource(viewModel.get("routinesDataSource"));
                applyFilter();             }
        }
    }

    function openModal(){
        viewModel.set("modalOpened", true);

        var modalID = $("#filterModal");
        var mv = modalID.data("kendoMobileModalView");

        var WheelValue = "";

        modalID.removeClass("hidden");
        mv.open();
        modalID.css("height", modalID.parent().height());
        $("#filterContainer").css("height", modalID.parent().height());
        mv.scroller.reset();

        var filterTags = document.getElementById('filterTags');
        var miscTags = document.getElementById('miscTags');

        if (!viewModel.get("filterItemsCreated")){
            viewModel.set("filterItemsCreated", true);
            createTagButtons(filterTags, "tag");
            assignTouchEventsToTags("#filterTags li");
            createTagButtons(miscTags, "misc");
            assignTouchEventsToTags("#miscTags li")
        }

        var filter = getFilter();

        if (filter.reset){
            // reset time
            $('#routinesFilterMenu').mobiscroll('setVal', "All durations");
            viewModel.set("selectedTime", "All durations");
            viewModel.set("selectedTimeValue", 1);

            // reset tags
            $("#filterTags li").removeClass("selected");
            // reset misc tags
            $("#miscTags li").removeClass("selected");

        }else {
            // handle time
            if (filter.workoutTimeRange == 1){
                WheelValue = 'All durations';
            }else if (filter.workoutTimeRange == 2){
                WheelValue = "5 - 15 MIN";
            }else if (filter.workoutTimeRange == 3){
                WheelValue = "16 - 25 MIN";
            }else if (filter.workoutTimeRange == 4){
                WheelValue = "25+ MIN";
            }
            $('#routinesFilterMenu').mobiscroll('setVal', WheelValue);
            viewModel.set("selectedTime", WheelValue);
            viewModel.set("selectedTimeValue", filter.workoutTimeRange);

            // handle tags - - - - - - - - -
            // remove all selected
            $("#filterTags li").removeClass("selected");
            $("#miscTags li").removeClass("selected");

            if (!mad.common.isNullOrEmpty(filter.selectedTags)) {
                _.forEach(filter.selectedTags, function (obj) {
                    if (obj == "Butt") { // jer guzica je na drugoj listi
                        $("#miscTags li[tag='" + obj + "']").addClass("selected");
                    }else if (obj == "Full body"){ // ako je full body selektiraj sve tagocve na misc listi
                        $("#miscTags li").addClass("selected");
                    }else{
                        $("#filterTags li[tag='" + obj + "']").addClass("selected");
                    }
                });
            }

            // handle misc tags
            if (!mad.common.isNullOrEmpty(filter.selectedMiscTags)) {
                _.forEach(filter.selectedMiscTags, function (obj) {
                    $("#miscTags li[tag='" + obj + "']").addClass("selected");
                });
            }

        }

        doFiltering();
    }

    function createTagButtons(container, which){

        var sortiraniTagovi;

        if ("tag" == which){
            sortiraniTagovi = _.sortBy(filterTAGs, 'order');
        }else{
            sortiraniTagovi = _.sortBy(filterMISCs, 'order');
        }

        _.forEach(sortiraniTagovi, function (obj, n) {
            var newLi = document.createElement("li");   // mora se uvijek kreirati novi node
            container.appendChild(newLi);
            newLi.innerText = obj.ime;
            var klase = "tagGumb";
            if (obj.selected){
                klase += " selected";
            }
            newLi.className = klase;
            newLi.setAttribute('tag', obj.tag);

            if ("misc" == which){
                newLi.setAttribute('type', obj.type);
            }
        });
    }

    function assignTouchEventsToTags(objekt){

        $(objekt).kendoTouch({
            tap: function(e) {
                e.preventDefault(); // da ne probija
                var element = e.touch.target.context;

                var tag = $(element).attr("tag");
                var lista = $(element).closest("ul");
                var listaMisc = lista.hasClass("miscTags");

                var selected = $(element).hasClass("selected");
                var fullBodyTag = $("#miscTags li[tag='Full body']");
                var fullBodyTagSelected  = fullBodyTag.hasClass("selected");

                if (tag == "Full body") { // ako je odabran Full body
                    if (!selected) { // i sad ce bit selektiran selektiraj sve tagove
                        $("#miscTags li").addClass("selected");
                    }else{
                        $("#miscTags li").removeClass("selected");
                    }
                }else{  // neki drugi tag
                    if (selected) { // ce biti odselektiran
                        if (listaMisc){ // a tag je na misc listi
                            $("#miscTags li[tag='Full body']").removeClass("selected"); // odselektiraj Full body
                        }
                    }else{ // je selektiran
                        if (listaMisc) { // a dio je misc liste
                            var selected = lista.find(".selected");
                            var numberOfSelected = selected.length + 1;
                            if (numberOfSelected == 7){ // i selektirani su svi tagovi
                                $("#miscTags li[tag='Full body']").addClass("selected"); // selektiraj Full body
                            }
                        }
                    }
                    $(element).toggleClass("selected");
                }
                doFiltering();
            }
        });
    }

    function doFiltering(){
        console.log("---- filtering -----");

        var selektiraniTagovi, selektiraniMiscTagovi, pozicijaGuzice;
        var filterValues = {};

        selektiraniTagovi = getSelectedTags();
        selektiraniMiscTagovi = getSelectedMiscTags(selektiraniTagovi);

        if (selektiraniTagovi.indexOf("Full body")<0){
            console.log("u selektiranim nema full body", selektiraniTagovi, selektiraniMiscTagovi);
        }else{
            selektiraniMiscTagovi = [];
            console.log("u selektiranim IMA full body", selektiraniTagovi, selektiraniMiscTagovi);
            // vidi jel ima Butt i izbaci ga
            pozicijaGuzice = selektiraniTagovi.indexOf("Butt");
            if (pozicijaGuzice > -1) {
                selektiraniTagovi.splice(pozicijaGuzice, 1);
                console.log("u selektiranim je bila i guzica sad je vise nema", selektiraniTagovi);
            }
        }

        // drazen - spremi u viewmodel sve sto je setirano
        filterValues.reset = false;                         // means apply filter
        filterValues.workoutTimeRange = viewModel.get("selectedTimeValue");
        filterValues.selectedTags = selektiraniTagovi;
        filterValues.selectedMiscTags = selektiraniMiscTagovi;
        viewModel.set("filterValues", filterValues);

        //console.log("filter je", filterValues);

        viewModel.routinesDataSource.group([]); // makni grupe
        viewModel.set("filterActivated", true);


        var applyFilter = setFilter(filterValues);

        viewModel.routinesDataSource.filter(applyFilter);

        updateNumbers(); //of filtered records

    }

    function getSelectedTags(){
        var rez = [];
        $("#filterTags .selected").each(function(){
            rez.push( $(this).attr("tag"));
        });
        return rez;
    }

    function getSelectedMiscTags(tagsArray){
        var rez = [];
        $("#miscTags .selected").each(function(){
            var tagJe = $(this).attr("tag");
            var typeJe = $(this).attr("type");
            if ("muscle" == typeJe){
                rez.push(parseInt(tagJe));
            }else{
                tagsArray.push(tagJe);
            }
        });
        return rez;
    }

    function filterByTag(tagovi, selektiraniTagovi) {
        if (selektiraniTagovi.length == 0){
            return true
        }
        return _.every(selektiraniTagovi, function (value) {
            var sadrzi = tagovi.filter(function(tag){ return tag.Name === value });
            return sadrzi.length>0;    // vrati true ako tag iz rutine odgovara selektiranom tagu
        });
    }

    function filterByMuscles(tagovi, selektiraniTagovi) {
        if (selektiraniTagovi.length == 0){
            return true
        }
        return _.every(selektiraniTagovi, function (value) {
            var sadrzi = tagovi.filter(function(tag){ return tag === value });
            return sadrzi.length>0;    // vrati true ako tag iz rutine odgovara selektiranom tagu
        });
    }


    /*
    function updateNumbers(){
        if (viewModel.routinesDataSource.length == 0){
            return
        }
        //update number of filtered data(on filter button & beside filter icon)
        var selected;
        selected = viewModel.routinesDataSource.view().length;
        viewModel.set("brojPodataka", selected);
        var zerofilled = ('00'+selected).slice(-2);    // zadnja 2

        $(".saveFilter").addClass("efekt");
        $(".saveFilter .value").text(""+zerofilled+"");

        setTimeout(function () {
            $(".saveFilter").removeClass("efekt");
        }, 333);
    }
    */
    function updateNumbers(){
        console.log("updateNumbers");
        if (viewModel.routinesDataSource.length == 0){
            return
        }

        var view = viewModel.routinesDataSource.view();
        var selected = view.length;
        var top, rest;
        var topCount, restCount;

        console.log("updateNumbers - filter je reset");
        if (selected == 2){
            console.log("updateNumbers - filter je reset - selected je 2");
            top = view[0];
            rest = view[1];
            console.log ("lista se sastoji od", top.value, rest.value);
            if (top.value == "TOP 3"){
                topCount = top.items.length;
                restCount = rest.items.length;
                selected = topCount + restCount;
            }
        }
        viewModel.set("brojPodataka", selected);

        var zerofilled = ('00'+selected).slice(-2);    // zadnja 2

        $(".saveFilter").addClass("efekt");
        $(".saveFilter .value").text(""+zerofilled+"");

        setTimeout(function () {
            $(".saveFilter").removeClass("efekt");
        }, 333);
    }

    function closeModal(){
        viewModel.set("modalOpened", false);

        var modalID = $("#filterModal");
        var mv = modalID.data("kendoMobileModalView");
        mv.close();

        modalID.addClass("hidden");

        bLazy.revalidate();
    }

    function closeFilter(){
        applyFilter();
        closeModal();
    }

    function saveFilter(){
        var brp = viewModel.get("brojPodataka");
        if (brp == 0 || brp== ""){
            mad.alerts.error("No results, please filter again","");
        }else{
            // spremi filter parametre i zatvori
            mad.local.saveVariableParse("routines-filter", viewModel.get("filterValues"));
            closeModal();
            mad.common.scrollViewToTop();
        }
    }

    function applyFilter() {
        timeStart = new Date().getTime();

        var filter = getFilter();
        var applyFilter;

        if (filter.reset){
            applyFilter = filterOFF;
            viewModel.routinesDataSource.group({field: "IsTop"});  // postavi grupe
            viewModel.set("filterActivated", false);
        }else{
            filterON.value = filter;
            applyFilter = setFilter(filter);

            viewModel.routinesDataSource.group([]); // makni grupe
            viewModel.set("filterActivated", true);
        }

        console.log("lista rutina", viewModel.routinesDataSource);

        viewModel.routinesDataSource.filter(applyFilter);

        if (mad.common.isNullOrEmpty(viewModel.routinesDataSource)){
            viewModel.set("brojPodataka", 0);
        }else{
            var view = viewModel.routinesDataSource.view();
            var selected = view.length;
            var top, rest;
            var topCount, restCount;

            if (selected == 2){
                top = view[0];
                rest = view[1];
                console.log ("lista se sastoji od", top.value, rest.value);
                if (top.value == "TOP 3"){
                    topCount = top.items.length;
                    restCount = rest.items.length;
                    selected = topCount + restCount;
                }
            }
            viewModel.set("brojPodataka", selected);
            //viewModel.set("brojPodataka", viewModel.routinesDataSource.view().length);
        }

        mad.common.scrollViewToTop();

        mad.googleAnalytics.trackEvent("Used Filter", "Click - Workout Filter", filter);

        console.log("applyFilter gotov", new Date().getTime() - timeStart);

        bLazy.revalidate();

    }

    function getFilter(){
        // loads saved filter values
        var savedFilterValues = mad.local.loadVariableParse("routines-filter");
        if (mad.common.isNullOrEmpty(savedFilterValues)){
            viewModel.filterValues.set("reset", true);
        }else{
            viewModel.set("filterValues", savedFilterValues);
        }
        return viewModel.get("filterValues");
    }

    function setFilter(filter){
        var filterTime, timeFrom, timeTo, rez;

        console.log("filter input", filter);
        filterTime = parseInt(filter.workoutTimeRange);
        if (filterTime == 1) {
            timeFrom = 0;
            timeTo = 999;
        }else if (filterTime == 2){
                timeFrom = 0;
                timeTo = 15;
        }else if (filterTime == 3){
            timeFrom = 16;
            timeTo = 25;
        }else{
            timeFrom = 26;
            timeTo = 999;
        }
        rez =  {
            logic: "and",
            filters: [
                {
                    logic: "and",
                    filters: [
                        { field: "AvgWorkoutTimeInMinutes", operator: "gte", value: timeFrom },
                        { field: "AvgWorkoutTimeInMinutes", operator: "lte", value:  timeTo}
                    ]
                },
                {
                    field: "Tags",
                    operator: function (Tags) {
                        var selectedTags = viewModel.get("filterValues.selectedTags");
                        if (!selectedTags){
                            //console.log("selektiraniTagovi jos nisu definirani vrati true");
                            return true
                        }
                        if (!Tags){
                            //console.log("nema Tags - vrati false");
                            return false;
                        }
                        return filterByTag(Tags, selectedTags);
                    }
                },
                {
                    field: "MuscleGroupIds",
                    operator: function (Tags) {
                        var selectedTags = viewModel.get("filterValues.selectedMiscTags");
                        if (!selectedTags){
                            //console.log("selektiraniTagovi jos nisu definirani vrati true");
                            return true
                        }
                        if (!Tags){
                            //console.log("nema Tags - vrati false");
                            return false;
                        }
                        return filterByMuscles(Tags, selectedTags);
                    }
                }

            ]
        };
        console.log("filter output", rez);
        return rez;

    }

    function goToSelectedRoutine(routine) {
        mad.viewModels.madbarzWorkout.viewModel.set("workoutType", "Madbarz");
        viewModel.set("selectedWorkout", routine);
        mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkout.html", "fade");
    }

    function resetFilter(){
        $('#routinesFilterMenu').mobiscroll("setVal", "All durations");
        viewModel.set("selectedTime", "All durations");
        viewModel.set("selectedTimeValue", 1);

        $("#filterTags li").removeClass("selected");
        $("#miscTags li").removeClass("selected");

        viewModel.filterValues.set("reset", true);

        mad.local.saveVariableParse("routines-filter", viewModel.get("filterValues"));
        closeFilter();

        mad.common.scrollViewToTop();
    }

    function prepareMobiscroll() {
        var theme = $.mobiscroll.defaults.theme,
            mode = "static",
            display = "bottom",
            lang = "hr";

        var podaci = [// Wheel groups array
            [
                { // Wheel object
                    values: ["5 - 15 MIN", "16 - 25 MIN", "25+ MIN", "All durations"]
                }
            ]
        ];

        $("#routinesFilterMenu").mobiscroll({
            theme: theme,
            mode: mode,
            display: display,
            buttons: [],
            lang: lang,
            showLabel: false,
            showInput: false,
            wheels: podaci,
            height: 60,
            rows: 4,
            readonly: false,
            group: false,
            layout: "liquid",
            onShow: function (html, valueText, inst) {

                html.addClass("routinesFilterMenuOpened");

                var winH = $(window).height();
                var dialogEl = html.find("[role='dialog']");
                var dialogElHight = dialogEl.height();
                // korigiraj top poziciju
                dialogEl.css({"top": winH - dialogElHight});

            },
            onValueTap: function (item, inst) {

                viewModel.set("selectedTime", item.context.textContent);
                // ? mad.local.saveVariable("selectedTime", item.context.textContent);

                // prepare & fetch data
                if (item.context.textContent == "All durations") {
                    viewModel.set("selectedTimeValue", 1);
                }else if (item.context.textContent == "5 - 15 MIN") {
                    viewModel.set("selectedTimeValue", 2);
                } else if (item.context.textContent == "16 - 25 MIN") {
                    viewModel.set("selectedTimeValue", 3);
                } else if (item.context.textContent == "25+ MIN") {
                    viewModel.set("selectedTimeValue", 4);
                }
                inst.hide(false, "set");

                doFiltering();

            }
        });

    }

    function checkIsFemale() {
        console.log("comm vars", mad.common.variables);
        return (mad.common.variables.gender == "f");
    }

    return {
        viewModel: viewModel
    };

}());

