var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.madbarzRoutines = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        beforeShow: beforeShow,
        beforeHide: beforeHide,
        show: showView,
        afterShow: afterShow,
        uCanTouchThis: false,
        selectedWorkout: {},
        tags: [],
        routines: [],
        routinesDataSource: {},
        brojPodataka: "",
        modalOpened: false,
        filterValues: {},
        filterItemsCreated: false,
        selectedTime: selectedTime,
        selectedTimeValue: 0,
        closeFilter: closeFilter,
        resetFilter: resetFilter,
        saveFilter: saveFilter
    });

    /*
    var filterTAGs = [
        {
            ime: 'Upper body',
            tag: 'UPPER',
            order: 1,
            selected: false
        },
        {
            ime: 'Lower body',
            tag: ' LOWER',
            order: 2,
            selected: false
        },
        {
            ime: 'Core',
            tag: 'Core',
            order: 3,
            selected: true
        },
        {
            ime: 'No equipment',
            tag: 'No equipment',
            order: 4,
            selected: false
        },
        {
            ime: 'Silent',
            tag: 'QUIET',
            order: 5,
            selected: false
        },
        {
            ime: 'Female choice',
            tag: 'FEMALE',
            order: 6,
            selected: false
        },
        {
            ime: 'Male choice',
            tag: 'MALE',
            order: 7,
            selected: false
        }
    ];
    */
    var filterTAGs = [
        {
            ime: 'Upper body',
            tag: 'Upper body',
            order: 1,
            selected: false
        },
        {
            ime: 'Lower body',
            tag: 'Lower body',
            order: 2,
            selected: false
        },
        {
            ime: 'No equipment',
            tag: 'No equipment',
            order: 4,
            selected: false
        },
        {
            ime: 'Fat burn',
            tag: 'Fat burn',
            order: 5,
            selected: false
        },
        {
            ime: 'Abs',
            tag: 'Abs',
            order: 3,
            selected: false
        }
    ];

    var filterON = {};
    var filterOFF = {};

    var timeStart;

    var scroller;

    function initView(e) {
        var viewID = "#madbarzRoutines";
        scroller = e.view.scroller;

        viewModel.set("filterItemsCreated", false);
        viewModel.set("uCanTouchThis", false);

        $(viewID).kendoTouch({
            filter: ".lButton, .toWorkout, .filterButton",
            touchstart: function(e) {
                //console.log("touchstart");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    //console.log("touchstart but canceled")
                    if(scroller){
                        if (scroller.enabled){
                            scroller.disable();
                        }
                    }
                }else{
                    if(scroller){
                        if (!scroller.enabled) {
                            scroller.enable();
                        }
                    }
                }
            },
            tap: function(e) {
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                }else{
                    handleTap(e);
                }
            }
        });
        readRoutines();
    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target.context;

        if ($(element).hasClass("lButton")) {
            mad.common.goBack();
        }else if ($(element).hasClass("toWorkout")) {
            handleSelection(element);
        }else if ($(element).hasClass("filterButton")) {
            openModal();
        }
    }

    function handleSelection(element){
        var uidElement = $(element).parent();
        var selectedItem = viewModel.routinesDataSource.getByUid(uidElement.attr("data-uid"));

        if (!selectedItem.IsPro) {
            goToSelectedRoutine(selectedItem);
        } else {
            var checkIfUserHasAccesToProPromise = $.Deferred();
            checkIfUserHasAccesToProPromise.then(function (hasUserAccessToPRo) {
                if (hasUserAccessToPRo) {
                    goToSelectedRoutine(selectedItem);
                } else {
                    mad.viewModels.popups.viewModel.openModalWindow("proRutine", "Premium workout", "Only premium members can see this workout. Premium members:", "Learn more");
                }
            }).fail(function (err) {
                console.log("There has been some errr determing if user is pro or not: ", err);
                mad.viewModels.popups.viewModel.openModalWindow("proRutine", "Premium workout", "Only premium members can see this workout. Premium members:", "Learn more");
            });
            mad.common.hasUserAccessToPro(checkIfUserHasAccesToProPromise);
        }

    }

    function beforeShow(e){
        $("#madbarzRoutines").removeClass("transBack");
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e) {
        //console.log("show madbarz workouts");
        mad.common.setActualView(); mad.common.addViewToHistory();
        //mad.common.stretchViewContentToBeElastic();

        if (mad.common.$actualViewID == "#madbarzRoutines"){
            kendo.bind($(mad.common.$actualViewID), viewModel);
        }

        var origin = e.view.params.origin;
        console.log("origin", origin);

        var winH = $(window).height();
        var winW = $(window).width();

        // ako se ne vraca s workouta
        if (origin != "madbarzWorkout"){
            $("#madbarzWorkoutsListContainer").css({
                "height": (winH + 2),
                "width": winW
            });

            if (mad.common.isNullOrEmpty(viewModel.routinesDataSource)){
                readRoutines();
            }else{
                applyFilter();
            }
        }
        if (origin == "exercising"){
            mad.common.removeLastFromHistory();
            mad.common.removeLastFromHistory();
        }
    }

    function afterShow(e) {
        viewModel.set("uCanTouchThis", true);
        mad.googleAnalytics.trackView("Workouts - Madbarz");
    }

    function beforeHide(e){
        //$("#madbarzWorkout-muscles").hide();
        $("#madbarzRoutines").addClass("transBack");
    }

    function readRoutines(){

        /*
        timeStart = new Date().getTime();
        console.log("ucitavanje rutina");
        */

        var loadedRoutines = mad.local.loadMadbarzRoutines(),
            routines = loadedRoutines.data,
            expired = loadedRoutines.expired;

        if (navigator.connection.type == Connection.UNKNOWN ||
            navigator.connection.type == Connection.NONE) {
            viewModel.set("routines", routines);
            createListOfRoutines();
        } else {
            if (expired || routines.length == 0) {
                console.log("idem ucitat rutine sa servera");
                mad.local.removeMadbarzRoutines();
                mad.models.routines.read().then(function () {
                    createListOfRoutines();
                });
            } else {
                viewModel.set("routines", routines);
                createListOfRoutines();
            }
        }
    }

    function createListOfRoutines() {
        viewModel.routinesDataSource = kendo.data.DataSource.create({ data: viewModel.get("routines") });

        //console.log("kreirana lista rutina", new Date().getTime() - timeStart);

        //applyFilter();      // za prvi put kad ne dohvaca iz cachea jer se applyFilter u showView izvršiti prije no što se podaci dohvate

        $("#listOfRoutines").kendoMobileListView({
            dataSource: viewModel.routinesDataSource,
            template: $("#RoutineTemplate").text(),
            endlessScroll: false
        });

        applyFilter();      // za prvi put kad ne dohvaca iz cachea jer se applyFilter u showView izvršiti prije no što se podaci dohvate
    }

    function openModal(){
        viewModel.set("modalOpened", true);

        var modalID = $("#filterModal");
        var mv = modalID.data("kendoMobileModalView");

        modalID.removeClass("hidden");
        mv.open();
        modalID.css("height", modalID.parent().height());
        $("#filterContainer").css("height", modalID.parent().height());
        mv.scroller.reset();

        var buttongroup = $("#timeIntervals").data("kendoMobileButtonGroup");
        var filterTags = document.getElementById('filterTags');

        if (!viewModel.get("filterItemsCreated")){
            viewModel.set("filterItemsCreated", true);
            createTagButtons(filterTags);
            assignTouchEventsToTags("#filterTags li")
        }

        var filter = getFilter();

        if (filter.reset){
            buttongroup.select(1);
            viewModel.set("selectedTimeValue", 1);

            $("#filterTags li").removeClass("selected");
        }else {
            buttongroup.select(filter.workoutTimeRange);
            viewModel.set("selectedTimeValue", filter.workoutTimeRange);

            $("#filterTags li").removeClass("selected");
            if (!mad.common.isNullOrEmpty(filter.selectedTags)) {
                _.forEach(filter.selectedTags, function (obj) {
                    $("#filterTags li[tag='" + obj + "']").addClass("selected");
                });
            }
        }

        doFiltering();
    }

    function createTagButtons(container){

        var sortiraniTagovi = _.sortBy(filterTAGs, 'order');

        _.forEach(sortiraniTagovi, function (obj, n) {
            var newLi = document.createElement("li");   // mora se uvijek kreirati novi node
            container.appendChild(newLi);
            newLi.innerText = obj.ime;
            var klase = "tagGumb";
            if (obj.selected){
                klase += " selected";
            }
            newLi.className = klase;
            newLi.setAttribute('tag', obj.tag);
        });
    }

    function assignTouchEventsToTags(objekt){

        $(objekt).kendoTouch({
            tap: function(e) {
                e.preventDefault(); // da ne probija
                var element = e.touch.target.context;
                $(element).toggleClass("selected");
                doFiltering();
            }
        });
    }

    function selectedTime(e){
        var index = this.current().index();
        viewModel.set("selectedTimeValue", index);
        doFiltering();
    }

    function getSelectedTags(){
        var rez = [];
        $("#filterTags .selected").each(function(){
            rez.push( $(this).attr("tag"));
        });
        return rez;
    }

    function doFiltering(){
        console.log("---- filtering -----");

        var selektiraniTagovi;
        var filterValues = {};

        selektiraniTagovi = getSelectedTags();
        //console.log("selektiraniTagovi", selektiraniTagovi);

        // drazen - spremi u viewmodel sve sto je setirano
        filterValues.reset = false;                         // means apply filter
        filterValues.workoutTimeRange = viewModel.get("selectedTimeValue");
        filterValues.selectedTags = selektiraniTagovi;
        viewModel.set("filterValues", filterValues);

        var applyFilter = setFilter(filterValues);

        viewModel.routinesDataSource.filter(applyFilter);   // resetira b-loaded

        updateNumbers(); //of filtered records

    }

    function filterByTag(tagovi, selektiraniTagovi) {
        if (selektiraniTagovi.length == 0){
            return true
        }
        return _.every(selektiraniTagovi, function (value) {
            var sadrzi = tagovi.filter(function(tag){ return tag.Name === value });
            return sadrzi.length>0;    // vrati true ako tag iz rutine odgovara selektiranom tagu
        });
    }

    function updateNumbers(){
        if (viewModel.routinesDataSource.length == 0){
            return
        }
        //update number of filtered data(on filter button & beside filter icon)
        var selected;
        selected = viewModel.routinesDataSource.view().length;
        viewModel.set("brojPodataka", selected);
        var zerofilled = ('00'+selected).slice(-2);    // zadnja 2

        $(".saveFilter").addClass("efekt");
        $(".saveFilter .value").text("("+zerofilled+")");

        setTimeout(function () {
            $(".saveFilter").removeClass("efekt");
        }, 333);
        /*
        $(".saveFilter .value").addClass("zavrti");
        setTimeout(function () {
            $(".saveFilter .value").text("("+zerofilled+")").removeClass("zavrti");
        }, 333);
        */

        //console.log("filrirano", selected);
    }

    function closeModal(){
        viewModel.set("modalOpened", false);

        var modalID = $("#filterModal");
        var mv = modalID.data("kendoMobileModalView");
        mv.close();

        modalID.addClass("hidden");
    }

    function closeFilter(){
        applyFilter();
        closeModal();
    }

    function saveFilter(){
        var brp = viewModel.get("brojPodataka");
        if (brp == 0 || brp== ""){
            mad.alerts.error("No results, please filter again","");
        }else{
            // spremi filter parametre i zatvori
            mad.local.saveVariableParse("routines-filter", viewModel.get("filterValues"));
            closeModal();
            mad.common.scrollViewToTop();
        }
    }

    function applyFilter() {
        timeStart = new Date().getTime();

        console.log("primjenjujem filter");

        var filter = getFilter();
        var applyFilter;


        if (filter.reset){
            applyFilter = filterOFF;
        }else{
            filterON.value = filter;
            applyFilter = setFilter(filter);
        }
        //console.log("filter za apply je", applyFilter);

        viewModel.routinesDataSource.filter(applyFilter);

        /*
        if (filter.reset){
            viewModel.set("brojPodataka", "all");
        }else{
            if (mad.common.isNullOrEmpty(viewModel.routinesDataSource)){
                viewModel.set("brojPodataka", 0);
            }else{
                viewModel.set("brojPodataka", viewModel.routinesDataSource.view().length);
            }
        }
        */
        if (mad.common.isNullOrEmpty(viewModel.routinesDataSource)){
            viewModel.set("brojPodataka", 0);
        }else{
            viewModel.set("brojPodataka", viewModel.routinesDataSource.view().length);
        }

        mad.common.scrollViewToTop();

        mad.googleAnalytics.trackEvent("Used Filter", "Click - Workout Filter", filter);

        console.log("applyFilter gotov", new Date().getTime() - timeStart);
    }

    function getFilter(){
        // loads saved filter values
        var savedFilterValues = mad.local.loadVariableParse("routines-filter");
        if (mad.common.isNullOrEmpty(savedFilterValues)){
            viewModel.filterValues.set("reset", true);
        }else{
            viewModel.set("filterValues", savedFilterValues);
        }
        //console.log("getFilter vrijednosti spremljenog filtera su", viewModel.get("filterValues"));
        return viewModel.get("filterValues");
    }

    function setFilter(filter){
        var filterTime, timeFrom, timeTo;

        filterTime = parseInt(filter.workoutTimeRange);
        if (filterTime == 0){
            timeFrom = 0;
            timeTo = 15;
        }else if (filterTime == 1){
            timeFrom = 16;
            timeTo = 25;
        }else{
            timeFrom = 26;
            timeTo = 999;
        }
        /*
        console.log("set filter - input", filter);
        console.log("time from", timeFrom);
        console.log("time to", timeTo);
        */
        return  {
            logic: "and",
            filters: [
                {
                    logic: "and",
                    filters: [
                        { field: "AvgWorkoutTimeInMinutes", operator: "gte", value: timeFrom },
                        { field: "AvgWorkoutTimeInMinutes", operator: "lte", value:  timeTo}
                    ]
                },
                {
                    field: "Tags",
                    operator: function (Tags) {
                        var selectedTags = viewModel.get("filterValues.selectedTags");
                        if (!selectedTags){
                            //console.log("selektiraniTagovi jos nisu definirani vrati true");
                            return true
                        }
                        if (!Tags){
                            //console.log("nema Tags - vrati false");
                            return false;
                        }
                        return filterByTag(Tags, selectedTags);
                    }
                }
            ]
        };

    }

    function goToSelectedRoutine(routine) {
        mad.viewModels.madbarzWorkout.viewModel.set("workoutType", "Madbarz");
        viewModel.set("selectedWorkout", routine);

        //mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkout.html", "slide:left");
        //mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkout.html", "overlay:left");
        mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkout.html", "fade");
    }

    function resetFilter(){
        var buttongroup = $("#timeIntervals").data("kendoMobileButtonGroup");
        buttongroup.select(1);
        viewModel.set("selectedTimeValue", 1);

        $("#filterTags li").removeClass("selected");

        viewModel.filterValues.set("reset", true);

        mad.local.saveVariableParse("routines-filter", viewModel.get("filterValues"));
        closeFilter();

        mad.common.scrollViewToTop();
    }

    return {
        viewModel: viewModel
    };

}());

