var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.madbarzWorkoutsFilter = (function () {

   "use strict";

   var viewModel = kendo.observable({ 
       // properties or functions we want to observe and expose to html
       common: mad.common.observables,

       init: initView,
       beforeShow: beforeShow,
       show: showView,
       afterShow: afterShow,

       uCanTouchThis: false,

       selectedTagName: "",
       selectedTag: ""
   });


    function initView(e){
        var viewID = "#madbarzWorkoutsFilter";

        viewModel.set("uCanTouchThis", false);

        var scroller = e.view.scroller;

        $(viewID).kendoTouch({
            filter: ".lButton, .filterSelected",
            touchstart: function(e) {
                //console.log("touchstart");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    //console.log("touchstart but canceled")
                    if(scroller){
                        if (scroller.enabled){
                            scroller.disable();
                        }
                    }
                }else{
                    if(scroller){
                        if (!scroller.enabled) {
                            scroller.enable();
                        }
                    }
                }
            },
            tap: function(e) {
                //console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    //console.log("but canceled")
                }else{
                    handleTap(e);
                }
            }
        });


        generateListOfFilters();
    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target;

        if ($(element).hasClass("lButton")) {
            mad.common.goBack();
        }else if ($(element).hasClass("filterSelected")) {
            if (!checkifOnline()) {
                mad.alerts.realTop0("You are currently offline");
            }else{
                handleSelection(element);
            }

        }
    }

    function handleSelection(element){
        console.log("selected", element);
        var selectedTag = element.attr("data-value");
        var selectedTagName = element.attr("data-displayvalue");

        var listElement = $(element).parent();

        mad.viewModels.madbarzWorkoutsFilter.viewModel.set("selectedTag",selectedTag);
        mad.viewModels.madbarzWorkoutsFilter.viewModel.set("selectedTagName",selectedTagName);

        listElement.find(".k-state-selected").removeClass('k-state-selected');
        $(element).addClass('k-state-selected');

        var data = {
            "Filter name": selectedTag
        };
        mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.FB], mad.analyticEvents.categories.QUICKWORKOUT, mad.analyticEvents.types.EVENT,
            "Quick workout - Filter Selected",
            data,
            "Quick workout",
            "Filter Selected");

        mad.mobileApp.navigate("ui/workouts/madbarz/madbarzWorkoutsList.html?origin=filter", "slide:left");
    }

    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e){
        mad.common.setActualView(); mad.common.addViewToHistory(); setupView();
        kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    function afterShow(e){
        viewModel.set("uCanTouchThis", true);

        mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.FB], mad.analyticEvents.categories.QUICKWORKOUT, mad.analyticEvents.types.VIEW,
            "Quick workout screen loaded",
            null,
            "Quick workout screen loaded",
            "Screen loaded");
    }

    function setupView(id){
        mad.common.setActualViewTitle();
        mad.common.stretchViewContentToBeElastic();

        /*
        var contentHeight = Math.ceil(mad.mobileApp.view().content.height());
        $("#madbarzWorkoutsFilterContainer").css("height", contentHeight+3);
        */

        /*
        mad.common.setResolutionForView(parseInt(mad.mobileApp.view().content.width()), parseInt(mad.mobileApp.view().content.height()));
        mad.common.setLangForView();
        */
    }

    function checkifOnline() {
        return viewModel.common.ifOnline();
    }

    function generateListOfFilters(){
        //console.log("generateListOfFilters");

        var template = kendo.template($("#filterData").html(), {useWithBlock:false});
        var data = [{
            "RoutineTagId": 8,
            "Name": "Full body",
        }, {
            "RoutineTagId": 6,
            "Name": "Chest",
        }, {
            "RoutineTagId": 3,
            "Name": "Arms",
        }, {
            "RoutineTagId": 10,
            "Name": "Legs",
        }, {
            "RoutineTagId": 4,
            "Name": "Back",
        }, {
            "RoutineTagId": 2,
            "Name": "Abs",
        }, {
            "RoutineTagId": 12,
            "Name": "Shoulders",
        }, {
            "RoutineTagId": 13,
            "Name": "Hardcore",
        }, {
            "RoutineTagId": 0,
            "Name": "All",
        }];


        var result = template(data);          //Pass the muscle data to the compiled template
        $("#filters").html(result);

        mad.viewModels.madbarzWorkoutS.viewModel.set("tags", data);

    }

    return {
        viewModel: viewModel
    }

}());

