var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.editReps = (function () {

    "use strict";

    var viewModel = kendo.observable({
        common: mad.common.observables,
        init: initView,
        beforeShow: beforeShow,
        show: showView,
        afterShow: afterShow,

        leftButtonAction: leftButtonAction,
        checkEnter: checkEnter,
        inputChanged: inputChanged,

        titlePressed: mad.common.titlePressed,

        selectedExercise: {
            Name: "",
            NewValue: 0
        },

        done: leftButtonAction,

        uCanTouchThis: false
    });


    function initView(e){
        var viewID = "#editReps";
        viewModel.set("uCanTouchThis", false);

        $(viewID).kendoTouch({
            filter: ".lButton, .save",
            touchstart: function(e) {
                console.log("touchstart");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    console.log("touchstart but canceled")
                }
            },
            tap: function(e) {
                console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    console.log("but canceled")
                }else{
                    handleTap(e);
                }
            }
        });
    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target;

        if ($(element).hasClass("lButton") || $(element).hasClass("save")) {
            goBack();
        }
    }

    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e){
        console.log("on show editReps --");
        viewModel.set("selectedExercise",mad.viewModels.madbarzWorkout.viewModel.get("selectedExercise"));  // copy exercise from madbarzWorkout

        mad.common.setActualView();
        setupView();

        kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    function afterShow(e) {
        viewModel.set("uCanTouchThis", true);

        $("#repsContainer").css("width", mad.common.actualView.content.width()); // ovo je bitno jer se nece dobro posloziti widget
        $("#EditWorkoutValPicker").data("kendoValuePicker").initNumbers();

        mad.googleAnalytics.trackView("Workouts - Edit Reps");

    }

    /* not in viewModel Context  - - - - - -  */
    function setupView(){
        mad.common.stretchView();
        //mad.common.setResolutionForView(parseInt(mad.mobileApp.view().content.width()), parseInt(mad.mobileApp.view().content.height()));
        //mad.common.setLangForView();
        setViewTitle();
    }

    function leftButtonAction(e){
        if (e){
            e.preventDefault();     // da ne probija
        }

        $("#editRepsField").blur();

        mad.viewModels.madbarzWorkout.viewModel.set("selectedExercise", viewModel.get("selectedExercise"));
        $(".madbarz-value-picker-list").empty();    // brisi elemente liste
        mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkout.html?origin=editReps");
    }

    function goBack(){
        $("#editRepsField").blur();

        mad.viewModels.madbarzWorkout.viewModel.set("selectedExercise", viewModel.get("selectedExercise"));
        $(".madbarz-value-picker-list").empty();    // brisi elemente liste
        mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkout.html?origin=editReps");
    }

    function inputChanged(e) {
        var brj = parseInt(viewModel.get("selectedExercise.NewValue"));
        if (brj > 3600){
            viewModel.set("selectedExercise.NewValue", 3600);
        }
    }

    function checkEnter(e) {
        console.log("checkEnter");
        if (e.keyCode == 13) {
            leftButtonAction(e);
        }
    }

    function setViewTitle(){
        var naslov = "Edit";
        mad.common.actualView.title = naslov;
        mad.common.actualView.header
            .find(".km-navbar")
            .data("kendoMobileNavBar").title(naslov);
    }

    return {
        viewModel: viewModel
    };

}());

