var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.madbarzExercising = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,
        counters: mad.viewModels.madbarzWorkout.viewModel.counters,
        init: initView,
        beforeShow: beforeShow,
        show: showView,
        afterShow: afterShow,
        transitionStart: transitionStart,
        transitionEnd: transitionEnd,
        workoutImg: getWorkoutImg,
        question: question,
        elapsedTimeVisible: prikazTrajanjaVjezbeVidljiv,
        workoutTimeVisible: prikazTrajanjaWorkoutaVidljiv,
        displayCycles: displayCycles,
        displayExercises: displayExercises,
        displayRoundStarted: displayRoundStarted,
        displayRoundFinished: displayRoundFinished,

        isCounting: isCounting,
        isStarted: isStarted,
        isExerciseDone: isExerciseDone,
        isCameToEnd: isCameToEnd,
        exerciseDoneAndCameToEnd: exerciseDoneAndCameToEnd,
        exerciseDoneAndNotCameToEnd: exerciseDoneAndNotCameToEnd,
        isFirstInRound: isFirstInRound,
        isLastInRound: isLastInRound,
        savingWorkout: false,

        totalWorkoutTime: showTotalTime,
        totalWorkoutTimeDisplay: showTotalTimeDisplay,
        totalPauseTime: showTotalPauseTime,
        pauseTime: showPauseTime,
        getNextExerciseValue: getNextExerciseValue,
        getNextExerciseImg: getNextExerciseImg,
        inTransition: false,
        selectedExercise: {},
        odbrojavanje: "",
        status: "initial",
        muteStatus: false,
        pauseStoppedStatus: false,
        pauseStoppedAt: 0,

        workoutTimerActive: false,
        workoutStoppedAt: 0,

        uCanTouchThis: false,

        viewHeight: 999,
        isTest: false,
        isTapWhenDoneVisible: false,                  //refers to footer button
        isNextVisible: false,
        confirmOpened: false,
        resumeCounter: resumeCounter
    });

    var kendoValuePickerInitialized = false;

    // update heights when status change
    viewModel.bind("change", function(e) {
        if (e.field == "status"){
            setTimeout(function () {
                updateHeights();
            }, 1);
        }
    });

    var odbrojavanje = kendo.observable({
        brojac: new mad.common.countdownTimer(5, 0, countdown)
    });

    var vjezbanje = kendo.observable({
        brojac: new mad.common.simpleTimer(trajanjeVjezbanja)
    });

    function initView(e){
        //bind to countdownTimer events
        mad.viewModels.madbarzExercising.odbrojavanje.bind("started", pocetakOdbrojavanja);
        mad.viewModels.madbarzExercising.odbrojavanje.bind("finished", zavrsetakOdbrojavanja);

        var viewID = "#madbarzExercising";

        viewModel.set("uCanTouchThis", false);

        $(viewID).kendoTouch({
            filter: ".quitButton, .video-placeholder, .bottom-container, .exercising-timer, .skipPause, .tapButton, .finishButton, .nextInfo, .mute, .pause",
            touchstart: function(e) {
                //console.log("touchstart");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    console.log("touchstart but canceled")
                }
            },
            tap: function(e) {
                //console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    console.log("but canceled")
                }else{
                    handleTap(e);
                }
            }
        });
    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var pauseStopped, inTransition;
        var element = e.touch.target;

        if ($(element).hasClass("quitButton")) {
            quitExercise();
        }else if ($(element).hasClass("video-placeholder")) {
            showVideo(e);
        }else if ($(element).hasClass("bottom-container")) {
            tapOnContainer();
        }else if ($(element).hasClass("exercising-timer")) {
            addMorePause();
        }else if ($(element).hasClass("skipPause")) {
            skipPause();
        }else if ($(element).hasClass("tapButton")) {
            exerciseDone();
        }else if ($(element).hasClass("finishButton")) {
            if (viewModel.get("savingWorkout")) {
                e.sender.cancel();
                console.log("vec se jednom sejva");
            }else{
                workoutDone();
            }
        }else if ($(element).hasClass("nextInfo")) {
            showNextVideo(e);
        }else if ($(element).hasClass("mute")) {
            viewModel.set("muteStatus", !viewModel.get("muteStatus"));
            mad.local.saveVariable("mute",viewModel.get("muteStatus"));
        }else if ($(element).hasClass("pause")) {
            pauseStopped = viewModel.get("pauseStoppedStatus");
            if (!pauseStopped) {
                mad.viewModels.madbarzWorkout.pauza.brojac.stop();
                viewModel.set("pauseStoppedAt", mad.viewModels.madbarzWorkout.viewModel.get("counters.pauseCountdown"));
                mad.viewModels.madbarzWorkout.viewModel.set("pause", "finished");
            }else{
                resumeCounter(viewModel.get("pauseStoppedAt"));
            }
            viewModel.set("pauseStoppedStatus", !pauseStopped);
        }
    }

    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e){
        //console.log("showView");

        this.set("status", "initial");

        viewModel.set("muteStatus", getMuteStatus());

        mad.common.handleInsomnia();  // drazen - prebaceno iz app.js

        // move Exercise from workout to this view model
        mad.viewModels.madbarzExercising.viewModel.set("selectedExercise",mad.viewModels.madbarzWorkout.viewModel.get("selectedExercise"));
        // & set default reps
        mad.viewModels.madbarzExercising.viewModel.selectedExercise.set("NumberOfReps", mad.viewModels.madbarzExercising.viewModel.selectedExercise.get("NewValue"));

        mad.common.setActualView();
        setupView();

        kendoValuePickerInitialized = false;

        mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.set("counter.nextExercise", mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("counter.exercise"));
        mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.set("counter.nextCycle", mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("counter.cycle"));

        mad.viewModels.madbarzWorkout.selectNextExercise("check");

        /* to add ellipsis if exercise name is too long */
        var w =  mad.common.actualView.content.width();
        //$(".workout-name").css("width", w);
        $(".workout-reps").css("width", w);

        kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    function afterShow(e) {
        viewModel.set("uCanTouchThis", true);

        //initialize value picker list to first 26 numbers
        if (!mad.common.isNullOrEmpty($("#EditRepsValPicker").data("kendoValuePicker"))){
                //console.log("**** praznim value picker");
                $("#EditRepsValPicker").data("kendoValuePicker").initNumbers()
        }

        viewModel.set("viewHeight", parseInt(mad.mobileApp.view().content.height()));

        // view is not stretched now so disable any scrolling of view
        var ctnt = $(mad.common.$actualViewID + ' [data-role="content"]');
        if (ctnt.length){
            ctnt.data('kendoMobileScroller').disable();
        }

        mad.googleAnalytics.trackView("Workouts - Workout Process");

        //var speak = mad.viewModels.settings.getTTSsettings();
        var speak = false;

        if (window.plugins && speak) {
            //var say = "prepare for " +
            var say = "" +
                mad.viewModels.madbarzWorkout.viewModel.selectedExercise.get("Name") + "   " +
                mad.viewModels.madbarzWorkout.viewModel.selectedExercise.get("NewValue") + " " +
                (mad.viewModels.madbarzWorkout.viewModel.selectedExercise.get("Unit") == "SEC" ? "Seconds" : "Repetitions")

            window.TTS.speak({
                text: say,
                locale: 'en-GB',
                rate: 1, //0.75
            }, function () {
                //console.log("TTS playback ended");
                mad.viewModels.madbarzExercising.odbrojavanje.brojac.start();
            }, function (reason) {
                mad.alerts.error("audio error " + reason);
                // drazen - mali delay prije pocetka da se izbjegne preklapanje view-ova
                setTimeout(function() {
                    viewModel.set("status", "countdown");
                    mad.viewModels.madbarzExercising.odbrojavanje.brojac.start();
                }, 22)
            });
        }else{
            // drazen - mali delay prije pocetka da se izbjegne preklapanje view-ova
            setTimeout(function() {
                viewModel.set("status", "countdown");
                mad.viewModels.madbarzExercising.odbrojavanje.brojac.start();
            }, 222)
        }
        // ovdje se mijenjaju visine nakon sto je sve ucitano i prikazano
        updateHeights();
    }

    function transitionStart(e){
        viewModel.set("inTransition", true);
    }

    function transitionEnd(e){
        viewModel.set("inTransition", false);
    }

    function updateHeights(){

        var status = mad.viewModels.madbarzExercising.viewModel.get("status");
        var inTransition = mad.viewModels.madbarzExercising.viewModel.get("inTransition");

        if (inTransition) return;

        //console.log("updateHeights");

        var contentHeight = viewModel.get("viewHeight");

        var visinaVidea = $(".top-container img").height();
        $("#workout-img .video-placeholder").css("height", visinaVidea);

        var visinaTopa = $(".top-container").height();
        var visinaFootera = $("#madbarzExercising .km-footer").height();
        var visinaOverlaya =  contentHeight - visinaTopa - visinaFootera;
        $(".bottom-container").css("height", visinaOverlaya);

        if ( mad.viewModels.madbarzExercising.viewModel.get("status") == 'pause'){
            $("#nextInfo > div").css("height", visinaFootera);
        }
    }

    function getWorkoutImg(){
        return mad.common.showImage(this.selectedExercise.get("ImageUrlMobile"), 'exercise');
    }

    function question(){
        //return this.selectedExercise.IsTimed ? mad.glossary.ui.madbarzExercising.labels.secs[mad.common.observables.languageIndex()]: mad.glossary.ui.madbarzExercising.labels.reps[mad.common.observables.languageIndex()];
        // ovo sa sekundama nije bas najbolje receno
        return this.selectedExercise.IsTimed ? "Seconds finished?" : "Repetitions done?";
    }

    // - - - - - - 5, 4, 3, 2, 1 ------------------------------------------------
    function countdown(v){
        mad.viewModels.madbarzExercising.viewModel.set("odbrojavanje",v);

        var playSound = !mad.viewModels.settings.getMuteSelection();
        if (playSound) {
            if( window.plugins && window.plugins.NativeAudio ) {
                window.plugins.NativeAudio.play('say'+v, mad.common.audioOnSuccess, mad.common.audioOnError, mad.common.audioOnComplete);
            }
        }

    }

    function pocetakOdbrojavanja(e){
        mad.viewModels.madbarzExercising.viewModel.set("isTapWhenDoneVisible", false);
        mad.viewModels.madbarzExercising.viewModel.set("isNextVisible", false);

        var playSound = !mad.viewModels.settings.getMuteSelection();
        if (playSound) {
            if( window.plugins && window.plugins.NativeAudio ) {
                    window.plugins.NativeAudio.duckON();
            }
        }
    }

    function zavrsetakOdbrojavanja(e){
        mad.viewModels.madbarzExercising.viewModel.set("isTapWhenDoneVisible", true);
        mad.viewModels.madbarzExercising.viewModel.set("odbrojavanje","");
        mad.viewModels.madbarzExercising.viewModel.set("status", "start");

        var playSound = !mad.viewModels.settings.getMuteSelection();
        if (playSound) {
            if( window.plugins && window.plugins.NativeAudio ) {
                    window.plugins.NativeAudio.duckOFF();
            }
        }
        //start exercising timer
        mad.viewModels.madbarzExercising.vjezbanje.brojac.start();
        viewModel.set("workoutTimerActive", true);

        // add COUNTDOWN time to total workout time
        var tWt = mad.viewModels.madbarzWorkout.viewModel.get("counters.totalWorkoutTime");
        tWt += 5;
        mad.viewModels.madbarzWorkout.viewModel.set("counters.totalWorkoutTime", tWt);
    }
    // - - - - - - 5, 4, 3, 2, 1 end --------------------------------------------

    // ** ----- switches for displaying ----------------------------------------
    function prikazTrajanjaVjezbeVidljiv(){
        if (this.selectedExercise.get("IsTimed") && this.get("status") ==  "start"){
            return true;
        }else{
            return false;
        }
    }

    function prikazTrajanjaWorkoutaVidljiv(){
        if (!this.selectedExercise.get("IsTimed")){
            return true;
        }else{
            return false;
        }
    }

    function isCounting(){
        var counting = (this.get("status") ==  "countdown") ? true : false;
        if (counting){
            mad.common.fadeIn();
        }
        return counting;
    }

    function isStarted(){
        var started = (this.get("status") ==  "start") ? true : false;
        if (started){
            mad.common.fadeIn();
        }
        return started;
    }

    function isExerciseDone(){
        var status = mad.viewModels.madbarzExercising.viewModel.get("status");
        var inTransition = mad.viewModels.madbarzExercising.viewModel.get("inTransition");

        if (status == "done" ||
            status == "pause" ||

            status == "quited" ||


            status == "finished"){

            mad.viewModels.madbarzExercising.viewModel.set("isTapWhenDoneVisible", false);

            $(".reps-container").css("width", mad.common.actualView.content.width());

            if (!kendoValuePickerInitialized){
                if (!mad.common.isNullOrEmpty($("#EditRepsValPicker").data("kendoValuePicker"))){
                    if (!inTransition){
                        //console.log("praznim value picker");
                        $("#EditRepsValPicker").data("kendoValuePicker").initNumbers()
                        kendoValuePickerInitialized = true;
                    }
                }
            }

            if (status ==  "done" || status == "pause") {       
                mad.viewModels.madbarzExercising.viewModel.set("isNextVisible", true);
            }
            mad.common.fadeIn();
            //console.log("isExerciseDone", true);
            return true;
        }else{
            return false;
        }
    }

    function isCameToEnd(){
        return (viewModel.get("status") ==  "finished") ? true : false;
    }

    function exerciseDoneAndCameToEnd(){
        return  isExerciseDone() &&  isCameToEnd();
    }

    function exerciseDoneAndNotCameToEnd(){
        return  isExerciseDone() &&  !isCameToEnd();
    }

    function isFirstInRound(){
        var counting = (this.get("status") ==  "countdown") ? true : false;
        var currentExercise = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("counter.exercise");

        var vrati = (counting && currentExercise == 1) ? true : false;
        return vrati;
    }

    function isLastInRound(){
        var totalExercises = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("total.exercises");
        var currentExercise = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("counter.exercise");

        var vrati = (currentExercise  == totalExercises) ? true : false;
        return vrati;
    }

    // ** ----- switches for displaying ---------------------------------------- end

    // ** ----- variables for displaying ----------------------------------------

    function getMuteStatus(){
        var status = mad.local.loadVariableParse("mute");
        return status;
    }

    function displayCycles(){
        var totalCycles = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("total.cycles");
        var currentCycle =  mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("counter.cycle");
        return  "Round " + currentCycle + "/" + totalCycles;
    }
    function displayExercises(){
        var totalExercises = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("total.exercises");
        var currentExercise = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("counter.exercise");
        return "exercise: " + currentExercise + "/" + totalExercises;
    }

    function displayRoundStarted(){
        var currentCycle =  mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("counter.cycle");
        return  "Round " + currentCycle;
    }

    function displayRoundFinished(){
        var currentCycle =  mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("counter.cycle");
        return  "Round " + currentCycle + " done!";
    }

    function showTotalTime (){
        return  mad.viewModels.madbarzExercising.viewModel.get("counters.totalWorkoutTime");
    }

    function showTotalTimeDisplay(){
        return  mad.viewModels.madbarzExercising.viewModel.get("counters.totalWorkoutTime") + mad.viewModels.madbarzExercising.viewModel.selectedExercise.get("LengthInSeconds");
    }

    function showTotalPauseTime(){
        return  mad.viewModels.madbarzExercising.viewModel.get("counters.totalPauseTime");
    }

    function showPauseTime (){
        return  mad.viewModels.madbarzExercising.viewModel.get("counters.pauseCountdown");
    }

    function trajanjeVjezbanja(v){      // trenutnog exercisea
        mad.viewModels.madbarzExercising.viewModel.selectedExercise.set("LengthInSeconds",v);
        if (mad.viewModels.madbarzExercising.viewModel.selectedExercise.get("IsTimed")) {
            var brojacMax = mad.viewModels.madbarzExercising.viewModel.selectedExercise.get("NewValue")
            var playSound = !mad.viewModels.settings.getMuteSelection();
            if (v == brojacMax - 3) {
                if (playSound) {
                    //console.log("just before start beeeeeping ---------- - - -");
                    if( window.plugins && window.plugins.NativeAudio ) {
                        startBeeping();
                    }
                }
            }
        }
    }

    function startBeeping(){
        window.plugins.NativeAudio.duckON();
        window.plugins.NativeAudio.play('beep2', mad.common.audioOnSuccess, mad.common.audioOnError, beep3);
    }
    function beep3(){
        if (mad.viewModels.madbarzExercising.viewModel.get("status") !=  "done"){
            window.plugins.NativeAudio.play('beep3', mad.common.audioOnSuccess, mad.common.audioOnError, beep4);
        }else{
            beepGotov()
        }
    }
    function beep4(){
        if (mad.viewModels.madbarzExercising.viewModel.get("status") !=  "done"){
            window.plugins.NativeAudio.play('beep4', mad.common.audioOnSuccess, mad.common.audioOnError, beep5);
        }else{
            beepGotov()
        }
    }
    function beep5(){
        if (mad.viewModels.madbarzExercising.viewModel.get("status") !=  "done"){
            window.plugins.NativeAudio.play('beep5', mad.common.audioOnSuccess, mad.common.audioOnError, beepGotov);
        }else{
            beepGotov()
        }
    }
    function beepGotov(){
        window.plugins.NativeAudio.duckOFF();
    }

    function getNextExerciseLabel(){
        return mad.common.translate('words', 'next');
    }
    
    function getNextExerciseValue(){
        var name = mad.viewModels.madbarzWorkout.viewModel.nextExercise.Name;
        var reps = mad.viewModels.madbarzWorkout.viewModel.nextExercise.NewValue;
        var unts = mad.viewModels.madbarzWorkout.viewModel.nextExercise.Unit;
        //return  reps + " " + unts + " " + name ;
        return  name ;
    }
    
    function getNextExerciseImg(){
       var wktImg = mad.common.showImage(mad.viewModels.madbarzWorkout.viewModel.nextExercise.get("ImageUrlMobile"), "exercise");
       return wktImg;
    }

    // ** ----- for displaying ---------------------------------------- end
    function showVideo(e){
        e.preventDefault();     // da ne probija

        if (viewModel.get("status") == "start") {
            mad.viewModels.madbarzExercising.vjezbanje.brojac.stop();
            viewModel.set("workoutTimerActive", false);

            mad.viewModels.workoutVideo.viewModel.set("workoutTimerStopped", true);
            mad.viewModels.workoutVideo.viewModel.set("workoutTimerValue", mad.viewModels.madbarzExercising.vjezbanje.brojac.value());
        }else if (viewModel.get("status") == "countdown") {
            mad.viewModels.madbarzExercising.odbrojavanje.brojac.stop();
            mad.viewModels.workoutVideo.viewModel.set("countdownTimerStopped", true);
            mad.viewModels.workoutVideo.viewModel.set("countdownTimerValue", mad.viewModels.madbarzExercising.odbrojavanje.brojac.value());
        }
        mad.viewModels.workoutVideo.viewModel.set("selectedExercise",mad.viewModels.madbarzWorkout.viewModel.get("selectedExercise"));
        mad.viewModels.workoutVideo.viewModel.openVideoModal();
    }

    function showNextVideo(e){
        e.preventDefault();     // da ne probija

        mad.viewModels.madbarzWorkout.pauza.brojac.stop();
        mad.viewModels.workoutVideo.viewModel.set("pauseTimerStopped", true);
        mad.viewModels.workoutVideo.viewModel.set("pauseTimerValue", mad.viewModels.madbarzWorkout.pauza.brojac.value());

        mad.viewModels.workoutVideo.viewModel.set("selectedExercise",mad.viewModels.madbarzWorkout.viewModel.get("nextExercise"));
        mad.viewModels.workoutVideo.viewModel.openVideoModal();
    }

    // ** ----- handling pauses ---------------------------------------
    function addMorePause(){
        var pauseLength = mad.viewModels.madbarzWorkout.viewModel.get("counters.pauseCountdown");
        pauseLength += 10;
        mad.viewModels.madbarzWorkout.viewModel.set("counters.pauseCountdown", pauseLength);
        mad.viewModels.madbarzWorkout.pauza.brojac.stop();
        mad.viewModels.madbarzWorkout.pauza.brojac.setStart(pauseLength);
        mad.viewModels.madbarzWorkout.pauza.brojac.start();

    }
    function skipPause(){
        mad.viewModels.madbarzWorkout.zavrsetakOdbrojavanjaPauze();
    }
    // ** ----- handling pauses --------------------------------------- end

    function exerciseDone(){
        //stop exercising timer
        mad.viewModels.madbarzExercising.vjezbanje.brojac.stop();
        viewModel.set("workoutTimerActive", false);

        // add exercising time to total workout time
        var tWt = mad.viewModels.madbarzWorkout.viewModel.get("counters.totalWorkoutTime");
        var tEt = mad.viewModels.madbarzExercising.vjezbanje.brojac.value();
        tWt += tEt;
        mad.viewModels.madbarzWorkout.viewModel.set("counters.totalWorkoutTime", tWt);

        // spremi brojac prije resetiranja za timed exercise
        if (mad.viewModels.madbarzExercising.viewModel.selectedExercise.get("IsTimed")){
            mad.viewModels.madbarzExercising.viewModel.selectedExercise.set("NumberOfReps", mad.viewModels.madbarzExercising.vjezbanje.brojac.value());
        }else{
            mad.viewModels.madbarzExercising.viewModel.selectedExercise.set("NumberOfReps", mad.viewModels.madbarzExercising.viewModel.selectedExercise.get("NewValue"));
        }

        var totalCycles = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("total.cycles");
        var currentCycle =  mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("counter.cycle");
        var totalExercises = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("total.exercises");
        var lastExercise = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("total.lastExercise");
        var currentExercise = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("counter.exercise");

        // i dodaj u gotove vjezbe
        mad.viewModels.madbarzWorkout.addExerciseToFinishedExercises();

        if (currentExercise == lastExercise) {
            if (currentCycle == totalCycles) {
                mad.viewModels.madbarzExercising.viewModel.set("status", "finished");
            } else {
                mad.viewModels.madbarzWorkout.startPauseCountdown('cycle');
            }
        }else{
            mad.viewModels.madbarzWorkout.startPauseCountdown('exercise');
        }
    }

    function quitExercise(){
        mad.viewModels.madbarzWorkout.pauza.brojac.stop();
        var pauseLength = mad.viewModels.madbarzWorkout.viewModel.get("counters.pauseCountdown");
        mad.viewModels.madbarzWorkout.viewModel.set("pause", "finished");

        viewModel.set("confirmOpened", true);

        var msg = mad.glossary.messages.quitWorkout;
        navigator.notification.confirm(
            msg.message[mad.common.observables.languageIndex()],
            function (button) {
                if (button == 3 || button == 0) {  // and you want to cancel by selecting a button or android back buttun
                    resumeCounter(pauseLength);
                }else if (button == 2) {            // and you want to quit without saving

                    var Ycallback = function(){quitWOsaving()};
                    var Ncallback = function(){resumeCounter(pauseLength)};
                    areYouSureYN(Ycallback, Ncallback);

                } else if (button == 1) {                            // you want save
                    viewModel.set("confirmOpened", false);

                    mad.viewModels.madbarzExercising.viewModel.set("status", "quited");         // to remove quit button because reps can be added to last exercise
                    mad.viewModels.madbarzWorkout.viewModel.set("status", "quiting workout");
                    mad.viewModels.madbarzWorkout.zavrsetakOdbrojavanjaPauze();
                }
            },
            msg.title[mad.common.observables.languageIndex()],
            [msg.button1[mad.common.observables.languageIndex()], msg.button2[mad.common.observables.languageIndex()], msg.button3[mad.common.observables.languageIndex()]]);
    }

    function areYouSureYN(YEScallback, NOcallback) {
        navigator.notification.confirm(
            "",
            function(button) {if (button == 1) {YEScallback()}else if (button == 2) {NOcallback()}},
            "Are you sure you want to quit without saving?", ["Yes", "No"]);
    }

    function quitWOsaving(){
        viewModel.set("confirmOpened", false);

        // iskljuci insomniu
        mad.common.turnInsomniaOFF();

        // go back to workouts list
        if (mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz") {
            //mad.mobileApp.navigate("ui/workouts/madbarz/madbarzWorkoutsList.html?origin=exercising", "slide:left reverse");
            mad.mobileApp.navigate("ui/workouts/madbarz/madbarzRoutines.html?origin=exercising", "slide:left reverse");
        }else{
            mad.mobileApp.navigate("ui/feed/feed.html?origin=exercising", "slide:left reverse");
        }

        var typeText = mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz" ? "Madbarz routine" : "Saved workout";
        var numOfWorkoutsForThisUserSoFar = parseInt(mad.local.loadVariable("NumberOfFinishedWorkouts"));

        mad.googleAnalytics.trackEvent("Training Activity", "Quited Without Saving", typeText, numOfWorkoutsForThisUserSoFar);

        if (numOfWorkoutsForThisUserSoFar == 0) {
            mad.googleAnalytics.trackEvent("Training Activity", "Quited First Workout Without Saving", typeText, numOfWorkoutsForThisUserSoFar);
        }
    }

    function resumeCounter(from){
        viewModel.set("confirmOpened", false);
        mad.viewModels.madbarzWorkout.pauza.brojac.setStart(from);
        mad.viewModels.madbarzWorkout.pauza.brojac.start();
        mad.viewModels.madbarzWorkout.viewModel.set("pause", "active");
    }

    function workoutDone(){
        mad.viewModels.madbarzWorkout.updateReps();
        mad.viewModels.madbarzWorkout.selectNextExercise("do");     //to finish and add skipped
    }

    function tapOnContainer(e){
        if (viewModel.get("status") == "start"){
            exerciseDone();
        }
    }

    // ** ---- not in viewModel Context  - - - - - - - - - - - - - - - - -
    function setupView(){
        mad.common.stretchView();
        mad.common.setResolutionForView(parseInt(mad.mobileApp.view().content.width()), parseInt(mad.mobileApp.view().content.height()));
        mad.common.setLangForView();
    }

    function setViewTitle(){
        var naslov = mad.viewModels.madbarzWorkout.viewModel.selectedExercise.get("Name");
        mad.common.actualView.title = naslov;
        mad.common.actualView.header
            .find(".km-navbar")
            .data("kendoMobileNavBar").title(naslov);
    }

    return {
        viewModel: viewModel,
        odbrojavanje: odbrojavanje,
        vjezbanje: vjezbanje 
    };

}());

