var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.madbarzWorkoutComment = (function () {

    "use strict";

    var cekam;

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        beforeShow: beforeShow,
        show: showView,
        afterShow: afterShow,

        ifWorkoutSaved: false,
        favouritesIcon: favouritesIcon,
        cameFromPlan: cameFromPlan,
        hideSaveWorkoutButton: hideSaveWorkoutButton,

        uCanTouchThis: false,

        postComment: publish,
        comment: ""
    });


    function initView(e) {
        var viewID = "#madbarzWorkoutComment";

        viewModel.set("uCanTouchThis", false);

        $(viewID).kendoTouch({
            filter: ".lButton, .rButton, .saveTap, .fbShareTap, .tweetShareTap",
            touchstart: function(e) {
                console.log("touchstart");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    console.log("touchstart but canceled")
                }
            },
            tap: function(e) {
                console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    console.log("but canceled")
                }else{
                    handleTap(e);
                }
            }
        });
    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target;

        if ($(element).hasClass("lButton")) {
            mad.common.goBack();
        }else if ($(element).hasClass("rButton")) {
            publish();
        }else if ($(element).hasClass("mTitle")) {
            mad.common.titlePressed();
        }else if ($(element).hasClass("saveTap")) {
            mad.viewModels.madbarzWorkout.saveWorkout();
        }else if ($(element).hasClass("fbShareTap")) {
            fbShare();
        }else if ($(element).hasClass("tweetShareTap")) {
            tweetShare();
        }
    }

    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e) {
        mad.common.setActualView(); mad.common.addViewToHistory(); setupView();
        kendo.bind($(mad.common.$actualViewID), viewModel);
        viewModel.set("ifWorkoutSaved", mad.viewModels.madbarzWorkout.viewModel.get("isWorkoutSaved"));
    }

    function afterShow(e) {
        viewModel.set("uCanTouchThis", true);
        mad.googleAnalytics.trackView("Workouts - Result - Comment");
    }

    function fbShare() {
        var treningId = getId();

        if (window.navigator.simulator === true) {
            mad.alerts.error('Cannot run in simulator or comapanion app!');
            return false;
        } else {
           
            mad.common.showLoader();
           var analyticsData = {
               "Origin": cameFromPlan() ? "Workout plan result screen" : "Quick Workout result screen",
                "Type": "Facebook"
            };

            mad.analyticEvents.track([mad.analyticEvents.services.GA], mad.analyticEvents.categories.WORKOUTSSHARE, mad.analyticEvents.types.EVENT,
                "Workout share click",
                analyticsData,
                "Social",
                "Share Workout Click", "Facebook Share");

            window.plugins.socialsharing.shareViaFacebook('I finished workout using Madbarz', null, "http://madbarz.com/home/result/" + treningId + "?utm_source=facebook&utm_medium=share&utm_campaign=appfbshare", onShareFbSuccess, onShareError);
        }
    }

    function tweetShare() {
        var treningId = getId();

        if (window.navigator.simulator === true) {
            mad.alerts.error('Cannot run in simulator or comapanion app!');
            return false;
        } else {
            
            mad.common.showLoader();
         
            var analyticsData = {
                "Origin": cameFromPlan() ? "Workout plan result screen" : "Quick Workout result screen",
                "Type": "Twitter"
            };
            mad.analyticEvents.track([mad.analyticEvents.services.GA], mad.analyticEvents.categories.WORKOUTSSHARE, mad.analyticEvents.types.EVENT,
                "Workout share click",
                analyticsData,
                "Social",
                "Share Workout Click", "Twitter Share");


            window.plugins.socialsharing.shareViaTwitter('I just finished my workout with #madbarzApp', null, "http://madbarz.com/home/result/" + treningId + "?utm_source=facebook&utm_medium=share&utm_campaign=appfbshare", onShareTwitteruccess, onShareError);
        }
    }

    function onShareFbSuccess() {

        var analyticsData = {
            "Origin": cameFromPlan() ? "Workout plan result screen" : "Quick Workout result screen",
            "Type": "Facebook"
        };
        mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP], mad.analyticEvents.categories.WORKOUTSSHARE, mad.analyticEvents.types.EVENT,
            "Workout Shared",
            analyticsData,
            "Social",
            "Workout Shared", "Facebook");

        mad.common.hideLoader();
    }

    function onShareTwitteruccess() {

        var analyticsData = {
            "Origin": cameFromPlan() ? "Workout plan result screen" : "Quick Workout result screen",
            "Type": "Twitter"
        };
        mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.MIXP], mad.analyticEvents.categories.WORKOUTSSHARE, mad.analyticEvents.types.EVENT,
            "Workout Shared",
            analyticsData,
            "Social",
            "Workout Shared", "Twitter");

        mad.common.hideLoader();
    }

    function onShareError(msg) {
        mad.common.hideLoader();
        console.log('SocialSharing error: ' + msg);
        mad.common.alerts.error('Workout not shared because of error: ' + msg);
    }

    function publish(e) {
        console.log(e, "post comment");

        if (e){
            e.preventDefault();
        }

        // automatically close the keyboard on iOS
        document.activeElement.blur();

        var commentIs = mad.viewModels.madbarzWorkoutComment.viewModel.get("comment");

        if (commentIs) {

            //hide keyboard
            if (cordova.plugins && cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.close();
            }
            mad.common.showBusyLoader();

            /*
            mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/FeedV3/AddWorkoutComment";
            mad.common.variables.forAjax.akcija = "POST";
            mad.common.variables.dataOptions = {
                //Id: mad.viewModels.workoutStat.viewModel.get("results.TreningId"),
                Id: getId(),
                IsWorkoutFromPlan: cameFromPlan(),
                Comment: commentIs
            };
            */

            var link   = {putanja : mad.common.variables.serverUrl + "api/FeedV3/AddWorkoutComment", akcija : "POST"};
            var podaci = {
                Id: getId(),
                IsWorkoutFromPlan: cameFromPlan(),
                Comment: commentIs
            };

            mad.data.post(link, podaci)
                .done(function(data) {
                    mad.viewModels.madbarzWorkoutComment.viewModel.set("comment", "");
                    mad.common.hideLoader();
                    mad.googleAnalytics.trackEvent("Social", "Comment", "After workout (result screen)");
                    navigate();
                })
                .fail(function(qXHR, textStatus, errorThrown) {
                    mad.viewModels.madbarzWorkoutComment.viewModel.set("comment", "");
                    mad.common.hideLoader();
                    mad.alerts.error("Error writing comment");
                    navigate();
                });
        } else {
            //hide keyboard
            if (cordova.plugins && cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.close();
            }
            navigate();
        }

        function navigate() {
            if (mad.viewModels.madbarzWorkout.viewModel.get("showPopup")) {
                mad.viewModels.popups.viewModel.openModalWindow("nextPart", "Well done!", "You can now move on to a new plan!", "See plans");
            } else {
                mad.mobileApp.navigate("ui/feed/feed.html?origin=workoutComment", "slide:right");
            }
        }
    }

    function cameFromPlan() {
        return mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Plan";
    }

    function hideSaveWorkoutButton() {
        var isFromPlan = cameFromPlan();
        var isPro = mad.viewModels.madbarzWorkout.viewModel.get("selectedWorkout.IsPro");
        return isFromPlan || isPro;
    }

    function getId(){
        if (mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Plan"){
            return mad.viewModels.planWorkoutStat.viewModel.get("results.WorkoutActivityId");
        }else{
            return mad.viewModels.workoutStat.viewModel.get("results.TreningId");
        }
    }

    function favouritesIcon() {
        if (mad.viewModels.madbarzWorkout.viewModel.get("isWorkoutSaved"))
            return "images/icons/unsaved.svg";
        else
            return "images/icons/saved.svg";
    }

    /* not in viewModel Context  - - - - - -  */
    function setupView() {
        mad.common.stretchView();
        //mad.common.setActualViewTitle();
        mad.common.setResolutionForView(parseInt(mad.mobileApp.view().content.width()), parseInt(mad.mobileApp.view().content.height()));
        mad.common.setLangForView();

    }

    return {
        viewModel: viewModel
    };

}());

