var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.madbarzWorkoutDone = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        show: showView,
        afterShow: afterShow,
        showStats: showStats,
        toSaved: toSaved,
        ifOffline: ifOffline,
        footerEnabled: false,
        score: 0,
        targetScore: 0,
        message: "Cool!"
    });


    function initView(e){
    }

    function showView(e){

        mad.common.setActualView();
        mad.common.stretchView();

        //erase comment
        mad.viewModels.madbarzWorkoutComment.viewModel.set("comment", "");

        //erase previous counter
        $('#workoutPoints').text("");

        kendo.bind($(mad.common.$actualViewID), viewModel);

        getMessage();
    }

    function afterShow(e) {
        if (mad.common.observables.networkStatus == "online") {
            animateCounter(0, mad.viewModels.madbarzWorkoutDone.viewModel.get("score"), 5000);
        }else {
            animateCounter(0, mad.viewModels.madbarzWorkoutDone.viewModel.get("score"), 3000);
        }

        mad.googleAnalytics.trackView("Workouts - Result - Score Counter");
    }

    function animateCounter(s,e,d){
        $('#workoutPoints').animatedCounter({
            start: s,
            end:e,
            duration: d
        });
    }

    function showStats(){
        mad.googleAnalytics.trackEvent("Training Activity", "Click - See your statistics");
        // go to next view
        mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkoutStat.html", "slide:left");
    }

    function toSaved(){
        // go back to list of saved workouts
        mad.mobileApp.navigate("ui/workouts/saved/madbarzSavedWorkoutsList.html", "slide:right");
    }

    function ifOffline(){
        var vrati = mad.common.observables.networkStatus == "online" ? false : true;
        return vrati;
    }

    /* not in viewModel Context  - - - - - -  */
    function getMessage(){
        var arrary;
        var points = mad.viewModels.madbarzWorkoutDone.viewModel.score;
        if(points <= 100){
            arrary = mad.glossary.messages.workoutResult[mad.common.observables.languageIndex()][0];
        }else if(points <=250 && points > 100){
            arrary = mad.glossary.messages.workoutResult[mad.common.observables.languageIndex()][1];
        }else if(points <=500 && points > 250){
            arrary = mad.glossary.messages.workoutResult[mad.common.observables.languageIndex()][2];
        }else if(points <=800 && points >500){
            arrary = mad.glossary.messages.workoutResult[mad.common.observables.languageIndex()][3];
        }else{
            arrary = mad.glossary.messages.workoutResult[mad.common.observables.languageIndex()][4];
        }
        var randomNumber = Math.floor(Math.random() * arrary.length);
        mad.viewModels.madbarzWorkoutDone.viewModel.set("message", arrary[randomNumber]);

    }

    return {
        viewModel: viewModel
    };

}());

