var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.workoutStatShare = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        beforeShow: beforeShow,
        show: showView,
        afterShow: afterShow,

        showPreloader: false,

        cameFrom: "?",

        takenPhoto: "",
        photoForUpload: "",
        workoutInfo: "",
        workoutName: "",
        WorkoutTime: "",    //formated

        uCanTouchThis: false,

        exercises: []
    });

    function initView(e) {
        var viewID = "#madbarzWorkoutStatShare";

        viewModel.set("uCanTouchThis", false);

        $(viewID).kendoTouch({
            filter: ".lButton, .rButton, .toShare",
            touchstart: function (e) {
                //console.log("touchstart");
                if (!viewModel.get("uCanTouchThis")) {
                    e.sender.cancel();
                    console.log("touchstart but canceled")
                }
            },
            tap: function (e) {
                //console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")) {
                    e.sender.cancel();
                    console.log("but canceled")
                } else {
                    handleTap(e);
                }
            }
        });

        // prepare mobiscroll options
        $(".shareOptions-rs").mobiscroll({
            theme: $.mobiscroll.defaults.theme,
            mode: "static",
            display: "bottom",
            buttons: [],
            lang: "hr",
            showLabel: false,
            showInput: false,
            wheels: [[{ values: ["share photo", "share link"] }]],
            height: 45,
            rows: 2,
            readonly: false,
            group: false,
            layout: "liquid",
            onShow: function (html, valueText, inst) {
                html.addClass("mobi-shareOptions");
                var winH = $(window).height();
                var dialogEl = html.find("[role='dialog']");
                var dialogElHight = dialogEl.height();
                dialogEl.css({ "top": winH - dialogElHight });    // korigiraj top poziciju
            },
            onValueTap: function (item, inst) {
                if (item.context.textContent == "share photo") {
                    sharePhoto();
                } else if (item.context.textContent == "share link") {
                    shareLink();
                }
                inst.hide(false, "set");
            }
        });

      

    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target;

        if ($(element).hasClass("lButton")) {
            leftButtonAction();
        } else if ($(element).hasClass("rButton")) {
           rightButtonAction(e);
        } else if ($(element).hasClass("toShare")) {
            share(e);
        }
    }



 
    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e){

        var week, rbr, name, plan, naslov;

        var rounds =  mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("FinishedCycles"),
        roundsFormatted = "";

        mad.common.setActualView(); mad.common.addViewToHistory();
        mad.common.stretchView();

        var origin = e.view.params.origin;
        viewModel.set("cameFrom", origin);

        viewModel.set("showPreloader", false);
        $("#madbarzWorkoutStatShare .rButton .text").removeClass("textInvisible");


        if (origin == "planRoutineStat"){
            viewModel.set("takenPhoto", mad.viewModels.planWorkoutStat.viewModel.get("takenPhoto"));
            viewModel.set("exercises", mad.viewModels.planWorkoutStat.viewModel.get("listOfFinishedExercises"));

            week = mad.viewModels.plansWork.viewModel.selectedPlan.ActiveExecution.ExecutionData.CurrentWeek;
            rbr  = parseInt(mad.viewModels.plansWork.viewModel.selectedWorkout.WorkoutOrdinal)-1;
            name = mad.viewModels.plansWork.viewModel.selectedPlan.ActiveExecution.ExecutionData.Weeks[week-1].Workouts[rbr].Name;
            plan = mad.viewModels.plansWork.viewModel.selectedPlan.Name;

            naslov = name + " - Week " + week + "<br>" + plan;
            viewModel.set("workoutName", naslov);

        }else{
            viewModel.set("takenPhoto", mad.viewModels.workoutStat.viewModel.get("takenPhoto"));
            viewModel.set("exercises", mad.viewModels.workoutStat.viewModel.get("comparison"));
            viewModel.set("workoutName", mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("Name"));
        }

        $("#myWorkoutShare").css('background-image', 'url("' + viewModel.get("takenPhoto") + '")');


        if (rounds == 0) {
            roundsFormatted = ", 0 rounds"
        }else if (rounds == 1){
            roundsFormatted = ", 1 round"
        }else{
            roundsFormatted = ", " + rounds + " rounds"
        }
        viewModel.set("workoutInfo", mad.common.formatTimeForDisplayingTimedExercises(mad.viewModels.madbarzWorkout.viewModel.get("counters.totalWorkoutTime")) + roundsFormatted);

        var template = kendo.template($("#madbarzWorkoutStatShare-exercises-template").html(), { useWithBlock: false });
        var result = template(viewModel);        //Pass the data to the compiled template
        $(".workoutExercises").html(result);

        kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    function afterShow(e) {
        viewModel.set("uCanTouchThis", true);
    }

    function leftButtonAction(){
        mad.common.goBack();
    }

    function rightButtonAction(){

        if (viewModel.get("showPreloader")){
            return
        }

        $("#madbarzWorkoutStatShare .rButton .text").addClass("textInvisible");
        viewModel.set("showPreloader", true);

        if (viewModel.get("cameFrom") == "planRoutineStat"){
            if (!mad.viewModels.planWorkoutStat.viewModel.photoNotTaken){
                uploadPhoto();
            }
        }else{
            if (!mad.viewModels.workoutStat.viewModel.photoNotTaken){
                uploadPhoto();
            }
        }

        renderShareImg();

        setTimeout(function () {
            gotoNextView();
        }, 999);

    }

    function uploadPhoto(){

        var fotka, w, h;

        if (viewModel.get("cameFrom") == "planRoutineStat"){
            fotka = mad.viewModels.planWorkoutStat.viewModel.get("takenPhoto");
            w = mad.viewModels.planWorkoutStat.viewModel.get("takenPhotoInfo.width");
            h = mad.viewModels.planWorkoutStat.viewModel.get("takenPhotoInfo.height");
        }else{
            fotka = mad.viewModels.workoutStat.viewModel.get("takenPhoto");
            w = mad.viewModels.workoutStat.viewModel.get("takenPhotoInfo.width");
            h = mad.viewModels.workoutStat.viewModel.get("takenPhotoInfo.height");
        }

        mad.data.post({
                putanja : mad.common.variables.serverUrl + "api/workout/AddImageToWorkout?api-version=2.0",
                akcija : "POST"
            },
            {
                Id: getId(),
                IsWorkoutFromPlan: isFromPlan(),
                Width: w,
                Height: h,
                Extension: "jpeg",
                ImageBase64: fotka
            })
            .done(function (data) {
                console.log("upload fotke prosao - vratio", data);
            })
            .fail(function(qXHR, textStatus, errorThrown) {
                console.log("Error uploading img", textStatus, qXHR);
                mad.alerts.error("photo Upload failed");
            });

    }


    function renderShareImg(e){
        console.log("rendering");

        var w = 0,
            h = 0,
            originalW = 0,
            originalH = 0,
            scale = 1;

        if (viewModel.get("cameFrom") == "planRoutineStat"){
            if (!mad.viewModels.planWorkoutStat.viewModel.photoNotTaken){
                // ako je s plana i fotkano je pokupi visinu i sirinu
                originalW = mad.viewModels.planWorkoutStat.viewModel.get("takenPhotoInfo.width");
                originalH = mad.viewModels.planWorkoutStat.viewModel.get("takenPhotoInfo.height");
            }
        }else{
            // ako je s normalnog workouta i fotkano je pokupi visinu i sirinu
            if (!mad.viewModels.workoutStat.viewModel.photoNotTaken){
                originalW = mad.viewModels.workoutStat.viewModel.get("takenPhotoInfo.width");
                originalH = mad.viewModels.workoutStat.viewModel.get("takenPhotoInfo.height");
            }
        }
        w = $("#myWorkoutShare").width();
        h = $("#myWorkoutShare").height();

        scale = 1200 / w;

        console.log("original / device /  scale", originalW, w, scale);

        var source, dataURL, options = {};
        source = $("#madbarzWorkoutStatShareContainer .photo")[0];
        options = {
            allowTaint: true,
            logging: true,
            scale: scale,
            background: "undefined"
        };

        html2canvas(source, options)
            .then(function(canvas) {
                console.log("renderirano");

                dataURL = canvas.toDataURL('image/jpeg', 0.8);
                viewModel.set("photoForUpload", dataURL);

                uploadSharePhotoAndComment();
            }, function(err){
                console.log("greska kod renderiranja", err);
                mad.alerts.error("h2c error");
            });
    }


    function uploadSharePhotoAndComment(){

        var w, h;
        var id = getId();
        var imgBase64 = viewModel.get("photoForUpload");
        var note;

        if (viewModel.get("cameFrom") == "planRoutineStat"){
            w = mad.viewModels.planWorkoutStat.viewModel.get("takenPhotoInfo.width");
            h = mad.viewModels.planWorkoutStat.viewModel.get("takenPhotoInfo.height");
            note = mad.viewModels.planWorkoutStat.viewModel.get("sadrzajKomentara");
        }else{
            w = mad.viewModels.workoutStat.viewModel.get("takenPhotoInfo.width");
            h = mad.viewModels.workoutStat.viewModel.get("takenPhotoInfo.height");
            note = mad.viewModels.workoutStat.viewModel.get("sadrzajKomentara");
        }


        mad.data.post({
            putanja : mad.common.variables.serverUrl + "api/workout/UpdateFinihedWorkout?api-version=2.0",
            akcija : "POST"
        },
        {
            Id: id,
            IsWorkoutFromPlan: isFromPlan(),
            Note: note,
            Width: w,
            Height: h,
            ImageBase64: imgBase64
        })
            .done(function (data) {
                console.log("upload share fotke i komentara prosao - vratio", data);
            })
            .fail(function(qXHR, textStatus, errorThrown) {
                console.log("Error uploading img", textStatus, qXHR);
                mad.alerts.error("Share photo Upload failed");
            });
    }

    function gotoNextView(){
        // continue to next view
        if (mad.viewModels.madbarzWorkout.viewModel.get("showPopup")) {     // drazen - testirati ovu varijantu todo
            mad.viewModels.popups.viewModel.openModalWindow("nextPart", "Well done!", "You can now move on to a new plan!", "See plans");
        } else {
            mad.mobileApp.navigate("ui/feed/feed.html?origin=workoutComment", "slide:right");   //drazen - workoutComment bi trebao biti WorkoutStatShare i fiksati to za android back
        }
    }

    function getId() {
        if (mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Plan") {
            return mad.viewModels.planWorkoutStat.viewModel.get("results.WorkoutActivityId");
        } else {
            return mad.viewModels.workoutStat.viewModel.get("results.TreningId");
        }
    }

    function isFromPlan(){
        var fromPlan = mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Plan";
        return fromPlan;
    }

    function share(el) {
        var inst = $(".shareOptions-rs").mobiscroll("getInst");
        setTimeout(function () {
            inst.show(false, false);
        }, 22);
    }

    function sharePhoto() {
        var source, options = {};
        var message, subject, image, link;
        message = null;
        subject = null;
        link = null;
        image = null;

        console.log("rendering");

        if (!checkSimulator()) {

            var displayName = mad.local.loadVariable("DisplayName");
            var isFromPlan = isWorkoutFromPlan();
            link = "https://www.madbarz.com/workout/" + displayName + "/" + getId() + "?p=" + (isFromPlan ? "t" : "f");
            link = link.replace(/\s+/g, "-");

            var w = 0,
                h = 0,
                originalW = 0,
                originalH = 0,
                scale = 1;

            if (viewModel.get("cameFrom") == "planRoutineStat") {
                if (!mad.viewModels.planWorkoutStat.viewModel.photoNotTaken) {
                    // ako je s plana i fotkano je pokupi visinu i sirinu
                    originalW = mad.viewModels.planWorkoutStat.viewModel.get("takenPhotoInfo.width");
                    originalH = mad.viewModels.planWorkoutStat.viewModel.get("takenPhotoInfo.height");
                }
            } else {
                // ako je s normalnog workouta i fotkano je pokupi visinu i sirinu
                if (!mad.viewModels.workoutStat.viewModel.photoNotTaken) {
                    originalW = mad.viewModels.workoutStat.viewModel.get("takenPhotoInfo.width");
                    originalH = mad.viewModels.workoutStat.viewModel.get("takenPhotoInfo.height");
                }
            }
            w = $("#myWorkoutShare").width();
            h = $("#myWorkoutShare").height();

            scale = 1200 / w;

            console.log("original / device /  scale", originalW, w, scale);

            var source, dataURL, options = {};
            source = $("#madbarzWorkoutStatShareContainer .photo")[0];
            options = {
                allowTaint: true,
                logging: true,
                scale: scale,
                background: "undefined"
            };

            html2canvas(source, options).then(function (canvas) {
                console.log("renderirano");
                image = canvas.toDataURL('image/jpeg', 0.8);
                window.plugins.socialsharing.share(message, subject, image, link, onSuccessPic, onError);
            });
        }

    }

    function shareLink() {
        var message, subject, image, link;
        message = null;
        subject = null;
        image = null;
        var displayName = mad.local.loadVariable("DisplayName");
        var isFromPlan = isWorkoutFromPlan();
        link = "https://www.madbarz.com/workout/" + displayName + "/" + getId() + "?p=" + (isFromPlan ? "t" : "f");
        link = link.replace(/\s+/g, "-");

        if (!checkSimulator()) {
            window.plugins.socialsharing.share(message, subject, image, link, onSuccessLink, onError);
        }
    }

    function checkSimulator() {
        if (window.navigator.simulator === true) {
            alert('This plugin is not available in the simulator.');
            return true;
        } else if (window.plugins === undefined || window.plugins.socialsharing === undefined) {
            alert('Plugin not found. Maybe you are running in AppBuilder Companion app which currently does not support this plugin.');
            return true;
        } else {
            return false;
        }
    }

    // callbacks
    function onSuccessLink(msg) {
        console.log('SocialSharing success: ' + msg);
        sendDataToAnalytics("link", true);

    }
    //
    function onSuccessPic(msg) {
        console.log('SocialSharing success: ' + msg);
        sendDataToAnalytics("photo", true);
    }

    function onError(msg) {
        console.log('SocialSharing error: ' + msg);
        mad.alerts.top0("Share problem / " + msg);
    }

    function isWorkoutFromPlan() {
        if (mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Plan") {
            return true;
        } else {
            return false;
        }
    }

    function sendDataToAnalytics(type, isCurrentUserOneWhoFinished) {

        var isFromPlan = isWorkoutFromPlan();

        var data = {
            "Source": "Result screen",
            "Type": type, // link or picture,
            "Current user w.": isCurrentUserOneWhoFinished ? "Current user" : "Other user",
            "Workout type": isFromPlan ? "From Plan" : "Single",

        };

        mad.analyticEvents.track([mad.analyticEvents.services.MIXP], mad.analyticEvents.categories.MAX, mad.analyticEvents.types.EVENT,
            "Share workout",
            data,
            "Share workout",
            "", "Click on share");
    }


    return {
        viewModel: viewModel
    };

}());

