var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.workoutStat = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        beforeShow: beforeShow,
        show: showView,
        afterShow: afterShow,

        takenPhoto: "",
        takenPhotoInfo: {},
        photoNotTaken: true,

        noComment: true,

        hideSaveWorkoutButton: hideSaveWorkoutButton,
        ifWorkoutSaved: false,
        adjustHeight: adjustHeight,

        progress: progressPercentage,
        progressColor: progressColor,

        score: 0,
        targetScore: 0,

        uCanTouchThis: false,
        origin: "",

        results: {},
        comparison: [],
        firstWorkout: true,
        PercentageOfMusclesHit: 0,
        LastCycle: 0,
        TotalCycles: 0,
        workoutName: "",
        WorkoutTime: "",    //formated
        totalWorkoutTime: "",
        PauseTime: "",
        pausePercentage: "",
        workoutPercentage: "",
        WorkoutScore: 0,
        accomplishment: "",
        bestExerciseValue: "",  // postavljeno u madbarzWorkout
        bestExerciseName: ""   // postavljeno u madbarzWorkout
    });

    //var commentsTopPosition = 0;

    function initView(e){
        var viewID = "#madbarzWorkoutStat";

        viewModel.set("uCanTouchThis", false);

        $(viewID).kendoTouch({
            filter: ".rButton, .mainContainer, .takePhotoGumb, .saveTap, .unsaveTap, .editPhotoGumb, .commentGumb, .comment-content, .comment-value, .comment-OK",
            touchstart: function(e) {
                console.log("touchstart");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    console.log("touchstart but canceled")
                }
            },
            tap: function(e) {
                //console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    console.log("but canceled")
                }else{
                    handleTap(e);
                }
            }
        });
    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target;

        if ($(element).hasClass("rButton")) {
            rightButtonAction();
        }else if ($(element).hasClass("takePhotoGumb")) {
            selectPhoto(e);
        }else if ($(element).hasClass("saveTap")) {
            mad.viewModels.madbarzWorkout.saveWorkout();
        }else if ($(element).hasClass("unsaveTap")) {
            mad.viewModels.madbarzWorkout.removeFromSaved();
        }else if ($(element).hasClass("editPhotoGumb")) {
            selectPhoto(e);
        }else if ($(element).hasClass("commentGumb") || $(element).hasClass("comment-content") || $(element).hasClass("comment-value")) {
            focusComment();
        }else if ($(element).hasClass("comment-OK") || $(element).hasClass("mainContainer")){
            defocusComment();
        }
    }

    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e){
        mad.common.setActualView(); mad.common.addViewToHistory();
        mad.common.stretchView();

        var origin = e.view.params.origin;
        viewModel.set("origin", origin);

        if (origin != "madbarzWorkoutStatShare"){
            prepare();                              // prepare data
        }

        kendo.bind($(mad.common.$actualViewID), viewModel);

        var contentHeight, contentWidth;

        contentHeight = parseInt(mad.mobileApp.view().content.height());
        contentWidth  = parseInt(mad.mobileApp.view().content.width());

        var scroller =  $("#workoutStat-scroller");
        var scrollerWidget= scroller.data("kendoMobileScroller");

        scroller.css({"height": contentHeight, "width": contentWidth});

        scrollerWidget.reset();                                         // go to top
    }

    function afterShow(e) {
        viewModel.set("uCanTouchThis", true);

        var origin = viewModel.get("origin");

        if (origin != "madbarzWorkoutStatShare"){
            if (mad.common.observables.networkStatus == "online") {
                animateCounter(0, viewModel.get("score"), 5000);
            }else {
                animateCounter(0, viewModel.get("score"), 3000);
            }
            mad.googleAnalytics.trackView("Workouts - Result");
        }
    }

    function animateCounter(s,e,d){
        $('#scoredPoints').animatedCounter({
            start: s,
            end:e,
            duration: d
        });
    }

    function rightButtonAction(){
        // go to next view
        mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkoutStatShare.html?origin=routineStat", "slide:left");
    }

    function focusComment(){

        $(".entryField-comment").removeClass("hidden");
        $(".comment-value").focus();

        /*
        if (kendo.support.mobileOS.device == "android" || window.navigator.simulator) {
            $("#workoutStatContainer .zamraci").addClass("defocus");
        }
        */
        $("#workoutStatContainer .zamraci").addClass("defocus");
    }

    function defocusComment(){

        $(".comment-value").blur();
        $(".entryField-comment").addClass("hidden");

        //if (viewModel.get("sadrzajKomentara") !=""){
        if (viewModel.get("sadrzajKomentara").trim().length>0){
            viewModel.set("noComment", false);
        }else{
            viewModel.set("noComment", true);
        }

        $("#workoutStatContainer .zamraci").removeClass("defocus");
        $("#workoutStat-scroller").data("kendoMobileScroller").contentResized();
    }

    function adjustHeight(o) {
        var minHeight= 3;
        var object = o.currentTarget;

        object.style.height  = "1px";
        object.style.height = (minHeight + object.scrollHeight)+"px";
    }

    function selectPhoto(e){
        if (e){
            e.preventDefault();
        }

        var inst;

        //if (!mad.viewModels.workoutStat.viewModel.results.HasUploadedProfilePhoto && mad.viewModels.workoutStat.viewModel.get("takenPhoto") == "images/no_photo_workout.jpg"){
        // ako nema profilnu i nije vec uploadana pitaj oce li fotkat ili izabrat neku
        if (viewModel.get("photoNotTaken")){
            // ako nije dodana nova fotka pitaj oce li fotkat ili izabrat neku iz galerije
            inst = $(".actionsheetphotoupload").mobiscroll("getInst");
        }else{
            // ak vec ima neka ponudi edit ili opet
            inst = $(".actionsheetphotosource").mobiscroll("getInst");
            inst.settings.wheels = [[{values: ["Edit photo", "Upload new"]}]];       //ako slucajno treba promjenit defaultno
        }
        setTimeout(function () {
            inst.show(false, false);
        }, 22);
    }

    function progressPercentage(){
        var LastScore = this.results.get("LastTreningScore");
        var ThisScore = this.results.get("TreningScore");
        if (LastScore === 0){
            return "100%";
        }
        else{
            var prog = Math.round(((ThisScore / LastScore) * 100) - 100);
            if (prog > 999){
                return "> 999 %";
            }else{
                return String(prog).replace('', '') + "%";
            }
        }
    }

    function progressColor(){
        var LastScore = this.results.get("LastTreningScore");
        var ThisScore = this.results.get("TreningScore");
        if (LastScore === 0)
            return "results-value positive";
        if ((((ThisScore / LastScore) * 100) - 100) < 0)
            return "results-value negative";
        else
            return "results-value positive";
    }

    /* not in viewModel Context  - - - - - -  */
    function prepare(){

        viewModel.set("noComment", true);
        viewModel.set("sadrzajKomentara", "");
        viewModel.set("photoNotTaken", true);

        if (viewModel.results.HasUploadedProfilePhoto){
            viewModel.set("takenPhoto", mad.viewModels.workoutStat.viewModel.results.ProfilePhotoUrl);
        }else{
            viewModel.set("takenPhoto", "images/no_photo_workout.jpg");
        }

        //viewModel.set("ifWorkoutSaved", false);
        viewModel.set("ifWorkoutSaved", mad.viewModels.madbarzWorkout.viewModel.get("isWorkoutSaved"));

        mad.common.variables.showGender = mad.common.variables.gender;

        //check if there were workouts before
        if (mad.viewModels.workoutStat.viewModel.results.LastTreningResults === null) {
            mad.viewModels.workoutStat.viewModel.set("firstWorkout", true);
        }else{
            var lastWorkout = 0;
            _.each(mad.viewModels.workoutStat.viewModel.results.LastTreningResults, function (element, index) {
                lastWorkout += element.Value;
            });
            if (lastWorkout != 0) {
                mad.viewModels.workoutStat.viewModel.set("firstWorkout", false);
            }else{
                mad.viewModels.workoutStat.viewModel.set("firstWorkout", true);
            }
        }

        viewModel.set("workoutName", mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("Name"));

        mad.viewModels.workoutStat.viewModel.set("LastCycle", mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("FinishedCycles"));
        mad.viewModels.workoutStat.viewModel.set("TotalCycles", mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("NumberOfCycles"));
        mad.viewModels.workoutStat.viewModel.set("WorkoutTime", mad.common.formatedTime(mad.viewModels.madbarzWorkout.viewModel.get("counters.totalWorkoutTime")));

        mad.viewModels.workoutStat.viewModel.set("totalWorkoutTime", mad.viewModels.madbarzWorkout.viewModel.get("counters.totalWorkoutTime"));
        mad.viewModels.workoutStat.viewModel.set("PauseTime", mad.viewModels.madbarzWorkout.viewModel.get("counters.totalPauseTime"));

        mad.viewModels.workoutStat.viewModel.set("pausePercentage", Math.round(mad.viewModels.workoutStat.viewModel.get("PauseTime") / mad.viewModels.workoutStat.viewModel.get("totalWorkoutTime") * 100));
        var workoutTime =  mad.viewModels.workoutStat.viewModel.get("totalWorkoutTime") - mad.viewModels.workoutStat.viewModel.get("PauseTime");
        mad.viewModels.workoutStat.viewModel.set("workoutPercentage", Math.round((workoutTime / mad.viewModels.workoutStat.viewModel.get("totalWorkoutTime")) * 100));

        //mad.viewModels.workoutStat.viewModel.set("WorkoutScore", mad.viewModels.madbarzWorkoutDone.viewModel.get("score"))
        mad.viewModels.workoutStat.viewModel.set("accomplishment", Math.round(mad.viewModels.workoutStat.viewModel.get("score") * 100 / mad.viewModels.workoutStat.viewModel.get("targetScore")) + "%");

        mad.viewModels.workoutStat.viewModel.set("PercentageOfMusclesHit", Math.round(mad.viewModels.workoutStat.viewModel.results.PercentageOfMusclesHit));

        var template = kendo.template($("#madbarzWorkoutStat-top-template").html(), { useWithBlock: false });
        var result = template(viewModel);        //Pass the data to the compiled template
        $(".workoutStat-top").html(result);

        var template = kendo.template($("#madbarzWorkoutStat-rounds-template").html(), { useWithBlock: false });
        var result = template(viewModel);        //Pass the data to the compiled template
        $(".workoutStat-rounds").html(result);

        mad.viewModels.editPhoto.viewModel.prepareMobiscroll();

        showExercises();
        showMuscles();

        //commentsTopPosition= Math.round($(".workoutStat-comment").offset().top) * -1;
    }

    function showExercises() {
        // prepare comparison data
        mad.viewModels.workoutStat.viewModel.set("comparison", []);

        _(mad.viewModels.workoutStat.viewModel.results.get("TreningResults")).forEach(function (current, index) {

            var found = _(mad.viewModels.workoutStat.viewModel.results.get("LastTreningResults")).find(function (last) {
                return last.Id === current.Id;
            });
            var before = 0;
            if (found !== null && found !== undefined) {
                before = found.Value;
            }

            var formmatedVal = current.Value;

            if (current.Unit !== 'reps') {
                formmatedVal = mad.common.formatTimeForDisplayingTimedExercises(current.Value);
            }else{
                formmatedVal += " Reps";
            }

            var itm = {
                Name: current.Name,
                OldValue: before,
                NewValue: current.Value,
                FormmatedNewVal : formmatedVal,
                Unit: current.Unit,
                ImageUrlMobile: current.ImageUrlMobile
            };
            mad.viewModels.workoutStat.viewModel.get("comparison").push(itm);
        }).value();

        var template = kendo.template($("#madbarzWorkoutStat-exercises-template").html(), { useWithBlock: false });
        var result = template(viewModel);        //Pass the data to the compiled template
        $(".workoutStat-list").html(result);
    }

    function showMuscles(){
        var musclesTemplate = kendo.template($("#stat-muscles-template").html());
        var musclesHTML = musclesTemplate(mad.viewModels.workoutStat.viewModel);
        $(".workoutStat-mm").html(musclesHTML);

        // generate muscle imgs
        musclesTemplate = kendo.template($("#MuscleMapTemplate").html(), {useWithBlock:false});
        musclesHTML = musclesTemplate(mad.viewModels.workoutStat.viewModel.results.MuscleIds);
        $("#madbarzWorkoutStat-muscles-imgs").html(musclesHTML);

        setTimeout(function () {
            var contentHeight= parseInt(mad.mobileApp.view().content.height());
            var reduce = 25 / 100;                               //percentage
            var muscleManContainerHeight = parseInt(contentHeight - (contentHeight * reduce));
            var contentWidth  = parseInt(mad.mobileApp.view().content.width());
            $(".workoutStat-mm .muscles-container").css("height", muscleManContainerHeight);
            mad.common.scaleMuscleMan2(muscleManContainerHeight,contentWidth, 10);
        }, 234);

    }

    function hideSaveWorkoutButton() {

        //return true;

        var isFromPlan = mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Plan";
        var isPro = mad.viewModels.madbarzWorkout.viewModel.get("selectedWorkout.IsPro");
        return isFromPlan || isPro;
    }

    return {
        viewModel: viewModel
    };

}());

