var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.madbarzWorkout = (function() {
  "use strict";

  var cekam, cekamDaZavrsiSejvanje;

  var viewModel = kendo.observable({
    // properties or functions we want to observe and expose to html
    common: mad.common.observables,

    init: initView,
    beforeShow: beforeShow,
    show: showView,
    afterShow: afterShow,
    beforeHide: beforeHide,
    showWarmup: showWarmup,
    goBack: mad.common.goBack,
    startAfterWarmup: startAfterWarmup,

    ifSavedWorkout: ifSavedWorkout,
    ifWorkoutPlan: ifWorkoutPlan,
    ifFromPlanOrSaved: ifFromPlanOrSaved,

    hideSaveWorkoutButton: hideSaveWorkoutButton,
    firstTimeHere: false,

    titlePressed: mad.common.titlePressed,
    footerEnabled: false,
    checkReps: true, //true=hidden
    isMadbarzWorkout: true,
    isWorkoutSaved: false,
    savedWorkoutChanges: false,
    lastExerciseIndex: 0,
    workoutType: "unknown",
    selectedWorkout: {},

    selectedExercise: {},
    nextExercise: {},

    counters: {
      totalWorkoutTime: 0,
      totalPauseTime: 0,
      pauseCountdown: 0
    },

    origin: "?",
    pauseExit: 0,
    pauseResume: 0,
    brojac: 0,

    showPopup: false,
    saveSavedWorkouts: toSavedWorkouts,
    editSavedWorkouts: editSavedWorkouts,

    uCanTouchThis: false,

    pause: "unknown",
    status: "unknown"
  });

  var pauza = kendo.observable({
    brojac: new mad.common.countdownTimer(25, 0, countdown)
  });

  var tmpSelectedWorkout = {}; // for extending selectedWorkout before binding
  var startPauseLength = 0;

  function initView(e) {
    mad.viewModels.madbarzWorkout.pauza.bind(
      "started",
      pocetakOdbrojavanjaPauze
    );
    mad.viewModels.madbarzWorkout.pauza.bind(
      "finished",
      zavrsetakOdbrojavanjaPauze
    );

    var viewID = "#madbarzWorkout";
    viewModel.set("uCanTouchThis", false);
    var scroller = e.view.scroller;

    $(viewID).kendoTouch({
      filter:
        ".lButton, .skipWorkout, .editSavedWorkout, .mTitle, .dButton, .toInstructions, .toEdit, .repsHint, .saveButton, .tempoSetupPauseButton, .show-more, .show-less",
      touchstart: function(e) {
        //console.log("touchstart");
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          //console.log("touchstart but canceled")
          if (scroller) {
            if (scroller.enabled) {
              scroller.disable();
            }
          }
        } else {
          if (scroller) {
            if (!scroller.enabled) {
              scroller.enable();
            }
          }
        }
      },
      tap: function(e) {
        //console.log(e.touch.target, " was tapped");
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          console.log("but canceled");
        } else {
          handleTap(e);
        }
      }
    });

    $("#madbarzWorkout-list").kendoMobileListView({
      autoBind: false,
      endlessScroll: false,
      dataBinding: function(e) {
        viewModel.set("brojac", 0);
      },
      template: function(data) {
        var br = viewModel.get("brojac") + 1;
        viewModel.set("brojac", br);
        var tpl = kendo.template($("#madbarzWorkout-list-template").html(), {
          useWithBlock: false
        });
        if (viewModel.get("firstTimeHere") && br == 2) {
          data.showTooltip = true;
        } else {
          data.showTooltip = false;
        }
        return tpl(data);
      }
    });
  }

  function handleTap(e) {
    e.preventDefault(); // da ne probija

    var element = e.touch.target;

    if ($(element).hasClass("lButton")) {
      leftButtonAction();
    } else if ($(element).hasClass("skipWorkout")) {
      skipWorkoutTap();
    } else if ($(element).hasClass("mTitle")) {
      mad.common.titlePressed();
    } else if ($(element).hasClass("dButton")) {
      startWorkout();
    } else if ($(element).hasClass("repsHint")) {
      viewModel.set("firstTimeHere", false);
      $(element).addClass("hidden"); // hide tooltip
    } else if ($(element).hasClass("toInstructions")) {
      mad.viewModels.workoutVideo.viewModel.set(
        "selectedExercise",
        getSelectedByUID(element)
      ); //potrebno za video
      mad.viewModels.workoutVideo.viewModel.openVideoModal();
    } else if ($(element).hasClass("toEdit")) {
      mad.viewModels.madbarzWorkout.viewModel.set(
        "selectedExercise",
        getSelectedByUID(element)
      );
      mad.mobileApp.navigate("ui/workouts/madbarz/workout/editReps.html");
    } else if ($(element).hasClass("saveButton")) {
      toggleSavedWorkouts(e);
    } else if ($(element).hasClass("editSavedWorkout")) {
      editSavedWorkouts();
    } else if ($(element).hasClass("tempoSetupPauseButton")) {
      incrementPause(e);
    } else if (
      $(element).hasClass("show-more") ||
      $(element).hasClass("show-less")
    ) {
      mad.common.showMore(e);
    }
  }

  function getSelectedByUID(element) {
    var uidElement = element.closest("li");
    var selectedUID = uidElement.attr("data-uid");
    var listElement = $(uidElement.parent());
    var listview = $(listElement).data("kendoMobileListView");
    var selectedItem = listview.dataSource.getByUid(selectedUID);
    if (mad.common.isNullOrEmpty(selectedItem)) {
      return {};
    } else {
      return selectedItem;
    }
  }

  function showWarmup(e) {
    mad.common.setActualView();
    mad.common.addViewToHistory(); // drazen - jeli ovo dobro nakon povratka s editReps
  }

  function beforeShow(e) {
    $("#madbarzWorkout").removeClass("transBack");
    viewModel.set("uCanTouchThis", false);

    // za svaki slucaj (pojavljuje se povremeno bug da misicavko nema tijelo neg samo misice)
    if (
      mad.common.variables.gender === undefined ||
      (mad.common.variables.gender != "f" && mad.common.variables.gender != "m")
    ) {
      mad.common.variables.gender = "m";
    }
  }

  function showView(e) {
    var contentWidth, contentHeight;
    var scroller = e.view.scroller;

    viewModel.set("firstTimeHere", checkTutorial());

    mad.common.setActualView();
    mad.common.addViewToHistory(); // drazen - jeli ovo dobro nakon povratka s editReps
    contentHeight = mad.common.stretchViewContentToBeElastic();
    contentWidth = $(window).width(); // jquery width
    setViewTitle();

    mad.common.variables.showGender =
      mad.common.variables.gender == "f" ? "f" : "m";

    // bind viewModel to view
    if (mad.common.$actualViewID == "#madbarzWorkout") {
      kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    $("#madbarzWorkout-muscles").show();

    var origin = e.view.params.origin;
    viewModel.set("origin", origin);

    if (origin == "editReps") {
      afterEditReps();
      return;
    }

    viewModel.set("status", "working out");
    viewModel.set("savedWorkoutChanges", false);
    viewModel.set("showPopup", false);

    if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz"
    ) {
      viewModel.set("isMadbarzWorkout", true);
      //postavi za pocetak selectedWorkout kako bi se ubrzalo generiranje (kasnije ucitaj repse)
      mad.viewModels.madbarzWorkout.viewModel.set("footerEnabled", false);

      //viewModel.set("selectedWorkout", mad.viewModels.madbarzWorkoutS.viewModel.selectedWorkout);
      viewModel.set(
        "selectedWorkout",
        mad.viewModels.madbarzRoutines.viewModel.selectedWorkout
      );

      prepareMadbarz();
    } else if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Saved"
    ) {
      viewModel.set("isMadbarzWorkout", false);
      mad.viewModels.madbarzWorkout.viewModel.set("footerEnabled", true);
      viewModel.set(
        "selectedWorkout",
        mad.viewModels.madbarzSavedWorkoutS.viewModel.selectedWorkout
      );
      prepareSaved();
      console.log("ucitani sejvani wktsi", viewModel.get("selectedWorkout"));
    } else if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Plan"
    ) {
      viewModel.set("isMadbarzWorkout", true);
      mad.viewModels.madbarzWorkout.viewModel.set("footerEnabled", true);
      viewModel.set(
        "selectedWorkout",
        mad.viewModels.plansWork.viewModel.selectedWorkout
      );
      preparePlan();
    } else {
      console.log("ERROR - not valid workout type");
      return false;
    }

    // generate top part content -----------------------------------------------
    var tTemplate = kendo.template($("#madbarzWorkout-top-template").html());
    var tHTML = tTemplate(mad.viewModels.madbarzWorkout.viewModel);
    $("#madbarzWorkout-top").html(tHTML);

    // generate muscle man -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
    var musclesTemplate = kendo.template($("#muscles-template").html());
    var musclesHTML = musclesTemplate(mad.viewModels.madbarzWorkout.viewModel);
    $("#madbarzWorkout-muscles")
      .html(musclesHTML)
      .addClass(mad.common.observables.selectedLanguage); // put generated html & add language to class

    // generate muscle imgs
    musclesTemplate = kendo.template($("#MuscleMapTemplate").html(), {
      useWithBlock: false
    });
    musclesHTML = musclesTemplate(
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.MuscleIds
    );
    $("#madbarzWorkout-muscles-imgs").html(musclesHTML);

    // generete list of exercises -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
    //console.log("eksercajzi iz selectedWorkout", viewModel.selectedWorkout.get("Exercises"));
    $("#madbarzWorkout-list")
      .data("kendoMobileListView")
      .dataSource.data(viewModel.selectedWorkout.get("Exercises"));

    if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz"
    ) {
      $("#madbarzWorkout .workout-reps").css("opacity", 0);
    } else {
      $("#madbarzWorkout-list .forAnimation").removeClass("blured");
      mad.viewModels.madbarzWorkout.viewModel.set("checkReps", false);
    }

    // generate pauses -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
    var pTemplate = kendo.template($("#pause-template").html());
    var pHTML = pTemplate(mad.viewModels.madbarzWorkout.viewModel);
    $("#madbarzWorkout-pauses")
      .html(pHTML)
      .addClass(mad.common.observables.selectedLanguage);
    // unfortunately because it's template we need to bind again
    kendo.bind(
      $("#madbarzWorkout-pauses"),
      mad.viewModels.madbarzWorkout.viewModel
    );

    // generate bottom part content -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
    if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz"
    ) {
      tTemplate = kendo.template($("#madbarzWorkout-bottom-template").html());
      tHTML = tTemplate(mad.viewModels.madbarzWorkout.viewModel);
      $("#madbarzWorkout-bottom").html(tHTML);
    } else {
      $("#madbarzWorkout-bottom").html("");
    }

    //if not a workout plan
    if (mad.viewModels.madbarzWorkout.viewModel.get("workoutType") != "Plan") {
      // -- checking & marking saved workouts
      mad.viewModels.madbarzWorkout.cekam = $.Deferred();
      mad.viewModels.madbarzWorkout.cekam.then(
        function(status) {
          mad.viewModels.madbarzWorkout.viewModel.set("isWorkoutSaved", status); // for star
        },
        function(fail) {
          // -- eventualna greska
        }
      );
      isSaved(); // check if it is saved workout
    }

    if (mad.common.$actualViewID == "#madbarzWorkout") {
      kendo.bind($(mad.common.$actualViewID), viewModel);
    }

    var reduce = 25 / 100; //percentage
    var muscleManContainerHeight = contentHeight - contentHeight * reduce;

    $("#madbarzWorkout-muscles .muscles-container").css(
      "height",
      muscleManContainerHeight
    );
    mad.common.scaleMuscleMan2(muscleManContainerHeight, contentWidth, 10);

    mad.common.shortenDescription();

    $("#madbarzWorkout .margin-wrapper").css("width", contentWidth);
    scroller.reset();
  }

  function afterShow(e) {
    viewModel.set("uCanTouchThis", true);

    if (viewModel.get("origin") == "editReps") {
      return;
    }

    if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz"
    ) {
      viewModel.set("isMadbarzWorkout", true);
      getReps(); // & extend exercises then set selectedWorkout observable in viewModel
    }

    if (viewModel.get("firstTimeHere")) {
      mad.local.appendUsernameTo(
        "visitedWorkouts",
        mad.common.variables.username
      );
    }
  }

  function beforeHide(e) {
    $("#madbarzWorkout-muscles").hide();
    $("#madbarzWorkout").addClass("transBack");
  }

  function checkTutorial() {
    return mad.common.checkTutorial("visitedWorkouts");
  }

  function leftButtonAction() {
    var changes = false,
      exercisesForUpdate = []; //for changed saved exercises

    if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz"
    ) {
      mad.common.goBack();
    } else {
      // za sejvane
      changes = mad.viewModels.madbarzWorkout.viewModel.get(
        "savedWorkoutChanges"
      );

      if (changes) {
        // if there were some changes update in database
        // for saved workout which is changed
        _.forEach(viewModel.selectedWorkout.Exercises, function(
          element,
          index
        ) {
          exercisesForUpdate.push({
            // store info about exercises
            Id: element.SavedExerciseId,
            Reps: element.NewValue
          });
        });
        mad.viewModels.madbarzWorkout.cekamDaZavrsiSejvanje = jQuery.Deferred();
        mad.viewModels.madbarzWorkout.cekamDaZavrsiSejvanje.then(
          function(status) {
            //console.log("after update finished, status=",status)
            mad.viewModels.madbarzWorkout.viewModel.set(
              "savedWorkoutChanges",
              false
            );
            if (checkifOnline()) {
              // only if online
              mad.local.removeVariable("savedWorkouts"); // clear cache - it will be read again when necessary
              mad.viewModels.madbarzSavedWorkoutS.viewModel.set(
                "reloadSavedWorkouts",
                true
              );
            }
            mad.common.goBack();
          },
          function(fail) {
            // -- eventualna greska (moze pokusati ponovo back ali ako ne uspije spremiti nece nikad izaci odavde
            console.log(
              "greska u updateSavedWorkoutsInDB (fail nakon promisa)"
            );
          }
        );
        updateSavedWorkoutsInDB(
          "onBack",
          viewModel.selectedWorkout.Id,
          viewModel.selectedWorkout.Name,
          exercisesForUpdate,
          viewModel.selectedWorkout.NumberOfCycles,
          viewModel.selectedWorkout.ShortPauseLengthInSeconds,
          viewModel.selectedWorkout.LongPauseLengthInSeconds
        );
      } else {
        mad.common.goBack();
      }
    }
  }

  function skipWorkoutTap(e) {
    var msg = mad.glossary.messages.skipWorkout,
      language = mad.common.observables.languageIndex();
    navigator.notification.confirm(
      msg.message[language],
      function(button) {
        if (button == 1) {
          // and you want to cancel it
          skipWorkout();
        }
      },
      msg.title[language],
      [msg.button1[language], msg.button2[language]]
    );
  }

  function skipWorkout() {
    var gotoLink = "ui/plans/work.html?origin=madbarzWorkout&skipped=yes";

    var imgTmp;

    // prepare data
    var dataToSave = {};

    dataToSave.ExecutionId = mad.viewModels.plansWork.viewModel.get(
      "selectedPlan.ActiveExecution.ExecutionData.Id"
    );
    dataToSave.WeekOrdinal = mad.viewModels.plansWork.viewModel.get(
      "selectedPlan.ActiveExecution.ExecutionData.CurrentWeek"
    );
    dataToSave.WorkoutOrdinal = mad.viewModels.plansWork.viewModel.get(
      "selectedWorkout.WorkoutOrdinal"
    );

    if (mad.common.observables.networkStatus == "online") {
      // if we are online
      /*
            mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/WorkoutPlans/SaveWorkoutActivity";
            mad.common.variables.forAjax.akcija = "POST";
            mad.common.variables.dataOptions = dataToSave;
            */
      var link = {
        putanja:
          mad.common.variables.serverUrl +
          "api/WorkoutPlans/SaveWorkoutActivity",
        akcija: "POST"
      };
      var podaci = dataToSave;

      mad.data
        .post(link, podaci, false)
        .done(function(data, code) {
          console.log("skip - nakon slanja podataka response je", data);

          // postavi execution data aktivnog plana
          imgTmp = mad.viewModels.plansWork.viewModel.get(
            "selectedPlan.ActiveExecution.ExecutionData.ImageUrl"
          ); // save image url
          mad.viewModels.plansWork.viewModel.set(
            "selectedPlan.ActiveExecution.ExecutionData",
            data.Execution
          );
          mad.viewModels.plansWork.viewModel.set(
            "selectedPlan.ActiveExecution.ExecutionData.ImageUrl",
            imgTmp
          ); // restore img

          //mad.common.hideLoader();
          var additionalInfo = {
            "Part Name": mad.viewModels.plansWork.viewModel.get(
              "selectedPlan.Name"
            ),
            "Part Ordinal Name": mad.viewModels.plansWork.viewModel.get(
              "selectedPlan.CategoryOrdinalName"
            ),
            "Workout name":
              "Week: " +
              dataToSave.WeekOrdinal +
              " - Workout: " +
              dataToSave.WorkoutOrdinal
          };

          //analytics services where we send data, category of evenet (max is allways sent), event type (such as event, view, purchase), event name, any additional info, event categorz, event action
          mad.analyticEvents.track(
            [mad.analyticEvents.services.GA],
            mad.analyticEvents.categories.WORKOUTPLAN,
            mad.analyticEvents.types.EVENT,
            "Workout Plan - Workout - Skipped",
            additionalInfo,
            "Workout Plan",
            "Workout",
            "Skipped"
          );

          if (data.Execution.Status == "finished") {
            additionalInfo = {
              "Part Name": mad.viewModels.plansWork.viewModel.get(
                "selectedPlan.Name"
              ),
              "Part Ordinal Name": mad.viewModels.plansWork.viewModel.get(
                "selectedPlan.CategoryOrdinalName"
              ),
              "How was it finished": "Skipped workout"
            };

            mad.analyticEvents.track(
              [mad.analyticEvents.services.GA],
              mad.analyticEvents.categories.WORKOUTPLAN,
              mad.analyticEvents.types.EVENT,
              "Workout Plan - Finished",
              additionalInfo,
              "Workout Plan",
              "Finished"
            );

            mad.viewModels.popups.viewModel.openModalWindow(
              "nextPartToList",
              "Well done!",
              "You can now move on to a new plan!",
              "See plans"
            );
          } else {
            // go back to work view
            // remove last from history
            mad.common.removeLastFromHistory();
            mad.mobileApp.navigate(gotoLink, "slide:right"); // go back to workouts
          }
        })
        .fail(function(qXHR, textStatus, errorThrown) {
          console.log("skip - save failed");
          // enable showStats button on madbarzWorkoutDone view (da zavrsi animacija)
          //mad.viewModels.madbarzWorkoutDone.viewModel.set("footerEnabled", true);

          if (textStatus == "timeout") {
            if (mad.common.observables.askAboutWaiting) {
              var msg = mad.glossary.messages.saveTimeout;
              navigator.notification.alert(
                msg.message[mad.common.observables.languageIndex()],
                setTimeout(function() {
                  // dodano spremanje u cache kod timeouta (postoji mogucnost da 2x spremi)
                  mad.local.appendWorkoutPlan(dataToSave);
                  mad.common.removeLastFromHistory();
                  mad.mobileApp.navigate(gotoLink, "slide:right"); // go back to workouts
                }, 1111), // after some time
                msg.title[mad.common.observables.languageIndex()],
                msg.button[mad.common.observables.languageIndex()]
              );
            } else {
              mad.alerts.error(
                mad.glossary.messages.tooLongNotSaved[
                  mad.common.observables.languageIndex()
                ]
              );
              mad.common.removeLastFromHistory();
              mad.mobileApp.navigate(gotoLink, "slide:right"); // go back to workouts
            }
          } else {
            console.log("Error skipping - saving workout ", textStatus, qXHR);
            mad.alerts.error(
              mad.glossary.messages.errorSavingWorkout[
                mad.common.observables.languageIndex()
              ]
            );
            mad.common.removeLastFromHistory();
            mad.mobileApp.navigate(gotoLink, "slide:right"); // go back to workouts
          }
        });
    } else {
      mad.local.appendWorkoutPlan(dataToSave);
      mad.alerts.info(mad.common.translate("messages", "willBeSynced"));
      mad.common.removeLastFromHistory();
      mad.mobileApp.navigate(gotoLink, "slide:right"); // go back to workouts
    }
  }

  function ifSavedWorkout() {
    if (mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Saved") {
      return true;
    } else {
      return false;
    }
  }

  function ifWorkoutPlan() {
    if (mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Plan") {
      return true;
    } else {
      return false;
    }
  }

  function ifFromPlanOrSaved() {
    return ifWorkoutPlan() || ifSavedWorkout();
  }

  function hideSaveWorkoutButton() {
    var isfromPlan =
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Plan";
    var isPro = viewModel.get("selectedWorkout.IsPro");

    return isPro || isfromPlan;
  }

  function startWorkout() {
    var repsTotal = 0,
      lastExerciseIndex = 0,
      changes = false,
      exercisesForUpdate = []; //for changed saved exercises

    changes = mad.viewModels.madbarzWorkout.viewModel.get(
      "savedWorkoutChanges"
    );

    /*
        count total reps,
        find index of last workout,
        prepare data for update saved workouts
        */
    _.forEach(viewModel.selectedWorkout.Exercises, function(element, index) {
      repsTotal += element.NewValue; // count num of reps
      if (element.NewValue > 0) lastExerciseIndex = index; // remember last exer. ndx
      if (
        mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Saved" &&
        changes
      ) {
        // only for saved workouts & there were some changes
        exercisesForUpdate.push({
          // store info about exercises
          Id: element.SavedExerciseId,
          Reps: element.NewValue
        });
      }
    });

    if (repsTotal == 0) {
      mad.alerts.warning("You must have at least one repetition !", "");
    } else {
      // OK - we can prepare data and start with 1st exercise

      //but before that let's update saved workouts if there were some changes
      if (viewModel.get("workoutType") == "Saved" && changes) {
        mad.viewModels.madbarzWorkout.cekamDaZavrsiSejvanje = jQuery.Deferred(); //ovdje se zapravo NE koristi promise da bi odmah krenulo vježbanje
        updateSavedWorkoutsInDB(
          "onStart",
          viewModel.selectedWorkout.Id,
          viewModel.selectedWorkout.Name,
          exercisesForUpdate,
          viewModel.selectedWorkout.NumberOfCycles,
          viewModel.selectedWorkout.ShortPauseLengthInSeconds,
          viewModel.selectedWorkout.LongPauseLengthInSeconds
        );
        //update this regardless of result
        viewModel.set("savedWorkoutChanges", false);
        if (checkifOnline()) {
          // only if online
          mad.local.removeVariable("savedWorkouts"); // clear cache - it will be read again when necessary
        }
      }
      var typeText =
        viewModel.get("workoutType") == "Madbarz"
          ? "Madbarz routine"
          : "Saved workout";
      var numOfWorkoutsForThisUserSoFar = parseInt(
        mad.local.loadVariable("NumberOfFinishedWorkouts")
      );
      mad.googleAnalytics.trackEvent(
        "Training Activity",
        "Click - Start Workout",
        typeText,
        numOfWorkoutsForThisUserSoFar
      );
      mad.facebookAnalytics.trackEvent("Workout Start", {}, 0);

      viewModel.set("lastExerciseIndex", lastExerciseIndex + 1);
      extendSelectedWorkout();

      // stavi brojac za ukupnu pauzu na 0
      viewModel.set("counters.totalPauseTime", 0);
      // isto tako brojac ukupnog trajanja vjezbanja
      viewModel.set("counters.totalWorkoutTime", 0);

      //brojanje u counters.totalWorkoutTime pokrenut ce se u exercise

      // show warmup message if necessary
      if (!showWarmupReminder()) {
        selectNextExercise("do");
      }
    }
  }

  function showWarmupReminder() {
    var viewShown;
    var reminder = mad.local.loadVariable("WarmupReminder");

    if (reminder === null || reminder === "undefined" || reminder === "") {
      mad.mobileApp.navigate("ui/workouts/madbarz/workout/Warmup.html");
      viewShown = true;
    } else {
      viewShown = false;
    }
    return viewShown;
  }

  function startAfterWarmup() {
    var deactivate = $("#warmupDeactivate").prop("checked");
    if (deactivate) {
      mad.local.saveVariable("WarmupReminder", true);
    }
    //mad.common.removeLastFromHistory();
    selectNextExercise("do");
    event.preventDefault();
  }

  function getWord(word) {
    return mad.common.translate("words", word);
  }

  //** ---- not in viewModel Context - - - - - - - - - - -  - - - - - -
  function setupView() {
    mad.common.stretchView();
    setViewTitle();
    mad.common.setResolutionForView(
      parseInt(mad.mobileApp.view().content.width()),
      parseInt(mad.mobileApp.view().content.height())
    );
    mad.common.setLangForView();
  }

  function prepareMadbarz() {
    //prepare madbarz routine exercises for display for 1st time
    _.forEach(
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("Exercises"),
      function(exercise, i) {
        // do some extending
        // we'll skip OrdinalNum... for now because it is already ordered
        // and add Unit & Quantity (for easier displaying and strange name which tell us nothing)

        _.assign(
          exercise,
          { RoutineExerciseId: "" }, // to be assigned later
          {
            Unit: exercise.IsTimed
              ? mad.glossary.ui.madbarzWorkout.labels.sec[
                  mad.common.observables.languageIndex()
                ]
              : mad.glossary.ui.madbarzWorkout.labels.reps[
                  mad.common.observables.languageIndex()
                ]
          },
          { Cycle: 0 },
          { LengthInSeconds: 0 }, // trajanje vjezbanja jednog exercisea
          { NumberOfReps: 0 },
          { OldValue: 0 }, // to be assigned later
          { NewValue: 0 } // to be assigned later
        );
      }
    );
  }

  function preparePlan() {
    //prepare workout plan routine exercises for display for 1st time
    //mad.viewModels.madbarzWorkout.viewModel.set("selectedWorkout.AvgWorkoutTime", mad.common.formatedTime(mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.AvgWorkoutDuration));
    var tmpTime;
    var duration =
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout
        .AvgWorkoutDuration;

    if (duration == 0) {
      tmpTime = "N/A";
    } else {
      tmpTime = mad.common.formatedTime(duration);
    }
    mad.viewModels.madbarzWorkout.viewModel.set(
      "selectedWorkout.AvgWorkoutTime",
      tmpTime
    );

    _.forEach(
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get("Exercises"),
      function(exercise, i) {
        // do some extending
        // we'll skip OrdinalNum... for now because it is already ordered
        // and add Unit & Quantity (for easier displaying and strange name which tell us nothing)

        _.assign(
          exercise,
          { RoutineExerciseId: exercise.ExerciseId }, // to be assigned later
          {
            Unit: exercise.IsTimed
              ? mad.glossary.ui.madbarzWorkout.labels.sec[
                  mad.common.observables.languageIndex()
                ]
              : mad.glossary.ui.madbarzWorkout.labels.reps[
                  mad.common.observables.languageIndex()
                ]
          },
          { Cycle: 0 },
          { LengthInSeconds: 0 }, // trajanje vjezbanja jednog exercisea
          { NumberOfReps: 0 },
          { OldValue: exercise.Reps }, // to be assigned later
          { NewValue: exercise.Reps } // to be assigned later
        );
      }
    );
  }

  function prepareSaved() {
    // prepare saved workout to look same as regular madbarz workout
    mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.CardioPercentage =
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.Cardio;
    mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.StrengthPercentage =
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.Strength;
    mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.Exercises = [];
    _.forEach(
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.ExercisesAndReps,
      function(exercise, i) {
        var oneExercise = _.clone(exercise.m_Item1.Exercise);

        _.assign(
          oneExercise,
          { InternalNdx: i },
          { RoutineExerciseId: exercise.m_Item1.RoutineExerciseId },
          { SavedExerciseId: exercise.m_Item1.SavedExerciseId },
          {
            Unit: oneExercise.IsTimed
              ? mad.glossary.ui.madbarzWorkout.labels.sec[
                  mad.common.observables.languageIndex()
                ]
              : mad.glossary.ui.madbarzWorkout.labels.reps[
                  mad.common.observables.languageIndex()
                ]
          },
          { MuscleIds: exercise.m_Item1.MuscleHits },
          { Categories: exercise.m_Item1.Categories },
          { Cycle: 0 },
          { LengthInSeconds: 0 }, //set to ExercisingTime
          { NumberOfReps: 0 }, //actual NumberOfReps done
          { OldValue: exercise.m_Item2 }, //it was 0 before
          { NewValue: exercise.m_Item2 } //new default NumberOfReps set
        );
        mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.Exercises.push(
          oneExercise
        );
      }
    );
  }

  function getReps() {
    // we'll use tmp variable first to store selectedWorkout from madbarzWorkoutS view model
    //tmpSelectedWorkout = mad.viewModels.madbarzWorkoutS.viewModel.selectedWorkout;
    tmpSelectedWorkout =
      mad.viewModels.madbarzRoutines.viewModel.selectedWorkout;

    // ucitavanje Reps-a za exercises
    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/EditWorkout/GetNumberOfRepsForExericseInRoutine";
        mad.common.variables.forAjax.akcija = "GET";
        mad.common.variables.dataOptions = {
            id: tmpSelectedWorkout.RoutineId
        };
        */
    var link = {
      putanja:
        mad.common.variables.serverUrl +
        "api/EditWorkout/GetNumberOfRepsForExericseInRoutine",
      akcija: "GET"
    };
    var podaci = {
      id: tmpSelectedWorkout.RoutineId
    };

    mad.data
      .load(link, podaci, false, true) // don't use cache
      .done(function(data) {
        // we are moving relevant data to selectedWorkout object
        // this assumes same exercises in same order for both arrays
        _.forEach(tmpSelectedWorkout.Exercises, function(exercise, i) {
          // do some extending
          // we'll skip OrdinalNum... for now because it is already ordered
          // and add Unit & Quantity (for easier displaying and strange name which tell us nothing)

          _.assign(
            exercise,
            { RoutineExerciseId: data[i].m_Item1.RoutineExerciseId },
            { VideoUrl: data[i].m_Item1.Exercise.VideoUrl },
            { ImageUrlMobile: data[i].m_Item1.Exercise.ImageUrlMobile },
            { Description: data[i].m_Item1.Exercise.Description },
            { OldValue: data[i].m_Item2 }, //it was 0 before
            { NewValue: data[i].m_Item2 } //new default NumberOfReps set
          );
        });

        // move tmp to observable selectedWorkout of THIS view model
        mad.viewModels.madbarzWorkout.viewModel.set(
          "selectedWorkout",
          tmpSelectedWorkout
        );
        mad.viewModels.madbarzWorkout.viewModel.set("footerEnabled", true);

        // animate reps

        // drazen - ovo rijesi - ovaj refresh zajebe showtooltip
        // tj. radi s viewModel.set("firstItem", false); koji se postavi u gen. templejtu

        $("#madbarzWorkout-list")
          .data("kendoMobileListView")
          .refresh();
        $("#madbarzWorkout .workout-reps").css("opacity", 0);
        setTimeout(function() {
          $("#madbarzWorkout .workout-reps").css("opacity", 1);
        }, 11);
      })
      .fail(function(e, r, t) {
        mad.alerts.error("error loading reps", "");
      });
  }

  function updateReps() {
    // update reps if they are changed in pause time (or skip is pressed) (or for last exercise)
    var storedReps = _.last(
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
        "finishedExercises"
      )
    ).NumberOfReps;
    var currentReps = mad.viewModels.madbarzExercising.viewModel.selectedExercise.get(
      "NumberOfReps"
    );

    if (currentReps != storedReps) {
      _.last(
        mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
          "finishedExercises"
        )
      ).NumberOfReps = currentReps;
    }
  }

  function extendSelectedWorkout() {
    _.assign(
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout,
      {
        total: {
          cycles:
            mad.viewModels.madbarzWorkout.viewModel.selectedWorkout
              .NumberOfCycles,
          exercises: mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
            "Exercises"
          ).length,
          lastExercise: mad.viewModels.madbarzWorkout.viewModel.get(
            "lastExerciseIndex"
          )
        }
      },
      {
        counter: {
          cycle: 1,
          exercise: 0,
          nextCycle: 1,
          nextExercise: 0,
          lastExerciseDoneNdx: 0
        }
      },
      {
        finishedExercises: [],
        TotalTime: 0,
        TotalPause: 0,
        FinishedCycles: 0,
        PercentageOfCompleteness: 0
      }
    );
  }

  function selectNextExercise(modus) {
    if (modus != "do" && modus != "check") {
      console.log("pogrešan mod");
      return;
    }
    var totalCycles = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      "total.cycles"
    );
    var totalExercises = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      "total.exercises"
    );
    var lastExercise = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      "total.lastExercise"
    );

    var currentExercise, currentCycle;

    if (modus == "do") {
      currentExercise = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
        "counter.exercise"
      );
      currentCycle = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
        "counter.cycle"
      );
    } else {
      currentExercise = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
        "counter.nextExercise"
      );
      currentCycle = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
        "counter.nextCycle"
      );
    }

    if (currentExercise < totalExercises) {
      currentExercise += 1;
    } else {
      currentCycle += 1;
      currentExercise = 1;
    }

    if (currentCycle > totalCycles) {
      if (modus == "do") workoutDone();
    } else {
      if (modus == "do") {
        mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.set(
          "counter.exercise",
          currentExercise
        );
        mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.set(
          "counter.cycle",
          currentCycle
        );

        //move excersise from selectedWorkout to selectedExercise
        mad.viewModels.madbarzWorkout.viewModel.set(
          "selectedExercise",
          mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
            "Exercises"
          )[currentExercise - 1]
        );
        mad.viewModels.madbarzWorkout.viewModel.selectedExercise.set(
          "Cycle",
          currentCycle
        );

        console.log(
          "cycle: " + currentCycle + "/" + totalCycles,
          "exercise: " + currentExercise + "/" + totalExercises,
          mad.viewModels.madbarzWorkout.viewModel.selectedExercise.Name
        );

        if (
          mad.viewModels.madbarzWorkout.viewModel.selectedExercise.NewValue ===
            0 ||
          mad.viewModels.madbarzWorkout.viewModel.get("status") ==
            "quiting workout"
        ) {
          //quiting is set in exercisingVmodel
          addSkippedToFinishedExercises();
          selectNextExercise(modus);
        } else {
          setTimeout(function() {
            //we need cycle in case there is only 1 exercise repeating & current exercise number in case that consecutive exercises are same
            mad.mobileApp.navigate(
              "ui/workouts/madbarz/workout/madbarzExercising.html?id=" +
                mad.viewModels.madbarzWorkout.viewModel.get(
                  "selectedExercise.ExerciseId"
                ) +
                "&cycle=" +
                currentCycle +
                "&ex=" +
                currentExercise,
              "overlay:left"
            );
          }, 22);
        }
      } else {
        mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.set(
          "counter.nextExercise",
          currentExercise
        );
        mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.set(
          "counter.nextCycle",
          currentCycle
        );

        //move excersise from selectedWorkout to nextExercise
        mad.viewModels.madbarzWorkout.viewModel.set(
          "nextExercise",
          mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
            "Exercises"
          )[currentExercise - 1]
        );
        mad.viewModels.madbarzWorkout.viewModel.nextExercise.set(
          "Cycle",
          currentCycle
        );

        //console.log("next cycle: " + currentCycle + "/" + totalCycles, "next exercise: " + currentExercise + "/" + totalExercises, mad.viewModels.madbarzWorkout.viewModel.nextExercise.Name);

        if (
          mad.viewModels.madbarzWorkout.viewModel.nextExercise.NewValue === 0
        ) {
          selectNextExercise(modus);
        }
      }
    }
  }

  function addSkippedToFinishedExercises() {
    var exercise = _.clone(
      mad.viewModels.madbarzWorkout.viewModel.get("selectedExercise")
    );
    exercise.LengthInSeconds = 0;
    exercise.NumberOfReps = 0;
    mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.finishedExercises.push(
      exercise
    );
  }

  function addExerciseToFinishedExercises() {
    var exercise = _.clone(
      mad.viewModels.madbarzExercising.viewModel.get("selectedExercise")
    );
    mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.finishedExercises.push(
      exercise
    );

    // store total number of exercises done
    mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.set(
      "counter.lastExerciseDoneNdx",
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.finishedExercises
        .length
    );

    // save last cycle number
    var lastExercise = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      "total.lastExercise"
    );
    var currentExercise = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      "counter.exercise"
    );
    var currentCycle = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      "counter.cycle"
    );
    if (currentExercise == lastExercise) {
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.set(
        "FinishedCycles",
        currentCycle
      );
    }
  }

  // ** pause counter - - - - - - - - - - - - - - - - - - - - - - - - - - -
  function startPauseCountdown(which) {
    var pauseLength;

    if (which === "cycle") {
      pauseLength = mad.viewModels.madbarzWorkout.viewModel.get(
        "selectedWorkout.LongPauseLengthInSeconds"
      );
    } else {
      pauseLength = mad.viewModels.madbarzWorkout.viewModel.get(
        "selectedWorkout.ShortPauseLengthInSeconds"
      );
    }
    mad.viewModels.madbarzWorkout.viewModel.set(
      "counters.pauseCountdown",
      pauseLength
    );
    mad.viewModels.madbarzWorkout.pauza.brojac.setStart(pauseLength);
    mad.viewModels.madbarzWorkout.pauza.brojac.start();
  }

  function countdown(v) {
    mad.viewModels.madbarzWorkout.viewModel.set("counters.pauseCountdown", v);
    if (v == 10) {
      var playSound = !mad.viewModels.settings.getMuteSelection();
      if (playSound) {
        if (window.plugins && window.plugins.NativeAudio) {
          window.plugins.NativeAudio.duckON();
          window.plugins.NativeAudio.play(
            "ten",
            mad.common.audioOnSuccess,
            mad.common.audioOnError,
            tenGotov
          );
        }
      }
    }
  }

  function tenGotov() {
    window.plugins.NativeAudio.duckOFF();
  }

  function pocetakOdbrojavanjaPauze(e) {
    mad.viewModels.madbarzWorkout.viewModel.set("pause", "active");
    mad.viewModels.madbarzExercising.viewModel.set("pauseStoppedStatus", false);
    mad.viewModels.madbarzExercising.viewModel.set(
      "pauseTxt",
      mad.glossary.ui.madbarzExercising.labels.skip[
        mad.common.observables.languageIndex()
      ]
    );
    startPauseLength = mad.viewModels.madbarzWorkout.pauza.brojac.value();
    mad.viewModels.madbarzExercising.viewModel.set("status", "pause");
  }

  function zavrsetakOdbrojavanjaPauze(e) {
    mad.viewModels.madbarzWorkout.viewModel.set("pause", "finished");
    var pauseLength =
      startPauseLength - mad.viewModels.madbarzWorkout.pauza.brojac.value();
    mad.viewModels.madbarzWorkout.pauza.brojac.stop();
    // pribroji pauzu u total za pauze
    mad.viewModels.madbarzWorkout.viewModel.set(
      "counters.totalPauseTime",
      mad.viewModels.madbarzWorkout.viewModel.get("counters.totalPauseTime") +
        pauseLength
    );
    // pribroji pauzu u total za workout
    mad.viewModels.madbarzWorkout.viewModel.set(
      "counters.totalWorkoutTime",
      mad.viewModels.madbarzWorkout.viewModel.get("counters.totalWorkoutTime") +
        pauseLength
    );

    updateReps();
    selectNextExercise("do");
  }
  // ** pause counter - - - - - - - - - - - - - - - - - - - - - - - - - - - end

  function workoutDone() {
    // move (selectedWorkout) to another (madbarzWorkoutDone) view model
    // drazen mad.viewModels.madbarzWorkoutDone.viewModel.set("selectedWorkout",mad.viewModels.madbarzWorkout.viewModel.get("selectedWorkout"));

    // prepare data ----
    var totalCycles = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      "total.cycles"
    );
    var totalExercises = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      "total.exercises"
    );
    var exercisesDone = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      "counter.lastExerciseDoneNdx"
    );
    var totalWorkouts = totalCycles * totalExercises;
    var percentageDone = ((exercisesDone / totalWorkouts) * 100).toFixed(2);
    var longPause = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      "LongPauseLengthInSeconds"
    );
    var shortPause = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      "ShortPauseLengthInSeconds"
    );
    // remove unnecessary fields and calculate total score
    var cleanedExercises = [],
      score = 0,
      targetScore = 0;
    _.forEach(
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.finishedExercises,
      function(value) {
        console.log("finishirani exer", value);

        var eScore = value.NumberOfReps * value.CoefficientForPoints;
        score += eScore;
        var tScore = value.OldValue * value.CoefficientForPoints;
        targetScore += tScore;
        var tmp = _.pick(
          value,
          "Name",
          "Cycle",
          "NumberOfReps",
          "RoutineExerciseId",
          "LengthInSeconds",
          "Ordinal"
        ); // pick only what is needed
        tmp.Score = eScore; // ovaj score se koristi za power graph i nije vise podjeljen s 43 jer se prikazuje odnosi u % i nije bitno

        cleanedExercises.push(tmp);
      }
    );
    //console.log("exer1", cleanedExercises);
    score = parseInt(score / 43); // samo za ukupan score (kao na serveru)
    targetScore = parseInt(targetScore / 43);

    // move score to next viewModel
    mad.viewModels.workoutStat.viewModel.set("score", score);
    mad.viewModels.workoutStat.viewModel.set("targetScore", targetScore);
    // i za planove
    mad.viewModels.planWorkoutStat.viewModel.set("score", score);
    mad.viewModels.planWorkoutStat.viewModel.set("targetScore", targetScore);

    // move scores by cycle to next viewModel
    // drazen mad.viewModels.madbarzWorkoutDone.viewModel.set("scoresByCycle", _.zbroji(cleanedExercises, 'Cycle', 'Score'));

    // zbroji sve bodove po exerciseu
    //console.log("dump", cleanedExercises);
    var groupedExercises = d3
      .nest()
      .key(function(d) {
        return d.Name;
      })
      .rollup(function(v) {
        return d3.sum(v, function(d) {
          return parseInt(d.Score / 43);
        });
      })
      .entries(cleanedExercises);
    //console.log("grupirano i sumirano", groupedExercises);

    var maxPointsFor = _.max(groupedExercises, "values");
    mad.viewModels.planWorkoutStat.viewModel.set(
      "bestExerciseValue",
      maxPointsFor.values
    );
    mad.viewModels.planWorkoutStat.viewModel.set(
      "bestExerciseName",
      maxPointsFor.key
    );
    mad.viewModels.workoutStat.viewModel.set(
      "bestExerciseValue",
      maxPointsFor.values
    );
    mad.viewModels.workoutStat.viewModel.set(
      "bestExerciseName",
      maxPointsFor.key
    );
    var finishedW = Math.round(
      mad.viewModels.plansWork.viewModel.get(
        "selectedPlan.ActiveExecution.ExecutionData.Progress.FinishedWorkoutCount"
      ) + 1
    );
    var totalW = Math.round(
      mad.viewModels.plansWork.viewModel.get(
        "selectedPlan.ActiveExecution.ExecutionData.Progress.TotalWorkoutCount"
      )
    );
    mad.viewModels.planWorkoutStat.viewModel.set(
      "finished",
      Math.round((finishedW / totalW) * 100) + "%"
    );
    // now, remove Name & Score because it isn't necessary anymore
    var totallyCleanedExercises = _.map(cleanedExercises, function(o) {
      return _.omit(o, "Name", "Score");
    });
    //console.log("exer2", totallyCleanedExercises);

    var DoneTrening = {
      RoutineId: mad.viewModels.madbarzWorkout.viewModel.get(
        "selectedWorkout.RoutineId"
      ),
      TreningLength: mad.viewModels.madbarzWorkout.viewModel.get(
        "counters.totalWorkoutTime"
      ),
      FinishedCycles: mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
        "FinishedCycles"
      ),
      PercentageOfCompleteness: percentageDone,
      IsItSavedWorkout:
        mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Saved"
          ? true
          : false,
      TreningExercises: totallyCleanedExercises,
      ShortPause: shortPause,
      LongPause: longPause
    };

    var numOfWorkoutsForThisUserSoFar = parseInt(
      mad.local.loadVariable("NumberOfFinishedWorkouts")
    );

    mad.local.saveVariable(
      "NumberOfFinishedWorkouts",
      (numOfWorkoutsForThisUserSoFar + 1).toString()
    );

    if (mad.viewModels.madbarzWorkout.viewModel.get("workoutType") != "Plan") {
      // start saving workout
      saveWorkout(DoneTrening);

      // za test - pravo sejvanje (gore) je zakomentirano
      /*
            mad.viewModels.madbarzExercising.viewModel.set("savingWorkout", true);
            console.log("sejvanje je kao pocelo");
            setTimeout(function() {
                console.log("sejvanje je kao gotovo");
                mad.viewModels.workoutStat.viewModel.set("results", {"TreningScore":16,"LastTreningScore":30,"PercentageOfMusclesHit":10,"HasUserUploadedPhoto":false,
                    "TreningResults":    [
                        {"Name":"Back Plank","Value":35,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":35,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":35,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":35,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":35,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":35,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":35,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"}
                        ],
                    "LastTreningResults":[
                        {"Name":"Back Plank","Value":66,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":66,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":66,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":66,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":66,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":66,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"},
                        {"Name":"Back Plank","Value":66,"Id":3570,"ImageUrl":"","Unit":"sec","ImageUrlMobile":"http://mdbrzexercise.azureedge.net/back_plank80E8792D1125F446B26414F9F3EE73E1.jpg"}
                        ],
                    "MuscleIds":[10,17],
                    "TreningId":"67a14dd5-7850-4494-8440-528d9bc97ef0","DateOfLastWorkoutFormmated":"17 hours ago","TimeStamp":"2017-09-18T16:04:47.34"});

                mad.viewModels.madbarzExercising.viewModel.set("savingWorkout", false);
                mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkoutStat.html", "slide:left");
            }, 3000);
            */
      // --- kraj testa --------

      /* --- tracking - - - - - - - - - - - */
      if (viewModel.common.ifOnline()) {
        var typeText =
          mad.viewModels.madbarzWorkout.viewModel.get("workoutType") ==
          "Madbarz"
            ? "Madbarz routine"
            : "Saved workout";
        var quitedText =
          mad.viewModels.madbarzExercising.viewModel.get("status") == "quited"
            ? "Quited"
            : "Finished"; // to remove quit button because reps can be added to last exercise
        var clickText =
          quitedText == "Quited"
            ? "Click - Quit Workout"
            : "Click - Finish Workout";
        var wTime = mad.viewModels.madbarzWorkout.viewModel.get(
          "counters.totalWorkoutTime"
        );
        //var scoreForMix = mad.viewModels.madbarzWorkoutDone.viewModel.score;
        var scoreForMix = mad.viewModels.workoutStat.viewModel.score;
        var cycles = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
          "FinishedCycles"
        );
        var data = {
          Type: typeText,
          Quited: quitedText,
          "Workout Length": Math.round(wTime / 60),
          //"Score": Math.round(scoreForMix / 43),
          Score: scoreForMix, // vec je podjeljen s 43
          "Number of Finished Cycles": cycles,
          "Number Of workouts for this user so far": numOfWorkoutsForThisUserSoFar
        };

        mad.googleAnalytics.trackEvent(
          "Training Activity",
          clickText,
          typeText,
          numOfWorkoutsForThisUserSoFar
        );

        if (numOfWorkoutsForThisUserSoFar == 0) {
          mad.googleAnalytics.trackEvent(
            "Training Activity",
            "First Workout Ever " + quitedText,
            typeText,
            numOfWorkoutsForThisUserSoFar
          );
        }

        if (wTime >= 300) {
          mad.analyticEvents.track(
            [
              mad.analyticEvents.services.GA,
              mad.analyticEvents.services.MIXP,
              mad.analyticEvents.FB
            ],
            mad.analyticEvents.categories.MAX,
            mad.analyticEvents.types.EVENT,
            "Workout Done Overall 5 mins",
            data,
            "Training Activity",
            clickText + " - Longer than 5min",
            typeText,
            numOfWorkoutsForThisUserSoFar
          );

          if (numOfWorkoutsForThisUserSoFar == 0) {
            mad.googleAnalytics.trackEvent(
              "Training Activity",
              "First Workout Ever " + quitedText + " - Longer than 5min",
              typeText,
              numOfWorkoutsForThisUserSoFar
            );
          }
        }
      }
      /* --- tracking - - - - - - - - - - - */

      // and go to next view
      //mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkoutDone.html", "slide:left");
    } else {
      saveWorkoutForPlan(DoneTrening);

      // drazen - privremeno umjesto ovog gore
      /*
            var rez = {"WorkoutActivityId":"9ff5b8b0-6fff-4c90-a5d5-8de68f8e8fa2","Stats":{"ActivatedMuscleIds":[18,19]},"Execution":{"Id":"c530f452-a840-417e-b597-0090373e4095","WorkoutPlanId":67,"StartedOn":"2017-10-20T08:57:03.043","EndedOn":null,"ModifiedOn":"2017-10-20T12:08:46.0505953Z","Status":"opened","Progress":{"StartedOn":"2017-10-20T08:57:03.043","EndedOn":null,"FinishedWeekCount":1,"TotalWeekCount":6,"FinishedWorkoutCount":5,"TotalWorkoutCount":24},"CurrentWeek":2,"Stats":null,"Weeks":[{"Ordinal":1,"Status":"finished","Progress":{"FinishedWorkoutCount":4,"TotalWorkoutCount":4},"Stats":null,"Workouts":[{"Ordinal":1,"WorkoutId":579,"Name":"Workout 1","Status":"finished","MostRecentActivityId":"6858554e-3bc1-4010-87e7-ebf2d179faa3","Activities":[{"RoutineId":579,"PercentageOfCompleteness":5.0,"TreningLength":103,"FinishedCycles":0,"IsItSavedWorkout":false,"TreningComment":null,"PlannedCyclePause":10,"PlannedExercisePause":10,"TreningExercises":[{"Id":"3607","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":7,"LengthInSeconds":0},{"Id":"3607","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":6,"LengthInSeconds":0},{"Id":"3578","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"3607","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":97,"Cycle":1,"LengthInSeconds":97},{"Id":"3607","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":5,"LengthInSeconds":0},{"Id":"3578","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":5,"LengthInSeconds":0},{"Id":"3578","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":8,"LengthInSeconds":0},{"Id":"3607","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":8,"LengthInSeconds":0},{"Id":"3578","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"3607","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":10,"LengthInSeconds":0},{"Id":"3578","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":7,"LengthInSeconds":0},{"Id":"3578","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"3578","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":6,"LengthInSeconds":0},{"Id":"3607","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"3578","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":9,"LengthInSeconds":0},{"Id":"3578","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"3607","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"3578","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":10,"LengthInSeconds":0},{"Id":"3607","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"3607","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":9,"LengthInSeconds":0}]}]},{"Ordinal":2,"WorkoutId":580,"Name":"Workout 2","Status":"finished","MostRecentActivityId":"65a5afd1-0201-4cba-92df-de4d34c0f6bf","Activities":[{"RoutineId":580,"PercentageOfCompleteness":5.0,"TreningLength":9,"FinishedCycles":0,"IsItSavedWorkout":false,"TreningComment":null,"PlannedCyclePause":5,"PlannedExercisePause":20,"TreningExercises":[{"Id":"34","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":5,"LengthInSeconds":0},{"Id":"26","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":8,"Cycle":1,"LengthInSeconds":3},{"Id":"26","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"47","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":6,"LengthInSeconds":0},{"Id":"47","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"26","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":5,"LengthInSeconds":0},{"Id":"34","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":6,"LengthInSeconds":0},{"Id":"47","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":5,"LengthInSeconds":0},{"Id":"26","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"34","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"47","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"26","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":6,"LengthInSeconds":0},{"Id":"34","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"26","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"34","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"47","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"34","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"47","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0}]}]},{"Ordinal":3,"WorkoutId":581,"Name":"Workout 3","Status":"finished","MostRecentActivityId":"3bf570ac-6eb8-48c5-b9ba-2180fdecbd4f","Activities":[{"RoutineId":581,"PercentageOfCompleteness":7.0,"TreningLength":19,"FinishedCycles":0,"IsItSavedWorkout":false,"TreningComment":null,"PlannedCyclePause":40,"PlannedExercisePause":30,"TreningExercises":[{"Id":"40","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"46","RoutineExerciseId":"4","Ordinal":4,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"46","RoutineExerciseId":"4","Ordinal":4,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"70","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"46","RoutineExerciseId":"4","Ordinal":4,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"2","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"1034","RoutineExerciseId":"7","Ordinal":7,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"1034","RoutineExerciseId":"7","Ordinal":7,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"40","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":6,"Cycle":1,"LengthInSeconds":2},{"Id":"3584","RoutineExerciseId":"6","Ordinal":6,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"40","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"70","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"1034","RoutineExerciseId":"7","Ordinal":7,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"3584","RoutineExerciseId":"6","Ordinal":6,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"46","RoutineExerciseId":"4","Ordinal":4,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"2","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"70","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"3584","RoutineExerciseId":"6","Ordinal":6,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"40","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"1035","RoutineExerciseId":"5","Ordinal":5,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"2","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"70","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":8,"Cycle":1,"LengthInSeconds":3},{"Id":"1035","RoutineExerciseId":"5","Ordinal":5,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"2","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"1035","RoutineExerciseId":"5","Ordinal":5,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"3584","RoutineExerciseId":"6","Ordinal":6,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"1035","RoutineExerciseId":"5","Ordinal":5,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"1034","RoutineExerciseId":"7","Ordinal":7,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0}]}]},{"Ordinal":4,"WorkoutId":582,"Name":"Workout 4","Status":"finished","MostRecentActivityId":"514f36a7-931f-4067-a17c-8fe06fa50433","Activities":[{"RoutineId":582,"PercentageOfCompleteness":5.0,"TreningLength":25,"FinishedCycles":0,"IsItSavedWorkout":false,"TreningComment":null,"PlannedCyclePause":40,"PlannedExercisePause":30,"TreningExercises":[{"Id":"3589","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"3589","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"47","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"37","RoutineExerciseId":"4","Ordinal":4,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"37","RoutineExerciseId":"4","Ordinal":4,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"47","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"3589","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"47","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":12,"Cycle":1,"LengthInSeconds":18},{"Id":"20","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"37","RoutineExerciseId":"4","Ordinal":4,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"3589","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"20","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"47","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"19","RoutineExerciseId":"5","Ordinal":5,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"20","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"37","RoutineExerciseId":"4","Ordinal":4,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":4,"LengthInSeconds":0},{"Id":"19","RoutineExerciseId":"5","Ordinal":5,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0},{"Id":"19","RoutineExerciseId":"5","Ordinal":5,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"19","RoutineExerciseId":"5","Ordinal":5,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":2,"LengthInSeconds":0},{"Id":"20","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":3,"LengthInSeconds":0}]}]}]},{"Ordinal":2,"Status":"inProgress","Progress":{"FinishedWorkoutCount":1,"TotalWorkoutCount":4},"Stats":null,"Workouts":[{"Ordinal":1,"WorkoutId":583,"Name":"Workout 1","Status":"finished","MostRecentActivityId":"9ff5b8b0-6fff-4c90-a5d5-8de68f8e8fa2","Activities":[{"RoutineId":583,"PercentageOfCompleteness":10.0,"TreningLength":7,"FinishedCycles":0,"IsItSavedWorkout":false,"TreningComment":null,"PlannedCyclePause":5,"PlannedExercisePause":15,"TreningExercises":[{"Id":"49","RoutineExerciseId":"1","Ordinal":1,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":1,"Cycle":1,"LengthInSeconds":1},{"Id":"3608","RoutineExerciseId":"2","Ordinal":2,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"2","RoutineExerciseId":"3","Ordinal":3,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"34","RoutineExerciseId":"4","Ordinal":4,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"35","RoutineExerciseId":"5","Ordinal":5,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"3578","RoutineExerciseId":"6","Ordinal":6,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"10","RoutineExerciseId":"7","Ordinal":7,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"47","RoutineExerciseId":"8","Ordinal":8,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"70","RoutineExerciseId":"9","Ordinal":9,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0},{"Id":"19","RoutineExerciseId":"10","Ordinal":10,"RoutineExercise":null,"SuggestedNumberOfReps":0,"NumberOfReps":0,"Cycle":1,"LengthInSeconds":0}]}]},{"Ordinal":2,"WorkoutId":584,"Name":"Workout 2","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":3,"WorkoutId":585,"Name":"Workout 3","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":4,"WorkoutId":586,"Name":"Workout 4","Status":"ready","MostRecentActivityId":"","Activities":null}]},{"Ordinal":3,"Status":"ready","Progress":{"FinishedWorkoutCount":0,"TotalWorkoutCount":4},"Stats":null,"Workouts":[{"Ordinal":1,"WorkoutId":587,"Name":"Workout 1","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":2,"WorkoutId":588,"Name":"Workout 2","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":3,"WorkoutId":589,"Name":"Workout 3","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":4,"WorkoutId":590,"Name":"Workout 4","Status":"ready","MostRecentActivityId":"","Activities":null}]},{"Ordinal":4,"Status":"ready","Progress":{"FinishedWorkoutCount":0,"TotalWorkoutCount":4},"Stats":null,"Workouts":[{"Ordinal":1,"WorkoutId":591,"Name":"Workout 1","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":2,"WorkoutId":592,"Name":"Workout 2","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":3,"WorkoutId":593,"Name":"Workout 3","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":4,"WorkoutId":595,"Name":"Workout 4","Status":"ready","MostRecentActivityId":"","Activities":null}]},{"Ordinal":5,"Status":"ready","Progress":{"FinishedWorkoutCount":0,"TotalWorkoutCount":4},"Stats":null,"Workouts":[{"Ordinal":1,"WorkoutId":596,"Name":"Workout 1","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":2,"WorkoutId":597,"Name":"Workout 2","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":3,"WorkoutId":598,"Name":"Workout 3","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":4,"WorkoutId":599,"Name":"Workout 4","Status":"ready","MostRecentActivityId":"","Activities":null}]},{"Ordinal":6,"Status":"ready","Progress":{"FinishedWorkoutCount":0,"TotalWorkoutCount":4},"Stats":null,"Workouts":[{"Ordinal":1,"WorkoutId":600,"Name":"Workout 1","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":2,"WorkoutId":601,"Name":"Workout 2","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":3,"WorkoutId":602,"Name":"Workout 3","Status":"ready","MostRecentActivityId":"","Activities":null},{"Ordinal":4,"WorkoutId":603,"Name":"Workout 4","Status":"ready","MostRecentActivityId":"","Activities":null}]}]}}
            // move results to another (planWorkoutStat) view model
            mad.viewModels.planWorkoutStat.viewModel.set("results", rez);

            mad.viewModels.planWorkoutStat.viewModel.set("results.HasUploadedProfilePhoto", true);
            // say that muscles are ready so we can show them
            mad.viewModels.planWorkoutStat.viewModel.set("musclesLoaded", true);
            mad.mobileApp.navigate("ui/workouts/madbarz/workout/planWorkoutStat.html?origin=madbarzWorkout", "slide:left");
            */
    }
  }

  function incrementPause(e) {
    //a i oduzima (ne bi covjek reko)
    //var target = e.touch.currentTarget;      // za tap
    var target = e.touch.target; // drazen - zbog nove verzije kenda
    var sign = $(target).attr("data-sign");
    var val = $(target).attr("data-val");
    var step = parseInt($(target).attr("data-step"));
    var oldValue = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
      val
    );
    if (sign === "+") {
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.set(
        val,
        oldValue + step
      );
    } else {
      if (oldValue - step <= 0) {
        return;
      } else {
        mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.set(
          val,
          oldValue - step
        );
      }
    }
    if (mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Saved") {
      // only for saved workouts
      mad.viewModels.madbarzWorkout.viewModel.set("savedWorkoutChanges", true);
    }
  }

  function setViewTitle() {
    var naslov, week, rbr, name;

    if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz"
    ) {
      naslov = mad.viewModels.madbarzRoutines.viewModel.get(
        "selectedWorkout.Name"
      );
    } else if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Saved"
    ) {
      naslov = mad.viewModels.madbarzSavedWorkoutS.viewModel.get(
        "selectedWorkout.Name"
      );
    } else {
      // Plan
      week =
        mad.viewModels.plansWork.viewModel.selectedPlan.ActiveExecution
          .ExecutionData.CurrentWeek;
      rbr =
        parseInt(
          mad.viewModels.plansWork.viewModel.selectedWorkout.WorkoutOrdinal
        ) - 1;
      name =
        mad.viewModels.plansWork.viewModel.selectedPlan.ActiveExecution
          .ExecutionData.Weeks[week - 1].Workouts[rbr].Name;
      naslov = name + " - Week " + week;
    }

    mad.common.actualView.title = naslov;
    mad.common.actualView.header
      .find(".km-navbar")
      .data("kendoMobileNavBar")
      .title(naslov);
  }

  function checkifOnline() {
    return mad.viewModels.madbarzWorkout.viewModel.common.ifOnline();
  }

  function editSavedWorkouts() {
    var msg = mad.glossary.messages.editSaved,
      language = mad.common.observables.languageIndex();
    navigator.notification.confirm(
      msg.message[language],
      function(button) {
        if (button == 1) {
          // remove
          removeFromSavedWorkouts();
        } else if (button == 2) {
          // edit
          createWorkout.model.addSavedForEdit(viewModel.get("selectedWorkout"));
        } else if (button == 1) {
          // cancel
        }
      },
      msg.title[language],
      [msg.button1[language], msg.button2[language], msg.button3[language]]
    );
  }

  function removeFromSavedWorkouts() {
    var favID = getSavedRoutineId();
    if (mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Saved") {
      var callback = function() {
        fromSavedWorkouts(favID);
      };
      mad.common.areYouSure(callback);
    } else {
      fromSavedWorkouts(favID);
    }
  }

  function toggleSavedWorkouts(e) {
    var element = e.touch.target;

    if (mad.common.observables.ifOffline()) {
      mad.alerts.error("You must be online to do that.");
    } else {
      //if ($(e.currentTarget).hasClass("saved")) {
      //if ($(e.touch.currentTarget).hasClass("saved")) {
      if ($(element).hasClass("saved")) {
        // drazen - zbog nove verzije kenda
        var favID = getSavedRoutineId();
        if (
          mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Saved"
        ) {
          var callback = function() {
            fromSavedWorkouts(favID);
          };
          mad.common.areYouSure(callback);
        } else {
          fromSavedWorkouts(favID);
        }
      } else {
        toSavedWorkouts();
      }
    }
  }

  function fromSavedWorkouts(savedWorkoutId) {
    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/Saved/RemoveFromSaved";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = {
            Id: savedWorkoutId
        };
        */
    var link = {
      putanja: mad.common.variables.serverUrl + "api/Saved/RemoveFromSaved",
      akcija: "POST"
    };
    var podaci = { Id: savedWorkoutId };

    if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz"
    ) {
      mad.common.showLoader();
    }
    mad.data
      .post(link, podaci)
      .done(function(data) {
        // drazen - prijevod
        //mad.alerts.success("Workout removed from saved");

        var savedWorkouts = mad.local.loadSaved(); // load saved from cache
        mad.local.removeVariable("savedWorkouts"); // remove it from cache
        var newSaved = _.reject(savedWorkouts, { Id: savedWorkoutId }); // remove selected workoutID from saved
        mad.local.saveSaved(newSaved); // store to cache

        mad.viewModels.madbarzWorkout.viewModel.set("isWorkoutSaved", false); // for star

        if (
          mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Saved"
        ) {
          mad.viewModels.madbarzSavedWorkoutS.viewModel.set(
            "reloadSavedWorkouts",
            true
          );
          mad.common.goBack();
        }
      })
      .fail(function(e, r, t) {
        mad.alerts.error("Error removing workout from saved.");
      })
      .always(function() {
        if (
          mad.viewModels.madbarzWorkout.viewModel.get("workoutType") ==
          "Madbarz"
        ) {
          mad.common.hideLoader();
        }
      });
  }

  function justRemoveFromSaved() {
    var savedWorkoutId = getSavedRoutineId();

    var link = {
      putanja: mad.common.variables.serverUrl + "api/Saved/RemoveFromSaved",
      akcija: "POST"
    };
    var podaci = { Id: savedWorkoutId };

    if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz"
    ) {
      mad.common.showLoader();
    }

    mad.data
      .post(link, podaci)
      .done(function(data) {
        mad.viewModels.workoutStat.viewModel.set("ifWorkoutSaved", false); // update status in stats for save button there

        var savedWorkouts = mad.local.loadSaved(); // load saved from cache
        mad.local.removeVariable("savedWorkouts"); // remove from cache
        var newSaved = _.reject(savedWorkouts, { Id: savedWorkoutId }); // remove selected workoutID from saved
        mad.local.saveSaved(newSaved); // and store all back to cache
      })
      .fail(function(e, r, t) {
        mad.alerts.error("Error removing workout from saved.");
      })
      .always(function() {
        mad.common.hideLoader();
      });
  }

  var saveWorkoutOnServer = function(hasPro) {
    var selectedWorkout = mad.viewModels.madbarzWorkout.viewModel.get(
      "selectedWorkout"
    );
    var exercises = [];
    var exercise = selectedWorkout.Exercises;

    $(exercise).each(function(index, val) {
      exercises.push({
        Id: val.RoutineExerciseId,
        Reps: val.NewValue
      });
    });
    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/Saved/SaveWorkoutAsyncNew";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = {
            RoutineId: selectedWorkout.RoutineId,
            Exercises: exercises,
            ShortPause: selectedWorkout.ShortPauseLengthInSeconds,
            LongPause: selectedWorkout.LongPauseLengthInSeconds,
            HasUserPro: hasPro
        };
        */
    var link = {
      putanja: mad.common.variables.serverUrl + "api/Saved/SaveWorkoutAsyncNew",
      akcija: "POST"
    };
    var podaci = {
      RoutineId: selectedWorkout.RoutineId,
      Exercises: exercises,
      ShortPause: selectedWorkout.ShortPauseLengthInSeconds,
      LongPause: selectedWorkout.LongPauseLengthInSeconds,
      HasUserPro: hasPro
    };

    mad.common.showLoader("Saving");
    mad.data
      .post(link, podaci)
      .done(function(data) {
        mad.common.hideLoader();
        if (data.Data) {
          var savedWorkouts = mad.local.loadSaved(); // load saved from cache
          mad.local.removeVariable("savedWorkouts"); // remove it from cache
          savedWorkouts.push(data.Data); // append just saved workout
          mad.local.saveSaved(savedWorkouts); // store to cache

          mad.viewModels.madbarzWorkout.viewModel.set("isWorkoutSaved", true); // for star
          //mad.viewModels.madbarzWorkoutComment.viewModel.set("ifWorkoutSaved", true); // update status in comments for save button there
          mad.viewModels.workoutStat.viewModel.set("ifWorkoutSaved", true); // update status in stats for save button there

          mad.googleAnalytics.trackEvent(
            "Training Activity",
            "Saved Madbarz workout"
          );
          mad.facebookAnalytics.trackEvent(
            "Workout Saved",
            { Origin: "Madbarz Workout" },
            0
          );
        } else {
          if (data.Message != "max") {
            mad.alerts.error(mad.common.translate("messages", "notSaved"));
          } else {
            //mad.viewModels.popups.viewModel.openModal("buySavedPRO");
            mad.viewModels.popups.viewModel.openModalWindow(
              "buySavedPRO",
              "You reached your limit of 5",
              "Premium account lets you save unlimited workouts and much more",
              "Get unlimited space!"
            );
          }
        }
      })
      .fail(function(e, r, t) {
        mad.common.hideLoader();
        mad.alerts.error(
          mad.common.translate("messages", "errorSavingWorkout")
        );
      });
  };

  function toSavedWorkouts() {
    var isUserProPromise = $.Deferred();
    var hasUserPro = false;

    isUserProPromise.then(
      function(hasPro) {
        if (typeof hasPro === "boolean") {
          hasUserPro = hasPro;
        }
        saveWorkoutOnServer(hasUserPro);
      },
      function(fail) {
        console.log("hasUserAccessToPro failed !!", fail);
        saveWorkoutOnServer(hasUserPro);
      }
    );

    //check if user has access to pro or not
    mad.common.hasUserAccessToPro(isUserProPromise);
  }

  function updateSavedWorkoutsInDB(
    fromWhere,
    pId,
    pName,
    pExercises,
    pCycles,
    pPauseE,
    pPauseC
  ) {
    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/Saved/UpdateSavedWorkout?api-version=2.0";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = {
            Id: pId,
            Name: pName,
            ExercisesAndReps: pExercises,
            NumOfCycles: pCycles,
            ShortPause: pPauseE,
            LongPause: pPauseC
        };
        */
    var link = {
      putanja:
        mad.common.variables.serverUrl +
        "api/Saved/UpdateSavedWorkout?api-version=2.0",
      akcija: "POST"
    };
    var podaci = {
      Id: pId,
      Name: pName,
      ExercisesAndReps: pExercises,
      NumOfCycles: pCycles,
      ShortPause: pPauseE,
      LongPause: pPauseC
    };

    if (checkifOnline()) {
      // if online - save
      if (fromWhere != "onStart") {
        mad.common.showLoader("Saving");
      }
      mad.data
        .post(link, podaci)
        .done(function(data) {
          if (fromWhere != "onStart") {
            mad.common.hideLoader();
          }
          if (data) {
            console.log("new RoutineId after UpdateSavedWorkout", data);

            // update RoutineId with ID returned from UpdateSavedWorkout
            mad.viewModels.madbarzWorkout.viewModel.set(
              "selectedWorkout.RoutineId",
              data
            );

            console.log(
              "selected wkt after update",
              mad.viewModels.madbarzWorkout.viewModel.get("selectedWorkout")
            );

            mad.viewModels.madbarzWorkout.cekamDaZavrsiSejvanje.resolve("OK");
          } else {
            if (fromWhere == "onStart") {
              mad.alerts.realTop0("Saved workout not updated");
            } else {
              mad.alerts.error("Saved workout not updated");
            }
            mad.viewModels.madbarzWorkout.cekamDaZavrsiSejvanje.resolve(
              "nije OK"
            );
          }
        })
        .fail(function(e, r, t) {
          if (fromWhere == "onStart") {
            mad.alerts.realTop0("Error! Saved workout not updated");
          } else {
            mad.common.hideLoader();
            mad.alerts.error("Error! Saved workout not updated");
          }
          mad.viewModels.madbarzWorkout.cekam.reject("nije OK");
        });
    } else {
      //if offline - store in local storage
      mad.local.appendPendingUpdates(mad.common.variables.dataOptions);

      // drazen - todo / prijevod
      if (fromWhere == "onStart") {
        mad.alerts.info0(
          "Your changes will be updated & visible</br>when you connect to Internet"
        );
      } else {
        mad.alerts.info(
          "Your changes will be updated & visible</br>when you connect to Internet"
        );
      }
      mad.viewModels.madbarzWorkout.cekamDaZavrsiSejvanje.resolve("POSTPONED");
    }
    return mad.viewModels.madbarzWorkout.cekamDaZavrsiSejvanje.promise();
  }

  function isSaved() {
    // drazen - ovo zna malo potrajat 1. put kad nema sejvane u cacheu
    var isItSaved = false;

    //set loader on saved workouts screen to true
    mad.viewModels.madbarzSavedWorkoutS.viewModel.set("loadingSaved", true);

    var tmp = mad.local.loadSaved() == [] ? [] : mad.local.loadSaved();

    if ($.isEmptyObject(tmp)) {
      // if there is no saved workouts in a local storage
      mad.local.removeVariable("savedWorkouts");
      mad.models.savedWorkouts.read().then(
        function() {
          // read OK (promise finished)
          tmp = mad.local.loadSaved() == [] ? [] : mad.local.loadSaved();
          isItSaved = isSavedCheck(tmp);
          mad.viewModels.madbarzSavedWorkoutS.viewModel.set(
            "loadingSaved",
            false
          );

          mad.viewModels.madbarzWorkout.cekam.resolve(isItSaved);
        },
        function() {
          // read failed
          mad.viewModels.madbarzSavedWorkoutS.viewModel.set(
            "loadingSaved",
            false
          );

          mad.viewModels.madbarzWorkout.cekam.reject(false);
        }
      );
    } else {
      // there are some save workouts in a local storage
      isItSaved = isSavedCheck(tmp); // so check if this one is on a list
      mad.viewModels.madbarzSavedWorkoutS.viewModel.set("loadingSaved", true);

      mad.viewModels.madbarzWorkout.cekam.resolve(isItSaved);
    }
  }

  function isSavedCheck(savedWorkouts) {
    var selectedWorkout = mad.viewModels.madbarzWorkout.viewModel.get(
      "selectedWorkout"
    );
    var item = _(savedWorkouts).find(function(itm) {
      return itm.RoutineId === selectedWorkout.RoutineId;
    });
    if ($.isEmptyObject(item)) {
      return false;
    } else {
      return true;
    }
  }

  function getSavedRoutineId() {
    var savedRoutines, selectedWorkoutRoutineId, savedId;

    if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz"
    ) {
      savedRoutines = mad.local.loadSaved();
      selectedWorkoutRoutineId = mad.viewModels.madbarzWorkout.viewModel.get(
        "selectedWorkout.RoutineId"
      );
      savedId = _.result(
        _.find(savedRoutines, "RoutineId", selectedWorkoutRoutineId),
        "Id"
      );
    } else {
      savedId = mad.viewModels.madbarzWorkout.viewModel.get(
        "selectedWorkout.Id"
      );
    }
    return savedId;
  }

  function saveWorkout(dataToSend) {
    console.log("--- data for saving", dataToSend);

    var goBackLink;
    if (
      mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Madbarz"
    ) {
      //goBackLink = "ui/workouts/madbarz/madbarzWorkoutsList.html";
      goBackLink = "ui/workouts/madbarz/madbarzRoutines.html";
    } else {
      goBackLink =
        "ui/workouts/saved/madbarzSavedWorkoutsList.html?origin=workout";
    }

    if (mad.common.observables.networkStatus == "online") {
      // if we are online

      mad.viewModels.madbarzExercising.viewModel.set("savingWorkout", true);
      /*
            mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/Trening/AddResults";
            mad.common.variables.forAjax.akcija = "POST";
            mad.common.variables.dataOptions = dataToSend;
            */
      var link = {
        putanja: mad.common.variables.serverUrl + "api/Trening/AddResults",
        akcija: "POST"
      };
      var podaci = dataToSend;

      mad.common.showLoader();

      mad.data
        .post(link, podaci)
        .done(function(data, code) {
          mad.common.hideLoader();

          // move results to another (madbarzWorkoutStat) view model
          mad.viewModels.workoutStat.viewModel.set("results", data);

          console.log("results je", data);
          var numOfWorkoutsInFeedFollowing = mad.local.loadVariable(
            "noOfWorkoutsInFeed"
          );

          if (
            numOfWorkoutsInFeedFollowing &&
            typeof numOfWorkoutsInFeedFollowing === "number"
          ) {
            numOfWorkoutsInFeedFollowing++;
          } else {
            numOfWorkoutsInFeedFollowing = 1;
          }

          mad.local.saveVariable(
            "noOfWorkoutsInFeed",
            numOfWorkoutsInFeedFollowing
          );

          if (
            mad.common.variables.noOfWorkoutsInFeed &&
            typeof mad.common.variables.noOfWorkoutsInFeed === "number"
          ) {
            mad.common.variables.noOfWorkoutsInFeed++;
          } else {
            mad.common.variables.noOfWorkoutsInFeed = 1;
          }

          // enable showStats button on madbarzWorkoutDone view
          //mad.viewModels.madbarzWorkoutDone.viewModel.set("footerEnabled", true);
          mad.viewModels.madbarzExercising.viewModel.set(
            "savingWorkout",
            false
          );

          mad.mobileApp.navigate(
            "ui/workouts/madbarz/workout/madbarzWorkoutStat.html",
            "slide:left"
          );
        })
        .fail(function(qXHR, textStatus, errorThrown) {
          mad.common.hideLoader();

          console.log("save failed");
          // enable showStats button on madbarzWorkoutDone view (da zavrsi animacija)
          //mad.viewModels.madbarzWorkoutDone.viewModel.set("footerEnabled", true);
          mad.viewModels.madbarzExercising.viewModel.set(
            "savingWorkout",
            false
          );

          if (textStatus == "timeout") {
            if (mad.common.observables.askAboutWaiting) {
              var msg = mad.glossary.messages.saveTimeout;
              navigator.notification.alert(
                msg.message[mad.common.observables.languageIndex()],
                setTimeout(function() {
                  // dodano spremanje u cache kod timeouta (postoji mogucnost da 2x spremi)
                  mad.local.appendWorkout(dataToSend);
                  mad.mobileApp.navigate(goBackLink, "slide:right"); // go back to workouts
                }, 1111), // after some time
                msg.title[mad.common.observables.languageIndex()],
                msg.button[mad.common.observables.languageIndex()]
              );
            } else {
              mad.alerts.error(
                mad.glossary.messages.tooLongNotSaved[
                  mad.common.observables.languageIndex()
                ]
              );
              mad.mobileApp.navigate(goBackLink, "slide:right"); // go back to workouts
            }
          } else {
            console.log("Error saving workout ", textStatus, qXHR);
            mad.alerts.error(
              mad.glossary.messages.errorSavingWorkout[
                mad.common.observables.languageIndex()
              ]
            );
            mad.mobileApp.navigate(goBackLink, "slide:right"); // go back to workouts
          }
        });
    } else {
      mad.local.appendWorkout(dataToSend);
      mad.alerts.info(mad.common.translate("messages", "willBeSynced"));
      mad.mobileApp.navigate(goBackLink, "slide:right"); // go back to workouts
    }
  }

  function saveWorkoutForPlan(dataToSend) {
    console.log("--- data for saving - prije sređivanja", dataToSend);

    var gotoLink = "ui/plans/work.html?origin=madbarzWorkout";

    // prepare data
    var dataToSave = {};

    dataToSave.ExecutionId = mad.viewModels.plansWork.viewModel.get(
      "selectedPlan.ActiveExecution.ExecutionData.Id"
    );
    dataToSave.WeekOrdinal = mad.viewModels.plansWork.viewModel.get(
      "selectedPlan.ActiveExecution.ExecutionData.CurrentWeek"
    );
    dataToSave.WorkoutOrdinal = mad.viewModels.plansWork.viewModel.get(
      "selectedWorkout.WorkoutOrdinal"
    );

    dataToSave.WorkoutActivity = {};
    dataToSave.WorkoutActivity.PlannedCyclePause = dataToSend.LongPause;
    dataToSave.WorkoutActivity.PlannedExercisePause = dataToSend.ShortPause;
    dataToSave.WorkoutActivity.RoutineId = dataToSend.RoutineId;
    dataToSave.WorkoutActivity.PercentageOfCompleteness =
      dataToSend.PercentageOfCompleteness;
    dataToSave.WorkoutActivity.TreningLength = dataToSend.TreningLength;
    dataToSave.WorkoutActivity.FinishedCycles = dataToSend.FinishedCycles;
    dataToSave.WorkoutActivity.IsItSavedWorkout = false;
    dataToSave.WorkoutActivity.TreningComment = "";
    dataToSave.WorkoutActivity.TreningExercises = [];

    _(dataToSend.TreningExercises)
      .forEach(function(value, key) {
        var exercise = {};
        (exercise.Ordinal = value.Ordinal),
          (exercise.Id = value.RoutineExerciseId);
        exercise.RoutineExerciseId = null;
        exercise.RoutineExercise = null;
        exercise.SuggestedNumberOfReps = 0;
        exercise.NumberOfReps = value.NumberOfReps;
        exercise.Cycle = value.Cycle;
        exercise.LengthInSeconds = value.LengthInSeconds;
        dataToSave.WorkoutActivity.TreningExercises.push(exercise);
      })
      .value();

    console.log("--- data for saving - nakon sređivanja", dataToSave);

    if (mad.common.observables.networkStatus == "online") {
      // if we are online
      /*
            mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/WorkoutPlans/SaveWorkoutActivity";
            mad.common.variables.forAjax.akcija = "POST";
            mad.common.variables.dataOptions = dataToSave;
            */
      var link = {
        putanja:
          mad.common.variables.serverUrl +
          "api/WorkoutPlans/SaveWorkoutActivity",
        akcija: "POST"
      };
      var podaci = dataToSave;

      mad.common.showLoader();

      mad.viewModels.planWorkoutStat.viewModel.set("musclesLoaded", false);

      mad.data
        .post(link, podaci)
        .done(function(data, code) {
          console.log(
            ">>> nakon slanje podataka u SaveWorkoutActivity response je",
            data
          );

          mad.common.hideLoader();

          if (dataToSave.WorkoutActivity.TreningLength >= 300) {
            var numOfWorkoutsForThisUserSoFar = parseInt(
              mad.local.loadVariable("NumberOfFinishedWorkouts")
            );

            var additionalData = {
              Type: "Workout Plan",
              "Workout Length": Math.round(
                dataToSave.WorkoutActivity.TreningLength / 60
              ),
              "Number of Finished Cycles":
                dataToSave.WorkoutActivity.FinishedCycles,
              "Number Of workouts for this user so far": numOfWorkoutsForThisUserSoFar
            };

            mad.analyticEvents.track(
              [
                mad.analyticEvents.services.GA,
                mad.analyticEvents.services.MIXP,
                mad.analyticEvents.FB
              ],
              mad.analyticEvents.categories.MAX,
              mad.analyticEvents.types.EVENT,
              "Workout Done Overall 5 mins",
              additionalData,
              "Training Activity",
              "Workout Done" + " - Longer than 5min",
              "Workout Plan",
              numOfWorkoutsForThisUserSoFar
            );
          }

          if (data.Execution.Status == "finished") {
            var additionalInfo = {
              "Part Name": mad.viewModels.plansWork.viewModel.get(
                "selectedPlan.Name"
              ),
              "Part Ordinal Name": mad.viewModels.plansWork.viewModel.get(
                "selectedPlan.CategoryOrdinalName"
              ),
              "How was it finished": "Finished workout"
            };

            mad.analyticEvents.track(
              [mad.analyticEvents.services.GA],
              mad.analyticEvents.categories.WORKOUTPLAN,
              mad.analyticEvents.types.EVENT,
              "Workout Plan - Finished",
              additionalInfo,
              "Workout Plan",
              "Finished"
            );

            viewModel.set("showPopup", true);
          }

          // move results to another (planWorkoutStat) view model
          mad.viewModels.planWorkoutStat.viewModel.set("results", data);
          // say that muscles are ready so we can show them
          mad.viewModels.planWorkoutStat.viewModel.set("musclesLoaded", true);

          mad.mobileApp.navigate(
            "ui/workouts/madbarz/workout/planWorkoutStat.html?origin=madbarzWorkout",
            "slide:left"
          );
        })
        .fail(function(qXHR, textStatus, errorThrown) {
          console.log("save failed");

          mad.common.hideLoader();

          // enable showStats button on madbarzWorkoutDone view (da zavrsi animacija)
          //mad.viewModels.madbarzWorkoutDone.viewModel.set("footerEnabled", true);

          if (textStatus == "timeout") {
            if (mad.common.observables.askAboutWaiting) {
              var msg = mad.glossary.messages.saveTimeout;
              navigator.notification.alert(
                msg.message[mad.common.observables.languageIndex()],
                setTimeout(function() {
                  // dodano spremanje u cache kod timeouta (postoji mogucnost da 2x spremi)
                  mad.local.appendWorkoutPlan(dataToSave);
                  mad.common.removeLastFromHistory();
                }, 1111), // after some time
                msg.title[mad.common.observables.languageIndex()],
                msg.button[mad.common.observables.languageIndex()]
              );
            } else {
              mad.alerts.error(
                mad.glossary.messages.tooLongNotSaved[
                  mad.common.observables.languageIndex()
                ]
              );
            }
          } else {
            console.log("Error saving workout ", textStatus, qXHR);
            mad.alerts.error(
              mad.glossary.messages.errorSavingWorkout[
                mad.common.observables.languageIndex()
              ]
            );
            mad.common.removeLastFromHistory();
            mad.mobileApp.navigate(gotoLink, "slide:right"); // go back to workouts
          }
        });
    } else {
      mad.local.appendWorkoutPlan(dataToSave);
      mad.alerts.info(mad.common.translate("messages", "willBeSynced"));
    }
  }

  function syncPendingWorkout() {
    console.log("syncing pending workout ...");
    mad.common.observables.set("syncingTrenings", true);

    mad.common.showLoader(mad.common.translate("words", "syncing"));

    var dataToUpdate = mad.common.pendingWorkouts[0];
    var link = {
      putanja: mad.common.variables.serverUrl + "api/Trening/AddResults",
      akcija: "POST"
    };
    /*
        mad.common.variables.forAjax.putanja = mad.common.variables.serverUrl + "api/Trening/AddResults";
        mad.common.variables.forAjax.akcija = "POST";
        mad.common.variables.dataOptions = dataToUpdate;
        mad.data.post(mad.common.variables.forAjax, mad.common.variables.dataOptions)
*/
    mad.data
      .post(link, dataToUpdate)
      .done(function(response) {
        mad.common.hideLoader();
        mad.common.pendingWorkouts.shift(); // remove first from array aka that one which is processed

        var numOfWorkoutsInFeedFollowing = mad.local.loadVariable(
          "noOfWorkoutsInFeed"
        );

        if (
          numOfWorkoutsInFeedFollowing &&
          typeof numOfWorkoutsInFeedFollowing === "number"
        ) {
          numOfWorkoutsInFeedFollowing++;
        } else {
          numOfWorkoutsInFeedFollowing = 1;
        }

        mad.local.saveVariable(
          "noOfWorkoutsInFeed",
          numOfWorkoutsInFeedFollowing
        );

        if (
          mad.common.variables.noOfWorkoutsInFeed &&
          typeof mad.common.variables.noOfWorkoutsInFeed === "number"
        ) {
          mad.common.variables.noOfWorkoutsInFeed++;
        } else {
          mad.common.variables.noOfWorkoutsInFeed = 1;
        }

        if (mad.common.pendingWorkouts.length == 0) {
          // if this is last one
          mad.common.observables.set("syncingTrenings", false);
          mad.local.clearWorkout();
          mad.common.observables.trigger("checkSync");
        } else {
          // for everyone but last
          mad.local.saveWorkout(mad.common.pendingWorkouts); // save what's rest
          syncPendingWorkoutAgain();
        }
      })
      .fail(function(fail) {
        console.log("syncing failed", fail);
        mad.common.hideLoader();
        mad.alerts.error(mad.common.translate("messages", "syncingError"));
      });
  }

  function syncPendingWorkoutAgain() {
    setTimeout(function() {
      syncPendingWorkout();
    }, timeBetweenSyncsWorkout);
  }

  function syncPendingUpdates() {
    console.log("syncing pending updates ...");
    mad.common.observables.set("syncingUpdates", true);

    var dataToUpdate = mad.common.pendingUpdates[0];
    mad.common.showLoader(mad.common.translate("words", "syncing"));

    mad.viewModels.madbarzWorkout.cekamDaZavrsiSejvanje = jQuery.Deferred();
    mad.viewModels.madbarzWorkout.cekamDaZavrsiSejvanje.then(
      function(status) {
        mad.common.pendingUpdates.shift(); // remove first from array aka that one which is processed
        if (mad.common.pendingUpdates.length == 0) {
          // if this is last one
          mad.common.observables.set("syncingUpdates", false);
          mad.local.clearPendingUpdates(); // clear pending updates from cache
          mad.local.removeVariable("savedWorkouts"); // clear saved workouts from cache - it will be read again when necessary
          mad.common.observables.trigger("checkSync"); // check if all syncing is finished
        } else {
          // for everyone but last
          mad.local.savePendingUpdates(mad.common.pendingUpdates); // save what's rest
          syncPendingUpdateAgain();
        }
      },
      function(fail) {
        console.log("status nakon update nije OK", fail);
        mad.alerts.error(mad.common.translate("messages", "syncingError"));
      }
    );
    updateSavedWorkoutsInDB(
      "onSync",
      dataToUpdate.Id,
      dataToUpdate.Name,
      dataToUpdate.ExercisesAndReps,
      dataToUpdate.NumOfCycles,
      dataToUpdate.ShortPause,
      dataToUpdate.LongPause
    );
  }

  function syncPendingUpdateAgain() {
    setTimeout(function() {
      syncPendingUpdates();
    }, timeBetweenSyncsSaved);
  }

  function afterEditReps() {
    var ndx, selectedExerciseReps, trazeni;

    if (
      mad.viewModels.madbarzWorkout.viewModel.get(
        "selectedExercise.OldValue"
      ) !=
      mad.viewModels.madbarzWorkout.viewModel.get("selectedExercise.NewValue")
    ) {
      // check for reps changes
      if (
        mad.viewModels.madbarzWorkout.viewModel.get("workoutType") == "Saved"
      ) {
        // only for saved workouts
        mad.viewModels.madbarzWorkout.viewModel.set(
          "savedWorkoutChanges",
          true
        );

        ndx = mad.viewModels.madbarzWorkout.viewModel.get(
          "selectedExercise.InternalNdx"
        );
        selectedExerciseReps = mad.viewModels.madbarzWorkout.viewModel.get(
          "selectedExercise.NewValue"
        );

        trazeni = mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
          "Exercises"
        )[ndx];
        trazeni.NewValue = selectedExerciseReps;
      }
    }

    $("#madbarzWorkout-list")
      .data("kendoMobileListView")
      .refresh();
  }

  return {
    viewModel: viewModel,
    pauza: pauza,
    selectNextExercise: selectNextExercise,
    workoutDone: workoutDone,
    addExerciseToFinishedExercises: addExerciseToFinishedExercises,
    startPauseCountdown: startPauseCountdown,
    zavrsetakOdbrojavanjaPauze: zavrsetakOdbrojavanjaPauze,
    updateReps: updateReps,
    syncPendingWorkout: syncPendingWorkout,
    syncPendingUpdates: syncPendingUpdates,
    saveWorkout: toSavedWorkouts,
    removeFromSaved: justRemoveFromSaved
  };
})();
