var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.planWorkoutStat = (function() {
  "use strict";

  var viewModel = kendo.observable({
    // properties or functions we want to observe and expose to html
    common: mad.common.observables,

    init: initView,
    beforeShow: beforeShow,
    show: showView,
    afterShow: afterShow,

    points: "",
    time: "",
    progress: "",
    bestExerciseValue: "", // postavljeno u madbarzWorkout
    bestExerciseName: "", // postavljeno u madbarzWorkout
    finished: "", // postavljeno u madbarzWorkout

    rounds: "",

    musclesLoaded: false,
    musclesGenerated: false,
    viewGenerated: false,
    dataToSendToServer: {},
    results: {},
    comparison: [],
    listOfFinishedExercises: [],

    power: [],
    powerByPercent: [],
    duration: 444,
    firstWorkout: true,
    PercentageOfMusclesHit: 0,
    LastCycle: 0,
    totalCycles: 0,
    WorkoutTime: "", //formated
    totalWorkoutTime: "",
    PauseTime: "",
    pausePercentage: "",
    workoutPercentage: "",
    WorkoutScore: 0,
    selectedTab: 0,
    isButtonVisibleL: false,
    isButtonVisibleR: true,

    enableIfOfflineL: true,
    enableIfOfflineR: true,

    score: 0,
    targetScore: 0,

    takenPhoto: "",
    takenPhotoInfo: {},
    photoNotTaken: true,

    sadrzajKomentara: "",
    noComment: true,
    adjustHeight: adjustHeight,

    closeModal: closeModal,
    sendFeedback: sendFeedback,
    feedbackText: "",
    binded: false,
    handleSkipClick: handleSkipClick,
    showPreloader: false
  });

  // show muscles when data arrives
  viewModel.bind("change", function(e) {
    if (e.field == "musclesLoaded") {
      console.log("musclesLoaded");
      if (viewModel.get("viewGenerated")) {
        console.log("and view generated");
        if (!viewModel.get("musclesGenerated")) {
          console.log("and muscles not generated");
          showMuscles();
        } else {
          console.log("and muscles already generated");
        }
      } else {
        console.log("and view not generated");
      }
    }
  });

  function initView(e) {
    //console.log("init planStat -------------------");

    var viewID = "#planWorkoutStat";

    viewModel.set("uCanTouchThis", false);

    $(viewID).kendoTouch({
      filter:
        ".rButton, .mainContainer, .takePhotoGumb, .editPhotoGumb, .commentGumb, .comment-content, .comment-value, .comment-OK",
      touchstart: function(e) {
        console.log("touchstart");
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          console.log("touchstart but canceled");
        }
      },
      tap: function(e) {
        if (!viewModel.get("uCanTouchThis")) {
          e.sender.cancel();
          console.log("but canceled");
        } else {
          handleTap(e);
        }
      }
    });

    viewModel.set("viewGenerated", false);

    $(".fdb-easy-tap").bind("tap", function(e) {
      console.log("tap na easy!");
      $("#fdb-easy").prop("checked", true);
      $("#fdb-beasy").prop("checked", false);
      $("#fdb-taman").prop("checked", false);
    });
    $(".fdb-beasy-tap").bind("tap", function(e) {
      console.log("tap na beasy!");
      $("#fdb-easy").prop("checked", false);
      $("#fdb-beasy").prop("checked", true);
      $("#fdb-taman").prop("checked", false);
    });
    $(".fdb-taman-tap").bind("tap", function(e) {
      console.log("tap na taman!");
      $("#fdb-easy").prop("checked", false);
      $("#fdb-beasy").prop("checked", false);
      $("#fdb-taman").prop("checked", true);
    });

    $(".fdb-okay-tap").bind("tap", function(e) {
      console.log("tap na taman!");
      $("#fdb-okay").prop("checked", true);
      $("#fdb-bad").prop("checked", false);
    });
    $(".fdb-bad-tap").bind("tap", function(e) {
      console.log("tap na taman!");
      $("#fdb-okay").prop("checked", false);
      $("#fdb-bad").prop("checked", true);
    });

    //   $(".fdb-easy-tap").bind( "tap", function( e ){
    //     console.log( "tapnut sam!" );
    //   });
  }

  function handleTap(e) {
    e.preventDefault(); // da ne probija

    var element = e.touch.target;

    if ($(element).hasClass("rButton")) {
      rightButtonAction();
    } else if ($(element).hasClass("takePhotoGumb")) {
      selectPhoto(e);
    } else if ($(element).hasClass("editPhotoGumb")) {
      selectPhoto(e);
    } else if (
      $(element).hasClass("commentGumb") ||
      $(element).hasClass("comment-content") ||
      $(element).hasClass("comment-value")
    ) {
      focusComment();
    } else if (
      $(element).hasClass("comment-OK") ||
      $(element).hasClass("mainContainer")
    ) {
      defocusComment();
    }
  }

  function beforeShow(e) {
    viewModel.set("uCanTouchThis", false);
    viewModel.set("viewGenerated", false);
    hideFeedbackLoader();
  }

  function showView(e) {
    console.log("showView");

    var contentHeight, contentWidth, scroller, scrollerWidget;

    scroller = $(".plan-workout-list-scroller");
    scrollerWidget = scroller.data("kendoMobileScroller");

    mad.common.setActualView();
    mad.common.addViewToHistory();
    mad.common.stretchViewContentToBeElastic();

    mad.common.variables.showGender = mad.common.variables.gender;

    kendo.bind($(mad.common.$actualViewID), viewModel);

    var origin = e.view.params.origin;

    clearRadioButtons();

    if (origin != "madbarzWorkoutStatShare") {
      kendo.bind($(mad.common.$actualViewID), viewModel);
      prepareBeforeFeedback(); // prepare data

      contentHeight = parseInt(mad.mobileApp.view().content.height());
      contentWidth = parseInt(mad.mobileApp.view().content.width());
      scroller.css({ height: contentHeight, width: contentWidth });

      openModal();
    }
    scrollerWidget.reset(); // go to top
    viewModel.set("viewGenerated", true);
  }

  function afterShow(e) {
    viewModel.set("uCanTouchThis", true);
  }

  function rightButtonAction() {
    mad.mobileApp.navigate(
      "ui/workouts/madbarz/workout/madbarzWorkoutStatShare.html?origin=planRoutineStat",
      "slide:left"
    );
  }

  function prepareBeforeFeedback() {
    mad.viewModels.editPhoto.viewModel.prepareMobiscroll();

    viewModel.set("noComment", true);
    viewModel.set("sadrzajKomentara", "");
    viewModel.set("photoNotTaken", true);
    viewModel.set("musclesGenerated", false);
    viewModel.set("takenPhoto", "images/no_photo_workout.jpg");

    viewModel.set("points", 0);
    viewModel.set("time", 0);
    viewModel.set("progress", 0 + "%");
    viewModel.set("rounds", 0);
    viewModel.set("pausePercentage", "0%");
  }

  function prepare() {
    if (viewModel.results.HasUploadedProfilePhoto) {
      viewModel.set("takenPhoto", viewModel.results.ProfilePhotoUrl);
    }

    var pauseTime = mad.viewModels.madbarzWorkout.viewModel.get(
      "counters.totalPauseTime"
    );
    var totalWorkoutTime = mad.viewModels.madbarzWorkout.viewModel.get(
      "counters.totalWorkoutTime"
    );

    viewModel.set("points", viewModel.score);
    viewModel.set(
      "time",
      mad.common.formatedTime(
        mad.viewModels.madbarzWorkout.viewModel.get("counters.totalWorkoutTime")
      )
    );
    viewModel.set(
      "progress",
      Math.round(
        (viewModel.get("score") * 100) / viewModel.get("targetScore")
      ) + "%"
    );
    viewModel.set(
      "rounds",
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.get(
        "FinishedCycles"
      )
    );
    viewModel.set(
      "pausePercentage",
      Math.round((pauseTime / totalWorkoutTime) * 100) + "%"
    );

    showWorkout();
    if (viewModel.get("musclesLoaded")) {
      showMuscles();
    }
  }

  function showWorkout() {
    console.log("showWorkout");

    var finished =
      mad.viewModels.madbarzWorkout.viewModel.selectedWorkout.finishedExercises;
    //console.log("podaci za listu", finished);

    // agregiraj i zbroji sve repse po exerciseu
    var finishedAggregate = d3
      .nest()
      //.key(function(d) { return d.RoutineExerciseId; })         // za grupiranje exercisea
      .key(function(d) {
        return d.Ordinal;
      })
      .rollup(function(v) {
        return d3.sum(v, function(d) {
          return parseInt(d.NumberOfReps);
        });
      })
      .entries(finished);
    //console.log("grupirano i sumirano", finishedAggregate);

    // povuci ostale podatke za listu
    _.map(finishedAggregate, function(element) {
      var found = _.find(finished, function(svi) {
        //return svi.RoutineExerciseId == parseInt(element.key)   // za grupiranje exercisea
        return svi.Ordinal == parseInt(element.key);
      });
      console.log("found", found);
      if (mad.common.isNullOrEmpty(found)) {
        console.log("nije upareno - greska");
      } else {
        var formmatedVal = element.values;
        if (found.Unit == "SEC") {
          formmatedVal = mad.common.formatTimeForDisplayingTimedExercises(
            element.values
          );
        } else {
          formmatedVal += " Reps";
        }

        return _.extend(element, {
          Ordinal: found.Ordinal,
          Name: found.Name,
          ImageUrlMobile: found.ImageUrlMobile,
          NumberOfReps: element.values,
          FormmatedNumOfReps: formmatedVal,
          Unit: found.Unit
        });
      }
    });

    //console.log("grupirano, sumirano, prosireno", finishedAggregate);
    finishedAggregate = _.sortBy(finishedAggregate, "Ordinal");
    //console.log("sortirano", finishedAggregate);

    viewModel.set("listOfFinishedExercises", finishedAggregate); // za shared

    var template = kendo.template(
      $("#plan-stat-workout-list-template").html(),
      { useWithBlock: false }
    );
    var result = template(finishedAggregate); //Pass the data to the compiled template
    $("#planWorkoutStat-list").html(result);
  }

  function showMuscles() {
    console.log("showMuscles");

    var musclesTemplate = kendo.template(
      $("#plan-wkt-stat-muscles-template").html()
    );
    var musclesHTML = musclesTemplate(mad.viewModels.planWorkoutStat.viewModel);
    $("#planWorkoutStat-muscles").html(musclesHTML);

    musclesTemplate = kendo.template($("#MuscleMapTemplate").html(), {
      useWithBlock: false
    });
    musclesHTML = musclesTemplate(
      mad.viewModels.planWorkoutStat.viewModel.results.Stats.ActivatedMuscleIds
    );
    $("#planWorkoutStat-muscles-imgs").html(musclesHTML);

    setTimeout(function() {
      var contentHeight = parseInt(mad.mobileApp.view().content.height());
      var reduce = 25 / 100; //percentage
      var muscleManContainerHeight = parseInt(
        contentHeight - contentHeight * reduce
      );
      var contentWidth = parseInt(mad.mobileApp.view().content.width());
      $("#planWorkoutStat-muscle .muscles-container").css(
        "height",
        muscleManContainerHeight
      );
      mad.common.scaleMuscleMan2(muscleManContainerHeight, contentWidth, 10);
    }, 111);

    viewModel.set("musclesGenerated", true);
  }

  function focusComment() {
    $(".entryField-comment").removeClass("hidden");
    $(".comment-value").focus();

    /*
        if (kendo.support.mobileOS.device == "android" || window.navigator.simulator) {
            $("#workoutStatContainer .zamraci").addClass("defocus");
        }
        */
    $("#planWorkoutStatContainer .zamraci").addClass("defocus");
  }

  function defocusComment() {
    $(".comment-value").blur();
    $(".entryField-comment").addClass("hidden");

    //if (viewModel.get("sadrzajKomentara") !=""){
    if (viewModel.get("sadrzajKomentara").trim().length > 0) {
      viewModel.set("noComment", false);
    } else {
      viewModel.set("noComment", true);
    }

    $("#planWorkoutStatContainer .zamraci").removeClass("defocus");
    $(".plan-workout-list-scroller")
      .data("kendoMobileScroller")
      .contentResized();
  }

  function adjustHeight(o) {
    var minHeight = 3;
    var object = o.currentTarget;

    object.style.height = "1px";
    object.style.height = minHeight + object.scrollHeight + "px";
  }

  function selectPhoto(e) {
    if (e) {
      e.preventDefault();
    }

    var inst;

    //if (viewModel.results.HasUploadedProfilePhoto && viewModel.get("takenPhoto") == "images/no_photo_workout.jpg"){
    // ako nema profilnu i nije vec uploadana pitaj oce li fotkat ili izabrat neku
    if (viewModel.get("photoNotTaken")) {
      inst = $(".actionsheetphotoupload").mobiscroll("getInst");
    } else {
      // ak vec ima neka ponudi edit ili opet
      inst = $(".actionsheetphotosource").mobiscroll("getInst");
      inst.settings.wheels = [[{ values: ["Edit photo", "Upload new"] }]]; //ako slucajno treba promjenit defaultno
    }
    setTimeout(function() {
      inst.show(false, false);
    }, 22);
  }

  function openModal() {
    viewModel.set("modalOpened", true);

    var modalID = $("#feedbackModal");
    var mv = modalID.data("kendoMobileModalView");

    modalID.removeClass("hidden");
    mv.open();
    modalID.css("height", modalID.parent().height());

    $(".feedbackModalContainer").css("height", modalID.parent().height());
    mv.scroller.reset();
    viewModel.set("feedbackText", "");

    /*
        var happinessSlider = document.getElementById('happiness-slider');
        var tezinaSlider = document.getElementById('feeling-slider');

        if (!happinessSlider.noUiSlider){  // ako jos nije kreiran time slider
            createTimeSlider(happinessSlider);
            createTimeSlider(tezinaSlider);
            happinessSlider.noUiSlider.set( [3] );
            tezinaSlider.noUiSlider.set( [3] );
        }
        */
  }

  function closeModal() {
    viewModel.set("modalOpened", false);

    var modalID = $("#feedbackModal");
    var mv = modalID.data("kendoMobileModalView");
    prepare();
    mv.close();
    modalID.addClass("hidden");
    hideFeedbackLoader();
  }

  function createTimeSlider(container) {
    console.log("kreiranje time slidera");

    var slajo = noUiSlider.create(container, {
      start: [1],
      range: {
        min: [1],
        max: [5]
      },
      //connect: [true, false],
      behaviour: "drag-tap-snap",
      step: 1,
      /*
            pips: {
                mode: 'steps',
                density: 100,
                filter: function(v,t){
                    return 1
                },time-container
                format: {
                    to: function (value) {
                        var from = value * 15 + 1;
                        var to = (value < 2) ? value * 15 + 15 : "∞";
                        return from + '-' + to + ' min';
                    }
                }
            }
            */
      tooltips: [
        {
          to: function(value) {
            if (value == 1) {
              return "way too easy"; // terrible
            } else if (value == 2) {
              return "bit too easy"; // bad
            } else if (value == 3) {
              return "just right"; // okay
            } else if (value == 4) {
              return "bit hard"; // good
            } else if (value == 5) {
              return "way too hard"; // great
            }
          }
        }
      ]
    });
    console.log("assigning createTimeSlider on change event");
    //container.noUiSlider.on('update', function ( values, handle ) {
    slajo.on("update", function(values, handle) {
      console.log("slider value changed", container, values, handle);
    });
  }

  function sendFeedback() {
    var happiness = document.querySelector('input[name="happy"]:checked').value;
    var hardness = document.querySelector('input[name="hard"]:checked').value;
    var feedback = viewModel.get("feedbackText");

    var feedbackData = {
      UserLikedWorkout: hardness != "0",
      ReportedDifficulty: happiness,
      FeedbackContent: feedback
    };

    /*
        var plan = mad.viewModels.plansWork.viewModel.selectedPlan.Name;
        var week = mad.viewModels.plansWork.viewModel.selectedPlan.ActiveExecution.ExecutionData.CurrentWeek;
        var rbr = parseInt(mad.viewModels.plansWork.viewModel.selectedWorkout.WorkoutOrdinal)-1;
        var wname = mad.viewModels.plansWork.viewModel.selectedPlan.ActiveExecution.ExecutionData.Weeks[week-1].Workouts[rbr].Name;
        
        var formatedFeedback = "plan:" + plan + ", ";
        formatedFeedback += "tjedan: " + week + ", ";
        formatedFeedback += "workout: " + wname + ", ";
        formatedFeedback += "zadovoljstvo: " + happiness + ", ";
        formatedFeedback += "tezina: " + hardness + ", ";
        formatedFeedback += "komentar: " + feedback ;

        console.log("feedback je", plan, week, rbr, wname, happiness, hardness, feedback);
        console.log("feedback je", formatedFeedback);

        var subject = "test/" + plan + "/" + wname;
        var levelRange = ["?", "?", "Beginner", "Intermediate", "Advanced"];
        var userLevel = levelRange[mad.viewModels.settings.viewModel.get("user.FitnessLevel")];    //must be 2,3 or 4
        var ver = (version) ? version : "?";

        var link   = {putanja : mad.common.variables.serverUrl + "api/user/PostFeedback", akcija : "POST"};
        var podaci = {
            Feedback: formatedFeedback,
            Type: subject,
            Level: userLevel,
            Device_model: device.model,
            Device_platform: device.platform,
            Device_version: device.version,
            AppVersion: ver
        };

        /* privremeno
        mad.data.post(link, podaci)
            .done(function (data) {
                console.log('feedback sent', data);
            })
            .fail(function (qXHR, textStatus, errorThrown) {
                console.log("Error sending feedback", textStatus, qXHR);
            });
        */

    sendWorkoutDataToServer(feedbackData);
  }

  function handleSkipClick() {
    sendWorkoutDataToServer(null);
  }

  function sendWorkoutDataToServer(feedbackData) {
    showFeedbackLoader();

    var link = {
      putanja:
        mad.common.variables.serverUrl + "api/WorkoutPlans/SaveWorkoutActivity",
      akcija: "POST"
    };
    var podaci = mad.viewModels.madbarzWorkout.viewModel.planDataToSend;
    var dataToSave = podaci;

    if (feedbackData) {
      podaci.UserGaveFeedback = true;
      podaci.UserLikedWorkout = feedbackData.UserLikedWorkout;
      podaci.ReportedDifficulty = feedbackData.ReportedDifficulty;
      podaci.FeedbackContent = feedbackData.FeedbackContent;
    } else {
      podaci.UserGaveFeedback = false;
      podaci.UserLikedWorkout = false;
      podaci.ReportedDifficulty = -1;
      podaci.FeedbackContent = "";
    }

    mad.data
      .post(link, podaci)
      .done(function(data, code) {
        console.log(
          ">>> nakon slanje podataka u SaveWorkoutActivity response je",
          data
        );

        mad.common.hideLoader();

        if (dataToSave.WorkoutActivity.TreningLength >= 300) {
          var numOfWorkoutsForThisUserSoFar = parseInt(
            mad.local.loadVariable("NumberOfFinishedWorkouts")
          );

          var additionalData = {
            Type: "Workout Plan",
            "Workout Length": Math.round(
              dataToSave.WorkoutActivity.TreningLength / 60
            ),
            "Number of Finished Cycles":
              dataToSave.WorkoutActivity.FinishedCycles,
            "Number Of workouts for this user so far": numOfWorkoutsForThisUserSoFar
          };

          mad.analyticEvents.track(
            [
              mad.analyticEvents.services.GA,
              mad.analyticEvents.services.MIXP,
              mad.analyticEvents.FB
            ],
            mad.analyticEvents.categories.MAX,
            mad.analyticEvents.types.EVENT,
            "Workout Done Overall 5 mins",
            additionalData,
            "Training Activity",
            "Workout Done" + " - Longer than 5min",
            "Workout Plan",
            numOfWorkoutsForThisUserSoFar
          );

          mad.appsFlyer.trackEvent(
            "Workout Done Overall 5 mins - From plan",
            additionalData
          );

          if (numOfWorkoutsForThisUserSoFar == 0) {
            mad.appsFlyer.trackEvent(
              "Workout Done Overall 5 mins - From plan - 1",
              additionalData
            );
          }
          if (numOfWorkoutsForThisUserSoFar == 2) {
            mad.appsFlyer.trackEvent(
              "Workout Done Overall 5 mins - From plan - 3",
              additionalData
            );
          }
        }

        if (data.Execution.Status == "finished") {
          var additionalInfo = {
            "Part Name": mad.viewModels.plansWork.viewModel.get(
              "selectedPlan.Name"
            ),
            "Part Ordinal Name": mad.viewModels.plansWork.viewModel.get(
              "selectedPlan.CategoryOrdinalName"
            ),
            "How was it finished": "Finished workout"
          };

          mad.analyticEvents.track(
            [mad.analyticEvents.services.GA],
            mad.analyticEvents.categories.WORKOUTPLAN,
            mad.analyticEvents.types.EVENT,
            "Workout Plan - Finished",
            additionalInfo,
            "Workout Plan",
            "Finished"
          );

          mad.appsFlyer.trackEvent("Workout Plan - Finished", additionalInfo);

          viewModel.set("showPopup", true);
          mad.viewModels.madbarzWorkout.viewModel.set("showPopup", true);
        }

        // move results to another (planWorkoutStat) view model
        viewModel.set("results", data);
        // say that muscles are ready so we can show them
        viewModel.set("musclesLoaded", true);

        closeModal();
      })
      .fail(function(qXHR, textStatus, errorThrown) {
        console.log("save failed");

        mad.common.hideLoader();
        // enable showStats button on madbarzWorkoutDone view (da zavrsi animacija)
        //mad.viewModels.madbarzWorkoutDone.viewModel.set("footerEnabled", true);

        if (textStatus == "timeout") {
          if (mad.common.observables.askAboutWaiting) {
            var msg = mad.glossary.messages.saveTimeout;
            navigator.notification.alert(
              msg.message[mad.common.observables.languageIndex()],
              setTimeout(function() {
                // dodano spremanje u cache kod timeouta (postoji mogucnost da 2x spremi)
                mad.local.appendWorkoutPlan(dataToSave);
                mad.common.removeLastFromHistory();
              }, 1111), // after some time
              msg.title[mad.common.observables.languageIndex()],
              msg.button[mad.common.observables.languageIndex()]
            );
          } else {
            mad.alerts.error(
              mad.glossary.messages.tooLongNotSaved[
                mad.common.observables.languageIndex()
              ]
            );
          }
        } else {
          console.log("Error saving workout ", textStatus, qXHR);
          mad.alerts.error(
            mad.glossary.messages.errorSavingWorkout[
              mad.common.observables.languageIndex()
            ]
          );
          mad.common.removeLastFromHistory();
          closeModal();
          mad.mobileApp.navigate(gotoLink, "slide:right"); // go back to workouts
        }
      });
  }

  function showFeedbackLoader() {
    $("#planStatsPreloader").removeClass("nothere");
    $("#planStatsButtons").addClass("nothere");
  }

  function hideFeedbackLoader() {
    $("#planStatsPreloader").addClass("nothere");
    $("#planStatsButtons").removeClass("nothere");
  }

  function clearRadioButtons() {
    $("#fdb-easy").prop("checked", false);
    $("#fdb-beasy").prop("checked", false);
    $("#fdb-taman").prop("checked", false);

    $("#fdb-okay").prop("checked", false);
    $("#fdb-bad").prop("checked", false);
  }

  return {
    viewModel: viewModel
  };
})();
