var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.madbarzSavedWorkoutS = (function() {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        beforeShow: beforeShow,
        show: showView,
        afterShow: afterShow,

        noSaved: true,
        hasPro: false,
        loadingSaved: true,
        origin: "?",

        selectedWorkout: {},

        reloadSavedWorkouts: false,

        timeLastPull: 0,
        savedWorkouts: new kendo.data.DataSource({
            data: [],
            group:{ field: "createdBy", dir: "desc" },
            sort: { field: "DateWhenSaved", dir: "desc" }
        }),

        uCanTouchThis: false

    });

    var scroller;

    function initView(e) {

        var viewID = "#madbarzSavedWorkoutsList";
        viewModel.set("uCanTouchThis", false);
        scroller = e.view.scroller;

        $(viewID).kendoTouch({
            filter: ".lButton, .rButton, .add-button, .list-item",
            touchstart: function(e) {
                //console.log("touchstart");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    //console.log("touchstart but canceled");
                    if(scroller){
                        if (scroller.enabled){
                            //console.log("scroller disablan");
                            scroller.disable();
                        }
                    }
                }else{
                    //console.log("moze touch");
                    if(scroller){
                        if (!scroller.enabled) {
                            //console.log("scroller enablan");
                            scroller.enable();
                        }
                    }
                }
            },
            tap: function(e) {
                //console.log(e.touch.target, " was tapped");
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                    //console.log("but canceled")
                }else{
                    handleTap(e);
                }
            }
        });

        scroller.setOptions({
                pullToRefresh: true,
                pullOffset: 100,
                messages: {
                    pullTemplate: $("#refresh-template").html(),
                    releaseTemplate: $("#refresh-template").html(),
                    refreshTemplate: $("#refresh-template").html()
                },
                pull: function (e){
                    //console.log("pull")
                    if (!viewModel.get("uCanTouchThis")){
                        e.preventDefault();
                        console.log("pull canceled")
                        return
                    }

                    var atTheMoment = (new Date()).getTime();
                    //console.log(atTheMoment - viewModel.timeLastPull);

                    if (atTheMoment - viewModel.timeLastPull > 20123){
                        viewModel.timeLastPull = atTheMoment;
                        readSavedWorkouts();
                    }else{
                        //console.log("to top");
                        scroller.pullHandled();
                    }
                },
                scroll: function(e){
                    //console.log("scroll");
                    if (!viewModel.get("uCanTouchThis")){
                        e.preventDefault();
                        //console.log("pozvan preventDefault");
                        if(scroller){
                            if (scroller.enabled){
                                //console.log("scroller disablan");
                                scroller.disable();
                            }
                        }
                    }else{
                        //console.log("moze scroll");
                        if(scroller){
                            if (!scroller.enabled) {
                                //console.log("scroller enablan");
                                scroller.enable();
                            }
                        }
                    }
                }
            }
        );

        $(".madbarzSavedWorkouts-list").kendoMobileListView({
            dataSource: viewModel.savedWorkouts,
            autoBind: false,
            endlessScroll: false,
            fixedHeaders: false,
            template: function(data) {
                var tpl = kendo.template($("#savedWorkoutsTemplate").text());
                return tpl(data);
            },
            filterable: {
                field: "Name",
                operator: "contains"
            }

        });

        viewModel.set("reloadSavedWorkouts", false);
    }

    function handleTap(e) {
        e.preventDefault(); // da ne probija

        var element = e.touch.target;

        if ($(element).hasClass("lButton")) {
            leftButtonAction();
        }else if ($(element).hasClass("rButton")) {
            createWorkout();
        } else if ($(element).hasClass("add-button")) {
            createWorkout();
        }else if ($(element).hasClass("list-item")) {
            workoutSelected(e);
        }
    }

    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
    }

    function showView(e) {
        mad.common.setActualView();
        mad.common.addViewToHistory();
        mad.common.stretchViewContentToBeElastic();

        kendo.bind($(mad.common.$actualViewID), viewModel);

        var origin = e.view.params.origin;
        //console.log("origin", origin);
        viewModel.set("origin", origin);

        var reload = viewModel.get("reloadSavedWorkouts");

        if (origin == "menu" || origin == "start" || origin == "createWorkout"  || origin == "finishedEdit"  || (origin == "madbarzWorkout" && reload)){
            readSavedWorkouts();
        }else{
            viewModel.set("uCanTouchThis", true);
        }
    }

    function afterShow(e) {

        //viewModel.set("uCanTouchThis", true);
        mad.googleAnalytics.trackView("Workouts - Saved");
    }

    function readSavedWorkouts() {
        var tmp = (mad.local.loadSaved() == []) ? [] : mad.local.loadSaved();

        if (navigator.connection.type == Connection.UNKNOWN || navigator.connection.type == Connection.NONE) {
           viewModel.savedWorkouts.data(tmp);
          if (tmp.length == 0) {
            // show msg if there is no saved workouts
            viewModel.set("noSaved", true);
          } else {
            viewModel.set("noSaved", false);
            if (mad.common.actualViewID == "madbarzSavedWorkoutsList") {
              refreshListview();
            }
          }

          viewModel.set("uCanTouchThis", true);
        } else {
          if (mad.common.isNullOrEmpty(tmp)) {
            mad.local.removeVariable("savedWorkouts");
            readFromServer();
          } else {
            console.log("parsam saved workouts iz keša");
            viewModel.savedWorkouts.data(tmp);
            viewModel.set("noSaved", false);
            readFromServer();
          }
        }
    }

    function readFromServer(){

        //firstly we check if user is PRO or not
        // so that we can know how many saved workouts to fetch for the user      
        var hasUserAccessToUswPromise = $.Deferred();

        hasUserAccessToUswPromise.then(
            function (success) {
                if (success) { // ako ima access to pro
                    //console.log("user has access to pro");
                    viewModel.set("hasPro", true);
                    readDataFromServer();

                } else {
                    //console.log("user nema access to pro");
                    viewModel.set("hasPro", false);
                    readDataFromServer();
                }
            },
            function (fail) {
                console.log("hasUserAccessToPro failed !!");
                readDataFromServer();
            });

        //check if user has access to pro or not
        mad.common.hasUserAccessToPro(hasUserAccessToUswPromise);
    }

    function readDataFromServer() {
        mad.viewModels.madbarzSavedWorkoutS.viewModel.set("loadingSaved", true);

        var listview = $(".madbarzSavedWorkouts-list").data("kendoMobileListView");

        if (scroller.enabled){
            scroller.disable();
            scroller.animatedScrollTo(0, 100);
            setTimeout(function() {
                scroller.enable();
            }, 111);
        }else{
            scroller.animatedScrollTo(0, 100);
        }


        //scroller.animatedScrollTo(0, 100);

        //console.log("idem ucitat sejvane sa servera");
        mad.models.savedWorkouts.read().then(
            function () { // read OK (promise finished)
                //console.log("ucitani sejvani",mad.models.savedWorkouts.data());
                console.log("podaci ucitani");
                viewModel.savedWorkouts.data(mad.models.savedWorkouts.data());
                mad.viewModels.madbarzSavedWorkoutS.viewModel.set("loadingSaved", false);

                if (mad.models.savedWorkouts.data().length == 0) {
                    viewModel.set("noSaved", true);
                } else {
                    viewModel.set("noSaved", false);
                }

                if (mad.common.actualViewID == 'madbarzSavedWorkoutsList') {
                    if (mad.models.savedWorkouts.online()) { // when data fetched when online hide preloader

                        if (scroller.enabled){
                            console.log("disablanje scrollera");
                            scroller.disable();
                            console.log("animiranje");
                            scroller.animatedScrollTo(0, 0);
                                console.log("enablanje scrollera");
                                scroller.enable();
                                console.log("refresh liste");
                                listview.refresh();
                                viewModel.set("uCanTouchThis", true);
                        }else{
                            console.log("scroller na 0 i listview refresh");
                            scroller.animatedScrollTo(0, 0);
                            listview.refresh();
                            viewModel.set("uCanTouchThis", true);
                        }

                        /*
                        setTimeout(function() {
                            scroller.animatedScrollTo(0, 0);
                            listview.refresh();
                            viewModel.set("uCanTouchThis", true);
                        }, 333);
                        */
                    }
                }
            },
            function () { // read failed
                console.log("sejvani workouti nisu uspješno ucitani");

                if (mad.common.actualViewID == 'madbarzSavedWorkoutsList') {
                    if (mad.models.savedWorkouts.online()) { // when data fetched when online hide preloader
                        setTimeout(function() {
                            scroller.animatedScrollTo(0, 0);
                            listview.refresh();
                            viewModel.set("uCanTouchThis", true);
                        }, 333);
                    }
                }
            }
        );
    }

    function refreshListview(){
        scroller.pullHandled();
        scroller.reset();                                         // go to top
    }

    function leftButtonAction() {
        if (mad.common.variables.navigationHistory.length > 1 && viewModel.get("origin") != "finishedEdit") {
            console.log("back kroz history");
            mad.common.goBack();
        }else{
            console.log("forsirani back");
            mad.mobileApp.navigate("ui/workouts/menu.html", "slide:right");
        }
    }

    function workoutSelected(e){
        //var tappedElement = $(e.touch.currentTarget);
        var tappedElement = e.touch.target;  // drazen - zbog nove verzije kenda
        var listview = $(".madbarzSavedWorkouts-list").data("kendoMobileListView");
        var li = tappedElement.closest("li");
        var selectedItemData = listview.dataSource.getByUid(li.attr("data-uid"));

        if (selectedItemData.HasUserPermission) {
            viewModel.set("selectedWorkout", selectedItemData);
            viewModel.set("reloadSavedWorkouts", false);
            mad.viewModels.madbarzWorkout.viewModel.set("workoutType", "Saved");
            mad.mobileApp.navigate("ui/workouts/madbarz/workout/madbarzWorkout.html", "slide:left");
        } else {
            mad.viewModels.popups.viewModel.openModalWindow("buySaved", "Oops...", "Your subscription is expired. Only the last 3 workouts are visible now. To see all workouts please renew your subscription.", "Renew subscription");
        }
    }

    function createWorkout(e) {
        if (viewModel.common.ifOffline()){
            mad.alerts.realTop0("You are currently offline")
            return;
        }
        mad.googleAnalytics.trackEvent("Create Workout", "Click Create Workout");
        mad.mobileApp.navigate("ui/workouts/createWorkout/Name.html?origin=menu", "slide:left");
    }

    return {
        viewModel: viewModel,
        readSavedWorkouts: readSavedWorkouts
    };

}());