var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.madbarzSavedWorkoutS = (function() {
  "use strict";

  var viewModel = kendo.observable({
    // properties or functions we want to observe and expose to html
    common: mad.common.observables,

    init: initView,
    show: showView,
    afterShow: afterShow,

    //isButtonVisibleL: checkifOnline,
    isButtonVisibleL: true,
    enableIfOfflineL: true,
    leftButtonAction: leftButtonAction,

    //isButtonVisibleR: checkifOnline,
    isButtonVisibleR: true,
    //enableIfOfflineR: true,
    enableIfOfflineR: checkifOnline,
    rightButtonAction: createWorkout,

    checkifOnline: checkifOnline,
    titlePressed: mad.common.titlePressed,

    createWorkout: createWorkout,
    useMadbarz: useMadbarz,
    noSaved: true,
    hasPro: false,
    loadingSaved: true,

    selectedWorkout: {},

    reloadSavedWorkouts: false,

    savedWorkouts: new kendo.data.DataSource({
      data: [],
      group: { field: "createdBy", dir: "desc" }
      /*
            ,
            change: function(e) {
                var data = this.data();
                console.log("savedWorkouts promjena date je", data);
                console.log(e);
            }
            */
    })
  });

  function initView(e) {
    $("#savedList").kendoMobileScroller({
      pullToRefresh: true,
      pullOffset: 100,
      messages: {
        pullTemplate: $("#refresh-template").html(),
        releaseTemplate: $("#refresh-template").html(),
        refreshTemplate: $("#refresh-template").html()
      },
      pull: function(e) {
        var scroller = e.sender;
        var listview = $(".madbarzWorkoutsList-list").data(
          "kendoMobileListView"
        );
        readSavedWorkouts();
      }
    });

    $(".madbarzWorkoutsList-list")
      .kendoMobileListView({
        dataSource: viewModel.savedWorkouts,
        autoBind: false,
        endlessScroll: false,
        fixedHeaders: false,
        template: function(data) {
          var tpl = kendo.template($("#savedWorkoutsTemplate").text());
          return tpl(data);
        }
      })
      .kendoTouch({
        filter: ".list-item",
        //filter: "li",
        tap: workoutSelected
      });

    viewModel.set("reloadSavedWorkouts", false);
  }

  function showView(e) {
    mad.common.setActualView();

    mad.common.addViewToHistory();
    setupView();
    mad.common.stretchView();
    kendo.bind($(mad.common.$actualViewID), viewModel);
    mad.common.selectMenuTab("workouts");

    var origin = e.view.params.origin;
    var reload = viewModel.get("reloadSavedWorkouts");

    if (
      origin == "menu" ||
      origin == "start" ||
      origin == "createWorkout" ||
      (origin == "madbarzWorkout" && reload)
    ) {
      readSavedWorkouts();
    }
  }

  function afterShow(e) {
    var trazeniScroller = $("#savedList");

    var h = parseInt(mad.mobileApp.view().content.height());
    $(trazeniScroller).css("height", h);
    //$(trazeniScroller).data("kendoMobileScroller").reset();

    $(".madbarzWorkoutsList-list").css("height", h + 1);

    mad.googleAnalytics.trackView("Workouts - Saved");
  }

  function checkifOnline() {
    return viewModel.common.ifOnline();
  }

  function checkSaved() {
    return !viewModel.get("noSaved");
  }

  function setupView(id) {
    mad.common.setActualViewTitle();
    mad.common.setResolutionForView(
      parseInt(mad.mobileApp.view().content.width()),
      parseInt(mad.mobileApp.view().content.height())
    );
    mad.common.setLangForView();
  }

  function readSavedWorkouts() {
    var tmp = mad.local.loadSaved() == [] ? [] : mad.local.loadSaved();

    if (
      navigator.connection.type == Connection.UNKNOWN ||
      navigator.connection.type == Connection.NONE
    ) {
      viewModel.savedWorkouts.data(tmp);
      if (tmp.length == 0) {
        // show msg if there is no saved workouts
        viewModel.set("noSaved", true);
      } else {
        viewModel.set("noSaved", false);
        if (mad.common.actualViewID == "madbarzSavedWorkoutsList") {
          refreshListview();
        }
      }
    } else {
      if (mad.common.isNullOrEmpty(tmp)) {
        mad.local.removeVariable("savedWorkouts");
        readFromServer();
      } else {
        console.log("parsam saved workouts iz keša");
        viewModel.savedWorkouts.data(tmp);
        if (mad.common.actualViewID == "madbarzSavedWorkoutsList") {
          refreshListview();
        }
        viewModel.set("noSaved", false);

        readFromServer();
      }
    }
  }

  function readFromServer() {
    //firstly we check if user is PRO or not
    // so that we can know how many saved workouts to fetch for the user
    var hasUserAccessToUswPromise = $.Deferred();

    hasUserAccessToUswPromise.then(
      function(success) {
        if (success) {
          // ako ima access to pro
          console.log("user has access to pro");
          viewModel.set("hasPro", true);
          readDataFromServer();
        } else {
          console.log("user nema access to pro");
          viewModel.set("hasPro", false);
          readDataFromServer();
        }
      },
      function(fail) {
        console.log("hasUserAccessToPro failed !!");
        readDataFromServer();
      }
    );

    //check if user has access to pro or not
    mad.common.hasUserAccessToPro(hasUserAccessToUswPromise);
  }

  function readDataFromServer() {
    mad.viewModels.madbarzSavedWorkoutS.viewModel.set("loadingSaved", true);

    console.log("idem ucitat sejvane sa servera");
    mad.models.savedWorkouts.read().then(
      function() {
        // read OK (promise finished)
        //console.log("savedWorkouts sa servera nakon promisa", mad.models.savedWorkouts.data());
        viewModel.savedWorkouts.data(mad.models.savedWorkouts.data());
        mad.viewModels.madbarzSavedWorkoutS.viewModel.set(
          "loadingSaved",
          false
        );

        if (mad.models.savedWorkouts.data().length == 0) {
          viewModel.set("noSaved", true);
        } else {
          viewModel.set("noSaved", false);
          if (mad.common.actualViewID == "madbarzSavedWorkoutsList") {
            refreshListview();
          }
        }
      },
      function() {
        // read failed
        console.log("sejvani workouti nisu uspješno ucitani");
      }
    );
  }

  function refreshListview() {
    //kendo.bind($(mad.common.$actualViewID), viewModel);

    var scr = $("#savedList").data("kendoMobileScroller");

    if (!mad.common.isNullOrEmpty(scr)) {
      console.log("top je", scr.scrollTop);
      if (scr.scrollTop != 0) {
        console.log("anim gore");
        scr.animatedScrollTo(0, 0);
        scr.pullHandled();
      }

      setTimeout(function() {
        $(".madbarzWorkoutsList-list")
          .data("kendoMobileListView")
          .refresh();
      }, 11);
    }
  }

  function leftButtonAction() {
    if (mad.common.variables.navigationHistory.length > 1) {
      console.log("back kroz history");
      mad.common.goBack();
    } else {
      console.log("forsirani back");
      mad.mobileApp.navigate("ui/workouts/menu.html", "slide:right");
    }
  }

  function workoutSelected(e) {
    e.preventDefault(); // da ne probija

    //var tappedElement = $(e.touch.currentTarget);
    var tappedElement = e.touch.target; // drazen - zbog nove verzije kenda

    var listview = $(".madbarzWorkoutsList-list").data("kendoMobileListView");
    var li = tappedElement.closest("li");
    var selectedItemData = listview.dataSource.getByUid(li.attr("data-uid"));

    if (selectedItemData.HasUserPermission) {
      viewModel.set("selectedWorkout", selectedItemData);
      viewModel.set("reloadSavedWorkouts", false);
      mad.viewModels.madbarzWorkout.viewModel.set("workoutType", "Saved");
      mad.mobileApp.navigate(
        "ui/workouts/madbarz/workout/madbarzWorkout.html",
        "slide:left"
      );
    } else {
      mad.viewModels.popups.viewModel.openModalWindow(
        "buySaved",
        "Oops...",
        "Your subscription is expired. Only the last 3 workouts are visible now. To see all workouts please renew your subscription.",
        "Renew subscription"
      );
    }
  }

  function createWorkout(e) {
    if (this.common.ifOffline()) {
      mad.alerts.realTop0(mad.common.translate("words", "offline"));
      return;
    }

    mad.googleAnalytics.trackEvent("Create Workout", "Click Create Workout");
    mad.mobileApp.navigate(
      "ui/workouts/createWorkout/Name.html?origin=menu",
      "slide:left"
    );
  }

  function useMadbarz(parameters) {
    mad.mobileApp.navigate(
      "ui/workouts/madbarz/madbarzWorkoutsFilter.html?origin=madbarzSavedWorkoutS"
    );
  }

  return {
    viewModel: viewModel,
    readSavedWorkouts: readSavedWorkouts
  };
})();
