var mad = mad || {};

mad.viewModels = mad.viewModels || {};

mad.viewModels.workoutsMenu = (function () {

    "use strict";

    var viewModel = kendo.observable({
        // properties or functions we want to observe and expose to html
        common: mad.common.observables,

        init: initView,
        beforeShow:beforeShow,
        show: showView,
        afterShow: afterShow,

        syncInfo: "",
        sayHello: "",
        ime: "",
        //quoteOfTheDay: mad.common.getQuote,
        myImg: "",
        IsPro: false,
        controlFinished: false,
        showCallToAction: false,

        generatedMenu: "",
        isModalOpened: false,
        isFemale: false,
        openSales: openSales,
        closeModalButtonClick: closeModalButtonClick,

        selectedPlan: {},
        selectedCategory: 0,

        uCanTouchThis: false,

        enabled: true

    });

    function initView(e) {
        var viewID = "#workoutsMenu";

        viewModel.set("uCanTouchThis", false);

        $(viewID).kendoTouch({
            filter: ".goPro, .gotoPlan, .madbarzRutine, .custom",
            touchstart: function(e) {
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                }
            },
            tap: function(e) {
                if (!viewModel.get("uCanTouchThis")){
                    e.sender.cancel();
                }else{
                    handleTap(e);
                }
            }
        });
    }

    function handleTap(e) {
        e.preventDefault();     // da ne probija

        var tappedElement = $(e.touch.target);

        if (tappedElement.hasClass("madbarzRutine")) {
            tappedElement.find(".preloader").removeClass("hidden");
        }

        var loadedRoutines = mad.local.loadMadbarzRoutines(),
            routines = loadedRoutines.data,
            expired = loadedRoutines.expired;

        if (tappedElement.hasClass("goPro")) {
            var data = {
                "Source" : "Workouts - Main screen"
            };
            mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.FB], mad.analyticEvents.categories.SALES, mad.analyticEvents.types.EVENT,
                "Pro Converter - Crown Click",
                data,
                "Pro Converter",
                "Crown Click");
            mad.appsFlyer.trackEvent("PRO Converter - Main Screen - Button clicked");

            mad.mobileApp.navigate("ui/PRO/explain.html?origin=workoutMenu&modal=noshow", "overlay:up");
        }else if (tappedElement.hasClass("madbarzRutine")){
            // load new madbarz routines if necessary
            if (expired || routines.length == 0) {
                console.log("idem ucitat ponovo rutine sa servera jer ih nema lokalno");
                //mad.alerts.error0("Oops, something went wrong. Please try again");
                mad.local.removeMadbarzRoutines();
                mad.models.routines.read()
                    .then(function () {
                        mad.mobileApp.navigate("ui/workouts/madbarz/madbarzRoutines.html?origin=workoutMenu", "slide");
                    })
                    .fail(function () {console.log("GREŠKA, nisu loadane rutine!")});
            }else{
                // napuni routinesDataSource iz cachea prije no sto loadash view
                mad.viewModels.madbarzRoutines.viewModel.routinesDataSource = kendo.data.DataSource.create({ data: routines });
                setTimeout(function () {
                    mad.mobileApp.navigate("ui/workouts/madbarz/madbarzRoutines.html?origin=workoutMenu", "slide");
                }, 555);

            }
        }else if (tappedElement.hasClass("custom")){
            mad.mobileApp.navigate("ui/workouts/saved/madbarzSavedWorkoutsList.html?origin=menu", "slide:left");
        }else if (tappedElement.hasClass("gotoPlan")){
            if (!checkifOnline()){
                mad.alerts.realTop0("You are currently offline");
            }
            mad.mobileApp.navigate("ui/plans/list.html?origin=workoutMenu", "fade");
        }
    }

    function beforeShow(e){
        viewModel.set("uCanTouchThis", false);
        $("#workoutsMenu .madbarzRutine .preloader").addClass("hidden");
    }

    function showView(e) {
        //console.log("menu - showView", mad.common.actualViewID, mad.common.actualView, e);

        console.log("- - - -", e.view.params);

        var origin = e.view.params.origin;
        var showModal = (e.view.params.modal == "show") ? true : false;

        //console.log("origin", origin);
        mad.common.setActualView(); mad.common.addViewToHistory("reset");
        mad.common.stretchViewContentToBeElastic();

        kendo.bind($(mad.common.$actualViewID), viewModel);

        viewModel.set("controlFinished", false);
        viewModel.set("IsPro", false);
        viewModel.set("showCallToAction", false);
        viewModel.set("isFemale", checkIsFemale());

        var displayName = mad.common.variables.username;

        if (mad.common.variables.firstName) {
            displayName = mad.common.variables.firstName;
        }

        displayName = mad.common.toTitleCase(displayName);
        viewModel.set("sayHello", displayName);

        viewModel.set("ime", displayName + ",");

        if (origin == "registration" || showModal){
            openModal();
        }
        

        var treningsToSync = mad.local.getWorkout();

        var totalUnsynced = treningsToSync.length;
        if (totalUnsynced > 0){
            if (viewModel.common.ifOnline()) {
                viewModel.set("syncInfo", "syncing workouts");
            }else{
                if (totalUnsynced == 1) {
                    viewModel.set("syncInfo", "1 workout not synced");
                }else {
                    viewModel.set("syncInfo", totalUnsynced + " workouts not synced");
                }
            }
        }else{
            viewModel.set("syncInfo", "");
        }

        checkPRO();

        if (origin != "menu") {
            // rucno selektiranje taba ako se nije doslo s menija
            mad.common.selectMenuTab("workouts");
        }
    }

    function afterShow(e) {
        viewModel.set("uCanTouchThis", true);
        mad.analyticEvents.track([mad.analyticEvents.services.GA, mad.analyticEvents.services.FB], mad.analyticEvents.categories.MENUSCREEN, mad.analyticEvents.types.VIEW,
            "Workouts - Main screen loaded",
            null,
            "Workouts - Main",
            "Screen loaded");
        
    }

    function checkPRO(){
        //console.log("MENU - checking pro");

        var isUserProPromise = $.Deferred();

        isUserProPromise.then(
            function(success) {
                if (success) { // ako ima access to pro
                    console.log("user is PRO");
                    viewModel.set("IsPro", true);
                    viewModel.set("showCallToAction", false);
                } else {
                    console.log("user is not PRO");
                    viewModel.set("IsPro", false);
                    viewModel.set("showCallToAction", true);
                }
                viewModel.set("controlFinished", true);
                //kendo.bind($(mad.common.$actualViewID), viewModel);
            },
            function(fail) {
                viewModel.set("controlFinished", true);
                //kendo.bind($(mad.common.$actualViewID), viewModel);
                console.log("hasUserAccessToPro failed !!");
            });

        //check if user has access to pro or not
        mad.common.hasUserAccessToPro(isUserProPromise);
    }

    function checkifOnline() {
        return viewModel.common.ifOnline();
    }

    // oko modala
    function openModal(){
        viewModel.set("isModalOpened", true);

        viewModel.set("isFemale", checkIsFemale());

        var modalID = $("#menuModal");
        var mv = modalID.data("kendoMobileModalView");

        modalID.removeClass("hidden");
        mv.open();
        modalID.css("height",  $(window).height());
    }

    function openSales() {
        //analytics here
        trackAfterRegisterModalAnalytics("Premium");

        closeModal();
        mad.mobileApp.navigate("ui/PRO/explain.html?origin=workoutMenu&modal=show", "overlay:up");
    }

    function closeModalButtonClick() {
        //analytics here
        trackAfterRegisterModalAnalytics("Not Premium");
        closeModal();
    }

    function closeModal(e){
        viewModel.set("isModalOpened", false);

        var modalID = $("#menuModal");
        var mv = modalID.data("kendoMobileModalView");
        mv.close();

        modalID.addClass("hidden");
    }

    function checkIsFemale(){
        console.log("comm vars", mad.common.variables);
        return (mad.common.variables.gender == "f");
    }

    function trackAfterRegisterModalAnalytics(buttonName) {
        var dataForAnalytics = {
            "Type": buttonName
        };
        mad.analyticEvents.track(
            [mad.analyticEvents.services.GA, mad.analyticEvents.services.FB],
            mad.analyticEvents.categories.MAX,
            mad.analyticEvents.types.EVENT,
            "After register modal - Button Click",
            dataForAnalytics,
            "After register modal - Button Click",
            buttonName);
        mad.appsFlyer.trackEvent("After register modal - Button Click - " + buttonName);
    }

    return {
        viewModel: viewModel
    };

}());

